#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXLEN 21000

typedef struct linie { char *l; int len; linie* prev; linie* next; };

linie* f, *faux;
char ch, *newl, cch[2], laux[MAXLEN];
int cpoz, nbl;

int main()
{
int i, j;

cpoz = 0;
nbl = 0;

f = new linie;
f->prev = f->next = NULL;
f->l = (char *) malloc(4 * sizeof(char));
f->l[0] = 0;
f->len = 0;

while (scanf("%c", &ch) != EOF)
  {
    if (ch == 'Q')
      break;

    if (ch == '\n')
      continue;

    if (cpoz >= f->len)
      nbl = cpoz - f->len;
    else
      nbl = 0;

    switch (ch)
      {
        case 'L':
          {
            if (cpoz)
              cpoz--;

          } break;

        case 'R':
          {
            cpoz++;
          } break;

        case 'U':
          {
            if (f->prev)
              f = f->prev;
          } break;

        case 'D':
          {
            if (f->next)
              f = f->next;
          } break;

        case 'N':
          {
            faux = new linie;
            faux->l = (char *) malloc(4 * sizeof(char));
            faux->l[0] = faux->len = 0;
            faux->prev = f;
            faux->next = f->next;
            f->next = faux;

            if (faux->next)
              faux->next->prev = faux;

            if (cpoz < f->len)
              {
                newl = (char *) malloc((f->len - cpoz + 4) * sizeof(char));
                newl[0] = 0;
                strcat(newl, f->l + cpoz);
                faux->len = strlen(newl);

                free(faux->l);
                faux->l = newl;

                newl = (char *) malloc((cpoz + 4) * sizeof(char));
                newl[0] = 0;
                f->l[cpoz] = 0;
                strcat(newl, f->l);

                free(f->l);
                f->l = newl;
                f->len = strlen(f->l);
              }

            f = faux;
            cpoz = 0;
          } break;

        case 'E':
          {
            cpoz = f->len;
          } break;

        case 'H':
          {
            cpoz = 0;
          } break;

        case 'X':
          {
            if (cpoz < f->len)
              {
                f->l[cpoz] = 0;

                newl = (char *) malloc((f->len) * sizeof(char));
                newl[0] = 0;
                strcat(newl, f->l);
                strcat(newl, f->l + cpoz + 1);

                free(f->l);
                f->l = newl;
                f->len = strlen(f->l);
              }
            else
            if (cpoz >= f->len && f->next)
              {
                newl = (char *) malloc((f->len + nbl + f->next->len + 4) * sizeof(char));
                newl[0] = 0;

                strcat(newl, f->l);

                for (i = 0; i < nbl; i++)
                  laux[i] = ' ';
                laux[nbl] = 0;

                strcat(newl, laux);
                strcat(newl, f->next->l);

                free(f->l);
                f->l = newl;
                f->len = strlen(f->l);

                faux = f->next;

                f->next = faux->next;
                if (f->next)
                  f->next->prev = f;

                free(faux->l);
                free(faux);
              }
          } break;

        case 'B':
          {
            if (cpoz > f->len && f->len)
                cpoz--;
            else
            if (cpoz == 0 && f->prev)
              {
                cpoz = f->prev->len;

                newl = (char *) malloc((f->len + f->prev->len + 4) * sizeof(char));
                newl[0] = 0;

                strcat(newl, f->prev->l);
                strcat(newl, f->l);

                free(f->prev->l);
                f->prev->l = newl;
                f->prev->len = strlen(f->prev->l);

                f->prev->next = f->next;
                if (f->next)
                  f->next->prev = f->prev;

                faux = f;
                f = f->prev;

                free(faux->l);
                free(faux);
              }
            else
            if (cpoz)
              {
                f->l[cpoz-1] = 0;

                newl = (char *) malloc((f->len + 2) * sizeof(char));
                newl[0] = 0;
                strcat(newl, f->l);
                strcat(newl, f->l + cpoz);

                free(f->l);
                f->l = newl;
                f->len = strlen(f->l);
                cpoz--;
              }
          } break;

        default:
          {
            if (cpoz < f->len)
              {
                //f->l[cpoz] = ch;

                // sau insereaza
                newl = (char *) malloc((f->len + 4) * sizeof(char));
                newl[0] = 0;
                strncpy(newl, f->l, cpoz);
                newl[cpoz] = 0;
                cch[0] = ch, cch[1] = 0;
                strcat(newl, cch);
                strcat(newl, f->l + cpoz);

                free(f->l);
                f->l = newl;
                f->len = strlen(f->l);
              }
            else
              {
                newl = (char *) malloc((f->len + 3 + nbl) * sizeof(char));
                newl[0] = 0;
                strcat(newl, f->l);

                for (i = 0; i < nbl; i++)
                  laux[i] = ' ';
                laux[nbl] = 0;

                strcat(newl, laux);

                cch[0] = ch, cch[1] = 0;
                strcat(newl, cch);

                if (f->l)
                  free(f->l);

                f->l = newl;
                f->len = strlen(newl);
              }

            cpoz++;
          } break;
      }
  }

while (f->prev)
  f = f->prev;

while (f)
  {
    printf("%s", f->l);
    if (f->next)
      printf("\n");
    f = f->next;
  }

//printf("\n");

return 0;
}