{$o-,q+,r+}

{Problem  :  ERRORS}
{Solved by Sergey Orshanskiy}

function hash(s : string) : integer;
var i : integer;
  x : integer;
begin
  x := 0;
{  for i := 1 to length(s) do
    x := (x * 24709 + ord(s[i])) mod 836472;}
  for i := 1 to length(s) do
  begin
    x := (x shl 4 + x + ord(s[i])) and (1 shl 18 - 1);
    x := x xor 119 + 1;
  end;
  if x = 0 then hash := 1 else hash := x;
end;

const MAX_DIC = 30000;
      _10 = 20;
var i, x, j, k, q, y, z, nn : integer;
    ndic, ndic2 : integer;
    s : string;
    dic : array [1..MAX_DIC] of string; // [_10]
    dic2 : array [1..MAX_DIC * _10] of string; // [_10]
    // number of words it looks like & one (last) of them
    ss, nm : array [1..MAX_DIC * _10] of integer;
    a : array [1.._10] of string; // [_10]
    h1, h2 : array [1..400000] of integer;
    //tt : string; // [_10]

function getword(s:string):integer;
var x:integer;
begin
  x := hash(s);
  while (h1[x] <> 0) and (dic[h1[x]] <> s) do inc(x);
  if h1[x] = 0 then getword := 0 else getword := x;
end;


function getword2(s : string; alloc : boolean):integer;
var x:integer;
begin
  x := hash(s);
  repeat
    if h2[x] = 0 then
    begin
      if alloc then
      begin
        inc(ndic2);
        dic2[ndic2] := s;
        h2[x] := ndic2;
        getword2 := x;
      end else getword2 := 0;
      exit;
    end;
    if dic2[h2[x]] = s then
    begin
      getword2 := x;
      exit;
    end;
    inc(x);
  until false;
end;

function split(s:string):integer;
var j, k : integer;
begin
{    for k := 1 to length(s) do
    begin
      a[k] := s;
      delete(a[k], k, 1);
    end;
    for k := length(s) downto 1 do
      for j := 1 to k do
        if a[j] > a[k] then
        begin
          tt := a[j]; a[j] := a[k]; a[k] := tt;
        end;
    j := 1;
    for k := 2 to length(s) do
    if a[k] <> a[k-1] then
    begin
      inc(j);
      a[j] := a[k];
    end;}
  j := 0;
  for k := 1 to length(s) do if (k = 1) or (s[k] <> s[k-1]) then
  begin
    inc(j);
    a[j] := s;
    delete(a[j], k, 1);
  end;
  split := j;
end;

function readword:string;
var cc:char;
    sss:string;
begin
    sss:='';
    if seekeof then;
    repeat
        read(cc);
        if cc <= ' ' then break;
        sss:=sss+cc;
    until eof;
    readword := sss;
end;

function rotate(s:string; x, y : integer) : string;
var l : string;
    i : integer;
    c1, c2 : char;
begin
  l := s;
  c1 := s[x];
  c2 := s[x+1];
  for i := x to y do
  if l[i]=c1 then l[i]:=c2 else l[i]:=c1;
  rotate := l;
end;

procedure process(s : string; l, r : integer);
var c1, c2 : char;
    ll : string;
    i : integer;
begin
  ll := s;
  c1 := s[l];
  c2 := s[l+1];
  ll[l] := c2;
  for i := l+1 to r do
  begin
    if ll[i] = c1 then ll[i] := c2 else ll[i] := c1;
    if getword(ll) <> 0 then dec(x);
  end;
end;

begin
  assign(input, 'errors.in');
  reset(input);
  assign(output, 'errors.out');
  rewrite(output);
  readln(ndic);
  fillchar(h1, sizeof(h1), 0);
  fillchar(h2, sizeof(h2), 0);
  ndic2 := 0;
  fillchar(ss, sizeof(ss), 0);
  for i := 1 to ndic do
  begin
    dic[i] := readword;
    x := hash(dic[i]);
    while (h1[x] <> 0) do inc(x);
    h1[x] := i;

    j := split(dic[i]);

    for k := 1 to j do
    begin
      q := getword2(a[k], true);
      inc(ss[h2[q]]);
      nm[h2[q]] := i;
    end;
  end;

  while not seekeof do
  begin
    s:=readword;
    y := getword(s);
    z := getword2(s, false);
    x := 0;
    nn := 0;
    if y <> 0 then
    begin
      inc(x);
      nn := y;
    end;
    if z <>  0 then
    begin
      inc(x, ss[h2[z]]);
      nn := nm[h2[z]];
    end;

    j := split(s);
    if y <> 0 then dec(x, j); // because the word is like itself


    for k := 1 to j do
    begin
      y := getword(a[k]);
      if y <> 0 then
      begin
        inc(x);
        nn := h1[y];
      end;
      z := getword2(a[k], false);
      if z <> 0 then
      begin
        inc(x, ss[h2[z]]);
        nn := nm[h2[z]];
      end;
    end;

{    j := 1;
    while (j < length(s)) do
    begin
        while (j < length(s)) and (s[j] = s[j+1]) do inc(j);
        if j = length(s) then break;
        i := j + 1;
        while (i < length(s)) and (s[i-1]=s[i+1]) do inc(i);
        if getword(copy(s, 1, j - 1) + s[i] + copy(s, j, i - j) + copy(s, i + 1, 1000)) <> 0 then
          dec(x);
        j := i + 1;
    end;}

    for j := 1 to length(s) - 1 do if s[j] <> s[j+1] then
    begin
      i := j + 1;
      // new!
      while (i < length(s)) and (s[i+1] = s[i-1]) do inc(i);
      process(s, j, i);
      // --

//      repeat
//          if getword(rotate(s, j, i)) <> 0 then
//                      dec(x);
//        if i = length(s) then break;
//        if s[i-1] <> s[i+1] then break;
//        inc(i);
//      until false;
    end;

    write(s, ' ');
    if x <> 1 then writeln(x) else writeln('1 ', dic[nn]);
  end;
end.