{$apptype console}

type integer = longint;
const 
  max = 1000;
  maxops = 48000;
var
  i, n, nops: longint;
  d: array [1..max, 1..max] of integer;
  ops: array [1..maxops, 1..4] of integer;

procedure ReadAll;
var
  i, j, m, x, y: integer;
begin
  Assign (Input, 'gosha.in'); Reset (Input);

  fillchar (d, sizeof (d), 0);

  Read (n);
  Read (m);
  for i := 1 to m do begin
    Read (x, y);
    Dec(d[x][y]);
    Dec(d[y][x]);
  end;

  for i := 1 to m do begin
    Read (x, y);
    Inc(d[x][y]);
    Inc(d[y][x]);
  end;

  Close (Input);
end;

procedure doop (v1, v2, v3, v4: integer);
begin
  Dec (d[v1][v2]);
  Dec (d[v2][v1]);
  Dec (d[v3][v4]);
  Dec (d[v4][v3]);

  Inc (d[v1][v3]);
  Inc (d[v3][v1]);
  Inc (d[v2][v4]);
  Inc (d[v4][v2]);

  inc (nops);
  if nops > maxops then begin
    WriteLn ('too many ops');
  end;

  ops[nops][1] := v1;
  ops[nops][2] := v2;
  ops[nops][3] := v4;
  ops[nops][4] := v3;
end;

var
  v3, v4: integer;
procedure findv(v1, v2: integer);
var _v3, _v4: integer;
begin
  v3 := 0;
  for _v3 := 1 to n do if (d[v2][_v3] < 0) and (_v3<>v1) then begin
    for _v4 := 1 to n do if (d[_v3][_v4] > 0) and (_v4<>v1) and (_v4<>v2) then begin
      v3 := _v3;
      v4 := _v4;
      exit;
    end;
        exit;
    end;

end;

procedure Solve;
var
  v1, v2: integer;
  again: boolean;
  t: integer;
begin
  t := 0;
  repeat
    inc (t);
    again := false;
    for v1 := 1 to n do
      for v2 := 1 to n do if (v2 <> v1) then
        while (d[v1][v2] > 0) do begin
          findv(v1, v2);
          if v3<1 then break;
          again := true;
          doop (v1, v2, v4, v3);
        end;
  until not again;
  WriteLn (t);
end;

begin
  ReadAll;
  nops := 0;
  Solve;
  Assign (Output, 'gosha.out'); ReWrite (Output);
  for i := 1 to nops do begin
    Write (ops[i][1], ' ', ops[i][2], ' ', ops[i][3], ' ', ops[i][4], ' ');
    WriteLn (ops[i][1], ' ', ops[i][4], ' ', ops[i][2], ' ', ops[i][3]);
  end;

  Close (Output);
end.
