{
          

    :      
    :       
    :     
}

{$O-,Q+,R+}
{$APPTYPE CONSOLE}
{$DEFINE ALLOWMULTITEST}

program ancient_civilizations;

uses
    sysutils, math;

const
    maxn = 100000;
    minc = -1000000000;
    maxc = 1000000000;

var
    a, s: array [1..2 * maxn] of longint;
    l, r: array [1..maxn] of longint;
    n: longint;

procedure sort(l, r: longint);
var
    i, j, x, t: longint;
begin
    i := l;
    j := r;
    x := a[l + random(r - l + 1)];

    while i <= j do
    begin
        while a[i] < x do inc(i);
        while a[j] > x do dec(j);
        if i <= j then
        begin
            t := a[i]; a[i] := a[j]; a[j] := t;
            t := s[i]; s[i] := s[j]; s[j] := t;
            inc(i);
            dec(j);
        end;
    end;

    if l < j then sort(l, j);
    if i < r then sort(i, r);
end;

var
    i, j, k, m, p, q, best, t: longint;
    u, pos: array [1..maxn] of longint;

begin
    assign(input, 'ancient.in');
    reset(input);
    assign(output, 'ancient.out');
    rewrite(output);

    if eoln then runerror(239);
    read(n);
    if not eoln then runerror(239);
    readln;

    if (n < 1) or (n > maxn) then runerror(239);

    m := 0;
    for i := 1 to n do
    begin
        if eoln then runerror(239);
        read(l[i]);
        if eoln then runerror(239);
        read(r[i]);
        if not eoln then runerror(239);
        readln;

        if (l[i] < minc) or (l[i] > maxc) or (r[i] < minc) or (r[i] > maxc) or (l[i] >= r[i]) then
            runerror(239);

        inc(m);
        a[m] := 2 * l[i];
        s[m] := i;
        inc(m);
        a[m] := 2 * r[i] - 1;
        s[m] := i;
    end;

    {$IFNDEF ALLOWMULTITEST}
    if not eof then runerror(239);
    {$ENDIF}

    sort(1, m);

    k := 0;
    best := 0;
    p := 0;
    q := 0;
    for i := 1 to m do
    begin
        if a[i] mod 2 = 0 then
        begin
            inc(k);
            u[k] := s[i];
            pos[s[i]] := k;
            if (k > 1) and (a[i + 1] mod 2 <> 0) then
            begin
                t := (a[i + 1] + 1) div 2 - a[i] div 2;
                if (best = 0) or (t < best) then
                begin
                    best := t;
                    p := s[i];
                    if s[i + 1] = p then
                    begin
                        q := u[1];
                    end else begin
                        q := s[i + 1];
                    end;
                end;
            end;
        end else begin
            u[pos[s[i]]] := u[k];
            pos[u[k]] := pos[s[i]];
            dec(k);
        end;
    end;

    if best = 0 then
    begin
        writeln(0)
    end else begin
        if q = p then runerror(240);

        {  ,       ;-) }
        writeln(min(p, q), ' ', max(p, q));
    end;

    close(input);
    close(output);
end.

