const Base=10000;
      MaxL=100;
      logbase=4;

type long=array [1..MaxL] of integer;


procedure muls (var a, b:long; s:integer);
var i, cy:integer;
begin
  cy:=0;
  for i:=1 to MaxL do begin
    inc (cy, b[i]*s);
    a[i]:=cy mod Base;
    cy:=cy div Base;
  end;
end;


procedure writeb (x:integer);
var s:string;
begin
  str (x, s);
  while length (s)<logbase do s:='0'+s;
  write(s);
end;

procedure writel (var a:long);
var i, t:integer;
begin
  t:=1;
  for i:=MaxL downto 1 do if a[i]>0 then begin t:=i; break end;
  write (a[t]);
  for i:=t-1 downto 1 do writeb (a[i]);
  writeln;
end;


var cnt:array [1..10000] of integer;
    p:array [1..200] of integer;
    a, b:long;
    i, n:integer;
begin
  assign (input, 'fraction.in'); reset (input);
  assign (output, 'fraction.out'); rewrite (output);
  read (n);
  for i:=1 to n do begin
    read (p[i]); inc (cnt[p[i]]);
  end;
  a[1]:=1; b[1]:=1;
  for i:=1 to 10000 do 
    if cnt[i]>0 then begin
      muls (a, a, cnt[i]+1-ord (i=p[1])-ord (i=p[2]));
      muls (b, b, cnt[i] shr 1  + 1 - ord (i=p[2]));
    end;
  writel (a);
  writel (b);
end.