{
          

    :      
    :       
    :     
}

{$APPTYPE CONSOLE}

const
    inFile = 'kingdom.in';
    outFile = 'kingdom.out';

    maxN = 256;

    pow2 : array[0..8] of integer = (1, 2, 4, 8, 16, 32, 64, 128, 256);

var
    n, k : integer;
    g : array[1..maxN,1..maxN] of integer;
    deg : array[1..maxN] of integer;
    cov : array[1..maxN] of boolean;

    ansCol : integer;
    ansLen : integer;
    ans : array[1..maxN] of integer;

procedure Solve;

    function TryColor(w : integer) : boolean;
    var
        i, j, q, t : integer;
        killed : integer;

    begin
        fillchar(deg, sizeof(deg), 0);
        for i := 1 to n do
            for j := 1 to n do
                if g[i,j] = w then
                    inc(deg[i]);

        fillchar(cov, sizeof(cov), false);
        ansLen := 0;
        killed := 0;

        for i := 1 to n do begin
            j := 1;
            for q := 1 to n do
                if deg[q] > deg[j] then
                    j := q;

            inc(ansLen);
            ans[ansLen] := j;

            for q := 1 to n do
                if ((q = j) or (g[j,q] = w)) and not cov[q] then begin
                    inc(killed);
                    cov[q] := true;
                    for t := 1 to n do
                        if g[q,t] = w then
                            dec(deg[t]);
                end;

            if killed = n then
                break;
        end;

        if ansLen <= k then begin
            TryColor := true;
            ansCol := w;
        end else
            TryColor := false;
    end;

begin
    if not TryColor(1) then
        if not TryColor(2) then
            RunError(241);
end;

procedure ReadData;
var
    i, j : integer;

begin
    assign(input, inFile);
    reset(input);

    read(n);
    if (n < 2) or (n > maxN) then
        RunError(239);
    read(k);
    if (k < 0) or (k > n) or (pow2[k] < n) then
        RunError(239);

    fillchar(g, sizeof(g), 0);
    for i := 1 to n do
        for j := 1 to n do begin
            read(g[i,j]);
            if ((i = j) and (g[i,j] <> 0)) or
               ((i <> j) and (g[i,j] <> 1) and (g[i,j] <> 2)) then
                RunError(239);
        end;

    for i := 1 to n do
        for j := 1 to n do
            if g[i,j] <> g[j,i] then
                RunError(239);

    close(input);
end;

procedure WriteData;
var
    i : integer;

begin
    assign(output, outFile);
    rewrite(output);
    writeln(ansCol);
    writeln(ansLen);
    for i := 1 to ansLen do
        write(ans[i], ' ');
    writeln;
    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
