{
    ⢥ ᨩ᪠   誮쭨  ணࠬ஢

    :     
    :      ३ ⠭, ࣨ ୥
    襭:     ९
}


{$APPTYPE CONSOLE}
const
    inFile = 'light.in';
    outFile = 'light.out';

    maxN = 1000;

    eps = 1e-12;
type
     real = extended;
     point = record
       x,y:real;
     end;

var
    p:array[0..maxn]of point;
    d1,d2:array[0..maxn]of real;
    z, vp:point;
    v, answer :real;
    n:integer;


function IsIntersect(a,b:point; c,d:point):boolean;
var
  t,u,r:real;
begin
 IsIntersect := false;
 r := (a.x-b.x)*(c.y-d.y) + (a.y-b.y)*(d.x-c.x);
 if r*r < eps*eps * (1 + sqr(a.x-b.x)+sqr(a.y-b.y)) * (sqr(c.x-d.x)+sqr(c.y-d.y)) then
   exit;
 t := ((d.x-b.x)*(c.y-d.y)+(d.y-b.y)*(d.x-c.x))/r;
 u := ((d.x-b.x)*(a.y-b.y)+(d.y-b.y)*(b.x-a.x))/r;
 IsIntersect := (-eps < u) and (u < 1+eps) and (-eps < t) and (t < 1 + eps);
end;


function compare_(a,b:point):integer;
var
 r:real;
begin

  r := a.x*a.x+a.y*a.y;
  if r < eps*eps then r:=1
  else r:=sqrt(r);
  a.x := a.x / r;
  a.y := a.y / r;

  r := b.x*b.x+b.y*b.y;
  if r < eps*eps then r:=1
  else r:=sqrt(r);
  b.x := b.x / r;
  b.y := b.y / r;

  r := a.x*b.y - a.y*b.x;

  compare_ := 0;
  if r < eps then compare_ := 1;
  if r > eps then compare_ := -1;

end;




function compare(a,b,c:point):integer;
begin

  a.x := a.x - c.x;
  a.y := a.y - c.y;
  b.x := b.x - c.x;
  b.y := b.y - c.y;
  compare := compare_(a,b);
end;



procedure solve;
var
  i,j,k,l:integer;
  t1, t2:integer;
  tp1, tp2:point;
  d,r:real;
begin
  z.x := 0;
  z.y := 0;
  answer := 0;
  p[0] := p[n];
  p[n+1] := p[1];
  j:=1;
  for i:=1 to n do
    if IsInterSect(z,vp,p[i], p[i+1]) then j:=0;
  if j > 0 then exit;
  for i:=0 to n+1 do d1[i]:=1e20;
  d2 := d1;
  t1 := 1;
  t2 := 1;
  for i:=2 to n do
     begin
       if (compare(p[i], p[t1],z) < 0) then t1 := i;
       if (compare(p[i], p[t2],z) > 0) then t2 := i;
     end;
  d := sqrt(sqr(p[t1].x)+sqr(p[t1].y));
  tp1.x := p[t1].x/d;
  tp1.y := p[t1].y/d;
  d := sqrt(sqr(p[t2].x)+sqr(p[t2].y));
  tp2.x := p[t2].x/d;
  tp2.y := p[t2].y/d;

  answer := 1e20;

  r := tp1.x * vp.x + tp1.y * vp.y;
  d := abs(tp1.x * vp.y - tp1.y * vp.x);
  z.x := tp1.x * r;
  z.y := tp1.y * r;
  j := 1;
  for i:=1 to n do
    if IsInterSect(z,vp,p[i], p[i+1]) then j:=0;
  if (j>0) and (d < answer) then answer := d;

  r := tp2.x * vp.x + tp2.y * vp.y;
  d := abs(tp2.x * vp.y - tp2.y * vp.x);
  z.x := tp2.x * r;
  z.y := tp2.y * r;
  j := 1;
  for i:=1 to n do
    if IsInterSect(z,vp,p[i], p[i+1]) then j:=0;
  if (j>0) and (d < answer) then answer := d;




  i:=t1;
  j:=1;
  if compare(p[t1+1], p[t1-1], p[t1]) > 0 then j:=-1;
  d1[t1] := 0;
  d1[0] := d1[n];
  d1[n+1] := d1[1];
  while(i<>t2) do
    begin
      i:=(i+n+j-1)mod n + 1;
      if (p[i].x - p[i-j].x) * tp1.x  +  (p[i].y-p[i-j].y) * tp1.y > 0 then
        d1[i] := abs(p[i].x * tp1.y - p[i].y * tp1.x)
      else d1[i] := d1[i-j] + sqrt(sqr(p[i].x-p[i-j].x) + sqr(p[i].y-p[i-j].y));
      d1[0] := d1[n];
      d1[n+1] := d1[1];
    end;

  i:=t2;
  j:=1;
  if compare(p[t2+1], p[t2-1], p[t2]) < 0 then j:=-1;
  d2[t2] := 0;
  d2[0] := d2[n];
  d2[n+1] := d2[1];
  while(i<>t1) do
    begin
      i:=(i+n+j-1)mod n + 1;
      if (p[i].x - p[i-j].x) * tp2.x  +  (p[i].y-p[i-j].y) * tp2.y > 0 then
        d2[i] := abs(p[i].x * tp2.y - p[i].y * tp2.x)
      else d2[i] := d2[i-j] + sqrt(sqr(p[i].x-p[i-j].x) + sqr(p[i].y-p[i-j].y));
      d2[0] := d2[n];
      d2[n+1] := d2[1];
    end;

  for i:=0 to n+1 do
    if d1[i] > d2[i] then d1[i] := d2[i];


  t1:=1;
  t2:=1;
  for i:=2 to n do
     begin
       if (compare(p[i], p[t1], vp) < 0) then t1 := i;
       if (compare(p[i], p[t2], vp) > 0) then t2 := i;
     end;

  d := sqrt(sqr(vp.x-p[t1].x)+sqr(vp.y-p[t1].y));
  if answer > d + d1[t1] then answer := d1[t1] + d;

  d := sqrt(sqr(vp.x-p[t2].x)+sqr(vp.y-p[t2].y));
  if answer > d + d1[t2] then answer := d1[t2] + d;

end;


procedure ReadData;
var
    i : integer;

begin
    assign(input, inFile);
    reset(input);
    read(vp.x, vp.y, v);
    read(n);
    for i := 1 to n do begin
        read(p[i].x, p[i].y);
    end;

    close(input);
end;

procedure WriteData;
begin
    assign(output, outFile);
    rewrite(output);
    writeln(answer/v:0:20);
    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
