{
          

    :     
    :       
    :     
}

{$O-,Q+,R+}
{$APPTYPE CONSOLE}
{$DEFINE ALLOWMULTITEST}

program terminal;

uses
    sysutils;

const
    dirs: string = 'LRUD';
    dx: array [1..4] of longint = (0, 0, -1, 1);
    dy: array [1..4] of longint = (-1, 1, 0, 0);

    maxn = 200;
    maxk = 40000;
    maxcount = 5000000;
    maxv = 100;

var
    dt: array [0..maxn+1, 0..maxn+1, 1..4] of longint;
    m, n: longint;
    count: longint;

procedure a(x, y, d, v: longint);
begin
    inc(dt[x][y][d], v);
    inc(count);
    if count > maxcount then
        runerror(239);
end;

procedure readn(var x: longint; min, max: longint);
begin
    if eoln then runerror(239);
    read(x);
    if (x < min) or (x > max) then runerror(239);
end;

procedure reqeoln;
begin
    if not eoln then runerror(239);
    readln;
end;

var
    k: longint;
    c: char;
    d, x, y, v, x1, y1, x2, y2: longint;
    ch: char;
    i, j: longint;

begin
    assign(input, 'terminal.in');
    reset(input);
    assign(output, 'terminal.out');
    rewrite(output);

    readn(m, 1, maxn);
    readn(n, 1, maxn);
    reqeoln;

    readn(k, 0, maxk);
    reqeoln;

    count := 0;
    for i := 1 to k do
    begin
        if eoln then runerror(239);
        read(c);
        if c = 'A' then
        begin
            readn(x, 1, m);
            readn(y, 1, n);
            read(ch);
            if ch <> ' ' then runerror(239);
            read(ch);
            if pos(ch, dirs) = 0 then runerror(239);
            readn(v, 0, maxv);

            a(x, y, pos(ch, dirs), v);
        end else if c = 'B' then
        begin
            readn(x1, 1, m);
            readn(y1, 1, n);
            readn(x2, 1, m);
            readn(y2, 1, n);
            read(ch);
            if ch <> ' ' then
                runerror(239);
            read(ch);
            if pos(ch, dirs) = 0 then
                runerror(239);
            readn(v, 0, maxv);
            if (x1 > x2) or (y1 > y2) then
                runerror(239);

            d := pos(ch, dirs);
            for x := x1 to x2 do
                for y := y1 to y2 do
                    a(x, y, d, v);
        end else begin
            runerror(239);
        end;

        reqeoln;
    end;

    for i := 1 to m do
        for j := 1 to n do
        begin
            dt[i][j][2] := dt[i][j][2] + dt[i][j-1][2];
            dt[i][j][4] := dt[i][j][4] + dt[i-1][j][4];
        end;

    for i := m downto 1 do
        for j := n downto 1 do
        begin
            dt[i][j][1] := dt[i][j][1] + dt[i][j+1][1];
            dt[i][j][3] := dt[i][j][3] + dt[i+1][j][3];
        end;

    for i := 1 to m do
    begin
        for j := 1 to n do
        begin
            write(dt[i][j][1] + dt[i][j][2] + dt[i][j][3] + dt[i][j][4]);
            if j < n then
                write(' ')
            else
                writeln;
        end;
    end;

    close(input);
    close(output);
end.