{
          

    :       
    :       
    :     
}

{$APPTYPE CONSOLE}
{.$define DEBUG}

const
    inFile = 'time.in';
    outFile = 'time.out';

    maxN = 1000;
    maxK = 1000;
    maxT = 1000000000;
    infinity = maxlongint;

type
    TEdge = record
        s, t : integer;
        stime, ttime : integer;
    end;

var
    n : integer;
    a, b : integer;
    k : integer;
    e : array[1..maxN] of TEdge;
    answer : integer;

    d : array[1..maxN] of integer;
    
procedure Solve;
var
    i : integer;
    flag : boolean;

{$ifdef DEBUG}
    nUpdates : integer;
{$endif}
        
begin
{$ifdef DEBUG}
	nUpdates := 0;
{$endif}
    for i := 1 to n do
        d[i] := infinity;
    d[a] := 0;

    repeat
        flag := false;
        for i := 1 to k do
            if (d[e[i].s] <= e[i].stime) and (d[e[i].t] > e[i].ttime) then begin
                d[e[i].t] := e[i].ttime;
                flag := true;
            end;
{$ifdef DEBUG}
	    inc(nUpdates);
{$endif}
    until not flag;

{$ifdef DEBUG}
	writeln(nUpdates, ' update(s).');
{$endif}
    answer := d[b];
    if answer = infinity then
    	RunError(239);
end;

procedure ReadData;
var
    i : integer;

begin
    assign(input, inFile);
    reset(input);

    read(n);
    if (n < 1) or (n > maxN) then
        RunError(239);
    read(a, b);
    if (a < 1) or (a > n) or (b < 1) or (b > n) then
        RunError(239);
    read(k);
    if (k < 1) or (k > maxK) then
        RunError(239);

    for i := 1 to k do begin
        read(e[i].s, e[i].stime, e[i].t, e[i].ttime);
        if (e[i].s < 1) or (e[i].s > n) or (e[i].t < 1) or (e[i].t > n) then
            RunError(239);
        if (abs(e[i].stime) > maxT) or (abs(e[i].ttime) > maxT) then
            RunError(239);
    end;

    close(input);
end;

procedure WriteData;
begin
    assign(output, outFile);
    rewrite(output);
    writeln(answer);
    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
