{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $4000000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{$APPTYPE CONSOLE}
{Orshanskiy Sergey}
uses SysUtils;
var
  ss : array [1..10000] of string;
  i, n, nsel : integer;
  ind, sel, ind2 : array [1..10000] of integer;
  a : array [0..1000000] of integer;
procedure Sort(l, r : integer);
var i, j, m, y : integer;
begin
  m := length(ss[ind[l + random(r - l + 1)]]);
  i := l;
  j := r;
  while i <= j do
  begin
    while length(ss[ind[i]]) < m do inc(i);
    while length(ss[ind[j]]) > m do dec(j);
    if i <= j then
    begin
      y := ind[i];
      ind[i] := ind[j];
      ind[j] := y;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then Sort(i, r);
  if l < j then Sort(l, j);
end;

procedure Sort2(l, r : integer);
var i, j,  y : integer;
    m : string;
begin
  m := ss[ind2[l + random(r - l + 1)]];
  i := l;
  j := r;
  while i <= j do
  begin
    while ss[ind2[i]] < m do inc(i);
    while ss[ind2[j]] > m do dec(j);
    if i <= j then
    begin
      y := ind2[i];
      ind2[i] := ind2[j];
      ind2[j] := y;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then Sort2(i, r);
  if l < j then Sort2(l, j);
end;


function match(i, l : integer) : boolean;
var j, k, ln : integer;
begin
  if a[l] = i then
  begin
    match := true;
    exit;
  end;
  if a[l] = -i then
  begin
    match := false;
    exit;
  end;
  for j := 1 to nsel do if length(ss[ind[sel[j]]]) <= l then
  begin
    ln := length(ss[ind[sel[j]]]);
    k := 0;
    while (k < ln) and (ss[ind[i]][l - k] = ss[ind[sel[j]]][ln - k]) do inc(k);
    if k = ln then
    begin
      if match(i, l - ln) then
      begin
        a[l] := i;
        match :=true;
        exit;
      end;
    end;
  end;
  match := false;
  a[l] := -i;
end;

begin
  assign(input, 'concat.in');
  reset(input);
  assign(output, 'concat.out');
  rewrite(output);
  randseed := 8234;
  n := 0;
  while not seekeof do
  begin
    inc(n);
    readln(ss[n]);
    ss[n] := trim(ss[n]);
  end;
  if (n = 0) then
  begin
    close(input);
    close(output);
    halt;
  end;
  for i := 1 to n do ind[i] := i;
  Sort(1, n);
  fillchar(a, sizeof(a), 0);
  nsel := 0; // selected


  for i := 1 to n do
  begin
    a[0] := i;
    if not match(i, length(ss[ind[i]])) then
    begin
      inc(nsel);
      sel[nsel] := i;
    end;
  end;

  for i := 1 to nsel do ind2[i] :=ind[sel[i]];
  Sort2(1, nsel);
  for i := 1 to nsel do writeln(ss[ind2[i]]);
  close(input);
  close(output);
end.