{$APPTYPE CONSOLE}
{$O-,Q+,R+}
var
        i, n, best, nh : integer;
        heap : array [0..50000] of integer;
        t, l : array [1..50000] of integer;

procedure sort(ll, rr : integer);
var i, j, m, y : integer;
begin
        m := t[ll + random(rr - ll + 1)];
        i := ll;
        j := rr;
        while i <= j do
        begin
                while t[i] < m do inc(i);
                while t[j] > m do dec(j);
                if i <= j then
                begin
                        y := t[i];
                        t[i] := t[j];
                        t[j] := y;
                        y := l[i];
                        l[i] := l[j];
                        l[j] := y;
                        inc(i);
                        dec(j);
                end;
        end;
        if i < rr then sort(i, rr);
        if ll < j then sort(ll, j);
end;

procedure add(x : integer);
var i, y : integer;
begin
        inc(nh);
        heap[nh] := x;
        i := nh;
        while heap[i] < heap[i div 2] do
        begin
                y := heap[i];
                heap[i] := heap[i div 2];
                heap[i div 2] := y;
                i := i div 2;
        end;
end;

procedure extract_min;
var i, y : integer;
begin
        heap[1] := heap[nh];
        dec(nh);
        i := 1;
        while (i * 2 <= nh) do
        begin
                if i*2 = nh then
                begin
                        if heap[i] > heap[i*2] then
                        begin
                                y := heap[i];
                                heap[i] := heap[i*2];
                                heap[i*2] := y;
                        end;
                        exit;
                end else
                begin
                        if heap[i*2]<heap[i*2+1] then
                        begin
                                if heap[i] > heap[i*2] then
                                begin
                                  y := heap[i];
                                  heap[i] := heap[i*2];
                                  heap[i*2] := y;
                                  i := i * 2;
                                end else exit;
                        end else
                        begin
                                if heap[i] > heap[i*2+1] then
                                begin
                                        y := heap[i];
                                        heap[i] := heap[i*2+1];
                                        heap[i*2+1] := y;
                                        i := i * 2 + 1;
                                end else exit;
                        end;
                end;
        end;
end;

begin
        randomize;
        assign(input, 'customs.in');
        reset(input);
        assign(output, 'customs.out');
        rewrite(output);
        read(n);
        for i := 1 to n do read(t[i], l[i]);
        sort(1, n);
        best := 0;
        nh := 0;
        heap[0] := -1000000000;
        for i := 1 to n do
        begin
           while (nh > 0) and (heap[1] <= t[i]) do extract_min;
           add(t[i] + l[i]);
          if best < nh then best := nh;
        end;
        writeln(best);
        close(input);
        close(output);
end.