{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}
type int = longint;
const eps = 1e-10;

var x, y, xx, yy: array [1..1100] of int;
procedure swap(u, v: int);
var t: int;
begin
  t:=x[u];
  x[u]:=x[v];
  x[v]:=t;

  t:=y[u];
  y[u]:=y[v];
  y[v]:=t;
end;

procedure merge(l, h: int);
var a, b, c, j: int;
begin
  if (l = h) then exit;
  b:=(l + h) div 2;
  merge(l, b);
  merge(b + 1, h);
  a:=l;
  c:=b + 1;
  j:=l;
  while (a <= b) and (c <= h) do
    if ((x[a] - x[1]) * (y[c] - y[1]) - (y[a] - y[1]) * (x[c] - x[1]) > 0) or
       (((x[a] - x[1]) * (y[c] - y[1]) - (y[a] - y[1]) * (x[c] - x[1]) = 0) and (sqr(x[a] - x[1]) + sqr(y[a] - y[1]) < sqr(x[c] - x[1]) + sqr(y[c] - y[1]))) then
      begin
        xx[j]:=x[a];
        yy[j]:=y[a];
        inc(a);
        inc(j);
      end
    else
      begin
        xx[j]:=x[c];
        yy[j]:=y[c];
        inc(c);
        inc(j);
      end;
  while (a <= b) do
    begin
      xx[j]:=x[a];
      yy[j]:=y[a];
      inc(a);
      inc(j);
    end;
  while (c <= h) do
    begin
      xx[j]:=x[c];
      yy[j]:=y[c];
      inc(c);
      inc(j);
    end;
  for j:=l to h do
    begin
      x[j]:=xx[j];
      y[j]:=yy[j];
    end;
end;

var xc, yc: int;

var ans, sp, n, i, min: int;
var s: array [1..1100] of int;
var r, u, v, d, dd: extended;
begin
  assign(input, 'dragon.in');
  assign(output, 'dragon.out');
  reset(input);
  rewrite(output);
  read(n, xc, yc);
  for i:=1 to n do
    read(x[i], y[i]);
  min:=1;
  for i:=2 to n do
    if (y[i] < y[min]) or ((y[i] = y[min]) and (x[i] < x[min])) then
      min:=i;
  swap(1, min);
  merge(2, n);

  s[1]:=1;
  s[2]:=2;
  sp:=2;
  for i:=3 to n do
    begin
      while true do
        begin
          if (sp >= 2) and ((x[s[sp]] - x[s[sp - 1]]) * (y[i] - y[s[sp]]) - (y[s[sp]] - y[s[sp - 1]]) * (x[i] - x[s[sp]]) <= 0) then
            begin
              dec(sp);
              continue;
            end;
          break;
        end;
      inc(sp);
      s[sp]:=i;
    end;
  for i:=1 to sp do
    begin
      x[i]:=x[s[i]];
      y[i]:=y[s[i]];
    end;
  x[sp + 1]:=x[1];
  y[sp + 1]:=y[1];
  n:=sp;
  ans:=0;
  for i:=1 to n do
    begin
      dd:=sqrt(sqr(x[i + 1] - x[i]) + sqr(y[i + 1] - y[i]));
      u:=x[i + 1] - x[i];
      v:=y[i + 1] - y[i];
      r:=-u * xc - v * yc;
      d:=sqrt(sqr(u) + sqr(v));
      u:=u / d;
      v:=v / d;
      r:=r / d;

      if (abs(abs(x[i] * u + y[i] * v + r) + abs(x[i + 1] * u + y[i + 1] * v + r) - dd) < eps) and
         (abs(abs(x[i] * u + y[i] * v + r) - dd) > eps) and (abs(abs(x[i + 1] * u + y[i + 1] * v + r) - dd) > eps) then
        inc(ans);
    end;
  writeln(ans);
  close(input);
  close(output);
end.
