{$Q-,R-,O+}
{$APPTYPE CONSOLE}
type int = longint;
const MAX_NUM = 50100;
const inf = 1000000000;
const MAX_ROAD_LEN = 1000000;

var ex, ey, el, en: array [1..MAX_NUM] of int;
var d: array [1..510] of int;
var s, n: int;


var st: array [1..2 * MAX_NUM] of int;
var top: int;

procedure push(u: int);
begin
  st[top]:=u;
  inc(top);
end;

procedure pop(var u: int);
begin
  dec(top);
  u:=st[top];
end;


var head: array [1..510] of int;
var p1, p2, vx, len, next, prev: array [0..2 * MAX_NUM] of int;

var heap: array [1..2 * MAX_NUM] of int;
var enum: int;

var mark: array [1..510] of boolean;
function dfs(u, v: int): int;
var v1, v2, r, u1, u2: int;
begin
  if (mark[v]) then
    begin
      if (d[v] = 2) then
        dfs:=inf
      else
        begin
          v1:=vx[head[u]];
          v2:=vx[next[head[u]]];
          if (v1 = v) then
            r:=len[head[u]]
          else
            r:=len[next[head[u]]];
          dfs:=r;
        end;
      exit;
    end;
  mark[v]:=true;
  if (d[v] <> 2) then
    begin
      u1:=vx[head[u]];
      u2:=vx[next[head[u]]];

      if (u1 = v) then
        dfs:=len[head[u]]
      else
        dfs:=len[next[head[u]]];
      exit;
    end;
  u1:=vx[head[v]];
  u2:=vx[next[head[v]]];

  v1:=vx[head[u]];
  v2:=vx[next[head[u]]];
  if (u1 = u) then
    r:=len[head[v]]
  else
    r:=len[next[head[v]]];

  if (u1 <> u) then
    r:=r + dfs(v, u1);
  if (u2 <> u) then
    r:=r + dfs(v, u2);
  if (r > inf) then
    r:=inf;
  dfs:=r;
end;


procedure solve;
var r, i, u1, u2, max: int;
begin
  if (enum > 0) then
    max:=el[heap[1]]
  else
    max:=0;
  for i:=1 to n do
    mark[i]:=false;

  for i:=1 to n do
    if (d[i] = 2) and (not mark[i]) then
      begin
        u1:=vx[head[i]];
        u2:=vx[next[head[i]]];
        if (u1 = 0) or (u2 = 0) then
          writeln('BUGS!!!');
        if (u1 = u2) then {  }
          begin
            if (d[u1] = 2) then
              writeln('*')
            else
              begin
                if (max < len[head[i]] + len[next[head[i]]]) then
                  max:=len[head[i]] + len[next[head[i]]];
                continue;
              end;
            exit;
          end;
        if (d[u1] = 2) and (d[u2] = 2) then
          begin
            mark[i]:=true;
            r:=dfs(i, u1);
            r:=r + dfs(i, u2);
            if (r > max) then
              max:=r;
            continue;
          end;
        if (d[u1] <> 2) and (d[u2] <> 2) then
          begin
            if (max < len[head[i]] + len[next[head[i]]]) then
              max:=len[head[i]] + len[next[head[i]]];
            continue;
          end;
        if (d[u1] <> 2) then
          r:=dfs(u1, i);
        if (d[u2] <> 2) then
          r:=dfs(u2, i);
        if (r > max) then max:=r;
      end;
  if (max >= inf) then
    writeln('*')
  else
    writeln(max);
end;



procedure heapswap(u, v: int);
var tmp: int;
begin
  tmp:=heap[u];
  heap[u]:=heap[v];
  heap[v]:=tmp;

  en[heap[u]]:=u;
  en[heap[v]]:=v;
end;

procedure sift_up(u: int);
var v: int;
begin
  v:=u;
  while (v > 1) do
    begin
      if (el[heap[v div 2]] >= el[heap[v]]) then break;
      heapswap(v div 2, v);
      v:=v div 2;
    end;
end;

procedure sift_down(u: int);
var max: int;
begin
  if (2 * u + 1 <= enum) and (el[heap[2 * u + 1]] > el[heap[u]]) then
    max:=2 * u + 1;
  if (2 * u <= enum) and (el[heap[2 * u]] > el[heap[max]]) then
    max:=2 * u;
  if (max <> u) then
    begin
      heapswap(u, max);
      sift_down(max);
    end;
end;

procedure do_addedge;
var r1, w, r, u, v, l: int;
begin
  read(u, v, l);
  if (u < 1) or (u > n) then
    begin
      writeln('Incorrect vertex: ', u);
      halt(239);
    end;
  if (v < 1) or (v > n) then
    begin
      writeln('Incorrect vertex: ', v);
      halt(239);
    end;
  if (l < 1) or (l > MAX_ROAD_LEN) then
    begin
      writeln('Too long or too short road: ', l);
      halt(239);
    end;

  ex[s]:=u;
  ey[s]:=v;
  el[s]:=l;
  inc(d[u]);
  inc(d[v]);

  pop(r);
  vx[r]:=v;
  len[r]:=l;
  prev[r]:=0;
  next[r]:=head[u];
  prev[head[u]]:=r;
  head[u]:=r;
  p1[s]:=r;

  pop(r);
  vx[r]:=u;
  len[r]:=l;
  prev[r]:=0;
  next[r]:=head[v];
  prev[head[v]]:=r;
  head[v]:=r;
  p2[s]:=r;

  inc(enum);
  heap[enum]:=s;
  en[s]:=enum;
  sift_up(enum);
  solve;
end;

procedure do_deledge;
var r, u, v, m: int;
begin
  read(m);
  u:=ex[m]; v:=ey[m];
  if (u < 0) or (v < 0) then
    begin
      writeln('Incorrect test!!! Step number ', s, '.');
      halt(239);
    end;
  dec(d[u]); ex[m]:=-1;
  dec(d[v]); ey[m]:=-1;

  r:=p1[m];
  vx[r]:=0;
  prev[next[r]]:=prev[r];
  next[prev[r]]:=next[r];
  if (head[u] = r) then
    head[u]:=next[r];
  prev[r]:=0;
  next[r]:=0;

  r:=p2[m];
  vx[r]:=0;
  prev[next[r]]:=prev[r];
  next[prev[r]]:=next[r];
  if (head[v] = r) then
    head[v]:=next[r];
  prev[r]:=0;
  next[r]:=0;

  u:=en[m];
  heapswap(en[m], enum);
  dec(enum);
  sift_up(u);
  sift_down(u);

  solve;
end;

var i, r, m, zzz: int;
begin
  assign(input, 'railroad.in');
  assign(output, 'railroad.out');
  reset(input);
  rewrite(output);
  read(n, m);
  if (n < 1) or (n > 500) then
    begin
      writeln('Too many vertexes: ', n);
      halt(239);
    end;
  if (m < 1) or (m > 50000) then
    begin
      writeln('Too many or no changes made with graph: ', m);
      halt(239);
    end;

  { Init stack of free space }
  for i:=1 to 2 * MAX_NUM do
    st[i]:=2 * MAX_NUM + 1 - i;
  top:=2 * MAX_NUM + 1;

  { Init head of vertexes }
  for i:=1 to n do
    head[i]:=0;

  { Main loop }
  s:=0;
  for zzz:=1 to m do
    begin
      inc(s);
      if (s = 139) then
        s:=s;
      ex[s]:=-1;
      ey[s]:=-1;
      if (s > 50000) then break;
      read(r);
      if (r <> 0) and (r <> 1) then
        begin
          writeln('Incorrect operation. Code: ', r, '.');
          halt(239);
        end;
      if (r = 0) then
        do_addedge
      else
        do_deledge;
    end;
  close(input);
  close(output);
end.