{$Q+,R+,O+}
program macro;
const MaxN=500;  MaxX={2000}500;  MaxDX = {8192}2048;  Leafs = MaxDX*MaxDX;
  Thres = (Leafs+2) div 3;  Tot = (4*Leafs-1) div 3;
var
  A  : array [1..Tot] of integer;
  Xc, Yc, R, u, v : integer;

procedure insert (k, x1, y1, x2, y2 : integer);
var xh, yh : integer;
begin
  if (Xc+u < x1) or (Xc-u > x2) or (Yc+u < y1) or (Yc-u > y2) or
     (Xc+Yc+v < x1+y1) or (Xc+Yc-v > x2+y2) or
     (Xc-Yc+v < x1-y2) or (Xc-Yc-v > x2-y1) then exit;
  if (Xc-u <= x1) and (Xc+u >= x2) and (Yc-u <= y1) and (Yc+u >= y2) and
     (Xc+Yc-v <= x1+y1) and (Xc+Yc+v >= x2+y2) and
     (Xc-Yc-v <= x1-y2) and (Xc-Yc+v >= x2-y1) then begin
         inc(A[k]); exit end;
  if k >= Thres then runerror (239);
  xh := (x1 + x2) shr 1;  yh := (y1 + y2) shr 1;
  k := 4*k-2;
  insert (k, x1, y1, xh, yh);
  insert (k+1, xh+1, y1, x2, yh);
  insert (k+2, x1, yh+1, xh, y2);
  insert (k+3, xh+1, yh+1, x2, y2);
end;

function calc (k, l, q : integer) : integer;
begin
  l := l - A[k];
  if l <= 0 then begin Result := q;  exit end;
  if q = 1 then begin Result := 0;  exit end;
  k := 4*k-2;  q := q shr 2;
  Result := calc(k,l,q)+calc(k+1,l,q)+calc(k+2,l,q)+calc(k+3,l,q)
end;

var i, N, S : integer;
begin
  assign (input, 'octagons.in');  reset (input);
  assign (output, 'octagons.out');  rewrite (output);
  repeat
    read (N);  if (N <= 0) or (N > MaxN) then runerror (239);
    for i := 1 to N do begin
      read (Xc, Yc, R);
      if (abs(Xc) > MaxX) or (abs(Yc) > MaxX) or (R <= 0) or
         (R > MaxX) then runerror (239);
      u := R * 405451 div 438857;
      v := R * 738651 div 565339;
      if v > 2 * u then v := 2 * u;
      {writeln (sqr(2*u+1)-2*(2*u-v)*(2*u-v+1));}
      Xc := Xc + (MaxDX shr 1);  Yc := Yc + (MaxDX shr 1);
      insert (1, 0, 0, MaxDX-1, MaxDX-1)
    end;
    read (S);  if (S <= 0) or (S > MaxN) then runerror (239);
    writeln (calc (1, S, Leafs));
    if seekeof then halt;
    fillchar (A, sizeof(A), 0)
  until false
end.
