Program AKindOfAPlusB;

Type
  Integer=LongInt;

Const
  TaskID='sumtwo';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=240002;

Var
  N:Integer;
  A:Array[1..MaxN]Of Integer;
  Res:Integer;

Procedure Load;
Var
  I:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  For I:=1 To N Do
    Read(A[I]);
  Close(Input);
End;

Procedure QSort(L,R:Integer);
Var
  I,J,X,Y:Integer;
Begin
  I:=L;
  J:=R;
  X:=A[L+Random(R-L+1)];
  While I<=J Do Begin
    While A[I]<X Do Inc(I);
    While X<A[J] Do Dec(J);
    If I<=J Then Begin 
      Y:=A[I];
      A[I]:=A[J];
      A[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  End;
  If L<J Then QSort(L,J);
  If I<R Then QSort(I,R);
End;

Procedure Solve;
Var
  I,A1,A2,Prev,Cur:Integer;
Begin
  QSort(1,N);
  Res:=-MaxLongInt Div 2;
  A1:=N;
  A2:=1;
  Cur:=0;
  For I:=1 To N Do Begin 
    Prev:=Cur;
    If Odd(I) Then Begin
      Cur:=A[A1];
      Dec(A1);
    End Else Begin
      Cur:=A[A2];
      Inc(A2);
    End;
    If (I>1) And (Cur+Prev>Res) Then Res:=Cur+Prev;
  End;
End;

Procedure Save;
Var
  I,A1,A2:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Res);
  A1:=N;
  A2:=1;
  For I:=1 To N Do Begin
    If I>1 Then Write(' ');
    If Odd(I) Then Begin
      Write(A[A1]);
      Dec(A1);
    End Else Begin
      Write(A[A2]);
      Inc(A2);
    End;
  End;
  WriteLn;
  Close(Output);
End;

Begin
  RandSeed:=451543181;
  Load;
  Solve;
  Save;
End.