  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>

  const int N = 'Z'-'A'+1;

  bool ** M;
  char    S[255];


  int temporary_function_for_quick_sort ( const void *first_argument, const void *second_argument )
  {
       return *( (const int*) first_argument ) - *( (const int *) second_argument );
  }

  template <class smth> inline smth Min ( smth A , smth B )
  {  return (A<B)?A:B;  }


  inline bool GetData ( char *Path )
  {
      FILE *DatFile;
      if ( ( DatFile = fopen(Path,"r") ) == NULL ) return false;

      int I=0 , tmp;
      for (;;)
      {
          tmp = fgetc ( DatFile );
          if ( tmp == EOF ) break;
          S[I] = tmp;
          I++;
      }
      S[I] = '\0';
      
      fclose(DatFile);
      return true;
  }


  void JumpDown ( int &I )
  {
      while ( S[I+1] != '(' )
      {
          if ( S[I] == ')' ) { I--; JumpDown(I); }
          I--;
      }
  }

  void JumpUp ( int &I )
  {
      while ( S[I-1] != ')' )
      {
          if ( S[I] == '(' ) { I++; JumpUp(I); }
          I++;
      }
  }


  void Conect ( int A , int B )
  {
      if ( ( S[A] != ')' ) && ( S[B] != '(' ) )
      {
          M [ (int)S[A] - 'A' ] [ (int)S[B] - 'A' ] = true;
          M [ (int)S[B] - 'A' ] [ (int)S[A] - 'A' ] = true;
      }
      else if ( S[A] == ')' )
      {
          int I;
          for ( I=A ; S[I] != '(' ; I-- )
              if ( S[I-1] == ',' ) Conect(I,B);
              else if ( S[I-1] == ')' ) { I-- ; I-- ;JumpDown(I); }
          Conect(I+1,B);
      }
      else if ( S[B] == '(' )
      {
          M [ (int)S[  A] - 'A' ] [ (int)S[B+1] - 'A' ] = true;
          M [ (int)S[B+1] - 'A' ] [ (int)S[  A] - 'A' ] = true;
          int I;
          for ( I=B+2 ; S[I] != ')' ; I++ )
              if ( S[I-1] == ',' )
              {
                  M [ (int)S[A] - 'A' ] [ (int)S[I] - 'A' ] = true;
                  M [ (int)S[I] - 'A' ] [ (int)S[A] - 'A' ] = true;
              }
              else if ( S[I-1] == '(' ) JumpUp( I );
      }
  }


  
  inline void BuildG ( void )
  {
      int I,J;
      for ( J=0; J<N; J++ ) for ( I=0; I<N; I++ ) M[J][I] = false;

      int L[255];

      J = 0;
      for ( I=0 ; I<strlen(S)-1 ; I++ ) if ( S[I] == '-' )
      {
          L[J] = I;
          J++;
          I++;
      }

      for ( I=0 ; I < J ; I++ ) Conect ( L[I]-1 , L[I]+2 );
  }



  int main (void)
  {
      int I,J,H;
      bool f;

      M=(bool**)malloc(N*sizeof(bool*));
      for ( I=0 ; I<N ; I++ ) M[I] = (bool*) malloc ( N*sizeof(bool) );

      if ( ! GetData("dist.in") )
      {
          printf("\n Could not open ""dist.in"" ! \n");
          return 1;
      }
      BuildG();

      int K=0;
      int V[N];
      for ( I=0 ; I<strlen(S) ; I++ ) if ( ( S[I]-'A' < N ) && ( S[I]-'A' >= 0 ) )
      {
          f = true;
          for ( J=0 ; J<K ; J++ ) if ( V[J] == S[I]-'A' ) f = false;
          if ( f )
          {
              V[K] = S[I]-'A';
              K++;
          }
      }
      V[K] = 0;

      int R[N][N];
      for ( I=0 ; I<N ; I++ ) for ( J=0 ; J<N ; J++ )
      if ( M[I][J] ) R[I][J] = 1; else R[I][J] = 1000;
      for ( I=0 ; I<N ; I++ ) R[I][I] = 0;
/*
      for ( I=0 ; I<K ; I++ ) for ( J=I+1 ; J<K ; J++ )
          if (  R [ V[I] ] [ V[J] ] < 1000  )
              printf( "\n  %c - %c  %d" , V[I]+'A' , V[J]+'A' , (int) R [ V[I] ] [ V[J] ] );
      getchar();
*/
      for ( I=0 ; I<K ; I++ )
          for ( H=0 ; H<K ; H++ )
              for ( J=0 ; J<K ; J++ )
                  R [ V[0] ] [ V[H] ] = Min (  R [ V[0] ] [ V[H] ]                         ,
                                               R [ V[0] ] [ V[J] ] + R [ V[J] ] [ V[H] ]   );

      FILE *OutFile;
      OutFile = fopen("dist.out","w");

      qsort ( V , K , sizeof(*V) , temporary_function_for_quick_sort );

      for ( I=0 ; I<K ; I++ )
          if ( R [ V[0] ] [ V[I] ] < 1000 ) fprintf ( OutFile , "%c %d\n" , V[I]+'A' , R [ V[0] ] [ V[I] ] );
          else fprintf ( OutFile , "%c -\n" , V[I]+'A' );

      fclose(OutFile);
      return 0;
  }
