{$o-,q+,r+}
{$apptype console}
uses sysutils, math;

const MaxN=1000;
      MaxL=5;
      Base=1000000000;
      LogBase=9;

type Long=array [0..MaxL] of integer;


procedure add (var a, b, c:long);
var i, z, cy:integer;
begin
  cy:=0;
  z:=max (b[0], c[0])+1;
  for i:=1 to z do begin
    inc (cy, b[i]+c[i]);
    if cy>=Base then begin a[i]:=cy-Base; cy:=1 end
                else begin a[i]:=cy;      cy:=0 end;
  end;
  if a[z]=0 then a[0]:=z-1 else a[0]:=z;
  assert (cy=0);
end;


procedure writel (var a:long);
var s:string;
    i:integer;
begin
  write (a[a[0]]);
  for i:=a[0]-1 downto 1 do begin
    str (a[i], s); while length (s)<LogBase do s:='0'+s;
    write (s);
  end;
end;

var i, j, n, l, x, k:integer;
    a:array [1..MaxN] of integer;
    h:array [1..MaxN] of boolean;
    f:array [1..MaxN, 1..MaxN] of boolean;
    g:array [1..MaxN+1, 0..MaxN] of long;
    b:array [1..MaxN, 1..MaxN] of integer;

begin
  assign (input, 'young.in'); reset (input);
  assign (output, 'young.out'); rewrite (output);
  assert (not seekeoln); read (n); assert ((n>=1) and (n<=MaxN));
  assert (seekeoln); readln;
  for i:=1 to n do begin
    assert (not seekeoln); read (a[i]); 
    assert ((a[i]>=1) and (a[i]<=n) and not h[a[i]]); h[a[i]]:=true;
  end;
  assert (seekeof);
  for l:=1 to n do
    for i:=n-l downto 1 do
      if a[i]<a[i+l] then b[i, l]:=b[i+1, l]+1 else b[i, l]:=0;
  for i:=1 to n do
    for j:=i+1 to n+1 do begin
      f[i, j-i]:=true;
      if (j>n) or (a[j-1]>a[j]) then break;
    end;
  g[n+1, 0, 0]:=1; g[n+1, 0, 1]:=1;
  for k:=1 to n do begin
    for x:=n+1 downto n-k+2 do g[x, k]:=g[x, k-1];
    for x:=n-k+1 downto 1 do 
      if f[x, k] then add (g[x, k], g[x, k-1], g[x+k, min (b[x, k], k)])
                 else g[x, k]:=g[x, k-1];
  end;
  writel (g[1, n]);
end.