program macro;
uses testjury;
const MaxMN=100;
var b, px, py:array [1..MaxMN, 1..MaxMN] of integer;
    m, n, st:integer;
    i, j:integer;
var changes:boolean;

procedure _try (x, y:integer);
begin
  if (x<1) or (x>m) or (y<1) or (y>n) then exit;
  if b[x, y]>st+1 then begin
    b[x, y]:=st+1;
    px[x, y]:=i;
    py[x, y]:=j;
    changes:=true;
  end;
end;


procedure rec (x, y:integer);
begin
  if b[x, y]>0 then rec (px[x, y], py[x, y]);
  writeln (x, ' ', y)
end;

var p, q:integer;
    x1, y1, x2, y2:integer;
begin
  ci ('horse.in'); ao ('horse.out');
  m:=inf.getint; n:=inf.getint;
  test ((m>=1) and (n>=1) and (m<=MaxMN) and (n<=MaxMN));
  p:=inf.getint; q:=inf.getint;
  test ((p>=0) and (q>=0) and (p<=m) and (q<=n));
  test ((p>0) or (q>0));
  x1:=inf.getint; y1:=inf.getint;
  test ((x1>=1) and (y1>=1) and (x1<=m) and (y1<=n));
  x2:=inf.getint; y2:=inf.getint;
  test ((x2>=1) and (y2>=1) and (x2<=m) and (y2<=n));
  reqseof;
  fillchar (b, sizeof (b), 127);
  b[x1, y1]:=0;
  repeat
    changes:=false;
    for i:=1 to m do
      for j:=1 to n do
        if b[i, j]=st then begin
          _try (i-p, j-q);
          _try (i-p, j+q);
          _try (i+p, j-q);
          _try (i+p, j+q);
          _try (i-q, j-p);
          _try (i-q, j+p);
          _try (i+q, j-p);
          _try (i+q, j+p);
        end;
    inc (st);
  until not changes;
  if b[x2, y2]>1000 then writeln (-1)
  else begin writeln (b[x2, y2]); rec (x2, y2);end;
end.