program nearest;

const
    maxn = 10000;

var
    a, i, n, s: longint;
    x, ind, pos: array [1..maxn] of longint;
    z: array [1..maxn] of char;
    t: longint;

procedure sort(l, r: longint);
var
    m, i, j: longint;
begin
    m := abs(x[(l + r) div 2]);
    i := l;
    j := r;
    while i <= j do begin
        while abs(x[i]) > m do inc(i);
        while abs(x[j]) < m do dec(j);
        if i <= j then begin
            t := x[i]; x[i] := x[j]; x[j] := t;
            t := ind[i]; ind[i] := ind[j]; ind[j] := t;
            pos[ind[i]] := i;
            pos[ind[j]] := j;
            inc(i);
            dec(j);
        end;
    end;
    if l < j then sort(l, j);
    if i < r then sort(i, r);
end;

begin
    assign(input, 'nearest.in');
    reset(input);
    assign(output, 'nearest.out');
    rewrite(output);

    read(n, a);
    for i := 1 to n do begin
        read(x[i]);
        ind[i] := i;
        pos[i] := i;
    end;
    
    x[1] := x[1] - a;

    sort(2, n);

    s := x[1];
    for i := 2 to n do begin
        if abs(s + x[i]) < abs(s - x[i]) then begin
            z[i] := '+';
            s := s + x[i];
        end else begin
            z[i] := '-';
            s := s - x[i];
        end;
    end;

    writeln(s+a);
    write(x[1]+a);
    for i := 2 to n do begin
        write(z[pos[i]]);
        write(x[pos[i]]);
    end;
    writeln;

    close(input);
    close(output);
end.