{$O-,Q+,R+}

const MaxN=32;
      MaxL=100;
      Base=10;

type long=array [1..MaxL] of integer;

procedure add (var a, b, c:long);
var cy, i:integer;
begin
  cy:=0;
  for i:=1 to MaxL do begin
    inc (cy, b[i]+c[i]);
    if cy>=Base then begin a[i]:=cy-Base; cy:=1 end
            else begin a[i]:=cy;      cy:=0 end;
  end;
  if cy>0 then runerror (239);
end;


procedure muls (var a, b:long; s:integer);
var cy:int64;
    i:integer;
begin
  cy:=0;
  for i:=1 to MaxL do begin
    inc (cy, b[i]*s);
    a[i]:=cy mod Base;
    cy:=cy div Base;
  end;
  if cy>0 then runerror (239);
end;


procedure writel (var a:long);
var i, k:integer;
begin
  k:=1; for i:=MaxL downto 1 do if a[i]<>0 then begin k:=i; break end;
  for i:=k downto 1 do write (a[i]);
  writeln;
end;


var c:array [0..MaxN, -1..MaxN] of integer;
    f:array ['a'..'z'] of boolean;
    z:array ['a'..'z'] of integer;
    a, b:long;
    x, y:char;
    tmp:integer;
    i, j:integer;
    s:string;


begin
  c[0, 0]:=1;
  for i:=1 to MaxN do
    for j:=0 to i do c[i, j]:=c[i-1, j-1]+c[i-1, j];
  assign (input, 'string.in'); reset (input);
  assign (output, 'string.out'); rewrite (output);
  readln (s);
  if (length (s)=0) or (length (s)>MaxN) then runerror (239);
  for i:=1 to length (s) do 
    if not (s[i] in ['a'..'z']) then runerror (239)
    else begin f[s[i]]:=true; inc (z[s[i]]) end;
  for i:=1 to length (s) do begin
    for x:='a' to pred (s[i]) do
      if f[x] then begin
        fillchar (b, sizeof (b), 0); b[1]:=1;
        tmp:=length (s)-i;
        for y:='a' to 'z' do begin
          if f[y] then if y=x then begin
            muls (b, b, c[tmp, z[y]-1]);
            dec (tmp, z[y]-1);
          end else begin
            muls (b, b, c[tmp, z[y]]);
            dec (tmp, z[y]);
          end;
        end;
        add (a, a, b);
      end;
    dec (z[s[i]]);
  end;
  fillchar (b, sizeof (b), 0); b[1]:=1; add (a, a, b);
  writel (a);
end.