Program ThereExistThreeKindsOfLieTheyAreLieBarefacedLieAndPoliticsTheLatterIsWhatWeAreTalkingAboutSoYoudBetterStopReadingThisTitleAndStartDoingWhatYouAreExpectedToDoNOW;

Type
  Integer=LongInt;

Const
  TaskID='minister';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxM=100002;
  MaxN=4002;
  Infinity=MaxLongInt Div 2;

Var
  N,M:Integer;
  D:Array[1..MaxN]Of Integer;
  R:Array[1..MaxM]Of Record
    A,B,L:Integer;
    Next:Integer;
  End;
  First:Array[1..MaxN]Of Integer;
  Perm,Rating:Array[1..MaxN]Of Integer;
  Res:Int64;

Procedure Load;
Var
  I:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M);
  For I:=1 To N Do Read(D[I]);
  For I:=1 To M Do With R[I] Do Read(A,B,L);
  Close(Input);
End;

Procedure QSort(L,R:Integer);
Var
  I,J,X,Y:Integer;
Begin
  I:=L;
  J:=R;
  X:=Perm[L+Random(R-L+1)];
  While I<=J Do Begin
    While D[Perm[I]]<D[X] Do Inc(I);
    While D[X]<D[Perm[J]] Do Dec(J);
    If I<=J Then Begin
      Y:=Perm[I];
      Perm[I]:=Perm[J];
      Perm[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  End;
  If L<J Then QSort(L,J);
  If I<R Then QSort(I,R);
End;

Procedure Solve;
Var
  I,T,Min,MinAt,Cur:Integer;
Begin
  If D[1]<>0 Then Begin
    Res:=-1;
    Exit;
  End;
  Res:=0;
  For I:=1 To M Do With R[I] Do
    If L<Abs(D[A]-D[B]) Then Begin
      Inc(Res,Abs(D[A]-D[B])-L);
      L:=0;
    End Else Dec(L,Abs(D[A]-D[B]));

  For I:=1 To N Do Perm[I]:=I;
  QSort(1,N);
  For I:=1 To N Do Rating[Perm[I]]:=I;

  FillChar(First,SizeOf(First),0);
  For I:=1 To M Do With R[I] Do Begin
    If Rating[A]>Rating[B] Then Begin
      T:=A;
      A:=B;
      B:=T;
    End;
    If A<>B Then Begin
      Next:=First[B];
      First[B]:=I;
    End;
  End;

  For I:=2 To N Do Begin
    Min:=Infinity;
    Cur:=First[I];
    While Cur>0 Do Begin
      If R[Cur].L<Min Then Begin
        Min:=R[Cur].L;
        MinAt:=Cur;
      End;
      Cur:=R[Cur].Next;
    End;
    If Min>=Infinity Then Begin
      Res:=-1;
      Exit;
    End;
    Inc(Res,R[MinAt].L);
    R[MinAt].L:=0;
  End;
End;

Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Res);
  If Res>=0 Then
    For I:=1 To M Do With R[I] Do
      WriteLn(R[I].L+Abs(D[A]-D[B]));
  Close(Output);
End;

Begin
  RandSeed:=432742821;
  Load;
  Solve;
  Save;
End.
