Program ThereExistThreeKindsOfLieTheyAreLieBarefacedLieAndPoliticsTheLatterIsWhatWeAreTalkingAboutSoYoudBetterStopReadingThisTitleAndStartDoingWhatYouAreExpectedToDoNOW;

Type
  Integer=LongInt;

Const
  TaskID='minister';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxM=100002;
  MaxN=4002;

Var
  N,M:Integer;
  D:Array[1..MaxN]Of Integer;
  R:Array[1..MaxM]Of Record
    A,B,L:Integer;
  End;
  Perm:Array[1..MaxM]Of Integer;
  Parent:Array[1..MaxN]Of Integer;
  Res:Int64;

Procedure Load;
Var
  I:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M);
  For I:=1 To N Do Read(D[I]);
  For I:=1 To M Do With R[I] Do Read(A,B,L);
  Close(Input);
End;

Function Less(A,B:Integer):Boolean;
Begin
  Less:=R[A].L<R[B].L;
End;

Procedure QSort(L,R:Integer);
Var
  I,J,X,Y:Integer;
Begin
  I:=L;
  J:=R;
  X:=Perm[L+Random(R-L+1)];
  While I<=J Do Begin
    While Less(Perm[I],X) Do Inc(I);
    While Less(X,Perm[J]) Do Dec(J);
    If I<=J Then Begin
      Y:=Perm[I];
      Perm[I]:=Perm[J];
      Perm[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  End;
  If L<J Then QSort(L,J);
  If I<R Then QSort(I,R);
End;

Function Get(A:Integer):Integer;
Begin
  If Parent[A]<>A Then Parent[A]:=Get(Parent[A]);
  Get:=Parent[A];
End;

Procedure Union(A,B:Integer);
Begin
  If Random(2)=0 Then
    Parent[A]:=B
  Else
    Parent[B]:=A;
End;

Procedure Solve;
Var
  I,PA,PB:Integer;
Begin
  Res:=0;
  For I:=1 To M Do With R[I] Do
    If L<Abs(D[A]-D[B]) Then Begin
      Inc(Res,Abs(D[A]-D[B])-L);
      L:=0;
    End Else Dec(L,Abs(D[A]-D[B]));
  For I:=1 To M Do Perm[I]:=I;
  QSort(1,M);
  For I:=1 To N Do Parent[I]:=I;
  For I:=1 To M Do With R[Perm[I]] Do Begin
    PA:=Get(A);
    PB:=Get(B);
    If PA<>PB Then Begin
      Union(PA,PB);
      Inc(Res,L);
      L:=0;
    End;
  End;
End;

Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Res);
  If Res>=0 Then
    For I:=1 To M Do With R[I] Do
      WriteLn(R[I].L+Abs(D[A]-D[B]));
  Close(Output);
End;

Begin
  RandSeed:=432742821;
  Load;
  Solve;
  Save;
End.
