{$APPTYPE CONSOLE}
uses
  Balls;

const
  NMAX = 24;

type
  tline = array [0..NMAX] of integer;

var
  _all, all : array [0..1 shl (NMAX + 1)] of integer;
  n, k : integer;
  
function doInt(var l : tline) : integer;
  var
    i : integer;
begin
  Result := 0;
  for i := 0 to NMAX do
    if l[i] <> 0 then
      Result := Result + 1 shl i;
end;

procedure doLine(var l : tline; n : integer);
  var
    i : integer;
begin
  for i := 0 to NMAX do
    if n and (1 shl i) <> 0 then
      l[i] := 1
    else
      l[i] := 0;
end;

procedure update_all(a : integer; r : integer);
  var
    i : integer; 
begin
  writeln(r);
  _all[0] := 0;
  for i := 1 to all[0] do
    if ((all[i] and a <> 0) = (r <> 0)) then begin
      inc(_all[0]);
      _all[_all[0]] := all[i];
    end;
  Move(_all, all, sizeof(all[0]) * (_all[0] + 1));
end;

var
  i, j, ii : integer;
  b, a : tline;
  ka : integer;
  min, pmin : integer;
  ca, cb : integer;
begin
  randseed := 13;
  
  fillchar(b, sizeof(b), 0);
  Init(n, k);
  writeln('Game started... ', n, ' balls, ', k, ' radioballs');

  (*

  fillchar(b, sizeof(b), 0);
  for i := 0 to n - 1 do begin
    fillchar(a, sizeof(a), 0);
    a[i] := 1;
    if IsRadioactive(a) then
    begin
      b[i] := 1;
      writeln(i);
    end;
  end;

  *)

  all[0] := 0;

  for i := 0 to (1 shl n) - 1 do begin
    ka := 0;
    for j := 0 to n - 1 do
      if i and (1 shl j) <> 0 then inc(ka);
    if ka = k then begin
      inc(all[0]);
      all[all[0]] := i;
    end;
  end;

  while all[0] > 1 do begin
    min := 1 shl NMAX;
    pmin := -1;
    for ii := 0 to 1 shl n - 1 do begin
      if ii * all[0] > 1000000000 then
        break;
      i := random(1 shl n);
      ca := 0;
      cb := 0;
      for j := 1 to all[0] do
        if all[j] and i <> 0 then
          inc(ca)
        else
          inc(cb);
      if (min > abs(ca - cb)) then begin
        min := abs(ca - cb);
        pmin := i;
      end;
    end;
    doLine(a, pmin);
    if (IsRadioactive(a)) then
      update_all(pmin, 1)
    else
      update_all(pmin, 0);
  end;

  doLine(b, all[1]);

  Finish(b);
end.