{$o-,q+,r+}
{$apptype console}
uses sysutils;

const MaxMN=55;
      MaxZ=20000;
      inf=MaxZ*100;
      DSize=4;

const dirs:string [DSize]='LURD';
      dx:array [1..DSize] of integer=(-1, 0, 1, 0);
      dy:array [1..DSize] of integer=(0, -1, 0, 1);

type darr=array [1..MaxMN, 1..MaxMN] of integer;
     dtarr=array [1..MaxMN, 1..MaxMN] of boolean;
     parr=array [1..MaxMN*MaxMN*5] of integer;

var wl:array [1..MaxMN, 1..MaxMN, 1..DSize] of boolean;
    mon:array [1..MaxMN, 1..MaxMN] of integer;
    m, n:integer;

procedure dijkstra (var d, px, py:darr; const nextdx, nextdy:darr; var g:dtarr);
var f:array [1..MaxMN, 1..MaxMN] of boolean;
    i, j, dd, min, mini, minj, ni, nj, n2i, n2j:integer;
    dyrka:boolean;
begin
  fillchar (f, sizeof (f), 0);
  repeat
    min:=maxlongint; mini:=0; minj:=0;
    for i:=1 to m do
      for j:=1 to n do
        if not f[i, j] and (d[i, j]<min) then begin 
          min:=d[i, j]; mini:=i; minj:=j 
        end;
    if mini=0 then break;
    f[mini, minj]:=true;
    for dd:=1 to 4 do if not wl[mini, minj, dd] then begin
      ni:=mini+dx[dd]; nj:=minj+dy[dd];
      if nextdx[ni, nj]<>0 then begin 
        dyrka:=true; n2i:=nextdx[ni, nj]; n2j:=nextdy[ni, nj];
        ni:=n2i; nj:=n2j
      end else dyrka:=false;
      if not f[ni, nj] and 
         (min+mon[ni, nj]<d[ni, nj]) then begin
        d[ni, nj]:=min+mon[ni, nj];
        g[ni, nj]:=dyrka;
        px[ni, nj]:=mini;
        py[ni, nj]:=minj
      end;
    end;
    if nextdx[mini, minj]<>0 then begin
      ni:=nextdx[mini, minj]; nj:=nextdy[mini, minj];
      if not f[ni, nj] and (min<d[ni, nj]) then begin
        d[ni, nj]:=min;
        g[ni, nj]:=false;
        px[ni, nj]:=mini;
        py[ni, nj]:=minj
      end
    end;
  until false;
end;


procedure createpath (const px, py, prevdx, prevdy:darr; const g:dtarr; var pathx, pathy:parr;
                      var pc, startx, starty:integer);
var x, y, nx, ny:integer;
begin
  pc:=0; x:=startx; y:=starty;
  repeat
    inc (pc); pathx[pc]:=x; pathy[pc]:=y;
    if g[x, y] then begin
      inc (pc); pathx[pc]:=prevdx[x, y]; pathy[pc]:=prevdy[x, y]
    end;
    if px[x, y]=0 then break;
    nx:=px[x, y]; ny:=py[x, y];
    x:=nx; y:=ny;
  until false;
end;


var x, y, bx, by, px, py, i, j, k, l, w, z, dd, cc, pathc, nx, ny:integer;
    lastx, lasty, min, minx, miny:integer;
    xp, yp, xn, yn, d1, d2, d3, px1, px2, px3, py1, py2, py3:darr;
    g1, g2, g3:dtarr;
    e:array [0..MaxMN+1, 0..MaxMN+1] of boolean;
    IsMon:array [1..MaxMN, 1..MaxMN] of boolean;
    pathx, pathy:parr;
    d:char;
    s:string;


begin
  assign (input, 'princess.in'); reset (input);
  assign (output, 'princess.out'); rewrite (output);
  assert (not seekeoln); read (m); assert ((m>=1) and (m<=MaxMN));
  assert (not seekeoln); read (n); assert ((n>=1) and (n<=MaxMN));
  assert (seekeoln); readln;
  assert (not seekeoln); read (k); assert ((k>=1) and (k<=2*(m+n)));
  assert (seekeoln); readln;
  for i:=1 to k do begin
    assert (not seekeoln); read (x); assert ((x>=1) and (x<=m));
    assert (not seekeoln); read (y); assert ((y>=1) and (y<=n));
    read (d); assert (d=' '); read (d); dd:=pos (d, dirs); assert (dd>0);
    assert (seekeoln); readln;
    assert ((x+dx[dd]<1) or (x+dx[dd]>m) or (y+dy[dd]<1) or (y+dy[dd]>n));
    assert (not e[x+dx[dd], y+dy[dd]]);
    e[x+dx[dd], y+dy[dd]]:=true;
    e[x, y]:=true;
  end;
  assert (not seekeoln); read (z); assert ((z>=0) and (z<=MaxZ));
  assert (seekeoln); readln;
  for i:=1 to z do begin
    assert (not seekeoln); read (x); assert ((x>=1) and (x<=m));
    assert (not seekeoln); read (y); assert ((y>=1) and (y<=n));
    read (d); assert (d=' '); readln (s);
    if s='P' then inc (mon[x, y], 2) else
    if s='MT' then inc (mon[x, y], 4) else
    if s='AM' then inc (mon[x, y], 6) else
    if s='BA' then inc (mon[x, y], 8) else
    if s='BU' then inc (mon[x, y], 10) else
    if s='K' then inc (mon[x, y], 0) else
    assert (false);
    IsMon[x, y]:=true;
  end;
  assert (not seekeoln); read (w); assert ((w>=0) and (w<=m*n));
  assert (seekeoln); readln;
  for i:=1 to n do begin wl[1, i, 1]:=true; wl[m, i, 3]:=true end;
  for i:=1 to m do begin wl[i, 1, 2]:=true; wl[i, n, 4]:=true end;
  for i:=1 to w do begin
    assert (not seekeoln); read (x); assert ((x>=1) and (x<=m));
    assert (not seekeoln); read (y); assert ((y>=1) and (y<=n));
    read (d); assert (d=' '); read (d); dd:=pos (d, dirs); assert (dd>0);
    assert (seekeoln); readln;
    assert (not wl[x, y, dd] and not wl [x+dx[dd], y+dy[dd], ((dd-1) xor 2) + 1]);
    wl[x, y, dd]:=true;
    wl[x+dx[dd], y+dy[dd], ((dd-1) xor 2) + 1]:=true;
  end;
  assert (not seekeoln); read (l); assert ((l>=0) and (l<=m*n-1));
  assert (seekeoln); readln;
  for i:=1 to l do begin
    assert (not seekeoln); read (cc); assert (cc>=1);
    assert (not seekeoln); read (x); assert ((x>=1) and (x<=m));
    assert (not seekeoln); read (y); assert ((y>=1) and (y<=n));
    assert ((mon[x, y]=0) and not IsMon[x, y]);
    bx:=x; by:=y; 
    px:=x; py:=y;
    xp[bx, by]:=-1; yp[bx, by]:=-1;
    for j:=1 to cc-1 do begin
      xn[px, py]:=-1; yn[px, py]:=-1; 
      assert (not seekeoln); read (x); assert ((x>=1) and (x<=m));
      assert (not seekeoln); read (y); assert ((y>=1) and (y<=n));
      assert ((xp[x, y]=0) and (yp[x, y]=0) and (xn[x, y]=0) and (yn[x, y]=0) and 
              (mon[x, y]=0) and not IsMon[x, y]);
      xn[px, py]:=x; yn[px, py]:=y;
      xp[x, y]:=px; yp[x, y]:=py;
      px:=x; py:=y;
    end;
    xn[px, py]:=bx; yn[px, py]:=by;
    xp[bx, by]:=px; yp[bx, by]:=py;
    assert (seekeoln); readln;
  end;
  assert (not seekeoln); read (bx); assert ((bx>=1) and (bx<=m));
  assert (not seekeoln); read (by); assert ((by>=1) and (by<=n));
  assert (seekeoln); readln;
  assert (not seekeoln); read (px); assert ((px>=1) and (px<=m));
  assert (not seekeoln); read (py); assert ((py>=1) and (py<=n));
  assert ((xp[px, py]=0) and (yp[px, py]=0) and (xn[px, py]=0) and (yn[px, py]=0));
  assert (seekeoln); readln;
  assert (seekeof);
  fillchar (d1, sizeof (d1), 31);
  if xn[bx, by]=0 then d1[bx, by]:=mon[bx, by] else begin
    nx:=xn[bx, by]; ny:=yn[bx, by]; d1[nx, ny]:=0; g1[nx, ny]:=true
  end;
  dijkstra (d1, px1, py1, xn, yn, g1);
  fillchar (d2, sizeof (d2), 31);
  d2[px, py]:=mon[px, py];
  dijkstra (d2, px2, py2, xp, yp, g2);
  fillchar (d3, sizeof (d3), 31);
  for x:=1 to m do
    for y:=1 to n do
      if e[x, y] then begin
        if xp[x, y]=0 then d3[x, y]:=mon[x, y] else begin
          nx:=xp[x, y]; ny:=yp[x, y]; d3[nx, ny]:=0; g3[nx, ny]:=true
        end
      end;
  dijkstra (d3, px3, py3, xp, yp, g3);
  min:=maxlongint;
  for x:=1 to m do
    for y:=1 to n do
      if d1[x, y]+d2[x, y]+d3[x, y]-2*mon[x, y]<min then begin
        min:=d1[x, y]+d2[x, y]+d3[x, y]-2*mon[x, y];
        minx:=x; miny:=y;
      end;
  if min>inf then begin writeln (-1); halt end;
  writeln (min);
  createpath (px1, py1, xp, yp, g1, pathx, pathy, pathc, minx, miny);
  lastx:=0; lasty:=0;
  for i:=pathc downto 1 do begin
    if (pathx[i]<>lastx) or (pathy[i]<>lasty) then writeln (pathx[i], ' ', pathy[i]);
    lastx:=pathx[i]; lasty:=pathy[i];
    mon[lastx, lasty]:=0;
  end;
  createpath (px2, py2, xn, yn, g2, pathx, pathy, pathc, minx, miny);
  for i:=1 to pathc do begin
    if (pathx[i]<>lastx) or (pathy[i]<>lasty) then writeln (pathx[i], ' ', pathy[i]);
    lastx:=pathx[i]; lasty:=pathy[i];
    mon[lastx, lasty]:=0;
  end;
  fillchar (d2, sizeof (d2), 31);
  fillchar (g2, sizeof (g2), 0);
  fillchar (px2, sizeof (px2), 0);
  fillchar (py2, sizeof (py2), 0);
  d2[px, py]:=mon[px, py];
  dijkstra (d2, px2, py2, xn, yn, g2);
  assert (d2[minx, miny]=0);
  createpath (px2, py2, xp, yp, g2, pathx, pathy, pathc, minx, miny);
  for i:=pathc downto 1 do begin
    if (pathx[i]<>lastx) or (pathy[i]<>lasty) then writeln (pathx[i], ' ', pathy[i]);
    lastx:=pathx[i]; lasty:=pathy[i];
  end;
  createpath (px3, py3, xn, yn, g3, pathx, pathy, pathc, minx, miny);
  for i:=1 to pathc do begin
    if (pathx[i]<>lastx) or (pathy[i]<>lasty) then writeln (pathx[i], ' ', pathy[i]);
    lastx:=pathx[i]; lasty:=pathy[i];
  end;
end.