{$apptype console}
{$o-,q+,r+}

uses
  SysUtils;

const
  ang: array[1..4, -1..1, 0..1] of boolean = ((
                                            (false, false),
                                            (true, true),
                                            (false, true)),
                                            (
                                            (false, true),
                                            (true, true),
                                            (false, false)),
                                            (
                                            (false, false),
                                            (true, true),
                                            (true, false)),
                                            (
                                            (false, false),
                                            (true, false),
                                            (true, true)));

const
   maxn = 7;

type
  matr = array[0..1 shl maxn, 0..1 shl maxn] of integer;
  vect = array[0..1 shl maxn] of integer;

var
  n, m: integer;
  z: array[1..maxn + 1, 1..maxn + 1] of boolean;
  basenum: array[0..1 shl maxn, 0..1 shl maxn] of integer;
  numb: integer;
  matr1, matr2: matr;

procedure bt(x, y: integer);
var
  i: integer;
  fl: boolean;
  xx, yy, k1, k2: integer;
begin
  while (y <= m) and z[x, y] do begin
    inc(x);
    if x > n + 1 then begin
      x := 1;
      y := y + 1;
    end;
  end;

  if y > m then begin
    k1 := 0;
    for i := 1 to n do begin
      k1 := k1 * 2 + ord(z[i, m + 1]);
    end;
    k2 := 0;
    for i := 1 to m do begin
      k2 := k2 * 2 + ord(z[n + 1, i]);
    end;
    inc(basenum[k1, k2]);
    exit;
  end;

  if x = n + 1 then begin
    bt(1, y + 1);
  end;

  for i := 1 to 4 do begin
    fl := true;
    for xx := -1 to 1 do
      for yy := 0 to 1 do
        if ang[i][xx, yy] and
          ((x + xx > n + 1) or ((x + xx > n) and (y + yy > m)) or (x + xx < 1)) then fl := false;
    if fl then begin
      fl := true;
      for xx := -1 to 1 do
        for yy := 0 to 1 do if ang[i][xx, yy] and z[x + xx, y + yy] then fl := false;
      if fl then begin
        for xx := -1 to 1 do
          for yy := 0 to 1 do if ang[i][xx, yy] then z[x + xx, y + yy] := true;
        bt(x, y);
        for xx := -1 to 1 do
          for yy := 0 to 1 do if ang[i][xx, yy] then z[x + xx, y + yy] := false;
      end;
    end;
  end;
end;

procedure genmatrix(n: integer; var a: matr);
var
  z: array[1..maxn, 1..2] of boolean;
  i, j, x: integer;

  procedure bt2(x: integer);
  var
    xx, yy, ii, k: integer;
    fl: boolean;
  begin
    while (x <= n) and z[x, 1] do inc(x);
    if x > n then begin
      j := 0;
      for xx := 1 to n do if z[xx, 2] then j := j + 1 shl (xx - 1);
      inc(a[i, j]);
    end;
    for ii := 1 to 4 do begin
      fl := true;
      for xx := -1 to 1 do
        for yy := 0 to 1 do
          if ang[ii][xx, yy] and ((x + xx < 1) or (x + xx > n)) then fl := false;
      if fl then begin
        fl := true;
        for xx := -1 to 1 do
          for yy := 0 to 1 do
            if ang[ii][xx, yy] and z[x + xx, 1 + yy] then fl := false;
        if fl then begin
          for xx := -1 to 1 do
            for yy := 0 to 1 do
              if ang[ii][xx, yy] then z[x + xx, 1 + yy] := true;
          bt2(x);
          for xx := -1 to 1 do
            for yy := 0 to 1 do
              if ang[ii][xx, yy] then z[x + xx, 1 + yy] := false;
        end;
      end;
    end;
  end;

begin
  for i := 0 to 1 shl n - 1 do begin
    fillchar(z, sizeof(z), 0);
    for x := 1 to n do if (i shr (x - 1)) and 1 = 1 then z[x, 1] := true;
    bt2(1);
  end;
end;

procedure genresvect(n, b1: integer; matr1: matr; var q1: vect);
var
  v, vv: vect;
  q, i, j: integer;
begin
  fillchar(v, sizeof(v), 0);
  v[0] := 1;
  for q := 1 to b1 - 1 do begin
    fillchar(vv, sizeof(vv), 0);
    for i := 0 to 1 shl n - 1 do begin
      for j := 0 to 1 shl n - 1 do begin
        vv[j] := vv[j] + v[i] * matr1[i, j];
      end;
    end;
    v := vv;
  end;

  for i := 0 to 1 shl n - 1 do
    q1[1 shl n - 1 - i] := v[i];

  if b1 = 0 then begin
    fillchar(q1, sizeof(q1), 0);
    q1[0] := 1;
  end;
end;

var
  a1, b1, a2, b2: integer;
  i, j: integer;
  q1, q2: vect;
  sum: integer;

begin
  assign(input, 'angle.in');
  reset(input);
  assign(output, 'angle.out');
  rewrite(output);

  read(a1, b1, a2, b2);

  n := a1 - b1;
  m := a2 - b2;
  if a1 * a2 - b1 * b2 = 0 then begin
    writeln(1);
    close(output);
    exit;
  end;

  fillchar(z, sizeof(z), 0);
  bt(1, 1);
{
  for i := 0 to 1 shl n - 1 do begin
    for j := 0 to 1 shl m - 1 do write(basenum[i, j], ' ');
    writeln;
  end;
}
  genmatrix(n, matr1);
  genmatrix(m, matr2);
{
  writeln;
  for i := 0 to 1 shl n - 1 do begin
    for j := 0 to 1 shl n - 1 do write(matr1[i, j],' ');
    writeln;
  end;
}
  genresvect(n, b2, matr1, q1);
  genresvect(m, b1, matr2, q2);


  sum := 0;

  for i := 0 to 1 shl n - 1 do
    for j := 0 to 1 shl m - 1 do
      sum := sum + basenum[i, j] * q1[i] * q2[j];

  writeln(sum);

  close(input);
  close(output);
end.
