{$I-,Q-,R-,S-}

uses diehard;

const
  inf = maxlongint shr 1;

  list = 1 shl 10;

type
  int = longint;
  real = extended;

var
  n, k, m : int;
  ans : int;

  a, b, c : Tmap;
  u, u2 : array [0..nmax,0..nmax] of boolean;
  d, px, py : array [0..nmax,0..nmax] of int;
  cpx, cpy : int;
  ex, ey : int;

  tree : array [1..list shl 1] of int;

procedure outdata;
var
  i, j : int;
begin

end;

function ok(dx, dy : int) : boolean;
var
  ac, bc : char;
  i, j : int;
begin
  for i:= 1 to n do
    for j:= 1 to m do
    begin
      ac:= a[(i+ dx-1) mod n+1, (j+dy-1) mod m + 1];
      bc:= b[i,j];
      if (bc <> '?') and (ac <> bc) then
      begin
        ok:= false;
        exit;
      end;
      if u[i,j] and (ac = 'T') then
      begin
        ok:= false;
        exit;
      end;
    end;
  for i:= 1 to n do
    for j:= 1 to m do
      c[i,j]:= a[(i+ dx-1) mod n+1, (j+dy-1) mod m + 1];
  a:= c;
end;

procedure aaok;
var
  i, j : int;
begin
  for i:= 0 to n do
    for j:= 0 to m do
      if ok(i,j) then
        exit;
end;

procedure aok;
var
  i, j : int;
begin
  aaok;
  for i:= 1 to n do
    for j:= 1 to m do
      if a[i,j] = 'T' then
      begin
        ex:= i;
        ey:= j;
        exit;
      end;
end;

function f(ch : char) : int;
begin
  if ch in ['.','T'] then f:= 1 else f:= 10;
end;

function f2(x, y : int) : int;
begin
  f2:= x*26+y;
end;

function findmin : int;
var
  i : int;
begin
  i:= 1;
  while i < list do
  begin
    i:= i shl 1;
    if tree[i] > tree[i+1] then inc(i);
  end;
  findmin:= i -list + 1;
end;

procedure change(v, b : int);
begin
  v:= v + list -1;
  tree[v]:= b;
  while v > 1 do
  begin
    v:= v shr 1;
    tree[v]:= tree[v shl 1 + 1];
    if tree[v] > tree[v shl 1] then tree[v]:= tree[v shl 1];
  end;
end;

procedure dijkstra(sx, sy : int);
var
  i, j : int;
  dx, dy, cx, cy : int;
  cur : int;
  min : int;
begin
  for i:= 1 to n do
    for j:= 1 to m do d[i,j]:= inf;
  for i:= 1 to list shl 1 do tree[i]:= inf;
  d[sx,sy]:= 0;
  change(sx*26+sy,d[sx,sy]);
  fillchar(px,sizeof(px),0);
  fillchar(py,sizeof(py),0);
  fillchar(u2,sizeof(u2),0);
  while true do
  begin
    cx:= 0; cy:= 0; min:= inf;
    cur:= findmin;
    min:= tree[1];
    change(cur,inf);
    cx:= cur div 26;
    cy:= cur mod 26;
    if cx = 0 then break;
    u2[cx,cy]:= true;
    dx:= 0; dy:= 1;
    if d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]
      > min + f(a[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]) then
    begin
      d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= min +
        f(a[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]);
      change(f2((cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1),d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]);
      px[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= cx;
      py[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= cy;
    end;
    dx:= 1; dy:= 0;
    if d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]
      > min + f(a[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]) then
    begin
      d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= min +
        f(a[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]);
      change(f2((cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1),d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]);
      px[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= cx;
      py[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= cy;
    end;
    dx:= n-1; dy:= 0;
    if d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]
      > min + f(a[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]) then
    begin
      d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= min +
        f(a[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]);
      change(f2((cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1),d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]);
      px[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= cx;
      py[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= cy;
    end;
    dx:= 0; dy:= m-1;
    if d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]
      > min + f(a[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]) then
    begin
      d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= min +
        f(a[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]);
      change(f2((cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1),d[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]);
      px[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= cx;
      py[(cx+dx-1) mod n + 1,(cy+dy-1) mod m + 1]:= cy;
    end;
  end;
  cx:= ex; cy:= ey;
  while (px[cx,cy] <> sx) or (py[cx,cy] <> sy) do
  begin
    dx:= px[cx,cy];
    dy:= py[cx,cy];
    cx:= dx; cy:= dy;
  end;
  dx:= 0; dy:= 1;
  if ((sx+dx-1) mod n + 1 = cx) and ((sy+dy-1) mod m + 1 = cy) then
  begin
    if domove(1) then b[cx,cy]:= '*' else b[cx,cy]:= '.';
    cpx:= cx; cpy:= cy;
    exit;
  end;
  dx:= 1; dy:= 0;
  if ((sx+dx-1) mod n + 1 = cx) and ((sy+dy-1) mod m + 1 = cy) then
  begin
    if domove(2) then b[cx,cy]:= '*' else b[cx,cy]:= '.';
    cpx:= cx; cpy:= cy;
    exit;
  end;
  dx:= n-1; dy:= 0;
  if ((sx+dx-1) mod n + 1 = cx) and ((sy+dy-1) mod m + 1 = cy) then
  begin
    if domove(0) then b[cx,cy]:= '*' else b[cx,cy]:= '.';
    cpx:= cx; cpy:= cy;
    exit;
  end;
  dx:= 0; dy:= m-1;
  if ((sx+dx-1) mod n + 1 = cx) and ((sy+dy-1) mod m + 1 = cy) then
  begin
    if domove(3) then b[cx,cy]:= '*' else b[cx,cy]:= '.';
    cpx:= cx; cpy:= cy;
    exit;
  end;
end;

procedure solve;
var
  i, j : int;
begin
  for i:= n downto 1 do a[i]:= a[i-1];
  for j:= m downto 1 do
    for i:= 1 to n do a[i,j]:= a[i,j-1];
  for i:= 1 to n do
    for j:= 1 to m do
      b[i,j]:= '?';
  fillchar(u,sizeof(u),0);
  u[1,1]:= true;
  b[1,1]:= '.';
  cpx:= 1;
  cpy:= 1;
  while true do
  begin
{    writeln(a[1,1]+a[1,2]);
    writeln(a[2,1]+a[2,2]);
    writeln;
    writeln(b[1,1]+b[1,2]);
    writeln(b[2,1]+b[2,2]);}
    aok;
    if a[cpx,cpy] = 'T' then
      if dig then exit else u[cpx,cpy]:= true;
    dijkstra(cpx,cpy);
  end;
end;

procedure solve2;
var
  i, j : int;
begin
  for i:= n downto 1 do a[i]:= a[i-1];
  for j:= m downto 1 do
    for i:= 1 to n do a[i,j]:= a[i,j-1];
  for i:= 1 to n do
    for j:= 1 to m do
      b[i,j]:= '?';
  fillchar(u,sizeof(u),0);
  u[1,1]:= true;
  b[1,1]:= '.';
  cpx:= 1;
  cpy:= 1;
  for i:= 1 to 20 do
  begin
    aok;
    if a[cpx,cpy] = 'T' then
      if dig then exit else u[cpx,cpy]:= true;
    dijkstra(cpx,cpy);
  end;
  while true do
  begin
    while a[cpx,cpy] <> 'T' do dijkstra(cpx,cpy);
    if not u[cpx,cpy] then
      if dig then exit else u[cpx,cpy]:= true;
    aok;
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  init(n,m,a);
  solve;
end;

begin
  readdata;
  outdata;
end.
