{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 16384,0,655360}
Uses DieHard;

Const MaxN=26;
      MaxS=MaxN*MaxN;
      MaxP=6250;
Const INF=724249387;

Const dy:Array[0..3] of Shortint=(0,1,0,-1);
      dx:Array[0..3] of Shortint=(-1,0,1,0);
Const WEIGHT:Array[0..2] of Byte=(1,10,1);

Const OTN:Real=1/11;

Type Real=Double;
     TMyMap=Array[0..MaxN+1,0..MaxN+1] of Byte;
     TMat=Array[1..MaxN,1..MaxN] of Byte;
     Point=record
     x,y:Integer;
     end;
var a:TMyMap;
    map:TMap;
    Were,Can,OCan,Cur:TMat;
    N,M,S:Longint;
    Sliding:Longint;
    PEnd:Point;
    i,j:Longint;

Function CharToByte(ch:Char):Byte;
begin
Case ch of
 '.':CharToByte:=0;
 '*':CharToByte:=1;
 'T':CharToByte:=2;
end;

end;

Procedure FRead;
var g:Longint;
begin
Init(N,M,map);
Sliding:=0;
g:=N*M;
FillChar(a,SizeOf(a),0);
for i:=0 to N do
for j:=0 to M do
begin
  a[i+1,j+1]:=CharToByte(map[i,j]);
  Inc(g,Ord(map[i,j]));
  if a[i+1,j+1]=1 then
    Inc(Sliding)
  else if a[i+1,j+1]=2 then
  begin
    PEnd.x:=i+1;
    PEnd.y:=j+1;
  end;
end;
for i:=1 to N do
begin
  a[i,0]:=a[i,M];
  a[i,M+1]:=a[i,1];
end;
for j:=1 to M do
begin
  a[0,j]:=a[N,j];
  a[N+1,j]:=a[1,j];
end;

S:=N*M;
RandSeed:=g;

FillChar(Were,SizeOf(Were),0);
FillChar(Can,SizeOf(Can),1);
end;

Procedure IncPoint(var p:Point;dx,dy:Shortint);
begin
Inc(p.x,dx);
Inc(p.y,dy);
if p.x<=0 then Inc(p.x,M);
if p.y<=0 then Inc(p.y,N);
if p.x>M then Dec(p.x,M);
if p.y>N then Dec(p.y,N);
end;

Procedure FindMin(Start:Point);
var f:Array[1..MaxN,1..MaxN] of Boolean;
    d:Array[1..MaxN,1..MaxN] of Longint;
    prev:Array[1..MaxN,1..MaxN] of Byte;
    Ans:Array[1..MaxS] of byte;
    k,i,j,g,h,ii,jj:Longint;
    pt:Point;
begin
FillChar(f,SizeOf(f),False);
FillChar(d,SizeOf(d),43);
d[Start.x,Start.y]:=0;

for k:=1 to S do
begin
  g:=INF;
  for i:=1 to N do
  for j:=1 to M do
    if (f[i,j]=False) AND (d[i,j]<g) then
    begin
      g:=d[i,j];
      ii:=i;
      jj:=j;
    end;

  f[ii,jj]:=True;
  for h:=0 to 3 do
  begin
    pt.x:=ii; pt.y:=jj;
    IncPoint(pt,dx[h],dy[h]);
    if d[ii,jj]+WEIGHT[a[pt.x,pt.y]]<d[pt.x,pt.y] then
    begin
      d[pt.x,pt.y]:=d[ii,jj]+WEIGHT[a[pt.x,pt.y]];
      prev[pt.x,pt.y]:=h;
    end;
  end;
end;

k:=0;
pt:=PEnd;
While (pt.x<>Start.x) OR (pt.y<>Start.y) Do
begin
  g:=prev[pt.x,pt.y];
  Inc(k);
  Ans[k]:=g;
  IncPoint(pt,-dx[g],-dy[g]);
end;
for i:=k downto 1 do
  DoMove(Ans[i]);
Dig;
end;

var SlideSide:Array[0..3] of Longint;
    Img,MReal:TMat;
    PImg,PReal:Point;
    NumMoves:Longint;

Procedure Solve;
var k,g,h:Longint;
    NCur:Longint;
    Dir:Byte;
    f:Boolean;
    t1,t2,RCurMin:Real;
    pt,pt2:Point;
begin
if Sliding=0 then
begin
  for j:=1 to M do
  begin
    for i:=1 to N-1 do
    begin
      DoMove(0);
      Dig;
    end;
    DoMove(1);
    Dig;
    for i:=1 to N-1 do
    begin
      DoMove(2);
      Dig;
    end;
    DoMove(1);
    Dig;
  end;
end;

FillChar(Img,SizeOf(Img),0);
PImg.x:=1; PImg.y:=1;
NumMoves:=0;
f:=True;
Repeat
  if (f=False) AND (Img[PImg.x,PImg.y]=0) then
  begin
    if Random(S)<5*Sliding then
    begin
      Dig;
      Img[PImg.x,PImg.y]:=1;
    end;
  end;

  FillChar(SlideSide,SizeOf(SlideSide),0);
  NCur:=0;
  for i:=1 to N do
  for j:=1 to M do
    if Can[i,j]=1 then
    begin
      PReal.x:=i; PReal.y:=j;
      Inc(NCur);
      for k:=0 to 3 do
        if (a[i+dx[k],j+dy[k]]=1) then
          Inc(SlideSide[k]);
    end;

  if NCur=1 then
    Break;

  RCurMin:=1E50;
  Dir:=4;
  for k:=0 to 3 do
  begin
    pt2:=PImg;
    IncPoint(pt2,dx[k],dy[k]);
    if Img[pt2.x,pt2.y]=0 then
    begin
      t1:=SlideSide[k]; t1:=Abs(t1/NCur-OTN);
      if t1<RCurMin then
      begin
        Dir:=k;
        RCurMin:=t1;
      end;
    end;
  end;
  if Dir=4 then Dir:=Random(2);

  IncPoint(PImg,dx[Dir],dy[Dir]);

  pt:=PEnd;
  IncPoint(pt,dx[Dir],dy[Dir]);

  Inc(NumMoves);
  f:=DoMove(Dir);
  OCan:=Can;
  FillChar(Can,SizeOf(Can),0);

  for i:=1 to N do
  for j:=1 to M do
    if (OCan[i,j]=1) then
    begin
      pt2.x:=i;
      pt2.y:=j;
      IncPoint(pt2,dx[Dir],dy[Dir]);

      if ((f=True) XOR (a[pt2.x,pt2.y]=1))=False then
        Can[pt2.x,pt2.y]:=1;
    end;
  Can[pt.x,pt.y]:=0;
Until False;

FillChar(MReal,SizeOf(MReal),0);
for i:=1 to N do
for j:=1 to M do
begin
  pt.x:=i;
  pt.y:=j;
  IncPoint(pt,PReal.x-PImg.x,PReal.y-PImg.y);
  MReal[pt.x,pt.y]:=Img[i,j];
end;

FindMin(PReal);
end;

begin
FRead;
Solve;
end.
