{$R-,S-,Q-,I-,L-}
uses diehard;
const big=maxlongint div 4;
type ValMap=array[0..nmax,0..nmax] of longint;
     ValMap2=array[0..nmax,0..nmax] of record
                                         d,p:longint;
                                       end;
var
  n,m,i,j,k,pr:longint;
  map:TMap;
  a,b,f:ValMap;
  d:ValMap2;
  min,mx,my,xn,yn:longint;
  act:boolean;
  dx,dy:longint;

procedure dijkstra;
begin
  for i:=1 to n*m do
  begin
    min:=big;
    mx:=0;
    my:=0;
    for j:=0 to n-1 do
      for k:=0 to m-1 do
        if (d[j,k].d<min)and(f[j,k]=0) then
        begin
          min:=d[j,k].d;
          mx:=j;
          my:=k;
        end;
    f[mx,my]:=1;
    xn:=mx+1;
    yn:=my;
    if xn>n-1 then xn:=0;
    pr:=DMG_MOVE;
    if map[xn,yn]='*' then pr:=pr+DMG_FALL;
    if d[xn,yn].d>d[mx,my].d+pr then
    begin
      d[xn,yn].d:=d[mx,my].d+pr;
      d[xn,yn].p:=DIR_UP;
    end;
    xn:=mx-1;
    yn:=my;
    if xn<0 then xn:=n-1;
    pr:=DMG_MOVE;
    if map[xn,yn]='*' then pr:=pr+DMG_FALL;
    if d[xn,yn].d>d[mx,my].d+pr then
    begin
      d[xn,yn].d:=d[mx,my].d+pr;
      d[xn,yn].p:=DIR_DOWN;
    end;
    xn:=mx;
    yn:=my+1;
    if yn>m-1 then yn:=0;
    pr:=DMG_MOVE;
    if map[xn,yn]='*' then pr:=pr+DMG_FALL;
    if d[xn,yn].d>d[mx,my].d+pr then
    begin
      d[xn,yn].d:=d[mx,my].d+pr;
      d[xn,yn].p:=DIR_LEFT;
    end;
    xn:=mx;
    yn:=my-1;
    if yn<0 then yn:=m-1;
    pr:=DMG_MOVE;
    if map[xn,yn]='*' then pr:=pr+DMG_FALL;
    if d[xn,yn].d>d[mx,my].d+pr then
    begin
      d[xn,yn].d:=d[mx,my].d+pr;
      d[xn,yn].p:=DIR_RIGHT;
    end;
  end;
end;


begin
  init(n,m,map);
  for i:=0 to n-1 do
    for j:=0 to m-1 do
      if map[i,j]='.' then a[i,j]:=1 else a[i,j]:=0;
  b:=a;
  fillchar(f,sizeof(f),0);
  for i:=0 to m-1 do
    for j:=0 to n-1 do
      if map[i,j]<>'T' then
        d[i,j].d:=big else d[i,j].d:=0;
  dijkstra;
  while true do
  begin
    min:=big;
    mx:=0;
    my:=0;
    for i:=0 to n-1 do
      for j:=0 to m-1 do
        if (d[i,j].d<min)and(b[i,j]=1) then begin min:=d[i,j].d; mx:=i; my:=j; end;
    if map[mx,my]='T' then
    begin
      act:=dig;
      if not act then
      begin
        b[mx,my]:=0;
        a[mx,my]:=0;
      end;
    end else
    begin
      act:=domove(d[mx,my].p);
      if act then
      begin
        fillchar(b,sizeof(b),0);
        case d[mx,my].p of
          DIR_UP:begin dx:=-1; dy:=0; end;
          DIR_DOWN:begin dx:=1; dy:=0; end;
          DIR_LEFT:begin dx:=0; dy:=-1; end;
          DIR_RIGHT:begin dx:=0; dy:=1; end;
        end;
        for i:=0 to n-1 do
          for j:=0 to m-1 do
            if a[i,j]=1 then
            begin
              xn:=i+dx;
              yn:=j+dy;
              if xn<0 then xn:=n-1;
              if xn>n-1 then xn:=0;
              if yn<0 then yn:=m-1;
              if yn>m-1 then yn:=0;
              if map[xn,yn]='*' then b[xn,yn]:=1;
            end;
        a:=b;
      end else
      begin
        fillchar(b,sizeof(b),0);
        case d[mx,my].p of
          DIR_UP:begin dx:=-1; dy:=0; end;
          DIR_DOWN:begin dx:=1; dy:=0; end;
          DIR_LEFT:begin dx:=0; dy:=-1; end;
          DIR_RIGHT:begin dx:=0; dy:=1; end;
        end;
        for i:=0 to n-1 do
          for j:=0 to m-1 do
            if a[i,j]=1 then
            begin
              xn:=i+dx;
              yn:=j+dy;
              if xn<0 then xn:=n-1;
              if xn>n-1 then xn:=0;
              if yn<0 then yn:=m-1;
              if yn>m-1 then yn:=0;
              if map[xn,yn] in ['.','T'] then b[xn,yn]:=1;
            end;
        a:=b;
      end;
    end;
  end;
end.