program zzz;

const
  inf = 500010;
  maxn = 350000;
  osn = 1 shl 20;

type
  otr = record
    x1,x2: Longint;
    col: char;
  end;

var
  fl: Boolean;
  us: array[1..maxn] of Boolean;
  sx,sy,bnum,blen,t,xx,yy,xs,xf,scc,ncur,sc,i,j,k,n,m: Longint;
  st: array[1..maxn] of Longint;
  r: array[-510001..510001] of Longint;
  a: array[1..maxn] of otr;
  tr: array[1..2*osn] of Byte;

procedure update(x,val: Longint);
var i: Longint;
begin
  i := x + 500005 + osn;
  tr[i] := val;
  while i <> 1 do begin
    i := i div 2;
    if (tr[i*2] <> 0) or (tr[i*2+1] <> 0) then tr[i] := 1 else tr[i] := 0;
  end;
end;

function next(x: Longint): Longint;
var i: Longint;
begin
  i := x + 500005 + osn;
  while true do begin
    if (i > osn) and (tr[i] = 1) then break;
    if tr[i] = 0 then i := (i+1) div 2 else begin
      if tr[i*2] = 1 then i := i * 2 else i := i * 2 + 1;
    end;
  end;
  next := i - 500005 - osn;
end;

function prev(x: Longint): Longint;
var i: Longint;
begin
  i := x + 500005 + osn;
  while true do begin
    if (i > osn) and (tr[i] = 1) then break;
    if tr[i] = 0 then i := (i-1) div 2 else begin
      if tr[i*2+1] = 1 then i := i * 2 + 1 else i := i * 2;
    end;
  end;
  prev := i - 500005 - osn;
end;

{procedure cross(n1,n2: Longint);
begin
  if (a[n1].x1 >= a[n2].x1) and (a[n1].x2 <= a[n2].x2) then begin
    update(a[n1].x1,0);
    update(a[n1].x2,0);
    r[a[n1].x1] := 0;
    r[a[n1].x2] := 0;
    if (a[n1].col = 'B') then begin
      dec(bnum);
    end;
    dec(blen,a[n1].x2 - a[n1].x1 + 1);
  end else begin
    if (a[n1].x1 < a[n2].x1) and (a[n1].x2 > a[n2].x2) then begin
      if (a[n2].col ='W') then begin
        inc(bcnt);
      end;
      dec(blen,a[n2].x2 - a[n2].x1 + 1);
    end else begin
      if a[n1].x < a[n2].x then begin
      end else begin
      end;
    end;
  end;
end;}

begin
  assign(input,'painter.in'); reset(input);
  readln(n);
  update(inf,1);
  update(-500002,1);
  r[inf] := 10000000;
{  update(100,1);
  writeln(next(0));
  writeln(next(100));
  writeln(next(101));}
  bnum := 0;
  blen := 0;
  sc := n;
  assign(output,'painter.out'); rewrite(output);
  for i := 1 to n do begin
    readln(a[i].col,a[i].x1,a[i].x2);
    xs := a[i].x1;
    a[i].x2 := a[i].x1 + a[i].x2 - 1;
    xf := a[i].x2;
    k := next(a[i].x2+1);
    t := prev(a[i].x1-1);
    if r[t] = r[k] then begin
      t := r[t];
      if a[t].col <> a[i].col then begin
        inc(sc);
        a[sc].x1 := a[i].x2+1;
        update(a[i].x2+1,1);
        r[a[i].x2+1] := sc;
        a[sc].x2 := a[t].x2;
        a[sc].col := a[t].col;
        update(a[t].x2,1);
        r[a[t].x2] := sc;
        a[t].x2 := a[i].x1-1;
        r[a[t].x2] := t;
        update(a[t].x2,1);
        inc(bnum);
        if a[t].col = 'B' then begin
          blen := blen - (a[i].x2 - a[i].x1 + 1);
        end else begin
          blen := blen + (a[i].x2 - a[i].x1 + 1);
        end;
        sx := a[i].x1;
        sy := a[i].x2;
        r[sx] := i;
        r[sy] := i;
        update(sx,1);
        update(sy,1);
{        if a[i].col = 'B' then begin
          inc(blen,sy-sx+1);
        end;}
        a[i].x1 := sx;
        a[i].x2 := sy;
      end else begin
        us[i] := true;
        writeln(bnum,' ',blen);
        continue;
      end;
    end else begin
      k := a[i].x1-1;
      k := next(k);
      sx := a[i].x1;
      sy := a[i].x2;
      while k <= a[i].x2+1 do begin
        t := r[k];
        if t = 0 then begin
          writeln('BOTVA');
          close(output);
          halt(0);
        end;
        if us[t] then begin
          k := next(k+1);
          continue;
        end;
        if a[t].col = a[i].col then begin
          us[t] := true;
          if a[t].col = 'B' then begin
            dec(bnum);
            blen := blen - (a[t].x2 - a[t].x1 + 1);
          end;
          if sx > a[t].x1 then sx := a[t].x1;
          if sy < a[t].x2 then sy := a[t].x2;
          r[a[t].x1] := 0;
          r[a[t].x2] := 0;
          update(a[t].x1,0);
          update(a[t].x2,0);
        end else begin
          if a[t].x1 < a[i].x1 then begin
            if a[t].col = 'B' then begin
              blen := blen - (a[t].x2 - a[i].x1+1);
            end;
            update(a[t].x2,0);
            r[a[t].x2] := 0;
            a[t].x2 := a[i].x1-1;
            update(a[t].x2,1);
            r[a[t].x2] := t;
          end else begin
            if a[t].x2 > a[i].x2 then begin
              if a[t].col = 'B' then begin
                blen := blen - (a[i].x2 - a[t].x1+1);
              end;
              update(a[t].x1,0);
              r[a[t].x1] := 0;
              a[t].x1 := a[i].x2+1;
              update(a[t].x1,1);
              r[a[t].x1] := t;
            end else begin
              us[t] := true;
              if a[t].col = 'B' then begin
                dec(bnum);
                blen := blen - (a[t].x2 - a[t].x1 + 1);
              end;
              update(a[t].x1,0);
              update(a[t].x2,0);
              r[a[t].x1] := 0;
              r[a[t].x2] := 0;
            end;
          end;
        end;
        k := next(k+1);
      end;
      r[sx] := i;
      r[sy] := i;
      update(sx,1);
      update(sy,1);
      if a[i].col = 'B' then begin
        inc(bnum);
        inc(blen,sy-sx+1);
      end;
      a[i].x1 := sx;
      a[i].x2 := sy;
    end;
{    for j := 1 to sc do begin
      if us[j] then continue;
      if (j <= n) and (j > i) then continue;
      if (r[a[j].x1] <>j) or (r[a[j].x2] <> j) then begin
        writeln('BOTVA',' ',j);
        close(output);
        halt(0);
      end;
    end;}
    writeln(bnum,' ',blen);
  end;
  close(input);
  close(output);
end.
