{$I-,Q-,R-,S-}
uses
  diehard;

const
  vx:array[0..3] of integer=(-1,0,1,0);
  vy:array[0..3] of integer=(0,1,0,-1);

var
  b:byte;
  n,m:longint;
  map1:TMap;
  map:array[1..nmax,1..nmax] of char;
  can,d,w:array[1..nmax,1..nmax] of boolean;
  i1,j1,i,j,dx,dy,x,y,tx,ty:integer;
  t:array[1..nmax,1..nmax] of longint;
  u:array[1..nmax,1..nmax] of boolean;
  from:array[1..nmax,1..nmax] of byte;
  cst:integer;

function goodx(x:integer):integer;
begin
  goodx:=x;
  while goodx<1 do
    inc(goodx,n);
  while goodx>n do
    dec(goodx,n);
end;

function goody(y:integer):integer;
begin
  goody:=y;
  while goody<1 do
    inc(goody,m);
  while goody>m do
    dec(goody,m);
end;

procedure addbaddig;
var
  i,j:integer;
begin
  i:=goodx(tx-dx+1);
  j:=goody(ty-dy+1);
  can[i,j]:=false;
end;

procedure mydig;
begin
  if d[dx,dy] then
    exit;
  d[dx,dy]:=true;
  dig();
  addbaddig();
end;

procedure addbadstart;
var
  i,j,i1,j1,dx1,dy1:integer;
begin
  for i:=1 to n do
    for j:=1 to m do begin
      i1:=goodx(i+dx-1);
      j1:=goody(j+dy-1);
      if map[i1,j1]<>'*' then begin
        can[i,j]:=false;
{
        dx1:=dx;
        dy1:=dy;
        dx:=goodx(tx-i+1);
        dy:=goody(ty-j+1);
        d[dx,dy]:=true;
        addbaddig;
        dx:=dx1;
        dy:=dy1;
}

      end;
    end;
end;

procedure addbadstart2;
var
  i,j,i1,j1,dx1,dy1:integer;
begin
  for i:=1 to n do
    for j:=1 to m do begin
      i1:=goodx(i+dx-1);
      j1:=goody(j+dy-1);
      if (map[i1,j1]='*') then begin
        can[i,j]:=false;
{
        dx1:=dx;
        dy1:=dy;
        dx:=goodx(tx-i+1);
        dy:=goody(ty-j+1);
        d[dx,dy]:=true;
        addbaddig;
        dx:=dx1;
        dy:=dy1;
}
      end;
    end;
end;

procedure mydomove(dir:longint);
var
  f:boolean;

begin
  dx:=goodx(dx+vx[dir]);
  dy:=goody(dy+vy[dir]);
  f:=domove(dir);
  if f then begin
    w[dx,dy]:=true;
    d[dx,dy]:=true;
    addbaddig();
    addbadstart();
  end;
  if not d[dx,dy] then
    mydig();
  if not f then
    addbadstart2();

end;

function cost(i,j:integer):integer;
begin
  case map[i,j] of
    '*':cost:=10;
    '.':begin
      cost:=1;
    end;
    'T':cost:=0;
  end;
end;

begin
  init(n,m,map1);
  for i:=1 to n do
    for j:=1 to m do
      map[i,j]:=map1[i-1,j-1];
  for i:=1 to n do
    for j:=1 to m do begin
      can[i,j]:=map[i,j]='.';
      if map[i,j]='T' then begin
        tx:=i;
        ty:=j;
      end;
    end;

  fillchar(d,sizeof(d),false);
  fillchar(w,sizeof(d),false);
  dx:=1;
  dy:=1;
  d[dx,dy]:=true;










        for i:=1 to n do
          for j:=1 to m do
            t[i,j]:=1000000;
        fillchar(u,sizeof(u),false);
        t[tx,ty]:=0;
        fillchar(from,sizeof(from),0);
        while true do begin
          i:=1;
          j:=1;
          for i1:=1 to n do
            for j1:=1 to m do
              if (not u[i1,j1]) and ((u[i,j]) or (t[i1,j1]<t[i,j])) then begin
                i:=i1;
                j:=j1;
              end;
          if (u[i,j]) then
            break;
          u[i,j]:=true;
          for b:=0 to 3 do begin
            i1:=goodx(i+vx[b]);
            j1:=goody(j+vy[b]);
            cst:=cost(i1,j1);
            if (not u[i1,j1]) and (t[i1,j1]>t[i,j]+cst) then begin
              t[i1,j1]:=t[i,j]+cst;
              from[i1,j1]:=(b+2) mod 4;
            end;
          end;
        end;





  for x:=1 to n do begin
    for y:=1 to m do begin
      if can[x,y] then begin


{
        for i:=1 to n do
          for j:=1 to m do
            t[i,j]:=1000000;
        fillchar(u,sizeof(u),false);
        t[tx,ty]:=0;
        fillchar(from,sizeof(from),0);
        while true do begin
          i:=1;
          j:=1;
          for i1:=1 to n do
            for j1:=1 to m do
              if (not u[i1,j1]) and ((u[i,j]) or (t[i1,j1]<t[i,j])) then begin
                i:=i1;
                j:=j1;
              end;
          if (i=x) and (j=y) then
            break;
          u[i,j]:=true;
          for b:=0 to 3 do begin
            i1:=goodx(i+vx[b]);
            j1:=goody(j+vy[b]);
            cst:=cost(i1,j1);
            if (not u[i1,j1]) and (t[i1,j1]>t[i,j]+cst) then begin
              t[i1,j1]:=t[i,j]+cst;
              from[i1,j1]:=(b+2) mod 4;
            end;
          end;
        end;
}

        i:=x;
        j:=y;
        while can[x,y] do begin
          i1:=goodx(i+vx[from[i,j]]);
          j1:=goody(j+vy[from[i,j]]);
          mydomove(from[i,j]);
          i:=i1;
          j:=j1;
          if (i=tx) and (j=ty) then
            can[x,y]:=false;
        end;





      end;
    end;
  end;

  randseed:=666;
  while true do begin
    domove(random(4));
    dig;
  end;

end.
