const MAXOTR=500000;
type node=record
     val,l,r:longint;
end;
var treex,treey:array[0..MAXOTR]of node;
    otr:array[0..MAXOTR,1..2]of longint;
    x,l,cb,notr,n,cursum:longint;
    c:char;

procedure AddX(num:longint);
var was,cur:longint;
begin
     was:=0;
     cur:=1;
     if treex[cur].val=0 then begin
        treex[cur].val:=num;
        exit;
     end;
     while cur<>0 do begin
           was:=cur;
           if (otr[num,1]>otr[treex[cur].val,1]) then begin
              if treex[cur].r=0 then begin
                 treex[cur].r:=2*cur+1;
                 treex[2*cur+1].val:=num;
                 treex[2*cur+1].l:=0;
                 treex[2*cur+1].r:=0;
                 exit;
              end;
              cur:=treex[cur].r;
           end
           else begin
              if treex[cur].l=0 then begin
                 treex[cur].l:=2*cur;
                 treex[2*cur].val:=num;
                 treex[2*cur].l:=0;
                 treex[2*cur].r:=0;
                 exit;
              end;
              cur:=treex[cur].l;
           end;
     end;
     if cur=1 then treex[1].val:=num;
end;

procedure AddY(num:longint);
var was,cur:longint;
begin
     was:=0;
     cur:=1;
     if treey[cur].val=0 then begin
        treey[cur].val:=num;
        exit;
     end;
     while cur<>0 do begin
           was:=cur;
           if (otr[num,2]>otr[treey[cur].val,2]) then begin
              if treey[cur].r=0 then begin
                 treey[cur].r:=2*cur+1;
                 treey[2*cur+1].val:=num;
                 treey[2*cur+1].l:=0;
                 treey[2*cur+1].r:=0;
                 exit;
              end;
              cur:=treey[cur].r;
           end
           else begin
              if treey[cur].l=0 then begin
                 treey[cur].l:=2*cur;
                 treey[2*cur].val:=num;
                 treey[2*cur].l:=0;
                 treey[2*cur].r:=0;
                 exit;
              end;
              cur:=treey[cur].l;
           end;
     end;
     if cur=1 then treey[1].val:=num;
end;

procedure ChangeX(cur:longint);
var nxt:longint;
begin
     if treex[cur].l<>0 then begin
        nxt:=treex[cur].l;
        if (treex[nxt].l=0)and(treex[nxt].r=0) then treex[cur].l:=0;
     end
     else if treex[cur].r<>0 then begin
          nxt:=treex[cur].r;
          if (treex[nxt].l=0)and(treex[nxt].r=0) then treex[cur].r:=0;
     end
     else begin
          treex[cur].val:=0;
          exit;
     end;
     treex[cur].val:=treex[nxt].val;
     ChangeX(nxt);
end;

procedure DeleteX(num:longint);
var cur,was:longint;
begin
     cur:=1;
     was:=0;
     while otr[treex[cur].val,1]<>otr[num,1] do begin
           was:=cur;
           if otr[num,1]>otr[treex[cur].val,1] then begin
              cur:=treex[cur].r;
           end
           else cur:=treex[cur].l;
     end;
     ChangeX(cur);
end;

procedure ChangeY(cur:longint);
var nxt:longint;
begin
     if treey[cur].l<>0 then begin
        nxt:=treey[cur].l;
        if (treey[nxt].l=0)and(treey[nxt].r=0) then treey[cur].l:=0;
     end
     else if treey[cur].r<>0 then begin
          nxt:=treey[cur].r;
          if (treey[nxt].l=0)and(treey[nxt].r=0) then treey[cur].r:=0;
     end
     else begin
          treey[cur].val:=0;
          exit;
     end;
     treey[cur].val:=treey[nxt].val;
     ChangeY(nxt);
end;

procedure DeleteY(num:longint);
var cur,was:longint;
begin
     cur:=1;
     was:=0;
     while otr[treey[cur].val,2]<>otr[num,2] do begin
           was:=cur;
           if otr[num,2]>otr[treey[cur].val,2] then begin
              cur:=treey[cur].r;
           end
           else cur:=treey[cur].l;
     end;
     Changey(cur);
end;

function Find1(x1,y1:longint):longint;
var cur:longint;
begin
     cur:=1;
     while not((otr[treex[cur].val,1]<x1)and(otr[treex[cur].val,2]>=x1)and(otr[treex[cur].val,2]<y1))do begin
           if otr[treex[cur].val,1]<x1 then begin
              cur:=treex[cur].r;
              if cur=0 then begin
                 Find1:=0;
                 exit;
              end;
           end
           else begin
              cur:=treex[cur].l;
              if cur=0 then begin
                 Find1:=0;
                 exit;
              end;
           end;
     end;
     Find1:=treex[cur].val;
end;

function Find3(x1,y1:longint):longint;
var cur:longint;
begin
     cur:=1;
     while not((otr[treey[cur].val,1]<=y1)and(otr[treey[cur].val,2]>y1)and(otr[treey[cur].val,1]>x1))do begin
           if otr[treey[cur].val,2]<y1 then begin
              cur:=treey[cur].r;
              if cur=0 then begin
                 Find3:=0;
                 exit;
              end;
           end
           else begin
              cur:=treey[cur].l;
              if cur=0 then begin
                 Find3:=0;
                 exit;
              end;
           end;
     end;
     Find3:=treey[cur].val;
end;

function Find2(x1,y1:longint):longint;
var cur:longint;
begin
     cur:=1;
     while not((otr[treex[cur].val,1]<=x1)and(otr[treex[cur].val,2]>=y1))do begin
           if otr[treex[cur].val,1]<x1 then begin
              cur:=treex[cur].r;
              if cur=0 then begin
                 Find2:=0;
                 exit;
              end;
           end
           else begin
              cur:=treex[cur].l;
              if cur=0 then begin
                 Find2:=0;
                 exit;
              end;
           end;
     end;
     Find2:=treex[cur].val;
end;


function Find4(x1,y1:longint):longint;
var cur:longint;
begin
     cur:=1;
     while not((otr[treex[cur].val,1]>=x1)and(otr[treex[cur].val,2]<=y1))do begin
           if otr[treex[cur].val,1]<x1 then begin
              cur:=treex[cur].r;
              if cur=0 then begin
                 Find4:=0;
                 exit;
              end;
           end
           else begin
              cur:=treex[cur].l;
              if cur=0 then begin
                 Find4:=0;
                 exit;
              end;
           end;
     end;
     Find4:=treex[cur].val;
end;

procedure Merge(x1,y1,x2,y2:longint;var xr,yr:longint);
begin
     if x1<x2 then xr:=x1
     else xr:=x2;
     if y1>y2 then yr:=y1
     else yr:=y2;
     dec(cursum,y2-x2);
     dec(cb);
end;

procedure Split(x1,y1,x2,y2:longint;var xr,yr:longint);
begin
     if (y1>x2)and(y1<y2) then begin
        xr:=x1;
        yr:=x2;
        if xr=yr then xr:=-500001;
     end
     else begin
        xr:=y1;
        yr:=y2;
        if xr=yr then xr:=-500001;
     end;
end;

procedure Intersect(x1,y1:longint);
var m,xx,yy:longint;
begin
     {1}
     m:=Find1(x1,y1);
     if m<>0 then begin
        DeleteX(m);
        DeleteY(m);
        if c='B' then begin
           Merge(x1,y1,otr[m,1],otr[m,2],xx,yy);
           InterSect(xx,yy);
           exit;
        end
        else begin
           Split(otr[m,1],otr[m,2],x1,y1,xx,yy);
           if xx=-500001 then exit;
           InterSect(xx,yy);
           c:='B';
           dec(cb);
           InterSect(x1,xx);
           exit;
        end;
     end;
     {3}
     m:=Find3(x1,y1);
     if m<>0 then begin
        DeleteX(m);
        DeleteY(m);
        if c='B' then begin
           Merge(x1,y1,otr[m,1],otr[m,2],xx,yy);
           InterSect(xx,yy);
           exit;
        end
        else begin
           Split(x1,y1,otr[m,1],otr[m,2],xx,yy);
           if xx=-500001 then exit;
           InterSect(xx,yy);
           exit;
        end;
     end;
     {2}  {big which contain our small}
     m:=Find2(x1,y1);
     if m<>0 then begin
        if c='B' then exit;
        DeleteX(m);
        DeleteY(m);
        if c='W' then begin
           dec(cb);
           dec(cursum,otr[m,2]-otr[m,1]);
           if x1<>otr[m,1] then begin
               c:='B';
               InterSect(otr[m,1],x1);
           end
           else dec(cb);
           if otr[m,2]<>y1 then begin
              c:='B';
              InterSect(y1,otr[m,2]);
           end
           else dec(cb);
           exit;
        end;
     end;
     {small which are contained in our big}
     m:=Find4(x1,y1);
     if m<>0 then begin
        dec(cb);
        dec(cursum,otr[m,2]-otr[m,1]);
        DeleteX(m);
        DeleteY(m);
        InterSect(x1,y1);
        exit;
     end;
     {have not intersections}
     if (m=0)and(c='B') then begin
        inc(notr);
        otr[notr,1]:=x1;
        otr[notr,2]:=y1;
        AddX(notr);
        AddY(notr);
        inc(cb);
        inc(cursum,y1-x1);
     end;
end;

procedure Solve;
var i,x1,x2:longint;
begin
     treex[1].l:=0;
     treey[1].r:=0;
     treex[1].r:=0;
     treey[1].l:=0;
     cursum:=0;
     readln(n);
     notr:=0;
     for i:=1 to n do begin
         readln(c,x,l);
         {begin - better }
         Intersect(x,x+l);
         writeln(cb,' ',cursum);
     end;
end;

begin
     assign(input,'painter.in');
     assign(output,'painter.out');
     reset(input);
     rewrite(output);
     Solve;
     close(input);
     close(output);
end.
