{$N+}
program zzzz;

const maxn = 1010;
      inf = 8000;
      alfa = 22.5*pi/180;

type Float = extended;
     TOcta = record
        x,y,r : longint;
        s,s1 : Float;
        num : longint;
     end;
     TArr = array [0..maxn*2] of longint;

var i,j,k,n,m,t,t1,col,sc,ans : longint;
    ii,jj : longint;
    a,tmp : array [1..maxn] of TOcta;
    ev,num,x,ev1,num1,x1 : TArr;
    st : TArr;
    sina,cosa : Float;
    vis : array [1..maxn] of boolean;

procedure DelOctas;
var i,j : longint;
    vis : array [1..maxn] of boolean;
begin
   fillchar(vis,sizeof(vis),false);
   for i := 1 to n do begin
      if vis[i] then continue;
      for j := 1 to n do begin
         if vis[j] then continue;
         if i = j then continue;
         if (tmp[i].x = tmp[j].x) and (tmp[i].y = tmp[j].y)
         and (tmp[i].r = tmp[j].r) then begin
            vis[j] := true;
            inc(tmp[i].num,tmp[j].num);
         end;
      end;
   end;
   m := 0;
   for i := 1 to n do begin
      if not vis[i] then begin
         inc(m);
         a[m] := tmp[i];
      end;
   end;
   n := m;
end;

procedure Swap(var i,j : longint);
var t : longint;
begin
   t := i;
   i := j;
   j := t;
end;

procedure Qsort(l,r : longint; var a,b,c : TArr);
var i,j,x,e,k : longint;
begin
   i := l;
   j := r;
   k := random(r-l)+l;
   x := a[k];
   e := c[k];
   repeat
      while (a[i] < x) or ((a[i] = x) and (c[i] > e)) do inc(i);
      while (a[j] > x) or ((a[j] = x) and (c[j] < e)) do dec(j);
      if i <= j then begin
         Swap(a[i],a[j]);
         Swap(b[i],b[j]);
         Swap(c[i],c[j]);
         inc(i);
         dec(j);
      end;
   until i>j;
   if l < j then Qsort(l,j,a,b,c);
   if i < r then Qsort(i,r,a,b,c);
end;

procedure Initer;
var i,j : longint;
begin
   t := 0;
   for i := 1 to n do begin
      inc(t);
      ev[t] := a[i].num;
      x[t] := a[i].x-trunc(a[i].s);
      num[t] := i;
      inc(t);
      ev[t] := -a[i].num;
      x[t] := a[i].x+trunc(a[i].s);
      num[t] := i;
   end;
   Qsort(1,t,x,num,ev);
   dec(x[1]);
   t := 0;
   for i := 1 to n do begin
      inc(t);
      ev1[t] := a[i].num;
      x1[t] := a[i].y-trunc(a[i].s);
      num1[t] := i;
      inc(t);
      ev1[t] := -a[i].num;
      x1[t] := a[i].y+trunc(a[i].s);
      num1[t] := i;
   end;
   Qsort(1,t,x1,num1,ev1);
   dec(x1[1]);
end;

function Inside(x,y,i : longint) : boolean;
var f : boolean;
begin
   f := true;
   f := f and (x >= a[i].x-a[i].s);
   f := f and (x <= a[i].x+a[i].s);
   f := f and (y >= a[i].y-a[i].s);
   f := f and (y <= a[i].y+a[i].s);
   f := f and (x-y >= a[i].x-a[i].s-(a[i].y+a[i].s1));
   f := f and (x-y <= a[i].x+a[i].s-(a[i].y-a[i].s1));
   f := f and (x+y <= a[i].x+a[i].s+(a[i].y+a[i].s1));
   f := f and (x+y >= a[i].x-a[i].s+(a[i].y-a[i].s1));
   Inside := f;
end;

function Check(x,y : longint) : boolean;
var i,j : longint;
    f : longint;
begin
   f := 0;
   for i := 1 to st[0] do begin
      if Inside(x,y,st[i]) then inc(f,num[st[i]]);
   end;
   Check := f >= k;
end;

begin
   randseed := 39875643;
   sina := sin(alfa);
   cosa := cos(alfa);
   assign(input,'octagons.in'); reset(input);
   assign(output,'octagons.out'); rewrite(output);
   read(n);
   for i := 1 to n do begin
      read(tmp[i].x,tmp[i].y,tmp[i].r);
      tmp[i].r := abs(tmp[i].r);
      tmp[i].num := 1
   end;
   read(k);
   DelOctas;
   for i := 1 to n do begin
      a[i].s := a[i].r*cosa;
      a[i].s1:= a[i].r*sina;
   end;

   Initer;
   ans := 0;
   sc := 0;
   col := 0;
   st[0] := 0;
   fillchar(vis,sizeof(vis),false);
   for i := 1 to t do begin
      for j := 1 to t do begin
         inc(col,ev1[j]);


         if ev[j] > 0 then begin
            if not vis[num[j]] then begin
               inc(st[0]);
               st[st[0]] := num[j];
               vis[num[j]] := true;
            end;
         end else begin
            if vis[num[i]] then dec(st[0]);
            vis[num[j]] := false
         end;


         if col >= k then begin
            for ii := x[i]+1 to x[i+1] do begin
               for jj := x1[i]+1 to x1[i+1] do begin
                  if Check(ii,jj) then inc(ans);
               end;
            end;
         end;
      end;
   end;
   write(ans);
   close(output);
   close(input);
end.
