type
   int = integer;
   integer = longint;

   parambit=byte;

const
   rb=1;
   lb=2;
   all=4;
   np=8;
   max=2097151;

var
   h: packed array [1..max] of packed record l, r: integer;end;
   bl, gr: packed array [1..max] of integer;
   mask: packed array [1..max] of parambit;


procedure init;
begin
   assign(input, 'painter.in'); reset(input);
   assign(output, 'painter.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

var
   n: integer;

procedure readinfo;
begin
   readln(n);
end;

var count: int64;


procedure buildtree(i: integer; l, r: integer);
var sr: integer;
begin
   if r-l<0 then
    begin exit end;
//   if i> count then count:=i;
   sr:=(l+r+1)div 2;
   h[i].r:=r;
   h[i].l:=l;
{
   bl[i]:=0;
   gr[i]:=0;}
   mask[i]:=all;


   if l<r then
   begin
     buildtree(i*2,l,sr-1);
     buildtree(i*2+1,sr,r);
   end;
end;

var
   cur: boolean;
   cleft, cright: integer;

procedure settoproc(i: integer);
var k: integer;
begin
   k:=i*2;
   if k>max then exit;
   mask[k]:=mask[k] or np;
   k:=k+1;
   if k>max then exit;
   mask[k]:=mask[k] or np;
end;

procedure rerec(i: integer; m:parambit);
begin
   if (m and lb<>0)or(m and rb<>0) then
   begin
      mask[i]:=m;
      gr[i]:=1;
      bl[i]:=h[i].r-h[i].l+1;
   end
   else
   begin
      mask[i]:=all;
      gr[i]:=0;
      bl[i]:=0;
   end

end;

procedure rec(i: integer);
{var
   f1: boolean;}
begin
{    if (h[i].l>=3)and(h[i].r<=4) then
     begin
     i:=i+1-1;
     end;
 }

{   if mask[i] and np <> 0 then
   begin
      if (mask[i]and all<>0)then
          if (mask[i] and  rb <> 0) then
          begin
            bl[i]:=h[i].r-h[i].l+1;
            gr[i]:=1;
          end
          else
          begin
            bl[i]:=0;
            gr[i]:=0;
          end
      else
      settoproc(i);
      mask[i]:=mask[i] and not np;
      exit;
   end;
}
   if (h[i].l>=cleft)and(h[i].r<=cright) then
   begin
 //    settoproc(i);
     if cur then
      begin
       mask[i]:=lb or rb or all;
       bl[i]:=h[i].r-h[i].l+1;
       gr[i]:=1;
      end
      else
      begin
       mask[i]:=all;
       bl[i]:=0;
       gr[i]:=0;
      end;
      exit;
   end;


   if (i>1) and (mask[i div 2] and all <> 0)then
   begin
     mask[i]:= mask[i div 2];
   end;

   if (cleft < (h[i].r+h[i].l+1)div 2){ or (mask[i*2]and np<>0)} then
     rec(i*2)
   else
     if mask[i] and all<>0 then
      rerec(i*2,mask[i]);


   if (cright >= (h[i].r+h[i].l+1)div 2){ or (mask[i*2+1]and np<>0) }then
     rec(i*2+1)
   else
     if mask[i] and all<>0 then
      rerec(i*2+1,mask[i]);





   mask[i]:={(mask[i] and not all) or}(mask[i*2] and lb) or (mask[i*2+1] and rb);
{
   if mask[i*2] and np <> 0 then
    rec(i*2);
   if mask[i*2] and np <> 0 then
    rec(i*2);
}
   bl[i]:=bl[i*2] + bl[i*2+1];
   gr[i]:=gr[i*2] + gr[i*2+1];

   if ( mask[i*2] and rb <> 0) and (mask[i*2+1] and lb<>0) then
     dec(gr[i]);
end;


procedure process(black: boolean; left, len: integer);
begin
   cur:=black;
   cleft:=left;
   cright:=left+len-1;
   rec(1);
end;


procedure wri;
begin
   writeln(gr[1],' ',bl[1]);
end;

procedure solve;
var
   i, x, l: integer;
   c: char;
begin
  readinfo;
  count:=0;
  buildtree(1,-500000,500000);
  for i:=1 to n do
  begin
    readln(c, x, l);
    process(upcase(c)='B', x, l);
    wri;
  end;
end;

begin
 init;
 solve;
 done;
end.

