  {$I-,Q-,R-,S-}
const maxd = 1850; maxx = 2000; maxn = 500; inf = maxlongint div 2;
      cs = cos(pi/8); sn = sin(pi/8); eps = 0.000001;
var n,x,y,r,k: longint;
    f: array [-maxx-maxd..maxx+maxd,1..maxn,1..2] of integer;
    num: array [-maxx-maxd..maxx+maxd] of integer;
    ans: longint;

procedure add(w: longint; s1,s2: extended);
var x1,y1: longint;
begin
     if abs(frac(s1)) > eps then x1:=trunc(s1+inf)+1-inf
        else x1:=round(s1);
     if abs(frac(s2)) > eps then y1:=trunc(s2+inf)-inf
        else y1:=round(s2);
     inc(num[w]);
     f[w,num[w],1]:=x1;
     f[w,num[w],2]:=y1;
end;

procedure update;
var ed,a,g: extended;
    d,i: longint;
begin
     ed:=cs*r; a:=sn*r;
     if abs(frac(ed)) > eps then d:=trunc(ed) else d:=round(ed);
     for i:=x-d to x+d do begin
        if x-i-a > eps then begin
           g:=a+ed-(x-i);
           add(i,y-g,y+g);
        end
           else if i-x-a > eps then begin
              g:=a+ed-(i-x);
              add(i,y-g,y+g);
           end
              else begin
                 add(i,y-d,y+d);
              end;
     end;
end;

procedure solve;
var i,j,min,max,cur: longint;
    map: array [-maxx-maxd..maxx+maxd] of integer;
begin
     for i:=-maxx-maxd to maxx+maxd do begin
        if num[i] = 0 then continue;
        fillchar(map,sizeof(map),0);
        min:=maxint; max:=1-maxint;
        for j:=1 to num[i] do begin
           if f[i,j,1] < min then min:=f[i,j,1];
           if f[i,j,2] > max then max:=f[i,j,2];
           inc(map[f[i,j,1]]);
           dec(map[f[i,j,2]+1]);
        end;
        cur:=0;
        for j:=min to max do begin
           cur:=cur+map[j];
           if cur >= k then inc(ans);
        end;
     end;
end;

var i: longint;
begin
     assign(input,'octagons.in');
     reset(input);
     assign(output,'octagons.out');
     rewrite(output);
     read(n);
     fillchar(num,Sizeof(num),0);
     ans:=0;
     for i:=1 to n do begin
        read(x,y,r);
        update;
     end;
     read(k);
     solve;
     write(ans);
     close(input);
     close(output);
end.
