{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='triples';
  fin =problem+'.in';
  fout=problem+'.out';
  maxn=103;
  ct=0.999992;

var
  a:array[1..maxn]of byte;
  x,y,z:array[1..maxn,1..maxn]of integer;
  t,t0,q:extended;
  s,s1,ans:array[1..maxn,1..2]of byte;
  n,i,j,k,l,f,f1,max,maxk:longint;

procedure nextt;
begin
  if t>500 then
    t:=t-4
  else
    t:=t*ct;
end;

procedure nexts(k:longint);
var
  l,i,j:longint;
begin
  s1:=s;
  f1:=f;
  for l:=1 to k do begin
    i:=random(n)+1;
    j:=random(n)+1;
    if i=j then
      continue;
    if random(2)=0 then begin
      f1:=f1-x[i,s1[i,1]]+x[i,s1[j,1]]-y[s1[i,2],s1[i,1]]+y[s1[i,2],s1[j,1]];
      f1:=f1-x[j,s1[j,1]]+x[j,s1[i,1]]-y[s1[j,2],s1[j,1]]+y[s1[j,2],s1[i,1]];
      s1[i,1]:=s1[i,1] xor s1[j,1];
      s1[j,1]:=s1[i,1] xor s1[j,1];
      s1[i,1]:=s1[i,1] xor s1[j,1];
    end
    else begin
      f1:=f1-z[s1[i,2],i]+z[s1[j,2],i]-y[s1[i,2],s1[i,1]]+y[s1[j,2],s1[i,1]];
      f1:=f1-z[s1[j,2],j]+z[s1[i,2],j]-y[s1[j,2],s1[j,1]]+y[s1[i,2],s1[j,1]];
      s1[i,2]:=s1[i,2] xor s1[j,2];
      s1[j,2]:=s1[i,2] xor s1[j,2];
      s1[i,2]:=s1[i,2] xor s1[j,2];
    end;
  end;
end;

function norm(t:extended):extended;
var
  i:longint;
  t1:extended;
begin
  t1:=0;
  for i:=1 to 12 do
    t1:=t1+random;
  t1:=t1-6;
  norm:=t1*sqrt(t);
end;

procedure gens;
var
  i,k:longint;
begin
  fillchar(s,sizeof(s),0);
  fillchar(a,sizeof(a),0);
  for i:=1 to n do begin
    repeat
      k:=random(n)+1;
    until a[k]=0;
    a[k]:=1;
    s[i,1]:=k;
  end;
  fillchar(a,sizeof(a),0);
  for i:=1 to n do begin
    repeat
      k:=random(n)+1;
    until a[k]=0;
    a[k]:=1;
    s[i,2]:=k;
  end;
  f:=0;
  for i:=1 to n do
    f:=f+x[i,s[i,1]]+y[s[i,2],s[i,1]]+z[s[i,2],i];
end;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);
    for i:=1 to n do
      for j:=1 to n do
        read(x[i,j]);
    for i:=1 to n do
      for j:=1 to n do
        read(y[i,j]);
    for i:=1 to n do
      for j:=1 to n do
        read(z[i,j]);

  close(input);
end;

procedure solve;
begin
  randseed:=n+x[1,1]+y[n,1]+z[1,n];
  t0:=50000;
  t:=t0;
  gens;
  k:=0;
  max:=-maxlongint;
  maxk:=800000;
  repeat
    if f>max then begin
      max:=f;
      ans:=s;
    end;
    q:=norm(t);
    if q<1 then
      q:=2.5;
    if q>n then
      q:=n;
    nexts(trunc(q));
    q:=(f1-f)/t;
    q:=q*5;
    if q<-100 then
      q:=-100;
    if q>0.5 then
      q:=0.5;
    if random<exp(q) then begin
      s:=s1;
      f:=f1;
    end;
    nextt;
    inc(k);
    if t<0.9 then begin
      t:=t0;
      gens;
    end;
  until k>500000;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writeln((max/(n)):0:2);
    for k:=1 to n do
      writeln(k,' ',ans[k,1],' ',ans[k,2]);

  close(output);
end;
begin
  init;
  solve;
  done;
end.
