{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='queen';
  fin =problem+'.in';
  fout=problem+'.out';
  dx:array[0..7]of shortint=(1,0,-1,0,1,1,-1,-1);
  dy:array[0..7]of shortint=(0,1,0,-1,1,-1,-1,1);

var
  a,kk,qq:array[1..2,0..50,1..2,0..50]of byte;
  b:array[1..2,0..50,1..2,0..50]of integer;
  c:array[0..300,0..2,0..2]of byte;
  i,j,k,l,n,m,total,x1,y1,x2,y2,q:longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n,m);
    for k:=1 to m do
      read(c[k,1,1],c[k,1,2],c[k,2,1],c[k,2,2]);

  close(input);
end;

function dfs(x1,y1,x2,y2,move:longint):byte;
var
  i,j,q,w:longint;
begin
  if a[x1,y1,x2,y2]<>0 then begin
    dfs:=a[x1,y1,x2,y2];
    exit;
  end;
  a[x1,y1,x2,y2]:=3;
  if move=1 then begin
    dfs:=2;
    w:=2;
    for i:=1 to 2 do
      for j:=1 to n do
        if (kk[x1,y1,i,j]=1)and(qq[x2,y2,i,j]=0) then begin
          q:=dfs(i,j,x2,y2,2);
          if (q=1)and(w=2) then
            b[x1,y1,x2,y2]:=maxint-10;
          if q=1 then begin
            dfs:=1;
            if b[x1,y1,x2,y2]>b[i,j,x2,y2]+1 then
              b[x1,y1,x2,y2]:=b[i,j,x2,y2]+1;
            w:=1;
          end;
          if (q=2)and(w=2) then
            if b[x1,y1,x2,y2]<b[i,j,x2,y2]+1 then
              b[x1,y1,x2,y2]:=b[i,j,x2,y2]+1;
        end;
  end;
  if move=2 then begin
    dfs:=1;
    w:=1;
    for i:=1 to 2 do
      for j:=1 to n do
        if (qq[x2,y2,i,j]=1)and(kk[x1,y1,i,j]=0) then begin
          q:=dfs(x1,y1,i,j,1);
          if (q=2)and(w=1) then
            b[x1,y1,x2,y2]:=maxint-10;
          if q=2 then begin
            dfs:=2;
            if b[x1,y1,x2,y2]>b[x1,y1,i,j]+1 then
              b[x1,y1,x2,y2]:=b[x1,y1,i,j]+1;
            w:=2;
          end;
          if (q=1)and(w=1) then
            if b[x1,y1,x2,y2]<b[x1,y1,i,j]+1 then
              b[x1,y1,x2,y2]:=b[x1,y1,i,j]+1;
        end;
  end;
  a[x1,y1,x2,y2]:=w;
end;

procedure solve;
begin
  for x1:=1 to 2 do
    for y1:=1 to n do begin
      for k:=0 to 7 do begin
        if x1+dx[k]<=0 then
          continue;
        if y1+dy[k]<=0 then
          continue;
        if x1+dx[k]>=3 then
          continue;
        if y1+dy[k]>=n+1 then
          continue;

        kk[x1,y1,x1+dx[k],y1+dy[k]]:=1;
        for q:=1 to m do begin
          if (c[q,1,1]=x1)and(c[q,1,2]=y1)and(c[q,2,1]=x1)and(c[q,2,1]=y1+dy[k]) then
            kk[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,1,1]=x1)and(c[q,1,2]=y1)and(c[q,2,1]=x1+dx[k])and(c[q,2,1]=y1) then
            kk[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,2,1]=x1)and(c[q,2,2]=y1)and(c[q,1,1]=x1)and(c[q,1,1]=y1+dy[k]) then
            kk[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,2,1]=x1)and(c[q,2,2]=y1)and(c[q,1,1]=x1+dx[k])and(c[q,1,1]=y1) then
            kk[x1,y1,x1+dx[k],y1+dy[k]]:=0;
        end;
      end;
      for k:=0 to 7 do begin
        if x1+dx[k]<=0 then
          continue;
        if y1+dy[k]<=0 then
          continue;
        if x1+dx[k]>=3 then
          continue;
        if y1+dy[k]>=n+1 then
          continue;
        qq[x1,y1,x1+dx[k],y1+dy[k]]:=1;
        for q:=1 to m do begin
          if (c[q,1,1]=x1)and(c[q,1,2]=y1)and(c[q,2,1]=x1)and(c[q,2,1]=y1+dy[k]) then
            qq[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,1,1]=x1)and(c[q,1,2]=y1)and(c[q,2,1]=x1+dx[k])and(c[q,2,1]=y1) then
            qq[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,2,1]=x1)and(c[q,2,2]=y1)and(c[q,1,1]=x1)and(c[q,1,1]=y1+dy[k]) then
            qq[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,2,1]=x1)and(c[q,2,2]=y1)and(c[q,1,1]=x1+dx[k])and(c[q,1,1]=y1) then
            qq[x1,y1,x1+dx[k],y1+dy[k]]:=0;
        end;
      end;
      for k:=0 to 3 do begin
        qq[x1,y1,x1+dx[k],y1+dy[k]]:=1;
        for q:=1 to m do begin
          if (c[q,1,1]=x1)and(c[q,1,2]=y1)and(c[q,2,1]=x1)and(c[q,2,1]=y1+dy[k]) then
            qq[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,1,1]=x1)and(c[q,1,2]=y1)and(c[q,2,1]=x1+dx[k])and(c[q,2,1]=y1) then
            qq[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,2,1]=x1)and(c[q,2,2]=y1)and(c[q,1,1]=x1)and(c[q,1,1]=y1+dy[k]) then
            qq[x1,y1,x1+dx[k],y1+dy[k]]:=0;
          if (c[q,2,1]=x1)and(c[q,2,2]=y1)and(c[q,1,1]=x1+dx[k])and(c[q,1,1]=y1) then
            qq[x1,y1,x1+dx[k],y1+dy[k]]:=0;
        end;
      end;
    end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    if a[1,1,2,n]=1 then begin
      writeln('king wins');
      write(b[1,1,2,n]);
    end
    else
      if (b[1,1,2,n]=0)or(b[1,1,2,n]>30000)then begin
        write('draw');
      end
      else begin
      writeln('queen wins');
      write(b[1,1,2,n]);
    end;

  close(output);
end;
begin
  init;
  solve;
  done;
end.