{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 16384,0,655360}
const maxn=100000;
var qs,n,i,a,b,w,c,k,t:longint;
    en:array[1..2*maxn]of record
                          s,t,w:longint;
                        end;
    num,nm,best,prev:array[1..maxn]of longint;
    right,left:array[1..maxn]of longint;
    queue:array[1..2*maxn]of longint;
    cc:char;
    com:string;

procedure push(a:longint);
begin
  inc(qs);
  queue[qs]:=a;
end;

procedure pop(var a:longint);
begin
  a:=queue[1];
  move(queue[2],queue[1],sizeof(queue[1])*(qs));
  dec(qs);
end;

function empty:boolean;
begin
  empty:=false;
  if qs=0 then
    empty:=true;
end;

procedure qsort(l,r:longint);
var i,j,m,t:longint;
begin
  if l<r then
  begin
    i:=l;
    j:=r;
    m:=en[i].s;
    while i<j do
    begin
      while en[i].s<m do
        inc(i);
      while en[j].s>m do
        dec(j);
      if i<=j then
      begin
        t:=en[i].s;
        en[i].s:=en[j].s;
        en[j].s:=t;
        t:=en[i].t;
        en[i].t:=en[j].t;
        en[j].t:=t;
        t:=en[i].w;
        en[i].w:=en[j].w;
        en[j].w:=t;
        t:=num[i];
        num[i]:=num[j];
        num[j]:=t;
        t:=nm[i];
        nm[i]:=nm[j];
        nm[j]:=t;
        inc(i);
        dec(j);
      end;
    end;
    qsort(l,j);
    qsort(i,r);
  end;
end;

begin
  assign(input,'thruput.in');
  reset(input);
  assign(output,'thruput.out');
  rewrite(output);
  read(n);
  for i:=1 to n-1 do
  begin
    read(a,b,c);
    num[i]:=i;
    en[i].s:=a;
    en[i].t:=b;
    en[i].w:=c;
    nm[i]:=i+n-1;
    en[i+n-1].s:=b;
    en[i+n-1].t:=a;
    en[i+n-1].w:=c;
  end;
  qsort(1,n-1);
  for i:=1 to n*2-1 do
    if en[i].s<>en[i-1].s then
    begin
      right[en[i-1].s]:=i-1;
      left[en[i].s]:=i;
    end;
  readln;
  repeat
    read(cc);
    com:='';
    while (cc<>' ')and(not eof) do
    begin
      com:=com+cc;
      read(cc);
    end;
    if eof then
      com:=com+cc;
    if com<>'DONE' then
      readln(k,t);
    if com='CHANGE' then
    begin
      en[num[k]].w:=t;
      en[nm[k]].w:=t;
    end;
    if com='QUERY' then
    begin
      fillchar(best,sizeof(best),0);
      fillchar(prev,sizeof(prev),0);
      push(k);
      repeat
        pop(a);
        for i:=left[a] to right[a] do
        begin
          b:=en[i].t;
          w:=en[i].w;
          if (prev[a]<>b)and((best[a]>best[b])or(w>best[b])) then
          begin
            if best[a]<w then
              best[b]:=w
                         else
              best[b]:=best[a];
            push(b);
            prev[b]:=a;
          end;
        end;
      until empty;
      writeln(best[t]);
    end;
  until com='DONE';
  close(input);
  close(output);
end.