{$M 200000, 12000000}
program Temp;
const infile = 'queen.in';
      outfile = 'queen.out';
      MAXN = 50;
      inf = MAXINT;
var nm, ww, inr : array[1..2, 1..MAXN, 1..2, 1..MAXN, 1..2] of integer;
    sd : array[1..2, 1..MAXN, 1..2, 1..MAXN] of boolean;
    pk, pq : array[1..2, 1..MAXN, 1..2, 1..MAXN] of boolean;
    N, M : integer;

procedure ReadData;
var x1, y1, x2, y2, i : integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N, M);
  fillchar(sd, sizeof(sd), false);
  for i:=1 to M do
  begin
    read(x1, y1, x2, y2);
    sd[x1, y1, x2, y2]:=true;
    sd[x2, y2, x1, y1]:=true;
  end;
end;

function psq(x1, y1, x2, y2 : integer) : boolean;
var i : integer;
    b : boolean;

procedure swap(var a, b : integer);
var t : integer;
begin
  t:=a; a:=b; b:=t;
end;

begin
  if (x1=x2)and(y1=y2) then begin psq:=false; exit; end;
  if y1>y2 then begin swap(x1, x2); swap(y1, y2); end; b:=true;
  if (y1=y2)and(x1<>x2) then begin
    b:=not sd[x1, y1, x2, y2];
  end else if (y1<>y2)and(x1=x2) then begin
    for i:=y1 to y2-1 do b:=b and (not sd[x1, i, x2, i+1]);
  end else b:=(psq(x1, y1, x2, y1))and(psq(x1, y2, x2, y2))and(psq(x1, y1, x1, y2))and(psq(x2, y1, x2, y2));;
  psq:=b;
end;

function psk(x1, y1, x2, y2 : integer) : boolean;
var i : integer;
    b : boolean;

procedure swap(var a, b : integer);
var t : integer;
begin
  t:=a; a:=b; b:=t;
end;

begin
  if (x1=x2)and(y1=y2) then begin psk:=false; exit; end;
  if y1>y2 then begin swap(x1, x2); swap(y1, y2); end; b:=true;
  if (y1=y2)and(x1<>x2) then begin
    b:=not sd[x1, y1, x2, y2];
  end else if (y1<>y2)and(x1=x2) then begin
    for i:=y1 to y2-1 do b:=b and (not sd[x1, i, x2, i+1]);
  end else b:=(psk(x1, y1, x2, y1))and(psk(x1, y2, x2, y2))and(psk(x1, y1, x1, y2))and(psk(x2, y1, x2, y2));
  psk:=b;
end;

function attack(xq, yq, xk, yk : integer) : boolean;
begin
  attack:=pq[xq, yq, xk, yk];
end;

function dpmoveq(x1, y1, x2, y2, xk, yk : integer) : boolean;
var cm : boolean;
begin
  if (x1=x2)and(x2=y2) then begin dpmoveq:=false; exit; end;
  cm:=(x1=x2)or(y1=y2)or(x1+y1=x2+y2)or(x1-y1=x2-y2);
  if not cm then begin dpmoveq:=false; exit; end;
  dpmoveq:=pq[x1, y1, x2, y2] and (not attack(x2, y2, xk, yk));
end;

function dpmovek(x1, y1, x2, y2, xq, yq : integer) : boolean;
var cm : boolean;
begin
  if (x1=x2)and(x2=y2) then begin dpmovek:=false; exit; end;
  cm:=(abs(x1-x2)<2)and(abs(y1-y2)<2);
  if not cm then begin dpmovek:=false; exit; end;
  dpmovek:=pk[x1, y1, x2, y2] and (not attack(xq, yq, x2, y2));
end;

procedure Rec(x1, y1, x2, y2, m : integer);
var cm, cw : boolean;
    i, j, min, max : integer;
begin
  if inr[x1, y1, x2, y2, m]=2 then exit;
  inr[x1, y1, x2, y2, m]:=1;
  nm[x1, y1, x2, y2, m]:=inf; cw:=false;
  min:=inf; max:=-inf; cm:=false;

  if m=1 then begin
    for i:=1 to 2 do
      for j:=1 to N do
      if dpmovek(x1, y1, i, j, x2, y2) then begin
        if inr[i, j, x2, y2, 2-m+1]=1 then continue;
        cm:=true; Rec(i, j, x2, y2, 2-m+1);
        if ww[i, j, x2, y2, 2-m+1]=1 then
        begin cw:=true; if nm[i, j, x2, y2, 2-m+1]<min then min:=nm[i, j, x2, y2, 2-m+1]; end;
        if ww[i, j, x2, y2, 2-m+1]=2 then
          if nm[i, j, x2, y2, 2-m+1]>max then max:=nm[i, j, x2, y2, 2-m+1];
      end;

    if (cw)and(cm) then begin nm[x1, y1, x2, y2, m]:=min+1; ww[x1, y1, x2, y2, m]:=1; end;
    if (not cw)and(cm) then begin nm[x1, y1, x2, y2, m]:=max+1; ww[x1, y1, x2, y2, m]:=2; end;
    if not cm then begin nm[x1, y1, x2, y2, m]:=0; ww[x1, y1, x2, y2, m]:=2; end;
  end else begin
    for i:=1 to 2 do
      for j:=1 to N do
      if dpmoveq(x2, y2, i, j, x1, y1) then begin
        if inr[x1, y1, i, j, 2-m+1]=1 then continue;
        cm:=true; Rec(x1, y1, i, j, 2-m+1);
        if ww[x1, y1, i, j, 2-m+1]=2 then
        begin cw:=true; if nm[x1, y1, i, j, 2-m+1]<min then min:=nm[x1, y1, i, j, 2-m+1]; end;
        if ww[x1, y1, i, j, 2-m+1]=1 then
          if nm[x1, y1, i, j, 2-m+1]>max then max:=nm[x1, y1, i, j, 2-m+1];
      end;

    if (cw)and(cm) then begin nm[x1, y1, x2, y2, m]:=min+1; ww[x1, y1, x2, y2, m]:=2; end;
    if (not cw)and(cm) then begin nm[x1, y1, x2, y2, m]:=max+1; ww[x1, y1, x2, y2, m]:=1; end;
    if not cm then begin nm[x1, y1, x2, y2, m]:=0; ww[x1, y1, x2, y2, m]:=1; end;
  end;
  inr[x1, y1, x2, y2, m]:=2;
end;

procedure Solve;
var i, j, k, l : integer;
begin
  fillchar(inr, sizeof(inr), 0);
  for i:=1 to 2 do
    for j:=1 to N do
      for k:=1 to 2 do
        for l:=1 to N do
        begin
          pk[i, j, k, l]:=psk(i, j, k, l);
          pq[i, j, k, l]:=psq(i, j, k, l);
          nm[i, j, k, l, 1]:=inf;
          nm[i, j, k, l, 2]:=inf;
        end;
  Rec(1, 1, 2, N, 1);
  if nm[1, 1, 2, N, 1]=inf then write('draw') else
  begin
    if ww[1, 1, 2, N, 1]=1 then writeln('king wins') else writeln('queen wins');
    write(nm[1, 1, 2, N, 1]);
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
