{$I-,Q-,R-,S-}

const
  coutfile = 'queen.out';
  cinfile = 'queen.in';

  nmax = 61;
  inf = maxlongint shr 1;

type
  int = longint;
  real = extended;

  list = ^tlist;
  tlist = record
            x1 : int;
            y1 : byte;
            x2 : int;
            y2, h : byte;
            next : list;
          end;

var
  n, k, m : int;
  ans : int;

  t : array [0..nmax,0..3,0..3] of boolean;

  mx, mn : array [1..nmax,1..2,1..nmax,1..2,1..2] of int;
  l, s : array [1..nmax,1..2,1..nmax,1..2,1..2] of int;

  g, gt : array [1..nmax,1..2,1..nmax,1..2,1..2] of list;

  hd, ta : int;
  q : array [1..nmax*nmax*8,1..5] of int;

procedure outdata;
var
  i, j : int;
begin
  if l[1,1,n,2,1] = -1 then writeln('draw') else
    if l[1,1,n,2,1] = 1 then
    begin
      writeln('king wins');
      writeln(mn[1,1,n,2,1]-2);
    end else
    begin
      writeln('queen wins');
      writeln(mx[1,1,n,2,1]-2);
    end;
end;

procedure addq(x1,y1,x2,y2,h : int);
begin
  if l[x1,y1,x2,y2,h] <> -1 then exit;
  inc(ta); q[ta,1]:= x1; q[ta,2]:= y1;
  q[ta,3]:= x2; q[ta,4]:= y2; q[ta,5]:= h;
  l[x1,y1,x2,y2,h]:= 0;
end;

procedure decreaseall(x1,y1,x2,y2,no : int);
var q : list;
begin
  if l[x1,y1,x2,y2,no] <> -1 then exit;
  l[x1,y1,x2,y2,no]:= 1;
  q:= gt[x1,y1,x2,y2,no];
  while q <> nil do
  begin
    if l[q^.x1,q^.y1,q^.x2,q^.y2,q^.h] = -1 then
    begin
      dec(s[q^.x1,q^.y1,q^.x2,q^.y2,q^.h]);
      if mx[q^.x1,q^.y1,q^.x2,q^.y2,q^.h] < mn[x1,y1,x2,y2,no]+1 then
        mx[q^.x1,q^.y1,q^.x2,q^.y2,q^.h]:= mn[x1,y1,x2,y2,no]+1;
      if s[q^.x1,q^.y1,q^.x2,q^.y2,q^.h] = 0 then
        addq(q^.x1,q^.y1,q^.x2,q^.y2,q^.h);
    end;
    q:= q^.next;
  end;
end;

procedure first;
var
  x1, y1, x2, y2, h : int;
begin
  for x1:= 1 to n do
    for y1:= 1 to 2 do
      for x2:= 1 to n do
        for y2:= 1 to 2 do
          for h:= 1 to 2 do
          begin
            mx[x1,y1,x2,y2,h]:= -inf;
            mn[x1,y1,x2,y2,h]:= inf;
          end;
  hd:= 1; ta:= 0;
  for x1:= 1 to n do
    for y1:= 1 to 2 do
      for x2:= 1 to n do
        for y2:= 1 to 2 do
          if (x1 = x2) and (y1 = y2) then
          begin
            addq(x1,y1,x2,y2,1);
            mx[x1,y1,x2,y2,1]:= 0;
            addq(x1,y1,x2,y2,2);
            mx[x1,y1,x2,y2,2]:= 0;
          end;
end;

procedure push(var x : list;x1,y1,x2,y2,h : int);
var
  q : list;
begin
  new(q);
  q^.x1:= x1; q^.x2:= x2; q^.y1:= y1; q^.y2:= y2; q^.h:= h;
  q^.next:= x;
  x:= q;
end;

procedure add(x1,y1,x2,y2,h : int);
var
  cx1, cy1 : int;
begin
  if h = 1 then
  begin
    if not t[x1,y1,0] then push(g[x1,y1,x2,y2,h],x1,y1-1,x2,y2,2);
    if not t[x1,y1,1] then push(g[x1,y1,x2,y2,h],x1+1,y1,x2,y2,2);
    if not t[x1,y1,2] then push(g[x1,y1,x2,y2,h],x1,y1+1,x2,y2,2);
    if not t[x1,y1,3] then push(g[x1,y1,x2,y2,h],x1-1,y1,x2,y2,2);
    if not t[x1,y1,0] and not t[x1,y1,1] and not t[x1+1,y1,0]
      and not t[x1,y1-1,1] then push(g[x1,y1,x2,y2,h],x1+1,y1-1,x2,y2,2);
    if not t[x1,y1,2] and not t[x1,y1,1] and not t[x1+1,y1,2]
      and not t[x1,y1+1,1] then push(g[x1,y1,x2,y2,h],x1+1,y1+1,x2,y2,2);
    if not t[x1,y1,2] and not t[x1,y1,3] and not t[x1-1,y1,2]
      and not t[x1,y1+1,3] then push(g[x1,y1,x2,y2,h],x1-1,y1+1,x2,y2,2);
    if not t[x1,y1,0] and not t[x1,y1,3] and not t[x1-1,y1,0]
      and not t[x1,y1-1,3] then push(g[x1,y1,x2,y2,h],x1-1,y1-1,x2,y2,2);
    exit;
  end;
  if not t[x2,y2,0] and not t[x2,y2,1] and not t[x2+1,y2,0]
    and not t[x2,y2-1,1] then push(g[x1,y1,x1,y2,h],x1,y1,x2+1,y2-1,1);
  if not t[x2,y2,2] and not t[x2,y2,1] and not t[x2+1,y2,2]
    and not t[x2,y2+1,1] then push(g[x1,y1,x2,y2,h],x1,y1,x2+1,y2+1,1);
  if not t[x2,y2,2] and not t[x2,y2,3] and not t[x2-1,y2,2]
    and not t[x2,y2+1,3] then push(g[x1,y1,x2,y2,h],x1,y1,x2-1,y2+1,1);
  if not t[x2,y2,0] and not t[x2,y2,3] and not t[x2-1,y2,0]
    and not t[x2,y2-1,3] then push(g[x1,y1,x2,y2,h],x1,y1,x2-1,y2-1,1);
  if not t[x2,y2,0] then push(g[x1,y1,x2,y2,h],x1,y1,x2,y2-1,1);
  if not t[x2,y2,2] then push(g[x1,y1,x2,y2,h],x1,y1,x2,y2+1,1);
  cx1:= x2; cy1:= y2;
  while not t[cx1,cy1,1] do
  begin
    push(g[x1,y1,x2,y2,h],x1,y1,cx1+1,cy1,1);
    inc(cx1);
  end;
  cx1:= x2; cy1:= y2;
  while not t[cx1,cy1,3] do
  begin
    push(g[x1,y1,x2,y2,h],x1,y1,cx1-1,cy1,1);
    dec(cx1);
  end;
end;

procedure makegraph;
var
  x1, y1, x2, y2, h : int;
  q : list;
begin
  if t[1,1,1] and t[1,1,2] then
  begin
    writeln('queen wins');
    writeln(0);
    close(output);
    halt(0);
  end;
  if t[n,2,0] and t[n,2,3] then
  begin
    writeln('king wins');
    writeln(1);
    close(output);
    halt(0);
  end;
  fillchar(g,sizeof(g),0);
  for x1:= 1 to n do
    for y1:= 1 to 2 do
      for x2:= 1 to n do
        for y2:= 1 to 2 do
          for h:= 1 to 2 do
            add(x1,y1,x2,y2,h);
  fillchar(gt,sizeof(gt),0);
  for x1:= 1 to n do
    for y1:= 1 to 2 do
      for x2:= 1 to n do
        for y2:= 1 to 2 do
          for h:= 1 to 2 do
          begin
            s[x1,y1,x2,y2,h]:= 0;
            q:= g[x1,y1,x2,y2,h];
            while q <> nil do
            begin
              inc(s[x1,y1,x2,y2,h]);
              push(gt[q^.x1,q^.y1,q^.x2,q^.y2,q^.h],x1,y1,x2,y2,h);
              q:= q^.next;
            end;
          end;
end;

procedure solve;
var
  i, j : int;
  x1, x2, y1, y2, h : int;
  w : list;
begin
  fillchar(l,sizeof(l),255);
  makegraph;
  first;
  while (hd <= ta) do
  begin
    x1:= q[hd,1]; y1:= q[hd,2]; x2:= q[hd,3]; y2:= q[hd,4]; h:= q[hd,5];
    inc(hd);
    w:= gt[x1,y1,x2,y2,h];
    while w <> nil do
    begin
      if mn[w^.x1,w^.y1,w^.x2,w^.y2,w^.h] > mx[x1,y1,x2,y2,h]+1 then
        mn[w^.x1,w^.y1,w^.x2,w^.y2,w^.h]:= mx[x1,y1,x2,y2,h]+1;
      decreaseall(w^.x1,w^.y1,w^.x2,w^.y2,w^.h);
      w:= w^.next;
    end;
  end;
end;

procedure init;
var
  i, j : int;
begin
  fillchar(t,sizeof(t),0);
  for i:= 1 to n do t[i,1,0]:= true;
  for i:= 1 to n do t[i,2,2]:= true;
  for i:= 1 to 2 do t[1,i,3]:= true;
  for i:= 1 to 2 do t[n,i,1]:= true;
  for i:= 0 to n+1 do
  begin
    for j:= 0 to 3 do t[i,0,j]:= true;
    for j:= 0 to 3 do t[i,3,j]:= true;
  end;
  for i:= 1 to 2 do
  begin
    for j:= 0 to 3 do t[0,i,j]:= true;
    for j:= 0 to 3 do t[n+1,i,j]:= true;
  end;
end;

procedure readdata;
var
  i, j : int;
  x1,y1,x2,y2 : int;
begin
  read(n,m);
  init;
  for i:= 1 to m do
  begin
    read(y1,x1,y2,x2);
    if x1-x2 = 0 then
    begin
      if y1 - y2 < 0 then
      begin
        t[x1,y1,2]:= true;
        t[x2,y2,0]:= true;
      end else
      begin
        t[x1,y1,0]:= true;
        t[x2,y2,2]:= true;
      end;
    end else
    begin
      if x1 - x2 < 0 then
      begin
        t[x1,y1,1]:= true;
        t[x2,y2,3]:= true;
      end else
      begin
        t[x1,y1,3]:= true;
        t[x2,y2,1]:= true;
      end;
    end;
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
