{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 2000000,0,655360}

Const MaxN=100100;

Const INPUTFILE='thruput.in';
      OUTPUTFILE='thruput.out';

Type Real=Double;

var a:Array[1..MaxN+2,1..3] of Longint;
    b:Array[1..MaxN+1] of Longint;
    Nums,ANums:Array[1..MaxN] of Longint;

    N,M,oM:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Read(N);
M:=N-1;
for i:=1 to M do
begin
  Read(a[i,1],a[i,2],a[i,3]);
  a[i+M,1]:=a[i,2];
  a[i+M,2]:=a[i,1];
  a[i+M,3]:=a[i,3];
end;
oM:=M;
M:=2*M;
Readln;
end;

Function Cmp(i,j:Longint):Shortint;
var k:Byte;
begin
Cmp:=0;
for k:=1 to 3 do
  if a[i,k]>a[j,k] then
  begin
    Cmp:=1;
    Exit;
  end
  else if a[i,k]<a[j,k] then
  begin
    Cmp:=-1;
    Exit;
  end;
end;

Procedure QSort(L,R:Longint);
var i,j,t:Longint;
begin
i:=L;
j:=R;
a[M+1]:=a[(i+j) div 2];
Repeat
  While Cmp(i,M+1)=-1 Do Inc(i);
  While Cmp(j,M+1)=1 Do Dec(j);
  if i<=j then
  begin
    a[M+2]:=a[i];
    a[i]:=a[j];
    a[j]:=a[M+2];
    t:=Nums[i];
    Nums[i]:=Nums[j];
    Nums[j]:=t;

    Inc(i);
    Dec(j);
  end;
Until i>j;
if L<j then QSort(L,j);
if i<R then QSort(i,R);
end;

var Were:Array[1..MaxN] of Boolean;
    x,Max:Longint;
    Found:Boolean;

Procedure Dfs(i:Longint);
var j:Longint;
begin
Were[i]:=True;
if i=x then
begin
  Found:=True;
  Exit;
end;
for j:=b[i] to b[i+1]-1 do
  if Were[a[j,2]]=False then
  begin
    Dfs(a[j,2]);
    if Found then
    begin
      if Max<a[j,3] then Max:=a[j,3];
      Exit;
    end;
  end;
end;

Procedure Solve;
var g,h:Longint;
    ch:Char;
begin
for i:=1 to M do
  Nums[i]:=i;
QSort(1,M);
a[M+1,1]:=0;
b[1]:=1;
j:=1;
for i:=1 to N do
begin
  Inc(b[i+1],b[i]);
  While a[j,1]=i Do
  begin
    Inc(b[i+1]);
    Inc(j);
  end;
end;
for j:=1 to M do
  ANums[Nums[j]]:=j;

Repeat
  Read(ch);
  Case ch of
  'Q':
  begin
    for i:=1 to 4 do Read(ch);
    Read(j,x);
    FillChar(Were,SizeOf(Were),False);
    Max:=0;
    Found:=False;
    Dfs(j);
    Writeln(Max);
  end;
  'C':
  begin
    for i:=1 to 5 do Read(ch);
    Read(j,g);
    a[ANums[j],3]:=g;
    a[ANums[j+oM],3]:=g;
  end;
  end;
Until ch='D';
Close(Output);
Close(Input);
end;

begin
FRead;
Solve;
end.