{$I-,Q-,R-,S-}
uses math;
const inf='thruput.in';
      ouf='thruput.out';
var n,len,nused,root:longint;
    edge:array [1..100000] of record
      s,f,w,n:longint;
    end;
    first,parent,depth,start,go:array [1..100000] of longint;
    target:array [1..200000] of longint;
    tree:array [1..400000] of record
      x,l,r:longint;
    end;
procedure addedge(i,j,k,l:longint);
begin
  edge[i].s:=j;
  edge[i].f:=k;
  edge[i].w:=l;
  edge[i].n:=first[j];
  first[j]:=i;
end;
procedure dfs(x,p,h:longint);
var i:longint;
begin
  parent[x]:=p;
  depth[x]:=h;
  inc(len);
  target[len]:=x;
  i:=first[x];
  while i<>0 do
  begin
    if edge[i].f<>p then
    begin
      dfs(edge[i].f,x,h+1);
      go[edge[i].f]:=i;
      inc(len);
      target[len]:=x;
    end;
    i:=edge[i].n;
  end;
end;
function getmin(x,y:longint):longint;
begin
  getmin:=x;
  if depth[target[y]]<depth[target[x]] then
    getmin:=y;
end;
function buildlca(l,r:longint):longint;
var m,now:longint;
begin
  if l=r then
  begin
    inc(nused);
    buildlca:=nused;
    tree[nused].x:=l;
    tree[nused].l:=0;
    tree[nused].r:=0;
    exit;
  end;
  m:=(l+r) shr 1;
  inc(nused);
  buildlca:=nused;
  now:=nused;
  tree[now].l:=buildlca(l,m);
  tree[now].r:=buildlca(m+1,r);
  tree[now].x:=getmin(tree[tree[now].l].x,tree[tree[now].r].x);
end;
function rmq(t,l,r,i,j:longint):longint;
var m:longint;
begin
  if (l=i) and (r=j) then
  begin
    rmq:=tree[t].x;
    exit;
  end;
  m:=(l+r) shr 1;
  if j<=m then
  begin
    rmq:=rmq(tree[t].l,l,m,i,j);
    exit;
  end;
  if i>m then
  begin
    rmq:=rmq(tree[t].r,m+1,r,i,j);
    exit;
  end;
  rmq:=getmin(rmq(tree[t].l,l,m,i,m),rmq(tree[t].r,m+1,r,m+1,j));
end;
function lca(i,j:longint):longint;
var ii,jj,t:longint;
begin
  ii:=start[i];
  jj:=start[j];
  if ii>jj then
  begin
    t:=ii;
    ii:=jj;
    jj:=t;
  end;
  lca:=target[rmq(root,1,len,ii,jj)];
end;
function ask(x,y:longint):longint;
var cur,ans:longint;
begin
  cur:=y;
  ans:=-maxlongint;
  while cur<>x do
  begin
    ans:=max(ans,edge[go[cur]].w);
    cur:=parent[cur];
  end;
  ask:=ans;
end;
function query(x,y:longint):longint;
var l:longint;
begin
  l:=lca(x,y);
  query:=max(ask(l,x),ask(l,y));
end;
procedure init;
var i,j,k,l,x,y:longint;
    cmd,ch:char;
begin
  assign(input,inf);
  reset(input);
  assign(output,ouf);
  rewrite(output);
  readln(n);
  for i:=1 to n-1 do
  begin
    readln(j,k,l);
    addedge(2*i-1,j,k,l);
    addedge(2*i-0,k,j,l);
  end;
  len:=0;
  dfs(1,0,1);
  for i:=len downto 1 do
    start[target[i]]:=i;
  nused:=0;
  root:=buildlca(1,len);
  repeat
    read(cmd);
    read(ch);
    while ch in ['A'..'Z'] do
      read(ch);
    case cmd of
      'Q':begin readln(x,y); writeln(query(x,y)); end;
      'C':begin readln(x,y); edge[x].w:=y; end;
      'D':break;
    end;
  until false;
  close(input);
  close(output);
end;
begin
  init;
end.
