{$I-,Q-,R-,S-}
uses math;
const inf='queen.in';
      ouf='queen.out';
var n,m:longint;
    open:array [1..2,1..50,1..4] of boolean;
    corner:array [1..100] of boolean;
    can:array [1..2,1..2,1..50,1..2,1..50] of boolean;
    was:array [1..2,1..50,1..2,1..50] of boolean;
    c:array [1..2,1..2,1..50,1..2,1..50] of longint;
function getdir(x1,y1,x2,y2:longint):longint;
begin
  getdir:=1;
  if y1-y2=1 then
    getdir:=2;
  if x2-x1=1 then
    getdir:=3;
  if x1-x2=1 then
    getdir:=4;
end;
procedure init;
var i,x1,y1,x2,y2,d1,d2:longint;
begin
  assign(input,inf);
  reset(input);
  read(n,m);
  fillchar(open,sizeof(open),true);
  for i:=1 to m do
  begin
    read(x1,y1,x2,y2);
    d1:=getdir(x1,y1,x2,y2);
    d2:=getdir(x2,y2,x1,y1);
    open[x1,y1,d1]:=false;
    open[x2,y2,d2]:=false;
  end;
  close(input);
  for i:=1 to n do
  begin
    open[1,i,4]:=false;
    open[2,i,3]:=false;
  end;
  open[1,1,2]:=false;
  open[2,1,2]:=false;
  open[1,n,1]:=false;
  open[2,n,1]:=false;
end;
function prdir(x,y:longint):longint;
begin
  prdir:=1;
  if y=-1 then
    prdir:=2;
  if x=1 then
    prdir:=3;
  if x=-1 then
    prdir:=4;
end;
function prcorn(x,y,dx,dy:longint):longint;
begin
  if (dx=1) and (dy=1) then
    prcorn:=y;
  if (dx=1) and (dy=-1) then
    prcorn:=y-1;
  if (dx=-1) and (dy=1) then
    prcorn:=y;
  if (dx=-1) and (dy=-1) then
    prcorn:=y-1;
end;
function canking(xs,ys,xf,yf:longint):boolean;
var dx,dy:longint;
begin
  canking:=false;
  if (abs(xs-xf)>1) or (abs(ys-yf)>1) then
    exit;
  dx:=xf-xs;
  dy:=yf-ys;
  if (dx=0) or (dy=0) then
    canking:=open[xs,ys,prdir(dx,dy)]
  else canking:=corner[prcorn(xs,ys,dx,dy)];
end;
function getdy(x1,y1,x2,y2:longint):longint;
begin
  if y2>y1 then
    getdy:=1
  else getdy:=-1;
end;
function canline(x1,y1,x2,y2:longint):boolean;
begin
  canline:=false;
  if x1<>x2 then
    exit;
  canline:=true;
  if y1=y2 then
    exit;
  canline:=canline(x1,y1,x2,y2-getdy(x1,y1,x2,y2)) and open[x1,y1,getdir(x1,y1,x2,y2-getdy(x1,y1,x2,y2))];
end;
function canqueen(x1,y1,x2,y2:longint):boolean;
begin
  canqueen:=canking(x1,y1,x2,y2) or (canline(x1,y1,x2,y2));
end;
procedure run;
var i,j,k,l,m:longint;
begin
  for i:=1 to n-1 do
    corner[i]:=open[1,i,1] and open[1,i,3] and open[2,i+1,2] and open[2,i+1,4];
  for i:=1 to 2 do
    for j:=1 to 2 do
      for k:=1 to 50 do
        for l:=1 to 2 do
          for m:=1 to 50 do
            case i of
              1:can[i,j,k,l,m]:=canking(j,k,l,m);
              2:can[i,j,k,l,m]:=canqueen(j,k,l,m);
            end;
end;
function sgn(a:longint):longint;
begin
  if a>0 then
    sgn:=1;
  if a=0 then
    sgn:=0;
  if a<0 then
    sgn:=-1;
end;
function evalking(x1,y1,x2,y2,a,b:longint):longint;forward;
function evalqueen(x1,y1,x2,y2,a,b:longint):longint;
var cur,x3,y3,proba:longint;
begin
  if c[2,x1,y1,x2,y2]<1000000000 then
  begin
    cur:=c[2,x1,y1,x2,y2];
    if cur<=a then
      cur:=a;
    if cur>=a then
      cur:=b;
    evalqueen:=cur;
    exit;
  end;
  was[x1,y1,x2,y2]:=true;
  cur:=a;
  for x3:=1 to 2 do
    for y3:=1 to n do
      if ((x2<>x3) or (y2<>y3)) and can[2,x2,y2,x3,y3] and not can[1,x1,y1,x3,y3] then
      begin
        if was[x1,y1,x3,y3] then
          continue;
        proba:=evalking(x1,y1,x3,y3,cur,b);
        cur:=max(cur,proba);
        if cur=proba then
          cur:=cur-sgn(cur);
        if cur>=b then
        begin
          evalqueen:=b;
          exit;
        end;
      end;
  evalqueen:=cur;
  was[x1,y1,x2,y2]:=false;
  c[2,x1,y1,x2,y2]:=cur;
end;
function evalking(x1,y1,x2,y2,a,b:longint):longint;
var cur,x3,y3,proba:longint;
begin
  if c[1,x1,y1,x2,y2]<1000000000 then
  begin
    cur:=c[1,x1,y1,x2,y2];
    if cur<=a then
      cur:=a;
    if cur>=b then
      cur:=b;
    evalking:=cur;
    exit;
  end;
  was[x1,y1,x2,y2]:=true;
  cur:=b;
  for x3:=1 to 2 do
    for y3:=1 to n do
      if ((x1<>x3) or (y1<>y3)) and can[1,x1,y1,x3,y3] and not can[2,x2,y2,x3,y3] then
      begin
        if was[x3,y3,x2,y2] then
          continue;
        proba:=evalqueen(x3,y3,x2,y2,a,cur);
        cur:=min(cur,proba);
        if cur=proba then
          cur:=cur-sgn(cur);
        if cur<=a then
        begin
          evalking:=a;
          exit;
        end;
      end;
  was[x1,y1,x2,y2]:=false;
  evalking:=cur;
  c[1,x1,y1,x2,y2]:=cur;
end;
procedure done;
var answer:longint;
begin
  assign(output,ouf);
  rewrite(output);
  fillchar(was,sizeof(was),false);
  fillchar(c,sizeof(c),127);
  answer:=evalking(1,1,2,n,-1000,1000);
  if answer<0 then
  begin
    writeln('king wins');
    writeln(1000+answer);
  end;
  if answer=0 then
    write('draw');
  if answer>0 then
  begin
    writeln('queen wins');
    writeln(1000-answer);
  end;
  close(output);
end;
begin
  init;
  run;
  done;
end.
