program zzz;

const
  inf = 10000000;
  osn = 1 shl 19;
  maxn = 100000;

type
  plist = ^tlist;
  tlist = record
    v,num: Longint;
    next: plist;
  end;

var
  tr: array[1..2*osn] of Longint;
  i,j,k,n,sc1,sc2,m: Longint;
  vis: array[1..maxn] of Boolean;
  w: array[1..maxn] of Longint;
  g: array[1..maxn] of plist;
  ch: char;
  null: plist;

function min(a,b: Longint): Longint;
begin
  if a < b then min := a else min := b;
end;

function max(a,b: Longint): Longint;
begin
  if a > b then max := a else max := b;
end;

function ReadWord(): char;
var ch: char;
begin
  read(ch);
  readword := ch;
  while ch in ['A'..'Z'] do read(ch);
end;

{procedure euler(v,dep: Longint);
var buf: plist;
begin
  vis[v] := true;
  buf := g[v];
  while buf <> null do begin
    if not vis[buf^.v] then begin
      inc(cnt);
      a[cnt] := v;
      h[cnt] := dep;
      euler(buf^.v,dep+1);
    end;
    buf := buf^.next;
  end;
  inc(cnt);
  a[cnt] := v;
  h[cnt] := dep;
end;

procedure BuildTree();
var i,j: Longint;
begin
  for i := 1 to cnt do tr[i+osn-1] := i;
  for i := osn - 1 downto 1 do begin
    if h[tr[i*2]] > h[tr[i*2+1]] then begin
      tr[i] := tr[i*2+1] else tr[i] := tr[i*2];
    end;
  end;
end;

function query(st,fin: Longint): Longint;
var res,i,j: Longint;
begin
  res := inf;
end;}

procedure add(v1,v2,num: Longint);
var buf: plist;
begin
  new(buf);
  buf^.next := g[v1];
  g[v1] := buf;
  buf^.v := v2;
  buf^.num := num;
end;

function dfs(v,vneed,cst: Longint): Longint;
var buf: plist;
    k,res: Longint;
begin
  if v = vneed then begin
    dfs := cst;
    exit;
  end;
  vis[v] := true;
  buf := g[v];
  res := -1;
  while buf <> null do begin
    if not vis[buf^.v] then begin
      k := dfs(buf^.v,vneed,max(cst,w[buf^.num]));
      if k <> -1 then begin
        res := k;
      end;
    end;
    buf := buf^.next;
  end;
  dfs := res;
end;

begin
  assign(input,'thruput.in'); reset(input);
  assign(output,'thruput.out'); rewrite(output);
  readln(n);
  for i := 1 to n-1 do begin
    readln(k,j,w[i]);
    add(k,j,i);
    add(j,k,i);
  end;
  while true do begin
    ch := Readword();
    if ch = 'D' then break;
    if ch = 'Q' then begin
      readln(k,j);
      for i := 1 to n do vis[i] := false;
      writeln(dfs(k,j,0));
    end else begin
      readln(k,j);
      w[k] := j;
    end;
  end;
  close(input);
  close(output);
end.
