const MAXN=100100{};
var tree:array[1..MAXN,1..2]of longint;
    edges:array[0..MAXN,1..4]of longint;
    begedg,was:array[1..MAXN+1]of longint;
    n,nq:longint;

procedure Qsort(be,en:longint);
var x,t,l,r:longint;
begin
     l:=be;
     r:=en;
     x:=be+random(en-be);
     while l<r do begin
           while edges[x,1]>edges[l,1] do inc(l);
           while edges[x,1]<edges[r,1] do dec(r);
           if l<=r then begin
              t:=edges[l,1];
              edges[l,1]:=edges[r,1];
              edges[r,1]:=t;
              t:=edges[l,2];
              edges[l,2]:=edges[r,2];
              edges[r,2]:=t;
              t:=edges[l,3];
              edges[l,3]:=edges[r,3];
              edges[r,3]:=t;
              t:=edges[l,4];
              edges[l,4]:=edges[r,4];
              edges[r,4]:=t;
              inc(l);
              dec(r);
           end;
     end;
     if be<r then Qsort(be,r);
     if l<en then Qsort(l,en);
end;

procedure UnQsort(be,en:longint);
var x,t,l,r:longint;
begin
     l:=be;
     r:=en;
     x:=be+random(en-be);
     while l<r do begin
           while edges[x,4]>edges[l,4] do inc(l);
           while edges[x,4]<edges[r,4] do dec(r);
           if l<=r then begin
              t:=edges[l,1];
              edges[l,1]:=edges[r,1];
              edges[r,1]:=t;
              t:=edges[l,2];
              edges[l,2]:=edges[r,2];
              edges[r,2]:=t;
              t:=edges[l,3];
              edges[l,3]:=edges[r,3];
              edges[r,3]:=t;
              t:=edges[l,4];
              edges[l,4]:=edges[r,4];
              edges[r,4]:=t;
              inc(l);
              dec(r);
           end;
     end;
     if be<r then UnQsort(be,r);
     if l<en then UnQsort(l,en);
end;

procedure Dfs(ver:longint);
var i:longint;
begin
     if was[ver]=1 then exit;
     was[ver]:=1;
     for i:=begedg[ver] to begedg[ver+1]-1 do begin
         if (edges[i,1]=ver)and(tree[edges[i,2],1]=0) then begin
            tree[edges[i,2],1]:=ver;
            tree[edges[i,2],2]:=edges[i,4];
            if edges[i,4]>n-1 then dec(tree[edges[i,2],2],n-1);
            Dfs(edges[i,2]);
         end
         else if (edges[i,2]=ver)and(tree[edges[i,2],1]=0) then begin
            tree[edges[i,1],1]:=ver;
            tree[edges[i,1],2]:=edges[i,4];
            if edges[i,4]>n-1 then dec(tree[edges[i,1],2],n-1);
            Dfs(edges[i,1]);
         end;
     end
end;

procedure Load;
var i,t,us,ws:longint;
begin
     readln(n);
     for i:=1 to n-1 do begin
         readln(edges[i,1],edges[i,2],edges[i,3]);
         if edges[i,2]<edges[i,1] then begin
            t:=edges[i,1];
            edges[i,1]:=edges[i,2];
            edges[i,2]:=t;
         end;
         edges[i,4]:=i;
         edges[i+n-1,1]:=edges[i,2];
         edges[i+n-1,2]:=edges[i,1];
         edges[i+n-1,3]:=edges[i,3];
         edges[i+n-1,4]:=edges[i,4]+n-1;
     end;
     Qsort(1,2*(n-1));
     ws:=1;
     us:=1;
     for i:=2 to 2*n-1 do begin
         if edges[i,1]<>us then begin
            begedg[us]:=ws;
            ws:=i;
            us:=edges[i,1];
         end;
     end;
     begedg[n+1]:=2*n-1;
     for i:=n+1 downto 2 do begin
         if begedg[i-1]=0 then begedg[i-1]:=begedg[i];
     end;
     tree[1,1]:=1;
     Dfs(1);
     UnQsort(1,2*(n-1));
end;

var pathup:array[1..MAXN,1..2]of longint;

procedure DoUp(ver:longint);
var cur:longint;
begin
     inc(nq);
     cur:=ver;
     pathup[ver,2]:=edges[tree[ver,2],3];
     pathup[ver,1]:=nq;
     while cur<>1 do begin
         pathup[tree[cur,1],2]:=pathup[cur,2];
         if pathup[tree[cur,1],2]<edges[tree[cur,2],3] then pathup[tree[cur,1],2]:=edges[tree[cur,2],3];
         cur:=tree[cur,1];
         pathup[cur,1]:=nq;
     end;
     if pathup[cur,2]<edges[tree[cur,2],3] then pathup[cur,2]:=edges[tree[cur,2],3];
end;

procedure Solve;
var i,p,q,cmax,cur:longint;
    c:char;
begin
     read(c);
     nq:=0;
     while c<>'D' do begin
           if c='C' then begin
              while c<>' ' do read(c);
              readln(p,q);
              edges[p,3]:=q;
              read(c);
           end
           else begin
              while c<>' ' do read(c);
              readln(p,q);
              DoUp(p);
              cur:=q;
              cmax:=edges[tree[q,2],3];
              while pathup[cur,1]<nq do begin
                    if edges[tree[cur,2],3]>cmax then cmax:=edges[tree[cur,2],3];
                    cur:=tree[cur,1];
              end;
              if cmax<pathup[cur,2] then cmax:=pathup[cur,2];
              write(cmax);
              read(c);
              if c<>'D' then writeln;
           end;
     end;
end;

begin
     assign(input,'thruput.in');
     assign(output,'thruput.out');
     reset(input);
     rewrite(output);
     Load;
     Solve;
     close(input);
     close(output);
end.
