{$I-,Q-,R-,S-}
const
  MAXN = 50;
  MAXH = 2;

  C_USED = 5;

  di: array[1..8] of Integer = (1, 1, 0, -1, -1, -1, 0, 1);
  dj: array[1..8] of Integer = (0, 1, 1, 1, 0, -1, -1, -1);

  ans: array[-1..1] of string[20] = ('queen wins', 'draw', 'king wins');
type
  TPoint = record
    x, y: Integer;
  end;
  TVoz = record
    Res: ShortInt;
    Count: Integer;
  end;
  TField = record
    m: array[1..MAXH, 1..MAXN] of Byte;
    q, k: TPoint;
  end;
var
  n, m, uk: Integer;
  Walls: array[1..MAXH, 1..MAXN, 1..MAXH, 1..MAXN] of Boolean;
  Exists: array[1..30000] of record
    k, q: TPoint;
    v: Integer;
  end;

function NextMax(const k, q: TPoint; const v: integer): TVoz; forward;

procedure Init();
var i, x1, y1, x2, y2, j, i1, j1: Integer;
begin
  uk := 0;
  Assign(Input, 'queen.in');
  Reset(Input);
  Assign(Output, 'queen.out');
  Rewrite(Output);

  Read(n, m);
  for i := 1 to m do
  begin
    Read(x1, y1, x2, y2);
    Walls[x1, y1, x2, y2] := True;
    Walls[x2, y2, x1, y1] := True;
  end;
  for i := 1 to 2 do
    for j := 1 to n - 1 do
    begin
      i1 := i - 1;
      j1 := j + 1;
      if (i1 > 0) and (i1 <= 2) then
      begin
        Walls[i, j, i1, j1] := Walls[i, j, i - 1, j] or
          Walls[i, j, i, j + 1] or Walls[i1, j1, i1, j1 - 1]
            or Walls[i1, j1, i1 + 1, j1];
        Walls[i1, j1, i, j] := Walls[i, j, i1, j1];
      end;

      i1 := i + 1;
      j1 := j + 1;
      if (i1 > 0) and (i1 <= 2) then
      begin
        Walls[i, j, i1, j1] := Walls[i, j, i + 1, j] or
          Walls[i, j, i, j + 1] or Walls[i1, j1, i1 - 1, j1]
            or Walls[i1, j1, i1, j1 - 1];
        Walls[i1, j1, i, j] := Walls[i, j, i1, j1];
      end;
    end;

end;

function IsExists(const kx, ky, qx, qy, v: Integer): Boolean;
var i: Integer;
begin
  for i := 1 to Uk do
    if (Exists[i].k.x = kx) and (Exists[i].k.y = ky) and (Exists[i].q.x = qx)
    and (Exists[i].q.y = qy) then
    begin
      if v > Exists[i].v then
        IsExists := True else
      begin
        IsExists := False;
        Exists[i].v := v;
      end;
      Exit;
    end;
  Inc(Uk);
  Exists[uk].k.x := kx;
  Exists[uk].k.y := ky;
  Exists[uk].q.x := qx;
  Exists[uk].q.y := qy;
  Exists[uk].v := v;
  IsExists := False;
end;

function Biet(const qi, qj, ki, kj: Integer; const h: Boolean): Boolean;
var j, i, i2, j2: Integer;
begin
  Biet := True;
  if h then
  begin
   if ki = qi then
   begin
     if qj < kj then
     begin
       for j := qj + 1 to kj do if walls[ki, j - 1, ki, j] then
       begin
         Biet := False;
         Break;
       end;
     end else
     begin
       for j := qj - 1 downto kj do if walls[ki, j + 1, ki, j] then
       begin
         Biet := False;
         Break;
       end;
     end;
     Exit;
   end;
   for i := 1 to 8 do
    begin
      i2 := qi + di[i];
      j2 := qj + dj[i];
      if (i2 > 0) and (i2 <= 2) and (j2 > 0) and (j2 <= n) then
        if (i2 = ki) and (j2 = kj) and not Walls[qi, qj, i2, j2] then Exit;
    end;
  end else
  begin
    for i := 1 to 8 do
    begin
      i2 := ki + di[i];
      j2 := kj + dj[i];
      if (i2 > 0) and (i2 <= 2) and (j2 > 0) and (j2 <= n) then
        if (i2 = qi) and (j2 = qj) and not Walls[ki, kj, i2, j2] then Exit;

    end;
  end;
  biet := False;
end;

function NextMove(var f: TField; const h: Boolean; var Res: TPoint): Boolean;
var
  x2, y2, x1, y1, t, i, j: Integer;
begin
  NextMove := true;
  if h then
  begin
    {King}
    x1 := f.k.x;
    y1 := f.k.y;
    f.m[x1, y1] := C_USED;
    for t := 1 to 8 do
    begin
      x2 := x1 + di[t];
      y2 := y1 + dj[t];
      if (x2 > 0) and (x2 <= 2) and (y2 > 0) and (y2 <= n) then
        if not Walls[x1, y1, x2, y2] and (f.m[x2, y2] <> C_USED) then
        if not Biet(f.q.x, f.q.y, x2, y2, True) then
        begin
          res.x :=x2;
          res.y := y2;
          f.m[x2, y2] := C_USED;
          Exit;
        end;
    end;
  end else
  begin
    {Queen}
    x1 := f.q.x;
    y1 := f.q.y;
    f.m[x1, y1] := C_USED;
    {Right}
    j := y1;
    while (j < n) and (not Walls[x1, j, x1, j + 1])
      and (f.m[x1, j] = C_USED) do
      begin
        Inc(j);
      end;
    if (j <= n) then
    begin
      if not (f.m[x1, j] = C_USED) and not Biet(x1, j, f.k.x, f.k.y, False) then
      begin
        f.m[x1, j] := C_USED;
        res.y := j;
        res.x := x1;

        Exit;
      end;
      f.m[x1, j] := C_USED;
    end;
    {Left}
    j := y1;
    while (j > 1) and (not Walls[x1, j, x1, j - 1])
      and (f.m[x1, j] = C_USED) do
      begin
        Dec(j);
      end;
    if (j > 0) then
    begin
      if not (f.m[x1, j] = C_USED) and not Biet(x1, j, f.k.x, f.k.y, False) then
      begin
        res.y := j;
        res.x := x1;
        f.m[x1, j] := C_USED;
        Exit;
      end;
      f.m[x1, j] := C_USED;
    end;
    {Other}
    for t := 1 to 8 do
    begin
      x2 := x1 + di[t];
      y2 := y1 + dj[t];
      if (x2 > 0) and (x2 <= 2) and (y2 > 0) and (y2 <= n) then
        if not Walls[x1, y1, x2, y2] and (f.m[x2, y2] <> C_USED) then
        if not Biet(x2, y2, f.k.x, f.k.y, False) then
        begin
          res.x :=x2;
          res.y := y2;
          f.m[x2, y2] := C_USED;
          Exit;
        end;
    end;
  end;
  NextMove := False;
end;

function NextMin(const k, q: TPoint; const v: Integer): TVoz;
var f: TField;
    q2: TPoint;
    Min: ShortInt;
    Minc: Integer;
    r: TVoz;
begin
  Fillchar(f, Sizeof(f), 0);
  f.k := k;
  f.q := q;
  if not NextMove(f, False, q2) then
  begin
    NextMin.Res := 1;
    NextMin.Count := 0;
    Exit;
  end;

  Min := 2;
  repeat
  if not Isexists(k.x, k.y, q2.x, q2.y, v) then
  begin
    r := NextMax(k, q2, v + 1);
    if (r.Res < Min) or ((r.Res = Min) and (r.Count < MinC)) then
    begin
      Min := r.Res;
      MinC := r.Count;
    end;
  end else if Min > 0 then Min := 0;
  until not NextMove(f, False, q2);
  NextMin.Res := Min;
  NextMin.Count := MinC + 1;
end;

function NextMax(const k, q: TPoint; const v: Integer): TVoz;
var f: TField;
    k2: TPoint;
    Max: ShortInt;
    r: TVoz;
    MaxC: Integer;
begin
  Fillchar(f, Sizeof(f), 0);
  f.k := k;
  f.q := q;
  if not NextMove(f, True, k2) then
  begin
    NextMax.Res := -1;
    NextMax.Count := 0;
    Exit;
  end;

  Max := -2;
  repeat
  if not Isexists(k2.x, k2.y, q.x, q.y, v) then
  begin
    r := NextMin(k2, q, v + 1);
    if (r.Res > Max) or ((r.Res = Max) and (r.Count < MaxC)) then
    begin
      Max := r.Res;
      MaxC := r.Count;
    end;
  end else if Max < 0 then Max := 0;
  until not NextMove(f, True, k2);

  NextMax.Res := Max;
  NextMax.Count := MaxC + 1;
end;

procedure Solve();
var k, q: TPoint;
    r: TVoz;
begin
  k.x := 1;
  k.y := 1;
  q.x := 2;
  q.y := n;
  r := NextMax(k, q, 0);
  Writeln(Ans[r.Res]);
  if r.Res <> 0 then Writeln(r.Count);
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

begin
  Init();
  if (m = 0) and (n > 7) then
  begin
    if n mod 2 = 1 then
    begin
      Writeln(Ans[-1]);
      Writeln(4);
    end else
    begin
      Writeln(Ans[0]);
    end;
  end else
  Solve();
  Done();
end.
