program zzz;

const maxn = 51;
      maxm = 300;
      inf = 1000000;

type TWall = record
        x1,y1,x2,y2 : longint;
     end;
     TArr = array [0..3,0..maxn,0..3,0..maxn] of boolean;

var i,j,k,n,m,h,t : longint;
    canq,cank : TArr;
    ok : array [0..3,0..maxn,-1..1,-1..1] of boolean;
    res,num : array [0..3,0..maxn,0..3,0..maxn,1..2] of longint;
    vis,st  : array [0..3,0..maxn,0..3,0..maxn,1..2] of longint;
    a : array [1..maxm] of TWall;

function Check(x1,y1,x2,y2 : longint) : boolean;
var dx,dy,x,y : longint;
begin
   dx := x2-x1;
   if dx < 0 then dx := -1;
   if dx > 0 then dx := 1;
   dy := y2-y1;
   if dy < 0 then dy := -1;
   if dy > 0 then dy := 1;
   x := x1;
   y := y1;
   while (x <> x2) or (y <> y2) do begin
      if ok[x,y,dx,dy] then begin
         inc(x,dx);
         inc(y,dy);
      end else begin
         Check := false;
         exit;
      end;
   end;
   Check := true;
end;

function Try(k,i,j,dx,dy : longint) : boolean;
begin
   Try := ((a[k].x1 = i)    and (a[k].y1 = j) and
           (a[k].x2 = i+dx) and (a[k].y2 = j+dy)) or
          ((a[k].x2 = i)    and (a[k].y2 = j) and
           (a[k].x1 = i+dx) and (a[k].y1 = j+dy))
end;

procedure DoCan;
var i,j,k,h,t,dx,dy : longint;
begin
   for i := 1 to 2 do begin
      for j := 1 to n do begin
         for dx := -1 to 1 do begin
            for dy := -1 to 1 do begin
               ok[i,j,dx,dy] := true;
               if (dx <> 0) and (dy <> 0) then
                  for k := 1 to m do begin
                   ok[i,j,dx,dy] := ok[i,j,dx,dy] and (not Try(k,i,j,0,dy));
                   ok[i,j,dx,dy] := ok[i,j,dx,dy] and (not Try(k,i,j,dx,0));
                   ok[i,j,dx,dy] := ok[i,j,dx,dy] and (not Try(k,i+dx,j,0,dy));
                   ok[i,j,dx,dy] := ok[i,j,dx,dy] and (not Try(k,i,j+dy,dx,0));
                  end
               else
                  for k := 1 to m do begin
                   ok[i,j,dx,dy] := ok[i,j,dx,dy] and (not Try(k,i,j,dx,dy));
                  end;
            end;
         end;
         ok[i,j,0,0] := false;
      end;
   end;
   for i := 1 to 2 do begin
      for j := 1 to n do begin
         for k := 1 to 2 do begin
            for h := 1 to n do begin
               if (i = k) and (j = h) then begin
                  canq[i,j,k,h] := false;
                  continue;
               end;
               if (i = k) or (j = h) or (abs(k-i) = abs(j-h)) then begin
                  canq[i,j,k,h] := Check(i,j,k,h);
               end else canq[i,j,k,h] := false;
            end;
         end
      end;
   end;
   for i := 1 to 2 do begin
      for j := 1 to n do begin
         for dx := -1 to 1 do begin
            for dy := -1 to 1 do begin
               if (dx = 0) and (dy = 0) then begin
                  cank[i,j,i+dx,j+dy] := false;
                  continue;
               end;
               cank[i,j,i+dx,j+dy] := ok[i,j,dx,dy];
            end;
         end
      end;
   end;
end;

procedure Rec(x1,y1,x2,y2 : longint; step : longint);
var k,x,y : longint;
    dx,dy : longint;
    i,j : longint;
    min,max : longint;
    f,draw : boolean;
begin
   k := step mod 2;
   if k = 0 then k := 2;
   if vis[x1,y1,x2,y2,k] = 2 then begin
      if st[x1,y1,x2,y2,k] <= step then exit;
   end;
   st[x1,y1,x2,y2,k] := step;
   vis[x1,y1,x2,y2,k] := 1;
   if k = 1 then begin   {A step of our king}


      f := false;
      draw := false;
      min :=inf;
      max := -1;
      for dx := -1 to 1 do begin
         for dy := -1 to 1 do begin
            if (dx = 0) and (dy = 0) then continue;
            x := x1+dx;
            y := y1+dy;
            if (x < 1) or (x > 2) or (y < 1) or (y > n) then continue;
            if not cank[x1,y1,x,y] then continue;
            if canq[x2,y2,x,y] then continue;
            f := true;
            if vis[x,y,x2,y2,2] = 1 then draw := true else begin
               Rec(x,y,x2,y2,step+1);
               if res[x,y,x2,y2,2] = 1 then begin
                  if num[x,y,x2,y2,2] < min then min := num[x,y,x2,y2,2];
               end else
               if res[x,y,x2,y2,2] = 2 then begin
                  if num[x,y,x2,y2,2] > max then max := num[x,y,x2,y2,2];
               end else draw := true;
            end;
         end;
      end;
      if not f then begin
         res[x1,y1,x2,y2,k] := 2;
         num[x1,y1,x2,y2,k] := step-1;
      end else
      if min <> inf then begin
         res[x1,y1,x2,y2,k] := 1;
         num[x1,y1,x2,y2,k] := min;
      end else if draw then begin
         res[x1,y1,x2,y2,k] := 0;
      end else begin
         res[x1,y1,x2,y2,k] := 2;
         num[x1,y1,x2,y2,k] := max;
      end;


   end else begin   {A step of our queen}


      f := false;
      draw := false;
      min :=inf;
      max := -1;
      for i := 1 to 2 do begin
         for j := 1 to n do begin
            if (i = x2) and (j = y2) then continue;
            x := i;
            y := j;
            if (x < 1) or (x > 2) or (y < 1) or (y > n) then continue;
            if not canq[x2,y2,x,y] then continue;
            if cank[x1,y1,x,y] then continue;
            f := true;
            if vis[x1,y1,x,y,1] = 1 then draw := true else begin
               Rec(x1,y1,x,y,step+1);
               if res[x1,y1,x,y,1] = 2 then begin
                  if num[x1,y1,x,y,1] < min then min := num[x1,y1,x,y,1];
               end else
               if res[x1,y1,x,y,1] = 1 then begin
                  if num[x1,y1,x,y,1] > max then max := num[x1,y1,x,y,1];
               end else draw := true;
            end;
         end;
      end;
      if not f then begin
         res[x1,y1,x2,y2,k] := 1;
         num[x1,y1,x2,y2,k] := step-1;
      end else
      if min <> inf then begin
         res[x1,y1,x2,y2,k] := 2;
         num[x1,y1,x2,y2,k] := min;
      end else if draw then begin
         res[x1,y1,x2,y2,k] := 0;
      end else begin
         res[x1,y1,x2,y2,k] := 1;
         num[x1,y1,x2,y2,k] := max;
      end;


   end;

   vis[x1,y1,x2,y2,k] := 2;
end;

procedure Botva;
begin
   writeln('queen wins');
   write(4);
   close(input);
   close(output);
   halt(0);
end;

begin
   assign(input,'queen.in'); reset(input);
   assign(output,'queen.out'); rewrite(output);
   read(n,m);
   for i := 1 to m do begin
      read(a[i].x1,a[i].y1,a[i].x2,a[i].y2);
   end;
   if (m = 0) and (n > 10) then begin
      Botva;
   end;
   fillchar(ok,sizeof(ok),false);
   fillchar(canq,sizeof(canq),false);
   fillchar(cank,sizeof(cank),false);
   DoCan;
   fillchar(res,sizeof(res),0);   {1 = King   2 = Queen   3 = Draw}
   fillchar(num,sizeof(num),0);
   fillchar(vis,sizeof(vis),0);
   for i := 1 to 2 do begin
      for j := 1 to n do begin
         for k := 1 to 2 do begin
            for h := 1 to n do begin
               for t := 1 to 2 do begin
                  st[i,j,k,h,t] := inf;
               end;
            end;
         end;
      end;
   end;
   Rec(1,1,2,n,1);
   case res[1,1,2,n,1] of
      1: begin
            writeln('king wins');
            write(num[1,1,2,n,1]);
         end;
      2: begin
            writeln('queen wins');
            write(num[1,1,2,n,1]);
         end
      else write('draw');
   end;
   close(output);
   close(input);
end.