{$I-,Q-,R-,S-}
type
   int = integer;
   integer = longint;

procedure init;
begin
   assign(input, 'thruput.in'); reset(input);
   assign(output, 'thruput.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

function min(a, b: integer): integer;
begin
   if a< b then min:=a else min:=b;
end;

function max(a, b: integer): integer;
begin
   if a > b then max:=a else max:=b;
end;

const
   maxn=100000;

type
   ptx=^tx;
   tx= record node: integer;cost: integer; next: ptx; end;
   tm= array[1..maxn] of ptx;
   tquery=record
          head,tail: integer;
          v, c:array[0..maxn-1] of integer;
          end;
var
   n: integer;
   m: tm;
   mx: integer;
   q1, q2:tquery;

   d, d2: array[1..maxn] of boolean;
   r: array[1..maxn-1] of record s,e: integer end;
   rec1,rec2: array[1..maxn] of integer;


procedure add(a, b, c: integer);
var
   x: ptx;
begin
   new(x);
   x^.next:=m[a];
   x^.node:=b;
   x^.cost:=c;
   m[a]:=x;
end;

procedure readinfo;
var i, j, k, t: integer;
begin
   readln(n);
   for i:=1 to n-1 do
   begin
      readln(j,k,t);
      add(j,k,t);
      add(k,j,t);
      r[i].s:=j;
      r[i].e:=k;
   end;
end;

procedure Skip;
var
   c: char;
begin
   repeat
    read(c);
   until c=' ';
end;

procedure Change;
var
   a, b: integer;
   z: ptx;
   s, e: integer;
begin
   readln(a,b);
   s:=r[a].s;
   e:=r[a].e;

   z:=m[s];
   while true do
    if z^.node=e then
    begin
      z^.cost:=b;
      break;
    end
    else
    z:=z^.next;

   z:=m[e];
   while true do
    if z^.node=s then
    begin
      z^.cost:=b;
      break;
    end
    else
    z:=z^.next;
end;


procedure Push(vr, cost: integer;var q:tquery);
begin
 with q do
 begin
   v[tail]:=vr;
   c[tail]:=cost;
   tail:=(tail+1)mod maxn;
 end;
end;


function Pop(var vr, cost: integer;var q: tquery):boolean;
begin
 with q do
 begin
   if head=tail then
    Pop:=false
   else
   begin
    Pop:=true;
    vr:=v[head];
    cost:=c[head];
    head:=(head+1)mod maxn
   end;
 end;
end;


procedure Query;
var
   a, b: integer;
   x, y: integer;
   z: ptx;
begin
   with q1 do
   begin
      head:=0;
      tail:=0;
   end;

   readln(a,b);
   push(a,0,q1);
   fillchar(d,n,true);
   while pop(x,y,q1) do
   begin
      d[x]:=false;
      if x=b then
      begin
         writeln(y);
         exit;
      end;

      z:=m[x];
      while z<>nil do
      begin
         if d[z^.node] then
           push(z^.node,max(z^.cost,y),q1);
         z:=z^.next;
      end;
   end;
end;



procedure Query2;
var
   a, b: integer;
   x, y: integer;
   z: ptx;
begin
   with q1 do
   begin
      head:=0;
      tail:=0;
   end;
   with q2 do
   begin
      head:=0;
      tail:=0;
   end;

   readln(a,b);
   push(a,0,q1);
   push(b,0,q2);
   fillchar(d,n,true);
   fillchar(d2,n,true);
 repeat

  if pop(x,y,q2) then
   begin
      d2[x]:=false;
      rec2[x]:=y;
      if x=a then
      begin
         writeln(y);
         exit;
      end;

      if not d[x] then
      begin
         writeln(max(rec1[x],y));
         exit;
      end;

      z:=m[x];
      while z<>nil do
      begin
         if d[z^.node] then
           push(z^.node,max(z^.cost,y),q2);
         z:=z^.next;
      end;
   end;


   if pop(x,y,q1) then
   begin
      d[x]:=false;
      rec1[x]:=y;
      if x=b then
      begin
         writeln(y);
         exit;
      end;

      if not d2[x] then
      begin
         writeln(max(rec2[x],y));
         exit;
      end;

      z:=m[x];
      while z<>nil do
      begin
         if d[z^.node] then
           push(z^.node,max(z^.cost,y),q1);
         z:=z^.next;
      end;

   end;



 until false;
end;


procedure solve;
var
    c: char;
begin
 readinfo;

 repeat
  read(c);
  case c of
   'C': begin Skip; Change; end;
   'D': break;
   'Q': begin Skip; Query2; end;
  end;
 until false;
end;

begin
 init;
 solve;
 done;
end.

