{$I-,Q-,R-,S-}
type
   int = integer;
   integer = longint;

procedure init;
begin
   assign(input, 'triples.in'); reset(input);
   assign(output, 'triples.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

const
   maxn=100;
type
   tm=array[1..maxn,1..maxn] of word;
var
   n: integer;
   bd, dg, gb: tm;
   {bb,} dd, gg: array[1..maxn] of boolean;
   time: array[1..maxn, 1..maxn, 1..maxn] of integer;
   x, xn: array[1..maxn] of record d, g: integer end;
   best: integer;
   max, maxj, maxk: integer;

procedure readinfo;
var i, j: integer;
begin
   readln(n);
   for i:=1 to n do
    for j:=1 to n do
     read(bd[i,j]);
   for i:=1 to n do
    for j:=1 to n do
     read(dg[i,j]);
   for i:=1 to n do
    for j:=1 to n do
     read(gb[i,j]);
end;


procedure selectmax(i: integer);
var
   j, k: integer;
   max: integer;
begin
   max:=0;
   for j:=1 to n do
    for k:=1 to n do
     if not (dd[j] or gg[k]) then
      if max<time[i,j,k] then
      begin
       max:=time[i,j,k];
       maxj:=j;
       maxk:=k;
      end;
   dd[maxj]:=true;
   gg[maxk]:=true;
   xn[i].d:=maxj;
   xn[i].g:=maxk;
   inc(best,max);
end;


procedure rec(i: byte;t: integer);
var j, k: integer;
begin
   if t+max*(n-i+1)<best then
    exit;
   if i>n then
   begin
      k:=0;
      for j:=1 to n do
       inc(k, time[j,x[j].d,x[j].g]);
      if k>best then
      begin
         best:=k;
         xn:=x;
      end;
      exit;
   end;

   for j:=1 to n do
    if not dd[j] then
    begin
      dd[j]:=true;
      for k:=1 to n do
       if not gg[k] then
       begin
         gg[k]:=true;
         x[i].d:=j;
         x[i].g:=k;
         rec(i+1, t+time[i,j,k]);

         gg[k]:=false;
       end;
      dd[j]:=false;
    end;


end;


procedure solve;
var
   i, j, k: integer;
begin
  readinfo;
  for i:=1 to n do
   for j:=1 to n do
    for k:=1 to n do
     time[i,j,k]:=bd[i,j]+dg[j,k]+gb[k,i];

  if n>=7 then
  begin
   for i:=1 to n do
   begin
      selectmax(i);
      writeln(i,' ',maxj,' ',maxk);
   end;
   exit;
  end;

  for i:=1 to n do
   selectmax(i);

  max:=time[1,1,1];

  for i:=1 to n do
   for j:=1 to n do
    for k:=1 to n do
     if max<time[i,j,k] then
      max:=time[i,j,k];

  fillchar(dd,n,false);
  fillchar(gg,n,false);

  rec(1,0);
  for i:=1 to n do
   writeln(i,' ',xn[i].d,' ',xn[i].g);
end;

begin
 init;
 solve;
 done;
end.

