{$I-,Q-,R-,S-}
{$M 1048576, 0}
type
   int = integer;
   integer = longint;

procedure init;
begin
   assign(input, 'queen.in'); reset(input);
   assign(output, 'queen.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

const
   big=maxlongint div 2;

var
   n, m: integer;
   wh: array[1..50] of boolean;
   wv: array[1..50,1..2] of boolean;
   wins: array[1..2,1..50,1..2,1..50,1..2] of integer;
   bl, inproc: array[1..2,1..50,1..2,1..50,1..2] of boolean;
   stsize: integer;

function min(a, b: integer): integer;
begin
   if a< b then min:=a else min:=b;
end;

function max(a, b: integer): integer;
begin
   if a > b then max:=a else max:=b;
end;


procedure readinfo;
var
   i: integer;
   x1,y1,x2,y2: integer;
begin
   readln(n, m);
   for i:=1 to m do
   begin
      readln(x1,y1,x2,y2);
      if x1=x2 then
         wh[x1]:=true
      else
         wv[min(x1,x2),y2]:=true;
   end;
end;


function sgn(x: integer): integer;
begin
   if x<0 then sgn:=-1 else if x=0 then sgn:=0 else sgn:=1;
end;

procedure swap(var a,b: integer);
var
   t: integer;
begin
   t:=a; a:=b; b:=t;
end;




function QueenCanDoTurn(x2,y2,i,j: integer): boolean;
var
   k: integer;
begin
  if(x2=i)and(y2=j) then
    begin QueenCanDoTurn:=false; exit end;

  if y2=j then
  begin
   for k:=min(x2,i) to max(x2,i)-1 do
    if wv[k,y2] then
     begin QueenCanDoTurn:=false; exit end;
   QueenCanDoTurn:=true;
   exit;
  end;

  if x2=i then
   begin
      QueenCanDoTurn:= not wh[i];
      exit;
   end;

  if abs(x2-i)<>abs(y2-j) then
   begin QueenCanDoTurn:=false; exit end;

  if (x2>i) then
   begin
      swap(x2,i);
      swap(y2,j);
   end;

  QueenCanDoTurn:=not (wv[x2,y2] or wv[x2,j] or wh[x2] or wh[i]);
end;



function KingCanDoTurn(x1,y1,i,j: integer): boolean;
begin
   if(x1=i)and(y1=j) then
    begin KingCanDoTurn:=false; exit end;
   if (abs(x1-i)>1)or(abs(y1-j)>1) then
    begin KingCanDoTurn:=false; exit end;

   if y1=j then
   begin
      if i<x1 then
      begin
         if wv[i,y1] then
           begin KingCanDoTurn:=false; exit end;
      end
      else
      begin
         if wv[x1,y1] then
           begin KingCanDoTurn:=false; exit end;
      end;
      KingCanDoTurn:=true;
      exit;
   end;

   if x1=i then
   begin
      KingCanDoTurn:= not wh[x1];
      exit;
   end;

   if (x1>i) then
   begin
      swap(x1,i);
      swap(y1,j);
   end;

   KingCanDoTurn:=not (wv[x1,y1] or wv[x1,j] or wh[x1] or wh[i]);
end;


function QueenDrawField(x1,y1,i,j: integer):boolean;
begin
   if(x1=i)and(y1=j) then
      QueenDrawField:=true
   else
      QueenDrawField:=QueenCanDoTurn(x1,y1,i,j);
end;

function KingDrawField(x1,y1,i,j: integer):boolean;
begin
   if(x1=i)and(y1=j) then
      KingDrawField:=true
   else
      KingDrawField:=KingCanDoTurn(x1,y1,i,j);
end;


function KingCanGo(x1,y1,x2,y2,i,j: integer): boolean;
begin
   KingCanGo:= KingCanDoTurn(x1,y1,i,j)and
               not QueenDrawField(x2,y2,i,j);
end;
function QueenCanGo(x1,y1,x2,y2,i,j: integer): boolean;
begin
   QueenCanGo:= QueenCanDoTurn(x2,y2,i,j)and
                not KingDrawField(x1,y1,i,j);
end;


function king(x1,y1,x2,y2: integer):integer; forward;

function queen(x1,y1,x2,y2: integer):integer;
var i, j: integer;
    f, p: boolean;
    r: integer;
begin

   if bl[2,x1,y1,x2,y2] then
     begin queen:=wins[2,x1,y1,x2,y2]; exit end;
   if inproc[2,x1,y1,x2,y2] then
     begin
     queen:=big;
     exit
     end;

   f:=false;
   p:=false;
{   z:=false;}
   r:=-big;
   inc(stsize);
   inproc[2,x1,y1,x2,y2]:=true;
   for i:=1 to n do
    for j:=1 to 2 do
    begin
      if QueenCanGo(x1,y1,x2,y2,i,j) then
      begin
         r:= max(r, king(x1,y1,i,j));
         if r<>big then
          f:= true{ else z:=true};
         p:=true
      end;
    end;
   inproc[2,x1,y1,x2,y2]:=false;
   dec(stsize);
//   if not f then r:=-1 else r:=-r;
   if not f then
   begin
      if not p then
       r:=0
   end
   else
     if r<>big then
      if r=0 then
         r:=1
      else
         if r>0 then
            r:=-r-1
         else
            r:=-r+1;

   bl[2,x1,y1,x2,y2]:=true;
   wins[2,x1,y1,x2,y2]:=r;
   queen:=r;
end;

function king(x1,y1,x2,y2: integer):integer;
var i, j: integer;
    f, p: boolean;
    r: integer;
begin

   if bl[1,x1,y1,x2,y2] then
     begin king:=wins[1,x1,y1,x2,y2]; exit end;

  if inproc[1,x1,y1,x2,y2] then
    begin
     king:=big;
     exit
    end;

   f:=false;
   p:=false;
   {z:=false;}
   r:=-big;
   inproc[1,x1,y1,x2,y2]:=true;
   inc(stsize);
   for i:=max(1,x1-1) to min(n,x1+1) do
    for j:=1 to 2 do
    begin
      if KingCanGo(x1,y1,x2,y2,i,j) then
      begin
         r:= max(r, queen(i,j,x2,y2));
         if r<>big then
          f:= true;
         p:=true;
      end;
    end;
   inproc[1,x1,y1,x2,y2]:=false;
   dec(stsize);
//   if not f then r:=-1 else r:=-r;
   if not f then
   begin
      if not p then
        r:=0
   end
   else
      if r<>big then
      if r=0 then
         r:=1
      else
         if r>0 then
            r:=-r-1
         else
            r:=-r+1;

   bl[1,x1,y1,x2,y2]:=true;
   wins[1,x1,y1,x2,y2]:=r;
   king:=r;
end;

function kingCannotGo: boolean;
begin
   kingCannotGo:= not(KingCanDoTurn(1,1, 1,2) or
                      KingCanDoTurn(1,1, 2,2) or
                      KingCanDoTurn(1,1, 2,1));
end;
function QueenCannotGo: boolean;
begin
   QueenCannotGo:= not(QueenCanDoTurn(n,2, n-1,2) or
                      QueenCanDoTurn(n,2, n-1,1) or
                      QueenCanDoTurn(n,2, n,1));
end;

procedure Test;
var
   x:array[1..50,1..2] of byte;
   i,j, l, w: integer;
   f: boolean;
begin
   fillchar(x,sizeof(x),0);
   x[1,1]:=1;
   repeat
     f:=true;
     for i:=1 to n do
      for j:=1 to 2 do
      if x[i,j]=1 then
      begin
        for l:=max(1,i-1) to min(n,i+1) do
         for w:=1 to 2 do
          if (x[l,w]=0)and KingCanDoTurn(i,j,l,w) then
          begin
            x[l,w]:=1;
            f:=false;
          end;
      end;
   until f;
   if x[n,2]=0 then
   begin
      if kingCannotGo then
        begin writeln('queen wins');writeln('0'); end
      else
        if QueenCannotGo then
         begin writeln('king wins');writeln('1'); end
        else writeln('draw');
      done;
      halt(0);
   end;
end;

procedure solve;
var
   z: integer;
begin
  readinfo;
  Test;
  z:=king(1,1,n,2);
  if z=big then
    writeln('draw')
  else
   if z<=0 then
    begin writeln('queen wins');writeln(-z);end
   else
    begin writeln('king wins');writeln(z);end;
end;

begin
 init;
 solve;
 done;
end.
