{$I-,Q-,R-,S-}
type tarray=record
       cnt:longint;
       elem:array [1..200] of string;
     end;
     troom=record
       name:string;
       nchars,nobjs,nstuff:longint;
     end;
     tkey=record
       src,dst:longint;
       name:string;
     end;
     tchar=record
       room:longint;
       name:string;
       need,give:tarray;
     end;
     tobj=record
       room:longint;
       name:string;
       need,give:tarray;
     end;
     tstuff=record
       room:longint;
       name:string;
     end;
     ttemp=record
       len:longint;
       b:array [1..400000] of char;
     end;
var nrooms,nkeys,nchars,nobjs,nstuff,i,j,k,cur,nmy:longint;
    room:array [1..200] of troom;
    key:array [1..200] of tkey;
    chars:array [1..200] of tchar;
    obj:array [1..200] of tobj;
    stuff:array [1..200] of tstuff;
    firstroom,lastroom:string;
    was,canuse,canpick,cantalk:array [1..200] of boolean;
    cango,door:array [1..200,1..200] of boolean;
    last:array [1..200,1..200] of longint;
    inv:array [1..200] of string;
    temp:ttemp;
procedure clean(var s:string);
begin
  while s[1]=' ' do
    delete(s,1,1);
  while s[length(s)]=' ' do
    delete(s,length(s),1);
end;
procedure split(var s:ttemp;c:char;var res:tarray);
var i,j,k:longint;
begin
  res.cnt:=0;
  inc(s.len);
  s.b[s.len]:=c;
  j:=1;
  for i:=1 to s.len do
    if s.b[i]=c then
    begin
      inc(res.cnt);
{     res.elem[res.cnt]:=copy(s,j,i-j);}
      res.elem[res.cnt]:='';
      for k:=j to i-1 do
        res.elem[res.cnt]:=res.elem[res.cnt]+s.b[k];
      j:=i+1;
    end;
end;
function getroom(s:string):longint;
var i:longint;
begin
  getroom:=0;
  for i:=1 to nrooms do
    if room[i].name=s then
    begin
      getroom:=i;
      exit;
    end;
end;
procedure go(x,y:longint);
begin
  if x=y then
    exit;
  go(x,last[x,y]);
  if not door[last[x,y],y] then
  begin
    door[last[x,y],y]:=true;
    door[y,last[x,y]]:=true;
    writeln('open door to ',room[y].name);
  end;
  writeln('go to ',room[y].name);
  cur:=y;
end;
function iskey(s:string;var src,dst:longint):boolean;
var i:longint;
begin
  iskey:=false;
  for i:=1 to nkeys do
    if key[i].name=s then
    begin
      iskey:=true;
      src:=key[i].src;
      dst:=key[i].dst;
      exit;
    end;
end;
function require(s:string):boolean;
var i:longint;
begin
  require:=false;
  for i:=1 to nmy do
    if inv[i]=s then
    begin
      require:=true;
      exit;
    end;
end;
function same(a:tarray):boolean;
var i:longint;
begin
  same:=true;
  for i:=1 to a.cnt do
    same:=same and require(a.elem[i]);
end;
function outarray(a:tarray):string;
var i:longint;
    res:string;
begin
  res:='';
  for i:=1 to a.cnt-2 do
    res:=res+a.elem[i]+', ';
  if a.cnt-1>0 then
    res:=res+a.elem[a.cnt-1]+' and ';
  res:=res+a.elem[a.cnt];
  outarray:=res
end;
procedure addtoinv(a:tarray);
var i,src,dst:longint;
begin
  for i:=1 to a.cnt do
  begin
    if iskey(a.elem[i],src,dst) then
    begin
      for j:=1 to nrooms do
        if (j<>src) and (j<>dst) then begin
        if not cango[j,dst] and cango[j,src] then
        begin
          cango[j,dst]:=true;
          last[j,dst]:=src;
        end;
        if not cango[j,src] and cango[j,dst] then
        begin
          cango[j,src]:=true;
          last[j,src]:=dst;
        end;
        if not cango[dst,j] and cango[src,j] then
        begin
          cango[dst,j]:=true;
          last[dst,j]:=last[src,j];
        end;
        if not cango[src,j] and cango[dst,j] then
        begin
          cango[src,j]:=true;
          last[src,j]:=last[dst,j];
        end; end;
      cango[src,dst]:=true;
      last[src,dst]:=src;
      cango[dst,src]:=true;
      last[dst,src]:=dst;
    end
    else begin
      inc(nmy);
      inv[nmy]:=a.elem[i];
    end;
  end;
end;
function pick(x:longint):boolean;
var i,j,src,dst:longint;
begin
  pick:=false;
  for i:=1 to nstuff do
    if (canpick[i]) and (cango[cur,stuff[i].room]) then
    begin
      canpick[i]:=false;
      pick:=true;
      go(cur,stuff[i].room);
      writeln('pick ',stuff[i].name);
      if iskey(stuff[i].name,src,dst) then
      begin
        for j:=1 to nrooms do
          if (j<>src) and (j<>dst) then begin
          if not cango[j,dst] and cango[j,src] then
          begin
            cango[j,dst]:=true;
            last[j,dst]:=src;
          end;
          if not cango[j,src] and cango[j,dst] then
          begin
            cango[j,src]:=true;
            last[j,src]:=dst;
          end;
          if not cango[dst,j] and cango[src,j] then
          begin
            cango[dst,j]:=true;
            last[dst,j]:=last[src,j];
          end;
          if not cango[src,j] and cango[dst,j] then
          begin
            cango[src,j]:=true;
            last[src,j]:=last[dst,j];
          end; end;
        cango[src,dst]:=true;
        last[src,dst]:=src;
        cango[dst,src]:=true;
        last[dst,src]:=dst;
      end
      else begin
        inc(nmy);
        inv[nmy]:=stuff[i].name;
      end;
  end;
  for i:=1 to nobjs do
    if canuse[i] and (cango[cur,obj[i].room]) and (same(obj[i].need)) then
    begin
      pick:=true;
      go(cur,obj[i].room);
      canuse[i]:=false;
      writeln('use ',outarray(obj[i].need),' on ',obj[i].name);
      addtoinv(obj[i].give);
      writeln('take ',outarray(obj[i].give),' from ',obj[i].name);
    end;
  for i:=1 to nchars do
    if cantalk[i] and (cango[cur,chars[i].room]) and (same(chars[i].need)) then
    begin
      pick:=true;
      go(cur,chars[i].room);
      cantalk[i]:=false;
      writeln('talk to ',chars[i].name);
      writeln('give ',outarray(chars[i].need),' to ',chars[i].name);
      addtoinv(chars[i].give);
      writeln('take ',outarray(chars[i].give),' from ',chars[i].name);
    end;
end;
begin
  assign(input,'quest.in');
  reset(input);
  assign(output,'quest.out');
  rewrite(output);
  readln(nrooms);
  for i:=1 to nrooms do
  begin
    readln(room[i].name);
    clean(room[i].name);
  end;
  readln(nkeys);
  for i:=1 to nkeys do
  begin
    readln(key[i].src,key[i].dst,key[i].name);
    clean(key[i].name);
  end;
  nchars:=0;
  nobjs:=0;
  nstuff:=0;
  for i:=1 to nrooms do
  begin
    readln(room[i].nchars,room[i].nobjs,room[i].nstuff);
    for j:=1 to room[i].nchars do
    begin
      inc(nchars);
      chars[nchars].room:=i;
      readln(chars[nchars].name);
      clean(chars[nchars].name);
{      readln(temp);}
      temp.len:=0;
      while not eoln do
      begin
        inc(temp.len);
        read(temp.b[temp.len]);
      end;
      readln;
      split(temp,',',chars[nchars].need);
      for k:=1 to chars[nchars].need.cnt do
        clean(chars[nchars].need.elem[k]);
{      readln(temp);}
      temp.len:=0;
      while not eoln do
      begin
        inc(temp.len);
        read(temp.b[temp.len]);
      end;
      readln;
      split(temp,',',chars[nchars].give);
      for k:=1 to chars[nchars].give.cnt do
        clean(chars[nchars].give.elem[k]);
    end;
    for j:=1 to room[i].nobjs do
    begin
      inc(nobjs);
      obj[nobjs].room:=i;
      readln(obj[nobjs].name);
      clean(obj[nobjs].name);
{      readln(temp);}
      temp.len:=0;
      while not eoln do
      begin
        inc(temp.len);
        read(temp.b[temp.len]);
      end;
      readln;
      split(temp,',',obj[nobjs].need);
      for k:=1 to obj[nobjs].need.cnt do
        clean(obj[nobjs].need.elem[k]);
{      readln(temp);}
      temp.len:=0;
      while not eoln do
      begin
        inc(temp.len);
        read(temp.b[temp.len]);
      end;
      readln;
      split(temp,',',obj[nobjs].give);
      for k:=1 to obj[nobjs].give.cnt do
        clean(obj[nobjs].give.elem[k]);
    end;
    for j:=1 to room[i].nstuff do
    begin
      inc(nstuff);
      stuff[nstuff].room:=i;
      readln(stuff[nstuff].name);
      clean(stuff[nstuff].name);
    end;
  end;
  readln(firstroom);
  clean(firstroom);
  readln(lastroom);
  clean(lastroom);
  close(input);
  fillchar(was,sizeof(was),false);
  was[getroom(firstroom)]:=true;
  fillchar(cango,sizeof(cango),false);
  for i:=1 to nrooms do
    cango[i,i]:=true;
  nmy:=0;
  cur:=getroom(firstroom);
  fillchar(canpick,sizeof(canpick),true);
  fillchar(canuse,sizeof(canuse),true);
  fillchar(cantalk,sizeof(cantalk),true);
  fillchar(door,sizeof(door),false);
  for i:=1 to nrooms do
    last[i,i]:=i;
  while pick(0) do;
  if cango[cur,getroom(lastroom)] then
  begin
    go(cur,getroom(lastroom));
    writeln('save princess');
  end
  else begin rewrite(output); writeln('dead princess'); end;
  close(output);
end.
