type int = longint;
     str = string[100];
     tlist = array[0..201] of int;
     tkey = record
              x, y : int;
            end;
     tpers = record
               give, take : tlist
             end;
     troom = record
               p, o, f : tlist;
             end;
     ttpers = array[1..201] of tpers;

var n, m, k, tmp, start, finish, l : int;
    name : array[1..201] of str;
    keys : array[1..201] of tkey;
    pers, obj : ttpers;
    room : array[1..201] of troom;
    used, have : array[1..201] of int;
    ans : array[1..2000000, 1..2] of int;

procedure init;
var i, j, tt : int;
    s : str;
    c : char;
  procedure conv(var st : str);
  begin
    while st[1] = ' ' do
      if length(st) = 1 then break else delete(st, 1, 1);
    while st[length(st)] = ' ' do
      if length(st) = 1 then break else delete(st, length(st), 1);
  end;
  procedure rd_list(var v : tlist);
  var c : char;
      t : int;
  begin
    s:='';
    while not eoln do begin
      read(c);
      if c = ',' then begin
        conv(s);
        t:=1;
        while (name[t] <> s) and (t <= k) do inc(t);
        if t = k+1 then begin
          inc(k);
          name[k]:=s;
        end;
        inc(v[0]);
        v[v[0]]:=t;
        s:='';
      end else s:=s+c;
    end;
    conv(s);
    t:=1;
    while (name[t] <> s) and (t <= k) do inc(t);
    if t = k+1 then begin
      inc(k);
      name[k]:=s;
    end;
    inc(v[0]);
    v[v[0]]:=t;
    readln;
  end;
begin
  readln(n);
  for i:=1 to n do begin
    readln(name[i]);
    conv(name[i]);
  end;
  readln(m);
  for i:=1 to m do begin
    readln(keys[i+n].x, keys[i+n].y, s);
    conv(s);
    name[i+n]:=s;
  end;
  k:=m+n;
  for i:=1 to n do begin
    readln(room[i].p[0], room[i].o[0], room[i].f[0]);
    for j:=1 to room[i].p[0] do begin
      inc(k);
      readln(name[k]);
      conv(name[k]);
      tt:=k;
      room[i].p[j]:=k;
      rd_list(pers[tt].give);
      rd_list(pers[tt].take);
    end;
    for j:=1 to room[i].o[0] do begin
      inc(k);
      readln(name[k]);
      conv(name[k]);
      tt:=k;
      room[i].o[j]:=k;
      rd_list(obj[tt].give);
      rd_list(obj[tt].take);
    end;
    for tt:=1 to room[i].f[0] do begin
      readln(s);
      conv(s);
      j:=1;
      while (name[j] <> s) and (j <= k) do inc(j);
      if j > k then begin
        inc(k);
        name[k]:=s;
      end;
      room[i].f[tt]:=j;
    end;
  end;
  readln(s);
  conv(s);
  start:=1;
  while name[start] <> s do inc(start);
  readln(s);
  conv(s);
  finish:=1;
  while name[finish] <> s do inc(finish);
end;

function can(var v : tlist) : boolean;
var i : int;
begin
  for i:=1 to v[0] do
    if have[v[i]] = 0 then begin
      can:=false;
      exit;
    end;
  can:=true;
end;

procedure make(var v : tlist; m : int);
var i : int;
begin
  for i:=1 to v[0] do have[v[i]]:=m;
end;

function check(x : int) : boolean;
var i, id : int;
    r : boolean;
begin
  if used[x] > 0 then begin
    check:=true;
    exit;
  end;
  r:=true;
  if used[x] = 0 then
    for i:=1 to room[x].f[0] do begin
      id:=room[x].f[i];
      have[id]:=1;
      inc(l);
      ans[l, 1]:=3;
      ans[l, 2]:=id;
    end;
  used[x]:=tmp;
  for i:=1 to room[x].o[0] do begin
    id:=room[x].o[i];
    if used[id] = 1 then continue;
    if can(obj[id].give) then begin
      r:=false;
      used[id]:=1;
      inc(l);
      ans[l, 1]:=2;
      ans[l, 2]:=id;
      make(obj[id].take, 1);
    end else used[x]:=-tmp;
  end;
  for i:=1 to room[x].p[0] do begin
    id:=room[x].p[i];
    if used[id] = 1 then continue;
    if can(pers[id].give) then begin
      r:=false;
      used[id]:=1;
      inc(l);
      ans[l, 1]:=1;
      ans[l, 2]:=id;
      make(pers[id].give, 0);
      make(pers[id].take, 1);
    end else used[x]:=-tmp;
  end;
  check:=r;
end;

procedure wa;
var i, id : int;
  procedure out(var v : tlist);
  var j : int;
  begin
    write(name[v[1]]);
    if v[0] = 1 then exit;
    for j:=2 to v[0]-1 do
      write(', ', name[v[j]]);
    write(' and ', name[v[v[0]]]);
  end;
begin
  for i:=1 to l do begin
    id:=ans[i, 2];
    case ans[i, 1] of
    1 : begin
          writeln('talk to ', name[id]);
          write('give ');
          out(pers[id].give);
          writeln(' to ', name[id]);
          write('take ');
          out(pers[id].take);
          writeln(' from ', name[id]);
        end;
    2 : begin
          write('use ');
          out(obj[id].give);
          writeln(' on ', name[id]);
          write('take ');
          out(obj[id].take);
          writeln(' from ', name[id]);
        end;
    3 : begin
          writeln('pick ', name[id]);
        end;
    4 : begin
          writeln('open door to ', name[id]);
        end;
    5 : begin
          writeln('go to ', name[id]);
        end;
    end;
  end;
end;

procedure go(x : int);
var i, id : int;
begin
  if x = finish then begin
    assign(output, 'quest.out'); rewrite(output);
    wa;
    writeln('save princess');
    close(output);
    halt(0);
  end;
  repeat until check(x);
  if used[x] < 0 then used[x]:=-tmp else used[x]:=tmp;
  for i:=n+1 to m+n do
    if ((keys[i].x = x) or (keys[i].y = x)) and
       ((used[i] = 1) or (have[i] = 1))
    then if abs(used[keys[i].x+keys[i].y-x]) <> tmp
    then begin
      id:=keys[i].x+keys[i].y-x;
      if used[i] = 0 then begin
        inc(l);
        ans[l, 1]:=4;
        ans[l, 2]:=id;
        used[i]:=1;
      end;
      inc(l);
      ans[l, 1]:=5;
      ans[l, 2]:=id;
      go(id);
      inc(l);
      ans[l, 1]:=5;
      ans[l, 2]:=x;
    end;
end;

begin
  assign(input, 'quest.in'); reset(input);
  init;
  close(input);
  fillchar(used, sizeof(used), 0);
  fillchar(have, sizeof(have), 0);
  l:=0;
  for tmp:=1 to n do go(start);
  assign(output, 'quest.out'); rewrite(output);
  writeln('dead princess');
  close(output);
end.
