type
   int = integer;
   integer = longint;

procedure init;
begin
   assign(input, 'quest.in'); reset(input);
   assign(output, 'quest.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

var
   rooms: integer;
   rnam: array[1..8] of string;
   doors: integer;
   dkey: array[1..200] of string;
   dr: array[1..200] of record a,b : int end;
   her, obj, flo: array[1..8] of int;
   h, ob: array[1..8, 1..200] of record name, give, get: string; end;
   fl: array[1..8,1..200] of string;
   startroom, endroom: string;
   str, enr: integer;
   d:array[1..8] of boolean;
   hav: array[1..200] of string;
   hcn: integer;
   altlk, aluse: array[1..8,1..200] of boolean;
   a: array[1..8,1..8] of boolean;


procedure prstr(var x: string);
begin
   while (length(x)>0)and(x[1]=' ' ) do delete(x,1,1);
   while (length(x)>0)and(x[length(x)]=' ' ) do delete(x,length(x),1);
end;


procedure readinfo;
var
   i, j: integer;
begin
   readln(rooms);
   for i:=1 to rooms do
   begin
    readln(rnam[i]);
    prstr(rnam[i]);
   end;


   readln(doors);
   for i:=1 to doors do
   begin
    readln(dr[i].a, dr[i].b, dkey[i]);
    a[dr[i].a, dr[i].b]:=true;
    a[dr[i].b, dr[i].a]:=true;
    prstr(dkey[i]);
   end;
   for i:=1 to rooms do
   begin
      readln(her[i], obj[i], flo[i]);
      for j:=1 to her[i] do
      begin
       readln(h[i][j].name);
       readln(h[i][j].give);
       readln(h[i][j].get);
       prstr(h[i,j].name);
      end;
      for j:=1 to obj[i] do
      begin
       readln(ob[i][j].name);
       readln(ob[i][j].give);
       readln(ob[i][j].get);
       prstr(ob[i,j].name);
      end;
      for j:=1 to flo[i] do
      begin
       readln(fl[i][j]);
       prstr(fl[i,j]);
      end;
   end;

   readln(startroom);
   readln(endroom);

   prstr(startroom);
   prstr(endroom);
   for i:=1 to rooms do
    if startroom= rnam[i] then str:=i;
   for i:=1 to rooms do
    if endroom= rnam[i] then enr:=i;
end;

var cur: integer;



function stuff(s: string): boolean;
var
   i: integer;
begin
 prstr(s);
 for i:=1 to hcn do
  if hav[i]=s then
  begin
   stuff:=true;
   exit;
  end;
 stuff:=false;
end;


function haveallstuff(s: string): boolean;
var
   e: string;
   i: integer;
begin
 s:=s+',';
 repeat
//   prstr(s);
   i:=pos(',',s);
   e:=copy(s,1,i-1);
   if not stuff(e) then
    begin
    haveallstuff:=false;
    exit;
    end;
   delete(s,1,i);
 until length(s)=0;
 haveallstuff:=true;
end;


function proc(s: string): string;
var
   e,l,v: string;
   I: integer;
begin
  s:=s+',';
  v:='';
  l:='';
 repeat
//   prstr(s);
   i:=pos(',',s);
   e:=copy(s,1,i-1);
   delete(s,1,i);
   prstr(e);
   if length(v)=0 then
      v:=l else
       if length(l)>0 then
        v:=v+', '+l;
   l:=e;
 until length(s)=0;
 if length(v)>0 then
   proc:=v+' and '+l
  else
   proc:=l;
end;

procedure newstuff(s: string);
var
   e: string;
   i: integer;
begin
 s:=s+',';
 repeat
//   prstr(s);
   i:=pos(',',s);
   e:=copy(s,1,i-1);
   prstr(e);
   inc(hcn);
   hav[hcn]:=e;
   delete(s,1,i);
 until length(s)=0;
end;


procedure gotoroom(x: integer);
var
   p: array[1..8] of int;
   v: array[1..8] of word;
   i, j: integer;
   f: boolean;
begin
   if cur=x then exit;
   for i:=1 to rooms do
    v[i]:=65530;
   v[x]:=0;
   repeat
    f:=true;
    for i:=1 to rooms do
     if d[i] and (v[i]<>65530) then
     begin
      for j:=1 to rooms do
       if a[i,j] and d[j] and (v[j]>v[i]+1) then
       begin
        v[j]:=v[i]+1;
        p[j]:=i;
        f:=false;
       end;
     end;
   until f;
   i:=cur;
   while i<>x do
   begin
    j:=p[i];
    writeln('go to '+rnam[j]);
    i:=j;
   end;
   cur:=x;
end;




function SavePrincess: boolean;
begin
   if d[enr] then
   begin
    gotoroom(enr);
    writeln('save princess');
    SavePrincess:=true;
   end
   else
   SavePrincess:=false;
end;


function picall: boolean;
var
   i, j: integer;
   res: boolean;
begin
   res:=false;
   for i:=1 to rooms do
    if d[i] and(flo[i]>0) then
    begin
     gotoroom(i);
     for j:=1 to flo[i] do
     begin
      writeln('pick '+fl[i,j]);
      inc(hcn);
      hav[hcn]:=fl[i,j];
     end;
     flo[i]:=0;
     res:=true;
    end;
  picall:=res;
end;

function opendoor: boolean;
var
   i: integer;
   r: boolean;
begin
   r:=false;
   for i:=1 to doors do
   if (d[dr[i].a] xor d[dr[i].b])and(stuff(dkey[i])) then
   begin
    if d[dr[i].a] then
    begin
      gotoroom(dr[i].a);
      writeln('open door to '+rnam[dr[i].b]);
      d[dr[i].b]:=true;
    end
    else
    begin
      gotoroom(dr[i].b);
      writeln('open door to '+rnam[dr[i].a]);
      d[dr[i].a]:=true;
    end;
    r:=true;
   end;
  opendoor:=r;
end;

function useobject: boolean;
var i, j: integer;
    r: boolean;
begin
 r:=false;
 for i:=1 to rooms do
  if d[i] then
  begin
   for j:=obj[i] downto 1 do
   if not aluse[i,j] then
    if haveallstuff(ob[i,j].give) then
    begin
      gotoroom(i);
      writeln('use '+proc(ob[i,j].give)+' on '+ob[i,j].name);
      writeln('take '+proc(ob[i,j].get)+' from '+ob[i,j].name);
      newstuff(ob[i,j].get);
      aluse[i,j]:=true;
      r:=true;
    end;
  end;
 useobject:=r;
end;

function usehero: boolean;
var i, j: integer;
    r: boolean;
begin
   r:=false;
 for i:=1 to rooms do
  if d[i] then
  begin
   for j:=1 to her[i] do
   if not altlk[i,j] then
    if haveallstuff(h[i,j].give) then
    begin
      gotoroom(i);
      writeln('talk to '+h[i,j].name);
      writeln('give '+proc(h[i,j].give)+' to '+h[i,j].name);
      writeln('take '+proc(h[i,j].get)+' from '+h[i,j].name);
      newstuff(h[i,j].get);
      altlk[i,j]:=true;
      r:=true;
    end;
  end;
  usehero:=r;
end;

procedure solve;
var
   f: boolean;
begin
  readinfo;
  d[str]:=true;
  cur:=str;
  repeat
   f:=true;
   if saveprincess then break;
   f:=opendoor;
   f:=picall or f;
   f:=useobject or f;
   f:=usehero or f;
  until not f;

  if not f then
  begin
   done;
   init;
   writeln('dead princess');
  end;

end;

begin
 init;
 solve;
 done;
end.

