{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='sumcubes.in';
  outfile='sumcubes.out';
  eps=1e-10;
  mnoz = 1/3;
  km=3900000;
type
  Element = record
    x : Double;
    k : Byte;
    prev : LongInt;
  end;
var
  a : array [1..km] of Element;
  n,res : LongInt;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
end;
{}
Procedure Out(ok : Boolean);
var
  i,j : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ok then begin
    write(exp(ln(a[res].x)*mnoz):0:0,' ');
    i:=a[res].prev; j:=res;
    while i<>0 do begin
      write(exp(ln(a[i].x-a[j].x)*mnoz):0:0,' ');
      j:=i; i:=a[i].prev;
    end;
  end else writeln('IMPOSSIBLE');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
end;
{}
Procedure Solve;
var
  s,t,i,j,lo,hi : LongInt;
  b1,b2,x : Extended;
begin
  s:=1; t:=1;
  a[s].x:=n; a[s].k:=8; a[s].prev:=0;
  repeat
    b1:=ln(a[s].x); b2:=ln(a[s].k);
    lo:=trunc(exp((b1-b2)*mnoz));
    hi:=trunc(exp(b1*mnoz))+1;
    for i:=lo to hi do begin
      x:=a[s].x-i*i*i;
      if (x-eps>0) and (t<km) then begin
        inc(t);
        a[t].x:=x;
        a[t].k:=a[s].k-1;
        a[t].prev:=s;
      end else
      if abs(x)<eps then begin
        res:=s;
        Out(true);
      end;
    end;
    inc(s);
  until (s>t) or (a[t].k=0);
  Out(false);
end;
{}
Begin
  Init;
  Inp;
  Solve;
End.