{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_b;
const
  inpfile='sumtwo.in';
  outfile='sumtwo.out';
  inf=MaxLongInt;
  nm=300005;
var
  a,b : array [1..nm] of LongInt;
  n,res : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do read(a[i]);
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  for i:=1 to n do
    write(b[i],' ');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
end;
{}
Procedure Swap(var q,w : LongInt);
var
  bak : LongInt;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l,r : LongInt);
var
  i,j,x : LongInt;
begin
  i:=l; j:=r; x:=a[(l+r) div 2];
  repeat
    while a[i]<x do inc(i);
    while x<a[j] do dec(j);
    if i<=j then begin
      Swap(a[i],a[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
Procedure Solve;
var
  i,j,k,t,h : LongInt;
  sum,state : LongInt;
begin
  Sort(1,n);
  i:=0; j:=n+1;
  k:=0; t:=n+1;
  h:=0; state:=1;
  while h<n do begin
    inc(h);
    case state of
      1 : begin dec(j); inc(k); b[k]:=a[j]; state:=2; end;
      2 : begin inc(i); inc(k); b[k]:=a[i]; state:=3; end;
      3 : begin dec(j); dec(t); b[t]:=a[j]; state:=4; end;
      4 : begin inc(i); dec(t); b[t]:=a[i]; state:=1; end;
    end;
  end;

  res:=-inf;
  for i:=1 to n-1 do begin
    sum:=b[i]+b[i+1];
    if sum>res then res:=sum;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.