program Temp;
const infile = 'sumcubes.in';
      outfile = 'sumcubes.out';
      MAXC = 1260;
var N : longint;
    res : array[0..8] of longint;
    cb : array[1..MAXC] of longint;

procedure ReadData;
var i : longint;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N);
  for i:=1 to MAXC do cb[i]:=i*i*i;
end;

procedure outans(code : integer);
var i : longint;
begin
  for i:=1 to code do write(res[i], ' ');
  close(input);
  close(output);
  halt(0);
end;

function root3(i : longint) : longint;
var t : double;
    p : longint;
begin
  t:=exp(ln(i)/3); p:=trunc(t); root3:=p;
end;

function min(a, b : longint) : longint;
begin
  if a<b then min:=a else min:=b;
end;

procedure Rec(st, cur : longint);
var k, i, z : longint;
begin
  if st>8 then exit;
  k:=root3(cur); if cb[k]<>cur then z:=-1 else z:=k;
  if z<>-1 then begin res[st]:=z; outans(st); end; z:=min(res[st-1], k);
  for i:=z downto 1 do
  begin
    res[st]:=i;
    Rec(st+1, cur-cb[i]);
  end;
end;

procedure Solve;
begin
  res[0]:=10000;
  Rec(1, N);
end;

procedure WriteData;
begin
  write('IMPOSSIBLE');
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
