{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

Const MaxN=300000;
Const INPUTFILE='sumtwo.in';
      OUTPUTFILE='sumtwo.out';

Type Real=Double;

var a,b:Array[1..MaxN] of Longint;
    N:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for i:=1 to N do
  Read(a[i]);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writeln(Answer);
for i:=1 to N do
  Write(b[i],' ');
Close(Output);
Halt;
end;

Procedure QSort(L,R:Longint);
var i,j,t,x:Longint;
begin
i:=L;
j:=R;
x:=a[(i+j) div 2];
Repeat
  While a[i]>x Do Inc(i);
  While a[j]<x Do Dec(j);
  if i<=j then
  begin
    t:=a[i];
    a[i]:=a[j];
    a[j]:=t;

    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if L<j then QSort(L,j);
end;

Procedure Sort;
var h:Longint;
begin
h:=0;
for i:=1 to N do
begin
  Inc(h,a[i]);
  h:=h mod 1000000000;
end;
Inc(h,N);
RandSeed:=h;
for i:=N downto 1 do
begin
  j:=Random(i)+1;
  h:=a[i];
  a[i]:=a[j];
  a[j]:=h;
end;
QSort(1,N);
end;

Procedure Solve;
var g,h:Longint;
begin
Sort;
j:=1;
for i:=1 to N div 2 do
begin
  b[j]:=a[i];
  Inc(j);
  b[j]:=a[N-i+1];
  Inc(j);
end;
if Odd(N) then b[N]:=a[N div 2 + 1];
g:=-2100000000;
for i:=1 to N-1 do
  if b[i]+b[i+1]>g then
    g:=b[i]+b[i+1];
FWrite(g);
end;

begin
FRead;
Solve;
end.