const
     FileIn='sumtwo.in';
     FileOut='sumtwo.out';
     MaxN=239017;
var
   N: LongInt;
   Items, Answer: array [1..MaxN] of LongInt;
   AnswerValue: LongInt;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=1 to N
         do Read (F, Items [NItem]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, AnswerValue);
     for NItem:=1 to N-1
         do Write (F, Answer [NItem], #32);
     Writeln (F, Answer [N]);
     Close (F);
end;

procedure Swap (var aA, aB: LongInt);
var
   Temp: LongInt;
begin
     Temp:=aA;
     aA:=aB;
     aB:=Temp;
end;

procedure QuickSort (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   Middle: LongInt;
begin
     i:=aLeft;
     j:=aRight;
     Middle:=Items [(aLeft+aRight) div 2];

     repeat
           while Items [i]<Middle
                 do Inc (i);
           while Middle<Items [j]
                 do Dec (j);
           if i<=j
              then begin
                   Swap (Items [i], Items [j]);
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QuickSort (aLeft, j);
     if i<aRight
        then QuickSort (i, aRight);
end;

procedure MakeAnswer;
var
   Left, Right, Index: LongInt;
   Value: LongInt;
begin
     Left:=1;
     Right:=N;
     Index:=1;
     while Index<=N
           do begin
              Answer [Index]:=Items [Right];
              Inc (Index);
              Dec (Right);
              if Index<=N
                 then begin
                      Answer [Index]:=Items [Left];
                      Inc (Index);
                      Inc (Left);
                 end;
           end;
     AnswerValue:=Answer [1]+Answer [2];
     for Index:=2 to N-1
         do begin
            Value:=Answer [Index]+Answer [Index+1];
            if Value>AnswerValue
               then AnswerValue:=Value;
         end;
end;

procedure Solve;
begin
     QuickSort (1, N);
     MakeAnswer;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
