
const
   maxn = 239017;
type
   integer = longint;
   tar = array [1.. maxn] of Longint;
var
   a, b: tar;
   n: longint;
   max: longint;

procedure init;
var
   i: longint;
begin
   assign(input, 'sumtwo.in'); reset(input);
   assign(output, 'sumtwo.out'); rewrite(output);

   readln(n);
   for i:= 1 to n do
      read(a[i]);
end;

procedure radixsort;
   procedure sq(sh: integer);
   var
      c:array[byte]of integer;
      i,j: integer;
   begin
      fillchar(c, sizeof(c), 0);
      for i:= 1 to n do
       inc(c[(a[i] shr sh)and 255]);
      for i:= 1 to 255 do
       c[i]:= c[i] + c[i-1];
      for i:=n downto 1 do
      begin
       j:=(a[i] shr sh)and 255;
       b[c[j]]:=a[i];
       dec(c[j]);
      end;

      {a:=b;}
      move(b, a, sizeof(longint)*n);

   end;


begin
   sq(0);
   sq(8);
   sq(16);
   sq(24);
end;


procedure sort;
    procedure qsort(l,r: longint);
      var
         i,j,x,y: longint;
      begin
         i:=l;
         j:=r;
         x:=a[(l+r) div 2];
         repeat
           while a[i]<x do
            inc(i);
           while x<a[j] do
            dec(j);
           if not(i>j) then
             begin
                y:=a[i];
                a[i]:=a[j];
                a[j]:=y;
                inc(i);
                dec(j);
             end;
         until i>j;
         if l<j then
           qsort(l,j);
         if i<r then
           qsort(i,r);
      end;

begin
   qsort(1, n);
end;

procedure fillb;
var
   i, r, l: longint;
begin
   i := 1;
   r := n;
   l := 1;
   while i<= n do
   begin
     b[i] := a[r];
     inc(i);
     dec(r);
     if i<= n then
      begin
        b[i] := a[l];
        inc(i);
        inc(l);
      end;
   end;
end;

procedure foundmax;
var
   i, k: longint;
begin
   max := b[1] + b[2];
   for i := 2 to n - 1 do
   begin
      k := b[i] + b[i+1];
      if k > max then
       max := k;
   end;
end;

procedure writeres;
var
   i: longint;
begin
   writeln (max);
   for i:= 1 to n do
    write(b[i],' ');
   writeln;
end;

procedure solve;
begin
{   sort;}
   radixsort;
   fillb;
   foundmax;
   writeres;
end;

procedure done;
begin
   close(input);
   close(output);
end;

begin
   init;
   solve;
   done;
end.

