{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='dist.in';
  outfile='dist.out';
  nul=chr(ord('A')-1);
  inf=100;
type
  Flags = array ['A'..'Z'] of Boolean;
var
  a : array ['A'..'Z','A'..'Z'] of Byte;
  u : array ['A'..'Z'] of Boolean;
  st : String;
  root : Char;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  readln(st);
end;
{}
Procedure Out;
var
  i : Char;
begin
  assign(output,outfile);
  rewrite(output);
  for i:='A' to 'Z' do
    if u[i] then
      writeln(i,' ',a[i,root]);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(u,sizeof(u),0);
end;
{}
Procedure Tree(l,r : LongInt; var root : Char); forward;
{}
Procedure List(l,r : LongInt; var f : Flags);
var
  i,level : LongInt;
  ok : Boolean;
  rt : Char;
begin
  fillchar(f,sizeof(f),0);
  i:=l-1; level:=0; ok:=false;
  while i<r do begin
    inc(i);
    case st[i] of
      '(' : inc(level);
      ')' : dec(level);
      ',' : if level=0 then begin
              ok:=true;
              Tree(l,i-1,rt);
              List(i+1,r,f);
              f[rt]:=true;
              break;
            end;
    end;
  end;
  if not ok then begin
    Tree(l,r,rt);
    f[rt]:=true;
  end;
end;
{}
Procedure Forest(l,r : LongInt; var f : Flags);
var
  i,level : LongInt;
  rt : Char;
begin
  fillchar(f,sizeof(f),0);
  i:=l-1; level:=0;
  while i<r do begin
    inc(i);
    case st[i] of
      '(' : inc(level);
      ')' : dec(level);
    end;
    if (level=0) and ((i<>r) or (st[i]<>')')) then begin
      Tree(l,r,rt);
      f[rt]:=true;
      exit;
    end;
  end;
  List(l+1,r-1,f);
end;
{}
Procedure Tree(l,r : LongInt; var root : Char);
var
  i,level : LongInt;
  ok : Boolean;
  f : Flags;
  ch : Char;
begin
  root:=nul;
  if l=r then begin
    root:=st[l];
    u[st[l]]:=true;
  end else begin
    i:=l-1; ok:=false; level:=0;
    while i<r do begin
      inc(i);
      case st[i] of
        '(' : inc(level);
        ')' : dec(level);
        '-' : begin
                if level=0 then begin
                  Tree(l,i-1,root);
                  Forest(i+2,r,f);
                  for ch:='A' to 'Z' do
                    if f[ch] then begin
                      a[root,ch]:=1;
                      a[ch,root]:=1;
                    end;
                  ok:=true; break;
                end;
              end;
      end;
    end;
    if not ok then Tree(l+1,r-1,root);
  end;
end;
{}
Procedure Solve;
var
  i,j,k : Char;
begin
  for i:='A' to 'Z' do
    for j:='A' to 'Z' do a[i,j]:=inf;
  for i:='A' to 'Z' do a[i,i]:=0;
  Tree(1,length(st),root);
  for k:='A' to 'Z' do
    for i:='A' to 'Z' do
      for j:='A' to 'Z' do
        if a[i,j]>a[i,k]+a[j,k] then a[i,j]:=a[i,k]+a[k,j];
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.