{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
uses
  crt;

const
  problem='dist';
  fin =problem+'.in';
  fout=problem+'.out';
  chars=['A'..'Z'];
  a='A';
  z='Z';

type
  bbb=array['A'..'Z']of byte;
  tlex=(_op,_cl,_ch,_arr,_com);

var
  i,j,l,n,m,cpos:longint;
  val:char;
  clex:tlex;
  ii,jj,c,k:char;
  a1:array['A'..'Z','A'..'Z']of byte;
  b:bbb;
  s:string;

procedure init;
begin
  assign(input,fin);
  reset(input);

    readln(s);
    n:=length(s);

  close(input);
end;

procedure next;
begin
  if s[cpos] in chars then begin
    val:=s[cpos];
    clex:=_ch;
    inc(cpos);
    exit;
  end;
  if s[cpos]='(' then begin
    clex:=_op;
    inc(cpos);
    exit;
  end;
  if s[cpos]=')' then begin
    clex:=_cl;
    inc(cpos);
    exit;
  end;
  if s[cpos]='-' then begin
    clex:=_arr;
    inc(cpos,2);
    exit;
  end;
  if s[cpos]=',' then begin
    clex:=_com;
    inc(cpos);
    exit;
  end;
end;

function expr:char;
var
  cch,t1:char;
begin
  fillchar(b,sizeof(b),0);
  repeat
    next;
    if clex=_com then
      exit;
    if clex=_ch then begin
      cch:=val;
      expr:=cch;
    end;
    if clex=_cl then
      exit;
    if clex=_op then begin
      cch:=expr;
      expr:=cch;
    end;
    if clex=_arr then begin
      next;
      if clex=_ch then begin
        a1[cch,val]:=1;
        a1[val,cch]:=1;
        cch:=val;
      end;
      if clex=_op then
        while clex<>_cl do begin
          t1:=expr;
          a1[t1,cch]:=1;
          a1[cch,t1]:=1;
          cch:=t1;
        end;
    end;
    if cpos>n then
      exit;
  until false or keypressed;
end;

procedure solve;
begin
  fillchar(a1,sizeof(a1),255);
  cpos:=1;
  c:=expr;
  for ii:=a to z do
    a1[ii,ii]:=0;
  for k:=a to z do
    for ii:=a to z do
      for jj:=a to z do
        if a1[ii,jj]>a1[ii,k]+a1[k,jj] then
          a1[ii,jj]:=a1[ii,k]+a1[k,jj];
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    for ii:=a to z do begin
      if a1[c,ii]<255 then
        writeln(ii,' ',a1[c,ii]);
    end;

  close(output);
end;

begin
  init;
  solve;
  done;
end.