{$I-,Q-,R-,S-}

const
  coutfile = 'dist.out';
  cinfile = 'dist.in';

type
  int = longint;
  real = extended;

  bol = array ['A'..'Z'] of boolean;

var
  n, k, m : int;
  ans : int;

  r : int;
  s : string;

  g : array ['A'..'Z','A'..'Z'] of boolean;
  u : array ['A'..'Z'] of boolean;
  d : array ['A'..'Z'] of int;

procedure outdata;
var
  i, j : int;
  c : char;
begin
  for c:= 'A' to 'Z' do
    if u[c] then writeln(c,' ',d[c]);
  writeln;
end;

function go(var l : bol) : char;
var
  lc : bol;
  i, c : char;
begin
  fillchar(l,sizeof(l),0);
  if s[r] in ['A'..'Z'] then
  begin
    l[s[r]]:= true;
    go:= s[r];
    inc(r);
    exit;
  end;
  if s[r] = '(' then
  begin
    inc(r);
    c:= go(l);
    while s[r] = ',' do
    begin
      inc(r);
      i:= go(lc);
      for i:= 'A' to 'Z' do l[i]:= l[i] or lc[i];
    end;
    inc(r);
  end;
end;

function find(var l : bol) : char;
var
  i, c, nx : char;
  lx : bol;

  function go(var l : bol) : char;
  var
    lc : bol;
    i, c : char;
  begin
    fillchar(l,sizeof(l),0);
    if s[r] in ['A'..'Z'] then
    begin
      l[s[r]]:= true;
      go:= s[r];
      inc(r);
      exit;
    end;
    if s[r] = '(' then
    begin
      inc(r);
      go:= find(l);
      inc(r);
    end;
  end;

begin
  c:= go(l);
  find:= c;
  while s[r] = '-' do
  begin
    inc(r,2);
    nx:= go(lx);
    for i:= 'A' to 'Z' do
    begin
      g[c,i]:= g[c,i] or lx[i];
      g[i,c]:= g[c,i];
    end;
    c:= nx;
  end;
  while s[r] = ',' do
  begin
    inc(r);
    nx:= find(lx);
    for i:= 'A' to 'Z' do l[i]:= l[i] or lx[i];
    c:= nx;
  end;
end;

procedure solve;
var
  i, j : int;
  c, cr : char;
  min : int;
  b : bol;
begin
  fillchar(g,sizeof(g),0);
  r:= 1;
  cr:= find(b);
  fillchar(u,sizeof(u),0);
  for c:= 'A' to 'Z' do d[c]:= 10000;
  d[cr]:= 0;
  while true do
  begin
    min:= 10000;
    cr:= 'a';
    for c:= 'A' to 'Z' do
      if not u[c] and (min > d[c]) then
      begin
        min:= d[c];
        cr:= c;
      end;
    if cr = 'a' then break;
    u[cr]:= true;
    for c:= 'A' to 'Z' do
      if not u[c] and g[cr,c] and (d[c] > d[cr] + 1) then d[c]:= d[cr] + 1;
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  readln(s);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
