{$I-,Q-,R-,S-}
type
  PTree=^TTree;
  PForest=^TForest;
  TForest=record
    t:PTree;
    next:PForest;
  end;
  TTree=record
    n:char;
    c:PForest;
  end;

var
  u,b:array['A'..'Z'] of boolean;
  s:ansistring;
  i:integer;
  a:array['A'..'Z','A'..'Z'] of boolean;
  t:Ptree;
  c,d:char;
  tm:array['A'..'['] of byte;

function tree:PTree; forward;

function forest:PForest;
var
  f,f1:Pforest;
begin
  f:=nil;
  if s[i]='(' then begin
    inc(i);
    new(f1);
    f1^.t:=tree();
    f1^.next:=nil;
    f1^.next:=f;
    f:=f1;
    while s[i]=',' do begin
      inc(i);
      new(f1);
      f1^.t:=tree();
      f1^.next:=nil;
      f1^.next:=f;
      f:=f1;
    end;
    inc(i);
  end else begin
    new(f);
    f^.next:=nil;
    f^.t:=tree();
  end;
  forest:=f;
end;

function tree:PTree;
var
  t:ptree;
  f:pforest;
begin
  if s[i]='(' then begin
    inc(i);
    t:=tree();
    inc(i);
  end else begin
    new(t);
    t^.n:=s[i];
    u[s[i]]:=true;
    t^.c:=nil;
    inc(i);
  end;
  if s[i]='-' then begin
    inc(i);
    inc(i);
    if t^.c=nil then
      t^.c:=forest()
    else begin
      f:=t^.c;
      while f^.next<>nil do begin
        f:=f^.next;
      end;
      f^.next:=forest();
    end;
  end;
  tree:=t;
end;

procedure add(c1,c2:char);
begin
  a[c1,c2]:=true;
  a[c2,c1]:=true;
end;

procedure dfs(t:PTree);
var
  f:pforest;

begin
  f:=t^.c;
  while f<>nil do begin
    add(t^.n,f^.t^.n);
    dfs(f^.t);
    f:=f^.next;
  end;
end;

begin
  assign(input,'dist.in');
  reset(input);
  assign(output,'dist.out');
  rewrite(output);
  readln(s);
  i:=1;
  s:=s+'!';
  fillchar(u,sizeof(u),false);
  t:=tree;
  fillchar(a,sizeof(a),false);
  dfs(t);
  fillchar(b,sizeof(b),false);
  fillchar(tm,sizeof(tm),255);
  tm[t^.n]:=0;

  while true do begin
    c:='[';
    for d:='A' to 'Z' do begin
      if ((u[d]) and (not b[d])) and ((c='[') or (tm[c]>tm[d])) then
        c:=d;
    end;
    if c='[' then
      break;
    b[c]:=true;
    for d:='A' to 'Z' do begin
      if (a[c,d]) and (tm[d]>tm[c]+1) then
        tm[d]:=tm[c]+1;
    end;
  end;
  for c:='A' to 'Z' do begin
    if u[c] then
      writeln(c,' ',tm[c]);
  end;
  close(input);
  close(output);
end.
