type
   integer = longint;


var
   s: string;


procedure init;
var
   i: integer;
begin
   assign(input, 'dist.in'); reset(input);
   assign(output, 'dist.out'); rewrite(output);
   readln(s);
   for i:= 1 to length(s) do
    s[i]:= upcase(s[i]);
end;

procedure done;
begin
   close(input);
   close(output);
end;

type
   let='A'..'Z';


   ptree=^ttree;
   ttree=record
         parent: ptree;
         childcnt: integer;
         ch:array[let] of ptree;
         end;
   tlex=char;



var
   l: array[1..200]of tlex;
   lx: integer;
   a: array[let,let] of boolean;
   st: array[char] of boolean;
   stk: array[1..200]of tlex;
   cnt: integer;
   d: array[let] of word;

function islet(v:char):boolean;
begin
   islet:=(v>='A')and(v<='Z')
end;

procedure pushlex(v:char);
begin
   if v=' ' then exit;
   inc(lx);
   l[lx]:= v;
   if (v>='A')and(v<='Z') then st[v]:=true;
end;

procedure convlex;
var i: integer;
begin
   i:= 1;
   while i<=length(s) do
   begin
      if s[i]='-' then
       begin pushlex('-');inc(i); end
       else
       pushlex(s[i]);
      inc(i);
   end;
end;



procedure con(x, y: char);
begin
   if (islet(x) and islet(y) )then
   begin
      a[x, y]:= true;
      a[y, x]:= true;
   end;
end;

function up: char;
begin
   if cnt=0 then up:=#0 else
   up:= stk[cnt];
end;

function pop: char;
begin
   pop:= stk[cnt];
   dec(cnt);
end;

procedure push(v: char);
begin
   inc(cnt);
   stk[cnt]:= v;
end;

procedure popskb;
var
   prev: char;
begin
  while up<>'(' do
  begin
    prev:=pop;
  end;
  pop;
  push(prev);
end;

procedure popzpt;
begin
   while up<>'(' do pop;
end;

function uplet:char;
var
   i: integer;
begin
   for i:= cnt downto 1 do
    if islet(stk[i]) then
    begin
      uplet := stk[i];
      exit;
    end;
   uplet:=#0;
end;

procedure slv;
var
   i: integer;
begin
   for i:= 1 to lx do
   begin

     if islet(l[i]) then
     begin
      if up='-' then
      begin
        pop;
        con(up,l[i]);
      end
      else
      con(uplet,l[i]);


      push(l[i]);
     end;


     if l[i]='(' then
      push(l[i]);

     if l[i]=')' then
      popskb;

     if l[i]=',' then
      popzpt;

     if l[i]='-' then
      push(l[i]);

   end;
end;

function findfirst: char;
var i: integer;
begin
   i:=1;
   while not islet(s[i])  do inc(i);
   findfirst:= s[i];
end;

procedure calc(STart: char);
var
   i: integer;
   c, h: char;
   f: boolean;
   nl: integer;
begin
   for c:= 'A' to 'Z' do
    d[c]:=65535;
   d[start]:=0;

   repeat
     f:=true;
     for c:= 'A' to 'Z' do
      if st[c] then
       for h:='A' to 'Z' do
        if st[h] then
         if a[c, h] then
         begin
           nl:= d[c] + 1;
           if d[h] > nl then
           begin
            d[h]:= nl;
            f:= false;
           end;
         end;

   until f;
end;

procedure wri;
var
   c: char;
begin
   for c:='A' to 'Z' do
    if st[c] then
     writeln(C,' ',d[c]);
end;

procedure solve;
begin
   convlex;
   cnt:=0;
   slv;
   calc(findfirst);
   wri;
end;

begin
   init;
   solve;
   done;
end.


