program Temp;
const infile = 'horse.in';
      outfile = 'horse.out';
      inf = MAXINT;
      MAXN = 10000;
var M, N, p, q, x1, y1, x2, y2 : integer;
    d, fr : array[1..MAXN] of integer;

function inside(x, y : integer) : boolean;
begin
  if (0<x)and(0<y)and(x<=M)and(y<=M) then inside:=true else inside:=false;
end;

function f1(x, y : integer) : integer;
begin
  f1:=(y-1)*M+x;
end;

procedure f2(v : integer; var x, y : integer);
begin
  x:=(v-1) mod M+1; y:=(v-1) div M + 1;
end;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(M, N, P, Q, x1, y1, x2, y2);
end;

procedure BFS(a : integer);
var Qu : array[1..MAXN] of integer;
    Ql, Qr, Cur : integer;
    x, y : integer;

procedure Relax(x1, y1, x2, y2 : integer);
begin
  if inside(x2, y2) and (d[f1(x2, y2)]=inf) then
  begin
    d[f1(x2, y2)]:=d[f1(x1, y1)]+1;
    fr[f1(x2, y2)]:=f1(x1, y1);
    inc(Qr); Qu[Qr]:=f1(x2, y2);
  end;
end;

begin
  d[a]:=0; Ql:=1; Qr:=1; Qu[1]:=a;
  while Qr>=Ql do
  begin
    Cur:=Qu[Ql]; inc(Ql); f2(Cur, x, y);
    Relax(x, y, x+p, y+q);
    Relax(x, y, x+p, y-q);
    Relax(x, y, x-p, y+q);
    Relax(x, y, x-p, y-q);
    Relax(x, y, x+q, y+p);
    Relax(x, y, x+q, y-p);
    Relax(x, y, x-q, y+p);
    Relax(x, y, x-q, y-p);
  end;
end;

procedure Solve;
var i, j, c : integer;
    w : array[1..MAXN] of integer;
begin
  for i:=1 to N do
    for j:=1 to M do d[f1(j, i)]:=inf;
  BFS(f1(x1, y1));
  if d[f1(x2, y2)]=inf then write(-1) else
  begin
    writeln(d[f1(x2, y2)]); w[d[f1(x2, y2)]+1]:=f1(x2, y2); c:=fr[f1(x2, y2)];
    for i:=d[f1(x2, y2)] downto 1 do
    begin
      w[i]:=c;
      c:=fr[c];
    end;
    for i:=1 to d[f1(x2, y2)]+1 do
    begin
      f2(w[i], j, c);
      writeln(j, ' ', c);
    end;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
