{$I-,Q-,R-,S-}

const
  coutfile = 'horse.out';
  cinfile = 'horse.in';

  nmax = 111;

type
  int = longint;
  real = extended;

var
  n, k, m : int;
  ans : int;

  u : array [0..nmax,0..nmax] of boolean;
  p : array [0..nmax,0..nmax,1..2] of int;

  h, t : int;
  q : array [1..nmax*nmax,1..2] of int;

  sx, sy, fx, fy : int;

  dx, dy : int;

procedure out(x, y : int);
begin
  if x = -1 then
  begin
    writeln(ans-1);
    exit;
  end;
  inc(ans);
  out(p[x,y,1],p[x,y,2]);
  writeln(x,' ',y);
end;

procedure outdata;
var
  i, j : int;
begin
  ans:= 0;
  if not u[fx,fy] then writeln(-1) else out(fx,fy);
end;

procedure solve;
var
  i, j : int;
  cx, cy, e : int;
begin
  h:= 1;
  t:= 1;
  q[1,1]:= sx; q[1,2]:= sy;
  fillchar(p,sizeof(p),255);
  fillchar(u,sizeof(u),0);
  u[sx,sy]:=true;
  while (h <= t) do
  begin
    cx:= q[h,1];
    cy:= q[h,2];
    inc(h);
    for i:= -1 to 1 do
      for j:= -1 to 1 do
        if abs(i) + abs(j) = 2 then
          if (cx - i*dx <= n) and (cy -j*dy <= m) and
            (cx - i*dx > 0) and (cy -j*dy > 0)
          and not u[cx-i*dx,cy-j*dy] then
          begin
            u[cx-i*dx,cy-j*dy]:= true;
            p[cx-i*dx,cy-j*dy,1]:= cx;
            p[cx-i*dx,cy-j*dy,2]:= cy;
            inc(t);
            q[t,1]:= cx-i*dx;
            q[t,2]:= cy-j*dy;
          end;
    e:= dx;
    dx:= dy;
    dy:= e;
    for i:= -1 to 1 do
      for j:= -1 to 1 do
        if abs(i) + abs(j) = 2 then
          if (cx - i*dx <= n) and (cy -j*dy <= m) and
            (cx - i*dx > 0) and (cy -j*dy > 0)
          and not u[cx-i*dx,cy-j*dy] then
          begin
            u[cx-i*dx,cy-j*dy]:= true;
            p[cx-i*dx,cy-j*dy,1]:= cx;
            p[cx-i*dx,cy-j*dy,2]:= cy;
            inc(t);
            q[t,1]:= cx-i*dx;
            q[t,2]:= cy-j*dy;
          end;
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n,m);
  read(dx,dy);
  read(sx,sy,fx,fy);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
