{$I-,Q+,R+,S-}

const
  coutfile = 'lcm.out';
  cinfile = 'lcm.in';

  dig = 4;
  base = 10000;

type
  int = longint;
  real = extended;

  thuge = array [0..1000] of int;

var
  n, k, m : int;
  ans : thuge;

  p : array [0..1000] of int;
  c : array [0..1000] of int;

procedure writehuge(var a : thuge);
var
  i, j : int;
  s : string[dig];
begin
  write(a[a[0]]);
  for i:= a[0]-1 downto 1 do
  begin
    str(a[i],s);
    for j:= length(s) to dig-1 do write('0');
    write(s);
  end;
  writeln;
end;

procedure mulint(var a : thuge; b : int);
var
  r, i : int;
begin
  r:= 0;
  for i:=1  to a[0] do
  begin
    a[i]:= a[i]*b + r;
    r:= a[i] div base;
    a[i]:= a[i] - r*base;
  end;
  while r <> 0 do
  begin
    inc(a[0]);
    a[a[0]]:= r mod base;
    r:= r div base;
  end;
end;

procedure outdata;
var
  i, j : int;
begin
  writehuge(ans);
end;

procedure solve;
var
  i, j, cur : int;
  ok : boolean;
begin
  p[0]:= 0;
  for i:= 2 to 1000 do
  begin
    ok:= true;
    for j:= 1 to p[0] do
      if p[j]*p[j] > i then break else ok:= ok and (i mod p[j] <> 0);
    if ok then
    begin
      inc(p[0]);
      p[p[0]]:= i;
    end;
  end;
  for i:= 1 to p[0] do
  begin
    j:= p[i];
    while j <= n do
    begin
      inc(c[i]);
      j:= j*p[i];
    end;
  end;
  fillchar(ans,sizeof(ans),0);
  ans[0]:= 1;
  ans[1]:= 1;
  for i:= 1 to p[0] do
    for j:= 1 to c[i] do mulint(ans,p[i]);
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.