{$I-,Q-,R-,S-}

const
  coutfile = 'string.out';
  cinfile = 'string.in';

  dig = 4;
  base = 10000;

  nmax = 50;

type
  int = longint;
  real = extended;

  thuge = array [0..15] of int;

var
  n, k, m : int;
  ans : thuge;

  s : string;

  b, no : array [#0..#255] of int;
  c, fs : array [1..nmax] of int;
  fac : array [0..nmax] of thuge;

procedure writehuge(var a : thuge);
var
  i, j : int;
  s : string[dig];
begin
  write(a[a[0]]);
  for i:= a[0]-1 downto 1 do
  begin
    str(a[i],s);
    for j:= length(s) to dig-1 do write('0');
    write(s);
  end;
  writeln;
end;

procedure addhuge(var a, b : thuge);
var
  r, i : int;
begin
  r:= 0;
  if a[0] < b[0] then a[0]:= b[0];
  for i:=1  to a[0] do
  begin
    a[i]:= a[i] + b[i] + r;
    r:= a[i] div base;
    a[i]:= a[i] - r*base;
  end;
  while r <> 0 do
  begin
    inc(a[0]);
    a[a[0]]:= r mod base;
    r:= r div base;
  end;
end;

procedure mulint(var a : thuge; b : int);
var
  r, i : int;
begin
  r:= 0;
  for i:= 1 to a[0] do
  begin
    a[i]:= a[i]*b + r;
    r:= a[i] div base;
    a[i]:= a[i] - r*base;
  end;
  while r <> 0 do
  begin
    inc(a[0]);
    a[a[0]]:= r mod base;
    r:= r div base;
  end;
end;

procedure divint(var a : thuge; b : int);
var
  i, r : int;
begin
  r:= 0;
  for i:= a[0] downto 1 do
  begin
    r:= r*base + a[i];
    a[i]:= r div b;
    r:= r mod b;
  end;
  while (a[0] > 1) and (a[a[0]] = 0) do dec(a[0]);
end;

procedure int2huge(var a : thuge; b : int);
begin
  fillchar(a,sizeof(a),0);
  a[0]:= 1; a[1]:= b;
end;

procedure outdata;
var
  i, j : int;
begin
  writehuge(ans);
end;

procedure solve;
var
  i, j, r, q : int;
  ch : char;
  cur : thuge;
  kol : int;
begin
  n:= length(s);
  fillchar(b,sizeof(b),0);
  fillchar(no,sizeof(no),0);
  k:= 0;
  for i:= 1 to length(s) do inc(b[s[i]]);
  for ch:= #0 to #255 do
    if b[ch] <> 0 then
    begin
      inc(k);
      c[k]:= b[ch];
      no[ch]:= k;
    end;
  for i:= 1 to n do fs[i]:= no[s[i]];
  int2huge(ans,1);
  int2huge(fac[0],1);
  for i:= 1 to n do
  begin
    fac[i]:= fac[i-1];
    mulint(fac[i],i);
  end;
  for i:= 1 to n do
  begin
    cur:= fac[n-i];
    for j:= 1 to fs[i]-1 do
    if c[j] <> 0 then
      begin
        for r:= 1 to k do
        begin
          kol:= c[r];
          if r = j then dec(kol);
          for q:= 2 to kol do
            divint(cur,q);
        end;
        addhuge(ans,cur);
      end;
    dec(c[fs[i]]);
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  readln(s);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.