{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 16384,0,655360}

Const MaxN=1100;
      MaxP=500;
      MaxL=1000;

Const INPUTFILE='lcm.in';
      OUTPUTFILE='lcm.out';

Type Real=Double;
     TLong=record
     Len:Integer;
     Num:Array[1..MaxL] of Shortint;
     end;

var a:Array[1..MaxN] of Longint;
    pr:Array[1..MaxP] of Integer;
    lcm:Array[1..MaxP] of Byte;

    P:Longint;
    N:Longint;
    Ans:TLong;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
for i:=Ans.Len downto 1 do
  Write(Ans.Num[i]);
Close(Output);
Halt;
end;

Procedure CountPrimes;
var i,j,f:Longint;
begin
P:=1;
pr[1]:=2;
i:=3;
While i<=N Do
begin
  j:=1;
  f:=1;
  While (j<=P) AND (Sqr(pr[j])<=i) Do
  begin
    if i mod pr[j] = 0 then
    begin
      f:=0;
      Break;
    end;
    Inc(j);
  end;
  if f=1 then
  begin
    Inc(P);
    pr[P]:=i;
  end;
  Inc(i,2);
end;
end;

Procedure MulLong(var a,b,Res:TLong);
var i,j,t:Longint;
begin
FillChar(Res,SizeOf(Res),0);
for i:=1 to a.Len do
for j:=1 to b.Len do
begin
  t:=a.Num[i]*b.Num[j]+Res.Num[i+j-1];
  Res.Num[i+j-1]:=t mod 10;
  Inc(Res.Num[i+j],t div 10);
end;
Res.Len:=a.Len+b.Len;
While (Res.Len>1) AND (Res.Num[Res.Len]=0) Do Dec(Res.Len);
end;

Procedure ToLong(var a:TLong;v:Longint);
begin
FillChar(a,SizeOf(a),0);
if v=0 then
  a.Len:=1
else
begin
  While v>0 Do
  begin
    Inc(a.Len);
    a.Num[a.Len]:=v mod 10;
    v:=v div 10;
  end;
end;
end;

var t1,t2:TLong;

Procedure Solve;
var g,h,m:Longint;
begin
CountPrimes;
FillChar(lcm,SizeOf(lcm),0);
for j:=1 to P do
begin
  m:=0;
  for i:=1 to N do
  begin
    g:=0;
    h:=i;
    While h mod pr[j] = 0 Do
    begin
      Inc(g);
      h:=h div pr[j];
    end;
    if g>m then m:=g;
  end;
  lcm[j]:=m;
end;

ToLong(Ans,1);
for j:=1 to P do
begin
  ToLong(t1,pr[j]);
  for i:=1 to lcm[j] do
  begin
    MulLong(Ans,t1,t2);
    Ans:=t2;
  end;
end;
FWrite(1543);
end;

begin
FRead;
Solve;
end.