{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 16384,0,655360}

Const MaxN=40;
      MaxL=100;
      MaxP=20;

Const INPUTFILE='string.in';
      OUTPUTFILE='string.out';

Type Real=Double;
     TLong=record
     Len:Integer;
     Num:Array[1..MaxL] of Shortint;
     end;

var a:Array['a'..'z'] of Byte;
    pr:Array[1..MaxP] of Integer;

    s:String;
    N,L,P:Longint;
    Ans:TLong;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Readln(s);
Close(Input);
end;

Procedure Writelong(var A:TLong);
var i:Longint;
begin
for i:=A.Len downto 1 do
  Write(A.Num[i]);
Writeln;
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writelong(Ans);
Close(Output);
Halt;
end;

Procedure CountPrimes;
var i,j,f:Longint;
begin
P:=1;
pr[1]:=2;
i:=3;
While P<MaxP Do
begin
  j:=1;
  f:=1;
  While (j<=P) AND (Sqr(pr[j])<=i) Do
  begin
    if i mod pr[j] = 0 then
    begin
      f:=0;
      Break;
    end;
    Inc(j);
  end;
  if f=1 then
  begin
    Inc(P);
    pr[P]:=i;
  end;
  Inc(i,2);
end;
end;

Procedure MulLong(var a,b,Res:TLong);
var i,j,t:Longint;
begin
FillChar(Res,SizeOf(Res),0);
for i:=1 to a.Len do
for j:=1 to b.Len do
begin
  t:=a.Num[i]*b.Num[j]+Res.Num[i+j-1];
  Res.Num[i+j-1]:=t mod 10;
  Inc(Res.Num[i+j],t div 10);
end;
Res.Len:=a.Len+b.Len;
While (Res.Len>1) AND (Res.Num[Res.Len]=0) Do Dec(Res.Len);
end;

Procedure IncLong(var A,B:TLong);
var i,j,L:Longint;
begin
L:=a.Len;
if b.Len>L then L:=b.Len;
for i:=1 to L do
begin
  Inc(a.Num[i],b.Num[i]);
  if a.Num[i]>=10 then
  begin
    Dec(a.Num[i],10);
    Inc(a.Num[i+1]);
  end;
end;
if a.Num[L+1]>0 then Inc(L);
a.Len:=L;
end;

Procedure ToLong(var a:TLong;v:Longint);
begin
FillChar(a,SizeOf(a),0);
if v=0 then
  a.Len:=1
else
begin
  While v>0 Do
  begin
    Inc(a.Len);
    a.Num[a.Len]:=v mod 10;
    v:=v div 10;
  end;
end;
end;

var v:Array[1..MaxP] of Shortint;
    t1,t2,t3:TLong;

Procedure Solve;
var g,h,k:Longint;
    c,ch:Char;
begin
FillChar(a,SizeOf(a),0);
CountPrimes;
N:=26;
L:=Length(s);
for i:=1 to L do
  Inc(a[s[i]]);
ToLong(Ans,0);
for i:=1 to L do
begin
  for c:='a' to Pred(s[i]) do
  if a[c]>0 then
  begin
    Dec(a[c]);
    FillChar(v,SizeOf(v),0);
    g:=0;
    for ch:='a' to 'z' do
    for k:=1 to a[ch] do
    begin
      Inc(g);
      h:=k;
      for j:=1 to P do
        While h mod pr[j] = 0 Do
        begin
          h:=h div pr[j];
          Dec(v[j]);
        end;
    end;
    Inc(a[c]);

    for k:=1 to g do
    begin
      h:=k;
      for j:=1 to P do
        While h mod pr[j] = 0 Do
        begin
          h:=h div pr[j];
          Inc(v[j]);
        end;
    end;

    ToLong(t1,1);
    for j:=1 to P do
    begin
      ToLong(t2,pr[j]);
      for k:=1 to v[j] do
      begin
        MulLong(t1,t2,t3);
        t1:=t3;
      end;
    end;
    IncLong(Ans,t1);
  end;
  Dec(a[s[i]]);
end;
ToLong(t1,1);
IncLong(Ans,t1);
FWrite(1543);
end;

begin
FRead;
Solve;
end.