const
     FileIn='nearest.in';
     FileOut='nearest.out';
     MaxN=10000;
     MaxA=10000;
var
   N, A: LongInt;
   Items: array [1..MaxN] of LongInt;
   Ops: array [2..MaxN] of Char;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, A);
     for NItem:=1 to N
         do Readln (F, Items [NItem]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Write (F, Items [1]);
     for NItem:=2 to N
         do Write (F, Ops [NItem], Items [NItem]);
     Close (F);
end;

var
   Indexes: array [1..MaxN] of LongInt;

procedure Swap (var aA, aB: LongInt);
var
   Temp: LongInt;
begin
     Temp:=aA;
     aA:=aB;
     aB:=Temp;
end;

procedure QSort (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   M: LongInt;
begin
     i:=aLeft;
     j:=aRight;
     M:=Items [Indexes [(aLeft+aRight) shr 1]];
     repeat
           while Items [Indexes [i]]<M
                 do Inc (i);
           while M<Items [Indexes [j]]
                 do Dec (j);
           if i<=j
              then begin
                   Swap (Indexes [i], Indexes [j]);
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSort (aLeft, j);
     if i<aRight
        then QSort (i, aRight);
end;


procedure Solve;
var
   Index: LongInt;
   Value: LongInt;
begin
     for Index:=1 to N
         do Indexes [Index]:=Index;
     QSort (1, N);
     Value:=Items [1];
     for Index:=1 to N
         do if Indexes [Index]<>1
               then if (Value<A)=(Items [Indexes [Index]]>0)
                       then Ops [Indexes [Index]]:='+'
                       else Ops [Indexes [Index]]:='-';

end;

begin
     ReadData;
     Solve;
     WriteData;
end.
