program zzz;

const
  osn = 1000;

type
  Tlong = array[0..30] of Longint;

var
  t,i,j,k,n,m: Longint;
  s: string;
  cur,ans: Tlong;
  c: array[0..50,0..50] of Tlong;
  cnt: array['a'..'z'] of Longint;

function max(a,b: Longint): Longint;
begin
  if a > b then max := a else max := b;
end;

procedure sumlong(a,b: Tlong; var c: Tlong);
var i,j: Longint;
begin
  for i := 1 to max(a[0],b[0]) do begin
    c[i] := a[i] + b[i];
  end;
  for i := 1 to max(a[0],b[0]) do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] mod osn;
  end;
  c[0] := max(a[0],b[0]) + 1;
  while (c[c[0]] = 0) and (c[0] <> 0) do dec(c[0]);
end;

procedure printlong(a: TLong);
var i,j: Longint;
begin
  write(a[a[0]]);
  for i := a[0]-1 downto 1 do begin
    j := osn;
    while j <> 1 do begin
      j := j div 10;
      write(a[i] div j);
      a[i] := a[i] mod j;
    end;
  end;
  writeln;
end;

procedure prodlong(a,b: Tlong; var c: Tlong);
var i,j: Longint;
begin
  fillchar(c,sizeof(c),0);
  for i := 1 to a[0] do begin
    for j := 1 to b[0] do begin
      c[i+j-1] := c[i+j-1] + a[i] * b[j];
    end;
  end;
  for i := 1 to a[0] + b[0] do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] mod osn;
  end;
  c[0] := a[0] + b[0];
  while c[c[0]] = 0 do dec(c[0]);
end;

procedure prodsmall(var a: Tlong; m: Longint);
var i,j: Longint;
begin
  for i := 1 to a[0] do a[i] := a[i] * m;
  for i := 1 to a[0] do begin
    a[i+1] := a[i+1] + a[i] div osn;
    a[i] := a[i] mod osn;
  end;
  a[0] := a[0] + 1;
  while a[a[0]] = 0 do dec(a[0]);
end;

begin
  assign(input,'string.in'); reset(input);
  readln(s);
  for i := 1 to length(s) do begin
    inc(cnt[s[i]]);
  end;
  ans[0] := 1;
  ans[1] := 1;
  for i := 0 to 50 do begin
    c[0,i,0] := 1;
    c[0,i,1] := 1;
  end;
  for i := 1 to 50 do begin
    for j := 1 to i do begin
      sumlong(c[j-1,i-1],c[j,i-1],c[j,i]);
    end;
  end;
  for i := 1 to length(s)-1 do begin
    fillchar(cur,sizeof(cur),0);
    for j := ord('a') to ord(s[i])-1 do begin
      if cnt[chr(j)] = 0 then continue;
      dec(cnt[chr(j)]);
      fillchar(cur,sizeof(cur),0);
      cur[1] := 1;
      cur[0] := 1;
      t := length(s) - i;
      for k := ord('a') to ord('z') do begin
        if cnt[chr(k)] = 0 then continue;
        prodlong(cur,c[cnt[chr(k)],t],cur);
        t := t - cnt[chr(k)];
      end;
      inc(cnt[chr(j)]);
    end;
    sumlong(cur,ans,ans);
    dec(cnt[s[i]]);
  end;
  close(input);
  assign(output,'string.out'); rewrite(output);
  printlong(ans);
  close(output);
end.
