type int = longint;
     tlong = array[0..2000] of int;

var n, i : int;
    p : array[0..1000] of int;
    a, b : array[1..1000] of int;
    ans, c : tlong;

procedure primes;
var d, j : int;
begin
  fillchar(p, sizeof(p), 0);
  p[0]:=2;
  p[1]:=2;
  p[2]:=3;
  d:=5;
  while d <= n do begin
    while (j <= p[0]) and (sqr(p[j]) <= d) do
      if d mod p[j] = 0 then break else inc(j);
    if (j > p[0]) or (sqr(p[j]) > d) then begin
      inc(p[0]);
      p[p[0]]:=d;
    end;
    inc(d, 2);
  end;
end;

procedure make(x : int);
var j : int;
begin
  for j:=1 to p[0] do b[j]:=0;
  j:=1;
  while x > 1 do begin
    while x mod p[j] <> 0 do inc(j);
    while x mod p[j] = 0 do begin
      inc(b[j]);
      x:=x div p[j];
    end;
  end;
  for j:=1 to p[0] do
    if a[j] < b[j] then a[j]:=b[j];
end;

procedure mul(var x : tlong; y : int);
var j, t : int;
begin
  fillchar(c, sizeof(c), 0);
  for j:=1 to x[0] do begin
    inc(c[j], x[j]*y);
    t:=j;
    while c[t] > 10 do begin
      c[t+1]:=c[t] div 10;
      c[t]:=c[t] mod 10;
      inc(t);
    end;
    if c[0] < t then c[0]:=t;
  end;
  for j:=0 to c[0] do x[j]:=c[j];
end;

begin
  assign(input, 'lcm.in'); reset(input);
  assign(output, 'lcm.out'); rewrite(output);
  read(n);
  primes;
  fillchar(a, sizeof(a), 0);
  for i:=2 to n do make(i);
  fillchar(ans, sizeof(ans), 0);
  ans[0]:=1;
  ans[1]:=1;
  for i:=1 to p[0] do
    while a[i] > 0 do begin
      mul(ans, p[i]);
      dec(a[i]);
    end;
  for i:=ans[0] downto 1 do write(ans[i]);
  close(input); close(output);
end.
