const max = 10000;

type int = longint;

var a, n, s : int;
    p    : array[1..max] of int;
    b    : array[-max..max] of int;
    m    : array[1..max] of int;

procedure init;
var i : int;
begin
  read(n, a);
  s:=0;
  for i:=1 to n do begin
    read(p[i]);
    inc(s, p[i]);
  end;
end;

procedure solve;
var i, j, up, down : int;
begin
  fillchar(b, sizeof(b), 0);
  down:=max;
  up:=-max;
  for i:=2 to n do
    if p[i] > 0 then begin
      for j:=up downto down do
        if abs(j+p[i]) <= max then
          if b[j+p[i]] = 0 then begin
            b[j+p[i]]:=i;
            if j+p[i] > up then up:=j+p[i];
            if j+p[i] < down then down:=j+p[i];
          end;
      b[p[i]]:=i;
      if p[i] > up then up:=p[i];
      if p[i] < down then down:=p[i];
    end else begin
      for j:=down to up do
        if abs(j+p[i]) <= max then
          if b[j+p[i]] = 0 then begin
            b[j+p[i]]:=i;
            if j+p[i] > up then up:=j+p[i];
            if j+p[i] < down then down:=j+p[i];
          end;
      b[p[i]]:=i;
      if p[i] > up then up:=p[i];
      if p[i] < down then down:=p[i];
    end;
  j:=down;
  for i:=down+1 to up do
    if b[i] <> 0 then
      if abs(s-2*i-a) < abs(s-2*j-a) then j:=i;
  if abs(s-a) < abs(s-2*j-a) then begin
    writeln(s);
    s:=0;
  end else begin
    writeln(s-2*j);
    s:=j;
  end;
end;

procedure wa;
begin
  fillchar(a, sizeof(a), 0);
  while s <> 0 do begin
    m[b[s]]:=1;
    dec(s, p[b[s]]);
  end;
  for s:=1 to n do begin
    if m[s] = 1 then write('-')
    else if s > 1 then write('+');
    write(p[s]);
  end;
end;

begin
  assign(input, 'nearest.in'); reset(input);
  assign(output, 'nearest.out'); rewrite(output);
  init;
  solve;
  wa;
  close(input); close(output);
end.
