{$I-,Q-,R-,S-}
const
  MAXN = 105;
  InFile = 'horse.in';
  OutFile = 'horse.out';

var
  o: array[1..MAXN*MAXN*2] of record
    x, y: integer;
    p: Integer;
  end;
  m, n, p, q, x1, y1, x2, y2: integer;
  uk: integer;
  NNew: array[1..MAXN,1..MAXN] of boolean;

procedure Init();
begin
  Assign(Input, InFile);
  Reset(Input);
  Assign(Output, OutFile);
  Rewrite(Output);

  Read(m, n, p, q, x1, y1, x2, y2);
end;

procedure Rec(const k, v: Integer);
begin
  if o[k].p = k then
  begin
    Writeln(v);
    Writeln(o[k].x, ' ', o[k].y);
    Exit;
  end;
  Rec(o[k].p, v + 1);
  Writeln(o[k].x, ' ', o[k].y);
end;

procedure Done(const k: Integer);
begin
  Rec(k, 0);

  Close(Input);
  Close(Output);
    Halt;
end;

procedure Solve();
const
  di: array[1..4] of integer = (1, 1, -1, -1);
  dj: array[1..4] of integer = (1, -1, 1, -1);
var l, r, i, xt, yt, t: Integer;
begin
  uk := 1;
  o[1].x := x1;
  o[1].y := y1;
  o[1].p := 1;
  l := 1;
  r := 1;

  while (l <= r) do
  begin
    for i := l to r do
    begin
      if (o[i].x = x2) and (o[i].y = y2) then Done(i);

      for t := 1 to 4 do
      begin
        xt := o[i].x + p * di[t];
        yt := o[i].y + q * dj[t];
        if (xt <= m) and (xt > 0) and (yt <= n) and (yt > 0) and not NNew[xt, yt] then
        begin
          Inc(uk);
          NNew[xt, yt] := True;
          o[uk].x := xt;
          o[uk].y := yt;
          o[uk].p := i;
        end;
      end;

      for t := 1 to 4 do
      begin
        xt := o[i].x + q * di[t];
        yt := o[i].y + p * dj[t];
        if (xt <= m) and (xt > 0) and (yt <= n) and (yt > 0) and not NNew[xt, yt] then
        begin
          Inc(uk);
          NNew[xt, yt] := True;
          o[uk].x := xt;
          o[uk].y := yt;
          o[uk].p := i;
        end;
      end;

    end;
    l := r + 1;
    r := uk;
  end;

end;

begin
  Init();
  Solve();
  Writeln(-1);
  Close(input);
  close(output);
end.
