  {$I-,Q-,R-,S-}
const maxc = 105; osn = 10000;
type tlong = array [0..maxc] of longint;
var s: string;
    p: array ['a'..'z'] of longint;

operator := (t: longint)w: tlong;
begin
     fillchar(w,Sizeof(w),0);
     w[0]:=1; w[1]:=t;
end;

operator * (a,b: tlong)c: tlong;
var i,j,d: longint;
begin
     fillchar(c,Sizeof(c),0);
     for i:=1 to a[0] do
        for j:=1 to b[0] do begin
           d:=c[i+j-1]+a[i]*b[j];
           inc(c[i+j],d div osn);
           c[i+j-1]:=d mod osn;
        end;
     c[0]:=a[0]+b[0];
     while (c[0] > 1)and(c[c[0]] = 0) do dec(c[0]);
end;

operator * (a: tlong; b: longint)c: tlong;
var x: tlong;
begin
     x:=b;
     c:=a*x;
end;

operator + (a,b: tlong) c: tlong;
var i,k: longint;
begin
     fillchar(c,Sizeof(c),0);
     if a[0] > b[0] then k:=a[0] else k:=b[0];
     for i:=1 to k do begin
        c[i+1]:=(c[i]+a[i]+b[i]) div osn;
        c[i]:=(c[i]+a[i]+b[i]) mod osn;
     end;
     if c[k+1] > 0 then c[0]:=k+1 else c[0]:=k;

end;

operator + (a: tlong; b: longint) c: tlong;
var x: tlong;
begin
     x:=b;
     c:=a+x;
end;

operator div (a: tlong; b: longint) c: tlong;
var i,ost: longint;
begin
     fillchar(c,Sizeof(c),0);
     ost:=0;
     for i:=a[0] downto 1 do begin
        c[i]:=(a[i]+osn*ost) div b;
        ost:=(a[i]+osn*ost) mod b;
     end;
     if c[a[0]] = 0 then c[0]:=a[0]-1 else c[0]:=a[0];
end;

procedure write_long(w: tlong);
var ss,s: string;
    i: longint;
begin
     str(osn div 10,s);
     write(w[w[0]]);
     for i:=w[0]-1 downto 1 do begin
        str(w[i],ss);
        while length(ss) < length(s) do ss:='0'+ss;
        write(ss);
     end;
end;

function find: tlong;
var i: char;
    sum,j: longint;
    ans: tlong;
begin
     ans:=1; sum:=0;
     for i:='a' to 'z' do inc(sum,p[i]);
     for j:=2 to sum do ans:=ans*j;
     for i:='a' to 'z' do begin
        for j:=2 to p[i] do ans:=ans div j;
     end;
     find:=ans;
end;

procedure solve;
var i: longint;
    j: char;
    cur: tlong;
begin
     fillchar(p,Sizeof(p),0);
     for i:=1 to length(s) do inc(p[s[i]]);
     cur:=0;
     for i:=1 to length(s) do begin
        for j:='a' to 'z' do begin
           if j = s[i] then break;
           if p[j] = 0 then continue;
           dec(p[j]);
           cur:=cur+find;
           inc(p[j]);
        end;
        dec(p[s[i]]);
     end;
     write_long(cur+1);
end;

begin
assign(input,'string.in');
reset(input);
assign(output,'string.out');
rewrite(output);
readln(s);
     solve;
close(input);
close(output);
end.