{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='minister.in';
  outfile='minister.out';
  inf=20000;
  nm=4005;
  mm=100005;
type
  Pnode = ^Node;
  Node = record
    x,n,d : LongInt;
    lo : LongInt;
    next : Pnode;
  end;
var
  a : array [1..nm] of PNode;
  b : array [1..nm] of LongInt;
  r : array [1..mm] of LongInt;
  n,m,res : LongInt;
{}
Procedure Inp;
var
  i,x,y,d : LongInt;
  q : PNode;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m);
  for i:=1 to n do read(b[i]);
  for i:=1 to m do begin
    new(q); read(x,y,d);
    q^.x:=y; q^.d:=d;
    q^.lo:=0; q^.n:=i;
    q^.next:=a[x]; a[x]:=q;

    new(q);
    q^.x:=x; q^.d:=d;
    q^.lo:=0; q^.n:=i;
    q^.next:=a[y]; a[y]:=q;
  end;
end;
{}
Procedure Out(ok : Boolean);
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ok then begin
    writeln(res);
    for i:=1 to m do
      writeln(r[i]);
  end else writeln(-1);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
end;
{}
Function Max(q,w : LongInt) : LongInt;
begin
  if q>w then max:=q else max:=w;
end;
{}
Procedure Solve;
var
  i,j,min : LongInt;
  ok : Boolean;
  q : PNode;
begin
  res:=0;
  for i:=1 to n do begin
    q:=a[i]; if i>1 then ok:=false
                    else ok:=true;
    min:=inf;
    while q<>nil do begin
      if b[i]>b[q^.x] then begin
        q^.lo:=b[i]-b[q^.x];
        if min>abs(q^.lo-q^.d) then min:=abs(q^.lo-q^.d);
      end;
      q:=q^.next;
    end;

    q:= a[i];
    while q<>nil do begin
      if b[i]>b[q^.x] then begin
        q^.lo:=b[i]-b[q^.x];
        if not ok and (abs(q^.lo-q^.d)=min) or (q^.lo>q^.d) then begin
          r[q^.n]:=q^.lo;
          res:=res+abs(q^.lo-q^.d);
        end else r[q^.n]:=q^.d;
        ok:=true;
      end;
      q:=q^.next;
    end;

    if not ok then Out(false);
  end;

end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(true);
End.