{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_b;
const
  inpfile='brides.in';
  outfile='brides.out';
  inf=MaxLongInt;
  nm=205;
  km=105;
type
  PNode = ^Node;
  Node = record
    x,n,d : LongInt;
    u : Boolean;
    next : PNode;
  end;
var
  a : array [1..nm] of PNode;
  r : array [1..km,1..nm] of LongInt;
  rn : array [1..km] of LongInt;
  n,m,k : LongInt;
  res : Extended;
{}
Procedure Inp;
var
  i,x : LongInt;
  q : PNode;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m,k);
  for i:=1 to m do begin
    new(q); read(x,q^.x,q^.d);
    q^.u:=false; q^.n:=i;
    q^.next:=a[x]; a[x]:=q;
  end;
end;
{}
Procedure Out(ok : Boolean);
var
  i,j : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ok then begin
    writeln(res/k:0:10);
    for i:=1 to k do begin
      write(rn[i],' ');
      for j:=rn[i] downto 1 do
        write(r[i,j],' ');
      writeln;
    end;
  end else writeln(-1);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(r,sizeof(r),0);
  fillchar(rn,sizeof(rn),0);
end;
{}
var
  p,v : array [1..nm] of LongInt;
  u : array [1..nm] of Boolean;
  reb : array [1..nm] of PNode;
{}
Procedure Solve;
var
  i,j,t,min,mini : LongInt;
  q : PNode;
begin
  for t:=1 to k do begin
    fillchar(reb,sizeof(reb),0);
    fillchar(p,sizeof(p),0);
    fillchar(v,sizeof(v),0);
    fillchar(u,sizeof(u),0);
    for i:=2 to n do v[i]:=inf;

    repeat
      min:=inf; mini:=0;
      for i:=1 to n do
        if not u[i] and (v[i]<min) then begin
          min:=v[i]; mini:=i;
        end;

      if mini=0 then Out(false);

      u[mini]:=true;
      q:=a[mini];
      while q<>nil do begin
        if not q^.u and not u[q^.x] and (v[q^.x]>v[mini]+q^.d) then begin
          v[q^.x]:=v[mini]+q^.d;
          p[q^.x]:=mini;
          reb[q^.x]:=q;
        end;
        q:=q^.next;
      end;
    until u[n];

    i:=n;
    while i<>1 do begin
      inc(rn[t]);
      r[t,rn[t]]:=reb[i]^.n;
      res:=res+reb[i]^.d;
      reb[i]^.u:=true;
      i:=p[i];
    end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(true);
End.