{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_c;
const
  inpfile='dfs.in';
  outfile='dfs.out';
  nm=10005;
type
  PNode = ^Node;
  Node = record
    x : LongInt;
    next : PNode;
  end;
var
  a,b,c,r : array [1..nm] of PNode;
  col,num : array [1..nm] of LongInt;
  p,nch,u,nreb : array [1..nm] of LongInt;
  ch : array [1..nm] of Boolean;
  n,color,time : LongInt;
{}
Procedure Inp;
var
  i,j,k : LongInt;
  q : PNode;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=2 to n do read(p[i]);
  for i:=1 to n do begin
    read(nreb[i]);
    for j:=1 to nreb[i] do begin
      new(q); read(q^.x);
      q^.next:=a[i]; a[i]:=q;
    end;
  end;
end;
{}
Procedure Out(ok : Boolean);
var
  i : LongInt;
  q : PNode;
begin
  assign(output,outfile);
  rewrite(output);
  if ok then begin
    writeln('YES');
    for i:=1 to n do begin
      write(nreb[i],' ');
      q:=r[i];
      while q<>nil do begin
        write(q^.x,' ');
        q:=q^.next;
      end;
      writeln;
    end;
  end else writeln('NO');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
  fillchar(r,sizeof(r),0);
  fillchar(nch,sizeof(nch),0);
  fillchar(p,sizeof(p),0);
end;
{}
Procedure Paint(x : LongInt);
var
  q : PNode;
begin
  q:=b[x]; col[x]:=color;
  while q<>nil do begin
    Paint(q^.x);
    q:=q^.next;
  end;
end;
{}
Procedure AddRebr(x : LongInt);
var
  q,w : PNode;
begin
  q:=a[x];
  while q<>nil do begin
    if (col[q^.x]<>col[x]) and (col[q^.x]<>0) and (col[x]<>0) then begin
      new(w); w^.x:=col[q^.x];
      w^.next:=c[col[x]];
      c[col[x]]:=w;
    end;
    q:=q^.next;
  end;

  q:=b[x];
  while q<>nil do begin
    AddRebr(q^.x);
    q:=q^.next;
  end;
end;
{}
Procedure Topo(x : LongInt);
var
  q : PNode;
begin
  u[x]:=1;
  q:=c[x];
  while q<>nil do begin
    if u[q^.x]=0 then Topo(q^.x)
    else if u[q^.x]=1 then Out(false);
    q:=q^.next;
  end;
  dec(time); num[x]:=time;
  u[x]:=2;
end;
{}
Procedure Work(x : LongInt);
var
  i,j : LongInt;
  q,w : PNode;
begin
  fillchar(u,sizeof(u),0);
  fillchar(ch,sizeof(ch),0);
  fillchar(col,sizeof(col),0);
  fillchar(num,sizeof(num),0);
  q:=b[x];
  while q<>nil do begin
    ch[q^.x]:=true;
    color:=q^.x;
    Paint(q^.x);
    q:=q^.next;
  end;

  q:=b[x];
  while q<>nil do begin
    AddRebr(q^.x);
    q:=q^.next;
  end;

  q:=b[x]; time:=nch[x]+1;
  while q<>nil do begin
    if u[q^.x]=0 then Topo(q^.x);
    q:=q^.next;
  end;

  q:=b[x];
  while q<>nil do begin
    col[num[q^.x]]:=q^.x;
    q:=q^.next;
  end;

  q:=a[x];
  while q<>nil do begin
    if not ch[q^.x] then begin
      new(w); w^.x:=q^.x;
      w^.next:=r[x]; r[x]:=w;
    end;
    q:=q^.next;
  end;

  for i:=1 to nch[x] do begin
    new(q); q^.x:=col[i];
    q^.next:=r[x]; r[x]:=q;
  end;

end;
{}
Procedure Solve;
var
  i,j : LongInt;
  q : Pnode;
begin
  for i:=2 to n do begin
    new(q); q^.x:=i;
    q^.next:=b[p[i]];
    b[p[i]]:=q;
    inc(nch[p[i]]);
  end;

  for i:=1 to n do Work(i)
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(true);
End.