program fd;
const maxm=500000;
      maxn=100000;
var e,f:array[1..maxm] of integer;
    ae:array[0..maxn] of longint;
    tr,en,le:array[1..maxn] of longint;
    n,t:longint;

procedure load;
var i,j,k:longint;
begin
        fillchar(en,sizeof(en),0);
        t:=1;
        ae[0]:=0;
        read(n);
        for i:= 2 to n do read(tr[i]);
        for i:= 1 to n do begin
                read(k);
                for j:= 1 to k do begin
                        read(e[ae[i-1]+j]);
                        f[ae[i-1]+j]:=j;
                end;
                ae[i]:=ae[i-1]+k;
        end;
end;


function  dfs(x:longint):boolean;
var i,j,k:longint;
    f,h:boolean;
begin
        f:=true;
        en[x]:=t;
        inc(t);
        for i:= ae[x-1]+1 to ae[x] do begin
                if (en[e[i]]=0) then
                        if (tr[e[i]]=x) then begin
                               h:= dfs(e[i]);
                               f:=f and h;
                        end
                        else f:=false;
        end;
        le[x]:=t;
        inc(t);
        dfs:=f;
end;

function lca(a,b:longint):longint;
var i,j,k,m:longint;
begin
        m:=1;
        for i := 1 to n do begin
                if (en[i]<en[a])and(le[a]<le[i])and
                   (en[i]<en[b])and(le[b]<le[i])and
                                 (en[i]>en[m]) then
                                        m:=i;
        end;
        lca:=m;
end;


procedure swap(var a,b:integer);
var t:longint;
begin
        t:=a;
        a:=b;
        b:=t;
end;

procedure sort(l,r:longint);
var i,j,x:longint;
begin
        x:=f[l+random(r-l+1)];
        i:=l;
        j:=r;
        while i<=j do begin
                while f[i]<x do inc(i);
                while f[j]>x do dec(j);
                        if i<=j then begin
                                swap(f[i],f[j]);
                                swap(e[i],e[j]);
                                dec(j);inc(i);
                        end;
        end;
        if i<r then sort(i,r);
        if l<j then sort(l,j);
end;

procedure solve;
var i,j,k,l,h:longint;
    fff:boolean;
begin
        for i:= 1 to n do if tr[i]>0 then begin
                fff:=false;
                for j:= ae[tr[i]-1]+1 to ae[tr[i]] do begin
                        if e[j]=i then fff:=true;
                end;
                if not fff then begin
                        write('NO');
                        close(output);
                        halt(0);
                end;
        end;
        fff:=dfs(1);
        for i := 1 to n do begin
                for j := ae[i-1]+1 to ae[i] do begin
                        if (tr[e[j]]<>i) then begin
                                k:=lca(i,e[j]);
                                if (k=i)or(k=e[j]) then f[j]:=ae[i]-ae[i-1]
                                else begin
                                        for l := ae[k-1]+1 to ae[k] do begin
                                                if (en[e[l]]<=en[e[j]])and(le[e[j]]<=le[e[l]]) then
                                                        break;
                                        end;
                                        for h := ae[k-1]+1 to ae[k] do begin
                                                if (en[e[h]]<=en[i])and(le[i]<=le[e[h]]) then
                                                        break;
                                        end;
                                        if f[l]>f[h] then swap(f[l],f[h]);
                                end;
                        end;
                end;
        end;
        for i:= 1 to n do
                sort(ae[i-1]+1,ae[i]);
        fillchar(en,sizeof(en),0);

end;


procedure save;
var i,j:integer;
begin
        if not dfs(1) then begin
                write('NO');
        end
        else begin
                writeln('yes');
                for i:= 1 to n do begin
                        write(ae[i]-ae[i-1]);
                        for j:=ae[i-1]+1 to ae[i] do
                                write(' ',e[j]);
                        writeln;
                end;
        end;
end;

begin
        assign(input,'dfs.in');reset(input);
        assign(output,'dfs.out');rewrite(output);
        load;
        solve;
        save;
        close(output);
end.
