program Temp;
const infile = 'minister.in';
      outfile = 'minister.out';
      MAXN = 4000;
      MAXM = 200000;
      inf = 1000000000;

type TEdge = record
  A, B, l : longint;
end;

var N, M, nch : longint;
    GA : array[1..MAXN] of longint;
    GB : array[1..MAXM] of TEdge;
    dm, d : array[1..MAXN] of longint;

procedure outno;
begin
  write(-1);
  close(input);
  close(output);
  halt(0);
end;

procedure ReadData;
var l : array[1..MAXN] of longint;
    cur, u, v, len, i : longint;

procedure add(u, v, len : longint);
begin
  inc(cur); GB[cur].A:=v; GB[cur].B:=0; GB[cur].l:=len;
  if l[u]=0 then GA[u]:=cur else GB[l[u]].b:=cur;
  l[u]:=cur;
end;

begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N, M);
  for i:=1 to N do read(dm[i]); cur:=0;
  for i:=1 to M do
  begin
    read(u, v, len);
    add(u, v, len);
    add(v, u, len);
  end; nch:=0;
end;

procedure Solve;
var Cur, j, k, l, jt : longint;
    pass : array[1..MAXN] of boolean;

procedure Relax;
begin
  if d[k]<dm[k] then outno;
  if d[Cur]+l<d[k] then d[k]:=d[Cur]+l;

  if d[k]<dm[k] then begin
    d[k]:=dm[k]; GB[j].l:=dm[k]-d[Cur]; GB[jt].l:=GB[j].l; nch:=nch+dm[k]-d[Cur]-l;
  end else if d[k]>dm[k] then 
  begin
    d[k]:=dm[k];
    if dm[k]<d[Cur] then outno;
    GB[j].l:=dm[k]-d[Cur]; GB[jt].l:=GB[j].l; nch:=nch-dm[k]+d[Cur]+l;
  end;
end;

begin
  fillchar(pass, sizeof(pass), 0);
  for j:=1 to N do d[j]:=inf;
  Cur:=1; d[1]:=0;
  repeat
    pass[Cur]:=true; j:=GA[Cur];
    while j<>0 do
    begin
      k:=GB[j].A; l:=GB[j].l; if j mod 2=0 then jt:=j-1 else jt:=j+1;
      Relax;
      j:=GB[j].B;
    end;
    Cur:=0;
    for j:=1 to N do
      if (not pass[j])and((Cur=0)or(d[j]<d[Cur])) then Cur:=j;
  until Cur=0;
end;

procedure WriteData;
var i : longint;
begin
  for i:=1 to N do if d[i]<>dm[i] then outno;
  writeln(nch);
  for i:=1 to M do writeln(GB[i*2].l);
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.