{$I-,Q-,R-,S-}
const inf='minister.in';
      ouf='minister.out';
var d,d0,num,place:array [1..4000] of longint;
    n,m:longint;
    edge:array [1..200000] of record
      s,f,w,n:longint;
    end;
    first:array [1..4000] of longint;
    ans:longint;
procedure addedge(q,s,f,w:longint);
begin
  edge[q].s:=s;
  edge[q].f:=f;
  edge[q].w:=w;
  edge[q].n:=first[s];
  first[s]:=q;
end;
procedure qsort(l,r:longint);
var i,j,m,t:longint;
begin
  i:=l;
  j:=r;
  m:=d[l+random(r-l+1)];
  repeat
    while d[i]<m do
      inc(i);
    while d[j]>m do
      dec(j);
    if i<=j then
    begin
      t:=d[i];
      d[i]:=d[j];
      d[j]:=t;
      t:=num[i];
      num[i]:=num[j];
      num[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;
procedure outno();
begin
  assign(output,'minister.out');
  rewrite(output);
  write('-1');
  close(output);
  halt;
end;
procedure run;
var i,j,k,l,t,min:longint;
    best:array [1..4000] of longint;
    marked:array [1..4000] of boolean;
begin
  randomize;
  assign(input,inf);
  reset(input);
  read(n,m);
  for i:=1 to n do
  begin
    read(d[i]);
    if d[i]<0 then
      outno();
    num[i]:=i;
  end;
  qsort(1,n);
  for i:=1 to n do
    place[num[i]]:=i;
  d0:=d;
  for i:=1 to n do
    d[i]:=d0[place[i]];
  if d[1]<>0 then
    outno();
  for i:=1 to m do
  begin
    read(j,k,l);
    if place[j]<place[k] then
    begin
      t:=j;
      j:=k;
      k:=t;
    end;
    addedge(i,j,k,l);
  end;
  close(input);
  ans:=0;
  for i:=1 to n do
  begin
    j:=num[i];
    k:=first[j];
    if k=0 then
      continue;
    while k<>0 do
    begin
      if d[edge[k].f]+edge[k].w<d[j] then
      begin
        inc(ans,d[j]-d[edge[k].f]-edge[k].w);
        inc(edge[k].w,d[j]-d[edge[k].f]-edge[k].w);
      end;
      k:=edge[k].n;
    end;
    k:=first[j];
    min:=0;
    while k<>0 do
    begin
      if (min=0) or (abs(edge[k].w-d[j]+d[edge[k].f])<abs(edge[min].w-d[j]+d[edge[min].f])) then
        min:=k;
      k:=edge[k].n;
    end;
    if min<>0 then
    begin
      inc(ans,abs(edge[min].w-d[j]+d[edge[min].f]));
      edge[min].w:=d[j]-d[edge[min].f];
    end;
  end;
  for i:=1 to m do
    addedge(i+m,edge[i].f,edge[i].s,edge[i].w);
  best[1]:=0;
  for i:=2 to n do
    best[i]:=maxlongint shr 1;
  fillchar(marked,sizeof(marked),false);
  for i:=1 to n do
  begin
    min:=0;
    for j:=1 to n do
      if not marked[j] and ((min=0) or (best[j]<best[min])) then
        min:=j;
    marked[min]:=true;
    j:=first[min];
    while j<>0 do
    begin
      if best[edge[j].s]+edge[j].w<best[edge[j].f] then
        best[edge[j].f]:=best[edge[j].s]+edge[j].w;
      j:=edge[j].n;
    end;
  end;
  for i:=1 to n do
    if best[i]<>d[i] then
      outno;
end;
procedure done;
var i:longint;
begin
  assign(output,ouf);
  rewrite(output);
  writeln(ans);
  for i:=1 to m do
    writeln(edge[i].w);
  close(output);
end;
begin
  run();
  done();
end.
