program zzz;

const
  maxn = 4000;
  maxm = 100000;
type
  prib = ^trib;
  trib = record
    next: prib;
    v,w,num: Longint;
  end;

var
  null: prib;
  cost: int64;
  i,j,k,n,m: Longint;
  buf: prib;
  vis: array[1..maxn] of Boolean;
  num,ww,r: array[1..maxn] of Longint;
  g: array[1..maxn] of prib;
  ans,res: array[1..maxm] of Longint;

procedure add(v1,v2,w,num: Longint);
var buf: prib;
begin
  new(buf);
  buf^.next := g[v1];
  g[v1] := buf;
  buf^.v := v2;
  buf^.w := w;
  buf^.num := num;
end;

procedure swap(var a,b: Longint);
var i: Longint;
begin
  i := a;
  a := b;
  b := i;
end;

procedure qsort(st,fin: Longint);
var i,j,key: Longint;
begin
  i := st;
  j := fin;
  key := ww[i+random(j-i)];
  while i <= j do begin
    while ww[i] < key do inc(i);
    while ww[j] > key do dec(j);
    if i <= j then begin
      swap(ww[i],ww[j]);
      swap(num[i],num[j]);
      inc(i);
      dec(J);
    end;
  end;
  if j > st then qsort(st,j);
  if i < fin then qsort(i,fin);
end;

procedure printno();
begin
  writeln(-1);
  close(input);
  close(output);
  halt(0);
end;

procedure solve();
var i,j,min,nn: Longint;
    buf: prib;
    fl1,fl: Boolean;
begin
  vis[1] := true;
  for i := 2 to n do begin
    fl := false;
    fl1 := false;
    buf := g[num[i]];
    while buf <> null do begin
      if vis[buf^.v] then begin
        fl1 := true;
        if buf^.w + r[buf^.v] <= r[num[i]] then begin
          fl := true;
          ans[buf^.num] := r[num[i]] - r[buf^.v];
        end;
      end;
      buf := buf^.next;
    end;
    if not fl1 then printno();
    if not fl then begin
      buf := g[num[i]];
      min := maxLongint;
      while buf <> null do begin
        if vis[buf^.v] then begin
          if min > buf^.w then begin
            min := buf^.w;
            nn := buf^.num;
          end;
        end;
        buf := buf^.next;
      end;
      buf := g[num[i]];
      while buf <> null do begin
        if vis[buf^.v] then begin
          if buf^.num = nn then begin
            min := r[num[i]] - r[buf^.v];
            break;
          end;
        end;
        buf := buf^.next;
      end;
      ans[nn] := min;
    end;
    vis[num[i]] := true;
  end;
end;

begin
  new(null);
  null^.next := null;
  assign(input,'minister.in'); reset(input);
  assign(output,'minister.out'); rewrite(output);
  read(n,m);
  for i := 1 to n do g[i] := null;
  for i := 1 to n do begin
    read(ww[i]);
    r[i] := ww[i];
    if i = 1 then if ww[i] <> 0 then printno();
    num[i] := i;
  end;
  for i := 1 to m do begin
    read(j,k,res[i]);
    add(j,k,res[i],i);
    add(k,j,res[i],i);
  end;
  qsort(1,n);
  ans := res;
  solve();
  for i := 1 to m do begin
    cost := cost + abs(res[i] - ans[i]);
  end;
  writeln(cost);
  for i := 1 to m do writeln(ans[i]);
  close(input);
  close(output);
end.
