program zzz;

const
  inf = 1000000000;
  maxn = 200;
  maxm = 2000;
type
  rec = record
    v,r,nn: Longint;
  end;
  prib = ^trib;
  trib = record
    next: prib;
    v,num,w: Longint;
  end;

var
  ans: Double;
  i,j,k,n,m,nn: Longint;
  vs: array[1..maxn] of Boolean;
  vis: array[1..maxm] of Byte;
  g: array[1..maxn] of Prib;
  ww: array[1..maxm] of Longint;
  best: array[1..maxn] of Longint;
  link: array[1..maxn] of Rec;
  null: prib;

procedure add(v1,v2,num,w: Longint);
var buf: prib;
begin
  new(buf);
  buf^.next := g[v1];
  g[v1] := buf;
  buf^.v := v2;
  buf^.w := w;
  buf^.num := num;
end;

function djkstra(): Boolean;
var tt,min,i,j,num,k: Longint;
    buf: prib;
begin
  for i := 2 to n do begin
    best[i] := inf;
  end;
  fillchar(vs,sizeof(vs),false);
  best[1] := 0;
  for i := 1 to n do begin
    min := inf;
    for j := 1 to n do begin
      if vs[j] then continue;
      if best[j] < min then begin
        min := best[j];
        num := j;
      end;
    end;
    vs[num] := true;
    buf := g[num];
    while buf <> null do begin
      if buf^.v > num then begin
        if vis[buf^.num] <> 1 then begin
          if best[buf^.v] > best[num] + buf^.w then begin
            best[buf^.v] := best[num] + buf^.w;
            link[buf^.v].v := num;
            link[buf^.v].r := buf^.num;
            if vis[buf^.num] = 2 then tt := 0 else tt := 1;
            link[buf^.v].nn := tt;
          end;
        end;
      end else begin
        if vis[buf^.num] <> 2 then begin
          if best[buf^.v] > best[num] + buf^.w then begin
            best[buf^.v] := best[num] + buf^.w;
            link[buf^.v].v := num;
            link[buf^.v].r := buf^.num;
            if vis[buf^.num] = 1 then tt := 0 else tt := 2;
            link[buf^.v].nn := tt;
          end;
        end;
      end;
      buf := buf^.next;
    end;
    if min = inf then break;
  end;
  djkstra := best[n] <> inf;
  if best[n] <> inf then begin
    i := n;
    while i <> 1 do begin
      vis[link[i].r] := link[i].nn;
      i := link[i].v;
    end;
  end;
  for i := 1 to n do begin
    buf := g[i];
    while buf <> null do begin
      buf^.w := buf^.w + best[i] - best[buf^.v];
      buf := buf^.next;
    end;
  end;
end;

function dfs(v,dep: Longint): Boolean;
var buf: prib;
begin
  buf := g[v];
  if v = 1 then begin
    dfs := true;
    write(dep,' ');
    exit;
  end;
  while buf <> null do begin
    if buf^.v > v then begin
      if vis[buf^.num] = 2 then
      if dfs(buf^.v,dep+1) then begin
        dfs := true;
        write(buf^.num,' ');
        vis[buf^.num] := 0;
        exit;
      end;
    end else begin
      if vis[buf^.num] = 1 then
      if dfs(buf^.v,dep+1) then begin
        dfs := true;
        write(buf^.num,' ');
        vis[buf^.num] := 0;
        exit;
      end;
    end;
    buf := buf^.next;
  end;
  dfs := false;
end;

begin
  assign(input,'brides.in'); reset(input);
  assign(output,'brides.out'); rewrite(output);
  new(null);
  null^.next := null;
  read(n,m,nn);
  for i := 1 to n do g[i] := null;
  for i := 1 to m do begin
    read(j,k,ww[i]);
    add(j,k,i,ww[i]);
    add(k,j,i,ww[i]);
  end;
  for i := 1 to nn do begin
    if not djkstra() then begin
      writeln('-1');
      close(input);
      close(Output);
      halt(0);
    end;
  end;
  for i := 1 to m do begin
    if vis[i] <> 0 then ans := ans + ww[i];
  end;
  writeln((ans/nn):0:10);
  for i := 1 to nn do begin
    dfs(n,0);
    writeln;
  end;
  close(input);
  close(output);
end.
