{$M 20000000}
program zzz;

const
  maxn = 10000;

type
  plist = ^tlist;
  tlist = record
    next: Plist;
    v: Longint;
    fl: Boolean;
  end;
  prib = ^trib;
  trib = record
    next: prib;
    v1,v2: Longint;
  end;

var
  buf,null: Plist;
  bf,nrib: prib;
  bol: array[1..maxn] of Boolean;
  vv: array[1..maxn] of char;
  tt,r,nn,num: array[1..maxn] of Longint;
  i,j,k,n,m: Longint;
  vis: array[1..maxn] of Boolean;
  g2: array[1..maxn] of prib;
  ans,g1,g,tr: array[1..maxn] of Plist;
  gl,p,rank: array[1..maxn] of Longint;

procedure topsort(v: Longint);
begin
end;

procedure printno();
begin
  writeln('NO');
  close(input);
  close(output);
  halt(0);
end;

procedure makeset();
var i,j: Longint;
begin
  for i := 1 to n do begin
    p[i] := i;
    rank[i] := 0;
    gl[i] := i;
  end;
end;

function get(v: Longint): Longint;
var i: Longint;
begin
  if p[v] = v then get := v else begin
    i := get(p[v]);
    p[v] := i;
    get := i;
  end;
end;

procedure union(v1,v2: Longint);
var i,j: Longint;
begin
  i := get(v1);
  j := get(v2);
  if i <> j then begin
    if rank[i] > rank[j] then begin
      p[j] := i;
      gl[i] := v1;
    end else begin
      p[i] := j;
      gl[j] := v1;
      if rank[i] = rank[j] then inc(rank[j]);
    end;
  end;
end;

procedure treeadd(v1,v2: Longint);
var buf: Plist;
begin
  new(buf);
  buf^.next := tr[v1];
  tr[v1] := buf;
  buf^.v := v2;
end;

procedure gr1add(v1,v2: Longint; fl : Boolean);
var buf: plist;
begin
  new(buf);
  buf^.next := g[v1];
  g[v1] := buf;
  buf^.v := v2;
  buf^.fl := fl;
end;

procedure gr2add(v1,v2: Longint);
var buf: plist;
begin
  new(buf);
  buf^.next := g1[v1];
  g1[v1] := buf;
  buf^.v := v2;
end;

procedure addans(v1,v2: Longint);
var buf: plist;
begin
  new(buf);
  buf^.next := ans[v1];
  ans[v1] := buf;
  buf^.v := v2;
end;

procedure gr3add(v,v1,v2: Longint);
var buf: prib;
begin
  new(buf);
  buf^.next := g2[v];
  g2[v] := buf;
  buf^.v1 := v1;
  buf^.v2 := v2;
end;

procedure dfslca(v: Longint);
var buf: plist;
    k,i,j: Longint;
begin
  vis[v] := true;
  buf := tr[v];
  while buf <> null do begin
    dfslca(buf^.v);
    union(v,buf^.v);
    buf := buf^.next;
  end;
  buf := g[v];
  while buf <> null do begin
    if vis[buf^.v] then begin
      k := gl[get(buf^.v)];
      if buf^.fl then begin
        i := v;
        j := buf^.v;
      end else begin
        i := buf^.v;
        j := v;
      end;
    end;
    gr3add(k,i,j);
    buf := buf^.next;
  end;
end;

procedure dfs(v: Longint);
var buf: prib;
    buf1: plist;
    sc,i,j: Longint;

  procedure freeg();
  var cur,buf: plist;
      i,j: Longint;
  begin
    for i := 1 to sc do begin
      cur := g1[i];
      while cur <> null do begin
        buf := cur;
        cur := cur^.next;
        dispose(buf);
      end;
    end;
  end;

  procedure dfs1(ver: Longint);
  var buf1: plist;
  begin
    buf1 := g1[ver];
    vv[ver] := 'G';
    while buf1 <> null do begin
      if vv[buf1^.v] = 'G' then printno();
      if vv[buf1^.v] = 'W' then dfs1(buf1^.v);
      buf1 := buf1^.next;
    end;
    vv[ver] := 'B';
    addans(v,nn[ver]);
  end;

begin
  sc := 0;
  buf1 := tr[v];
  while buf1 <> null do begin
    dfs(buf1^.v);
    buf1 := buf1^.next;
  end;
  buf1 := tr[v];
  while buf1 <> null do begin
    inc(sc);
    nn[sc] := buf1^.v;
    vis[buf1^.v] := true;
    r[get(buf1^.v)] := sc;
    buf1 := buf1^.next;
  end;
  buf1 := g[v];
  while buf1 <> null do begin
    if buf1^.fl then
    if not vis[buf1^.v] then begin
      addans(v,buf1^.v);
    end;
    buf1 := buf1^.next;
  end;
  buf := g2[v];
  for i := 1 to sc do begin
    vv[i] := 'W';
  end;
  while buf <> nrib do begin
    if not ((buf^.v1 = v) or (buf^.v2 = v)) then begin
      i := r[get(buf^.v1)];
      j := r[get(buf^.v2)];
      if i <> j then gr2add(j,i);
    end;
    buf := buf^.next;
  end;
  for i := 1 to sc do begin
    if vv[i] = 'W' then dfs1(i);
  end;
  freeg();
  sc := 0;
  buf1 := tr[v];
  while buf1 <> null do begin
    inc(sc);
    nn[sc] := 0;
    vis[buf1^.v] := false;
    r[get(buf1^.v)] := 0;
    buf1 := buf1^.next;
  end;
  buf1 := tr[v];
  while buf1 <> null do begin
    union(v,buf1^.v);
    buf1 := buf1^.next;
  end;
end;

begin
  new(null);
  null^.next := null;
  new(nrib);
  nrib^.next := nrib;
  assign(input,'dfs.in'); reset(input);
  assign(output,'dfs.out'); rewrite(output);
  read(n);
  for i := 1 to n do begin
    tr[i] := null;
    g[i] := null;
    g1[i] := null;
    g2[i] := nrib;
    ans[i] := null;
  end;
  for i := 1 to n-1 do begin
    read(k);
    tt[i+1] := k;
    treeadd(k,i+1);
  end;
  for i := 1 to n do begin
    read(num[i]);
    for j := 1 to num[i] do begin
      read(k);
      if tt[k] = i then bol[k] := true;
      gr1add(i,k,true);
      gr1add(k,i,false);
    end;
  end;
  for i := 2 to n do if not bol[i] then printno();
  makeset();
  dfslca(1);
  fillchar(vis,sizeof(vis),false);
  makeset();
{  for i := 1 to n do begin
    bf := g2[i];
    while bf <> nrib do begin
      writeln('lca ',bf^.v1,' ',bf^.v2,'=',i);
      bf := bf^.next;
    end;
  end;}
  dfs(1);
  writeln('YES');
  for i := 1 to n do begin
    write(num[i],' ');
    buf := ans[i];
    for j := 1 to num[i] do begin
      write(buf^.v,' ');
      buf := buf^.next;
    end;
    writeln;
  end;
  close(input);
  close(output);
end.
