{$I-,Q-,R-,S-}
const
  maxn=200;
  maxk=100;
  maxm=2000;
  alot=2000010000;

type TRoad=record
    i,j:byte;
    l,n:longint;
  end;

var
  q,i,j,n,k:byte;
  z,m,l:longint;
  a:array[1..maxn,1..maxn] of record
    c:byte;
    l:array[1..maxk] of longint;
    n:array[1..maxk] of integer;
  end;
  roads:array[1..maxm] of TRoad;
  count:array[1..maxn,1..maxn] of integer;
  t:array[1..maxn] of longint;
  u:array[1..maxn] of boolean;
  ans:array[1..maxk] of record
    count:byte;
    a:array[1..maxn] of integer;
  end;
  time:extended;
  from:array[1..maxn] of byte;

procedure swap(i,j:integer);
var
  r:troad;
begin
  r:=roads[i];
  roads[i]:=roads[j];
  roads[j]:=r;
end;

function lessroad(r1,r2:troad):boolean;
begin
  if r1.i<r2.i then begin
    lessroad:=true;
    exit;
  end;
  if r1.i>r2.i then begin
    lessroad:=false;
    exit;
  end;
  if r1.j<r2.j then begin
    lessroad:=true;
    exit;
  end;
  if r1.j>r2.j then begin
    lessroad:=false;
    exit;
  end;
  if r1.l<r2.l then begin
    lessroad:=true;
    exit;
  end;
  lessroad:=false;
end;

procedure qsortroads(l,r:integer);
var
  i,j:integer;
  x:troad;
begin
  i:=l;
  j:=r;
  x:=roads[(l+r) shr 1];
  repeat
    while lessroad(roads[i],x) do
      inc(i);
    while lessroad(x,roads[j]) do
      dec(j);
    if not(i>j) then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsortroads(l,j);
  if i<r then
    qsortroads(i,r);
end;

procedure nosol;
begin
  write(-1);
  close(input);
  close(output);
  halt(0);
end;

begin
  assign(input,'brides.in');
  reset(input);
  assign(output,'brides.out');
  rewrite(output);

  read(n,m,k);
  for z:=1 to m do begin
    read(roads[z].i,roads[z].j,roads[z].l);
    if roads[z].i>roads[z].j then begin
      i:=roads[z].i;
      roads[z].i:=roads[z].j;
      roads[z].j:=i;
    end;
    roads[z].n:=z;
  end;

  qsortroads(1,m);
  fillchar(count,sizeof(count),0);
  for z:=1 to m do begin
    inc(count[roads[z].i,roads[z].j]);
    inc(count[roads[z].j,roads[z].i]);
  end;
  for i:=1 to n do
    for j:=1 to n do begin
      if count[i,j]>k then
        count[i,j]:=k;
      a[i,j].c:=count[i,j];
  end;
  for z:=1 to m do begin
    l:=roads[z].l;
    i:=roads[z].i;
    j:=roads[z].j;
    if count[i,j]>0 then begin
      a[i,j].l[count[i,j]]:=l;
      a[i,j].n[count[i,j]]:=roads[z].n;
      dec(count[i,j]);
    end;
    j:=roads[z].i;
    i:=roads[z].j;
    if count[i,j]>0 then begin
      a[i,j].l[count[i,j]]:=l;
      a[i,j].n[count[i,j]]:=roads[z].n;
      dec(count[i,j]);
    end;
  end;

  time:=0;
  for q:=1 to k do begin
    for i:=2 to n do
      t[i]:=alot;
    t[1]:=0;
    from[1]:=0;
    fillchar(u,sizeof(u),false);
    while true do begin
      j:=n;
      for i:=1 to n-1 do begin
        if (not u[i]) and ((u[j]) or (t[i]<t[j])) then begin
          j:=i;
        end;
      end;
      if u[j] or (t[j]>=alot) then
        nosol;
      if j=n then
        break;
      u[j]:=true;
      for i:=1 to n do begin
        if a[j,i].c>0 then begin
          if t[i]>t[j]+a[j,i].l[a[j,i].c] then begin
            t[i]:=t[j]+a[j,i].l[a[j,i].c];
            from[i]:=j;
          end;
        end;
      end;
    end;
    time:=time+t[n];
    i:=n;
    ans[q].count:=0;
    while i<>1 do begin
      j:=from[i];
      inc(ans[q].count);
      ans[q].a[ans[q].count]:=a[i,j].n[a[i,j].c];
      dec(a[i,j].c);
      dec(a[j,i].c);
      i:=j;
    end;
  end;

  writeln(time/k:0:6);
  for q:=1 to k do begin
    write(ans[q].count);
    for i:=ans[q].count downto 1 do
      write(' ',ans[q].a[i]);
    writeln;
  end;

  close(input);
  close(output);
end.
