type
   integer = longint;

procedure init;
begin
   assign(input, 'minister.in'); reset(input);
   assign(output, 'minister.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

const
   maxn=2600;
   maxm=65536;
   white=0;
   grey=1;
   black=2;


var
   n, m: integer;
   d0, d1, sd: array[1..maxn] of integer;
   a, rd: array[1..maxn,1..maxn] of word;
   color, p: array[1..maxn] of byte;
   q:array[1..maxn] of integer;
   qq: integer;
   sr: array[1..maxm] of integer;
   rlen: array[1..maxm] of integer;
   ss,ee: array[1..maxm] of word;

function Relax(x, y: integer):boolean;
begin
   if d1[x]+a[x,y]<d1[y] then
   begin
    d1[y]:=d1[x]+a[x,y];
    p[y]:=x;
    Relax:=true;
   end
   else
    Relax:=false;
end;

procedure hea(x: integer);
var
    t1, o: integer;
begin
 repeat
   t1:=x*2;
   if t1>qq then exit;
   if (t1<qq)and(q[t1+1]<q[t1]) then
    inc(t1);
   if q[x]<q[t1] then exit;
   o:= q[x];
   q[x]:=q[t1];
   q[t1]:=o;
   x:=t1;
 until false;
end;

procedure push(x: integer);
var
   i, j, k: integer;
begin
   inc(qq);
   i:=qq;
   q[i]:=x;
   while (i>1)and(q[i div 2]>q[i]) do
   begin
    j:=i div 2;
    k:=q[j];
    q[j]:=q[i];
    q[i]:=k;
    i:=j;
   end;
end;


function extract: integer;
begin
   extract:=q[1];
   q[1]:=q[qq];
   dec(qq);
   hea(1);
end;

function empty: boolean;
begin
   empty:=qq=0;
end;

function max(a, b: integer): integer;
begin
   if a> b then max := a else max := b;
end;

procedure go;
var
   i, j, x, y, road: integer;
begin
   d1[1]:=0;
   for i:=2 to n do
    d1[i]:=maxlongint;
   fillchar(color,n,white);
   qq:=0;
   push(1);
   while (not empty)and(color[n]<>black) do
   begin
      x:= extract;
      color[x]:=grey;
      for y:= 1 to n do
       if a[x,y]<>maxlongint then
      begin
       if color[y]<>black then
       begin
        if color[y]=white then
         begin
         color[y]:=grey;
         Relax(x,y);
         Push(y);
         end
         else
          if Relax(x,y) then Push(y);
       end;
      end;
      color[x]:=black;
   end;
end;


procedure readinfo;
var
   i, j, k,o: integer;
begin
   readln(n, m);
   for i:=1 to n do
    read(d0[i]);
   for i:=1 to n do
    for j:=1 to n do
     a[i,j]:=65535;
   for i:=1 to m do
   begin
    read(j,k,o);
    rd[j,k]:=i;
    rd[k,j]:=i;
    a[j,k]:=o;
    a[k,j]:=o;
    ss[i]:=j;
    ee[i]:=k;
    rlen[i]:=o;
   end;
end;

procedure dfs(x: integer);
var
   i: integer;
begin
   for i:=1 to n do
    if a[x,i]<>65535 then
     if p[i]=x then
     begin
      dfs(i);
//      inc(sd[x,sd[i]);
      inc(sr[rd[x,i]],sd[i]);
     end;
//   inc(sd[x],d0[x]-d1[x]);
end;

procedure fgf;
var
   i: integer;
begin
   for i:=2 to n do
    begin
    sr[rd[p[i],i]]:=d0[i]-d1[i];
    inc(sd[p[i]],d0[i]-d1[i]);
    end;
end;

procedure dfscorr(x: integer);
var
   i, k, delta,j: integer;
begin
   for i:=1 to n do
    if a[x,i]<>65535 then
     if p[i]=x then
     begin
      k:=rd[x,i];
      if sr[k]<0 then
       if rlen[k]+sr[k]<0 then
       begin
        delta:=(rlen[k]+sr[k]);
        sr[k]:=rlen[k];
        for j:=1 to m do
        begin
         if (ss[j]=i)and(ee[j]<>x)then
          inc(sr[j],delta);
         if (ee[j]=i)and(ss[j]<>x)then
          inc(sr[j],delta);
        end;
       end;

     end;
end;

procedure corr;
var
    i,j,dl,pt: integer;
    f, f1: boolean;
begin
repeat
 f:=true;
 for i:=1 to m do
 begin
  dl:=rlen[i]+sr[i];
  if dl<0 then
  begin
   f:=false;
   f1:=false;
   if p[ss[i]]=ee[i] then pt:=ss[i] else pt:=ee[i];
   for j:=1 to m do
    if j<>i then
    begin
     if ss[j]=pt then
      begin inc(sr[j],dl);f1:=true; end;
     if ee[j]=pt then
      begin inc(sr[j],dl);f1:=true end;
    end;
  end;
 end;
until f or (f1=false);
if f then exit;
writeln('-1');
done;
halt(0);

end;

procedure res;
var
   i: integer;
   sum: integer;
begin
  sum:=0;
  for i:=1 to m do
   inc(sum,abs(sr[i]));
  writeln(sum);
  for i:=1 to m do
   writeln(rlen[i]+sr[i]);
end;

procedure solve;
begin
 readinfo;
 go;
 fgf;
 dfs(1);
 corr;
 res;


end;

begin
 init;
 solve;
 done;

end.
