type
   int = integer;
   integer = longint;


procedure init;
begin
   assign(input, 'dfs.in'); reset(input);
   assign(output, 'dfs.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

const maxn=10000;

type
   ptx=^tx;
   tx= record node: int; next: ptx; end;
   tm= array[1..maxn] of ptx;
var
   n: integer;
   m, m2: tm;
   c, c2: array[1..maxn] of integer;
   p: array[1..maxn] of int;


procedure readinfo;
var
   i, j: integer;
   x: ptx;
begin
   readln(n);
   for i:=2 to n do
    read(p[i]);
   for i:=1 to n do
   begin
    read(c[i]);
    for j:= 1 to c[i] do
    begin
     new(x);
     read(x^.node);
     x^.next:=m[i];
     m[i]:=x;
    end;
   end;
end;

procedure nosolution;
begin
 write('NO');
 done;
 halt(0);
end;

function find(q, w: integer): boolean;
var
   x: ptx;
begin
   x:=m2[q];
   while x<> nil do
   begin
    if x^.node= w then
     begin find:= true; exit end;
    x:=x^.next;
   end;
   find:=false;
end;


procedure add(q, w: integer);
var
   x: ptx;
begin
   if find(q,w) then
    exit;
{   if find(w,q) then
    nosolution;}
   new(x);
   x^.node:=w;
   x^.next:=m2[q];
   m2[q]:=x;
   inc(c2[q]);
end;


procedure BuildG2;
var
   i, j: integer;
   x:ptx;
begin
 for i:=2 to n do
  add(p[i],i);
 for i:=2 to n do
 begin
  x:=m[i];
  for j:=1 to c[i] do
  begin
   if (x^.node<>p[i])and(p[x^.node]<>i) then
   begin
{    add(i, x^.node);}
    add( x^.node, i);
   end;
   x:=x^.next;
  end;
 end;
end;

var
   t: integer;
   leave: array[1..maxn] of integer;
   color: array[1..maxn] of byte;
   nw: array[1..maxn] of integer;

procedure dfs(x: integer);
var
   y: ptx;
begin
   color[x]:=1;
   y:=m2[x];
   while y<>nil do
   begin
    if color[y^.node]=0 then
     dfs(y^.node);
    y:=y^.next;
   end;

   color[x]:=2;
   leave[x]:=t;
   dec(t);
end;


procedure sort;
begin
   t:=n;
   dfs(1);
end;

procedure testsort;
var
   i, j: integer;
   x: ptx;
begin
 for i:=1 to n do
  nw[leave[i]]:=i;
 for i:=1 to n do
 begin
  j:=nw[i];
  x:=m2[j];

  while x<> nil do
  begin
   if leave[x^.node]<i then
    nosolution;
   x:=x^.next;
  end;
 end;
end;

type
   ttx=array[1..500000] of int;
var
   ta: ttx;

procedure sortta(l,r: longint);
var
   i,j,x,y: longint;
begin
   i:=l;
   j:=r;
   x:=leave[ta[(l+r) div 2]];
   repeat
     while leave[ta[i]] < x do
      inc(i);
     while x < leave[ta[j]] do
      dec(j);
     if not(i>j) then
     begin
      y:=ta[i];
      ta[i]:=ta[j];
      ta[j]:=y;
      inc(i);
      dec(j);
     end;
   until i>j;
   if l<j then
     sortta(l,j);
   if i<r then
     sortta(i,r);
end;


procedure sr(w: integer);
var
   x: ptx;
   i,j: integer;
begin
 if c[w]=0 then
  begin writeln('0'); exit end;
 write(c[w],' ');
 x:=m[w];
 i:=0;
 while x<>nil do
 begin
  inc(i);
  ta[i]:=x^.node;
  x:=x^.next;
 end;

 if i = 0 then
   writeln
 else
 begin
  sortta(1,i);
  for j:=1 to i-1 do
   write(ta[j],' ');
  writeln(ta[i]);
 end;
end;

procedure sorttable;
var
   i: integer;
begin
   for i:=1 to n do
    begin
     sr(i);
    end;
end;

procedure destroyG2;
var
   i: integer;
   x,y: ptx;
begin
   for i:=1 to n do
   begin
    x:=m2[i];
    while x<>nil do
    begin
     y:=x^.next;
     dispose(x);
     x:=y;
    end;
    c2[i]:=0;
   end;
end;

procedure solve;
begin
   readinfo;
   buildG2;
   sort;
   testsort;
   writeln('YES');
   destroyG2;
   sorttable;
end;

begin
   init;
   solve;
   done;
end.


