{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
Uses balls;
const
  eps=1e-2;
  nm=25;
type
  Permutation = array [1..nm] of LongInt;
var
  a,q,res : Permutation;
  n,k,found,act : LongInt;
  p : Extended;
{}
Procedure Inp;
begin
  Init(n,k);
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  Finish(res);
  halt;
end;
{}
Procedure Rec(l,r : LongInt; var a : Permutation);
var
  i,j,p1,p2 : LongInt;
  b : Permutation;
  ver : Extended;
begin

  fillchar(b,sizeof(b),0);
  for i:=l to r do begin
    repeat
      j:=l+random(r-l+1);
    until b[j]=0;
    b[j]:=a[i];
  end;

  if p>eps then begin
    if trunc(1/p)-1>1 then j:=trunc(1/p)-1
                      else j:=1;
  end;

  if j>=r-l+1 then j:=r-l;

  p1:=l;
  repeat
    if p1+j-1>r then p2:=r
                else p2:=p1+j-1;
    fillchar(q,sizeof(q),0);
    for i:=p1 to p2 do q[b[i]]:=1;
    if IsRadioactive(q) then begin
      if p1<p2 then begin
        Rec(p1,p2,b);
      end else begin
        res[b[p1]]:=1;
        inc(found); inc(act);
        if act=k then begin
          for i:=1 to n do
            if res[i]=2 then res[i]:=0;
          Out;
        end;
        if found<n then
          p:=(k-act)/(n-found);
      end;
    end else begin
      for i:=p1 to p2 do begin
        res[b[i]]:=0;
        inc(found);
      end;
      if k-act=n-found then begin
        for i:=1 to n do
          if res[i]=2 then res[i]:=1;
        Out;
      end;

      if found<n then
        p:=(k-act)/(n-found);
    end;
    p1:=p2+1;
  until p1>r;
end;
{}
Procedure Solve;
var
  i : LongInt;
begin
  found:=0; act:=0;
  randseed:=2034761941;
  for i:=1 to n do res[i]:=2;
  for i:=1 to n do a[i]:=i;
  p:=k/n;

  if k=n then begin
    for i:=1 to n do res[i]:=1;
    Out;
  end else Rec(1,n,a);
end;
{}
Begin
  Inp;
  Solve;
  Out;
End.
