type
   int = integer;
   integer = longint;

procedure init;
begin
   assign(input, 'princess.in'); reset(input);
   assign(output, 'princess.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

const
   up=0;
   down=1;
   left=2;
   right=3;

   sx:array[0..3] of integer=(0,0,-1,1);
   sy:array[0..3] of integer=(-1,1,0,0);


var
   m, n, k: integer;
   exx: array[1..50,1..50] of boolean;
   bl:array[1..50,1..50] of integer;
   cg: array[0..51,0..51,0..3] of boolean;
   holx,holy:array[1..50,1..50] of int;
   hh: array[1..50,1..50]of boolean;
   stx,sty,enx,eny: integer;
   minimum: integer;


function c2n(c:char): integer;
begin
   case upcase(c) of
    'L':c2n:=left;
    'R':c2n:=right;
    'U':c2n:=up;
    'D':c2n:=down;
   end;
end;

function prot(v: integer): integer;
begin
   prot:=v xor 1;
end;
function s2s(s:string): integer;
begin
   while s[1]=' ' do delete(s,1,1);
   if s='P' then begin s2s:=2;exit end;
   if s='MT' then begin s2s:=4;exit end;
   if s='AM' then begin s2s:=6;exit end;
   if s='BA' then begin s2s:=8;exit end;
   if s='BU' then begin s2s:=10;exit end;
   if s='K' then begin s2s:=0;exit end;
end;

function conv(s: string): char;
var i: integer;
begin
   for i:=1 to length(s) do
    if s[i]<>' ' then
     begin
      conv:=s[i];
      exit;
     end;
end;

procedure readinfo;
var
   i, j, k, l, v, aa,ss,zz,xx,qq,ww: integer;
   c: char;
   s: string;
begin
   fillchar(cg,sizeof(cg),true);
   readln(m, n);

   readln(k);
   for i:=1 to k do
   begin
      readln(k,l,S);
      exx[k,l]:=true;
   end;

   readln(j);
   for i:=1 to j do
   begin
      readln(k,l,s);
      inc(bl[k,l],s2s(s));
   end;

   for i:=1 to m do
   begin
    cg[i,1,up]:=false;
    cg[i,n,down]:=false;
   end;
   for i:=1 to n do
   begin
    cg[1,i,left]:=false;
    cg[m,i,right]:=false;
   end;

   readln(j);
   for i:=1 to j do
   begin
      readln(k,l,s);
      c:=conv(s);
      v:=c2n(c);
      cg[k,l,v]:=false;
      cg[k+sx[v],l+sy[v],prot(v)]:=false;
   end;


   for i:=1 to m do
    for j:=1 to n do
    begin
      holx[i,j]:=i;
      holy[i,j]:=j;
    end;

   readln(j);
   for i:=1 to j do
   begin
     read(k);
     read(aa,ss);
     qq:=aa;ww:=ss;
     for l:=1 to k-1 do
     begin
       read(zz,xx);
       holx[aa,ss]:=zz;
       holy[aa,ss]:=xx;
       hh[aA,ss]:=true;
       aa:=zz;
       ss:=xx;
     end;
     holx[aa,ss]:=qq;
     holy[aa,ss]:=ww;
     hh[aa,ss]:=true;
   end;

   readln(stx,sty);
   readln(enx,eny);
end;

var pat: integer;
    was: array[1..50,1..50] of word;
    path, bestpath, path2, bestpath2: array[1..4000] of record xx,yy: int end;
    pl, plbest,pl2, plbest2: integer;
    expoint: record x,y: integer; end;

procedure savepath;
begin
   plbest:=pl;
   bestpath:=path;
end;
procedure savepath2;
begin
   plbest2:=pl2;
   bestpath2:=path2;
end;

procedure pushstack(x,y: int);
begin
   inc(pl);
   path[pl].xx:=x;
   path[pl].yy:=y;
end;
procedure popstack;
begin
   dec(pl);
end;

procedure pushstack2(x,y: int);
begin
   inc(pl2);
   path2[pl2].xx:=x;
   path2[pl2].yy:=y;
end;
procedure popstack2;
begin
   dec(pl2);
end;

procedure go1(x,y: int);
begin
   if pat>=minimum then exit;
   if was[x,y]>=2 then exit;

   if (x=enx)and(y=eny) then
     begin
     savepath;
     minimum:=pat;
     exit;
     end;
   if (pl>0)and(path[pl].xx=x)and(path[pl].yy=y) then exit;
   if (was[x,y]=0) then
    inc(pat,bl[x,y]);


   inc(was[x,y]);
   inc(pl);
   path[pl].xx:=x;
   path[pl].yy:=y;

   if (cg[x,y,up]) then
   begin
     if hh[x+sx[up],y+sy[up]] then pushstack(x+sx[up],y+sy[up]);
     go1(holx[x+sx[up],y+sy[up]], holy[x+sx[up],y+sy[up]]);
     if hh[x+sx[up],y+sy[up]] then popstack;
   end;

   if (cg[x,y,left]) then
   begin
     if hh[x+sx[left],y+sy[left]] then pushstack(x+sx[left],y+sy[left]);
     go1(holx[x+sx[left],y+sy[left]], holy[x+sx[left],y+sy[left]]);
     if hh[x+sx[left],y+sy[left]] then popstack;
   end;

   if (cg[x,y,down]) then
   begin
     if hh[x+sx[down],y+sy[down]] then pushstack(x+sx[down],y+sy[down]);
     go1(holx[x+sx[down],y+sy[down]], holy[x+sx[down],y+sy[down]]);
     if hh[x+sx[down],y+sy[down]] then popstack;
   end;

   if (cg[x,y,right]) then
   begin
     if hh[x+sx[right],y+sy[right]] then pushstack(x+sx[right],y+sy[right]);
     go1(holx[x+sx[right],y+sy[right]], holy[x+sx[right],y+sy[right]]);
     if hh[x+sx[right],y+sy[right]] then popstack;
   end;


   if (hh[x,y]) then
     go1(holx[x,y],holy[x,y]);


   dec(pl);
   dec(was[x,y]);

   if (was[x,y]=0) then
    dec(pat,bl[x,y]);
end;

procedure go2(x,y: int);
begin
   if pat>=minimum then exit;
   if exx[x,y] then
     begin
     savepath2;
     minimum:=pat;
     expoint.x:=x;
     expoint.y:=y;
     exit;
     end;
   if was[x,y]>=2 then exit;
   if (pl2>0)and(path2[pl2].xx=x)and(path2[pl2].yy=y) then exit;
   if (was[x,y]=0) then
    inc(pat,bl[x,y]);



   inc(was[x,y]);
   inc(pl2);
   path2[pl2].xx:=x;
   path2[pl2].yy:=y;

   if (cg[x,y,up]) then
   begin
     if hh[x+sx[up],y+sy[up]] then pushstack2(x+sx[up],y+sy[up]);
     go2(holx[x+sx[up],y+sy[up]], holy[x+sx[up],y+sy[up]]);
     if hh[x+sx[up],y+sy[up]] then popstack2;
   end;

   if (cg[x,y,left]) then
   begin
     if hh[x+sx[left],y+sy[left]] then pushstack2(x+sx[left],y+sy[left]);
     go2(holx[x+sx[left],y+sy[left]], holy[x+sx[left],y+sy[left]]);
     if hh[x+sx[left],y+sy[left]] then popstack2;
   end;

   if (cg[x,y,down]) then
   begin
     if hh[x+sx[down],y+sy[down]] then pushstack2(x+sx[down],y+sy[down]);
     go2(holx[x+sx[down],y+sy[down]], holy[x+sx[down],y+sy[down]]);
     if hh[x+sx[down],y+sy[down]] then popstack2;
   end;

   if (cg[x,y,right]) then
   begin
     if hh[x+sx[right],y+sy[right]] then pushstack2(x+sx[right],y+sy[right]);
     go2(holx[x+sx[right],y+sy[right]], holy[x+sx[right],y+sy[right]]);
     if hh[x+sx[right],y+sy[right]] then popstack2;
   end;

   if (hh[x,y]) then
     go2(holx[x,y],holy[x,y]);



   dec(pl2);
   dec(was[x,y]);
   if (was[x,y]=0) then
    dec(pat,bl[x,y]);

end;


procedure processpath;
var i: integer;
begin
   fillchar(was,sizeof(was),0);
   for i:=1 to plbest do
    was[bestpath[i].xx,bestpath[i].yy]:=1;
end;

procedure writeres;
var i: integer;
begin
   if minimum=maxlongint then
    begin writeln('-1');exit end;
   writeln(minimum);
   if (bestpath[1].xx<>stx)or(bestpath[1].yy<>sty) then
     writeln(stx,' ',sty);
   for i:=1 to plbest do
      writeln(bestpath[i].xx,' ',bestpath[i].yy);
//   writeln(enx,' ',eny);
   for i:=1 to plbest2 do
      writeln(bestpath2[i].xx,' ',bestpath2[i].yy);
   with expoint do
      writeln(x,' ',y);
end;

procedure solve;
begin
  readinfo;
  minimum:=maxlongint;
  pat:=0;
  pl:=0;
  pl2:=0;
  go1(holx[stx,sty],holy[stx,sty]);
  if minimum<>maxlongint then
  begin
    processpath;
    pat:=minimum;
    minimum:=maxlongint;
    go2(enx,eny);
  end;
  writeres;

end;

begin
 init;
 solve;
 done;
end.

