{$H+}
const
     FileIn='aliens.in';
     FileOut='aliens.out';
var
   N: LongInt;
   Greeting: string;
   Song: string;
   Possible: Boolean;
   AnswerCount: LongInt;
   Answer: string;

procedure ReadData;
var
   F: Text;
   S: string;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     Readln (F, Greeting);
     Readln (F, Song);
     while not EOF (F)
           do begin
              Readln (F, S);
              Song:=Song+#10+S;
           end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Possible
        then begin
             Writeln (F, AnswerCount);
             Writeln (F, Answer);
        end
        else Writeln (F, 'IMPOSSIBLE');
     Close (F);
end;

function Match (aGreetCh, aSongCh: Char): Boolean;
begin
     if aGreetCh=#32
        then Match:=aSongCh in [#10, #32]
        else Match:=aGreetCh=aSongCh;
end;

function Min (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Min:=aA
        else Min:=aB;
end;

{Define Check}
procedure Solve;
var
   NChar, Index: LongInt;
begin
     AnswerCount:=0;
     Answer:=Song;
     Possible:=true;
     for NChar:=1 to Length (Greeting)
         do begin
            if (NChar*N>Length (Answer)) or (not Match (Greeting [NChar], Answer [NChar*N]))
               then begin
                    Possible:=false;
                    for Index:=Min (NChar*N-1, Length (Answer)) downto 1
                        do if Match (Greeting [NChar], Answer [Index])
                              then begin
                                   Possible:=true;
                                   Break;
                              end;
                    if not Possible
                       then Exit;
                    Possible:=false;
                    for Index:=Index downto (NChar-1)*N+1
                        do if Answer [Index] in [#32, #10]
                              then begin
                                   Possible:=true;
                                   Break;
                              end;
                    if not Possible
                       then Exit;
                    Answer:=Copy (Answer, 1, Index)+#32+Copy (Answer, Index+1, Length (Answer));
                    Inc (AnswerCount);
                    Dec (NChar);
               end;
         end;
     {$IfDef Check}
     if Possible
        then for NChar:=1 to Length (Greeting)
                 do if not Match (Greeting [NChar], Answer [NChar*N])
                       then Writeln ('ALARM! Mismatch ', NChar);
     {$EndIf}
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
