{$I-,Q-,R-,S-}
const
  MAXL = 1005;
  MAXK = 55;
  MAXN = 255;

  SPACE_SYMBOL: Char = ' ';
type
  Integer = Longint;
  Alph = array [#0..#255] of Integer;
var
  n, k, l, Spaces: Integer;
  p, s, s2: AnsiString;
  a, pr: array[0..MAXK, 0..MAXL] of Integer;
  Link: array[0..MAXK, 0..MAXL] of record
    t, i: integer
  end;
  NNew: array[0..MAXL] of Boolean;

procedure Init();
var Ch: Char;
    i: Integer;
begin
  Assign(Input, 'aliens.in');
  Reset(Input);
  Assign(Output, 'aliens.out');
  Rewrite(Output);

  Readln(n);
  Readln(p);
  s := '';
  Ch := ' ';
  while not Eof() and (Ch in [#32..#255, #10, #13]) do
  begin
    Read(Ch);
    if Ch <> #13 then
      if Ch = #10 then s := s + #21 else s := s + Ch;
  end;

  k := Length(p);
end;

procedure Done(const IsOk: Boolean);
var i: Integer;
begin
  if not IsOk then Writeln('IMPOSSIBLE') else
  begin
    Writeln(Spaces);
    for i := 1 to Length(s) do
      if s[i] = #21 then Writeln else Write(s[i]);
  end;
  Close(Input);
  Close(Output);
  Halt;
end;

function InsertSpaces(const k1, k2, n: Integer): Boolean;
var i, j: Integer;
    SpS: String;
begin
  if n = 0 then
  begin
    InsertSpaces := True;
    Exit;
  end;
  for i := k1 to k2 do if (s[i] = ' ') or (s[i] = #21) then
  begin
    SpS := '';
    for j := 1 to n do SpS := SpS + SPACE_SYMBOL;
    Insert(SpS, s, i);
    InsertSpaces := True;
    Exit;
  end;
  InsertSpaces := False;
end;

function Rec(const t, i: Integer): Boolean;
var t1, i1: Integer;
begin
  t1 := Link[t, i].t;
  i1 := Link[t, i].i;
  if not InsertSpaces(pr[t1, i1] + 1, pr[t, i], a[t, i] - a[t1, i1]) then
  begin
    Rec := False;
    Exit;
  end;
  if t > 0 then Rec := Rec(t1, i1) else Rec := True;
end;

procedure Solve();
var t, i, Min, Mn: Integer;
begin
  for t := 1 to k + 1 do
    for i := 0 to Length(s) + 1 do a[t, i] := -1;

  for t := 1 to k do
    for i := 1 to Length(s) do
    begin
      if a[t - 1][i - 1] > -1 then
        if (s[i] = p[t]) and (i + a[t - 1][i - 1] <= n * t) then
        begin
          a[t][i] := a[t - 1][i - 1] + n * t - (i + a[t - 1][i - 1]);
          pr[t][i] := i;
          Link[t][i].i := i - 1;
          Link[t][i].t := t - 1;
        end;

      if (a[t][i - 1] > -1) and ((a[t][i - 1] < a[t][i]) or (a[t][i] = -1)) then
      begin
        a[t][i] := a[t][i - 1];
        pr[t][i] := pr[t][i - 1];
        Link[t][i].i := Link[t][i - 1].i;
        Link[t][i].t := Link[t][i - 1].t;
      end;
    end;

  s2 := s;
  repeat
    Min := MAXLONGINT;
    s := s2;
    for i := 1 to Length(s) do if (a[k, i] < Min) and (a[k, i] > -1) and not NNew[i] then
    begin
      Min := a[k, i];
      Spaces := Min;
      Mn := i;
    end;
    NNew[Mn] := True;
    if Min = MAXLONGINT then Done(False);
  until Rec(k, Mn);
end;

begin
  Init();
  Solve();
  Done(True);
end.
