{$APPTYPE CONSOLE}
const maxn=30005;
      sz=1000005;
      ampq=3*maxn;
      ambt=1 shl 20;
var ans,npq,n,nx,ny,tt,nt:longint;
    x,y:array[1..maxn] of longint;
    pq:array[1..ampq] of longint;
    qpq:array[0..sz] of longint;
    bt:array[1..2*ambt] of longint;

procedure init;
begin
 fillchar(bt,sizeof(bt),0);
 fillchar(qpq,sizeof(qpq),0);
end;

procedure readdata;
var i:longint;
begin
 read(n,nx,ny);
 for i:=1 to n do
 read(x[i],y[i]);
end;

function max(a,b:longint):longint;
begin
 if a>b then
  max:=a
 else
  max:=b;
end;

function min(a,b:longint):longint;
begin
 if a<b then
  min:=a
 else
  min:=b;
end;

procedure swap(var a,b:longint);
var t:longint;
begin
 t:=a;a:=b;b:=t;
end;

procedure qsort(l,r:longint);
var i,j,xx:longint;
begin
 if l<r then
  begin
   i:=l;j:=r;
   xx:=x[(l+r) shr 1];
   repeat
    while x[i]<xx do i:=i+1;
    while x[j]>xx do j:=j-1;
    if i<=j then
     begin
      swap(x[i],x[j]);
      swap(y[i],y[j]);
      i:=i+1;j:=j-1;
     end;
   until i>j;
   qsort(l,j);
   qsort(i,r);
  end;
end;

procedure findbefore(x:longint;var xb:longint);
begin
 if x=0 then
  begin
   xb:=0;
   exit;
  end;
 x:=x+ambt-1;
 while bt[x]=0 do
 x:=(x-1) shr 1;
 while x<ambt do
 begin
  x:=x shl 1;
  if bt[x+1]>0 then
   x:=x+1;
 end;
 xb:=x-ambt;
end;

procedure findafter(x:longint;var xa:longint);
begin
 if x=ny then
  begin
   xa:=ny;
   exit;
  end;
 x:=x+ambt+1;
 while bt[x]=0 do
 x:=(x+1) shr 1;
 while x<ambt do
 begin
  x:=x shl 1;
  if bt[x]=0 then
   x:=x+1;
 end;
 xa:=x-ambt;
end;

procedure addbt(x,d:longint);
begin
 x:=x+ambt;
 while x>0 do
 begin
  bt[x]:=bt[x]+d;
  x:=x shr 1;
 end;
end;

procedure deletefictpq;
var t,x,x0:longint;
begin
 while qpq[pq[1]]=0 do
 begin
  t:=pq[npq];
  pq[npq]:=0;
  npq:=npq-1;
  x0:=1;x:=2;
  while (x<=npq) and (max(pq[x],pq[x+1])>t) do
  begin
   if (x<npq) and (pq[x+1]>pq[x]) then
    x:=x+1;
   pq[x0]:=pq[x];
   x0:=x;
   x:=x shl 1;
  end;
  pq[x0]:=t;
 end;
end;

procedure addpq(x:longint);
var i:longint;
begin
 qpq[x]:=qpq[x]+1;
 npq:=npq+1;
 i:=npq;
 while (i>1) and (x>pq[i shr 1]) do
 begin
  pq[i]:=pq[i shr 1];
  i:=i shr 1;
 end;
 pq[i]:=x;
end;

procedure deletepq(x:longint);
begin
 qpq[x]:=qpq[x]-1;
end;

procedure addrightpoint(py:longint);
var yb,ye:longint;
begin
 findbefore(py,yb);
 findafter(py,ye);
 if (bt[py+ambt]>0) and (yb<py) and (py<ye) then
  ye:=py;
 addbt(py,1);
 deletepq(ye-yb);
 addpq(py-yb);
 addpq(ye-py);
end;

procedure deleteleftpoint(py:longint);
var yb,ye:longint;
begin
 findbefore(py,yb);
 findafter(py,ye);
 addbt(py,-1);
 if (bt[py+ambt]>0) and (yb<py) and (py<ye) then
  ye:=py;
 deletepq(py-yb);
 deletepq(ye-py);
 addpq(ye-yb);
end;

procedure initcase;
begin
 x[n+1]:=0;y[n+1]:=0;
 x[n+2]:=nx;y[n+2]:=ny;
 n:=n+2;
 qsort(1,n);
 npq:=0;addpq(ny);
 addbt(0,1);addbt(ny,1);
 ans:=0;
end;

procedure deletecase;
begin
 deletepq(ny);
 addbt(0,-1);addbt(ny,-1);
end;

procedure solve;
var i,j:longint;
begin
 initcase;
 i:=1;j:=1;
 while i<=n do
 begin
  deletefictpq;
  if j<=n then
   ans:=max(ans,min(pq[1],x[j]-x[i]));
  if (i=j) or (j<=n) and (pq[1]>x[j]-x[i]) then
   begin
    j:=j+1;
    if i+1<j then
     addrightpoint(y[j-1]);
   end
  else
   begin
    i:=i+1;
    if i<j then
     deleteleftpoint(y[i]);
   end;
 end;
 deletecase;
end;

procedure outdata;
begin
 writeln(ans);
end;

begin
 assign(input,'square.in');
 reset(input);
 assign(output,'square.out');
 rewrite(output);
 readdata;
 solve;
 outdata;
 close(output);
end.
