{$apptype console}
{$o-,q+,r+}
uses math, sysutils;
type
  int = integer;
  bool = boolean;
  real = extended;

var
  tn, n, i, j : int;
  conv, b1, b2 : bool;
  total : real;
  x, y : array[0..1000001] of real;
  dx1, dy1, dx2, dy2, dp, cp : real;

begin
  assign(input, 'convex.in');
  reset(input);
  assign(output, 'convex.out');
  rewrite(output);
  read(tn);
  while true do
  begin
    read(n);
    dec(tn);
    for i := 0 to n - 1 do
      read(x[i], y[i]);
    if (x[0] <> x[n - 1]) or (y[0] <> y[n - 1]) then
      conv := false
    else
    begin
      dec(n);
      j := 1;
      for i := 1 to n - 1 do
        if (x[i] <> x[i - 1]) or (y[i] <> y[i - 1]) then
        begin
          x[j] := x[i];
          y[j] := y[i];
          inc(j);
        end;
      n := j;
      x[n] := x[0];
      y[n] := y[0];
      x[n + 1] := x[1];
      y[n + 1] := y[1];
      if n < 3 then
        conv := false
      else
      begin
        b1 := false;
        b2 := false;
        total := 0;
        for i := 0 to n - 1 do
        begin
          dx1 := x[i + 1] - x[i];
          dy1 := y[i + 1] - y[i];
          dx2 := x[i + 2] - x[i + 1];
          dy2 := y[i + 2] - y[i + 1];
          dp := dx1 * dx2 + dy1 * dy2;
          cp := dx1 * dy2 - dx2 * dy1;
          if cp > 0 then
            b1 := true
          else if cp < 0 then
            b2 := true
          else if dp < 0 then
          begin
            b1 := true;
            b2 := true;
            break;
          end
          else
            assert(dp > 0);

          total := total + arctan2(cp, dp);
        end;
        if b1 and b2 then
          conv := false
        else
          conv := (abs(total - 2 * pi) < pi) or (abs(total + 2 * pi) < pi);
      end;
    end;
    if conv then
      writeln('YES')
    else
      writeln('NO');
    if tn = 0 then
      break;
  end;
  close(output);
end.
