{$apptype console}

{Dmitry Orlov}

{$R+,S+,I+,Q+}

program template;
const
 nmax = 21;
 mmax = 101;
 kmax = 21;
 osn = 100000000;
 dig = 8;
 lenmax = 20;
 cinfile = 'input.txt';
 coutfile = 'output.txt';
type
 int = integer;
 real = extended;
 tlong = array [0..lenmax] of int;
var
 n,m,k :int;
 e :array [1..nmax,'a'..'z'] of int;
 suflink :array [1..nmax] of int;
 d :array [0..mmax,0..kmax,1..nmax] of tlong;
 s :string;
 ans :tlong;

procedure init;
begin
 fillchar (e,sizeof(e),0);
 fillchar (suflink,sizeof(suflink),0);
 fillchar (ans,sizeof(ans),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (s);
 read (m,k);
 close (input);
end;

procedure outdata;
var i,j :int;
    st :string;
begin
 assign (output,coutfile);
 rewrite (output);
 write (ans[ans[0]]);
 for i := ans[0]-1 downto 1 do
  begin
   str (ans[i],st);
   while length(st) < dig do
    st := '0' + st;
   write (st);
  end;
 close (output);
end;

procedure summ (var a,b :tlong);
var i :int;
    tmp :int;
    ost :int;
begin
 if b[0] > a[0] then
  a[0] := b[0];
 ost := 0;
 for i := 1 to a[0] do
  begin
   tmp := a[i] + b[i] + ost;
   if tmp >= osn then
    begin
     a[i] := tmp - osn;
     ost := 1;
    end
   else
    begin
     a[i] := tmp;
     ost := 0;
    end; 
  end;
 if ost > 0 then
  begin
   inc (a[0]);
   a[a[0]] := ost;
  end; 
end;


procedure solve;
var i,j,l :int;
    c :char;
begin
 n := length(s) + 1;
 for i := 1 to length(s) do
  e[i,s[i]] := i+1;
 for c := 'a' to 'z' do
  if e[1,c] = 0 then
   e[1,c] := 1;
 for i := 2 to n do
  begin
   if (i = 2) then
    suflink[i] := 1
   else
    suflink[i] := e[suflink[i-1],s[i-1]];
   for c := 'a' to 'z' do
    if (e[i,c] = 0) then
     e[i,c] := e[suflink[i],c];
  end;
 for i := 0 to m do
  for j := 0 to k+1 do
   for l := 1 to n do
    fillchar (d[i,j,l],sizeof(d[i,j,l]),0);
 d[0,0,1][0] := 1;
 d[0,0,1][1] := 1;
 for i := 0 to m-1 do
  for j := 0 to k do
   for l := 1 to n do
    for c := 'a' to 'z' do
     begin
      if (e[l,c] = n) then
       summ (d[i+1,j+1,e[l,c]],d[i,j,l])
      else
       summ (d[i+1,j,e[l,c]],d[i,j,l]);
     end;
 for l := 1 to n do
  summ (ans,d[m,k,l]);     
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.