program p14_C;
const infile = 'dvd.in';
      outfile = 'dvd.out';
      MAXN = 2000;
type t1 = record
  year, reg:integer;
  tit:string[100];
end;
     t2 = record
  jt, jk:integer;
  b:boolean;
end;

var fl:array[1..MAXN]of t1;
    p:array[1..MAXN]of integer;
{    res:array[1..MAXN, 0..5]of integer;
    oh:array[1..MAXN, 0..5]of t2;}
    N, heapsize:integer;

procedure swap(var a, b:integer);
var t:integer;
begin
  t:=a; a:=b; b:=t;
end;

procedure swap(var a, b:longint);
var t:longint;
begin
  t:=a; a:=b; b:=t;
end;

procedure Heapify(i:longint);
var l, r, largest:longint;
begin
  l:=2*i; r:=2*i+1; largest:=i;
  if (l<=heapsize)and((fl[p[l]].year>fl[p[i]].year)or((fl[p[l]].year=fl[p[i]].year)and(fl[p[l]].reg>fl[p[i]].reg)))
    then largest:=l;
  if (r<=heapsize)and((fl[p[r]].year>fl[p[largest]].year)or((fl[p[r]].year=fl[p[largest]].year)and(fl[p[r]].reg>fl[p[largest]].reg)))
    then largest:=r;
  if (largest<>i) then begin swap(p[i], p[largest]); Heapify(largest); end;
end;

procedure BuildHeap;
var i:longint;
begin
  heapsize:=N;
  for i:=heapsize div 2 downto 1 do Heapify(i);
end;

procedure HeapSort;
var i:longint;
begin
  BuildHeap;
  for i:=N downto 2 do
  begin
    swap(p[i], p[1]);
    dec(heapsize);
    Heapify(1);
  end;
end;


procedure inp;
var i:integer;
    ch:char;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  readln(N);
  for i:=1 to N do
  begin
    read(ch); fl[i].tit:='"';
    repeat read(ch); fl[i].tit:=fl[i].tit+ch; until ch='"';
    read(fl[i].year, fl[i].reg);
    readln;
  end;
  for i:=1 to N do p[i]:=i;
end;

procedure run;
{var i, j, k, max, jt, jk:integer;
    c:array[1..MAXN]of integer;
    b:boolean;}
begin
  HeapSort;
{  fillchar(res, sizeof(res), 255);
  res[1][5]:=1; fillchar(oh, sizeof(oh), 0);
  for i:=2 to N do
    for k:=0 to 5 do
    begin
      max:=-1; jt:=0; jk:=0; b:=false;
      for j:=1 to N do
      begin
        if i=j then continue;
        if fl[j].year>fl[i].year then break;
        if res[j][k]>max then begin max:=res[j][k]; jt:=j; b:=false; end;
        if fl[p[j]].reg=fl[p[i]].reg then
          begin
            if (res[j][k]+1>max)and(res[j][k]<>-1) then begin max:=res[j][k]+1; jt:=j; jk:=k; b:=true; end;
          end
        else
          begin
            if k=5 then continue;
            if (res[j][k+1]+1>max)and(res[j][k+1]<>-1) then begin max:=res[j][k+1]+1; jt:=j; jk:=j+1; b:=true; end;
          end;
      end;
      res[i][k]:=max; oh[i][k].jt:=jt; oh[i][k].jk:=jk; oh[i][k].b:=b;
    end; max:=0;
  for i:=1 to 5 do if res[N][i]>max then max:=i;
  writeln(res[N][max]); if oh[N][max].b then c[res[N][max]]:=N else c[max]:=oh[N][max].jt;}
end;

procedure outp;
var i:longint;
begin
  writeln(N);
  for i:=1 to N do writeln(fl[p[i]].tit);
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
