#include <stdio.h>
#include <stdlib.h>

#define NN 131072
#define MANY 1100000000

FILE *fi, *fo;
int a[2*NN];
int n;

int min(int a, int b)
{
  return (a<b)?a:b;
}

void set(int ind)
{
  int i,j;
  i=ind*2+1;
  j=ind*2+2;
  if(i<2*NN-1)
  {
    a[ind]=a[i];
  }
  if(j<2*NN-1)
  {
    a[ind]=min(a[i],a[j]);
  }
}

void build()
{
  int i;
  for(i=2*NN-2;i>=0;i--)
    set(i);
}

int getparent(int x)
{
  return (x-1)/2;
}

int rmq(int x, int y)
{
  int i,j;
  if(x==y)
    return a[x];
  if(x>y)
    return MANY;
  i=getparent(x+1);
  j=getparent(y-1);
  return min(min(rmq(i,j),a[x]),a[y]);
}

int get(int ind)
{
  return a[ind+NN-1];
}

void put(int ind, int val)
{
  a[ind+NN-1]=val;
}

int main()
{
  int i,j;
  int s;
  fi=fopen("seq.in","rt");
  fo=fopen("seq.out","wt");

  for(i=0;i<2*NN;i++)
    a[i]=MANY;
  fscanf(fi,"%d",&n);
  s=0;
  for(i=0;i<n;i++)
  {
    fscanf(fi,"%d",&j);
    s+=j;
    put(i,s);
  }
  build();
  s=0;
  j=rmq(NN-1,n+NN-2);
  if(j>0)
    s++;
  for(i=1;i<n;i++)
  {
    j=rmq(i+NN-1,n+NN-2);
    if(j>get(i-1))
    {
      j=rmq(NN-1,i+NN-2);
      if(j+get(n-1)>get(i-1))
        s++;
    }
  }
  fprintf(fo,"%d\n",s);

  fclose(fi);
  fclose(fo);
  return 0;
}
