#include <stdio.h>
#include <stdlib.h>

#define YY 2005
#define LL 110
#define NN 2010
#define KK 6
#define FF 5000

struct FILM {
  char name[LL];
  int tm;
  int r;
};

FILE *fi, *fo;
FILM a[NN];
int c[YY][KK];
int b[NN][KK][KK];
int dx[NN][KK][KK];
int dy[NN][KK][KK];
int n;
int sw[FF][KK];
int swl[FF];
int ss[KK];
bool used[KK];
int cl;
int sws=0;

void readfilm(FILM *p)
{
  int c;
  int i;
  while((c=getc(fi))!='\"') ;
  i=0;
  while((c=getc(fi))!='\"')
    p->name[i++]=c;
  p->name[i]='\0';
  fscanf(fi,"%d%d",&p->tm,&p->r);
  p->r--;
}

void sort()
{
  FILM t;
  int i,j;
  for(i=0;i<n;i++)
  {
    for(j=i+1;j<n;j++)
    {
      if(a[j].tm<a[i].tm)
      {
        t=a[j];
        a[j]=a[i];
        a[i]=t;
      }
    }
  }
}

void buildc()
{
  int i,j,l;
  for(i=0;i<YY;i++)
    for(j=0;j<KK;j++)
      c[i][j]=0;
  for(i=0;i<n;i++)
    c[a[i].tm][a[i].r]++;
}

void solv()
{
  int i,j,l;
  int ii,jj;
  for(i=0;i<YY;i++)
  {
    for(j=0;j<KK;j++)
    {
      for(l=0;l<KK;l++)
      {
        b[i][j][l]=0;
      }
    }
  }
  for(i=1850;i<YY;i++)
  {
    for(j=0;j<KK;j++)
    {
      for(ii=0;ii<KK;ii++)
      {
        b[i][j][ii]=c[i][j];
        dx[i][j][ii]=-1;
        dy[i][j][ii]=-1;
        for(jj=1850;jj<i;jj++)
        {
          for(l=0;l<KK;l++)
          {
            if(l!=j)
            {
              if(ii>0)
              {
                if(b[i][j][ii]<c[i][j]+b[jj][l][ii-1])
                {
                  dx[i][j][ii]=jj;
                  dy[i][j][ii]=l;
                  b[i][j][ii]=c[i][j]+b[jj][l][ii-1];
                }
              }
            }
            else
            {
              if(b[i][j][ii]<c[i][j]+b[jj][l][ii])
              {
                dx[i][j][ii]=jj;
                dy[i][j][ii]=l;
                b[i][j][ii]=c[i][j]+b[jj][l][ii];
              }
            }
          }
        }
      }
    }
  }
}

int findmx(int *x, int *y, int *z)
{
  int i,j,k;
  int m;
  m=-1;
  for(i=1850;i<YY;i++)
  {
    for(j=0;j<KK;j++)
    {
      for(k=0;k<KK;k++)
      {
        if(b[i][j][k]>m)
        {
          m=b[i][j][k];
          *x=i;
          *y=j;
          *z=k;
        }
      }
    }
  }
}

void wrk(int x, int y)
{
  int i,j;
  for(i=0;i<n;i++)
  {
    if((a[i].tm==x)&&(a[i].r==y))
    {
      fprintf(fo,"\"");
      for(j=0;a[i].name[j]!='\0';j++)
        fprintf(fo,"%c",a[i].name[j]);
      fprintf(fo,"\"\n");
    }
  }
}

void wr(int x, int y, int z)
{
  if((dx[x][y][z]>=0)&&(dy[x][y][z]>=0))
  {
    if(dy[x][y][z]==y)
      wr(dx[x][y][z],dy[x][y][z],z);
    else
      wr(dx[x][y][z],dy[x][y][z],z-1);
  }
  wrk(x,y);
}

void gsv(int v)
{
  if(v>=cl)
  {
    int i;
    for(i=0;i<cl;i++)
    {
      sw[sws][i]=ss[i];
    }
  }
}

int main()
{
  int i,j,k;
  fi=fopen("dvd.in","rt");
  fo=fopen("dvd.out","wt");

  fscanf(fi,"%d",&n);
  for(i=0;i<n;i++)
    readfilm(&a[i]);
  sort();
  buildc();
  solv();
  findmx(&i,&j,&k);
  fprintf(fo,"%d\n",b[i][j][k]);
  wr(i,j,k);

  fclose(fi);
  fclose(fo);
}
