{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const MaxN = 100000;

Var I, N, Sub, Kol, S: Longint;
    A: array[1..MaxN] of Integer;
    P: array[1..MaxN] of Longint;
    H: array[0..MaxN] of Record
                           K: Longint;
                           P: Longint;
                         End;

Procedure Swap(var A, B: Longint);
Var C: Longint;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure SwapHeapElement(var X: Longint; Y: Longint);
Begin
  Swap(P[H[X].P], P[H[Y].P]);
  Swap(H[X].P, H[Y].P);
  Swap(H[X].K, H[Y].K);
  X := Y;
End;

Procedure MoveUp(X: Longint);
Begin
  While (X > 1) and (H[X].K < H[X shr 1].K) do
    SwapHeapElement(X, X shr 1);
End;

Procedure MoveDown(X: Longint);
Var Min: Longint;
Begin
  While (X shl 1 <= H[0].K) do Begin
    Min := X shl 1;
    If Min < H[0].K Then
      If H[Min + 1].K < H[Min].K Then Inc(Min);
    If H[X].K > H[Min].K
    Then
      SwapHeapElement(X, Min)
    Else
      Break;
  End;
End;

Procedure UpDate(X: Longint);
Begin
  If (X > 1) and (H[X].K < H[X shr 1].K) Then MoveUp(X)
                                         Else MoveDown(X);
End;

Begin
  Assign(Input, 'seq.in');
  Assign(Output, 'seq.out');
  Reset(Input);
  Rewrite(Output);
  Read(N);
  For I := 1 to N do Begin
    Read(A[I]);
    Inc(S, A[I]);
    Inc(H[0].K);
    H[H[0].K].K := S;
    H[H[0].K].P := I;
    P[I] := H[0].K;
    UpDate(H[0].K);
  End;
  For I := 1 to N do Begin
    Inc(Sub, A[I]);
    If I = 1 Then H[P[1]].K := H[P[N]].K + A[1]
             Else H[P[I]].K := H[P[I - 1]].K + A[I];
    UpDate(P[I]);
    If H[1].K - Sub > 0 Then Inc(Kol);
  End;
  Write(Kol);
  Close(Input);
  Close(Output);
End.
