{$D+,L+,I+,Q+,R+,S+,N+}
Program pr_c;
const
  inpfile='dvd.in';
  outfile='dvd.out';
  first = 1870;
  last = 2004;
  nm = 2005;
type
  Film = record
    year : LongInt;
    name : String;
  end;
  Region = array [1..nm] of Film;
  Solution = record
    kol : LongInt;
    first,reg : LongInt;
    ok : Boolean;
  end;
var
  a : array [1..5] of Region;
  an : array [1..5] of LongInt;
  b,s : array [first-1..last] of LongInt;
  c : array [1..5,first..last,first..last] of LongInt;
  d : array [0..6,first..last] of Solution;
  n,res,ptr : LongInt;
{}
Procedure Inp;
var
  i,j,year,reg : LongInt;
  name : String;
  ch : Char;
begin
  assign(input,inpfile);
  reset(input);
  readln(n);
  for i:=1 to n do begin
    read(ch); name:=ch;
    repeat
      read(ch);
      name:=name+ch;
    until ch='"';
    readln(year,reg);

    inc(an[reg]);
    a[reg,an[reg]].name:=name;
    a[reg,an[reg]].year:=year;
  end;
end;
{}
Procedure WritAns(h : LongInt; year : LongInt);
var
  i : LongInt;
begin
  if h=0 then exit;
  WritAns(h-1,d[h,year].first);

  for i:=1 to an[d[h,year].reg] do begin
    if (a[d[h,year].reg,i].year>=d[h,year].first)
    and (a[d[h,year].reg,i].year<=year) then begin
      writeln(a[d[h,year].reg,i].name);
    end;
  end;
end;
{}
Procedure Out;
var
  i,j,k : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  WritAns(ptr,last);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(an,sizeof(an),0);
  fillchar(b,sizeof(b),0);
  fillchar(s,sizeof(s),0);
  fillchar(c,sizeof(c),0);
  fillchar(d,sizeof(d),0);
end;
{}
Procedure Sort(n : LongInt; var a : Region);
  {}
  Procedure Swap(var q,w : Film);
  var
    bak : Film;
  begin
    bak:=q;
    q:=w;
    w:=bak;
  end;
  {}
  Procedure QSort(l, r: LongInt);
  var
    i, j, x : LongInt;
  begin
    i := l; j := r; x := a[(l+r) DIV 2].year;
    repeat
      while a[i].year < x do inc(i);
      while x < a[j].year do dec(j);
      if i <= j then
      begin
        Swap(a[i],a[j]);
        inc(i); dec(j);
      end;
    until i > j;
    if l < j then QSort(l, j);
    if i < r then QSort(i, r);
  end;
  {}
begin
  QSort(1,n);
end;
{}
Procedure Solve;
var
  i,j,k,t,h,q,plus : LongInt;
  ok : Boolean;
begin
  for i:=1 to 5 do
    Sort(an[i],a[i]);

  for k:=1 to 5 do begin
    fillchar(b,sizeof(b),0);
    fillchar(s,sizeof(s),0);
    for i:=1 to an[k] do inc(b[a[k,i].year]);
    s[first]:=b[first];
    for i:=first+1 to last do s[i]:=s[i-1]+b[i];

    for i:=first to last do
      for j:=i to last do
        c[k,i,j]:=s[j]-s[i-1];
  end;

  for k:=1 to 6 do begin

    for j:=first to last-1 do
      for i:=j to last do
        for t:=1 to 5 do if t<>d[k-1,j].reg then begin
          q:=j; plus:=c[t,j,i]; ok:=false; h:=k-1;
          if h>0 then
          while d[h,q].first=j do begin
            if t=d[h,q].reg then begin
              plus:=c[t,j+1,i];
              ok:=true;
            end;
            dec(h); if h=0 then break;
          end;

          if d[k,i].kol<d[k-1,j].kol+plus then begin
            d[k,i].kol:=d[k-1,j].kol+plus;
            d[k,i].first:=j; d[k,i].reg:=t;
            d[k,i].ok:=ok;
          end;
        end;

  end;

  res:=0; ptr:=0;
  for k:=1 to 6 do
    if d[k,last].kol>res then begin
      res:=d[k,last].kol;
      ptr:=k;
    end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
