{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T+,V+,X+,Y+}
Program Problem;
Const
     InFile = 'dvd.in';
     OutFile = 'dvd.out';
     NMax = 2000;
Type
    TFilm = Record
     Name : String[100];
     Year : 1870..2004;
     Region : 1..5;
    End;
Var
   N : LongInt;
   F : Array [0..NMax] Of TFilm;
   FMax : Array [0..NMax] Of LongInt;

 Procedure ReadData;
  Var
     I : LongInt;
     Ch : Char;
   Begin
     Assign (Input,InFile); ReSet (Input);
     ReadLn (N);
     For I:= 1 To N Do Begin
       F[I].Name:= '';
       Read (Ch);
       Read (Ch);
       While Ch <> '"' Do Begin
         F[I].Name:= F[I].Name + Ch;
         Read (Ch);
       End;
       Read (F[I].Year);
       ReadLn (F[I].Region);
     End;
     Close (Input);
   End;

 Procedure Sort;

  Procedure Swap (I,J : LongInt);
   Begin
     F[0]:= F[I]; F[I]:= F[J]; F[J]:= F[0];
   End;

  Procedure QSort (L,R : LongInt);
   Var
      I,J : LongInt;
      FM : TFilm;
   Begin
     I:= L; J:= R; FM:= F[(L + R) Div 2];
     Repeat
       While (F[I].Year < FM.Year) Do Inc (I);
       WHile (F[J].Year > FM.Year) Do Dec (J);
       If I <= J Then Begin
        Swap (I,J);
        Inc (I); Dec (J);
       End;
     Until I > J;
     If J > L Then QSort (L,J);
     If I < R Then QSort (I,R);
   End;

  Begin
    QSort (1,N);
  End;

 Procedure Solve;
  Begin
    Sort;
  End;

 Procedure WriteData;
  Var
     I : LongInt;
  Begin
    Assign (Output,OutFile); ReWrite (Output);
    WriteLn (N);
    For I:= 1 To N Do
      WriteLn ('"',F[I].Name,'"');
    Close (Output);
  End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.
