program zzz;

const
  maxn = 100;
  inf = 100000000;

type
  prib = ^trib;
  trib = record
    v,cost: Longint;
    next: prib;
  end;

var
  i,j,sc,k,n,m,t,tt,mn,nm: Longint;
  buf: Prib;
  g: array[1..maxn] of Prib;
  vis: array[1..maxn] of Boolean;
  num,a: array[1..20000] of Longint;
  best: array[1..maxn] of Longint;

procedure add(v1,v2,cst: Longint);
var buf: prib;
begin
  new(buf);
  buf^.next := g[v2];
  g[v2] := buf;
  buf^.cost := cst;
  buf^.v := v1;
end;

procedure swap(var a,b: Longint);
var i: Longint;
begin
  i := a;
  a := b;
  b := i;
end;

procedure qsort(st,fin: Longint);
var i,j,key: Longint;
begin
  key := a[st+random(fin-st)];
  i := st;
  j := fin;
  while i <= j do begin
    while key > a[i] do inc(i);
    while key < a[j] do dec(j);
    if i <= j then begin
      swap(a[i],a[j]);
      swap(num[i],num[j]);
      inc(i);
      dec(j);
    end;
  end;
  if j > st then qsort(st,j);
  if i < fin then qsort(i,fin);
end;

begin
  assign(input,'snow.in'); reset(input);
  assign(output,'snow.out'); rewrite(output);
  read(n,m,k);
  for i := 1 to n do begin
    new(g[i]);
    g[i]^.next := nil;
  end;
  for i := 1 to m do begin
    read(j,t,tt);
    add(j,t,tt);
    add(t,j,tt);
  end;
  for i := 1 to n do best[i] := inf;
  best[n] := 0;
  vis[n] := true;
  for i := 1 to n do begin
    mn := inf;
    for j := 1 to n do begin
      if vis[j] then continue;
      sc := 0;
      buf := g[j];
      while buf^.next <> nil do begin
        if best[buf^.v] <> inf then begin
          inc(sc);
          a[sc] := best[buf^.v] + buf^.cost;
          num[sc] := buf^.cost;
        end;
        buf := buf^.next;
      end;
      if sc = 0 then continue;
      qsort(1,sc);
      if k >= sc then t := sc else t := k;
      tt := inf;
      for i := 1 to t do begin
        if num[i] + a[i] < tt then tt := num[i] + a[i];
      end;
      if t <> sc then begin
        if tt > a[t+1] then tt := a[t+1];
      end;
      if tt < mn then begin
        mn := tt;
        nm := j;
      end;
    end;
    if mn < inf then begin
      vis[nm] := true;
      best[nm] := mn;
    end;
  end;
  if best[1] = inf then writeln('-1') else writeln(best[1]);
  close(input);
  close(Output);
end.
