program zzz;

const
  maxn = 2002;

var
  sc,i,j,k,n,m: Longint;
  a: array[0..2000,0..200] of char;
  num,len,res,y,p: array[0..maxn] of Longint;
  best: array[0..6,0..32,0..maxn] of Longint;

procedure readword(n: Longint);
var i,j: Longint;
    ch: char;
begin
  read(ch);
  while ch <> '"' do read(ch);
  a[n,1] := '"';
  read(ch);
  a[n,2] := ch;
  j := 2;
  while ch <> '"' do begin
    read(ch);
    inc(j);
    a[n,j] := ch;
  end;
  len[n] := j;
end;

procedure printword(n: Longint);
var i,j: Longint;
begin
  if n = 0 then exit;
  for i := 1 to len[n] do begin
    write(a[n,i]);
  end;
  writeln;
end;

procedure swap(var a,b: Longint);
var i: Longint;
begin
  i := a;
  a := b;
  b := i;
end;

function max(a,b: Longint): Longint;
begin
  if a > b then max := a else max := b;
end;

function more(i,j: Longint): Boolean;
begin
  if y[i] = y[j] then more := p[i] > p[j] else more := y[i] > y[j];
end;

procedure sort(n: Longint);
var i,j: Longint;
begin
  for i := 1 to n do begin
    for j := i+1 to n do begin
      if more(i,j) then begin
        swap(y[i],y[j]);
        swap(num[i],num[j]);
        swap(p[i],p[j]);
      end;
    end;
  end;
end;

function rec(n1,n2,n3: Longint): Longint;
var i,j: Longint;
begin
  if n1 > 6 then begin
    rec := 0;
    exit;
  end;
  if best[n1,n2,n3] <> 0 then begin
    rec := best[n1,n2,n3];
    exit;
  end;
  for i := n downto 1 do begin
    if i = n3 then continue;
    if y[i] < y[n3] then begin
      rec := best[n1,n2,n3];
      exit;
    end;
    if y[i] = y[n3] then begin
      if (n2 and (1 shl (p[i]-1)) <> 0) then continue;
      if (p[i] = p[n3]) and (i < n3) then continue;
      if (p[i] = p[n3]) then begin
        best[n1,n2,n3] := max(best[n1,n2,n3],rec(n1,n2,i)+1);
      end else begin
        best[n1,n2,n3] := max(best[n1,n2,n3],rec(n1+1,n2 or (1 shl (p[n3]-1)),i));
      end;
    end;
    if p[i] = p[n3] then begin
      best[n1,n2,n3] := max(best[n1,n2,n3],1+rec(n1,0,i));
    end else begin
      best[n1,n2,n3] := max(best[n1,n2,n3],1+rec(n1+1,0,i));
    end;
  end;
  if best[n1,n2,n3] = 0 then begin
    best[n1,n2,n3] := 1;
  end;
  rec := best[n1,n2,n3];
end;

procedure print(n1,n2,n3: Longint);
var i,j: Longint;
begin
  if best[n1,n2,n3] = 1 then begin
    printword(num[n3]);
    exit;
  end;
  for i := n downto 1 do begin
    if i = n3 then continue;
    if y[i] < y[n3] then exit;
    if y[i] = y[n3] then begin
      if (n2 and (1 shl (p[i]-1)) <> 0) then continue;
      if (p[i] = p[n3]) and (i < n3) then continue;
      if (p[i] = p[n3]) then begin
        if best[n1,n2,n3] = best[n1,n2,i] + 1 then begin
          print(n1,n2,i);
          printword(num[n3]);
          exit;
        end;
      end else begin
        if best[n1,n2,n3] = best[n1,n2 or (1 shl (p[n3]-1)),i] + 1 then begin
          print(n1,n2 or (1 shl (p[n3]-1)),i);
          printword(num[n3]);
          exit;
        end;
      end;
    end;
    if p[i] = p[n3] then begin
      if best[n1,n2,n3] = 1+best[n1,0,i] then begin
        print(n1,0,i);
        printword(n3);
        exit;
      end;
    end else begin
      if n1 = 6 then continue;
      if best[n1,n2,n3] = 1+best[n1+1,0,i] then begin
        print(n1+1,0,i);
        printword(n3);
        exit;
      end;
    end;
  end;
end;

begin
  assign(input,'dvd.in'); reset(input);
  assign(output,'dvd.out'); rewrite(output);
  read(n);
  fillchar(best,sizeof(best),0);
  for i := 1 to n do begin
    num[i] := i;
    readword(i);
    read(y[i],p[i]);
  end;
  sort(n);
  y[0] := 0;
  rec(0,0,0);
  writeln(best[0,0,0]-1);
  print(0,0,0);
  close(input);
  close(output);
end.
