type ls=record
 a:integer;
 nx:^ls;
end;
var
 d:array[1..3000,1..2] of longint;
 s:array[1..3000,1..2] of integer;
 c:array[1..3000] of integer;
 e:array[0..6000] of longint;
 i,j,k,l,n,heapsize:integer;
 cur,x,y:^ls;
procedure swap(b,c,x:integer);
var
 d:integer;
begin
 d:=s[b,x];
 s[b,x]:=s[c,x];
 s[c,x]:=d;
end;
procedure heapify(i,x:integer);
begin
 if (i*2+1<=heapsize) and (d[s[i*2+1,x],x]>d[s[i,x],x])
 and (d[s[i*2+1,x],x]>d[s[i*2,x],x]) then
  begin
   swap(i,i*2+1,x);
   heapify(i*2+1,x);
  end
 else
  if (i*2<=heapsize) and (d[s[i*2,x],x]>d[s[i,x],x]) then
   begin
    swap(i,i*2,x);
    heapify(i*2,x);
   end;
end;
begin
 assign(input,'g.in');
 reset(input);
 assign(output,'g.out');
 rewrite(output);
 readln(n);
 for i:=1 to n do
  readln(d[i,1],d[i,2]);
 heapsize:=n;
 for i:=1 to n do
  s[i,1]:=i;
 for i:=n div 2 downto 1 do
  heapify(i,1);
 for heapsize:=n-1 downto 1 do
  begin
   swap(1,heapsize+1,1);
   heapify(1,1);
  end;
 heapsize:=n;
 for i:=1 to n do
  s[i,2]:=i;
 for i:=n div 2 downto 1 do
  heapify(i,2);
 for heapsize:=n-1 downto 1 do
  begin
   swap(1,heapsize+1,2);
   heapify(1,2);
  end;
 fillchar(c,6000,0);
 j:=1;
 k:=0;
 cur:=nil;
 e[0]:=0;
 for i:=1 to n do
  begin
   if (c[s[i,2]]=0) and (e[k]<>d[s[i,2],2]-1) or
   (c[s[i,2]]=1) and (e[k]=d[s[i,2],2]-1) then
    begin
     inc(k);
     e[k]:=d[s[i,2],2]-1;
     while (j<=n) and (d[s[j,1],1]<=e[k]) do
      begin
       x:=cur;
       getmem(cur,sizeof(ls));
       cur^.a:=s[j,1];
       cur^.nx:=x;
       inc(j);
      end;
     x:=cur;
     y:=nil;
     while x<>nil do
      begin
       if d[x^.a,2]>=e[k] then
        begin
         inc(c[x^.a]);
         y:=x;
         x:=x^.nx;
        end
       else
        begin
         if y=nil then
          cur:=x^.nx
         else
          y^.nx:=x^.nx;
         freemem(x,sizeof(ls));
        end;
      end;
    end;
   if (c[s[i,2]]=1) and (e[k]<>d[s[i,2],2]) and (e[k-1]<>d[s[i,2],2]) then
    begin
     inc(k);
     e[k]:=d[s[i,2],2];
     while (j<=n) and (d[s[j,1],1]<=e[k]) do
      begin
       x:=cur;
       getmem(cur,sizeof(ls));
       cur^.a:=s[j,1];
       cur^.nx:=x;
       inc(j);
      end;
     x:=cur;
     y:=nil;
     while x<>nil do
      begin
       if d[x^.a,2]>=e[k] then
        begin
         inc(c[x^.a]);
         y:=x;
         x:=x^.nx;
        end
       else
        begin
         if y=nil then
          cur:=x^.nx
         else
          y^.nx:=x^.nx;
         freemem(x,sizeof(ls));
         x:=y^.nx;
        end;
      end;
    end;
  end;
 writeln(k);
 for i:=1 to k do
  write(e[i],' ');
 close(input);
 close(output);
end.