#include <stdio.h>
#include <stdlib.h>

#define NN 3000
#define MM 1000000

struct POINT {
  int x, y;
};

struct PP {
  int x;
  int tp;
  int ind;
};

FILE *fi, *fo;
POINT a[NN];
PP b[2*NN];
int n,m;
int s[NN];
int ans[2*NN];
int ans_s=0;
bool used[MM];

int cmp(PP a, PP b)
{
  if(a.x<b.x) return -1;
  if(a.x>b.x) return 1;
  if(a.tp>b.tp) return 1;
  if(a.tp<b.tp) return -1;
  return 0;
}

void sift(PP *a, int p, int q)
{
  int i,j;
  PP x;
  i=p;
  x=a[i];
  j=2*i+1;
  if(j<q-1) if(cmp(a[j+1],a[j])>0) j++;
  if(j<q) if(cmp(a[j],x)<=0) j=q+1;
  while(j<q)
  {
    a[i]=a[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(cmp(a[j+1],a[j])>0) j++;
    if(j<q) if(cmp(a[j],x)<=0) j=q+1;
  }
  a[i]=x;
}

void HeapSort(PP *a, int n)
{
  int i;
  PP x;
  for(i=n/2+1;i>=0;i--)
    sift(a,i,n);
  for(i=n-1;i>0;i--)
  {
    x=a[i];
    a[i]=a[0];
    a[0]=x;
    sift(a,0,i);
  }
}

bool build(int *k)
{
  int i,j;
  j=0;
  for(i=0;i<n;i++)
  {
    if(s[i]<2)
    {
      b[j].x=a[i].x;
      b[j].tp=0;
      b[j].ind=i;
      j++;
      b[j].x=a[i].y;
      b[j].tp=1;
      b[j].ind=i;
      j++;
    }
  }
  if(j<=0)
    return false;
  HeapSort(b,j);
  *k=j;
  m=j;
  return true;
}

bool rebuild(int *k)
{
  int i,j;
  j=0;
  for(i=0;i<m;i++)
    if(s[b[i].ind]<2)
      b[j++]=b[i];
  m=j;
  *k=j;
  if(m<=0)
    return false;
  return true;
}

bool findbest()
{
  int i,j;
  int ss,bs,bx;
  int k,l;
  ss=0;
  if(!rebuild(&j))
    return false;
  bs=0;
  k=j;
  for(i=0;i<k;i++)
  {
    if(b[i].tp)
      ss--;
    else
      ss++;
    if(ss>bs)
    {
      for(j=b[i].x;j<=b[i+1].x;j++)
      {
        if(!used[j])
        {
          bx=j;
          bs=ss;
          break;
        }
      }
    }
  }
  used[bx]=1;
  ans[ans_s++]=bx;
  for(i=0;i<n;i++)
    if((bx<=a[i].y)&&(bx>=a[i].x))
      s[i]++;
  return true;
}

int gminsum(int x)
{
  int i;
  int m;
  m=1000000;
  for(i=0;i<n;i++)
    if((x>=a[i].x)&&(x<=a[i].y))
      if(s[i]<m)
        m=s[i];
  return m;
}

void killunneed()
{
  int i;
  for(i=0;i<ans_s;i++)
  {
    if(gminsum(ans[i])>2)
    {
      ans[i--]=ans[--ans_s];
    }
  }
}

void sort()
{
  int i,j;
  int x;
  for(i=0;i<ans_s;i++)
  {
    for(j=i+1;j<ans_s;j++)
    {
      if(ans[j]<ans[i])
      {
        x=ans[i];
        ans[i]=ans[j];
        ans[j]=x;
      }
    }
  }
}

void init()
{
  int i;
  for(i=0;i<MM;i++)
    used[i]=0;
  for(i=0;i<n;i++)
    s[i]=0;
}

int main()
{
  int i;
  fi=fopen("g.in","rt");
  fo=fopen("g.out","wt");

  fscanf(fi,"%d",&n);
  init();
  for(i=0;i<n;i++)
    fscanf(fi,"%d%d",&a[i].x,&a[i].y);
  build(&i);
  while(findbest());
  killunneed();
  sort();
  fprintf(fo,"%d\n",ans_s);
  for(i=0;i<ans_s;i++)
    fprintf(fo,"%d ",ans[i]);
  fprintf(fo,"\n");

  fclose(fi);
  fclose(fo);
  return 0;
}
