  {$I-,Q-,R-,S-}
const infile = 'f.in'; outfile = 'f.out';
      max = 100; eps = 0.000001;
type pt = record x,y: extended; end;
type fr = record p1,p2: pt; t: extended; end;
     tf = array [1..max] of pt;
var s: array [1..max] of fr;
    fire,fire_new: tf;
    nnew: array [1..max] of longint;
    n,nf,nf_new: longint;
    mint: extended;
    res: pt;

procedure init;
var i: longint;
    mid: pt;
begin
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n do begin
         read(s[i].p1.x,s[i].p1.y,s[i].p2.x,s[i].p2.y,s[i].t);
         s[n+i].p2:=s[i].p2;
         mid.x:=(s[i].p1.x+s[i].p2.x)/2;
         mid.y:=(s[i].p1.y+s[i].p2.y)/2;
         s[i].p2:=mid;
         s[n+i].p1:=mid;
         s[i].t:=s[i].t/2;
         s[i+n].t:=s[i].t;
     end;
     n:=2*n;
     close(input);
end;

function eq(p1,p2: pt): boolean;
begin
     eq:=(abs(p1.x-p2.x) < eps)and(abs(p1.y-p2.y) < eps);
end;

procedure go_fire;
var i,j: longint;
begin
     nf_new:=0;
     for i:=1 to nf do begin
         for j:=1 to n do if (nnew[j] = 0) then begin
             if eq(s[j].p1,fire[i]) then begin
                inc(nf_new); fire_new[nf_new]:=s[j].p2;
                nnew[j]:=1;
             end;
             if eq(s[j].p2,fire[i]) then begin
                inc(nf_new); fire_new[nf_new]:=s[j].p1;
                nnew[j]:=1;
             end;
         end;
     end;
end;

function find(v: pt): extended;
var time: extended;
    i,j: longint;
begin
     time:=0;
     fillchar(nnew,SizeOf(nnew),0);
     nf:=1; fire[1]:=v;
     while true do begin
           go_fire;
           time:=time+0.5;
           fire:=fire_new; nf:=nf_new;
           for i:=1 to n do
               if nnew[i] = 0 then break;
           if nnew[i] = 1 then break;
     end;
     find:=time;
end;

procedure solve;
var i: longint;
    t1,t2: extended;
begin
     mint:=maxlongint;
     for i:=1 to n do begin
         if (abs(frac(s[i].p1.x)) < eps)and(abs(frac(s[i].p1.y)) < eps) then begin
            t1:=find(s[i].p1);
            if t1 < mint then begin
               mint:=t1; res:=s[i].p1;
            end;
         end;
         if (abs(frac(s[i].p2.x)) < eps)and(abs(frac(s[i].p2.y)) < eps) then begin
            t2:=find(s[i].p2);
            if t2 < mint then begin
               mint:=t2; res:=s[i].p2;
            end;
         end;
     end;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     writeln(res.x:0:0,' ',res.y:0:0);
     write(mint);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
