{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const MaxN = 30000;
      MaxD = 10;

Var I, J, N, K, S, Min: Integer;
    First: Boolean;
    A: array[1..MaxN] of Integer;
    D: array[1..MaxD] of Record
                           N, K: Integer;
                         End;

Procedure DecompositeToSimple(N: Integer);
Begin
  I := 2;
  Repeat
    First := True;
    While N mod I = 0 do Begin
      If First Then Begin
        Inc(K);
        D[K].N := I;
        First := False;
      End;
      Inc(D[K].K);
      N := N div I;
    End;
    S := Trunc(Sqrt(N));
    Inc(I);
  Until I > S;
  If N > 1 Then Begin
    Inc(K);
    D[K].N := N;
    D[K].K := 1;
  End;
End;

Procedure GenDivisors(P: Byte; X: Integer);
Var I, J: Integer;
Begin
  If X >= Min Then Exit;
  If P > K Then Begin
    J := 0;
    For I := X + 1 to N do Begin
      Inc(J);
      If J > X Then J := 1;
      If A[I] <> A[J] Then Exit;
    End;
    Min := X;
  End;
  For I := 1 to D[P].K + 1 do Begin
    GenDivisors(P + 1, X);
    If I <= D[P].K Then X := X * D[P].N;
  End;
End;

Begin
  Assign(Input, 'e.in');
  Assign(Output, 'e.out');
  Reset(Input);
  Rewrite(Output);
  Read(N);
  Dec(N);
  For I := 1 to N do
    Read(A[I]);
  DecompositeToSimple(N);
  Min := MaxInt;
  GenDivisors(1, 1);
  Write(Min);
  Close(Input);
  Close(Output);
End.
