{$I-,Q-,R-,S-}
Const
  FIn  = 'f.in';
  FOut = 'f.out';
{---------------------------------------------------------------------------}
Var
  Input,Output:TEXT;
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=40;
  MaxV=MaxN*2;
  MaxFire=MaxV*4;
  MMM=1E8;

Type
  TTime=Real;
  TCoo=Real;
  TMas=Record
    X1,Y1,X2,Y2:TCoo;
    T:TTime;
  end;

Var
  L1,L2:Extended;
  N:LongInt;
  Mas:array[1..MaxN]of TMas;

  Num1,Num2,R1,R:LongInt;
  X,Y:TCoo;

  V:LongInt;
  D:array[1..MaxV,1..MaxV] of TTime;
  Gr:array[1..MaxV]of Record
    X,Y:TCoo;
    Use:Boolean;
  end;

  Flag:Boolean;
  Start:LongInt;
  Col:LongInt;
  Fire:array[1..MaxFire]of Record
    V1,V2:LongInt;
    Time:TTime;
  end;
  Go,Used:array[1..MaxV]of Boolean;
  Min,Time:TTime;


  BestTime:TTime;
  BestX,BestY:TCoo;

Procedure Floid;
Var k,i,j:LongInt;
begin
  For k:=1 to V do
    For i:=1 to V do
      For j:=1 to V do
        If D[i,k]+D[k,j]<D[i,j] then D[i,j]:=D[i,k]+D[k,j];
end;

Procedure Clear;
begin
  V:=0;
  For R:=1 to MaxV do
    For R1:=1 to MaxV do
      If R=R1 then D[R,R1]:=0 else D[R,R1]:=MMM;
end;

Function Get(X,Y:TCoo):LongInt;
Var R:LongInt;
begin
  Get:=0;
  For R:=1 to V do
    If (Gr[R].X=X)and(Gr[R].Y=Y) then
    begin
      Get:=R;
      Exit;
    end;
end;

Function Put(X,Y:TCoo; Use:Boolean):LongInt;
begin
  Inc(V);
  Gr[V].X:=X;
  Gr[V].Y:=Y;
  Gr[V].Use:=Use;
  Put:=V;
end;

Function Len(R:LongInt):Extended;
begin
  With Mas[R] do Len:=sqrt(sqr(X1-X2)+sqr(Y1-Y2));
end;

Function Peres(R1,R2:LongInt; Var X,Y:TCoo):Boolean;
Var
  X1,Y1,X2,Y2:TCoo;
begin
  Peres:=False;
  If (Len(R1)=L2)and(Len(R2)=L2) then
  begin
    X1:=(Mas[R1].X1+Mas[R1].X2)/2; Y1:=(Mas[R1].Y1+Mas[R1].Y2)/2;
    X2:=(Mas[R2].X1+Mas[R2].X2)/2; Y2:=(Mas[R2].Y1+Mas[R2].Y2)/2;
    If (X1=X2)and(Y1=Y2) then
    begin
      Peres:=True;
      X:=X1;
      Y:=Y1;
    end;
  end;
end;

begin
  L1:=1;
  L2:=sqrt(2);
  Init;
  {}
  ReadLn(Input,N);
  For R:=1 to N do
    With Mas[R] do
      Read(Input,X1,Y1,X2,Y2,T);
  {}
  Clear;
  For R:=1 to N do
  begin
    Num1:=Get(Mas[R].X1,Mas[R].Y1);
    Num2:=Get(Mas[R].X2,Mas[R].Y2);
    If Num1=0 then Num1:=Put(Mas[R].X1,Mas[R].Y1,True);
    If Num2=0 then Num2:=Put(Mas[R].X2,Mas[R].Y2,True);
    D[Num1,Num2]:=Mas[R].T;
    D[Num2,Num1]:=Mas[R].T;
  end;
  For R:=1 to N-1 do
    For R1:=R+1 to N do
      If Peres(R,R1,X,Y) then
      begin
        Num1:=Get(Mas[R].X1,Mas[R].Y1);
        Num2:=Get(Mas[R].X2,Mas[R].Y2);
        D[Num1,Num2]:=MMM;
        D[Num2,Num1]:=MMM;

        Num1:=Get(Mas[R1].X1,Mas[R1].Y1);
        Num2:=Get(Mas[R1].X2,Mas[R1].Y2);
        D[Num1,Num2]:=MMM;
        D[Num2,Num1]:=MMM;

        Num1:=Put(X,Y,False);

        Num2:=Get(Mas[R].X1,Mas[R].Y1);
        D[Num1,Num2]:=Mas[R].T/2;
        D[Num2,Num1]:=Mas[R].T/2;
        Num2:=Get(Mas[R].X2,Mas[R].Y2);
        D[Num1,Num2]:=Mas[R].T/2;
        D[Num2,Num1]:=Mas[R].T/2;
        Num2:=Get(Mas[R1].X1,Mas[R].Y1);
        D[Num1,Num2]:=Mas[R1].T/2;
        D[Num2,Num1]:=Mas[R1].T/2;
        Num2:=Get(Mas[R1].X2,Mas[R].Y2);
        D[Num1,Num2]:=Mas[R1].T/2;
        D[Num2,Num1]:=Mas[R1].T/2;
      end;
  {}
  BestTime:=MMM;
  For Start:=1 to V do
    If Gr[Start].Use then
    begin
      Time:=0;
      FillChar(Used,SizeOf(Used),0);

      Col:=0;
      For R:=1 to V do
        If R<>Start then
        If D[Start,R]<>MMM then
        begin
          Inc(Col);
          Fire[Col].Time:=D[Start,R];
          Fire[Col].V1:=Start;
          Fire[Col].V2:=R;
        end;
      Used[Start]:=True;

      While True do
      begin
        Min:=MMM;
        For R:=1 to Col do
          If (Fire[R].Time<Min)and(Fire[R].Time<>0) then Min:=Fire[R].Time;
        If Min=MMM then Break;

        FillChar(Go,SizeOf(Go),0);
        For R:=1 to Col do
        begin
          If Fire[R].Time=Min then
          begin
            If Not Used[Fire[R].V1] then Go[Fire[R].V1]:=True;
            If Not Used[Fire[R].V2] then Go[Fire[R].V2]:=True;
          end;
          If Fire[R].Time<>0 then Fire[R].Time:=Fire[R].Time-Min;
        end;

        For Num1:=1 to V do
          If Go[Num1] then
          begin
            For R:=1 to V do
              If Num1<>R then
              If (D[Num1,R]<>MMM)and((Not Used[Num1])or(Not Used[Num2])) then
              begin
                Flag:=True;
                For R1:=1 to Col do
                  If ((Fire[R1].V1=Num1)and(Fire[R1].V2=R))
                   or((Fire[R1].V1=R)and(Fire[R1].V2=Num1)) then
                  begin
                    Flag:=False;
                    Fire[R1].Time:=Fire[R1].Time/2;
                  end;
                If Flag then
                begin
                  Inc(Col);
                  Fire[Col].Time:=D[Num1,R];
                  Fire[Col].V1:=Num1;
                  Fire[Col].V2:=R;
                end;
              end;
            Used[Num1]:=True;
          end;

        Time:=Time+Min;
      end;
    If Time<BestTime then
    begin
      BestTIme:=Time;
      X:=Gr[Start].X;
      Y:=Gr[Start].Y;
    end;
  end;
  {}
  WriteLn(Output,BestX:0:0,' ',BestY:0:0);
  WriteLn(Output,BestTime:0:2);
  {}
  Done;
end.