{$I-,Q-,R-,S-}
const
  maxn=40;
  alot=1e30;

var
  i,j,n:byte;
  sp:array[1..maxn] of record
    x1,y1,x2,y2:integer;
    t:longint;
    sm:byte;
    i1,i2:byte;
  end;
  points:array[1..maxn*2] of record
    x,y:integer;
    t:extended;
  end;
  pcount:byte;
  min:byte;

function addpoint(x,y:integer):byte;
var
  i:byte;
begin
  for i:=1 to pcount do begin
    if (points[i].x=x) and (points[i].y=y) then begin
      addpoint:=i;
      exit;
    end;
  end;
  inc(pcount);
  points[pcount].x:=x;
  points[pcount].y:=y;
  addpoint:=pcount;
end;

procedure burn(x:byte);
var
  t:array[1..maxn*2] of extended;
  u:array[1..maxn*2] of boolean;
  i,j:byte;
  t1,tmax:extended;

function count(tb,t1,t2:extended):extended;
var
  tm1,tm2,z:extended;

begin
  if t1>t2 then begin
    tm1:=t1;
    tm2:=t2;
  end else begin
    tm1:=t2;
    tm2:=t1;
  end;
  if (tm1-tm2)<=tb then begin
    z:=(1-(tm1-tm2)/tb);
    count:=tm1+z*tb/2;
  end else begin
    count:=tm2+tb;
  end;
end;

function burnsp(x:byte):extended;
var
  t_,t1,t2,tmin:extended;
  j:byte;

begin
  tmin:=count(sp[x].t,t[sp[x].i1],t[sp[x].i2]);
  if sp[x].sm>0 then begin
    j:=sp[x].sm;
    if t[sp[j].i1]<t[sp[j].i2] then begin
      t_:=t[sp[j].i1]+(sp[j].t/2);
    end else begin
      t_:=t[sp[j].i2]+(sp[j].t/2);
    end;
    t1:=count(sp[x].t/2,t[sp[x].i1],t_);
    t2:=count(sp[x].t/2,t[sp[x].i2],t_);
    if t1>t2 then
      t_:=t1
    else
      t_:=t2;
    if tmin>t_ then
      tmin:=t_;
  end;

  burnsp:=tmin;
end;

procedure relax(i:byte;time:extended);
begin
  if t[i]>time then
    t[i]:=time;
end;

begin
  for i:=1 to pcount do
    t[i]:=alot;
  fillchar(u,sizeof(u),false);
  t[x]:=0;
  while true do begin
    j:=1;
    for i:=1 to pcount do
      if (not u[i]) and ((u[j]) or (t[i]<t[j])) then
        j:=i;
    if u[j] then
      break;
    u[j]:=true;
    for i:=1 to n do begin
      if (sp[i].i1=j) or (sp[i].i2=j) then begin
        if sp[i].i1=j then begin
          relax(sp[i].i2,t[j]+sp[i].t);
        end else begin
          relax(sp[i].i1,t[j]+sp[i].t);
        end;
        if sp[i].sm>0 then begin
          relax(sp[sp[i].sm].i1,t[j]+(sp[i].t+sp[sp[i].sm].t)/2);
          relax(sp[sp[i].sm].i2,t[j]+(sp[i].t+sp[sp[i].sm].t)/2);
        end;
      end;
    end;
  end;

  tmax:=0;
  for i:=1 to n do begin
    t1:=burnsp(i);
    if t1>tmax then
      tmax:=t1;
  end;
  points[x].t:=tmax;

end;

begin
  assign(input,'f.in');
  reset(input);
  assign(output,'f.out');
  rewrite(output);

  read(n);
  pcount:=0;
  for i:=1 to n do begin
    read(sp[i].x1,sp[i].y1,sp[i].x2,sp[i].y2,sp[i].t);
    sp[i].i1:=addpoint(sp[i].x1,sp[i].y1);
    sp[i].i2:=addpoint(sp[i].x2,sp[i].y2);
    sp[i].sm:=0;
    if (sp[i].x1<>sp[i].x2) and (sp[i].y1<>sp[i].y2) then begin
      for j:=1 to i-1 do begin
        if ((sp[i].x1=sp[j].x1) and (sp[i].y1=sp[j].y2)
        and (sp[i].x2=sp[j].x2) and (sp[i].y2=sp[j].y1))
        or ((sp[i].x1=sp[j].x2) and (sp[i].y1=sp[j].y1)
        and (sp[i].x2=sp[j].x1) and (sp[i].y2=sp[j].y2))
        then begin
          sp[i].sm:=j;
          sp[j].sm:=i;
          break;
        end;
      end;
    end;
  end;

  min:=1;
  for i:=1 to pcount do begin
    burn(i);
    if points[i].t<points[min].t then begin
      min:=i;
    end;
  end;

  writeln(points[min].x,' ',points[min].y);
  write(points[min].t:0:2);
  close(input);
  close(output);
end.
