{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 65384,0,655360}
const
  inf = 'g.in'; ouf = 'g.out';
  max = 3010;
  procedure swap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
var
  a, b: array[1..max] of longint; hs: longint;
  procedure down(k: longint);
  var
    j, l: longint;
  begin
    l := k; j := k shl 1;
    if (j <= hs) and ((b[j] > b[l]) or
      ((b[j] = b[l]) and (a[j] > a[l]))) then l := j;
    inc(j);
    if (j <= hs) and ((b[j] > b[l]) or
      ((b[j] = b[l]) and (a[j] > a[l]))) then l := j;
    if (l <> k) then
    begin
      swap(a[l], a[k]); swap(b[l], b[k]);
      down(l);
    end;
  end;
var
  t: array[1..max shl 1] of longint;
  m: longint;
  procedure qsort(l, r: longint);
  var
     i, j: longint;
  begin
     i := l; j := r; m := t[l + random(r-l+1)];
     repeat
       while (t[i] < m) do inc(i);
       while (t[j] > m) do dec(j);
       if (i <= j) then
       begin
         swap(t[i], t[j]); inc(i); dec(j);
       end;
     until i > j;
     if (i < r) then qsort(i, r);
     if (j > l) then qsort(l, j);
  end;
var
  tk: array[1..max] of longint;
  i, j, n, lx, qt, q: longint;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  read(input, n); randomize;
  for i := 1 to n do
     read(input, a[i], b[i]);
  hs := n;
  for i := n shr 1 downto 1 do down(i);
  while (hs > 1) do
  begin
    swap(a[1], a[hs]); swap(b[1], b[hs]);
    dec(hs); down(1);
  end;
  lx := 0;
  fillchar(tk, sizeof(tk), 0);
  for i := 1 to n do
    if (a[i] > lx) then
    begin
      inc(q); lx := b[i]; tk[i] := 1;
      inc(qt); t[qt] := lx;
    end;
  lx := 0;
  for i := 1 to n do
    if (a[i] > lx) then
    begin
      inc(q); lx := b[i];
      if (tk[i] = 1) then dec(lx);
      inc(qt); t[qt] := lx;
    end;
  writeln(output, qt);
  qsort(1, qt);
  for i := 1 to qt do write(output, t[i], ' ');
  close(input); close(output);
end.
