const
     FileIn='d.in';
     FileOut='d.out';
     MaxN=100;
var
   N, K, S: LongInt;
   Q: array [1..MaxN, 1..MaxN] of LongInt;
   A: array [1..MaxN, 1..MaxN] of Byte;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, N, K, S);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   X, Y: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for Y:=1 to N
         do begin
            for X:=1 to N-1
                do Write (F, A [X, Y], #32);
            Writeln (F, A [N, Y]);
         end;
     Close (F);
end;

function Max (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Max:=aB
        else Max:=aA;
end;

function Test (aX, aY: LongInt): Boolean;
var
   X, Y: LongInt;
begin
     for X:=Max (1, aX-K+1) to aX
         do for Y:=Max (1, aY-K+1) to aY
                do if Q [X, Y]=S
                      then begin
                           Test:=false;
                           Exit;
                      end;
     Test:=true;
end;

procedure Hit (aX, aY: LongInt);
var
   X, Y: LongInt;
begin
     A [aX, aY]:=1;
     for X:=Max (1, aX-K+1) to aX
         do for Y:=Max (1, aY-K+1) to aY
                do Inc (Q [X, Y]);
end;

procedure Solve;
var
   X, Y: LongInt;
begin
     FillChar (A, SizeOf (A), 0);
     FillChar (Q, SizeOf (Q), 0);

     for X:=1 to N
         do for Y:=1 to N
                do if Test (X, Y)
                      then Hit (X, Y);
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
