{$I-,Q-,R-,S-}
const
     FileIn='g.in';
     FileOut='g.out';
     MaxN=3000;
     AdsPerOne=2;
     MaxTime=1000000;
var
   N: LongInt;
   A, B: array [1..MaxN] of LongInt;
   AnswerCount: LongInt;
   Answer: array [1..MaxN*2] of LongInt;
   AdsLeft: array [1..MaxN] of LongInt;
   TimeRatings: array [1..MaxTime] of Integer;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=1 to N
         do Read (F, A [NItem], B [NItem]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, AnswerCount);
     for NItem:=1 to AnswerCount-1
         do Write (F, Answer [NItem], #32);
     Writeln (F, Answer [AnswerCount]);
     Close (F);
end;

procedure QSort (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   M, T: LongInt;
begin
     i:=aLeft;
     j:=aRight;
     M:=Answer [(i+j) div 2];
     repeat
           while Answer [i]<M
                 do Inc (i);
           while M<Answer [j]
                 do Dec (j);
           if i<=j
              then begin
                   T:=Answer [i];
                   Answer [i]:=Answer [j];
                   Answer [j]:=T;
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSort (aLeft, j);
     if i<aRight
        then QSort (aRight, i);
end;

procedure RateTime (aTime: LongInt);
var
   NItem: LongInt;
begin
     TimeRatings [aTime]:=0;
     for NItem:=1 to N
         do if (A [NItem]<=aTime) and (aTime<=B [NItem])
               then Inc (TimeRatings [aTime]);
end;

function ExtractMax: LongInt;
var
   NItem: LongInt;
   Rating, BestRating: LongInt;
   BestTime: LongInt;
begin
     BestRating:=-1;
     for NItem:=1 to N
         do begin
            if BestRating<TimeRatings [A [NItem]]
               then begin
                    BestRating:=TimeRatings [A [NItem]];
                    BestTime:=A [NItem];
               end;
            if BestRating<TimeRatings [B [NItem]]
               then begin
                    BestRating:=TimeRatings [B [NItem]];
                    BestTime:=B [NItem];
               end;
         end;
     if BestRating>0
        then ExtractMax:=BestTime
        else ExtractMax:=0;
end;

procedure Solve;
var
   BestTime: LongInt;
   NItem: LongInt;
begin
     AnswerCount:=0;
     for NItem:=1 to N
         do begin
            AdsLeft [NItem]:=AdsPerOne;
            RateTime (A [NItem]);
            RateTime (B [NItem]);
         end;
     repeat
           BestTime:=ExtractMax;
           if BestTime>0
              then begin
                   for NItem:=1 to N
                       do if (A [NItem]<=BestTime) and (BestTime<=B [NItem])
                             then begin
                                  Dec (AdsLeft [NItem]);
                                  if AdsLeft [NItem]=0
                                     then begin
                                          Dec (TimeRatings [A [NItem]]);
                                          Dec (TimeRatings [B [NItem]]);
                                     end;
                             end;
                   Inc (AnswerCount);
                   Answer [AnswerCount]:=BestTime;
                   TimeRatings [BestTime]:=-1;
              end;
     until BestTime=0;
     QSort (1, AnswerCount);
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
