{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}

Const
  InputFile  = 'f.in';
  OutputFile = 'f.out';

Type
  Pointer = Record
    X, Y : Integer;
  End;
  Otr     = Record
    T : integer;
    A, B : Pointer;
  End;

Var
  N     : Integer;
  O     : Array [1..50]Of Otr;
  B     : Array [1..100,1..100]Of Longint;
  C     : Array [1..100,1..100]Of Boolean;
  V     : Array [1..100]Of Pointer;
  CV    : Integer;
  Res   : Real;
  X,Y   : Integer;

  Procedure Find;
  Begin

  End;

  Procedure Solve;
  Var I, J, M : Longint;
    Max  : Array [1..100]Of Longint;
    Min  : Longint;
  Begin
    For M := 1 to Cv Do
      For I := 1 to CV Do
        For J := 1 to CV Do
          If (B[I, J] > B[I, M]+B[M, J])
             Then B[I, J] := B[I, M]+B[M, J];

    For I :=1 to 100  Do Max[I] := -MaxLongint;

    For I := 1 To CV Do
      For J := 1 to CV Do
        If B[I, J] > Max[I] Then Max[I] := B[I, J];

    Min := MaxLongint;

    For I := 1 to Cv Do
      If Max[I] < Min Then
        Begin
          Min := Max[I];
          M := I;
        End;

    Res:= Min;
    X := V[M].X;
    Y := V[M].Y;
    Find;
  End;

  Procedure AddR(X : Otr);
  Var I,J,L : Integer;
  Begin
    For I := 1 to CV Do Begin
      If (X.A.X = V[I].X) And (X.A.Y = V[I].Y) Then J := I;
      If (X.B.X = V[I].X) And (X.B.Y = V[I].Y) Then L := I;
    End;
    B[J, L] := X.T;
    B[L, J] := X.T;
    C[J, L] := True;
  End;

  Procedure AddPoint(X : Pointer);
  Var pp : Boolean;
      I  : Integer;
  Begin
    pp := True;
    For I := 1 to Cv Do pp := pp And ((V[I].X <> X.X)or(V[I].Y <> X.Y));
    If pp Then
      Begin
        Inc(CV);
        V[CV] := X;
      End;
  End;

  Procedure Init;
  Var I, J : Integer;
  Begin
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);
    Read(N);
    For I := 1 to N Do
      With O[I] Do
       Readln(A.X, A.Y, B.X, B.Y, T);

    For I := 1 to 100 Do For J := 1 to 100 Do B[I, J] := 20000000;
    For I := 1 to 100 Do B[I,I] := 0;
    CV  := 0;
    For I := 1 to N DO
       Begin
         AddPoint(O[I].A);
         AddPoint(O[I].B);
         AddR(O[I]);
       End;
  End;

  Procedure Done;
  Begin
    Writeln(X,' ',Y);
    Writeln(Res:0:4);
    Close(Input);
    Close(Output);
  End;

Begin
  Init;
    Solve;
  Done;
End.
 Do
       Readln(A.X, A.Y, B.X, B.Y, T);

    For I := 1 to 100 Do For J := 1 to 100 Do
      Begin
        B[I, J] := 20000000;
        C[I, J] := -1;
      End;
    For I := 1 to 100 Do Begin B[I, I] := 0; C[I, I] := 0;End;
    CV  := 0;
    For I := 1 to N DO
       Begin
         AddPoint(O[I].A);
         AddPoint(O[I].B);
         AddR(O[I]);
       End;
  End;

  Procedure Done;
  Begin
    Writeln(X,' ',Y);
    Writeln(Res:0:4);
    Close(Input);
    Close(Output);
  End;

Begin
  Init;
    Solve;
  Done;
End.
