  {$I-,Q-,R-,S-}
uses sysutils;
const infile = 'square.in'; outfile = 'square.out'; max = 30005;
type pt = record x,y: longint; end;
var p,r: array [0..max] of pt;
    prl,prh,le: array [0..max] of longint;
    n,w,h,ans,ext_low,ext_high: longint;
    decr: boolean;
    start: double;
    tmp: pt;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(n,w,h);
     for i:=1 to n do read(p[i].x,p[i].y);
     p[0].x:=0; p[0].y:=0;
     p[n+1].x:=w; p[n+1].y:=h;
     close(input);
end;

function min(q1,q2: longint): longint;
begin
     if q1 < q2 then min:=q1
        else min:=q2;
end;

procedure sort_r(l,rg: longint);
var i,j,w: longint;
begin
     i:=l; j:=rg; w:=r[(l+rg) div 2].y;
     repeat
           while (r[i].y < w) do inc(i);
           while (r[j].y > w) do dec(j);
           if i <= j then begin
              tmp:=r[i]; r[i]:=r[j]; r[j]:=tmp;
              inc(i); dec(j);
           end;
     until i > j;
     if i < rg then sort_r(i,rg);
     if l < j then sort_r(l,j);
end;

function check_board(k: longint): boolean;
var i,num,last: longint;
begin
     num:=0; check_board:=true;
     for i:=1 to n do
         if p[i].x < k then begin
            inc(num); r[num]:=p[i];
         end;
     sort_r(1,num); last:=0;
     for i:=1 to num do
         if r[i].y > last then begin
            if last-r[i].y >= k then exit
               else last:=r[i].y;
         end;
     if h-last >= k then exit;
     check_board:=false;
end;

function can(k,down: longint): boolean;
var i,j,low,high: longint;
t: boolean;
begin
     can:=true; ext_low:=down;
     if check_board(k) then exit;
     if (now-start)*60*60*24 > 2.8 then begin
         can:=false; exit;
     end;
     for i:=0 to n+1 do begin
     t:=false;
         if p[i].x+k > w then break;
         if decr then begin low:=prl[i]; high:=prh[i]; j:=le[i]; end
            else begin low:=0; high:=h; j:=i+1; end;
         while (j <= n)and(p[j].x = p[i].x) do j:=j+1;
         while (j <= n)and(p[j].x < p[i].x+k) do begin
             if (p[j].y = p[i].y) then begin t:=true; break; end;
             if (p[j].y > low)and(p[j].y < p[i].y) then low:=p[j].y;
             if (p[j].y < high)and(p[j].y > p[i].y) then high:=p[j].y;
             inc(j);
         end;
         prl[i]:=low; prh[i]:=high; le[i]:=j;
         if t then begin
            prl[i]:=p[i].y; prh[i]:=p[i].y; le[i]:=i; continue;
         end;
         if high-low >= k then exit
            else begin
                 if ext_low < high-low then ext_low:=high-low;
            end;
     end;
     can:=false;
end;

procedure sort(l,r: longint);
var i,j,w: longint;
begin
     i:=l; j:=r; w:=p[(l+r) div 2].x;
     repeat
           while (p[i].x < w) do inc(i);
           while (p[j].x > w) do dec(j);
           if i <= j then begin
              tmp:=p[i]; p[i]:=p[j]; p[j]:=tmp;
              inc(i); dec(j);
           end;
     until i > j;
     if i < r then sort(i,r);
     if l < j then sort(l,j);
end;

procedure solve;
var up,down,mid: longint;
begin
     start:=now;
     sort(1,n);
     down:=1; up:=min(w,h); mid:=down; decr:=false;
     while (up-down) > 1 do begin
           mid:=(up+down) div 2;
           if can(mid,down) then begin
              down:=mid; decr:=true;
           end
              else begin
                   up:=mid; down:=ext_low; decr:=false;
              end;
           if (now-start)*60*60*24 > 2.8 then begin
                ans:=down; exit;
           end;
     end;
     if can(up,down) then ans:=up
        else ans:=down;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(ans);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
