  {$I-,Q-,R-,S-}
const infile = 'grlex.in'; outfile = 'grlex.out'; max = 1000005;
var n,k,ans: longint;
    f: array [1..max] of longint;
    w: array [1..max] of longint;
    rr: array [1..max,0..7] of byte;
    tmp: longint;

procedure gen(r: longint);
var e: longint;
begin
     e:=r; w[r]:=0;
     while e > 0 do begin
           inc(rr[r][0]);
           rr[r][rr[r][0]]:=e mod 10;
           w[r]:=w[r]+rr[r][rr[r][0]];
           e:=e div 10;
     end;
end;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(n,k);
     for i:=1 to n do begin
         f[i]:=i; gen(i);
     end;
     close(input);
end;

function less(x,y: longint): boolean;
var i,j: longint;
begin
     less:=false; if (w[x] > w[y]) then exit;
     less:=true; if (w[x] < w[y]) then exit;
     i:=rr[x][0]; j:=rr[y][0];
     while (i > 0)and(j > 0) do begin
           if rr[x][i] > rr[y][j] then begin less:=false; exit; end;
           if rr[x][i] < rr[y][j] then begin less:=true; exit; end;
           dec(i); dec(j);
     end;
     if rr[x][0] >= rr[y][0] then less:=false
        else less:=true;
end;

procedure sort(l,r: longint);
var i,j,x: longint;
begin
     i:=l; j:=r; x:=f[l+random(r-l+1)];
     repeat
           while less(f[i],x) do inc(i);
           while less(x,f[j]) do dec(j);
           if i <= j then begin
              tmp:=f[i]; f[i]:=f[j]; f[j]:=tmp;
              inc(i); dec(j);
           end;
     until i > j;
     if i < r then sort(i,r);
     if l < j then sort(l,j);
end;

procedure solve;
begin
     randseed:=13349873;
     sort(1,n);
     for ans:=1 to n do
         if f[ans] = k then break;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     writeln(ans);
     writeln(f[k]);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
