{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_b;
const
  inpfile='grlex.in';
  outfile='grlex.out';
  nm=25;
  smax=9*nm;
type
  Number = array [0..nm] of Byte;
var
  n,k,res : Number;
  lexn,ans : Extended;
{}
Procedure ReadNum(var q : Number);
var
  ch : Char;
begin
  fillchar(q,sizeof(q),0);
  repeat
    read(ch);
  until ch in ['1'..'9'];

  repeat
    inc(q[0]);
    q[q[0]]:=ord(ch)-ord('0');
    read(ch);
  until not (ch in ['0'..'9']);
end;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  ReadNum(n);
  ReadNum(k);
  lexn:=0;
  for i:=1 to k[0] do
    lexn:=10*lexn+k[i];
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(ans:0:0);
  if res[0]=0 then res[0]:=1;
  for i:=1 to res[0] do
    write(res[i]);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(n,sizeof(n),0);
  fillchar(k,sizeof(k),0);
  fillchar(res,sizeof(res),0);
end;
{}
var
  ks,ts : array [0..smax,false..true] of Extended;
{}
Function KolSum(s : LongInt; var n : Number) : Extended;
var
  i,j,t : LongInt;
  bol : Boolean;
  res : Extended;
begin
  if s<0 then begin
    KolSum:=0; exit;
  end;

  fillchar(ks,sizeof(ks),0);
  fillchar(ts,sizeof(ts),0);
  ks[0,false]:=1;

  for i:=1 to n[0] do begin
    for j:=0 to i*9 do begin
      for t:=0 to 9 do
        ts[j+t,true]:=ts[j+t,true]+ks[j,true];

      for t:=0 to n[i] do
        ts[j+t,(t<n[i])]:=ts[j+t,(t<n[i])]+ks[j,false];
    end;
    ks:=ts; fillchar(ts,sizeof(ts),0);
  end;

  res:=0;
  for i:=0 to s do
    res:=res+ks[i,true];

  KolSum:=res;
end;
{}
Function KSum(s : LongInt; var n : Number) : Extended;
var
  i,j,t : LongInt;
  bol : Boolean;
  res : Extended;
begin
  if s<0 then begin
    KSum:=0; exit;
  end;
  if (n[0]=0) and (s=0) then begin
    KSum:=1; exit;
  end;


  fillchar(ks,sizeof(ks),0);
  fillchar(ts,sizeof(ts),0);
  ks[0,false]:=1;

  for i:=1 to n[0] do begin
    for j:=0 to i*9 do begin
      for t:=0 to 9 do
        ts[j+t,true]:=ts[j+t,true]+ks[j,true];

      for t:=0 to n[i] do
        ts[j+t,(t<n[i])]:=ts[j+t,(t<n[i])]+ks[j,false];
    end;
    ks:=ts; fillchar(ts,sizeof(ts),0);
  end;

  KSum:=ks[s,true];
end;
{}
Procedure FirstSol;
var
  q : Number;
  i,j,t,s,cnt : LongInt;
  ks,ps : Extended;
  ok,found : Boolean;
begin
  fillchar(res,sizeof(res),0);

  s:=0;
  while KolSum(s,n)<lexn do inc(s);
  lexn:=lexn-KolSum(s-1,n);

  for j:=1 to 9 do begin
    ps:=0;
    for i:=1 to n[0] do
      if (j<=n[i]) or (i>1) then begin
        q[0]:=n[0]-i;
        if (j<n[i]) or (i>1) then begin
          for t:=1 to q[0] do q[t]:=9;
        end else begin
          for t:=1 to q[0] do q[t]:=n[i+t];
        end;
        ps:=ps+KSum(s-j,q);
      end;
    if ps>=lexn then begin
      inc(res[0]); res[res[0]]:=j;
      dec(s,j); break;
    end else lexn:=lexn-ps;
  end;

  cnt:=1;
  while s>0 do begin
    inc(cnt);

    for j:=0 to 9 do begin
      ps:=0;
      for i:=cnt to n[0] do
        if (j<=n[i]) or (i>1) then begin
          q[0]:=n[0]-i;
          if (j<n[i]) or (i>1) then begin
            for t:=1 to q[0] do q[t]:=9;
          end else begin
            for t:=1 to q[0] do q[t]:=n[i+t];
          end;
          ps:=ps+KSum(s-j,q);
        end;
      if ps>=lexn then begin
        inc(res[0]); res[res[0]]:=j;
        dec(s,j); break;
      end else lexn:=lexn-ps;
    end;
  end;
end;
{}
Procedure SecondSol;
var
  q : Number;
  i,j,t,w,s : LongInt;
  ps : Extended;
begin
  s:=0;
  for i:=1 to k[0] do inc(s,k[i]);
  ans:=KolSum(s-1,n);


  for j:=1 to k[1]-1 do begin

    for i:=1 to n[0] do begin
      if (j<=n[i]) or (i>1) then begin
        q[0]:=n[0]-i;
        if (j<n[i]) or (i>1) then begin
          for t:=1 to q[0] do q[t]:=9;
        end else begin
          for t:=1 to q[0] do q[t]:=n[i+t];
        end;
        ans:=ans+KSum(s-j,q);
      end;
    end;

  end;
  dec(s,k[1]);

  for w:=2 to k[0] do begin

    for j:=0 to k[w]-1 do begin

      for i:=w to n[0] do begin
        if (j<=n[i]) or (i>1) then begin
          q[0]:=n[0]-i;
          if (j<n[i]) or (i>1) then begin
            for t:=1 to q[0] do q[t]:=9;
          end else begin
            for t:=1 to q[0] do q[t]:=n[i+t];
          end;
          ans:=ans+KSum(s-j,q);
        end;
      end;
    end;
    dec(s,k[w]);
  end;

  ans:=ans+1;
end;
{}
Procedure Solve;
var
  i,j : LongInt;
begin
  FirstSol;
  SecondSol;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.