const MaxN = 1000005;

type
  lint = int64{longint};
  Tpoint = record
    x,y: lint;
  end;

var
  fi, fo: text;
  TestN: longint;
  a,t: array[1..MaxN] of Tpoint;
  n: longint;
  res: boolean;

function sign(v: lint):integer;
begin
  if v>0 then sign:=1 else
    if v<0 then sign:=-1 else
      sign:=0;
end;

function rdir(x1,y1,x2,y2: lint):integer;
begin
  rdir:=sign(x1*y2-y1*x2);
end;

procedure Solve;
var dir,cd: integer;
    i,mi: longint;
    x1,y1,x2,y2: lint;
begin
  res:=false;
  if (t[1].x<>t[n].x) and (t[1].x<>t[n].x) then begin
   exit;
  end;
  mi:=1;
  For i:=2 to n do begin
    if t[i].y<t[mi].y then mi:=i else
      if (t[i].y=t[mi].y) and (t[i].x<t[mi].x) then mi:=i;
  end;
  For i:=mi to n do begin
    a[i-mi+1]:=t[i];
  end;
  For i:=2 to mi do begin
    a[n-mi+i]:=t[i];
  end;

  dir:=0;
  For i:=3 to n do begin
    x1:=a[i-1].x-a[i-2].x;
    y1:=a[i-1].y-a[i-2].y;
    x2:=a[i].x-a[i-1].x;
    y2:=a[i].y-a[i-1].y;
    cd:=rdir(x1,y1,x2,y2);
    if (cd=0) and (sign(x1)=-sign(x2)) and (sign(y1)=-sign(y2)) then begin
     exit;
    end;
    if dir=0 then begin
      if cd<>0 then dir:=cd;
    end else begin
      if (cd<>0) and (cd<>dir) then begin
        exit;
      end;
      x1:=a[1].x-a[i].x;
      y1:=a[1].y-a[i].y;
      cd:=rdir(x2,y2,x1,y1);
      if (cd<>0) and (cd<>dir) then begin
       exit;
      end;
   end;
  end;
  res:=true;
end;

procedure Init;
var i,j,x,y: longint;
begin
  Assign(fi,'convex.in');
  Assign(fo,'convex.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,TestN);
  For i:=1 to TestN do begin
    Read(fi,n);
    For j:=1 to n do begin
      Read(fi,x,y);
      t[j].x:=x;
      t[j].y:=y;
    end;
    Solve;
    if res then WriteLn(fo,'YES') else WriteLn(fo,'NO');
  end;
end;

procedure Done;
begin

  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Done;
End.
