{$I-,Q-,R-,S-}

const
  answer:array[false..true] of string[3]=('NO','YES');
  maxn=1000000;
  eps=0.01;
  co:comp=1.0;

var
  z1,z:longint;
  i,j,n:longint;
  x,y:array[0..maxn] of comp;
  x1,y1:array[1..maxn] of longint;
  dx,dy:longint;
  can,flag1:boolean;
  s,s1:comp;
  l,l1:comp;
  r,r1:byte;

procedure swap(i,j:longint);
var
  temp:comp;
begin
  temp:=x[i];
  x[i]:=x[j];
  x[j]:=temp;
  temp:=y[i];
  y[i]:=y[j];
  y[j]:=temp;
end;

function psm(x1,y1,x2,y2:comp):comp;
begin
  psm:=x1*y2-x2*y1;
end;

function less(x1,y1,x2,y2:comp):boolean;
var
  m:comp;
begin
  m:=psm(x1,y1,x2,y2);
  if m>0 then begin
    less:=true;
    exit;
  end;
  if m<0 then begin
    less:=false;
    exit;
  end;
  if (y1=y2) and (x1=x2) then begin
    less:=x1>x2;
    exit;
  end;
  if (y1=0) then begin
    less:=x1<x2;
  end else begin
    less:=y1<y2;
  end;
end;

procedure qsort(l,r:longint);
var
  i,j:longint;
  x1,y1:comp;
begin
  if not can then
    exit;
  i:=l;
  j:=r;
  x1:=x[(l+r) div 2];
  y1:=y[(l+r) div 2];
  repeat
    while less(x[i],y[i],x1,y1) do
      inc(i);
    while less(x1,y1,x[j],y[j]) do
      dec(j);
    if i<=j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;

function ang(x1,y1,x2,y2,x3,y3:comp):byte;
var
  m:comp;
begin
  m:=psm(x2-x1,y2-y1,x3-x2,y3-y2);
  if m>eps then
    ang:=1
  else
    if m<-eps then
      ang:=2
    else
      ang:=0;

end;

begin
  assign(input,'convex.in');
  reset(input);
  assign(output,'convex.out');
  rewrite(output);
  read(z);
  for z1:=1 to z do begin
    flag1:=false;
    read(n);
    j:=1;
    read(x[1],y[1]);
    for i:=2 to n do begin
      read(x[i],y[i]);
      if (y[i]<y[j]) or ((y[i]=y[j]) and (x[i]>x[j])) then
        j:=i;
      if (not flag1) and (abs((x[i]-x[1])*(y[2]-y[1])-(x[2]-x[1])*(y[i]-y[1]))>eps) then
        flag1:=true;
    end;
    can:=flag1 and (x[n]=x[1]) and (y[n]=y[1]);
    if can then begin
      for i:=1 to n do begin
        x1[i]:=round(x[i]);
        y1[i]:=round(y[i]);
      end;
      dx:=round(x[j]);
      dy:=round(y[j]);
      swap(1,j);
      for i:=2 to n do begin
        x[i]:=x[i]-x[1];
        y[i]:=y[i]-y[1];
      end;
      x[1]:=0;
      y[1]:=0;
      x[n]:=0;
      y[n]:=0;
      qsort(2,n-1);
      x[0]:=x[n-1];
      y[0]:=y[n-1];
      if can then begin
        r:=0;
        for i:=1 to n-1 do begin
          r1:=ang(x[i-1],y[i-1],x[i],y[i],x[i+1],y[i+1]);
          if r=0 then
            r:=r1;
          if (r1>0) and (r1<>r) then begin
            can:=false;
            break;
          end;
        end;
        if can then begin
          s1:=0;
          s:=0;
          l1:=0;
          l:=0;
          for i:=1 to n-1 do begin
            l:=l+(sqr(x[i+1]-x[i])+sqr(y[i+1]-y[i]));
            l1:=l1+(sqr(co*x1[i+1]-x1[i])+sqr(co*y1[i+1]-y1[i]));
            s:=s+((x[i+1]-x[i])*(y[i+1]+y[i]));
            s1:=s1+((x1[i+1]-x1[i])*(y1[i+1]+y1[i]));
          end;
          s1:=abs(s1);
          s:=abs(s);
          if (s<eps) or (abs(s1-s)>eps) or (abs(l-l1)>eps) then
            can:=false;
        end;
      end;
    end;
    writeln(answer[can]);
  end;
  close(input);
  close(output);
end.
