type
  TPoint = record x,y : longint; end;

const
  MaxN = 30001;

var
  y1,y2     : longint;
  max       : longint;
  a         : array [1..MaxN] of TPoint;
  w,h,n,i,j : longint;


procedure init;
begin
  assign(input,'square.in'); reset(input);
  assign(output,'square.out'); rewrite(output);
  readln(n,w,h);
  for i:=1 to n do read(a[i].x,a[i].y);
  close(input);
end;

function min(q,w : longint) : longint;
begin
  if q<w then min:=q else min:=w;
end;

procedure Sort(l, r: longint);
var
  x1,i, j, x, y: longint;

begin
  i := l; j := r; x := a[(l+r) DIV 2].x;
  x1:=a[(l+r) div 2].y;
  repeat
    while a[i].x>x do i := i + 1;
    while x>a[j].x do j := j - 1;
    if i <= j then
    begin
      y := a[i].x; a[i].x := a[j].x; a[j].x := y;
      y := a[i].y; a[i].y := a[j].y; a[j].y := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

begin
  init;
  Sort(1,n);
  max:=min(w-a[1].x,h);
  i:=2;
  while (i<=n)and(a[i].x=a[1].x) do i:=i+1;
  for i:=i to n do
  begin
    y1:=0;
    y2:=h;
    for j:=i-1 downto 1 do
    begin
      if (a[j].y>y1)and(a[j].y<y2) then
      begin
        if min(a[j].x-a[i].x,y2-y1)>max then
          max:=min(a[j].x-a[i].x,y2-y1);
        if a[i].y>a[j].y then y1:=a[j].y else y2:=a[j].y;
      end;
    end;
    if min(w-a[i].x,y2-y1)>max then
      max:=min(w-a[i].x,y2-y1);
  end;
  if min(a[n].x,h)>max then max:=min(a[n].x,h);
  y1:=0; y2:=h;
  for j:=n downto 1 do
  begin
    if (a[j].y>y1)and(a[j].y<y2) then
    begin
      if min(a[j].x,y2-y1)>max then
        max:=min(a[j].x,y2-y1);
      if (h-a[j].y)>a[j].y then y1:=a[j].y else y2:=a[j].y;
    end;
  end;
  if min(w,y2-y1)>max then
    max:=min(w,y2-y1);
  writeln(max);
  close(output);
end.
