{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}

type
  Tpoint = record x,y : longint; end;

const
  MaxN = 1000001;

var
  o         : TPoint;
  min       : longint;
  z,q,r     : longint;
  ok        : boolean;
  a         : array [1..MaxN] of TPoint;
  num,n,i,j : longint;

procedure init;
begin
  assign(input,'convex.in'); reset(input);
  assign(output,'convex.out'); rewrite(output);
  read(n);
end;

function Rotate(a,b,c : TPoint) : integer;
var
  x1,y1,x2,y2 : longint;

begin
  x1:=a.x-b.x;
  y1:=a.y-b.y;
  x2:=c.x-b.x;
  y2:=c.y-b.y;
  if (x1*y2-y1*x2)>0 then rotate:=1 else
  if (x1*y2-y1*x2)=0 then rotate:=0 else rotate:=-1;
end;

procedure Sort(l,r : longint);
var
  p : tpoint;
  x1,y1,i, j, x, y: longint;

begin
  i:=l; j:=r;
  p.x:=a[(l+r) DIV 2].x;
  p.y:=a[(l+r) div 2].y;
  repeat
    while Rotate(a[i],a[1],p)>0 do i:=i+1;
    while Rotate(a[j],a[1],p)<0 do j:=j-1;
    if i <= j then
    begin
      y:=a[i].x; a[i].x:=a[j].x; a[j].x:=y;
      y:=a[i].y; a[i].y:=a[j].y; a[j].y:=y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

begin
  init;
  for i:=1 to n do
  begin
    read(num); min:=1;
    for j:=1 to num do
    begin
      read(a[j].x,a[j].y);
      if a[j].y<a[min].y then min:=j;
    end;
    if (a[1].x=a[num].x)and(a[1].y=a[num].y) then
    begin
      o:=a[1];
      a[1]:=a[min];
      a[min]:=a[1];
      num:=num-1;
      ok:=true; q:=0;
      for j:=3 to num do
      begin
        z:=Rotate(a[j-2],a[j-1],a[j]);
        if z<>0 then q:=q+1;
        if z=1 then
        begin
          ok:=false;
          break;
        end;
      end;
      if (ok=true)and(q<>0) then writeln('YES') else writeln('NO');
    end else writeln('NO');
  end;
  close(input); close(output);
end.
