{$N+}
type
  real = int64;
const
  inf= 'convex.in'; ouf = 'convex.out';
  max = 1000005;
  procedure swap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
var
  q: longint;
  qu, x, y, xn, yn: array[1..max] of longint;
  function vec(k: longint): real;
  var
    xa, ya, xb, yb: real;
  begin
    xa := x[qu[k]] - x[qu[k - 1]];  ya := y[qu[k]] - y[qu[k - 1]];
    xb := x[qu[k + 1]] - x[qu[k - 1]]; yb := y[qu[k + 1]] - y[qu[k - 1]];
    vec := xa * yb - xb * ya;
  end;
var
  w: array[1..max] of byte;
  hs: longint;
  v: real;
  procedure down(k: longint);
  var
    j, l: longint;
  begin
    l := k; j := k shl 1;
    if (j <= hs) and ((x[j] > x[l]) or
       ((x[j] = x[l]) and (y[j] > y[l]))) then
         l := j;
    inc(j);
    if (j <= hs) and ((x[j] > x[l]) or
       ((x[j] = x[l]) and (y[j] > y[l]))) then
         l := j;
    if (l <> k) then
    begin
      swap(x[l], x[k]); swap(y[l], y[k]);
      down(l);
    end;
  end;
  procedure miss;
  begin
    writeln(output, 'NO'); dec(q);
  end;
var
  i, j, n, dk, k: longint; ok: boolean;
begin
  assign(input, inf); reset(input);
  assign(output,ouf); rewrite(output);
  readln(input,q);
  while (q > 0) do
  begin
    readln(input, n);
    for i := 1 to n do readln(input, x[i], y[i]);
    if (x[1] <> x[n]) or (y[1] <> y[n]) then
    begin
       miss; continue;
    end;
    x[n] := 0; y[n] := 0; dec(n);
    xn := x; yn := y;
    hs := n;
    for i := n shr 1 downto 1 do down(i);
    while (hs > 1) do
    begin
      swap(x[1], x[hs]); swap(y[1], y[hs]);
      dec(hs); down(1);
    end;
    qu[1] := 1;  j:= 1;
    for i := 2 to n do
    begin
      qu[j+1] := i;
      while (j > 1) and (vec(j) > 0) do
      begin
        qu[j] := qu[j + 1]; qu[j + 1] := 0;
        dec(j);
      end;
      inc(j);
    end;
    fillchar(w, sizeof(w), 0);
    for i := 2 to j do w[qu[i]] := 1;
    for i := n downto 1 do
      if (w[i] = 0) then
      begin
        qu[j+1] := i;
        while (j > 1) and (vec(j) > 0) do
        begin
          qu[j] := qu[j + 1]; qu[j + 1] := 0;
          dec(j);
        end;
        inc(j);
      end;
      j := -1;
      for i := 1 to n do
        if (x[qu[i]] = xn[1]) and (y[qu[i]] = yn[1]) then
        begin
          j := qu[i]; break;
        end;
      if (j = -1) then
      begin
        miss; continue;
      end;
      if (x[qu[j + 1]] = xn[2]) and
         (y[qu[j + 1]] = yn[2]) then
           dk := 1 else dk := -1;
      ok := true; inc(j, dk);
      for i := 2 to n do
      begin
        if (j = 0) then j := n;
        if (j > n) then dec(j, n);
        if (xn[i] <> x[qu[j]]) or
           (yn[i] <> y[qu[j]]) then
           begin
             ok := false; break;
           end;
        inc(j, dk);
      end;
      if not ok then
      begin
        miss; continue;
      end else
      begin
        ok := false;
        for i := 2 to n do
           if (vec(i) <> 0) then
           begin
             ok := true; break;
           end;
        if ok then writeln(output, 'YES') else miss;
      end;
    dec(q);
  end;
  close(input); close(output);
end.
