Const
  InputFile  = 'square.in';
  OutputFile = 'square.out';

Type
  TPoint = Record
    X, Y : Longint;
    P    : Longint;
  End;

Var
  A, B       : Array [0..300]Of TPoint;

  X          : Array [1..300]Of Longint;
  Y          : Array [1..300]Of Longint;
  N, W, H    : Longint;
  Res        : Longint;

  Procedure SortA(L ,R : Longint);Forward;
  Procedure SortB(L ,R : Longint);Forward;


  Procedure Solve;
  Var
    I, J, K, L, R        : longint;
    X, Y, X1, Y1, X2, Y2 : Longint;
  Begin
    Res := 0;
    SortA(1, N);
    For I := 1 To N DO A[I].P := I;
    B := A;
    SortB(1, N);
    For I := 0 to n-1 Do
      Begin
        X := B[I].X;
        Y := B[I].Y;
        J := B[I].P;
        K := 1;
        L := 1;
        While ((B[K].Y<=B[I].Y)or(B[K].X<=B[I].X))And(K<=N) Do Inc(K);
        If K > N Then Y1 := H Else Y1 := B[K].Y;

        While ((A[L].X<=B[I].X)or(A[L].Y<=B[I].Y))And(L<=N) Do Inc(L);
        If L > N Then X1 := W Else X1 := A[L].X;

        If (X1 - X) > (Y1 - Y) Then R := Y1 - Y Else R := X1 - X;
        If R > Res Then Res := R;
      End;
  End;

  Procedure Init;
  Var I : Longint;
  Begin
    FillChar(A, SizeOf(A), 0);
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);
    Readln(N, W, H);
    For I := 1 to N Do Readln(A[I].X, A[I].Y);
  End;

  Procedure Swap(var X, Y : TPoint);
    Var Z : TPoint;
    Begin
      Z := X;
      X := Y;
      Y := Z;
    End;

  Procedure SortA(L, R : Longint);
  Var I, J, V     : Longint;
  Begin
    I := L;
    J := R;
    V := A[(I+J) Div 2].X;
    Repeat
      While A[I].X < V Do Inc(I);
      While V < A[J].X Do Dec(J);
      If I <= J Then
        Begin
          Swap(A[I], A[J]);
          Inc(I); Dec(J);
        End;
    Until I > J;
    If I < R Then SortA(I, R);
    If L < J Then SortA(L, J);
  End;

  Procedure SortB(L, R : Longint);
  Var I, J, V, P  : Longint;
  Begin
    I := L;
    J := R;
    V := B[(I+J) Div 2].Y;
    Repeat
      While B[I].Y < V Do Inc(I);
      While V < B[J].Y Do Dec(J);
      If I <= J Then
        Begin
          Swap(B[I], B[J]);
          P := A[I].P;
          A[I].P := A[J].P;
          A[J].P := P;
          Inc(I); Dec(J);
        End;
    Until I > J;
    If I < R Then SortB(I, R);
    If L < J Then SortB(L, J);
  End;

  Procedure Done;
  Begin
    Writeln(Res);
    Close(Input);
    Close(Output);
  End;

Begin
  Init;
    Solve;
  Done;
End.
