{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Type Tip=LongInt;
  Const Inp='square.in';
        Out='square.out';
        MaxN=30001;
  Var N,W,H : Tip;
      X,Y : Array [1..MaxN] Of Tip;
      WithIt : Array [1..MaxN] Of Boolean;
      NeedHelp : Tip;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Tip;
Begin
  FillChar(WithIt,SizeOf(WithIt),0);
  Read(N,W,H);
  For I :=1 To N Do
    Read(X[I],Y[I]);
End;

procedure SortX(l, r: Integer);
var
  i, j, Help : Tip;
begin
  i := l; j := r; Help := X[(l+r) DIV 2];
  repeat
    while X[i] < Help do i := i + 1;
    while Help < X[j] do j := j - 1;
    if i <= j then
    begin
      NeedHelp := X[i]; X[i] := X[j]; X[j] := NeedHelp;
      NeedHelp := Y[i]; Y[i] := Y[j]; Y[j] := NeedHelp;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then SortX(l, j);
  if i < r then SortX(i, r);
end;

Function Min(Const A,B : Tip) : Tip;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Function Max(Const A,B : Tip) : Tip;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure Solve;
  Var Answer : Tip;
      I : Tip;
      YDown,YUp,NowDown,NowUp : Tip;
      XtoYD,XToYU : Tip;
      Now : Tip;
Begin
  SortX(1,N);
  For I :=1 To N Do
    Begin
      If (I<>1) And (X[I-1]=X[I]) Then WithIt[I] :=True;
      If (I<>N) And (X[I+1]=X[I]) Then WithIt[I] :=True;
    End;
  Answer :=Max(1,Max(Min(X[1],H-Y[1]),Min(X[1],Y[1])));
  Answer :=Max(Answer,Max(Min(X[N],H-Y[N]),Min(W-X[N],H-Y[N])));
  X[N+1] :=N;
  Y[N+1] :=0;
  YDown :=Y[1];
  YUp :=H-Y[1];
  XToYD :=X[1];
  XToYU :=X[1];
  Now :=Max(Min(XToYU,YUp),Min(XToYD,YDown));
  if Now>Answer Then Answer :=Now;
  For I :=2 To N Do
    Begin
      Inc(XToYD,X[I]-X[I-1]);
      Inc(XToYU,X[I]-X[I-1]);
      Now :=Max(Min(XToYU,YUp),Min(XToYD,YDown));
      if Now>Answer Then Answer :=Now;
      If X[I]-X[I-1]>Answer Then Answer :=X[I]-X[I-1];
      If Y[I]<Y[I-1] Then
        Begin
          XToYU :=X[I]-X[I-1];
          Inc(XToYD,X[I]-X[I-1]);
          YUp :=H-Y[I];
          YDown :=Y[I];
          If I=N Then
            Begin
              Inc(XToYD,W-X[I]);
              Inc(XToYU,W-X[I]);
            End;
          Now :=Max(Min(XToYU,YUp),Min(XToYD,YDown));
        End
      Else If Y[I]>Y[I-1] Then
        Begin
          XToYD :=X[I]-X[I-1];
          Inc(XToYU,X[I]-X[I-1]);
          YUp :=H-Y[I];
          YDown :=Y[I];
          If I=N Then
            Begin
              Inc(XToYD,W-X[I]);
              Inc(XToYU,W-X[I]);
            End;
          Now :=Max(Min(XToYU,YUp),Min(XToYD,YDown));
        End
      Else
        Begin
          Inc(XToYD,X[I]-X[I-1]);
          Inc(XToYU,X[I]-X[I-1]);
          If I=N Then
            Begin
              Inc(XToYD,W-X[I]);
              Inc(XToYU,W-X[I]);
            End;
          Now :=Max(Min(XToYU,YUp),Min(XToYD,YDown));
        End;
      If WithIt[I] And (X[I+1]<>X[I]) Then
        Begin
          XToYD :=0;
          XToYU :=0;
        End;
      if Now>Answer Then Answer :=Now;
    End;
  WriteLn(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
