{$N+}
program TaskA;
const infile = 'input.txt';
      outfile = 'output.txt';
      MAXN = 200000;
      dt = 1e-3;
      DPI = 2*3.1415926535897932;
type t1=record
  x1, y1, x2, y2:extended;
end;
var ar:array[1..MAXN+4]of t1;
    area, x, y, M:extended;
    N:integer;

procedure inp;
var i:integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N, M); read(x, y);
  for i:=1 to N do
    read(ar[i].x1, ar[i].y1, ar[i].x2, ar[i].y2);
end;

function prin(x1, y1:extended; ot:t1):boolean;
begin
  if (x1=ot.x1)and(y1=ot.y1) then begin prin:=false; exit; end;
  if (x1=ot.x2)and(y1=ot.y2) then begin prin:=false; exit; end;
  if abs(sqrt(sqr(ot.x1-ot.x2)+sqr(ot.y1-ot.y2))-sqrt(sqr(ot.x1-x1)+sqr(ot.y1-y1))-sqrt(sqr(ot.x2-x1)+sqr(ot.y2-y1)))<dt
    then prin:=true else prin:=false;
end;

function getr(alpha:extended):extended;
var x1, y1, dx, dy, d, A1, B1, C1, A2, B2, C2, det:extended;
    i:integer;
begin
  d:=MAXLONGINT;
  x1:=x; y1:=y; dx:=cos(alpha)*10; dy:=sin(alpha)*10;
  A1:=dy; B1:=-dx; C1:=y1*dx-x1*dy; C1:=-C1;
  for i:=1 to N do
  begin
    A2:=(ar[i].y2-ar[i].y1); B2:=(ar[i].x1-ar[i].x2);
    C2:=-(A2*ar[i].x1+B2*ar[i].y1); C2:=-C2;
    det:=A1*B2-B1*A2;
    if abs(det)<dt then continue;
    x1:=(C1*B2-B1*C2)/det; y1:=(A1*C2-C1*A2)/det;
    if not prin(x1, y1, ar[i]) then continue;
    if (x1-x)*dx<0 then continue;
    if sqrt(sqr(x-x1)+sqr(y-y1))<d then d:=sqrt(sqr(x-x1)+sqr(y-y1));
  end;
  getr:=d;
end;

procedure run;
var an, d1, d2, sn:extended;
begin
  if N=0 then begin area:=sqr(M); exit; end;
  sn:=sin(dt);
  ar[N+1].x1:=0; ar[N+1].y1:=0; ar[N+1].x2:=0; ar[N+1].y2:=M;
  ar[N+2].x1:=0; ar[N+2].y1:=0; ar[N+2].x2:=M; ar[N+2].y2:=0;
  ar[N+3].x1:=0; ar[N+3].y1:=M; ar[N+3].x2:=M; ar[N+3].y2:=M;
  ar[N+4].x1:=M; ar[N+4].y1:=0; ar[N+4].x2:=M; ar[N+4].y2:=M;
  inc(N, 4); an:=dt; d1:=getr(0); area:=0;
  while an<=DPI do
  begin
    d2:=getr(an);
    area:=area+d1*d2*sn;
    d1:=d2;
    an:=an+dt;
  end;
  area:=area/2;
  area:=round(area*100)/100;
end;

procedure outp;
begin
  write(area:0:5);
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
