#include <stdio.h>
#include <stdlib.h>

#define QQ 3
#define NN 310

FILE *fi, *fo;
int dv[QQ][QQ];
int n;
int a[NN][NN];
int b[NN][NN];

void builddv()
{
  int i,j,k;
  for(i=0;i<QQ;i++)
    for(j=0;j<QQ;j++)
      dv[i][j]=-1;
  for(i=0;i<QQ;i++)
  {
    for(j=0;j<QQ;j++)
    {
      k=(i*j)%QQ;
      dv[k][j]=i;
      dv[k][i]=j;
    }
  }
}

int div3(int x, int y)
{
  x%=3;
  y%=3;
  if(x<0)
    x+=3;
  if(y<0)
    y+=3;
  x%=3;
  y%=3;
  return dv[x][y];
}

int main()
{
  int i,j;
  bool flag;
  int ii;
  int pr;
  fi=fopen("input.txt","rt");
  fo=fopen("output.txt","wt");

  builddv();
  fscanf(fi,"%d",&n);
  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
      fscanf(fi,"%d",&a[i][j]);
      b[i][j]=0;
    }
  }
  for(j=0;j<n;j++)
  {
    b[j][j]=1;
    flag=false;
    for(i=j-1;i>=0;i--)
    {
      pr=0;
      for(ii=i;ii<j;ii++)
      {
        pr+=b[i][ii]*b[ii][j];
        pr%=3;
      }
      b[i][j]=div3(a[i][j]-pr,b[i][i]+b[j][j]);
      if(b[i][j]<0)
        flag=true;
    }
    if(flag)
    {
      flag=false;
      b[j][j]=2;
      for(i=j-1;i>=0;i--)
      {
        pr=0;
        for(ii=i;ii<j;ii++)
        {
          pr+=b[i][ii]*b[ii][j];
          pr%=3;
        }
        b[i][j]=div3(pr,b[i][i]+b[j][j]);
        if(b[i][j]<0)
          flag=true;
      }
    }
    if(flag)
    {
      fprintf(fo,"0\n");
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
      fprintf(fo,"%d ",b[i][j]);
    fprintf(fo,"\n");
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
