#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define NN 21
#define LL 21
#define RR 256
#define MM 110

#define ML 30
#define BASE 10000000000000000LL

struct LLONG {
  long long a[ML];
  int l;
};

FILE *fi, *fo;
int s[LL];
int length;
int m,n;
int g[LL+1][RR];
//long long a[MM+1][NN+1][LL+1];
LLONG a[MM+1][NN+1][LL+1];
LLONG res;

int max(int a, int b)
{
  return (a>b)?a:b;
}

void zero(LLONG *a)
{
  int i;
  a->l=0;
  for(i=0;i<ML;i++)
    a->a[i]=0;
}

void set_one(LLONG *a)
{
  zero(a);
  a->l=1;
  a->a[ML-1]=1LL;
}

void wr(LLONG *a)
{
  int i;
  if(a->l==0)
  {
    fprintf(fo,"0\n");
    return ;
  }
  fprintf(fo,"%lld",a->a[ML-a->l]);
  for(i=ML-a->l+1;i<ML;i++)
    fprintf(fo,"%016lld",a->a[i]);
  fprintf(fo,"\n");
}

void sum(LLONG *a, LLONG *b)
{
  int i;
  long long r;
  a->l=max(a->l,b->l);
  r=0LL;
  for(i=ML-1;i>=ML-a->l;i--)
  {
    a->a[i]+=b->a[i]+r;
    r=a->a[i]/BASE;
    a->a[i]%=BASE;
  }
  while(r>0)
  {
    a->a[ML-(++(a->l))]=r%BASE;
    r/=BASE;
  }
}

int getpref(int pref,int c)
{
  int ss[LL+1];
  int l;
  int i,j;
  bool flag;
  for(l=0;l<pref;l++)
    ss[l]=s[l];
  ss[l]=c;
  if(l>=length)
    pref--;
  l++;
  for(i=pref+1;i>=0;i--)
  {
    flag=true;
    for(j=0;(j<i)&&(flag);j++)
      if(s[j]!=ss[l-i+j])
        flag=false;
    if(flag)
      return i;
  }
}

void buildg()
{
  int i,j;
  for(i=0;i<=length;i++)
//    for(j=0;j<RR;j++)
    for(j='a';j<='z';j++)
      g[i][j]=getpref(i,j);
}

int getcc()
{
  int c;
  c=getc(fi);
  while((c==' ')||(c=='\t'))
    c=getc(fi);
  return c;
}

void read_str()
{
  int c;
  length=0;
  while(((c=getcc())!=EOF)&&(c!='\n')&&(c!='\r'))
    if(isalpha(c))
      s[length++]=c;
}

int main()
{
  int i,j;
  int ii,jj;
  fi=fopen("input.txt","rt");
  fo=fopen("output.txt","wt");

  read_str();
  fscanf(fi,"%d%d",&m,&n);
  for(ii=0;ii<=MM;ii++)
    for(i=0;i<=NN;i++)
      for(j=0;j<RR;j++)
        zero(&a[0][i][j]);
  set_one(&a[0][0][0]);
  buildg();
  for(i=0;i<=m;i++)
  {
    for(j=0;j<=n;j++)
    {
      for(ii=0;ii<length;ii++)
      {
        for(jj='a';jj<='z';jj++)
          sum(&a[i+1][j][g[ii][jj]],&a[i][j][ii]);
      }
      ii=length;
      for(jj='a';jj<='z';jj++)
        sum(&a[i+1][j+1][g[ii][jj]],&a[i][j][ii]);
    }
  }
  zero(&res);
  for(i=0;i<length;i++)
    sum(&res,&a[m][n][i]);
  if(n>0)
    sum(&res,&a[m][n-1][length]);
//  fprintf(fo,"%lld\n",res);
  wr(&res);

  fclose(fi);
  fclose(fo);
  return 0;
}
