{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  problem='';
  fin= problem+'input.txt';
  fout=problem+'output.txt';
  maxn=30;
  maxm=120;

type
  long=record
    l:longint;
    z:array[-1..200]of shortint;
  end;

procedure readlong(var a:long);
var
  i:longint;
  c:char;
begin
  fillchar(a,sizeof(a),0);
  repeat
    read(c);
  until c in ['0'..'9'];

  repeat
    inc(a.l);
    for i:=a.l downto 2 do
      a.z[i]:=a.z[i-1];
    a.z[1]:=ord(c)-ord('0');
    read(c);
  until not (c in ['0'..'9']);

  while (a.z[a.l]=0)and(a.l>1) do
    dec(a.l);
end;

procedure writelong(const a:long);
var
  i:longint;
begin
  for i:=a.l downto 1 do
    write(a.z[i]);
end;

procedure inclong(var a:long;const b:long);
var
  c:long;
  i:longint;
begin
  fillchar(c,sizeof(c),0);
  c.l:=a.l;
  for i:=1 to c.l do
    c.z[i]:=a.z[i];
  a:=c;
  inc(a.l);
  if a.l<b.l+1 then
    a.l:=b.l+1;
  for i:=1 to a.l do begin
    inc(a.z[i],b.z[i]);
    inc(a.z[i+1],a.z[i] div 10);
    a.z[i]:=a.z[i] mod 10;
  end;
  while (a.z[a.l]=0)and(a.l>1) do
    dec(a.l);
end;

var
  a:array[1..maxm,0..maxn,0..maxn]of long;
  p:array[1..maxn]of byte;
  b:array[0..maxn,'a'..'z',0..maxn]of byte;
  s,s1:string;
  c:char;
  n,n1,m,i,j,k,np,i1:longint;
  ans:long;

procedure init;
begin
  assign(input,fin);
  reset(input);

    readln(s);
    read(m,n);
    n1:=n;

  close(input);
end;

procedure solve;
begin
  n:=length(s);
  np:=1;
  p[1]:=0;
  for k:=1 to n-1 do begin
    for i:=n-k+1 to n do
      if s[i]<>s[i-(n-k)] then
        break;
    if s[i]=s[i-(n-k)] then begin
      inc(np);
      p[np]:=k;
    end;
  end;
  p[1]:=p[np];
  np:=1;

  fillchar(b,sizeof(b),0);
  for i:=0 to n-1 do
    for c:='a' to 'z' do begin
      b[i,c,0]:=1;
      b[i,c,1]:=0;
      if (i=n-1)and(c=s[n]) then
        continue;
      s1:=copy(s,1,i)+c;
      for k:=1 to i+1 do begin
        for j:=1 to k do
          if s1[i+1-k+1+j-1]<>s[j] then
            break;
        if s1[i+1-k+1+j-1]=s[j] then begin
          inc(b[i,c,0]);
          b[i,c,b[i,c,0]]:=k;
        end;
      b[i,c,1]:=b[i,c,b[i,c,0]];
      b[i,c,0]:=1;
      end;
    end;

  fillchar(a,sizeof(a),0);
  if n=1 then begin
    a[1,1,0].l:=1;
    a[1,1,0].z[1]:=1;

    a[1,0,0].l:=2;
    a[1,0,0].z[1]:=5;
    a[1,0,0].z[2]:=2;
  end
  else begin
    a[1,0,1].l:=1;
    a[1,0,1].z[1]:=1;

    a[1,0,0].l:=2;
    a[1,0,0].z[1]:=5;
    a[1,0,0].z[2]:=2;
  end;

  for k:=2 to m do
    for c:='a' to 'z' do
      for i1:=0 to n1 do
        for i:=0 to n-1 do
          if (c=s[n])and(i=n-1) then
            for j:=1 to np do begin
              inclong(a[k,i1+1,p[j]],a[k-1,i1,i])
            end
          else
            for j:=1 to b[i,c,0] do
              inclong(a[k,i1,b[i,c,j]],a[k-1,i1,i]);


  ans.l:=1;
  ans.z[1]:=0;
  for i:=0 to n-1 do
    inclong(ans,a[m,n1,i]);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writelong(ans);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
