{$I-,Q-,R-,S-}
Const
  FIn  = 'input.txt';
  FOut = 'output.txt';
{---------------------------------------------------------------------------}
Var
  Input,Output:TEXT;
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  Max=10;

Var
  Mn,M,N:LongInt;
  S:String;
  T:String;

  Pi:array[1..Max]of LongInt;
  Temp,Ans:LongInt;

Procedure ComputePrefixFunction(P:String);
Var k,q:LongInt;
begin
  Pi[1]:=0;
  k:=0;
  for q:=2 to Length(P) do
  begin
    While (k>0)and(P[k+1]<>P[q]) do k:=Pi[k];
    if P[k+1]=P[q] then k:=k+1;
    Pi[q]:=k;
  end;
end;

Procedure KMP(T,P:String; Var Col:LongInt);
Var i,q,m,k:LongInt;
begin
  Col:=0;
  m:=Length(P);
  ComputePrefixFunction(P);
  q:=0;
  for i:=1 to Length(T) do
  begin
    while (q>0)and(P[q+1]<>T[i]) do q:=Pi[q];
    if P[q+1]=T[i] then q:=q+1;
    if q=m then Col:=Col+1;
  end;
end;

Procedure Rec(R:Byte);
Var Ch:Char;
begin
  R:=R+1;
  if R=M+1 then
  begin
    KMP(T,S,Temp);
    If Temp=N then Inc(Ans);
    Exit;
  end;
  For Ch:='a' to 'z' do
  begin
    T[R]:=Ch;
    Rec(R);
  end;
end;

begin
  Init;
  {}
  ReadLn(Input,S);
  ReadLn(Input,M,N);
  Ans:=0;
  If M<=4 then
  begin
    T[0]:=Chr(M);
    Rec(0);
  end;
  WriteLn(Output,Ans);
  {}
  Done;
end.