{$I-}{$R-}{$N+}
var
  f,f1 :text;

var
  m,n,i,j,k,x,y :longint;
  x1,x2,y1,y2 :array [1..50000] of real;
  no          :array [1..50000] of boolean;

procedure PUSH (ax1,ay1,ax2,ay2 :real);
begin
  inc (n);
  x1[n] := ax1;
  x2[n] := ax2;
  y1[n] := ay1;
  y2[n] := ay2;
end;

procedure Linnear (a1,b1,c1,a2,b2,c2 :real;
                                var x :real; var w :boolean);
var k :real;
begin
  if (b1-b2)=0
    then begin
      if (a1-a2)=0 then begin x := -1; w := true; exit; end;
      x:=0;
      end
    else begin
      k := a1+b1*((a1-a2)/(b1-b2));
      if k=0 then begin x := -1; w := true; exit; end;
      x := c1/k;
      end;
end;

procedure Peresech (x1,y1,x2,y2,x3,y3,x4,y4 :real;
                        var x,y :real; var w,r :boolean);
var a :real;
begin
  Linnear (x2-x1,x3-x4,x1-x3,y2-y1,y3-y4,y1-y3,a,w);
  if w then exit;
  if (0<a)and(a<1)
    then begin
      x := x1+a*(x2-x1);
      y := y1+a*(y2-y1);

      end
    else begin
      x := -1;
      y := -1;
      r := (a<=0);
      end;
end;

procedure rot (var a,b :real);
var t :real;
begin
  t := a;
  a := b;
  b := t;
end;

procedure LSort (var x1,y1,x2,y2 :real);
var w1,w2 :real;
begin
  if x1+y1>x2+y2 then begin rot(x1,x2); rot (y1,y2); end;
end;

function sqrlen (x1,y1,x2,y2 :real) :real;
begin
  sqrlen := sqr(x1-x2)+sqr(y1-y2);
end;

procedure MadeArray;
var
  nx1,nx2,nx3,nx4,
  ny1,ny2,ny3,ny4 :real;
  v1,v2,
  w1,w2,w3,w4,
  r1,r2,r3,r4 :boolean;
begin
  for i := 1 to n do
    for j := 1 to i-1 do
      begin
        if no[j] then continue;

        Peresech (x,y,x1[j],y1[j],x1[i],y1[i],x2[i],y2[i],nx1,ny1,w1,r1);
        Peresech (x,y,x2[j],y2[j],x1[i],y1[i],x2[i],y2[i],nx2,ny2,w2,r2);

        Peresech (x,y,x1[i],y1[i],x1[j],y1[j],x2[j],y2[j],nx3,ny3,w3,r3);
        Peresech (x,y,x2[i],y2[i],x1[j],y1[j],x2[j],y2[j],nx4,ny4,w4,r4);

        v1 := w3 or (nx3=-1);
        v2 := w4 or (nx4=-1);

        if not v1 and not v2 then begin no[i] := true; break; end;

        if v1 and v2 then
          begin
             if w3 then r3 := (sqrlen(x1[i],y1[i],x1[j],y1[j])
                              <=sqrlen(x1[i],y1[i],x2[j],y2[j]));
             if w4 then r4 := (sqrlen(x2[i],y2[i],x1[j],y1[j])
                              <=sqrlen(x2[i],y2[i],x2[j],y2[j]));
             if r3=r4 then continue;
             LSort (x1[i],y1[i],x2[i],y2[i]);
             LSort (nx1,ny1,nx2,ny2);
             PUSH (nx2,ny2,x2[i],y2[i]);
             x2[i] := nx1;
             y2[i] := ny1;
          end;

        if (nx1=-1) or w1 then begin rot (nx1,nx2); rot (ny1,ny2); end;

        if v1 then begin
             x2[i] := nx1;
             y2[i] := ny1;
        end;

        if v2 then begin
             x1[i] := nx1;
             y1[i] := ny1;
        end;
      end;
end;

var sum :real;

function XSum (x1,y1,x2,y2,x3,y3 :real) :real;
begin
  x1 := x1-x3;
  y1 := y1-y3;
  x2 := x2-x3;
  y2 := y2-y3;
  XSum := abs(x1*y2-x2*y1)/2;
end;

procedure CalkSum;
var i :longint;
begin
  for i := 1 to n do
    if not no[i] then
      sum := sum + XSum (x,y,x1[i],y1[i],x2[i],y2[i]);
end;

procedure Output;
begin
  writeln (f1,sum:0:5);
end;

procedure Input;
begin
  read (f,n,m,x,y);
  for i := 1 to n do
    read (f,x1[i],y1[i],x2[i],y2[i]);
end;

procedure Init;
begin
  PUSH (0,0,0,m);
  PUSH (0,0,m,0);
  PUSH (m,m,0,m);
  PUSH (m,m,m,0);
end;

begin
  assign (f,'input.txt');
  assign (f1,'output.txt');
  reset (f);
  rewrite (f1);
    Input;
    Init;
    MadeArray;
    CalkSum;
    Output;
  close (f);
  close (f1);
end.
