{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}

const
  MaxN =102;

type
  TLong = array [0..200] of byte;

var
  dsh : Tlong;
  p           : array [0..100] of TLong;
  a1          : array [0..MaxN+2,0..21] of TLong;
  d           : array [0..100] of integer;
  power,z,res : TLong;
  s           : string[20];
  n,m,i,j     : longint;

procedure init;
begin
  fillchar(dsh,sizeof(dsh),0);
  dsh[0]:=2;
  dsh[1]:=6; dsh[2]:=2;
  assign(input,'input.txt'); reset(input);
  assign(output,'output.txt'); rewrite(output);
  readln(s);
  read(m,n);
  close(input);
end;

procedure Mul(var a,b,c : TLong);
var
  i,j,dv : longint;

begin
  fillchar(c,sizeof(c),0);
  for i:=1 to a[0] do
    for j:=1 to b[0] do
    begin
      dv:=a[i]*b[j]+c[i+j-1];
      c[i+j-1]:=dv mod 10;
      c[i+j]:=c[i+j]+dv div 10;
    end;
  c[0]:=a[0]+b[0];
  while (c[0]>1)and(c[c[0]]=0) do c[0]:=c[0]-1;
end;

procedure Sum(var a,b,c : TLong);
var
  i,l,p : integer;

begin
  if b[0]=0 then c:=a else
  begin
    fillchar(c,sizeof(c),0);
    p:=0;
    if a[0]>b[0] then l:=a[0] else l:=b[0];
    for i:=1 to l do
    begin
      c[i]:=(a[i]+b[i]+p) mod 10;
      p:=(a[i]+b[i]+p) div 10;
    end;
    c[0]:=l;
    if p>0 then
    begin
      c[0]:=c[0]+1;
      c[c[0]]:=1;
    end;
  end;
end;

procedure WriteNum(a : Tlong);
var
  i : integer;

begin
  for i:=a[0] downto 1 do write(a[i]);
end;

procedure C(q,w : integer);
var
  i,j : integer;

begin
  for i:=0 to Maxn+1 do
    for j:=0 to 21 do fillchar(a1[i,j],sizeof(a1[i,j]),0);
  for i:=0 to q+1 do
  begin
    a1[i,0,0]:=1;
    a1[i,0,1]:=1;
  end;
  a1[0,0,0]:=1;
  a1[0,0,1]:=1;
  for i:=1 to q do
    for j:=1 to i+1  do Sum(a1[i-1,j],a1[i-1,j-1],a1[i,j]);
end;

procedure P1(w : integer);
var
  z : comp;

begin
  fillchar(p,sizeof(p),0);
  z:=1;
  p[0,0]:=1;
  p[0,1]:=1;
  for i:=1 to w do Mul(p[i-1],dsh,p[i]);
end;

function CanUnion : boolean;
var
  ok : boolean;

begin
  fillchar(d,sizeof(d),0);
  CanUnion:=false;
  for i:=2 to length(s) do
    if s[i]=s[1] then
    begin
      ok:=true;
      for j:=i+1 to length(s) do
        if s[j]<>s[j-i+1] then
        begin
          ok:=false;
          break;
        end;
      if ok=true then
      begin
        CanUnion:=true;
        d[0]:=d[0]+1;
        d[d[0]]:=i;
      end;
    end;
end;

procedure Rec(w,ost,len : integer);
var
  m1 : Tlong;
  r1 : tlong;
  i  : integer;

begin
  if len<=m then
  begin
    if (ost=0) then
    begin
      Mul(P[m-len],a1[m-len+w,w],m1);
      r1:=res;
      Sum(m1,r1,res);
    end else
    begin
      for i:=1 to d[0] do Rec(w,ost-1,len+d[i]-1);
      Rec(w+1,ost-1,len+length(s));
    end;
  end;
end;

begin
  init;
  C(m,m);
  P1(m);
  if CanUnion=false then
  begin
    if (m-length(s)*n)<0 then
    begin
      write(0);
      close(output);
      halt;
    end;
    Power:=p[m-length(s)*n];
    z:=a1[n+m-length(s)*n,n];
    Mul(power,z,res);
    WriteNum(res);
  end else
  begin
    fillchar(res,sizeof(res),0);
    Rec(1,n-1,length(s));
    WriteNum(res);
  end;
  close(output);
end.
