{$I-,Q-,R-,S-}
{$M 20000000,0,20000000}
const eps=1E-10;
const maxn=20100;
type
  int=longint;
  ex=extended;
  line = record
    x1,y1,x2,y2 : int;
    pu1,pu2 : ex;
  end;
var
  m,n,i,ii,j,jj : int;
  x,y : int;
  data : array [-3..maxn] of line;
  polugl : array [1..2*maxn] of ex;
  teknum : int;
  tek,prev : ex;
  tex,tex1,tex2,tex3 : ex;
  s : ex;
function striangl ( x1,y1,x2,y2,x3,y3 : ex ) : ex;
begin
  striangl:=0.5*abs((x1-x2)*(y1-y2)+(x2-x3)*(y2-y3)+(x3-x1)*(y3-y1));
end;
function striangl2 ( a,b,fi : ex ) : ex;
begin
  striangl2:=0.5*a*b*sin(fi);
end;
function pol ( x1,y1,x2,y2 : int ) : ex;
var
  a : ex;
begin
  if (x1<>x2) then a:=(y2-y1)/(x2-x1)
  else if y2>y1 then a:=Maxlongint
                else a:=-Maxlongint;
  a:=arctan(a);
  if a<0 then a:=a+2*pi;
  if x1>x2 then a:=a+pi;
  if a>=2*pi then a:=a-2*pi;
  pol:=a;
end;
procedure qsort ( l,r : int );
var
  i,j : int;
  x,t : ex;
begin
  i:=l;
  j:=r;
  x:=polugl[l+Random(r-l+1)];
  repeat
    while polugl[i]<x do inc ( i );
    while polugl[j]>x do dec ( j );
    if i<=j then begin
      t:=polugl[i];
      polugl[i]:=polugl[j];
      polugl[j]:=t;
      inc ( i );
      dec ( j );
    end;
  until i>j;
  if i<r then qsort ( i , r );
  if j>l then qsort ( l , j );
end;
function betw ( c,a,b : ex ) : boolean;
begin
  if a<b then if (c>=a-eps) and(c<=b+eps) then betw:=true
              else betw:=false
  else if (c>b-eps)and(c<a+eps) then betw:=true
       else betw:=false;
end;
function betwns ( c,a,b : ex ) : boolean;
begin
  if a<b then if (c>=a+eps) and(c<=b-eps) then betwns:=true
              else betwns:=false
  else if (c>b+eps)and(c<a-eps) then betwns:=true
       else betwns :=false;
end;
function per ( num : int; pu,ck : ex ) : ex;
var
  k1,b1,k2,b2 : ex;
  v1,v2 : boolean;
  cs,si : ex;
  xn,yn : ex;
begin
  if abs(data[num].pu1-data[num].pu2)<pi+eps then begin
    if not betw(ck,data[num].pu1,data[num].pu2) then begin
      per:=-1;
      exit;
    end;
  end else begin
    if betwns(ck,data[num].pu1,data[num].pu2) then begin
      per:=-1;
      exit;
    end;
  end;
  if data[num].x1<>data[num].x2 then begin
    v1:=false;
    k1:=(data[num].y2-data[num].y1)/(data[num].x2-data[num].x1);
    b1:=(data[num].x2*data[num].y1-data[num].x1*data[num].y2)/(data[num].x2-data[num].x1);
  end else begin
    v1:=true;
    k1:=data[num].x1;
  end;
  cs:=cos(pu);
  si:=sin(pu);
  if abs(cs)>eps then begin
    v2:=false;
    k2:=si/cs;
    b2:=y-k2*x;
  end else begin
    v2:=true;
    k2:=x;
  end;
  if not v1 and not v2 then begin
    if abs(k1-k2)<=eps then begin
      per:=-1;
      exit;
    end;
    xn:=(b2-b1)/(k1-k2);
    yn:=k1*xn+b1;
    per:=sqrt(sqr(xn-x)+sqr(yn-y));
    exit;
  end;
  if v1 and v2 then begin
    per:=-1;
    exit;
  end;
  if v1 then begin
    xn:=k1;
    yn:=k2*xn+b2;
    per:=sqrt(sqr(xn-x)+sqr(yn-y));
    exit;
  end;
  xn:=k2;
  yn:=k1*xn+b1;
  per:=sqrt(sqr(xn-x)+sqr(yn-y));
end;
begin
  Assign ( input , 'input.txt' );
  reset ( input );
  Assign ( output , 'output.txt' );
  rewrite ( output );
  read ( n,m );
  data[1].x1:=0;
  data[1].y1:=0;
  data[1].x2:=0;
  data[1].y2:=m;

  data[2].x1:=0;
  data[2].y1:=m;
  data[2].x2:=m;
  data[2].y2:=m;

  data[3].x1:=m;
  data[3].y1:=m;
  data[3].x2:=m;
  data[3].y2:=0;

  data[4].x1:=m;
  data[4].y1:=0;
  data[4].x2:=0;
  data[4].y2:=0;

  read ( x,y );
  for i:=5 to n+4 do begin
    read (data[i].x1,data[i].y1,data[i].x2,data[i].y2 );
  end;
  inc ( n , 4 );
  for i:=1 to n do begin
    polugl[2*i-1]:=pol(x,y,data[i].x1,data[i].y1);
    polugl[2*i  ]:=pol(x,y,data[i].x2,data[i].y2);
    data[i].pu1:=polugl[2*i-1];
    data[i].pu2:=polugl[2*i];
  end;
  qsort ( 1 , 2*n );
  polugl[2*n+1]:=2*pi;
  teknum:=1;
  prev:=0;
  s:=0;
  for i:=1 to 2*n+1 do begin
    tek:=polugl[i];
    tex2:=maxlongint;
    tex3:=maxlongint;
    for ii:=1 to n do begin
      tex:=per(ii,prev,(prev+tek)/2);
      if (tex>-eps) and (tex<tex2) then begin
        tex2:=tex;
      end;
      tex:=per(ii,tek,(prev+tek)/2);
      if (tex>-eps) and (tex<tex3) then begin
        tex3:=tex;
      end;
    end;
    s:=s+striangl2(tex2,tex3,tek-prev);
    prev:=tek;
  end;
  writeln ( s:0:6 );

  close ( input );
  close ( output );
end.
