{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
const inp_file = 'input.txt';
      out_file = 'output.txt';
      nmax = 20000;
      eps = 1e-10;
type tpoint = record
                x,y:extended;
              end;
     tline = record
               a,b:tpoint;
             end;
     ppoint = record
                tip:shortint;
                an:extended;
                po:tpoint;
              end;
     arr = array[1..nmax]of ppoint;

var i,j,n,m:longint;
          x,y,s,ans:extended;
          r:array[1..nmax]of tline;
          p:arr;

procedure readdata;
  begin
    assign(input,inp_file);
    reset(input);
      read(n,m,x,y);
      for i:=1 to n do
        read(r[i].a.x,r[i].a.y,r[i].b.x,r[i].b.y);
    close(input);
  end;
procedure add_new;
var i,j:longint;
    xx,yy:extended;
  begin
    xx:=x/2;
    yy:=y/2;
    r[n+1].a.x:=xx;
    r[n+1].a.y:=yy;
    r[n+1].b.x:=xx;
    r[n+1].b.y:=yy;

    xx:=x/2;
    yy:=(m+y)/2;
    r[n+2].a.x:=xx;
    r[n+2].a.y:=yy;
    r[n+2].b.x:=xx;
    r[n+2].b.y:=yy;

    xx:=(m+x)/2;
    yy:=(m+y)/2;
    r[n+3].a.x:=xx;
    r[n+3].a.y:=yy;
    r[n+3].b.x:=xx;
    r[n+3].b.y:=yy;

    xx:=(m+x)/2;
    yy:= y/2;
    r[n+4].a.x:=xx;
    r[n+4].a.y:=yy;
    r[n+4].b.x:=xx;
    r[n+4].b.y:=yy;

    n:=n+4;
  end;
function eq(x,y:extended):boolean;
  begin
    if abs(x-y)<eps then eq:=true else eq:=false;
  end;
function angle(x,y:extended):extended;
var p:extended;
  begin
    if eq(x,0) then if
      y>0 then angle:=pi/2 else angle:=3*pi/2 else
      if eq(y,0) then
      if x>0 then angle:=0 else angle:=pi else
      begin
        p:=arctan(y/x)+pi;
        if x>0 then
          if y<0 then p:=p + pi else
                      p:=p - pi;
        angle:=p;
      end;
  end;
function vect(x1,y1,x2,y2:extended):extended;
  begin
    vect:=x1*y2-x2*y1;
  end;
function sum(x1,y1,x2,y2,x3,y3:extended):extended;
  begin
    sum:=abs(vect(x2-x1,y2-y1,x3-x1,y3-y1))/2;
  end;

procedure Sort(l, r: longint);
var
  i, j, sr:  longint;
  x   : extended;
  y   : ppoint;
begin
  i := l;
  j := r;
  sr:=(l+r)div 2;
  x := p[sr].an;
  repeat
    while (p[i].an < x)or((eq(p[i].an,x)and(p[i].tip>p[sr].tip))) do i := i + 1;
    while (x < p[j].an)or((eq(p[j].an,x)and(p[j].tip<p[sr].tip))) do j := j - 1;
    if i <= j then
    begin
      y := p[i]; p[i] := p[j]; p[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;
function scal(x1,y1,x2,y2:extended):extended;
  begin
    scal:=x1*x2+y1*y2;
  end;
procedure get(x1,y1,x2,y2:extended;var a,b,c:extended);
  begin
    a:=y2-y1;
    b:=x1-x2;
    c:=x2*y1-x1*y2;
  end;
procedure intersection(x1,y1,x2,y2,x3,y3,x4,y4:extended;var q:boolean;var xx,yy:extended);
var a1,b1,c1,a2,b2,c2,xp,yp,t1,t2:extended;

  begin
    get(x1,y1,x2,y2,a1,b1,c1);
    get(x3,y3,x4,y4,a2,b2,c2);
    if eq(a1*b2,a2*b1) then q:=false else
      begin
        t1:=vect(x2-x1,y2-y1,x3-x1,y3-y1);
        t2:=vect(x2-x1,y2-y1,x4-x1,y4-y1);
        if t1*t2 >eps then begin q:=false;exit;end;
        q:=true;
        xp:=(c2*b1-c1*b2)/(a1*b2-a2*b1);
        if not eq(b1,0) then
          yp:=(-c1-a1*xp)/b1 else
          yp:=(-c2-a2*xp)/b2;

        if scal(x2-x1,y2-y1,xp-x1,yp-y1)< 0 then q:=false;

        xx:=xp;
        yy:=yp;
      end;
  end;

procedure per(x1,y1,x2,y2:extended;var xx,yy:extended);
var flag:boolean;
  begin
    intersection(x1,y1,x2,y2,0,0,0,m,flag,xx,yy);
    if flag then exit;
    intersection(x1,y1,x2,y2,0,0,m,0,flag,xx,yy);
    if flag then exit;
    intersection(x1,y1,x2,y2,m,m,m,0,flag,xx,yy);
    if flag then exit;
    intersection(x1,y1,x2,y2,m,m,0,m,flag,xx,yy);
    if flag then exit;
  end;
procedure solve;
var i,j,sk,kol,now:longint;
          last:tpoint;
          answer,xp,yp,xp2,yp2,pl:extended;

  begin
    add_new;
    sk:=0;
    kol:=0;

    for i:=1 to n do
      begin
        if vect(r[i].a.x-x,r[i].a.y-y,r[i].b.x-x,r[i].b.y-y)>0 then
          begin
            inc(kol);
            p[kol].tip:=1;
            p[kol].an:=angle(r[i].a.x-x,r[i].a.y-y);
            p[kol].po:=r[i].a;
            inc(kol);
            p[kol].tip:=-1;
            p[kol].an:=angle(r[i].b.x-x,r[i].b.y-y);
            p[kol].po:=r[i].b;
            if p[kol-1].an-p[kol].an>eps then inc(sk);
          end else
          begin
            inc(kol);
            p[kol].tip:=-1;
            p[kol].an:=angle(r[i].a.x-x,r[i].a.y-y);
            p[kol].po:=r[i].a;
            inc(kol);
            p[kol].tip:=1;
            p[kol].an:=angle(r[i].b.x-x,r[i].b.y-y);
            p[kol].po:=r[i].b;
            if p[kol].an-p[kol-1].an>eps
            then
            begin
            inc(sk);
            end;
          end;
      end;
  sort(1,kol);
  now:=sk;
  last.x:=m;
  last.y:=y;
  answer:=0;
  for i:=1 to kol do
    begin
      if (now = 0)and(p[i].tip = 1) then
        begin
          per(x,y,last.x,last.y,xp,yp);
          per(x,y,p[i].po.x,p[i].po.y,xp2,yp2);
          answer:=answer + sum(x,y,xp,yp,xp2,yp2);
          last:=p[i].po;
          now:=1;
        end else
        begin
          now:=now + p[i].tip;
          last:=p[i].po;
        end;

    end;
  if sk=0 then
    begin
      per(x,y,m,y,xp,yp);
      per(x,y,last.x,last.y,xp2,yp2);
      pl:=sum(x,y,xp,yp,xp2,yp2);
      answer:=answer + pl;
    end;
  ans:=answer;
  for i:=1 to n-4 do
    ans:=ans + sum(x,y,r[i].a.x,r[i].a.y,r[i].b.x,r[i].b.y);
end;

procedure outdata;
  begin
    assign(output,out_file);
    rewrite(output);
      write(ans:0:6);
    close(output);
  end;
begin
  readdata;
    solve;
  outdata;
end.