{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Type Tip=LongInt;
  Const Inp='input.txt';
        Out='output.txt';
        Max=300;
  Var N : Tip;
      Map,Answer : array [1..Max,1..Max] Of Tip;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I,J : Tip;
Begin
  FillChar(Answer,SizeOf(Answer),0);
  Read(N);
  For I :=1 To N Do
    For J :=1 To N Do
      Read(Map[I,J]);
End;

Function Sum(Const X,Y : Tip) : Tip;
  Var I,J,NeedSum : Tip;
Begin
  NeedSum :=0;
  For I :=1 To N Do
    Inc(NeedSum,Answer[X,I]*Answer[I,Y]);
  Sum :=NeedSum Mod 3;
End;

Function Can(Const I,J : Tip ): Boolean;
  Var NeedSum,Help : Tip;
      CanHelp : Boolean;
Begin
  NeedSum :=Sum(I,J);
  CanHelp :=False;
  Help :=Answer[I,I]+Answer[J,J];
  If NeedSum=Map[I,J] Then
    CanHelp :=True;
  If (NeedSum+Help*1) Mod 3=Map[I,J] Then
    CanHelp :=True;
  If (NeedSum+Help*2) Mod 3=Map[I,J] Then
    CanHelp :=True;
  Can :=CanHelp;
End;

Function What(Const I,J : Tip) : Tip;
  Var NeedSum,Help : Tip;
Begin
  NeedSum :=Sum(I,J);
  Help :=Answer[I,I]+Answer[J,J];
  If NeedSum=Map[I,J] Then
    Begin
      What :=0;
      Exit;
    End;
  If (NeedSum+Help*1) Mod 3=Map[I,J] Then
    Begin
      What :=1;
      Exit;
    End;
  If (NeedSum+Help*2) Mod 3=Map[I,J] Then
    Begin
      What :=2;
      Exit;
    End;
End;

Procedure Solve;
  var I,J : Tip;
      MayAnswer : Boolean;
Begin
  MayAnswer :=True;
  For I :=1 To N Do
    Answer[I,I] :=Map[I,I];
  For J :=2 To N Do
    Begin
      For I :=0 To N-J Do
        If Can(I+1,J+I) Then
          Answer[I+1,J+I] :=What(I+1,J+I)
        Else
          Begin
            MayAnswer :=False;
            break;
          End;
      If Not MayAnswer Then Break;
    End;
  If MayAnswer Then
    For I :=1 To N Do
      Begin
        For J :=1 To N Do
          Write(Answer[I,J],' ');
        WriteLn;
      End
  Else WriteLn(0);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
