#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define LL 32

int _atklen = 8000000;

FILE *fi, *fo;
int n,d,x;
int a[LL];
int l;

int getmy(int n, int d);
bool ismygood(int n, int d);

int lg(int n)
{
  return (int)(log(n)/log(2)+1.00001);
}

int getmy(int n, int d)
{
  int res;
  if(n<=2)
    return (2*d+1);
  res=(d+1)*lg(n);
  if(ismygood(lg(n),d))
    res+=getmy(lg(n),d);
  else
    res+=(2*d+1)*lg(lg(n));
  return res;
}

bool ismygood(int n, int d)
{
  int r1,r2;
  r1=0;
  r2=0;
  if(d==0)
    return false;
  if(n<=2)
    return false;
  r2=(2*d+1)*lg(n);
  r1=getmy(n,d);
  if(r1>=r2)
    return false;
  else
    return true;
}

int code(int n)
{
  int l;
  l=0;
  while(n)
  {
    a[l++]=n&1;
    n=n>>1;
  }
  return l;
}

void wr_code()
{
  int i;
  for(i=lg(n)-1;i>=0;i--)
    fprintf(fo,"%d",a[i]);
}

int getsum()
{
  int i;
  int res;
  res=0;
  for(i=0;i<lg(n);i++)
    res+=a[i];
  return res;
}

int main()
{
  bool flag;
  int i;
  fi=fopen("code.in","rt");
  fo=fopen("code.out","wt");

  fscanf(fi,"%d%d%d",&n,&d,&x);
  if(n==1)
  {
    fprintf(fo,"0\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  n--;
  x--;
  flag=true;
  while(flag)
  {
    for(i=0;i<LL;i++)
      a[i]=0;
    l=code(x);
    flag=ismygood(n,d);
    if(flag)
    {
      for(i=0;i<d+1;i++)
        wr_code();
    }
    else
    {
      for(i=0;i<2*d+1;i++)
        wr_code();
      flag=false;
    }
    x=getsum();
    n=lg(n);
  }
  fprintf(fo,"\n");
  

  fclose(fi);
  fclose(fo);
  return 0;
}
