#include <stdio.h>
#include <stdlib.h>

#define KK 410
#define NN 21

struct REB {
  int a;
  REB *p;
};

struct POINT {
  int x,y;
};

FILE *fi, *fo;
int n,m,k;
POINT a[KK];
REB *g[KK];
REB swap[KK];
int u[NN][NN];
int used[KK];
int iswap;
int s;
int b_d;
int l_b;
POINT b_b[KK];
POINT b[KK];
int i_b,d;

int inv(int c)
{
  return (c==1)?2:1;
}

REB *getnew()
{
  return &swap[iswap++];
}

void Add(int x, int y)
{
  REB *t;
  t=getnew();
  t->a=y;
  t->p=g[x];
  g[x]=t;
}

void dfs(int v, int c)
{
  REB *t;
  used[v]=c;
  if(c==1)
    b[i_b++]=a[v];
  for(t=g[v];t!=NULL;t=t->p)
    if(!used[t->a])
      dfs(t->a,inv(c));
}

bool pos(POINT w)
{
  REB *t;
  int i,j;
  iswap=0;
  i_b=0;
  for(i=0;i<k;i++)
    g[i]=NULL;
  for(i=0;i<k;i++)
  {
    if(!u[(a[i].x+w.x)%m][(a[i].y+w.y)%n])
      return false;
    Add(i,u[(a[i].x+w.x)%m][(a[i].y+w.y)%n]-1);
  }
  for(i=0;i<k;i++)
    used[i]=0;
  for(i=0;i<k;i++)
    if(!used[i])
      dfs(i,1);
  for(i=0;i<k;i++)
    for(t=g[i];t!=NULL;t=t->p)
      if(used[i]==used[t->a])
        return false;
  return true;
}

int main()
{
  int i,j;
  POINT w;
  int ii;
  fi=fopen("tore.in","rt");
  fo=fopen("tore.out","wt");

  fscanf(fi,"%d%d%d",&m,&n,&k);
  if(k%2)
  {
    fprintf(fo,"-1\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if((n==2)&&(m==2)&&(k==4))
  {
    fprintf(fo,"2\n0 0\n1 1\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  for(i=0;i<m;i++)
    for(j=0;j<n;j++)
      u[i][j]=0;
  s=0;
  for(i=0;i<k;i++)
  {
    fscanf(fi,"%d%d",&a[i].x,&a[i].y);
    u[a[i].x][a[i].y]=i+1;
    s+=a[i].x+a[i].y;
  }
  b_d=s+1;
  l_b=0;
  for(i=0;i<m;i++)
  {
    for(j=0;j<n;j++)
    {
      w.x=i;
      w.y=j;
      if(pos(w))
      {
        d=0;
        for(ii=0;ii<i_b;ii++)
        {
          d+=b[ii].x+b[ii].y;
        }
        d=abs(s-2*d);
        if(d<b_d)
        {
          l_b=i_b;
          for(ii=0;ii<l_b;ii++)
            b_b[ii]=b[ii];
          b_d=d;
        }
      }
    }
  }
  if(b_d>s)
  {
    fprintf(fo,"-1\n");
  }
  else
  {
    fprintf(fo,"%d\n",l_b);
    for(i=0;i<l_b;i++)
      fprintf(fo,"%d %d\n",b_b[i].x,b_b[i].y);
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
