{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'tore.out';
  cinfile = 'tore.in';

  nmax = 25;
  inf = maxlongint shr 1;
  smax = nmax*nmax*nmax;
  kcpmax = 250;

type
  int = longint;
  real = extended;

var
  n, m, k : int;
  ans : int;

  dx, dy : int;
  dxa, dya : int;

  a : array [0..nmax,0..nmax] of boolean;

  c, ca : array [0..nmax,0..nmax] of shortint;
  u : array [0..nmax,0..nmax] of boolean;

  dv : boolean;

  kc : int;
  cp : array [1..nmax*nmax,1..3] of int;

  p, pa : array [0..smax] of int;
  sm : int;

procedure outdata;
var
  i, j : int;
begin
  if ans = inf then writeln(-1) else
  begin
    writeln(k shr 1);
    for i:= 0 to n-1 do
      for j:= 0 to m-1 do
        if ca[i,j] = 0 then writeln(i,' ',j);
  end;
end;

procedure deep(x,y : int);
begin
  if a[(x+dx) mod n, (y+dy) mod m] then
  begin
    if c[(x+dx) mod n, (y+dy) mod m] = c[x,y] then
    begin
      dv:= false;
      exit;
    end;
    if c[(x+dx) mod n, (y+dy) mod m] = -1 then
    begin
      c[(x+dx) mod n, (y+dy) mod m]:= 1 - c[x,y];
      deep((x+dx) mod n, (y+dy) mod m);
    end;
  end;
  if a[(x+n-dx) mod n, (y+m-dy) mod m] then
  begin
    if c[(x+n-dx) mod n, (y+m-dy) mod m] = c[x,y] then
    begin
      dv:= false;
      exit;
    end;
    if c[(x+n-dx) mod n, (y+m-dy) mod m] = -1 then
    begin
      c[(x+n-dx) mod n, (y+m-dy) mod m]:= 1 - c[x,y];
      deep((x+n-dx) mod n, (y+m-dy) mod m);
    end;
  end;
end;

procedure fc;
var
  i, j : int;
  q, w, x : int;
  kol : int;
begin
  sm:= 0;
  fillchar(u,sizeof(u),0);
  kc:= 0;
  for i:= 0 to n-1 do
    for j:= 0 to m-1 do
      if a[i,j] and not u[i,j] and (c[i,j] = 0) then
      begin
        inc(kc);
        cp[kc,1]:= i;
        cp[kc,2]:= j;
        cp[kc,3]:= 0;
        q:= i;
        w:= j;
        if c[q,w] = 0 then x:= 1 else x:= -1;
        kol:= 0;
        while (not u[q,w]) and a[q,w] do
        begin
          inc(kol);
          u[q,w]:= true;
          inc(cp[kc,3],(q+w)*x);
          x:= x*-1;
          q:= (q + dx) mod n;
          w:= (w + dy) mod m;
        end;
        q:= (i+n-dx) mod n;
        w:= (j+m-dy) mod m;
        while (not u[q,w]) and a[q,w] do
        begin
          inc(kol);
          u[q,w]:= true;
          inc(cp[kc,3],(q+w)*x);
          x:= x*-1;
          q:= (q + m - dx) mod n;
          w:= (w + m - dy) mod m;
        end;
        if not a[q,w] then
        begin
          q:= (q + dx) mod n;
          w:= (w + dy) mod m;
          if c[q,w] = 1 then sm:= sm - cp[kc,3] else sm:= sm + cp[kc,3];
          if c[q,w] = 1 then
          begin
            while a[q,w] do
            begin
              c[q,w]:= 1-c[q,w];
              q:= (q + dx) mod n;
              w:= (w + dy) mod m;
            end;
          end;
          dec(kc);
        end;
        if kol and 1 = 1 then dv:= false;
      end;
end;

procedure rdj(tyu : int);
var
  i, j : int;
  q, w, t : int;
  uv : array [1..kcpmax] of boolean;
begin
  fillchar(uv,sizeof(uv),0);
  t:= tyu;
  while t <> 0 do
  begin
    uv[p[t]]:= true;
    t:= t-abs(cp[p[t],3]);
  end;
  fillchar(u,sizeof(u),0);
  for i:= 1 to kc do
    if (uv[i] and (cp[i,3] <= 0)) or (not uv[i] and (cp[i,3] > 0)) then
    begin
      q:= cp[i,1];
      w:= cp[i,2];
      while (not u[q,w]) and a[q,w] do
      begin
        u[q,w]:= true;
        ca[q,w]:= 1-ca[q,w];
        q:= (q + dx) mod n;
        w:= (w + dy) mod m;
      end;
      q:= (cp[i,1]+n-dx) mod n;
      w:= (cp[i,2]+m-dy) mod m;
      while (not u[q,w]) and a[q,w] do
      begin
        u[q,w]:= true;
        ca[q,w]:= 1-ca[q,w];
        q:= (q + dx) mod n;
        w:= (w + dy) mod m;
      end;
    end;
end;

procedure make;
var
  i, j : int;
  s, min, nmin : int;
  z : array [0..smax] of boolean;
begin
  s:= 0;
  for i:= 1 to kc do s:= s + abs(cp[i,3]);
  fillchar(z,sizeof(z),0);
  z[0]:= true;
  fillchar(p,sizeof(p),0);
  p[0]:= -1;
  for i:= 1 to kc do
  begin
    for j:= s-abs(cp[i,3]) downto 0 do
      if z[j] and not z[j+abs(cp[i,3])] then
      begin
        z[j+abs(cp[i,3])]:= true;
        p[j+abs(cp[i,3])]:= i;
      end;
  end;
  min:= inf;
  for i:= 0 to s do
    if z[i] and (min > abs(2*i-s+sm)) then
    begin
      min:= abs(2*i-s+sm);
      nmin:= i;
    end;
  if ans > min then
  begin
    ca:= c;
    ans:= min;
    dxa:= dx;
    dya:= dy;
    rdj(nmin);
  end;
end;

procedure find;
var
  i, j : int;
  s : int;
begin
  dv:= true;
  fillchar(c,sizeof(c),255);
  for i:= 0 to n-1 do
    for j:= 0 to m-1 do
      if (c[i,j] = -1) and a[i,j] then
      begin
        c[i,j]:= 0;
        deep(i,j);
      end;
  if not dv then exit;
  s:= 0;
  for i:= 0 to n-1 do
    for j:= 0 to m-1 do inc(s,ord(c[i,j] = 0));
  if s <> k shr 1 then exit;
  fc;
  if not dv then exit;
  make;
{  outdata;}
end;

procedure solve;
var
  i, j : int;
begin
  if k and 1 = 1 then
  begin
    writeln('-1');
    close(output);
    halt(0);
  end;
  ans:= inf;
  for i:= 0 to n-1 do
    for j:= 0 to m-1 do
    begin
      dx:= i;
      dy:= j;
      if (dx = 0) and (dy = 0) then continue;
      find;
     end;
end;

procedure readdata;
var
  i, j : int;
  x, y : int;
begin
  fillchar(a,sizeof(a),0);
  read(n,m,k);
  for i:= 1 to k do
  begin
    read(x,y);
    a[x,y]:= true;
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.