const
  MaxCLen = 32*21;
  MegaSeed = 667;

procedure MakePerm(var a: array of integer;l:integer;seed:longint);
var i,j,c: integer;
begin
  RandSeed:=seed;
  For i:=0 to l-1 do begin
    a[i]:=i;
  end;
  For i:=0 to l-1 do begin
    j:=random(l-i);
    c:=a[i];
    a[i]:=a[i+j];
    a[i+j]:=c;
  end;
end;


var
  fi, fo: text;
  n,d,len,clen,x: longint;
  bX: array[0..MaxCLen-1] of byte;
  code: array[0..MaxCLen-1] of byte;
  a: array[0..MaxCLen-1] of integer;


function DeCode:longint;
var i: integer;
    res,t: longint;
    count: array[0..31] of integer;
begin
  MakePerm(a,clen,MegaSeed);
  fillchar(bX,sizeof(bx),0);
  For i:=0 to clen-1 do
    bX[a[i]]:=code[i];
  res:=0;
  fillchar(count,sizeof(count),0);
  For i:=0 to clen-1 do begin
    if bX[i]=1 then inc(count[i mod len]) else dec(count[i mod len]);
  end;
  For i:=0 to len-1 do
    if count[i]>0 then bX[i]:=1 else bX[i]:=0;
  t:=1;
  For i:=len-1 downto 0 do begin
    res:=res shl 1;
    res:=res+bX[i]
  end;
  Decode:=res+1;
end;


procedure Solve;
begin
  x:=DeCode;
end;

procedure Init;
var i,t: longint;
    ch: char;
begin
  Assign(fi,'decode.in');
  Assign(fo,'decode.out');
  Reset(fi);
  Rewrite(fo);
  ReadLn(fi,n,d);
  while not eoln(fi) do begin
    Read(fi,ch);
    if ch='1' then code[clen]:=1 else code[clen]:=0;
    inc(clen);
  end;
  t:=1;
  len:=0;
  while t<n do begin
    inc(len);
    t:=t*2;
  end;
end;

procedure Done;
begin
  WriteLn(fo,x);
  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
