{$I+,Q+,R+,S+}
Const
  FIn  = 'tore.in';
  FOut = 'tore.out';
{---------------------------------------------------------------------------}
Var
  Input,Output:TEXT;
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxM=20;
  MaxN=20;
  MaxK=MaxN*MaxM;

Type
  TCoo=LongInt;
  TPixel=Record
    X,Y:TCoo;
  end;

Var
  N,M,K:LongInt;
  Pole:array[0..MaxM,0..MaxN]of Record
    P:Boolean;
    Num:LongInt;
  end;
  Coo:array[1..MaxK]of TPixel;
  Jump,Use:array[1..MaxK]of Boolean;

  Ans:Boolean;


  nx,ny,dx,dy,i,j,R:LongInt;

begin
  Init;
  FillChar(Pole,SizeOf(Pole),0);
  {}
  ReadLn(Input,M,N,K);
  For R:=1 to K do
    With Coo[R] do
    begin
      ReadLn(Input,X,Y);
      Pole[X,Y].P:=True;
      Pole[X,Y].Num:=R;
    end;

  For i:=1 to K do
    For j:=1 to K do
    begin
      WriteLn(Output,-1);
      Done;
      If i<>j then
      begin
        If Coo[i].X>Coo[j].X then dx:=M-Coo[i].X+Coo[j].X else dx:=Coo[j].X-Coo[i].X;
        If Coo[i].Y>Coo[j].Y then dy:=M-Coo[i].Y+Coo[j].Y else dy:=Coo[j].Y-Coo[i].Y;
        Ans:=True;
        Use[j]:=True;
        Jump[j]:=False;
        {}
        For R:=1 to K do
          if Not Use[Pole[Coo[R].X,Coo[R].Y].Num] then
          begin
            nx:=(Coo[R].x+dx)mod M;
            ny:=(Coo[R].y+dy)mod N;

            if Not Pole[nx,ny].P then
            begin
              Jump[R]:=False;
              Use[R]:=True;
            end else
            begin
              if (Use[Pole[nx,ny].Num])and(Not Jump[Pole[nx,ny].Num]) then
              begin
                Jump[R]:=True;
              end;
            end;
          end;
      end;
    end;
  {}
  Done;
end.