`{$I-}{$R-}{$N+}
var
  f,f1 :text;

const name = 'magic';

var
  stak :array [1..100000] of longint;
  size :longint;
  par  :array [1..100000] of longint;
  max  :array [1..100000] of longint;
  sp   :array [1..100000,1..100000] of longint;
  level:array [1..100000] of longint;
  n,p,k,m,i,j,x,y:longint;
  pred :array [1..100000,1..100000] of longint;
  k1,k2:array [1..100000] of longint;

procedure ADD (i,j :longint);
begin
  inc (max[i]);
  sp[i,max[i]]:=j;
end;

procedure SLIT (i,j :longint);
var x :longint;
begin
  for x := 1 to max[j]
    do ADD (i,sp[j,x]);
  max[j]:=0;
  if p=j  then p:=i;
  for x := 1 to k do
    begin
      if k1[x]=j then k1[x]:=i;
      if k2[x]=j then k2[x]:=i;
    end;
end;

procedure PUSH (g :longint);
begin
  inc(n);
  stak[n]:=g;
end;

procedure POP (var g :longint);
begin
  g := stak[n];
  dec(n);
end;

function Transform_Gorod (k :longint) :boolean;
var i,j,g :longint; f :boolean; label _exit;
begin
  for i := 1 to n do
    par[i]:=0;
  PUSH (k);
  f := true;
  while (size>0) and f do
    begin
      POP (g);
      for i := 1 to max[g] do
        begin
          if max[sp[g,i]]=0 then continue;
          if par[sp[g,i]]=0 then
            begin
              par[sp[g,i]]  := g;
              PUSH(sp[g,i]);
            end;
          if sp[g,i]=k then
            begin
              f := false;
              break;
            end;
        end;
    end;
  if f then goto _exit;
  while (size>0) do POP(i);
  g := par[k];
  repeat
    SLIT (k,g);
    g := par[g];
  until g=k;
_EXIT:
  Transform_Gorod := f;
end;

procedure Transform;
var i :longint; f :boolean;
begin
  repeat
    f := true;
    for i := 1 to n do
      if max[i]<>0 then
        if not Transform_Gorod(i) then f := false;
  until f;
end;

procedure MakeTree;
var i,g :longint;
begin
  PUSH(p);
  level[p] := 0;
  while (size>0) do
    begin
      POP(g);
      for i := 1 to max[g] do
        if max[sp[g,i]]<>0 then
          begin
            par[sp[g,i]]:=g;
            PUSH(sp[g,i]);
            level[sp[g,i]] :=level[g]+1;
          end;
    end;
end;

procedure Rasschet;
var i,j :longint; f :boolean;
begin
  for i := 1 to n do
    pred[i,i]:=i;
  repeat
    f := false;
    for i := 1 to n do
      for j := 1 to n do
        if pred[i,j]=0 then
          begin
            f := true;
            if level[i]<level[j] then pred[i,j]:=pred[par[i],j];
            if level[i]>level[j] then pred[i,j]:=pred[i,par[j]];
            if level[i]=level[j] then pred[i,j]:=pred[par[i],par[j]];
          end;
  until not f;
end;

begin
  assign (f,name+'.in');
  assign (f1,name+'.out');
  reset (f);
  rewrite (f1);
    read(f,n,m,p);
    for i := 1 to m do
      begin
        read (f,x,y);
        ADD(x,y);
        ADD(y,x);
      end;
    read(f,k);
    for i := 1 to k do
      read (f,k1[i],k2[i]);
    TRANSFORM;
    MAKETREE;
    RASSCHET;
    for i := 1 to k do
      writeln (f1,level[pred[k1[i],k2[i]]]);
  close (f);
  close (f1);
end.
