const
     FileIn='decode.in';
     FileOut='decode.out';
     MaxShift=30;
     MaxN=1 shl MaxShift;
     MaxX=MaxN;
     MaxD=10;
     MaxAnswerLength=(2*MaxD+1)*(MaxShift+1);
var
   N, D, X: LongInt;
   AnswerLength: LongInt;
   CurrentMaxShift: LongInt;
   Answer: array [1..MaxAnswerLength] of LongInt;

procedure CalcSmth;
begin
     CurrentMaxShift:=0;
     while 1 shl CurrentMaxShift<N-1
           do Inc (CurrentMaxShift);
     AnswerLength:=CurrentMaxShift*(2*D+1);
end;

procedure ReadData;
var
   F: Text;
   NBit: LongInt;
   Ch: Char;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, N, D);
     CalcSmth;
     for NBit:=1 to AnswerLength
         do begin
            Read (F, Ch);
            Answer [NBit]:=Byte (Ch='1');
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NBit: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, X);
     Close (F);
end;

procedure Solve;
var
   Shift: LongInt;
   Bits: array [0..MaxShift] of LongInt;
   NIteration: LongInt;
   AnswerBitIndex: LongInt;
begin
     AnswerBitIndex:=1;
     FillChar (Bits, SizeOf (Bits), 0);
     for Shift:=0 to CurrentMaxShift-1
         do for NIteration:=1 to 2*D+1
                do begin
                   Inc (Bits [Shift], Answer [AnswerBitIndex]);
                   Inc (AnswerBitIndex);
                end;
     for Shift:=0 to CurrentMaxShift-1
         do Bits [Shift]:=Round (Bits [Shift]/(2*D+1));
     X:=0;
     for Shift:=0 to CurrentMaxShift-1
         do X:=X or (Bits [Shift] shl Shift);
     X:=X+1;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
