{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Type Tip=LongInt;
  Const Inp='decode.in';
        Out='decode.out';
        Max=5000;
        Help : Array [1..31] Of Int64=(1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,
        65536,131072,262144,524288,1048576,2097152,4194304,8388608,16777216,33554432,67108864,134217728,
        268435456,536870912,1073741824);
  Var N,D,Answer : Tip;
      X : Array [0..Max] Of Tip;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
  Var Symbol : Char;
Begin
  FIllChar(X,SizeOf(X),0);
  ReadLn(N,D);
  Dec(N);
End;

Function Decode(Const From,ToThe,Len1,Len2 : Tip) : Tip;
  Var Help : Array [1..Max] Of Tip;
      I,J,Count,WhatCount,What,Z : Tip;
      {Count - count Differents}
Begin
  FillChar(help,SizeOf(Help),0);
  For I :=1 To Len2 Do
    For J :=From To From+Len1-1 Do
      If J And (1 Shl (I-1))>0 Then
        Begin
          Help[I] :=(Help[I]+X[J]) Mod 2;
          Help[Len2+1] :=(Help[Len2+1]+X[J]) Mod 2;
        End;
  Count :=0;
  For I :=1 To Len2+1 Do
    If Help[I]<>X[ToThe-Len2-1+I] Then
      Inc(Count);
  If Count=1 Then
    Begin
      What :=0;
      For I :=From To From+Len1-1 Do
        Inc(What,(1 Shl (From+Len1-I-1)*X[I]));
      Decode :=What;
    End
  Else
    If Count=0 Then
      Begin
        What :=0;
          For I :=From To From+Len1-1 Do
            Inc(What,(1 Shl (From+Len1-I-1)*X[I]));
        Decode :=What;
      End
    Else
    Begin
      What :=0;
      For I :=0 To Len2-1 Do
        If Help[I+1]<>X[From+Len1+I] Then
          Begin
            Z :=1 Shl I;
            Inc(What,Z);
          End;
      X[From+What-1] :=1-X[From+What-1];
      What :=0;
      For I :=From To From+Len1-1 Do
        Inc(What,(1 Shl (From+Len1-I-1)*X[I]));
      Decode :=What;
    End;
End;

Procedure Solve;
  Var I,J,Len,Count,S : LongWord;
      helpCount,K,Z,LenH,Maxim,W : Tip;
      H : Array [1..Max,1..2] Of Tip;
      Find : Boolean;
      Symbol : Char;
Begin
  FillChar(H,SizeOf(H),0);
  LenH :=0;
  Count :=0;
  While Help[Count+1]<=N Do
    Inc(Count);
  HelpCount :=0;
  While Help[HelpCount+1]<=Count Do
    Inc(HelpCount);
  If D=0 Then
    Begin
      Answer :=0;
      For I :=1 To Count Do
        Inc(Answer,(1 Shl (Count-I)*X[I]));
      WriteLn(Answer+1);
      Exit;
    End;
  Len :=Count+HelpCOunt+1;
  If D=1 Then S:=1
  Else S :=D+1;
  For I :=1 To S Do
    Begin
      X[0] :=0;
      For W:=1 To Len Do
        Begin
          Read(Symbol);
          Inc(X[0]);
          X[X[0]] :=Ord(Symbol)-Ord('0');
        End;
      Z :=Decode(1,Len,Count,HelpCount);
      Find :=False;
      For J :=1 To LenH Do
        If H[J,2]=Z Then
          Begin
            Find :=True;
            Inc(H[J,1]);
            Break;
          End;
      If Not Find Then
        Begin
          Inc(LenH);
          H[LenH,1] :=1;
          H[LenH,2] :=Z;
        End;
    End;
  maxim :=0;
  For I :=1 To LenH Do
    If H[I,1]>Maxim Then
      Begin
        Maxim :=H[I,1];
        Answer :=H[I,2];
      End;
  Write(Answer+1);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
