#include <stdio.h>
#include <string.h>

#define FOR(A1,B1,C1) for(A1 = B1;A1 < C1; A1++)
#define FOR2(A1,B1,C1,A2,B2,C2) for(A1 = B1;A1 < C1; A1++)\
					for(A2 = B2;A2 < C2; A2++)
#define CMP(A,B)  if (A == B)


#if 0
#define MSG(A) 			printf(#A"\n")
#define MSG1(A,A1)		printf(A,A1)
#define MSG2(A,A1,A2)		printf(A,A1,A2)
#define MSG3(A,A1,A2,A3)        printf(A,A1,A2,A3)
#define _M_			printf("Message %d\n",__LINE__);
#else
#define MSG(A)
#define MSG1(A,A1)
#define MSG2(A,A1,A2)
#define MSG3(A,A1,A2,A3)
#define _M_
#endif


struct lex
{
	char type;
	char n;
};

struct exe
{
	char *s;
	int p;
	char vals[26];
	struct lex l;
};

int razbor(struct exe *e,int pr);

char a[128][100][100];
char oper[21][30];

char s[200001];
char expr[31][31];
char fun[127];
int p;
int m;
int n;
struct exe var;

struct lex
lexem(struct exe *e)
{
	struct lex l;
	int x;
	if (	'0' <= e->s[e->p] &&
		e->s[e->p] <= '9') 
	{
		l.type = 1;
		x = 0;
		while ('0'<=e->s[e->p] &&
			e->s[e->p] <= '9') 
		{
			x*=10;
			x+=e->s[e->p]-'0';
			e->p++;
		}
		l.n = x;
		MSG1("LEX %d\n",x);
		return(e->l = l);
	}
	
	l.type = e->s[e->p++];
//	MSG1("LEX '%c'\n",l.type);
	return(e->l = l);
}

int 
in(char *s,char ch)
{
	int b;
	for (;*s;s++) CMP(*s,ch) 
	{
		break;
	}
	if (*s) return(1);
	   else return(0);
}
	
int
F(a,b,c)
{
	return(0);	
}

int
make(int a,int b,char c)
{
	switch(c)
	{
		case '-':return((p+a-b)%p);
		case '+':return((a+b)%p);
		case '*':return((a*b)%p);
		deafolt :return(F(a,b,c));
	}
}


int
razbor(struct exe *e,int pr)
{
	int a,b;
	MSG1("- %d\n",pr);
	CMP(pr,21)
	{
		CMP(e->l.type, '(' )
			{	
				lexem(e);
				a = razbor(e,1);
			}
		else if(e->l.type >= 'a' && e->l.type <= 'z')
			a = e->vals[e->l.type - 'a'];
		else a = e->l.n; 
		lexem(e);
		MSG1("@ %d \n",a);
		return(a);
	}
	CMP(pr,20)
	{
		if (in(oper[20],e->l.type))
		{
			char t = e->l.type;
			lexem(e);
			a = razbor(e,21);
			a = F(a,b,t);
		}
	}
	a = razbor(e,pr+1);
	if (oper[pr][0])
	{
		if (in(oper[pr],e->l.type))
		{
			char t = e->l.type;
			lexem(e);
			b = razbor(e,pr+1);
			a = make(a,b,t);
		}
	}
	return(a);
}




int 
main()
{                 	
	{
		int i,j;
		FILE *f;
		FOR (i,0,21)
			FOR (j,0,30)
			oper[i][j] = 0;
		oper[5][0] = '+';
		oper[5][1] = '-';
		oper[15][0] = '*';
		oper[15][1] = '/';
		f = fopen("calc.in","r");
		fscanf(f,"%d",&p);
		fscanf(f,"%d",&n);
		FOR (i,0,n)
		{
			char ch;
			char s[32];
			int p;
			fscanf(f,"%1s",s);
			ch = *s;
			CMP(ch,'B')
			{
				int j;
				fscanf(f,"%d a%cb=%s",&p,&ch,s);
				fun[ch] = 'B';
				for(j = 0;oper[p][j];j++);
				oper[p][j] = ch;
				strcpy(expr[ch],s);
			/*	printf("- %d %s %d %c\n",p,s,j,ch); */
			}else
			{
				int j;
				fscanf(f," %ca=%s",&ch,s);
				fun[ch] = 'U';
				for(j = 0;oper[20][j];j++);
				oper[p][j] = ch;
				strcpy(expr[ch],s);
			/*	printf("- %s %d %c\n",s,j,ch); */
			}
		}
		fscanf(f,"%d",&m);
		{
			int i,x;
			char ch[2];
			FOR (i,0,m)
			{
				fscanf(f,"%1s=%d\n",ch,&x);
				var.vals[*ch-'a'] = x;
				MSG2("val %c = %d\n",*ch , x);
			}
		}	
		fscanf(f,"%[^\n]",s);
		var.s = s;
		var.p = 0;
		fclose(f);
	}
	lexem(&var);
	{
		FILE *f;
		f = fopen("calc.out","w");
		fprintf(f,"%d\n",razbor(&var,1));
		fclose(f);
	}
#if 0
	{
		struct exe p;
		struct lex l;
		p.p = 0;
		p.s = expr['^']; 
		l = lexem(&p);
		while (l.type)
		{
			if (l.type == 1)
				printf("'%d' ",l.n);
			else
				printf("%c ",l.type);
			l = lexem(&p);
		}
		printf("\n");
	}	 
#endif
	return(0);
}
