  {$I-,Q-,R-,S-}
const infile = 'calc.in'; outfile = 'calc.out'; max = 25;
      end_exp = chr(203); l_val = chr(200); maxe = 200005;
type t_op = record tp: char; pr: longint; symb: char; exp: string[40]; end;
var n,p: longint;
    opers: set of char;
    op: array [1..max] of t_op;
    vr: array ['c'..'z'] of longint;
    cur: char;
    expr: array [1..maxe] of char;
    pos: array [0..max] of longint;
    le: longint;
    value,ans: longint;

procedure read_expr;
begin
     repeat
           inc(le); read(expr[le]);
     until eoln;
     inc(le); expr[le]:=end_exp;
end;

procedure init;
var i,num_vr: longint;
    ch,tmp: char;
    s1: string;
    code: integer;
begin
     assign(input,infile);
     reset(input);
     readln(p);
     readln(n);
     opers:=[];
     for i:=1 to n do begin
         read(op[i].tp);
         if op[i].tp = 'U' then begin
            read(ch);
            read(op[i].symb);
            read(ch); read(ch);
            readln(op[i].exp);
            op[i].exp:=op[i].exp+end_exp;
            opers:=opers+[op[i].symb];
         end
            else begin
            read(ch); read(op[i].pr);
            read(ch); read(ch);
            read(op[i].symb);
            read(ch); read(ch);
            readln(op[i].exp);
            op[i].exp:=op[i].exp+end_exp;
            opers:=opers+[op[i].symb];
         end;
     end;
     readln(num_vr);
     for i:=1 to num_vr do begin
         read(ch); read(tmp); readln(s1);
         val(s1,vr[ch],code);
     end;
     read_expr;
     fillchar(pos,SizeOf(pos),0);
     pos[0]:=1;
end;

procedure read_op_lexem(p: longint);
var ps: longint;
begin
     cur:=op[p].exp[pos[p]]; ps:=pos[p]; value:=0;
     while op[p].exp[pos[p]] in ['0'..'9'] do begin
           cur:=op[p].exp[pos[p]];
           value:=value*10+ord(cur)-48;
           inc(pos[p]);
     end;
     if pos[p] = ps then inc(pos[p])
end;

procedure read_main_lexem;
var ps: longint;
begin
     cur:=expr[pos[0]]; ps:=pos[0]; value:=0;
     while expr[pos[0]] in ['0'..'9'] do begin
           cur:=expr[pos[0]];
           value:=value*10+ord(cur)-48;
           inc(pos[0]);
     end;
     if pos[0] = ps then inc(pos[0])
end;

procedure read_lexem(t: longint);
begin
     if t = 0 then read_main_lexem
        else read_op_lexem(t);
end;

function divide(t,r: longint): longint;
var i: longint;
begin
     for i:=0 to p-1 do
         if (i*r) mod p = t then break;
     divide:=i;
end;

function slag(t: longint): longint; forward;
function mnog(t: longint): longint; forward;
function exp(t: longint): longint; forward;

function exp1(t,a: longint): longint;
var v,res: longint;
    oper: char;
begin
     res:=slag(t);
     while (cur = '+')or(cur = '-') do begin
           oper:=cur; v:=slag(t);
           if oper = '+' then res:=(res+v) mod p
              else res:=(res-v+p) mod p;
     end;
     exp1:=res;
end;

function exp2(t,a,b: longint): longint;
var v,res: longint;
    oper: char;
begin
     res:=slag(t);
     while (cur = '+')or(cur = '-') do begin
           oper:=cur; v:=slag(t);
           if oper = '+' then res:=(res+v) mod p
              else res:=(res-v+p) mod p;
     end;
     exp2:=res;
end;

function mnog(t: longint): longint;
var res,i: longint;
begin
     read_lexem(t);
     if cur in opers then begin
        for i:=1 to n do
            if op[i].symb = cur then begin
               if op[i].tp = 'U' then mnog:=exp1(i,mnog(0))
                  else mnog:=exp2(i,value,mnog(0));
            end;
     end;
     if cur = '-' then begin
        mnog:=-mnog(t); exit;
     end;
     if cur in ['0'..'9'] then begin
        mnog:=value; read_lexem(t); exit;
     end;
     if cur in ['c'..'z'] then begin
        mnog:=vr[cur]; read_lexem(t); exit;
     end;
     if cur = '(' then begin
        mnog:=exp(t);
        read_lexem(t);
        exit;
     end;
end;

function slag(t: longint): longint;
var res,v: longint;
    oper: char;
begin
     res:=mnog(0);
     while (cur = '*')or(cur = '/') do begin
           oper:=cur; v:=mnog(t)+p;
           if oper = '*' then res:=(res*v) mod p
              else res:=divide(res,v);
     end;
     slag:=res;
end;

function exp(t: longint): longint;
var v,res: longint;
    oper: char;
begin
     res:=slag(t) mod p;
     while (cur = '+')or(cur = '-') do begin
           oper:=cur; v:=slag(t);
           if oper = '+' then res:=(res+v) mod p
              else res:=(res-v+p) mod p;
     end;
     exp:=res;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(exp(0));
     close(output);
     close(input);
end;

begin
     init;
     done;
end.
