{$I-,Q-,R-,S-}
Const MaxN = 100000;
      None = MaxLongint;

Type TDocument = Record
                   A, B, N, P: Longint;
                 End;
     TTree = Record
               P, L, R, A, B, M: Longint;
             End;

Var I, J, N, M, K, X, Y, L, R, Left, Right, Middle: Longint;
    D: array[0..MaxN] of TDocument;
    A: array[1..MaxN shl 1] of TTree;
    Ans: array[1..MaxN] of Longint;

Procedure Swap(var A, B: TDocument);
Var C: TDocument;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure Hoar(Left, Right: Longint);
Var I, J, X: Longint;
Begin
  I := Left;
  J := Right;
  X := D[Random(J - I + 1) + I].A;
  While I < J do Begin
    While D[I].A < X do Inc(I);
    While D[J].A > X do Dec(J);
    If I <= J Then Begin
      Swap(D[I], D[J]);
      Inc(I);
      Dec(J);
    End;
  End;
  If Left < J Then Hoar(Left, J);
  If I < Right Then Hoar(I, Right);
End;

Procedure Create(L, R: Longint; var S: Longint);
Begin
  Inc(K);
  S := K;
  A[K].P := I;
  A[K].A := L;
  A[K].B := R;
  If L = R Then D[L].P := K;
End;

Function Min(A, B: Longint): Longint;
Begin
  If A < B Then Min := A
           Else Min := B;
End;

Function InitMin(X: Longint): Longint;
Var L, R: Longint;
Begin
  If A[X].A = A[X].B
  Then
    A[X].M := A[X].A
  Else Begin
    L := InitMin(A[X].L);
    R := InitMin(A[X].R);
    If D[L].B < D[R].B Then A[X].M := L
                       Else A[X].M := R;
  End;
  InitMin := A[X].M;
End;

Function CountMin(X, L, R: Longint): Longint;
Begin
  If (A[X].A = L) and (A[X].B = R)
  Then
    CountMin := A[X].M
  Else
    If R <= A[A[X].L].B
    Then
      CountMin := CountMin(A[X].L, L, R)
    Else
      If L >= A[A[X].R].A
      Then
        CountMin := CountMin(A[X].R, L, R)
      Else Begin
        L := CountMin(A[X].L, L, A[A[X].L].B);
        R := CountMin(A[X].R, A[A[X].R].A, R);
        If D[L].B < D[R].B Then CountMin := L
                           Else CountMin := R;
      End;
End;

Procedure UpDate(X: Longint);
Begin
  If X <= 0 Then Exit;
  If D[A[A[X].L].M].B < D[A[A[X].R].M].B
  Then
    A[X].M := A[A[X].L].M
  Else
    A[X].M := A[A[X].R].M;
  UpDate(A[X].P);
End;

Begin
  Assign(Input, 'docs.in');
  Assign(Output, 'docs.out');
  Reset(Input);
  Rewrite(Output);
  Read(N);
  For I := 1 to N do Begin
    Read(D[I].A, D[I].B);
    D[I].N := I;
  End;
  Hoar(1, N);
  A[1].A := 1;
  A[1].B := N;
  If N = 1 Then D[1].P := 1;
  I := 1;
  K := 1;
  While I <= K do Begin
    If A[I].A < A[I].B Then Begin
      Create(A[I].A, (A[I].A + A[I].B) shr 1, A[I].L);
      Create((A[I].A + A[I].B) shr 1 + 1, A[I].B, A[I].R);
    End;
    Inc(I);
  End;
  D[0].B := None;
  InitMin(1);
  Read(M);
  For I := 1 to M do Begin
    Read(X, Y);
    Left := 1;
    Right := N;
    While Left <= Right do Begin
      Middle := (Left + Right) shr 1;
      If D[Middle].A < X Then Left := Middle + 1
                         Else Right := Middle - 1;
    End;
    L := Middle;
    While (L <= N) and (D[L].A < X) do Inc(L);
    Left := 1;
    Right := N;
    While Left <= Right do Begin
      Middle := (Left + Right) shr 1;
      If D[Middle].A > Y Then Right := Middle - 1
                         Else Left := Middle + 1;
    End;
    R := Middle;
    While (R >= 1) and (D[R].A > Y) do Dec(R);
    If L <= R Then Ans[I] := CountMin(1, L, R)
              Else Ans[I] := 0;
    If Ans[I] = 0 Then Break;
    A[D[Ans[I]].P].M := 0;
    UpDate(A[D[Ans[I]].P].P);
  End;
  If Ans[I] = 0
  Then
    Write('BOTVA')
  Else
    For I := 1 to M do
      Write(D[Ans[I]].N, ' ');
  Close(Input);
  Close(Output);
End.