{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_c;
const
  inpfile='calc.in';
  outfile='calc.out';
  nm=200005;
  mm=35;
type
  String30 = String[32];
  Operation = record
    prior : LongInt;
    st : String30;
  end;
var
  a : array [1..nm] of Char;
  b : array [#33..#127] of Operation;
  v : array ['a'..'z'] of LongInt;
  n,m,p,vn,res : LongInt;
{}
Procedure Inp;
var
  i,j,prior : LongInt;
  ch,c : Char;
begin
  assign(input,inpfile);
  reset(input);
  readln(p,m);
  for i:=1 to m do begin
    read(ch);
    if ch='U' then begin
      prior:=20; read(ch,c);
      b[c].prior:=prior;
      read(ch,ch);
      readln(b[c].st);
    end else begin
      read(prior,ch,ch,c);
      b[c].prior:=prior;
      read(ch,ch);
      readln(b[c].st);
    end;
  end;

  b['+'].st:='a+b';
  b['+'].prior:=5;
  b['-'].st:='a-b';
  b['-'].prior:=5;
  b['*'].st:='a*b';
  b['*'].prior:=10;
  b['/'].st:='a/b';
  b['/'].prior:=10;

  readln(vn);
  for i:=1 to vn do begin
    read(c,ch);
    readln(v[c]);
  end;

  n:=0;
  while not seekeoln do begin
    inc(n); read(a[n]);
  end;
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(v,sizeof(v),0);
end;
{}
Function Expr2(c1,c2,l,r,prior : LongInt; var a : String30) : LongInt;
var
  er,i,j,q,w,kol : LongInt;
  res : LongInt;
  ok : Boolean;
begin
  if (prior=21) and (a[l]='(') and (a[r]=')') then begin
    Expr2:=Expr2(c1,c2,l+1,r-1,1,a); exit;
  end;
  if prior=21 then begin
    res:=0;
    if a[l] in ['a'..'b'] then begin
      if a[l]='a' then res:=c1
                  else res:=c2;
    end else begin
      for i:=l to r do
        res:=10*res+ord(a[i])-ord('0');
    end;
    Expr2:=res; exit;
  end;

  kol:=0; ok:=false; i:=l;
  for i:=l to r do
    if a[i] in [#33..#127] then begin
      if a[i]='(' then inc(kol);
      if a[i]=')' then dec(kol);

      if (b[a[i]].prior=prior) and (kol=0) then begin
        ok:=true;
        if prior=20 then begin
          q:=Expr2(c1,c2,i+1,r,prior,a);
          Expr2:=Expr2(c1,c2,1,length(a),1,a);
        end else begin
          q:=Expr2(c1,c2,l,i-1,prior+1,a);
          w:=Expr2(c1,c2,i+1,r,prior,a);
          case a[i] of
            '+' : Expr2:=(q+w) mod p;
            '-' : Expr2:=(q-w) mod p;
            '*' : Expr2:=(q*w) mod p;
            '/' : begin
              for er:=0 to p-1 do
                if (er*w) mod p = q then begin
                  Expr2:=er; break;
                end;
            end;
            else Expr2:=Expr2(q,w,1,length(b[a[i]].st),1,b[a[i]].st);
          end;
        end;
        break;
      end;
    end;

  if not ok then Expr2:=Expr2(c1,c2,l,r,prior+1,a);

end;
{}
Function Expr(l,r,prior : LongInt) : LongInt;
var
  i,j,q,w,kol : LongInt;
  res : LongInt;
  ok : Boolean;
begin
  if (prior=21) and (a[l]='(') and (a[r]=')') then begin
    Expr:=Expr(l+1,r-1,1); exit;
  end;
  if prior=21 then begin
    res:=0;
    if a[l] in ['a'..'z'] then res:=v[a[l]]
    else begin
      for i:=l to r do
        res:=10*res+ord(a[i])-ord('0');
    end;
    Expr:=res; exit;
  end;


  kol:=0; ok:=false; i:=l;
  for i:=l to r do
    if not (a[i] in ['a'..'z']) then begin
      if a[i]='(' then inc(kol);
      if a[i]=')' then dec(kol);

      if (b[a[i]].prior=prior) and (kol=0) then begin
        ok:=true;
        if prior=20 then begin
          q:=Expr(i+1,r,prior);
          Expr:=Expr2(q,q,1,length(b[a[i]].st),1,b[a[i]].st);
        end else begin
          q:=Expr(l,i-1,prior+1);
          w:=Expr(i+1,r,prior);
          Expr:=Expr2(q,w,1,length(b[a[i]].st),1,b[a[i]].st);
        end;
        break;
      end;
    end;

  if not ok then Expr:=Expr(l,r,prior+1);

end;
{}
Procedure Solve;
begin
  res:=Expr(1,n,1);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.