{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

{Alexey Timofeev }

const
	FILEIN='docs.in';
  FILEOUT='docs.out';
  NMAX=100005;
	inf=1234567890;
type
  longab=record
  	a,b,i:longint;
  end;
	list=array[1..NMAX] of longab;
	pnode=^node;
  node=record
  	key:longab;
    left,right:pnode;
  	i,j:longint;
  end;
var
	i,j,n,m:longint;
  d,p:list;
  ot:array[1..NMAX] of longint;
	i_ot:longint;
  root:pnode;

procedure QuickSort(var A: List; Lo, Hi: longint);
procedure Sort(l, r: longint);
var
  i, j: longint;
	x		: longint;
  y		: longab;
begin
  i := l; j := r; x := a[(l+r) DIV 2].a;
  repeat
    while a[i].a < x do i := i + 1;
    while x < a[j].a do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

begin {VeryQuickSort};
  Sort(Lo,Hi);
end;


procedure initdata;
begin
  fillchar(d,sizeof(d),0);
  fillchar(p,sizeof(p),0);
  fillchar(ot,sizeof(ot),0);
  i_ot:=0;
end;

procedure outdata(flag:boolean);
begin
	assign(output,FILEOUT);rewrite(output);
  if (flag) and (i_ot=m) then
  begin
  	for i:=1 to i_ot do write(ot[i],' ');
  end else
  begin
  	writeln('BOTVA');
  end;
	close(output);
	halt;
end;

procedure readdata;
begin
	assign(input,FILEIN);reset(input);
  read(n);
  for i:=1 to n do
  begin
		read(d[i].a,d[i].b);
  	d[i].i:=i;
  end;
  read(m);
  for i:=1 to m do read(p[i].a,p[i].b);
end;

procedure maket(var p:pnode;i,j,a,b:longint);
begin
	new(p);
  p^.key.a:=a;
  p^.key.b:=b;
  p^.i:=i;
  p^.j:=j;
  if i<j then
  begin
  	maket(p^.left,i,(i+j) div 2,a,b);
  	maket(p^.right,(i+j) div 2+1,j,a,b);
	end else
  begin
  	p^.left:=nil;
    p^.right:=nil;
  end;
end;

procedure insert(var p:pnode;a,b,i:longint);
begin
  if p^.i=p^.j then
  begin
  	p^.key.a:=a;
    p^.key.b:=b;
  end else
  begin
    if i<=(p^.i+p^.j) div 2 then insert(p^.left,a,b,i)
  	else insert(p^.right,a,b,i);

  	if p^.left^.key.a<p^.right^.key.a then p^.key:=p^.left^.key
    else p^.key:=p^.right^.key
  end;
end;

procedure min(p:pnode;i,j:longint;var a,b:longint);
var
	a2,b2:longint;
begin
  if (p^.i=i) and (p^.j=j) then
  begin
  	a:=p^.key.a;
    b:=p^.key.b;
  end else
  if (j<=(p^.i+p^.j) div 2) then
  begin
  	min(p^.left,i,j,a,b);
  end else
  if (i>(p^.i+p^.j) div 2) then
  begin
  	min(p^.right,i,j,a,b);
  end else
  begin
    min(p^.left,i,(p^.i+p^.j) div 2,a,b);
    min(p^.right,(p^.i+p^.j) div 2+1,j,a2,b2);
    if a2<a then
    begin
    	a:=a2;
      b:=b2;
    end;
  end;
end;

function num_c(c:longint):longint;
var
	i,j:longint;
begin
  i:=1;
  j:=n;
  while i+1<j do
  begin
  	if d[(i+j) div 2].a<c then i:=(i+j) div 2
    else j:=(i+j) div 2;
  end;
	if d[i].a<c then inc(i);
  num_c:=i;
end;

function num_d(c:longint):longint;
var
	i,j:longint;
begin
  i:=1;
  j:=n;
  while i+1<j do
  begin
  	if d[(i+j) div 2].a<=c then i:=(i+j) div 2
    else j:=(i+j) div 2;
  end;
	if d[j].a>c then dec(j);
  num_d:=j;
end;

procedure disposetree(var p:pnode);
begin
	if p=nil then exit;
  disposetree(p^.left);
  disposetree(p^.right);
  dispose(p);
end;


procedure solve;
var
	r1,r2,a1,b1:longint;
begin
  {make un HAOS}
  quicksort(d,1,n);

  {make 1/2 interval tree}

  {just empty}
  maket(root,1,n,inf,1);

  {make real tree}
  for i:=1 to n do insert(root,d[i].b,i,i);

  {do it}
  for i:=1 to m do
  begin
  	r1:=num_c(p[i].a);
    r2:=num_d(p[i].b);
    if r1>r2 then outdata(false);
    min(root,r1,r2,a1,b1);
    if a1=inf then outdata(false);
    inc(i_ot);
    ot[i_ot]:=d[b1].i;
    insert(root,inf,1,b1);
  end;

  disposetree(root);
  {scets ouich}

end;

begin
	initdata;
  readdata;
  solve;
  outdata(true);
end.