{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  problem='docs';
  fin= problem+'.in';
  fout=problem+'.out';
  maxn=105000;

type
  aaa=array[1..2]of longint;

var
  botva:boolean;
  a,e,c,d,f:array[1..maxn]of longint;
  b:array[1..2*maxn]of aaa;
  ans:array[1..maxn]of longint;
  i,j,k,n,m,l,r:longint;


procedure sort(l,r:longint);
var
  i,j,x:longint;
begin
  i:=l;
  j:=r;
  x:=a[(i+j)div 2];
  repeat
    while a[i]<x do
      inc(i);
    while a[j]>x do
      dec(j);
    if i<=j then begin
      if i<j then begin
        a[i]:=a[i] xor a[j];
        a[j]:=a[i] xor a[j];
        a[i]:=a[i] xor a[j];
        b[i,1]:=b[i,1] xor b[j,1];
        b[j,1]:=b[i,1] xor b[j,1];
        b[i,1]:=b[i,1] xor b[j,1];
        e[i]:=e[i] xor e[j];
        e[j]:=e[i] xor e[j];
        e[i]:=e[i] xor e[j];
      end;
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then
    sort(i,r);
  if j>l then
    sort(l,j);
end;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);
    for i:=1 to n do
      read(a[i],b[i,1]);
    read(m);
    for i:=1 to m do
      read(c[i],d[i]);

  close(input);
end;

function find1(l,r,x:longint):longint;
var
  i,j:longint;
begin
  i:=(l+r)div 2;
  if l=r then begin
    find1:=l;
    exit;
  end;
  if a[i]>=x then
    find1:=find1(l,i,x)
  else
    find1:=find1(i+1,r,x);
end;

function find2(l,r,x:longint):longint;
var
  i,j:longint;
begin
  i:=(l+r)div 2;
  if l>=r then begin
    find2:=l;
    exit;
  end;
  if a[i]>x then
    find2:=find2(l,i,x)
  else
    find2:=find2(i+1,r,x);
end;

procedure update(i,q:longint);
begin
  if i=0 then
    exit;
  if i<=k then begin
    b[i,1]:=maxlongint;
    if b[2*i,1]<b[i,1] then
      b[i]:=b[2*i];
    if b[2*i+1,1]<b[i,1] then
      b[i]:=b[2*i+1];
  end;
  if q=0 then
    exit;
  if i=1 then
    exit;
  update(i div 2,1);
end;

function min(l,r:longint):longint;
var
  ll,rr:longint;
  lm,rm:aaa;
begin
  if l=r then begin
    min:=b[l,2];
    exit;
  end;
  lm:=b[l div 2];
  rm:=b[r div 2];
  ll:=l div 2;
  rr:=r div 2;
  update(ll,0);
  update(rr,0);
  if l mod 2=1 then
    b[ll]:=b[l];
  if r mod 2=0 then
    b[rr]:=b[r];
  min:=min(ll,rr);
  b[ll]:=lm;
  b[rr]:=rm;
  update(ll,0);
  update(rr,0);
end;

procedure solve;
begin
  for i:=1 to n do
    e[i]:=i;
  sort(1,n);
  j:=1;
  while j<n do
    j:=j shl 1;
  for i:=1 to n do
    f[i]:=b[i,1];
  k:=j-1;
  for i:=1 to k+1 do
    if i<=n then begin
      b[k+i,1]:=f[i];
      b[k+i,2]:=i;
    end
    else begin
      b[k+i,1]:=maxlongint;
      b[k+i,2]:=i;
    end;
  for i:=1 to k do
    b[i,1]:=maxlongint;
  for i:=1 to n do
    update(k+i,1);

  botva:=false;
  for i:=1 to m do begin
    l:=find1(1,n,c[i]);
    r:=find2(1,n,d[i]);
    if a[l]<c[i] then
      inc(l);
    if a[r]>d[i] then
      dec(r);
    if r>=l then begin
      ans[i]:=min(k+l,k+r);
      if b[ans[i]+k,1]>2000000000 then begin
        botva:=true;
        exit;
      end;
      b[ans[i]+k,1]:=maxlongint;
      update(ans[i]+k,1);
      ans[i]:=e[ans[i]];
    end
    else begin
      botva:=true;
      exit;
    end;
  end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    if botva then
      write('BOTVA')
    else
      for i:=1 to m do
        write(ans[i],' ');

  close(output);
end;

begin
  init;
  solve;
  done;
end.