{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 50000,0,655360}

Const INPUTFILE='docs.in';
      OUTPUTFILE='docs.out';

Const MaxN=1 shl 18;
Const INF=1000000002;
Type Real=Double;
     Point=record
     x,y:Longint;
     end;

var a,b,d,Nums:Array[1..MaxN] of Longint;
    c:Array[1..2*MaxN-1] of Longint;
    N,M:Longint;
    N2:Longint;
    Ans:Array[1..MaxN] of Longint;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for i:=1 to N do
  Read(a[i],b[i]);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
if Answer=-1 then
  Writeln('BOTVA')
else
begin
  for i:=1 to M do
    Write(Ans[i],' ');
end;
Close(Output);
Close(Input);
Halt;
end;

Procedure QSort(L,R:Longint);
var i,j,x,t:Longint;
begin
i:=L;
j:=R;
x:=a[(i+j) div 2];
Repeat
  While a[i]<x Do Inc(i);
  While a[j]>x Do Dec(j);
  if i<=j then
  begin
    t:=a[i]; a[i]:=a[j]; a[j]:=t;
    t:=Nums[i]; Nums[i]:=Nums[j]; Nums[j]:=t;

    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if L<j then QSort(L,j);
end;

Function Min(a,b:Longint):Longint;
begin
if a<b then
  Min:=a
else
  Min:=b;
end;

Procedure Build;
var i,j,l:Longint;
begin
l:=1;
While l<N Do l:=l shl 1;
for i:=N+1 to l do
begin
  a[i]:=INF;
  b[i]:=INF;
end;

N:=l;
for i:=1 to N do
  Nums[i]:=i;
QSort(1,N);
for i:=1 to N do
  d[i]:=b[Nums[i]];
{for i:=1 to N do
  Inv[Nums[i]]:=i;}
N2:=2*N-1;
FillChar(c,SizeOf(c),0);
for i:=N to N2 do
  c[i]:=i-N+1;
for i:=N-1 downto 1 do
  if d[c[2*i]]<d[c[2*i+1]] then
    c[i]:=c[2*i]
  else
    c[i]:=c[2*i+1];
end;

Function Search(x:Longint;Left:Boolean):Longint;
var i,j,k:Longint;
    L,R,mid:Longint;
begin
L:=1;
R:=N;
While L<R Do
begin
  mid:=(L+R) div 2;
  if a[mid]<x then
    L:=mid+1
  else if a[mid]>x then
    R:=mid
  else
  begin
    if Left=True then
    begin
      if (mid>1) then
      begin
        if a[mid-1]=x then
          R:=mid-1
        else
        begin
          Search:=mid;
          Exit;
        end;
      end
      else
        Break;
    end
    else
    begin
      if (mid<N) then
      begin
        if a[mid+1]=x then
          L:=mid+1
        else
        begin
          Search:=mid;
          Exit;
        end;
      end
      else
        Break;
    end

  end;
end;
if Left=True then
begin
  if a[L]>=x then
    Search:=L
  else
  begin
    if a[L+1]>=x then
      Search:=L+1
    else
      Search:=0;
  end
end
else
begin
  if a[R]<=x then
    Search:=R
  else
  begin
    if a[R-1]<=x then
      Search:=R-1
    else
      Search:=0;
  end

end;
end;

Function GetMin(i:Longint;L,R:Longint;CL,CR:Longint):Longint;
var g,h,mid,cmid:Longint;
begin
if (L=CL) AND (R=CR) then
begin
  GetMin:=c[i];
  Exit;
end;
{if L=R then}
mid:=(L+R) div 2;
cmid:=(CL+CR) div 2;

if (L>=CL) AND (R<=cmid) then
  GetMin:=GetMin(2*i,L,R,CL,cmid)
else if (L>=cmid+1) AND (R<=CR) then
  GetMin:=GetMin(2*i+1,L,R,cmid+1,CR)
else
begin
  g:=GetMin(2*i,L,cmid,CL,cmid);
  h:=GetMin(2*i+1,cmid+1,R,cmid+1,CR);
  if d[g]<d[h] then
    GetMin:=g
  else
    GetMin:=h;
end;
end;

Procedure Add(i,V:Longint);
begin
i:=i+N-1;
Inc(d[c[i]],V);
While i>1 Do
begin
  i:=i div 2;
  if d[c[2*i]]<d[c[2*i+1]] then
    c[i]:=c[2*i]
  else
    c[i]:=c[2*i+1];
end;
end;

Procedure Solve;
var g,h,l:Longint;
    k:Longint;
begin
Build;
Read(M);
if M>N then FWrite(-1);
for k:=1 to M do
begin
  Read(g,h);
  g:=Search(g,True);
  h:=Search(h,False);
  if (g>h) OR (g=0) then FWrite(-1);
  l:=GetMin(1,g,h,1,N);
  if d[l]>=INF then FWrite(-1);
  Ans[k]:=Nums[l];
  Add(l,INF);
end;
FWrite(1543);
end;

begin
FRead;
Solve;
end.
