{$I-,Q-,R-,S-}
const
  maxn=100000;
  maxm=100000;

var
  j,m,i,n:longint;
  a,b,pos:array[1..maxn] of longint;
  ans:array[1..maxm] of longint;
  ac:longint;
  c,d:longint;
  u:array[1..maxn] of boolean;

procedure out(b:boolean);
var
  i:longint;
begin
  if b then begin
    for i:=1 to ac do begin
      write(ans[i],' ')
    end;
  end else begin
    write('BOTVA');
  end;
  close(input);
  close(output);
  halt(0);
end;

procedure swap(i,j:longint);
var
  temp:longint;
begin
  temp:=a[i];
  a[i]:=a[j];
  a[j]:=temp;
  temp:=b[i];
  b[i]:=b[j];
  b[j]:=temp;
  temp:=pos[i];
  pos[i]:=pos[j];
  pos[j]:=temp;
end;

procedure qsort(l,r:longint);
var
  i,j,x:longint;
begin
  i:=l;
  j:=r;
  x:=a[(l+r) div 2];
  repeat
    while (a[i]<x) do
      inc(i);
    while (x<a[j]) do
      dec(j);
    if i<=j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;

function bsearch(l,r,x:longint):longint;
var
  m:longint;
begin
  if r-l<=2 then begin
    for m:=l to r do begin
      if a[m]>=x then begin
        bsearch:=m;
        exit;
      end;
    end;
  end else begin
    m:=(l+r) div 2;
    if a[m]>=x then
      bsearch:=bsearch(l,m,x)
    else
      bsearch:=bsearch(m+1,r,x);
  end;
end;

function search(l,r:longint):longint;
var
  min,mini,i,l1,r1:longint;

begin
  l1:=bsearch(1,n,l);
  r1:=bsearch(1,n,r);
  if a[r1]>r then
    dec(r1);
  min:=maxlongint;
  mini:=0;
  for i:=l1 to r1 do begin
    if (not u[i]) and (b[i]<min) then begin
      min:=b[i];
      mini:=i;
    end;
  end;
  search:=mini;
end;

begin
  assign(input,'docs.in');
  reset(input);
  assign(output,'docs.out');
  rewrite(output);
  read(n);
  for i:=1 to n do begin
    read(a[i],b[i]);
    pos[i]:=i;
  end;
  qsort(1,n);
  fillchar(u,sizeof(u),false);
  ac:=0;
  read(m);
  for j:=1 to m do begin
    read(c,d);
    i:=search(c,d);
    if i=0 then
      out(false);
    u[i]:=true;
    inc(ac);
    ans[ac]:=pos[i];
  end;
  out(true);
end.
