{$I-,Q-,R-,S-}
const
  maxp=100;
  maxn=30;
  maxm=24;
  digits=['0'..'9'];
  letters=['a'..'z'];

var
  i,m,p,n:byte;
  x,y,z:integer;
  cur:char;
  op:array[1..maxn+4] of record
    curi:byte;
    a,b:byte;
    pr:byte;
    v:array[1..31] of char;
    len:byte;
    c:char;
    values:array[0..maxp-1,0..maxp-1] of byte;
  end;
  c1:char;
  sm:array[#33..#127] of byte;
  constants:array['c'..'z'] of byte;

function simpleexp(i,a,b:byte):byte; forward;

procedure getnext;
begin
  if not seekeof then
    read(cur)
  else
    cur:=' ';
end;

function readconst:byte;
var
  a:byte;

begin
  if cur in digits then begin
    a:=0;
    while cur in digits do begin
      a:=a*10+(ord(cur)-ord('0'));
      getnext;
    end;
    readconst:=a;
  end else begin
    readconst:=constants[cur];
    getnext;
  end;
end;

function readsimconst(i:byte):byte;
var
  a:byte;

begin
  if op[i].v[op[i].curi] in digits then begin
    a:=0;
    while op[i].v[op[i].curi] in digits do begin
      a:=a*10+(ord(op[i].v[op[i].curi])-ord('0'));
      inc(op[i].curi);
    end;
    readsimconst:=a;
  end else begin
    if op[i].v[op[i].curi]='a' then
      readsimconst:=op[i].a
    else
      readsimconst:=op[i].b;
    inc(op[i].curi);
  end;
end;

function simop(i,pr:byte):byte;
var
  u:boolean;
  a,b:byte;
  c1:char;

begin
  if pr=20 then begin
    case op[i].v[op[i].curi] of
      '(':begin
        inc(op[i].curi);
        simop:=simop(i,1);
        inc(op[i].curi);
      end;
      'a'..'z','0'..'9':begin
        simop:=readsimconst(i);
      end;
      else begin
        c1:=op[i].v[op[i].curi];
        inc(op[i].curi);
        simop:=simpleexp(sm[c1],simop(i,20),0);
      end;
    end;
  end else begin
    a:=simop(i,pr+1);
    while (op[i].v[op[i].curi]<>' ') and (op[i].v[op[i].curi]<>')') and (op[sm[op[i].v[op[i].curi]]].pr=pr) do begin
      c1:=op[i].v[op[i].curi];
      inc(op[i].curi);
      b:=simop(i,pr+1);
      a:=simpleexp(sm[c1],a,b);
    end;
    simop:=a;
  end;
end;

function simpleexp(i,a,b:byte):byte;
begin
  if op[i].values[a,b]=p then begin
    op[i].curi:=1;
    op[i].a:=a;
    op[i].a:=a;
    op[i].values[a,b]:=simop(i,1);
  end;
  simpleexp:=op[i].values[a,b];
end;

function operation(pr:byte):byte;
var
  u:boolean;
  a,b:byte;
  c1:char;

begin
  if pr=20 then begin
    case cur of
      '(':begin
        getnext;
        operation:=operation(1);
        getnext;
      end;
      'a'..'z','0'..'9':begin
        operation:=readconst;
      end;
      else begin
        c1:=cur;
        getnext;
        operation:=simpleexp(sm[c1],operation(20),0);
      end;
    end;
  end else begin
    a:=operation(pr+1);
    while (cur<>' ') and (cur<>')') and (op[sm[cur]].pr=pr) do begin
      c1:=cur;
      getnext;
      b:=operation(pr+1);
      a:=simpleexp(sm[c1],a,b);
    end;
    operation:=a;
  end;
end;

begin
  assign(input,'calc.in');
  reset(input);
  assign(output,'calc.out');
  rewrite(output);

  readln(p);
  fillchar(op,sizeof(op),p);

  fillchar(sm,sizeof(sm),0);
  op[1].pr:=5;
  op[1].len:=0;
  op[1].c:='+';
  sm['+']:=1;
  op[2].pr:=5;
  op[2].len:=0;
  op[2].c:='-';
  sm['-']:=2;
  op[3].pr:=15;
  op[3].len:=0;
  op[3].c:='*';
  sm['*']:=3;
  op[4].pr:=15;
  op[4].len:=0;
  op[4].c:='/';
  sm['/']:=4;

  for x:=0 to p do begin
    for y:=0 to p do begin
      op[1].values[x,y]:=(x+y) mod p;
      op[2].values[x,y]:=(x-y+p) mod p;
      op[3].values[x,y]:=(x*y) mod p;
    end;
  end;
  for x:=0 to p do begin
    for y:=1 to p do begin
      for z:=1 to y do begin
        if (z*p+x) mod y=0 then begin
          op[4].values[x,y]:=((z*p+x) div y) mod p;
          break;
        end;
      end;
    end;
  end;

  readln(n);
  n:=n+4;
  for i:=5 to n do begin
    read(c1);
    if c1='U' then begin
      op[i].pr:=20;
    end else begin
      read(op[i].pr);
    end;
    read(c1);{' '}
    read(c1);
    if op[i].pr<20 then
      read(c1);
    op[i].c:=c1;
    sm[c1]:=i;
    read(c1);
    read(c1);{'='}
    op[i].len:=0;
    while not seekeoln do begin
      inc(op[i].len);
      read(op[i].v[op[i].len]);
    end;
    inc(op[i].len);
    op[i].v[op[i].len]:=' ';
    readln;
  end;

  readln(m);
  for i:=1 to m do begin
    read(c1);
    read(cur);{'='}
    readln(constants[c1]);
  end;

  read(cur);
  write(operation(1));

  close(input);
  close(output);
end.
