{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
const
  inf = 'docs.in'; ouf = 'docs.out';
  max = 200100;
type
  liar = array[0..max] of longint;
  procedure swap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
var
  a, b, f, nm, ld, p, rn: liar;

  w: array[0..max] of byte;
  hs: longint;
  procedure down(k: longint);
  var
     j, l: longint;
  begin
    l := k; j := k shl 1;
    if (j <= hs) and
      ((a[j] > a[l]) or
      ((a[j] = a[l]) and (b[j] > b[l]))) then l := j;
    inc(j);
    if (j <= hs) and
      ((a[j] > a[l]) or
      ((a[j] = a[l]) and (b[j] > b[l]))) then l := j;
    if (l <> k) then
    begin
      swap(a[l], a[k]); swap(b[l], b[k]);
      swap(nm[l], nm[k]); down(l);
    end;
  end;
  function boss(k: longint): longint;
  var
    j, bs, pt: longint;
  begin
    j := k; bs := j;
    while (f[j] <> j) do j := f[j];
    boss := j; pt := j;
    j := bs;
    while (f[j] <> j) do
    begin
      bs := j; j := f[j];
      f[bs] := pt;
    end;
  end;
  procedure unite(k, l: longint);
  var
    bk, bl, newboss: longint;
  begin
    bk := boss(k); bl := boss(l);
    newboss := bl;
    if (rn[bk] > rn[bl]) then
    begin
       f[bl] := bk; newboss := bk
    end   else
       if (rn[bk] < rn[bl]) then
        f[bk] := bl
        else
        begin
          f[bk] := bl; inc(rn[bk]);
        end;
    p[newboss] := p[bl];
    if (p[bk] > p[bl]) then p[newboss] := p[bl];
  end;
var
  c, d, i, n: longint;
  function take: boolean;
  var
    l, r, m, j: longint;
  begin
    l := 0; r := n;
    while (r - l > 1) do
    begin
      m := (l + r) shr 1;
      if (a[m] > c) or
         ((a[m] = c) and
         (((b[m] < b[r]) and (a[m] = a[r]))
          or (a[m] <> a[r]))) then
           r := m else l := m;
    end;
    j := p[boss(r)];
    ld[i] := j;
    if (j <> -1) and (a[j] <= d) and (a[j] >= c) then
    begin
      take := true;
      unite(j, j+1);
    end else take := false;
  end;
var
  m, j: longint; ok: boolean;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n);
  fillchar(a, sizeof(a), 0);
  fillchar(f, sizeof(f), 0);
  for i := 1 to n do readln(input, a[i], b[i]);
  for i := 1 to n do
  begin
    nm[i] := i; rn[i] := 1;
  end;
  f := nm; p := f;
  rn[n + 1] := 1; f[n + 1] := n + 1;
  p[n + 1] :=-1;
  hs := n;
  for i := n shr 1 downto 1 do down(i);
  while (hs > 1) do
  begin
    swap(a[1], a[hs]); swap(b[1], b[hs]);
    swap(nm[1], nm[hs]); dec(hs); down(1);
  end;
  readln(input, m);
  for i := 1 to m do
  begin
    readln(input, c, d);
    ok := take;
    if not ok then break;
  end;
  if not ok then writeln(output,'BOTVA') else
  begin
    for i := 1 to m do write(output, nm[ld[i]], ' ');
  end;
  close(input); close(output);
end.
