{$I-,Q-,R-,S-}
var n,m,i,cnt,root,l,r,cur:longint;
    a,b,c,d:array [1..100000] of double;
    num,doc:array [1..100000] of longint;
    tree:array [1..200000] of record
      lb,rb,l,r,n:longint;
    end;
procedure qsort(l,r:longint);
var i,j,it:longint;
    m,t:double;
begin
  i:=l; j:=r;
  m:=a[(l+r) shr 1];
  repeat
    while a[i]<m do inc(i);
    while a[j]>m do dec(j);
    if i<=j then
    begin
      t:=a[i]; a[i]:=a[j]; a[j]:=t;
      t:=b[i]; b[i]:=b[j]; b[j]:=t;
      it:=num[i]; num[i]:=num[j]; num[j]:=it;
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then qsort(l,j);
  if i<r then qsort(i,r);
end;
function gentree(l,r:longint):longint;
var cur,m:longint;
begin
  inc(cnt); cur:=cnt;
  gentree:=cur;
  tree[cur].lb:=l; tree[cur].rb:=r;
  if l<>r then
  begin
    m:=(l+r) shr 1;
    tree[cur].l:=gentree(l,m); tree[cur].r:=gentree(m+1,r);
    tree[cur].n:=tree[tree[cur].l].n;
    if b[tree[tree[cur].r].n]<b[tree[tree[cur].l].n] then
      tree[cur].n:=tree[tree[cur].r].n;
  end
          else
  begin
    tree[cur].l:=0; tree[cur].r:=0;
    tree[cur].n:=l;
  end;
end;
procedure find(x,y:double;var b1,b2:longint);
var l,r,m:longint;
begin
  l:=0; r:=n+1;
  while r-l>1 do
  begin
    m:=(l+r) shr 1;
    if a[m]<x then l:=m
              else r:=m;
  end;
  b1:=r;
  l:=0; r:=n+1;
  while r-l>1 do
  begin
    m:=(l+r) shr 1;
    if a[m]>y then r:=m
              else l:=m;
  end;
  b2:=l;
end;
function getmin(v,l,r:longint):longint;
var m,t1,t2:longint;
begin
  m:=(tree[v].lb+tree[v].rb) shr 1;
  if (tree[v].lb=l) and (tree[v].rb=r) then
    getmin:=tree[v].n
                                       else
  if (l>=tree[v].lb) and (r<=m) then
    getmin:=getmin(tree[v].l,l,r)
                                else
  if (l>=m+1) and (r<=tree[v].rb) then
    getmin:=getmin(tree[v].r,l,r)
                                  else
  begin
    t1:=getmin(tree[v].l,l,m); t2:=getmin(tree[v].r,m+1,r);
    getmin:=t1;
    if b[t2]<b[t1] then getmin:=t2;
  end;
end;
procedure increase(v,c:longint);
var m:longint;
begin
  if (tree[v].lb=tree[v].rb) then
    tree[v].n:=c
                             else
  begin
    m:=(tree[v].lb+tree[v].rb) shr 1;
    if (c>=tree[v].lb) and (c<=m) then increase(tree[v].l,c);
    if (c>=m+1) and (c<=tree[v].rb) then increase(tree[v].r,c);
    tree[v].n:=tree[tree[v].l].n;
    if b[tree[tree[v].r].n]<b[tree[tree[v].l].n] then
      tree[v].n:=tree[tree[v].r].n;
  end;
end;
procedure outno;
begin
  assign(output,'docs.out'); rewrite(output);
  write('BOTVA');
  close(output); halt;
end;
begin
  assign(input,'docs.in'); reset(input);
  read(n);
  for i:=1 to n do
  begin
    read(a[i],b[i]); num[i]:=i;
  end;
  read(m);
  for i:=1 to m do read(c[i],d[i]);
  close(input);
  qsort(1,n);
  cnt:=0; root:=gentree(1,n);
  for i:=1 to m do
  begin
    find(c[i],d[i],l,r);
    if l>r then outno;
    cur:=getmin(root,l,r);
    if b[cur]=maxlongint then outno;
    doc[i]:=num[cur];
    b[cur]:=maxlongint;
    increase(root,cur);
  end;
  assign(output,'docs.out'); rewrite(output);
  for i:=1 to m do write(doc[i],' ');
  close(output);
end.
