program zzz;
{$M 20000000}
{
#10 - dight
#11 - end of expression
}
const
   alph: set of char = ['A'..'Z','a'..'z'];
   dig = ['0'..'9'];
   znak = [#33..#127];
   szn = ['/','*','+','-'];

var
  i,j,k,n,p,m: Longint;
  exp: array[0..35,1..140000] of char;
  pr,pos: array[0..35] of Longint;
  len: array[0..35] of Longint;
  curlexem: array[0..35] of char;
  numops: array[#0..#255] of Longint;
  isbin: array[0..35] of Boolean;
  zn: array[0..35,'a'..'z'] of Longint;
  vl: array[0..99,0..99,1..35] of Longint;
  vis: array[0..99,0..99,1..35] of Boolean;
  ch: char;
  Stng,vir: String;

procedure next(num: Longint; var znch: Longint; var lex: char);
var s: string[5];
    i,j: Longint;
begin
  while pos[num] <= len[num] do if exp[num,pos[num]] = ' ' then inc(pos[num]) else break;
  if pos[num] > len[num] then begin
    lex := #11;
    exit;
  end;
  if exp[num,pos[num]] in alph then begin
    znch := zn[num,exp[num,pos[num]]];
    lex := #10;
    inc(pos[num]);
  end else begin
    if exp[num,pos[num]] in dig then begin
      lex := #10;
      s := '';
      while pos[num] <= len[num] do if not (exp[num,pos[num]] in dig) then break else begin
        s := s + exp[num,pos[num]];
        inc(pos[num]);
      end;
      val(s,znch,i);
      inc(pos[num]);
    end else begin
      lex := exp[num,pos[num]];
      inc(pos[num]);
      exit;
    end;
  end;
end;

function getchar(): char;
var ch: char;
begin
  read(ch);
  while ch = ' ' do read(ch);
  getchar := ch;
end;

procedure extractnum(s: string);
var i,ans: Longint;
    ch: char;
    st: string[5];
begin
  i := 1;
  while s[i] = ' ' do inc(i);
  ch := s[i];
  while s[i] = ' ' do inc(i);
  inc(i);
  while s[i] = ' ' do inc(i);
  inc(i);
  st := '';
  while (i <= length(s)) do begin
    st := st + s[i];
    inc(i);
  end;
  val(st,ans,i);
  zn[0,ch] := ans;
end;

function rec(num: Longint; prior: Longint): Longint;
var i,val3,nm,val1,val2: Longint;
    ch: char;
begin
  if prior = 20 then begin
    next(num,val1,curlexem[num]);
    ch := curlexem[num];
    if ch = #10 then begin
      rec := val1;
      next(num,val1,curlexem[num]);
      exit;
    end;
    if ch = '(' then begin
      rec := rec(num,1);
      next(num,val1,curlexem[num]);
      exit;
    end;
    if not isbin[numops[ch]] then begin
      val1 := rec(num,prior);
      if vis[val1,0,numops[ch]] then begin
        rec := vl[val1,0,numops[ch]];
        exit;
      end else begin
        pos[numops[ch]] := 1;
        zn[numops[ch],'a'] := val1;
        val2 := rec(numops[ch],1);
        vis[val1,0,numops[ch]] := true;
        vl[val1,0,numops[ch]] := val2;
        rec := val2;
        exit;
      end;
    end;
  end else begin
    val1 := rec(num,prior+1);
    while true do begin
      ch := curlexem[num];
      if numops[curlexem[num]] = 0 then begin
        rec := val1;
        exit;
      end;
      if pr[numops[ch]] = prior then begin
        nm := numops[ch];
        val2 := rec(num,prior+1);
        if vis[val1,val2,nm] then begin
          val1 := vl[val1,val2,nm];
        end else begin
          if nm > 30 then begin
            case ch of
              '+': val1 := (val1 + val2) mod p;
              '-': val1 := (p + val1 - val2) mod p;
              '*': val1 := (val1 * val2) mod p;
              '/': begin
                for i := 0 to p-1 do begin
                  if (val2 * i) mod p = 1 then break;
                end;
                val1 := (val1 * i) mod p;
              end;
            end;
          end else begin
            pos[numops[ch]] := 1;
            zn[numops[ch],'a'] := val1;
            zn[numops[ch],'b'] := val2;
            vis[val1,val2,numops[ch]] := true;
            val3 := rec(numops[ch],1);
            vl[val1,val2,numops[ch]] := val3;
            val1 := val3;
          end;
        end;
      end else begin
        rec := val1;
        exit;
      end;
    end;
  end;
end;

begin
  assign(input,'calc.in'); reset(input);
  readln(p);
  readln(n);
  numops['/'] := 31;
  numops['*'] := 32;
  numops['+'] := 33;
  numops['-'] := 34;
  pr[31] := 15; pr[32] := 15;
  pr[33] := 5; pr[34] := 5;
  for i := 1 to n do begin
    isbin[i] := 'B' = getchar();
    if isbin[i] then read(pr[i]);
    if isbin[i] then begin
      getchar();
      numops[getchar()] := i;
      getchar();
      getchar();
    end else begin
      numops[getchar()] := i;
      getchar();
      getchar();
    end;
    readln(exp[i]);
  end;
  readln(m);
  for i := 1 to m do begin
    readln(stng);
    extractnum(stng);
  end;
  readln(exp[0]);
  for i := 0 to n do begin
    len[i] := length(exp[i]);
  end;
  pos[0] := 1;
  assign(output,'calc.out'); rewrite(output);
  writeln(rec(0,1));
  close(input);
  close(output);
end.
