program TaskC;
const infile = 'holidays.in';
      outfile = 'holidays.out';
      MAXN = 100;
      months:array[1..12]of string[9] = ('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
type t2 = (_ADD, _REMOVE);
     t3 = record
  m, d, hm, hd:integer;
  t:t2;
end;
var y1, y2, N:integer;
    hl:array[1..MAXN]of t3;
    yr:array[1..MAXN]of integer;

function fm(st:string):integer;
var i:integer;
begin
  for i:=1 to 12 do if months[i]=st then begin fm:=i; exit; end;
end;

procedure inp;
var st, t:string;
    i, k:integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  readln(y1, y2);
  readln(N);
  for i:=1 to N do
  begin
    readln(st);
    t:=copy(st, 1, pos(',', st)-1);
    hl[i].m:=fm(copy(t, 1, pos(' ', t)-1)); delete(t, 1, pos(' ', t));
    val(t, hl[i].d, k); delete(st, 1, pos(',', st)+1);
    if st[1]='a' then hl[i].t:=_ADD else hl[i].t:=_REMOVE;
    delete(st, 1, pos(' ', st));
    hl[i].hm:=fm(copy(st, 1, pos(' ', st)-1));
    delete(st, 1, pos(' ', st)); val(st, hl[i].hd, k);
  end;
end;

function isLeap(i:integer):boolean;
begin
  if (i mod 4=0)and((i mod 100<>0)or(i mod 400=0)) then isLeap:=true else isLeap:=false;
end;

function le(m1, d1, m2, d2:integer):boolean;
begin
  if (m1<m2)or((m1=m2)and(d1<=d2)) then le:=true else le:=false;
end;

function ge(m1, d1, m2, d2:integer):boolean;
begin
  if (m1>m2)or((m1=m2)and(d1>=d2)) then ge:=true else ge:=false;
end;

function can(i, y:integer):boolean;
begin
  if (hl[i].m=2)and(hl[i].d=29)and(not isLeap(y)) then begin can:=false; exit; end;
  if (i=1) then begin can:=true; exit; end;
  if (yr[i-1]=y)and(le(hl[i].m, hl[i].d, hl[i-1].m, hl[i-1].d)) then begin can:=false; exit; end;
  can:=true;
end;

function cnt(i, y:integer):longint;
var j:integer;
    t, o:longint;
begin
  t:=0;
  for j:=1 to i do
  begin
    if hl[j].t=_ADD then o:=1 else o:=-1;
    if (hl[j].m=2)and(hl[j].d=29)and(not isLeap(y)) then continue;
    if (yr[j]=y)and(ge(hl[j].m, hl[j].d, hl[j].hm, hl[j].hd)) then continue;
    t:=t+o;
  end;
  cnt:=t;
end;

procedure run;
var i, cur:integer;
    res:longint;
begin
  for i:=N downto 1 do if hl[i].t=_ADD then break;
  cur:=0; res:=0;
  for i:=y1 to y2 do
  begin
    while (cur<N)and(can(cur+1, i)) do begin inc(cur); yr[cur]:=i; end;
    inc(res, cnt(cur, i));
  end;
  if cur<N then begin write(-1); exit; end;
  writeln(res);
  for i:=1 to N do
  begin
    write(months[hl[i].m], ' ', hl[i].d, ' ', yr[i], ',');
    if hl[i].t=_ADD then write(' added ') else write(' removed ');
    writeln(months[hl[i].hm], ' ', hl[i].hd);
  end;
end;

procedure outp;
begin
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
