#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#define NN 101
#define MM 12
#define KK 31

#define MANY 100000000

struct TDATE {
  int month,day;
};

const int num_days[12] = {31,28,31,30,31,30,31,31,30,31,30,31};

FILE *fi, *fo;
int ys,yf;
int n;
TDATE x[NN];
TDATE y[NN];
bool tp[NN];
bool m[NN][KK][KK];
int a[NN][NN][NN];
int m_s[NN];
int m_l[NN];
int m_g1_s[NN],m_g1_l[NN];
int m_g2_s[NN],m_g2_l[NN];
int ps[NN];
int ans[NN];

void readword(char *s)
{
  int c;
  c=getc(fi);
  (*s)='\0';
  while(!isalpha(c))
    if(c==EOF)
      return ;
    else
      c=getc(fi);
  while(isalpha(c))
  {
    *s=c;
    s++;
    c=getc(fi);
  }
  *s='\0';
}

int s2m(char *s)
{
  if(strcmp(s,"January")==0)
    return 0;
  if(strcmp(s,"February")==0)
    return 1;
  if(strcmp(s,"March")==0)
    return 2;
  if(strcmp(s,"April")==0)
    return 3;
  if(strcmp(s,"May")==0)
    return 4;
  if(strcmp(s,"June")==0)
    return 5;
  if(strcmp(s,"July")==0)
    return 6;
  if(strcmp(s,"August")==0)
    return 7;
  if(strcmp(s,"September")==0)
    return 8;
  if(strcmp(s,"October")==0)
    return 9;
  if(strcmp(s,"November")==0)
    return 10;
  if(strcmp(s,"December")==0)
    return 11;
}

void wr_date(TDATE *p)
{
  switch(p->month)
  {
    case 0:
      fprintf(fo,"January");
      break;
    case 1:
      fprintf(fo,"February");
      break;
    case 2:
      fprintf(fo,"March");
      break;
    case 3:
      fprintf(fo,"April");
      break;
    case 4:
      fprintf(fo,"May");
      break;
    case 5:
      fprintf(fo,"June");
      break;
    case 6:
      fprintf(fo,"July");
      break;
    case 7:
      fprintf(fo,"August");
      break;
    case 8:
      fprintf(fo,"September");
      break;
    case 9:
      fprintf(fo,"October");
      break;
    case 10:
      fprintf(fo,"November");
      break;
    case 11:
      fprintf(fo,"December");
      break;
  }
  fprintf(fo," %d",p->day+1);
}

void read_date(TDATE *p)
{
  char s[256];
  readword(s);
  p->month=s2m(s);
  fscanf(fi,"%d",&p->day);
  p->day--;
}

void read_data()
{
  int i;
  char s[256];
  for(i=0;i<n;i++)
  {
    read_date(&x[i]);
    readword(s);
    read_date(&y[i]);
    if(strcmp(s,"added")==0)
      tp[i]=true;
    else
      tp[i]=false;
  }
}

void build_m()
{
  int i,j,k;
  for(i=0;i<MM;i++)
    for(j=0;j<KK;j++)
      m[0][i][j]=false;
  m[0][y[0].month][y[0].day]=true;
  for(k=1;k<n;k++)
  {
    for(i=0;i<MM;i++)
      for(j=0;j<KK;j++)
        m[k][i][j]=m[k-1][i][j];
    if(tp[k])
      m[k][y[k].month][y[k].day]=true;
    else
      m[k][y[k].month][y[k].day]=false;
    m_s[k]=0;
    for(i=0;i<MM;i++)
      for(j=0;j<num_days[i];j++)
        if(m[k][i][j])
          m_s[k]++;
    if(m[k][1][28])
      m_l[k]=m_s[k]+1;
    else
      m_l[k]=m_s[k];
    m_g1_s[k]=0;
    m_g2_s[k]=0;
    for(i=0;i<x[k].month;i++)
      for(j=0;j<num_days[i];j++)
        if(m[k][i][j])
          m_g1_s[k]++;
    for(j=0;(j<x[k].day)&&(j<num_days[x[k].month]);j++)
      if(m[k][x[k].month][j])
        m_g1_s[k]++;
    if(!tp)
      if(!((x[k].month==1)&&(x[k].day==28)))
        m_g1_s[k]++;
    if(m[k][1][28])
      if((x[k].month<1)||((x[k].month==1)&&(x[k].day<28)))
        m_g1_l[k]=m_g1_s[k]+1;
      else
        m_g1_l[k]=m_g1_s[k];
    else
      m_g1_l[k]=m_g1_s[k];
    for(i=MM-1;i>x[k].month;i--)
      for(j=num_days[i];j>=0;j--)
        if(m[k][i][j])
          m_g2_s[k]++;
    for(j=num_days[x[k].month];j>x[k].day;j--)
      if(m[k][x[k].month][j])
        m_g2_s[k]++;
    if(tp)
      if(!((x[k].month==1)&&(x[k].day==28)))
        m_g2_s[k]++;
    if(m[k][1][28])
      if(x[k].month>1)
        m_g2_l[k]=m_g2_s[k]+1;
      else
        m_g2_l[k]=m_g2_s[k];
    else
      m_g2_l[k]=m_g2_s[k];
    if((x[k].month==1)&&(x[k].day==28))
      if(tp)
        m_g2_l[k]++;
      else
        m_g1_l[k]++;
  }
}

int get_num(int q, int y1 ,int y2)
{
  if(y1==y2)
  {
    if(x[q].month>x[q+1].month)
      return -MANY;
    if(x[q].month==x[q+1].month)
      if(x[q].day>x[q+1].day)
        return -MANY;
    return m_g1_s[y1];
  }
}

bool isvis(int y)
{
  if(y%4!=0)   return false;
  if(y%400==0) return true;
  if(y%100==0) return false;
  return true;
}

int get_first_vis(int y)
{
  while(!isvis(y)) y++;
  return y;
}

int calc_ans()
{
  int i,j,k;
  int ii,jj;
  int res;
  k=0;
  res=0;
  for(i=ys;i<=yf;i++)
  {
    for(j=0;j<MM;j++)
    {
      for(ii=0;ii<num_days[j];ii++)
      {
        if((ans[k]==i)&&(x[k].month==j)&&(x[k].day==ii))
        {
          if(!tp[k])
            res++;
          k++;
        }
        else
          if((y[k].month!=j)||(y[k].day!=ii)||(!tp[k]))
            if(m[k][j][ii])
              res++;
      }
      if(isvis(i)&&(j==1))
      {
        ii=28;
        if((ans[k]==i)&&(x[k].month==j)&&(x[k].day==ii))
        {
          if(!tp[k])
            res++;
          k++;
        }
        else
          if((y[k].month!=j)||(y[k].day!=ii)||(!tp[k]))
            if(m[k][j][ii])
              res++;
      }
    }
  }
  return res;
}

int main()
{
  int res;
  int i,j;
  fi=fopen("holidays.in","rt");
  fo=fopen("holidays.out","wt");

  fscanf(fi,"%d%d",&ys,&yf);
  fscanf(fi,"%d",&n);
  read_data();
  build_m();
  for(i=0;i<n;i++)
    ps[i]=0;
  ps[n-1]=0;
  for(i=n-2;i>=0;i--)
    if(tp[i])
      ps[i]=ps[i+1]+1;
    else
      ps[i]=ps[i+1]-1;
  ans[0]=ys;
  if((x[0].month==1)&&(x[0].day==28))
    ans[0]=get_first_vis(ys);
  for(i=1;i<n;i++)
  {
    if((x[i].month>x[i-1].month)||((x[i].month==x[i-1].month)&&(x[i].day<x[i-1].day)))
      ans[i]=ans[i-1];
    else
      ans[i]=ans[i-1]+1;
    if((x[i].month==1)&&(x[i].day==28))
      ans[i]=get_first_vis(ans[i]);
  }
  for(i=0;i<n;i++)
  {
    if(ans[i]>yf)
    {
      fprintf(fo,"-1\n");
      fclose(fi);
      fclose(fo);
      return 0;
    }
  }
  for(i=0;i<MM;i++)
    for(j=0;j<KK;j++)
      m[n][i][j]=m[n-1][i][j];
  x[n].month=222;
  x[n].day=100;
  res=calc_ans();
  fprintf(fo,"%d\n",res);
  for(i=0;i<n;i++)
  {
    wr_date(&x[i]);
    fprintf(fo," %d,",ans[i]);
    if(tp[i])
      fprintf(fo," added ");
    else
      fprintf(fo," removed ");
    wr_date(&y[i]);
    fprintf(fo,"\n");
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
