  {$I-,Q-,R-,S-}
const infile = 'holidays.in'; outfile = 'holidays.out';
      _added = 1; _removed = 0; max = 105; y1 = 1790; y2 = 2220; inf = 100000;
      months: array [1..12] of string = ('January','February','March','April',
      'May','June','July','August','September','October','November','December');
      tp: array [0..1] of string = ('removed','added');
type recr = record dm,dd,hm,hd,id: integer; op: byte; end;
     mhld = array [1..max] of integer;
var r: array [1..max] of recr;
    h: array [1..max,1..2] of longint;
    t,c: array [0..max] of mhld;
    nt: array [0..max] of integer;
    can,cntf: array [1..max,1..max] of byte;
    f,f0: array [y1..y2,0..max] of longint;
    n,ys,yf,numh: longint;
    dcc: array [1..max,1..max] of byte;
    vis: array [y1..y2] of byte;
    ans,ans0: array [y1..y2,0..max] of integer;
    res: array [1..max] of longint;

function find_month(mm: string): longint;
var i: longint;
begin
     find_month:=0;
     for i:=1 to 12 do
         if months[i] = mm then begin
            find_month:=i; exit;
         end;
end;

procedure read_data(v: longint);
var m1,m2,what: string;
    n1,n2,i: longint;
    ch: char;
    ok: boolean;
begin
     while not (ch in ['a'..'z','A'..'Z']) do read(ch);
     m1:='';
     while ch in ['a'..'z','A'..'Z'] do begin
           m1:=m1+ch; read(ch);
     end;
     read(ch); n1:=0;
     while not (ch in ['0'..'9']) do read(ch);
     while ch in ['0'..'9'] do begin
           n1:=n1*10+ord(ch)-48; read(ch);
     end;
     read(ch); what:='';
     while not (ch in ['a'..'z','A'..'Z']) do read(ch);
     while ch in ['a'..'z','A'..'Z'] do begin
           what:=what+ch; read(ch);
     end;
     m2:='';
     while not (ch in ['a'..'z','A'..'Z']) do read(ch);
     while ch in ['a'..'z','A'..'Z'] do begin
           m2:=m2+ch; read(ch);
     end;
     read(ch); n2:=0;
     while not (ch in ['0'..'9']) do read(ch);
     while ch in ['0'..'9'] do begin
           n2:=n2*10+ord(ch)-48; read(ch);
     end;
     r[v].dm:=find_month(m1);
     r[v].hm:=find_month(m2);
     r[v].dd:=n1;
     r[v].hd:=n2;
     if what = 'added' then r[v].op:=_added
        else r[v].op:=_removed;
     ok:=false;
     for i:=1 to numh do
         if (h[i,1] = r[v].hm)and(h[i,2] = r[v].hd) then begin ok:=true; break; end;
     if not ok then begin
        inc(numh); h[numh,1]:=r[v].hm; h[numh,2]:=r[v].hd; r[v].id:=numh;
     end
        else begin
             r[v].id:=i;
        end;
end;

procedure init;
var i,j: longint;
begin
     assign(input,infile);
     reset(input);
     readln(ys,yf);
     readln(n); numh:=0;
     for i:=1 to n do
         read_data(i);
     close(input);
     fillchar(vis,SizeOf(vis),0);
     for i:=y1 to y2 do
         if (i mod 4 = 0) then begin
            if (i mod 100 = 0) then begin
               if (i mod 400 = 0) then vis[i]:=1;
            end
               else vis[i]:=1;
         end;
     fillchar(cntf,SizeOf(cntf),0);
     for i:=1 to n do
         for j:=i to n do begin
             if i < j then cntf[i,j]:=cntf[i,j-1];
             if (r[j].dm = 2)and(r[j].dd = 29) then
                cntf[i,j]:=1;
         end;
end;

procedure find_t;
var i,j: longint;
begin
     fillchar(t,SizeOf(t),0);
     fillchar(nt,SizEOf(nt),0);
     for i:=1 to n do begin
         t[i]:=t[i-1];
         if r[i].op = _added then t[i,r[i].id]:=1
            else t[i,r[i].id]:=0;
         for j:=1 to n do
             nt[i]:=nt[i]+t[i,j];
     end;
end;

procedure find_c;
var i,j,k1,k2: longint;
    cur: mhld;
begin
     for i:=1 to n do for j:=1 to n do begin c[i,j]:=0; can[i,j]:=0; end;
     for i:=1 to n do
         for j:=i to n do begin
             if  (i < j)and(r[j].dm*100+r[j].dd <= r[j-1].dm*100+r[j-1].dd) then break;
             cur:=t[i-1]; can[i,j]:=1;
             k1:=1; c[i,j]:=nt[i-1];
             for k2:=i to j do begin
                 if r[k2].op = _added then begin
                    if r[k2].dm*100+r[k2].dd < r[k2].hm*100+r[k2].hd then begin
                       inc(c[i,j]); cur[r[k2].id]:=1;
                    end;
                 end
                    else begin
                    if r[k2].dm*100+r[k2].dd < r[k2].hm*100+r[k2].hd then begin
                       dec(c[i,j]); cur[r[k2].id]:=0;
                    end;
                 end;
             end;
             for k2:=1 to n do
                 if (cur[k2] = 1)and(h[k2,1] = 2)and(h[k2,2] = 29) then
                    begin dcc[i,j]:=1; break; end;
         end;
end;

procedure solve;
var i,j,k,dc,dc2: longint;
begin
     fillchar(can,sizeOf(can),0);
     find_t;
     find_c;
     for i:=ys-1 to yf do begin
         for j:=1 to n do begin
             f[i,j]:=-inf;
             f0[i,j]:=-inf;
         end;
         f[i,0]:=0;
     end;
     f[ys,1]:=0;
     for i:=ys to yf do begin
         for j:=1 to n do begin
             dc:=0;
             if vis[i] = 0 then begin
                for k:=1 to n do
                    if (t[j,k] = 1)and(h[k,1] = 2)and(h[k,2] = 29) then
                       begin dc:=1; break; end;
             end;
             for k:=j-1 downto 0 do if can[k+1,j] = 1 then begin
                 dc2:=0;
                 if vis[i] = 0 then dc2:=dcc[k+1,j];
                 if (vis[i] = 1)or(cntf[k+1,j] = 0) then begin
                    if f[i,j] < f[i-1,k]+c[k+1,j]-dc2 then begin
                       f[i,j]:=f[i-1,k]+c[k+1,j]-dc2;
                       ans[i,j]:=k;
                    end;
                    if f[i,j] < f0[i-1,k]+c[k+1,j]-dc2 then begin
                       f[i,j]:=f0[i-1,k]+c[k+1,j]-dc2;
                       ans[i,j]:=-k;
                    end;
                 end;
             end;
             if f0[i,j] < f0[i-1,j]+nt[j]-dc then begin
                f0[i,j]:=f0[i-1,j]+nt[j]-dc;
                ans0[i,j]:=0;
             end;
             if f0[i,j] < f[i-1,j]+nt[j]-dc then begin
                f0[i,j]:=f[i-1,j]+nt[j]-dc;
                ans0[i,j]:=1;
             end;
         end;
     end;
end;

procedure gen_answer(ww: longint; st: longint);
var i,w,y,j,k: longint;
begin
     i:=st; w:=ww; y:=yf;
     while y >= ys do begin
           if w = 0 then begin
              j:=ans0[y,i];
              if j = 0 then w:=0
                 else w:=1;
              dec(y);
           end
              else begin
              j:=ans[y,i];
              if j < 0 then begin w:=0; j:=-j; end;
              for k:=j+1 to i do res[k]:=y;
              dec(y); i:=j;
           end;
     end;
end;

procedure done;
var i,mx,j,tt: longint;
begin
     assign(output,outfile);
     rewrite(output);
     mx:=0;
     for i:=n to n do begin
         if f0[yf,i] > mx then begin
            mx:=f0[yf,i]; tt:=0; j:=i;
         end;
         if f[yf,i] > mx then begin
            mx:=f[yf,i]; tt:=1; j:=i;
         end;
     end;
     writeln(mx);
     gen_answer(tt,j);
     for i:=1 to n do
         writeln(months[r[i].dm],' ',r[i].dd,' ',res[i],', ',tp[r[i].op],
            ' ',months[r[i].hm],' ',r[i].hd);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
