{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='casino.in';
  outfile='casino.out';
  osn=10000;
  lm=30;
  nm=55;
type
  TLong = array [0..lm] of LongInt;
var
  a,b : array [1..nm] of LongInt;
  c,d : array [-1..nm,-1..nm] of TLong;
  n,bn,mmax,moves : LongInt;
  res : TLong;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do read(a[i]);
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  write(res[res[0]]);
  for i:=res[0]-1 downto 1 do begin
    if res[i]<1000 then write(0);
    if res[i]<100 then write(0);
    if res[i]<10 then write(0);
    write(res[i]);
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
  fillchar(d,sizeof(d),0);
end;
{}
Procedure CountB;
var
  i,j : LongInt;
  ok : Boolean;
begin
  moves:=0; mmax:=0;
  ok:=false;
  a[n+1]:=2; bn:=0; i:=1;
  while a[i]=1 do inc(i);
  while a[i]<>2 do begin
    inc(bn);
    while a[i]=0 do begin
      inc(b[bn]); inc(i);
      inc(moves);
    end;
    while a[i]=1 do begin
      ok:=true; inc(i);
    end;
  end;
  if (a[1]=0) and (a[n]=0) and ok then begin
    inc(b[1],b[bn]); dec(bn);
  end;
  for i:=1 to bn do
    if b[i]>mmax then mmax:=b[i];
end;
{}
Function Max(q,w : LongInt) : LongInt;
begin
  if q>w then max:=q else max:=w;
end;
{}
Procedure Sum(var r : TLong; q,w : TLong);
var
  i,p : LongInt;
begin
  fillchar(r,sizeof(r),0); p:=0;
  r[0]:=max(q[0],w[0])+1;
  for i:=1 to r[0] do begin
    p:=q[i]+w[i]+p;
    r[i]:=p mod osn;
    p:=p div osn;
  end;
  if r[r[0]]=0 then dec(r[0]);
end;
{}
Procedure Mul(var r : TLong; q,w : TLong);
var
  i,j,t,p : LongInt;
begin
  fillchar(r,sizeof(r),0);
  r[0]:=q[0]+w[0];
  for i:=1 to q[0] do
    for j:=1 to w[0] do begin
      t:=i+j-1; p:=q[i]*w[j];
      repeat
        p:=r[t]+p;
        r[t]:=p mod osn;
        p:=p div osn;
        inc(t);
      until p=0;
    end;

  while (r[r[0]]=0) and (r[0]>0) do dec(r[0]);
end;
{}
Procedure CountC;
var
  i,j : LongInt;
begin
  c[0,0,0]:=1; c[0,0,1]:=1;
  for i:=1 to moves do
    for j:=0 to i do
      Sum(c[i,j],c[i-1,j-1],c[i-1,j]);
end;
{}
Procedure CountD;
var
  i,j,k,t : LongInt;
  bak : TLong;
begin
  for i:=0 to mmax do begin
    d[0,i,0]:=1; d[0,i,1]:=1;
  end;

  for i:=1 to mmax do
    for j:=0 to mmax-i do begin
      fillchar(bak,sizeof(bak),0);
      bak[0]:=1; bak[1]:=j+1;
      Mul(d[i,j],bak,d[i-1,j+1]);

      if i>1 then
        Sum(d[i,j],d[i,j],d[i-1,j]);

      for k:=2 to i-1 do begin
        for t:=1 to i-k-1 do begin
          Mul(bak,d[t,0],d[i-k-t,j]);
          Mul(bak,bak,d[k-1,t+1]);
          Sum(d[i,j],d[i,j],bak);
        end;
        Mul(bak,d[i-k,j],d[k-1,1]);
        Sum(d[i,j],d[i,j],bak);
        Mul(bak,d[i-k,j],d[k-1,i-k+1+j]);
        Sum(d[i,j],d[i,j],bak);
      end;
    end;
end;
{}
Procedure Solve;
var
  i,j : LongInt;
  ok : Boolean;
  bak : TLong;
begin
  CountB;
  CountC;
  CountD;

  fillchar(res,sizeof(res),0);
  res[0]:=1; res[1]:=1;

  if (bn>1) or (b[1]<n) then begin
    for i:=1 to bn do
      Mul(res,res,d[b[i],0]);

    for i:=1 to bn do begin
      Mul(res,res,c[moves,b[i]]);
      dec(moves,b[i]);
    end;
  end else begin
    fillchar(bak,sizeof(bak),0);
    bak[0]:=1; bak[1]:=n;
    Mul(res,bak,bak);
    Mul(res,res,d[n-1,0]);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.