{$I-}{$R-}{$N+}
var
  f,f1 :text;

const name = 'casino';

var
  data,t :array[1..51] of boolean;
  n      :longint;

procedure Rot;
var i,j :longint;
begin
  for j := 1 to n do
    if data[j] then break;
  for i := 1 to n-j do
    t[i] := data[j+i-1];
  for i := n-j+1 to n do
    t[i] := data[j+i-n-1];
  t[n+1]:=true;
end;

var         {--N--,--K--}
  mas :array[0..50,0..50]of longint;

procedure Build;
var i,j,k :longint;
begin
  for i := 0 to n do
    begin
      mas[0,i]:=1;
      mas[1,i]:=i+1;
    end;
  for i := 2 to n do
    for j := 0 to n do
      begin
        mas[i,j]:=(j+1)*mas[i-1,j+1];
        for k := 2 to i do
          mas[i,j]:=mas[i,j]+mas[k-1,j]*mas[i-k,j+k];
      end;
end;

function Sposobov (k:longint):longint;
begin
  Sposobov := mas[k,0];
end;

function fac (k:longint) :longint;
var i,r :longint;
begin
  r := 1;
  for i := 1 to k do
    r:=r*i;
  fac := r;
end;

procedure Sposobi (var l :longint);
var i,j,k,x :longint;
begin
  l := 1;
  j := 0;
  for i := 1 to n do
    if data[i] then j := 1;
  if j=0 then
    begin
      for j := 1 to n do
        l := l*n;
      exit;
    end;
  Rot;
  j := 1; k := 1; x := 0;
  for i := 2 to n+1 do
    if t[i] then
      begin
        if i<>j+1 then l:=l*Sposobov(i-j-1);
        k := k*fac(i-j+1);
        x := x+i-j+1;
        j:=i;
      end;
  l := l*(fac(x) div k);
end;

var
  i,k :longint;

begin
  assign (f,name+'.in');
  assign (f1,name+'.out');
  reset (f);
  rewrite (f1);
    read (f,n);
    Build;
    for i := 1 to n do
      begin
        read (f,k);
        data[i]:=(k=1);
      end;
    Sposobi (k);
    writeln (f1,k);
  close (f);
  close (f1);
end.
