const
  inf = 'casino.in'; ouf = 'casino.out';
  max = 55; mdg = 100;
  md = 1000;
type
  long = array[0..mdg] of longint;
  procedure inclong(var a, b: long);
  var
    i, l: longint;
  begin
    l := a[0];
    if (b[0] > l) then l := b[0];
    for i := 1 to l do
    begin
      inc(a[i], b[i]);
      inc(a[i + 1], a[i] div md);
      a[i] := a[i] mod md;
    end;
    if (a[l + 1] > 0) then inc(l);
    while (l > 1) and (a[l] = 0) do dec(l);
    a[0] := l;
  end;
  procedure mul(var a, b: long);
  var
     c: long;
     i, j, l, la, lb: longint;
     d: longint;
  begin
     fillchar(c, sizeof(c), 0);
     la := a[0]; lb := b[0];
     for i := 1 to la do
       for j := 1 to lb do
       begin
         l := i + j - 1; d := a[i]*b[j]+c[l];
         c[l] := d mod md; c[l + 1] := d div md;
       end;
     while (c[l+1] > md) do
     begin
       inc(l);
       c[l + 1] := c[l] div md;
       c[l] := c[l] mod md;
     end;
     if (c[l + 1] > 0) then inc(l);
     c[0] := l; a := c;
  end;
  procedure muls(var a: long; b: longint);
  var
    d, l, i: longint;
  begin
    l := a[0]; d := 0;
    for i := 1 to l do
    begin
      d := a[i] * b + d;
      a[i] := d mod md;
      d := d div md;
    end;
  end;
  procedure writelong(a: long);
  var
    l, k: byte;
    t: longint;
  begin
    l := a[0]; k := 0;
    if (l = 0) then writeln(output, 0);
    while (a[l] = 0) and (l > 1) do dec(l);
    while (l > 0) do
    begin
      t := md div 10;
      while (t > 0) do
      begin
        if (a[l] div t <> 0) or (k > 0) then
        begin
          write(output, a[l] div t); inc(k);
        end;
        a[l] := a[l] mod t; t := t div 10;
      end;
      dec(l);
    end;
  end;
var
  a: array[1..max] of byte;
  q: array[0..max+1] of byte;
  C: array[0..max,0..max] of long;
  r: array[0..max] of long;
  t, tn: long;
  n, i, j: longint;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n);
  fillchar(c, sizeof(c), 0);
  for i := 0 to n do
  begin
    c[i,0,0] := 1; c[i,0,1] := 1;
  end;
  for i := 1 to n do
     for j := 1 to n do
     begin
       inclong(c[i,j], c[i-1,j]);
       inclong(c[i,j], c[i-1,j-1]);
     end;
  fillchar(r, sizeof(r), 0);
  r[0,0] := 1; r[0,1] := 1;
  for i := 1 to n do
  begin
    fillchar(t, sizeof(t), 0);
    for j := 1 to i do
    begin
      t := r[j-1];
      mul(t,r[i-j]);
      mul(t,c[i-1,j-1]);
      muls(t,i-j+1);
      inclong(r[i],t);
    end;
  end;
  for i := 1 to n do read(input, a[i]);
  fillchar(q, sizeof(q), 0);
  for i := 1 to n do
    if (a[i] = 0) then q[i] := q[i - 1] + 1;
  q[0] := q[n];
  for i := 1 to n do q[i] := 0;
  for i := 1 to n do
    if (a[i] = 0) then q[i] := q[i - 1] + 1;
  q[n + 1] := q[0];
  if (q[n] > n) then
  begin
     fillchar(t, sizeof(t),0);
     t[0] := 1; t[1] := 1;
     tn[0] := 1; tn[1] := n;
     for i := 1 to n do mul(t, tn);
     writelong(t);
  end else
  begin
    fillchar(t, sizeof(t), 0);
    j := 0; t[0] := 1; t[1] := 1;
    for i := 0 to n do
      if (q[i] > 0) and (q[i + 1] = 0) then
      begin
        mul(t, r[q[i]]); inc(j, q[i]);
        mul(t, c[j, q[i]]);
      end;
    writelong(t);
  end;
  close(input); close(output);
end.
