program zzz;

const
  maxn = 50;
  osn = 1000;

type
  TLong = array[0..200] of Longint;

var
  c: array[0..maxn,0..maxn] of TLong;
  i,j,cur,k,n,m,sc: Longint;
  a,b: array[1..50] of Longint;
  ans: TLong;
  f1,f2,fl: Boolean;

function max(a,b: Longint): Longint;
begin
  if a > b then max := a else max := b;
end;

procedure prodsmall(var a: Tlong; num: Longint);
var i,j: Longint;
begin
  for i := 1 to a[0] do begin
    a[i] := a[i] * num;
  end;
  for i := 1 to a[0] do begin
    a[i+1] := a[i+1] + a[i] div osn;
    a[i] := a[i] mod osn;
  end;
  a[0] := a[0] + 1;
  while (a[a[0]] = 0) and (a[0] <> 0) do dec(a[0]);
end;

procedure prodlong(a,b: Tlong; var c: Tlong);
var i,j: Longint;
begin
  fillchar(c,sizeof(c),0);
  for i := 1 to a[0] do begin
    for j := 1 to b[0] do begin
      c[i+j-1] := c[i+j-1] + a[i] * b[j];
    end;
  end;
  for i := 1 to a[0] + b[0] do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] Mod osn;
  end;
  c[0] := a[0] + b[0];
  while (c[c[0]] = 0) and (c[0] <> 0) do dec(c[0]);
end;

procedure PrintLong(a: TLong);
var i,j: Longint;
begin
  write(a[a[0]]);
  for i := a[0] - 1 downto 1 do begin
    j := osn;
    while j <> 1 do begin
      j := j div 10;
      write(a[i] div j);
      a[i] := a[i] mod j;
    end;
  end;
end;

procedure sum(a,b: Tlong; var c: Tlong);
var i,j,k: Longint;
begin
  for i := 1 to max(a[0],b[0]) do begin
    c[i] := a[i] + b[i];
  end;
  for i := 1 to max(a[0],b[0]) do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] mod osn;
  end;
  c[0] := max(a[0],b[0])+1;
  while (c[c[0]] = 0) and (c[0] <> 0) do dec(c[0]);
end;

begin
  assign(input,'casino.in'); reset(input);
  assign(output,'casino.out'); rewrite(Output);
  read(N);
  for i := 1 to n do read(a[i]);
  fl := false;
  k := 0;
  ans[0] := 1;
  ans[1] := 1;
  f1 := false;
  f2 := false;
  for i := 1 to n do begin
    if a[i] = 0 then f1 := true;
    if a[i] = 1 then f2 := true;
  end;
  if not f1 then begin
    writeln(1);
    close(input);
    close(output);
    halt(0);
  end;
  if not f2 then begin
    for i := 1 to n do begin
      prodsmall(ans,n);
    end;
    printlong(ans);
    close(input);
    close(output);
    halt(0);
  end;
  for i := 1 to n do begin
    if a[i] = 0 then begin
      if fl then inc(k) else begin
        k := 1;
        fl := true;
      end;
    end else begin
      if fl then begin
        fl := false;
        inc(sc);
        b[sc] := k;
      end;
    end;
  end;
  if fl then begin
    inc(sc);
    b[sc] := k;
  end;
  if (a[n] = 0) and (a[1] = 0) then begin
    b[1] := b[1] + b[sc];
    dec(sc);
  end;
  cur := 0;
  for i := 1 to sc do begin
    cur := cur + b[i];
  end;
  for i := 1 to sc do begin
    for j := 1 to b[i]-1 do begin
      prodsmall(ans,b[i]+1);
    end;
  end;
  for i := 0 to n do begin
    c[0,i,0] := 1;
    c[0,i,1] := 1;
  end;
  for i := 1 to n do begin
    for j := i to n do begin
      sum(c[i-1,j-1],c[i,j-1],c[i,j]);
    end;
  end;
  for i := 1 to sc do begin
    prodlong(ans,c[b[i],cur],ans);
    cur := cur - b[i];
  end;
  printlong(ans);
  close(input);
  close(output);
end.
