{$I+,Q-,R-,S-}
Const
  InputFile  = 'casino.in';
  OutputFile = 'casino.out';
  MaxN       = 200;
  Osn        = 10000;
Type
  TLong      = Array[-10..200]Of Longint;

Var
  A             : array [0..MaxN] Of Integer;
  B             : Array [0..MaxN] Of Integer;
  C             : Array [0..MaxN] Of Integer;
  PP            : Array [-1..MaxN, -1..MaxN]Of Longint;
  N, LL         : Longint;
  Res, X, Y     : TLong;
  CC            : Array[1..MaxN]Of TLong;

  {Long Arifmetik}

  Procedure WriteLong(A : Tlong);
  Var
    I : Longint;
  Begin
    If A[0] = 0 Then Begin Write(0);Exit;End;
    Write(A[A[0]]);
    For I := A[0] - 1 DownTo 1 Do
      Write(A[I] Div 1000 Mod 10,
            A[I] Div 100  Mod 10,
            A[I] Div 10   Mod 10,
            A[I]          Mod 10);
  End;


  Procedure RaznLL(A, B : TLong ; Var C : TLong);
  Var
    I, J : Longint;
  Begin
    FillChar(C, SizeOf(C), 0);
    For I := 1 To A[0] Do
      Begin
        J := A[I] - B[I];
        If J < 0 Then Begin C[I] := J + Osn;Dec(A[I + 1]);End
        Else C[I] := J;
      End;
    C[0] := A[0];
    While C[C[0]] = 0 Do Dec(C[0]);
  End;

  Procedure MuLL(A, B : Tlong; Var C : Tlong);
  Var I, J : Longint;
  Begin
    FillChar(C, SizeOf(C), 0);
    For I := 1 To A[0] Do
      For J :=1 to B[0] DO
        Begin
          C[I+J-1] := (C[I+J-1] + A[I] * B[J]) Mod Osn;
          C[I + J] := (C[I + J] + A[I] * B[J]) Div Osn;
        End;
    C[0] := A[0] + B[0] - 1;
    While C[C[0] + 1] <> 0 do Inc(C[0]);
  End;

  Procedure SumLL(A, B : TLong; Var C : TLong);
  Var I, J  : Longint;
  Begin
    FillChar(C, SizeOf(C), 0);
    If A[0] > B[0] Then J := A[0] Else J := B[0];
    For I := 1 To J Do
      Begin
        C[ I ] := (C[ I ] + A[I] + B[I]) Mod Osn;
        C[I+1] := (C[I+1] + A[I] + B[I]) Div Osn;
      End;
    C[0] := J;
    While C[C[0] + 1] <> 0 Do Inc(C[0]);
  End;

  {End}

  Function Min (A, B : Longint) : Longint;
  Begin
    If A < B Then Min := A Else Min := B;
  End;

  Function Slag(P, K : Longint) : Longint;
  Var
    I : Longint;
    J : Longint;
  Begin
    If (PP[P, K] <> -1)Then Begin Slag := PP[P, K];Exit;End;
    If (K <= 1)or(P = 0) Then J := 1
    Else Begin
      J := 0;
      For I := 0 to P Do J := J + Slag (P - I, K - 1);
    End;
    Slag := J;
    PP[P, K] := J;
  End;

  Function Sum(P, K : Longint): longint;
  Var
    I, J : Longint;
  Begin
    If K = 0 Then Begin Sum := 1;Exit;End;
    J := 0;
    If K = P
      Then For i := 1 to K Do J := J + Sum (P-1, K - i)
      Else For i := 0 to K Do J := J + Sum (P-1, K - i);
    Sum := J;
  End;

  Procedure Done;Forward;

  Procedure Solve;
  Var
    I, J, K, L : Longint;
    F          : Boolean;
  Begin
    L := 0; J := 0;
    For I := 1 to MaxN Do Begin
      If (A[I] = 0) Then Inc(J);
      If (A[I] <> 0) And (A[I - 1] = 0) Then Begin Inc(L);B[L] := J;J := 0;End;
    End;
    LL := L; C[1] := B[1];
    For I := 2 to LL Do C[I] := C[i-1] + B[I];

    Res := CC[B[1]];
    For I := 2 to LL Do
      Begin
        L := Slag(C[I-1], B[I] + 1);
        X[0] := 1;
        x[1] := L Mod Osn;
        X[2] := L Div Osn;
        MuLL(Res, CC[B[I]], Res);
        MuLL(Res, x       , Res);

      End;
  End;

  Procedure Init;
  Var
    I, J : Longint;
  Begin
    FillChar(A, SizeoF(A), 1);
    FillChar(Res, SizeOf(Res), 0);
    FillChar(X, SizeOf(X), 0);
    FillChar(CC, SizeOf(CC), 0);

CC[ 1][ 0]:=    1;CC[ 1][ 1]:=    1;
CC[ 2][ 0]:=    1;CC[ 2][ 1]:=    3;
CC[ 3][ 0]:=    1;CC[ 3][ 1]:=   16;
CC[ 4][ 0]:=    1;CC[ 4][ 1]:=  121;
CC[ 5][ 0]:=    1;CC[ 5][ 1]:= 1181;
CC[ 6][ 0]:=    2;CC[ 6][ 1]:= 4107;CC[ 6][ 2]:=    1;
CC[ 7][ 0]:=    2;CC[ 7][ 1]:= 9221;CC[ 7][ 2]:=   19;
CC[ 8][ 0]:=    2;CC[ 8][ 1]:= 6225;CC[ 8][ 2]:=  324;
CC[ 9][ 0]:=    2;CC[ 9][ 1]:= 7706;CC[ 9][ 2]:= 5993;
CC[10][ 0]:=    3;CC[10][ 1]:= 7371;CC[10][ 2]:= 3655;CC[10][ 3]:=   12;
CC[11][ 0]:=    3;CC[11][ 1]:= 8231;CC[11][ 2]:= 8836;CC[11][ 3]:=  280;
CC[12][ 0]:=    3;CC[12][ 1]:=  473;CC[12][ 2]:= 7073;CC[12][ 3]:= 7035;
CC[13][ 0]:=    4;CC[13][ 1]:=  653;CC[13][ 2]:= 4996;CC[13][ 3]:=  824;CC[13][ 4]:=   19;
CC[14][ 0]:=    4;CC[14][ 1]:= 7339;CC[14][ 2]:= 3675;CC[14][ 3]:= 8120;CC[14][ 4]:=  558;
CC[15][ 0]:=    5;CC[15][ 1]:= 7956;CC[15][ 2]:= 8732;CC[15][ 3]:= 9218;CC[15][ 4]:= 7571;CC[15][ 5]:=    1;
CC[16][ 0]:=    5;CC[16][ 1]:=  289;CC[16][ 2]:= 8376;CC[16][ 3]:= 5559;CC[16][ 4]:=  514;CC[16][ 5]:=   59;
CC[17][ 0]:=    5;CC[17][ 1]:= 1821;CC[17][ 2]:= 4111;CC[17][ 3]:= 3675;CC[17][ 4]:=   40;CC[17][ 5]:= 2112;
CC[18][ 0]:=    6;CC[18][ 1]:= 8267;CC[18][ 2]:= 3395;CC[18][ 3]:=  219;CC[18][ 4]:= 6330;CC[18][ 5]:=   97;CC[18][ 6]:=    8;
CC[19][ 0]:=    6;CC[19][ 1]:= 4745;CC[19][ 2]:= 8788;CC[19][ 3]:= 3805;CC[19][ 4]:= 9356;CC[19][ 5]:=  633;CC[19][ 6]:=  321;
CC[20][ 0]:=    7;CC[20][ 1]:= 5321;CC[20][ 2]:= 6795;CC[20][ 3]:= 7039;CC[20][ 4]:= 1167;CC[20][ 5]:= 5914;CC[20][ 6]:= 3562;CC[20][ 7]:=    1;
CC[20][ 0]:=    7;CC[20][ 1]:= 5321;CC[20][ 2]:= 6795;CC[20][ 3]:= 7039;CC[20][ 4]:= 1167;CC[20][ 5]:= 5914;CC[20][ 6]:= 3562;CC[20][ 7]:=    1;
CC[21][ 0]:=    7;CC[21][ 1]:= 3790;CC[21][ 2]:= 5258;CC[21][ 3]:=  742;CC[21][ 4]:= 9133;CC[21][ 5]:= 4039;CC[21][ 6]:= 2194;CC[21][ 7]:=   60;
CC[22][ 0]:=    7;CC[22][ 1]:= 4475;CC[22][ 2]:= 7334;CC[22][ 3]:= 8445;CC[22][ 4]:= 5715;CC[22][ 5]:= 7322;CC[22][ 6]:= 7731;CC[22][ 7]:= 2803;
CC[23][ 0]:=    8;CC[23][ 1]:= 4623;CC[23][ 2]:=   74;CC[23][ 3]:= 9155;CC[23][ 4]:= 8072;CC[23][ 5]:= 3427;CC[23][ 6]:= 8799;CC[23][ 7]:= 6591;CC[23][ 8]:=   13;
CC[24][ 0]:=    8;CC[24][ 1]:= 9457;CC[24][ 2]:= 3652;CC[24][ 3]:= 7480;CC[24][ 4]:=  265;CC[24][ 5]:= 1060;CC[24][ 6]:= 1786;CC[24][ 7]:= 9090;CC[24][ 8]:=  694;
CC[25][ 0]:=    9;CC[25][ 1]:= 5801;CC[25][ 2]:= 3629;CC[25][ 3]:= 1153;CC[25][ 4]:= 6386;CC[25][ 5]:= 5373;CC[25][ 6]:= 1955;CC[25][ 7]:= 6369;CC[25][ 8]:= 6852;CC[25][ 9]:=    3;
CC[26][ 0]:=    9;CC[26][ 1]:= 8763;CC[26][ 2]:= 2152;CC[26][ 3]:= 2287;CC[26][ 4]:= 1199;CC[26][ 5]:= 8841;CC[26][ 6]:= 8575;CC[26][ 7]:= 9473;CC[26][ 8]:= 3882;CC[26][ 9]:=  203;
CC[27][ 0]:=   10;CC[27][ 1]:= 5512;CC[27][ 2]:= 6657;CC[27][ 3]:= 9785;CC[27][ 4]:= 5059;CC[27][ 5]:=  584;CC[27][ 6]:= 4610;CC[27][ 7]:= 8617;CC[27][ 8]:= 6581;CC[27][ 9]:= 1663;CC[27][10]:=    1;
CC[28][ 0]:=   10;CC[28][ 1]:= 6633;CC[28][ 2]:= 6186;CC[28][ 3]:= 1646;CC[28][ 4]:= 4587;CC[28][ 5]:= 6351;CC[28][ 6]:= 4723;CC[28][ 7]:= 7568;CC[28][ 8]:= 2490;CC[28][ 9]:= 4031;CC[28][10]:=   69;
CC[29][ 0]:=   10;CC[29][ 1]:= 4445;CC[29][ 2]:= 2954;CC[29][ 3]:= 7067;CC[29][ 4]:= 5284;CC[29][ 5]:= 8842;CC[29][ 6]:=  304;CC[29][ 7]:= 3173;CC[29][ 8]:= 6078;CC[29][ 9]:=   77;CC[29][10]:= 2638;
CC[30][ 0]:=   11;CC[30][ 1]:= 8091;CC[30][ 2]:= 5932;CC[30][ 3]:= 2734;CC[30][ 4]:= 3243;CC[30][ 5]:= 5853;CC[30][ 6]:= 1985;CC[30][ 7]:= 4950;CC[30][ 8]:= 2663;CC[30][ 9]:= 1417;CC[30][10]:= 3102;CC[30][11]:=   27;
CC[31][ 0]:=   11;CC[31][ 1]:= 4893;CC[31][ 2]:= 1642;CC[31][ 3]:= 6318;CC[31][ 4]:= 5339;CC[31][ 5]:=  398;CC[31][ 6]:= 2479;CC[31][ 7]:= 5833;CC[31][ 8]:= 8651;CC[31][ 9]:= 9336;CC[31][10]:= 7614;CC[31][11]:= 1801;
CC[32][ 0]:=   12;CC[32][ 1]:= 6865;CC[32][ 2]:= 7943;CC[32][ 3]:=  253;CC[32][ 4]:=  153;CC[32][ 5]:= 3055;CC[32][ 6]:= 3581;CC[32][ 7]:= 1860;CC[32][ 8]:= 9469;CC[32][ 9]:= 8402;CC[32][10]:= 7295;CC[32][11]:= 2754;CC[32][12]:=   12;
CC[33][ 0]:=   12;CC[33][ 1]:= 2178;CC[33][ 2]:= 5073;CC[33][ 3]:= 2789;CC[33][ 4]:= 9631;CC[33][ 5]:= 7095;CC[33][ 6]:= 9659;CC[33][ 7]:= 8471;CC[33][ 8]:= 4489;CC[33][ 9]:= 6946;CC[33][10]:=  640;CC[33][11]:= 8036;CC[33][12]:=  862;
CC[34][ 0]:=   13;CC[34][ 1]:= 1163;CC[34][ 2]:= 2759;CC[34][ 3]:= 1852;CC[34][ 4]:= 2834;CC[34][ 5]:= 9147;CC[34][ 6]:= 6979;CC[34][ 7]:= 2072;CC[34][ 8]:= 3090;CC[34][ 9]:= 2470;CC[34][10]:= 6162;CC[34][11]:= 1587;CC[34][12]:= 2504;CC[34][13]:=    6;
CC[35][ 0]:=   13;CC[35][ 1]:= 1831;CC[35][ 2]:= 1359;CC[35][ 3]:= 8910;CC[35][ 4]:= 8751;CC[35][ 5]:= 7448;CC[35][ 6]:= 8934;CC[35][ 7]:= 9066;CC[35][ 8]:= 4831;CC[35][ 9]:=    6;CC[35][10]:= 2893;CC[35][11]:= 4529;CC[35][12]:= 2766;CC[35][13]:=  466;
CC[36][ 0]:=   14;CC[36][ 1]:= 7225;CC[36][ 2]:= 7550;CC[36][ 3]:= 9851;CC[36][ 4]:= 4744;CC[36][ 5]:= 8340;CC[36][ 6]:= 4185;CC[36][ 7]:= 1099;CC[36][ 8]:= 5785;CC[36][ 9]:= 1502;CC[36][10]:= 6518;CC[36][11]:= 5259;CC[36][12]:= 2630;CC[36][13]:= 5789;CC[
36][14]:=    3;
CC[37][ 0]:=   14;CC[37][ 1]:= 7237;CC[37][ 2]:= 9740;CC[37][ 3]:= 6334;CC[37][ 4]:= 3712;CC[37][ 5]:= 4242;CC[37][ 6]:=  172;CC[37][ 7]:= 3389;CC[37][ 8]:= 6235;CC[37][ 9]:= 7462;CC[37][10]:= 4233;CC[37][11]:= 6047;CC[37][12]:= 6293;CC[37][13]:= 4183;CC[
37][14]:=  282;
CC[38][ 0]:=   15;CC[38][ 1]:= 5131;CC[38][ 2]:= 5485;CC[38][ 3]:= 5616;CC[38][ 4]:=  454;CC[38][ 5]:=  474;CC[38][ 6]:= 6427;CC[38][ 7]:= 6522;CC[38][ 8]:= 7046;CC[38][ 9]:= 1273;CC[38][10]:= 5246;CC[38][11]:=  474;CC[38][12]:= 8979;CC[38][13]:= 9380;CC[
38][14]:= 2894;CC[38][15]:=    2;
CC[39][ 0]:=   15;CC[39][ 1]:= 6716;CC[39][ 2]:= 5406;CC[39][ 3]:= 5516;CC[39][ 4]:= 8833;CC[39][ 5]:= 9160;CC[39][ 6]:= 5721;CC[39][ 7]:= 5783;CC[39][ 8]:= 6869;CC[39][ 9]:= 4388;CC[39][10]:= 9521;CC[39][11]:= 4168;CC[39][12]:= 6999;CC[39][13]:= 7963;CC[
39][14]:= 5393;CC[39][15]:=  190;
CC[40][ 0]:=   16;CC[40][ 1]:= 3681;CC[40][ 2]:= 7335;CC[40][ 3]:= 2100;CC[40][ 4]:= 5269;CC[40][ 5]:= 3169;CC[40][ 6]:= 3099;CC[40][ 7]:= 1520;CC[40][ 8]:= 4001;CC[40][ 9]:= 9164;CC[40][10]:= 6336;CC[40][11]:= 7935;CC[40][12]:= 5219;CC[40][13]:= 4422;CC[
40][14]:= 1018;CC[40][15]:= 6268;CC[40][16]:=    1;
CC[40][ 0]:=   16;CC[40][ 1]:= 3681;CC[40][ 2]:= 7335;CC[40][ 3]:= 2100;CC[40][ 4]:= 5269;CC[40][ 5]:= 3169;CC[40][ 6]:= 3099;CC[40][ 7]:= 1520;CC[40][ 8]:= 4001;CC[40][ 9]:= 9164;CC[40][10]:= 6336;CC[40][11]:= 7935;CC[40][12]:= 5219;CC[40][13]:= 4422;CC[
40][14]:= 1018;CC[40][15]:= 6268;CC[40][16]:=    1;
CC[41][ 0]:=   16;CC[41][ 1]:= 1869;CC[41][ 2]:= 8478;CC[41][ 3]:= 6035;CC[41][ 4]:= 6276;CC[41][ 5]:= 2058;CC[41][ 6]:= 2793;CC[41][ 7]:= 9981;CC[41][ 8]:= 3334;CC[41][ 9]:= 7747;CC[41][10]:= 8928;CC[41][11]:= 1397;CC[41][12]:= 5020;CC[41][13]:=  474;CC[
41][14]:= 2200;CC[41][15]:= 4028;CC[41][16]:=  142;
CC[42][ 0]:=   17;CC[42][ 1]:=  107;CC[42][ 2]:=  477;CC[42][ 3]:= 8912;CC[42][ 4]:=  457;CC[42][ 5]:= 1472;CC[42][ 6]:= 7323;CC[42][ 7]:=  875;CC[42][ 8]:= 6288;CC[42][ 9]:= 7668;CC[42][10]:= 6244;CC[42][11]:= 1541;CC[42][12]:= 5179;CC[42][13]:=   97;CC[
42][14]:= 1139;CC[42][15]:= 2120;CC[42][16]:= 2772;CC[42][17]:=    1;
CC[43][ 0]:=   17;CC[43][ 1]:= 3169;CC[43][ 2]:=  987;CC[43][ 3]:= 8916;CC[43][ 4]:= 4449;CC[43][ 5]:= 7291;CC[43][ 6]:= 2605;CC[43][ 7]:= 9050;CC[43][ 8]:= 7353;CC[43][ 9]:= 6536;CC[43][10]:= 6717;CC[43][11]:= 7030;CC[43][12]:= 1949;CC[43][13]:=   41;CC[
43][14]:= 1930;CC[43][15]:= 6359;CC[43][16]:= 3081;CC[43][17]:=  117;
CC[44][ 0]:=   18;CC[44][ 1]:= 9577;CC[44][ 2]:= 1548;CC[44][ 3]:=  655;CC[44][ 4]:= 1164;CC[44][ 5]:= 5606;CC[44][ 6]:= 7588;CC[44][ 7]:= 6602;CC[44][ 8]:= 6335;CC[44][ 9]:= 2576;CC[44][10]:= 3822;CC[44][11]:= 1501;CC[44][12]:= 2262;CC[44][13]:= 5731;CC[
44][14]:= 7496;CC[44][15]:= 6620;CC[44][16]:= 2039;CC[44][17]:= 1027;CC[44][18]:=    1;
CC[45][ 0]:=   18;CC[45][ 1]:= 3686;CC[45][ 2]:= 1023;CC[45][ 3]:= 6059;CC[45][ 4]:= 5560;CC[45][ 5]:= 4120;CC[45][ 6]:= 6664;CC[45][ 7]:= 9882;CC[45][ 8]:= 4456;CC[45][ 9]:= 5694;CC[45][10]:= 4082;CC[45][11]:= 1361;CC[45][12]:= 8054;CC[45][13]:= 6576;CC[
45][14]:= 7033;CC[45][15]:= 6159;CC[45][16]:= 3485;CC[45][17]:=  349;CC[45][18]:=  106;
CC[46][ 0]:=   19;CC[46][ 1]:= 7163;CC[46][ 2]:= 8438;CC[46][ 3]:= 7916;CC[46][ 4]:= 5696;CC[46][ 5]:= 2761;CC[46][ 6]:= 6183;CC[46][ 7]:= 1224;CC[46][ 8]:= 3678;CC[46][ 9]:= 1158;CC[46][10]:= 7197;CC[46][11]:= 9567;CC[46][12]:= 9589;CC[46][13]:= 6530;CC[
46][14]:= 6230;CC[46][15]:= 3831;CC[46][16]:= 4112;CC[46][17]:= 6247;CC[46][18]:=  424;CC[46][19]:=    1;
CC[47][ 0]:=   19;CC[47][ 1]:= 3007;CC[47][ 2]:= 2978;CC[47][ 3]:= 8836;CC[47][ 4]:= 9632;CC[47][ 5]:= 6879;CC[47][ 6]:= 2319;CC[47][ 7]:= 1956;CC[47][ 8]:= 2211;CC[47][ 9]:= 4820;CC[47][10]:= 7957;CC[47][11]:= 8628;CC[47][12]:= 3993;CC[47][13]:= 6647;CC[
47][14]:= 1704;CC[47][15]:= 8579;CC[47][16]:=  789;CC[47][17]:= 4119;CC[47][18]:= 7347;CC[47][19]:=  104;
CC[48][ 0]:=   20;CC[48][ 1]:= 8497;CC[48][ 2]:= 9723;CC[48][ 3]:= 3467;CC[48][ 4]:= 5080;CC[48][ 5]:= 2674;CC[48][ 6]:= 6269;CC[48][ 7]:= 3438;CC[48][ 8]:= 8736;CC[48][ 9]:= 6058;CC[48][10]:= 2319;CC[48][11]:= 1999;CC[48][12]:= 5911;CC[48][13]:= 7879;CC[
48][14]:= 3832;CC[48][15]:= 3911;CC[48][16]:= 2466;CC[48][17]:= 7737;CC[48][18]:= 3018;CC[48][19]:=  748;CC[48][20]:=    1;
CC[49][ 0]:=   20;CC[49][ 1]:= 1473;CC[49][ 2]:= 1819;CC[49][ 3]:= 8603;CC[49][ 4]:= 7572;CC[49][ 5]:= 9503;CC[49][ 6]:= 3160;CC[49][ 7]:= 9587;CC[49][ 8]:= 6533;CC[49][ 9]:= 1529;CC[49][10]:= 7526;CC[49][11]:= 9243;CC[49][12]:= 1211;CC[49][13]:= 8044;CC[
49][14]:= 1580;CC[49][15]:= 7853;CC[49][16]:=  294;CC[49][17]:= 7742;CC[49][18]:= 9963;CC[49][19]:= 6200;CC[49][20]:=  112;
CC[50][ 0]:=   21;CC[50][ 1]:= 1451;CC[50][ 2]:= 3565;CC[50][ 3]:= 5644;CC[50][ 4]:= 1918;CC[50][ 5]:= 7435;CC[50][ 6]:= 5970;CC[50][ 7]:= 6034;CC[50][ 8]:= 9052;CC[50][ 9]:= 2390;CC[50][10]:= 2296;CC[50][11]:=  867;CC[50][12]:= 9219;CC[50][13]:= 9124;CC[
50][14]:= 6425;CC[50][15]:= 9237;CC[50][16]:= 3984;CC[50][17]:= 5328;CC[50][18]:= 2183;CC[50][19]:=   73;CC[50][20]:= 2043;CC[50][21]:=    1;
CC[51][ 0]:=   21;CC[51][ 1]:= 3616;CC[51][ 2]:= 5920;CC[51][ 3]:= 9206;CC[51][ 4]:= 3453;CC[51][ 5]:= 8270;CC[51][ 6]:= 2696;CC[51][ 7]:= 4930;CC[51][ 8]:= 1588;CC[51][ 9]:= 7946;CC[51][10]:= 2069;CC[51][11]:= 5992;CC[51][12]:= 5963;CC[51][13]:= 6502;CC[
51][14]:= 6161;CC[51][15]:= 3634;CC[51][16]:= 3428;CC[51][17]:= 7284;CC[51][18]:= 3510;CC[51][19]:= 1063;CC[51][20]:= 3773;CC[51][21]:=  131;
CC[52][ 0]:=   22;CC[52][ 1]:= 5769;CC[52][ 2]:= 4083;CC[52][ 3]:= 3354;CC[52][ 4]:= 8367;CC[52][ 5]:= 5622;CC[52][ 6]:= 1568;CC[52][ 7]:=  460;CC[52][ 8]:= 7649;CC[52][ 9]:= 4047;CC[52][10]:= 7890;CC[52][11]:= 8589;CC[52][12]:= 5856;CC[52][13]:= 2205;CC[
52][14]:= 4398;CC[52][15]:= 2798;CC[52][16]:= 3334;CC[52][17]:= 5028;CC[52][18]:= 3912;CC[52][19]:= 3921;CC[52][20]:= 1225;CC[52][21]:= 4615;CC[52][22]:=    1;


    For I := -1 to MaxN Do For J := -1 To MaxN Do PP[I,J] := -1;
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);
    Read(N);
    J := 0;
    For I := 1 to N DO Begin Read(A[I]);Inc(J, A[I]);End;
    If J = 0 Then
      Begin
        Res[0] := 1;
        Res[1] := 1;
        X[0] := 1;
        X[1] := N;
        For J := 1 to N Do
          MuLL(Res, X, Res);
        Done;
      End;
    I := 1;
    While A[I] = 0 Do Begin A[I] := 1; A[I + N] := 0; Inc(I); End;
    Close(Input);
  End;

  Procedure Done;
  Var
    I, J : Longint;
  Begin
    WriteLong(Res);
    Close(Output);
    Halt(0);
  End;

Begin
  Init;
    Solve;
  Done;
End.
