{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const Inp='casino.in';
        Out='casino.out';
        MaxLen=100;
        Osn=10000;
        Len=4;
        MaxN=50;
  Type Tip=LongInt;
       TLong=Array [0..MaxLen] Of Tip;
       _Tip=Array [1..MaxN] Of Tip;
  Var C : Array [0..MaxN,0..MaxN] Of TLong; {First - N,Second - K}
      Help : Array [0..MaxN] OF TLong;
      Answer : TLong;
      N,Free : Tip;
      Round : _Tip;

Procedure Mul(Const A,B : TLong; VAr C : TLong);
  Var I,J,Help2 : Tip;
      Help : TLong;
Begin
  FillChar(Help,SizeOf(Help),0);
  Help[0] :=A[0]+B[0]-1;
  For I :=1 To A[0] Do
    For J :=1 To B[0] DO
      Begin
        Help2 :=Help[I+J-1]+A[I]*B[J];
        Help[I+J-1] :=Help2 Mod Osn;
        Inc(Help[I+J],Help2 Div Osn);
      End;
  If Help[Help[0]+1]>0 Then
    Inc(Help[0]);
  C :=Help;
End;

Procedure WriteLong(Const A : TLong);
  Var I : Tip;
      LineToWrite : String;
Begin
  Write(A[A[0]]);
  For I :=A[0]-1 DownTo 1 Do
    Begin
      Str(A[I],LineToWrite);
      While Length(LineToWrite)<Len Do
        LineToWRite :='0'+LineToWrite;
      Write(LineToWrite);
    End;
  WriteLn;
End;

Function Max(Const A,B : Tip) : Tip;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure Sum(Const A,B : TLong; Var C : TLong);
  Var I,Len,Ost : Tip;
      Help : TLong;
Begin
  FIllChar(Help,SizeOf(Help),0);
  Len :=max(A[0],B[0]);
  Help[0] :=Len;
  Ost :=0;
  For I :=1 To Len Do
    Begin
      Ost :=Help[I]+A[I]+B[I];
      Help[I] :=Ost Mod Osn;
      Help[I+1] :=Ost Div Osn;
    End;
  If Help[Help[0]+1]>0 Then Inc(Help[0]);
  C :=Help;
End;


Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
   Var I : Tip;
Begin
  FIllChar(Help,SizeOf(Help),0);
  FillChar(C,SizeOf(C),0);
  FillChar(Answer,SizeOf(Answer),0);
  Read(N);
  Free :=0;
  For I :=1 To N Do
    Begin
      Read(Round[I]);
      Inc(Free,1-Round[I]);
    End;
End;

Procedure GetC;
  Var I,J : Tip;
Begin
  For I :=0 To N Do
    Begin
      C[0,I][1] :=1;
      C[0,I][0] :=1;
      C[I,0][1] :=1;
      C[I,0][0] :=1;
      C[I,1][1] :=I;
      C[I,1][0] :=1;
    End;
  For J :=1 To N Do
    For I :=2 To N Do
      If I>=J Then
        Sum(C[I-1,J-1],C[I-1,J],C[I,J])
End;

Procedure GetHelp;
  Var I,J : Tip;
      HelpToHelp : TLong;
Begin
  FillChar(HelpToHelp,SizeOf(HelpToHelp),0);
  Help[0][0] :=1;
  Help[0][1] :=1;
  Help[1][0] :=1;
  Help[1][1] :=1;
  For I :=2 To N Do
    Begin
      HelpToHelp[0] :=1;
      HelpToHelp[1] :=I+1;
      Help[I][0] :=1;
      Help[I][1] :=1;
      For J :=1 To I-1 Do
        Mul(Help[I],HelpToHelp,Help[I]);
    End;
End;

procedure GetRound;
  Var I,Pol : Tip;
      Help : _Tip;
Begin
  For I :=1 To N Do
    If Round[I]=1 Then
      Begin
        Pol :=I;
        Break;
      End;
  FillChar(Help,SizeOf(Help),0);
  For I :=Pol To N Do
    Help[I-Pol+1] :=Round[I];
  For I :=1 To Pol-1 Do
    Help[I+N-Pol+1] :=Round[I];
  Round :=Help;
End;

Procedure GetNext(Var Pol : Tip);
Begin
  While (Pol<=N) And (Round[Pol]=0) Do Inc(Pol);
  While (Pol<=N) And (Round[Pol]=1) Do Inc(Pol);
End;

Function COuntLen(Const Pol : Tip) : Tip;
  Var Len : Tip;
begin
  Len :=0;
  While (Pol+Len<=N) And (Round[Pol+Len]=0) Do Inc(Len);
  CountLen :=Len;
End;

Procedure Solve;
  Var Pol,COuntNow,CountLast,I : Tip;
      NeedHelp : TLong;
Begin
  FIllChar(NeedHelp,SizeOf(NeedHelp),0);
  Answer[0] :=1;
  Answer[1] :=1;
  If Free=N Then
    Begin
      NeedHelp[0] :=1;
      NeedHelp[1] :=N;
      For I :=1 To N Do
        Mul(Answer,NeedHelp,Answer);
      WriteLong(Answer);
      Exit;
    End;
  GetC;
  GetHelp;
  GetRound;
  Pol :=1;
  GetNext(Pol);
  CountLast :=0;
  While Pol<=N Do
    Begin
      COuntNow :=CountLen(Pol);
      Inc(CountLast,CountNow);
      Mul(C[CountLast,CountNow],Help[CountNow],NeedHelp);
      Mul(NeedHelp,Answer,Answer);
      GetNext(Pol);
    End;
  WriteLong(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
