{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const Inp='invar.in';
        Out='invar.out';
        MaxM=100;
  Type Tip=LongInt;
       _Tip=Array [0..MaxM] Of Tip;
       _Set=Set Of 0..MaxM;
  Var M,Answer : Tip;
      CountP,CountQ,P,Q : _Tip;
      LenP,LenQ : Tip;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Tip;
Begin
  Read(M,LenP);
  For I :=LenP DownTo 0 Do
    Read(P[I]);
  Read(LenQ);
  For I :=LenQ DownTo 0 Do
    Read(Q[I]);
End;

Procedure GetCount(Const A : _Tip; Const Len,M : Tip; Var B : _Tip);
  Var I,J : Tip;
      Help : _Tip;
Begin
  For I :=0 To M-1 Do
    Begin
      B[I] :=A[0] Mod M;
      Help[I] :=I;
    End;
  For I :=1 To Len Do
    For J :=1 To M-1 Do
      Begin
        B[J] :=(B[J]+A[I]*Help[J]) Mod M;
        Help[J] :=(Help[J]*J) Mod M;
      End;
End;

Procedure Get(Const Pol : Tip; Var HelpGet : _Set);
  Var Help : _Set;
      I,J : Tip;
Begin
  Help :=[Pol];
  For I :=1 To M Do
    For J :=0 To M-1 Do
      If J In Help Then
        Begin
          Help :=Help+[CountP[J]];
          Help :=Help+[CountQ[J]];
        End;
  HelpGet :=Help;
End;

Procedure Solve;
  Var I,J,CountMn : Tip;
      Mn : Array [1..MaxM] Of _Set;
      Now : _Set;
      Ok : Boolean;

Procedure GetAnswer(A : Integer);
  VAr I : Tip;
      Help : _Set;
Begin
  Inc(Answer);
  For I :=A+1 To CountMn Do
    If (Now-Mn[I]<>[]) And (Mn[I]-Now<>[]) Then
      Begin
        Help :=Now;
        Now :=Now+Mn[I];
        GetAnswer(I);
        Now :=Help;
      End;
End;

Begin
  Answer :=0;
  GetCount(P,LenP,M,CountP);
  GetCount(Q,LenQ,M,CountQ);
  CountMn :=0;
  For I :=0 To M-1 Do
    Begin
      Get(I,Now);
      Ok :=False;
      For J :=1 To CountMn Do
        If Mn[J]=Now Then
          Ok :=True;
      If Not Ok Then
        Begin
          Inc(CountMn);
          Mn[CountMn] :=Now;
        End;
    End;
  For I :=1 To CountMn Do
    Begin
      Now :=Mn[I];
      GetAnswer(I);
    End;
  WriteLn(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
