{$N+}
program TaskA;
const infile = 'maps.in';
      outfile = 'maps.out';
      dt = 1e-5;
type t1=record
  x, y:extended;
end;
     t2=array[0..4]of t1;
var p1, p2, p3:t2;
    s1, s2, s3, x, y:extended;

function inside(p1, p2:t2):boolean;
begin
  if (abs(abs(p1[1].x-p2[1].x)+abs(p1[1].x-p2[3].x)-abs(p2[1].x-p2[3].x))<dt)and
     (abs(abs(p1[2].x-p2[1].x)+abs(p1[2].x-p2[3].x)-abs(p2[1].x-p2[3].x))<dt)and
     (abs(abs(p1[3].x-p2[1].x)+abs(p1[3].x-p2[3].x)-abs(p2[1].x-p2[3].x))<dt)and
     (abs(abs(p1[4].x-p2[1].x)+abs(p1[4].x-p2[3].x)-abs(p2[1].x-p2[3].x))<dt)and

     (abs(abs(p1[1].y-p2[1].y)+abs(p1[1].y-p2[3].y)-abs(p2[1].y-p2[3].y))<dt)and
     (abs(abs(p1[2].y-p2[1].y)+abs(p1[2].y-p2[3].y)-abs(p2[1].y-p2[3].y))<dt)and
     (abs(abs(p1[3].y-p2[1].y)+abs(p1[3].y-p2[3].y)-abs(p2[1].y-p2[3].y))<dt)and
     (abs(abs(p1[4].y-p2[1].y)+abs(p1[4].y-p2[3].y)-abs(p2[1].y-p2[3].y))<dt)
     then inside:=true else inside:=false;
end;

procedure inp;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(s1);
  read(p1[3].x, p1[3].y); p1[1].x:=0; p1[1].y:=0; p1[2].x:=p1[3].x; p1[2].y:=0; p1[4].x:=0; p1[4].y:=p1[3].y;
  read(s2);
  read(s3);
  read(p3[1].x, p3[1].y, p3[2].x, p3[2].y, p3[3].x, p3[3].y, p3[4].x, p3[4].y);
end;

procedure no;
begin
  write('impossible');
  close(input);
  close(output);
  halt;
end;

function check(v1, v2, v3, v4:t1):boolean;
begin
  if (abs(v1.y-v2.y)<=dt) then
  begin
    p2[1].x:=x+v1.x; p2[1].y:=y+v1.y; p2[2].x:=x+v2.x; p2[2].y:=y+v2.y;
    p2[3].x:=x+v3.x; p2[3].y:=y+v3.y; p2[4].x:=x+v4.x; p2[4].y:=y+v4.y;
    if (inside(p2, p1))and(inside(p3, p2)) then check:=true else check:=false;
  end
  else
  begin
    check:=false;
  end;
end;

procedure run;
var A1, B1, C1, A2, B2, C2, d, x1, y1, x2, y2:extended;
    v1, v2, v3, v4:t1;
begin
  A1:=p1[1].y-p3[1].y; B1:=p3[1].x-p1[1].x; C1:=0;
  A2:=p1[2].y-p3[2].y; B2:=p3[2].x-p1[2].x; C2:=A1*p1[2].x;
  d:=(A1*B2-B1*A2); x:=(C1*B2-B1*C2)/d; y:=(A1*C2-C1*A2)/d;
  v1.x:=x*s2/s1; v1.y:=y*s2/s1; v2.x:=(x-p1[2].x)*s2/s1; v2.y:=y*s2/s1;
  v3.x:=(x-p1[3].x)*s2/s1; v3.y:=(y-p1[3].y)*s2/s1; v4.x:=x*s2/s1; v4.y:=(y-p1[4].y)*s2/s1;
  if check(v1, v2, v3, v4) then exit;

  v1.x:=-v1.x; v1.y:=-v1.y; v2.x:=-v2.x; v2.y:=-v2.y;
  v3.x:=-v3.x; v3.y:=-v3.y; v4.x:=-v4.x; v4.y:=-v4.y;
  if check(v1, v2, v3, v4) then exit;
  no;
end;

procedure outp;
var i:integer;
begin
  for i:=1 to 4 do writeln(p2[i].x:0:7, ' ', p2[i].y:0:7);
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
