{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

{Alexey Timofeev }

const
	FILEIN='maps.in';
  FILEOUT='maps.out';
  eps=1E-7;
type
	rectangle=record
  	x1,y1,x2,y2,x3,y3,x4,y4:extended;
  end;
var
	a,b,c:rectangle;
  x,y,s1,s2,s3,x3,y3:extended;
  r1:boolean;

function vect(x1,y1,x,y,x2,y2:extended):extended;
begin
	vect:=(x1-x)*(y1-y)+(x2-x)*(y2-y);
end;

function infig(x,y,x1,y1,x2,y2,x3,y3,x4,y4:extended):boolean;
var
	r1:boolean;
begin
	r1:=true;

  if vect(x,y,x1,y1,x2,y2)*vect(x,y,x2,y2,x3,y3)<-eps then r1:=false;
  if vect(x,y,x2,y2,x3,y3)*vect(x,y,x3,y3,x4,y4)<-eps then r1:=false;
  if vect(x,y,x3,y3,x4,y4)*vect(x,y,x4,y4,x1,y1)<-eps then r1:=false;
  if vect(x,y,x4,y4,x1,y1)*vect(x,y,x1,y1,x2,y2)<-eps then r1:=false;
  infig:=r1;
end;

procedure getx(x3,y3:extended;a:rectangle;s:extended;var x,y:extended);
var
	c1,c2,c,k1,k2,k3,x1,x2,y1,y2:extended;
	r1:boolean;
begin
	{find (.) X }
  if a.x1=a.x2 then
  begin
    x:=a.x1/(1-s);
    y:=a.y1/(1-s);
    exit;
  end;

  s:=sqr(s);
  c1:=(y3+a.y1+a.y2);
  c2:=(a.x1-a.x2);
  c:=s*(sqr(a.x1)+sqr(a.y1)-sqr(a.x2)-sqr(a.y2))/2;
  c2:=-c2/c1;
  c:=c/c1;
  c1:=c2;
  k1:=1+sqr(c1)-s*(1+sqr(c1));
  k2:=c1*c-s*(c-a.x1-c1*a.y1);
  k3:=sqr(c)-s*(sqr(a.x1)+sqr(c)+sqr(a.y1)+2*a.x1*c-2*c*a.y1);
  if abs(k1)>eps then
  begin
  	x1:=(k2+sqrt(sqr(k2)-k1*k3))/k1;
    x2:=(k2-sqrt(sqr(k2)-k1*k3))/k1;
  	y1:=x1*c1+c;
    y2:=x2*c1+c;

    r1:=true;
    if ((x1>eps) and (x2-x3<-eps)) and ((y1>eps) and (y2-y3<-eps)) then r1:=true
    else r1:=false;
{
    if vect(x1,y1,a.x1,a.y1,a.x2,a.y2)*vect(x1,y1,a.x2,a.y2,a.x3,a.y3)<-eps then r1:=false;
    if vect(x1,y1,a.x2,a.y2,a.x3,a.y3)*vect(x1,y1,a.x3,a.y3,a.x4,a.y4)<-eps then r1:=false;
    if vect(x1,y1,a.x3,a.y3,a.x4,a.y4)*vect(x1,y1,a.x4,a.y4,a.x1,a.y1)<-eps then r1:=false;
    if vect(x1,y1,a.x4,a.y4,a.x1,a.y1)*vect(x1,y1,a.x1,a.y1,a.x2,a.y2)<-eps then r1:=false;
 }
    r1:=r1 and infig(x1,y1,a.x1,a.y1,a.x2,a.y2,a.x3,a.y3,a.x4,a.y4);

    if r1 then
    begin
    	x:=x1;
      y:=y2;
    end else
    begin
      x:=x2;
      y:=y2;
    end;
  end else
  begin
  	x:=k3/k2;
    y:=x*c1+c;
  end;

end;

procedure initdata;
begin

end;

procedure outdata(flag:boolean);
begin
	assign(output,FILEOUT);rewrite(output);
  if flag then
  begin
  	writeln(b.x1:0:8,' ',b.y1:0:8);
		writeln(b.x4:0:8,' ',b.y4:0:8);
  	writeln(b.x3:0:8,' ',b.y3:0:8);
		writeln(b.x2:0:8,' ',b.y2:0:8);
  end else writeln('impossible');
	close(output);
	halt;
end;

procedure readdata;
begin
	assign(input,FILEIN);reset(input);
  read(s1,x3,y3);
  read(s2);
  read(s3,c.x1,c.y1,c.x4,c.y4,c.x3,c.y3,c.x2,c.y2);
end;

procedure solve;
begin
  getx(x3,y3,c,s3/s1,x,y);
  b.x1:=x*(s1-s3)/s1;
  b.y1:=y*(s1-s3)/s1;
  b.x2:=b.x1;
  b.y2:=b.y1+y3*s3/s1;
  b.x3:=b.x1+x3*s3/s1;
  b.y3:=b.y2;
  b.x4:=b.x3;
  b.y4:=b.y1;

  r1:=true;
  r1:=r1 and (b.y1>eps) and (b.y4<y3) and (b.x1>eps) and (b.x4<x3);
  r1:=r1 and infig(c.x1,c.y1,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x2,c.y2,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x3,c.y3,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x4,c.y4,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);

  if r1 then  outdata(true);

  a:=b;

  b.x3:=x+(x-b.x1);
  b.x2:=x-(x-b.x4);
  b.x2:=b.x1;
  b.x4:=b.x3;

  r1:=true;
  r1:=r1 and (b.y1>eps) and (b.y4<y3) and (b.x1>eps) and (b.x4<x3);
  r1:=r1 and infig(c.x1,c.y1,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x2,c.y2,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x3,c.y3,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x4,c.y4,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);

  if r1 then  outdata(true);

  b.y3:=y+(x-b.x1);
  b.y2:=y-(x-b.x4);
  b.y2:=b.x1;
  b.y4:=b.x3;

  r1:=true;
  r1:=r1 and (b.y1>eps) and (b.y4<y3) and (b.x1>eps) and (b.x4<x3);
  r1:=r1 and infig(c.x1,c.y1,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x2,c.y2,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x3,c.y3,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x4,c.y4,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);

  if r1 then  outdata(true);

  b:=a;

  b.y3:=y+(x-b.x1);
  b.y2:=y-(x-b.x4);
  b.y2:=b.x1;
  b.y4:=b.x3;

  r1:=true;
  r1:=r1 and (b.y1>eps) and (b.y4<y3) and (b.x1>eps) and (b.x4<x3);
  r1:=r1 and infig(c.x1,c.y1,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x2,c.y2,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x3,c.y3,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);
  r1:=r1 and infig(c.x4,c.y4,b.x1,b.y1,b.x2,b.y2,b.x3,b.y3,b.x4,b.y4);

  if r1 then  outdata(true);

end;

begin
	initdata;
  readdata;
  {solve;}
  outdata(false);
end.