{$I-}{$R-}{$N+}
var
  f,f1 :text;

const name = 'maps';

procedure Linnear (a1,b1,c1,a2,b2,c2 :real; var x,y :real);
var k :real;
begin
  k := a1+b1*((a1-a2)/(b1-b2));
  x := c1/k;
  y := -(a1*x+c1)/b1;
end;

type TREST = record x1,x2,x3,x4,y1,y2,y3,y4 :real; end;

procedure Tochka (Rest1,Rest2 :TREST; var x,y :real);
begin
  Linnear
    (rest1.x1-rest2.x1+rest1.x2-rest2.x2,
     rest1.y1-rest2.y1+rest1.y2-rest2.y2,
     rest1.x1*rest1.x2-rest2.x1*rest2.x2+
     rest1.y1*rest1.y2-rest2.y1*rest2.y2,

     rest1.x1-rest2.x1+rest1.x3-rest2.x3,
     rest1.y1-rest2.y1+rest1.y3-rest2.y3,
     rest1.x1*rest1.x3-rest2.x1*rest2.x3+
     rest1.y1*rest1.y3-rest2.y1*rest2.y3,

     x,y);
end;

procedure Divide (x1,x2,s1,s2 :real; var x :real);
begin
  x := (s1*x2+s2*x1)/(s1+s2);
end;

procedure Rest (Rest1 :TREST; var Rest2 :TREST; x,y,s1,s2 :real);
begin
  Divide (Rest1.x1,x,s1-s2,s2,Rest2.x1);
  Divide (Rest1.x2,x,s1-s2,s2,Rest2.x2);
  Divide (Rest1.x3,x,s1-s2,s2,Rest2.x3);
  Divide (Rest1.x4,x,s1-s2,s2,Rest2.x4);

  Divide (Rest1.y1,y,s1-s2,s2,Rest2.y1);
  Divide (Rest1.y2,y,s1-s2,s2,Rest2.y2);
  Divide (Rest1.y3,y,s1-s2,s2,Rest2.y3);
  Divide (Rest1.y4,y,s1-s2,s2,Rest2.y4);
end;

procedure GetRest2 (Rest1 :TREST; var Rest2 :TREST; Rest3 :TREST;
                    s1 :real;     s2 :real; s3 :real);
var
  x,y :real;
begin
  Tochka (Rest1,Rest3,x,y);
  Rest   (Rest1,Rest2,x,y,s1,s2);
end;

var
  rest1,rest2,rest3 :TREST;
  s1,s2,s3 :real;

begin
  assign (f,name+'.in');
  assign (f1,name+'.out');
  reset (f);
  rewrite (f1);
    read (f,s1,rest1.x2,rest1.y4);
    rest1.x3:=rest1.x2;
    rest1.y3:=rest1.y4;
    read (f,s2);
    read (f,s3,rest3.x1,rest3.y1,rest3.x2,rest3.y2,
               rest3.x3,rest3.y3,rest3.x4,rest3.y4);
    GetRest2 (Rest1,Rest2,Rest3,s1,s2,s3);
    writeln (f1,rest2.x1 :0:10, rest2.y1 :0:10);
    writeln (f1,rest2.x2 :0:10, rest2.y2 :0:10);
    writeln (f1,rest2.x3 :0:10, rest2.y3 :0:10);
    writeln (f1,rest2.x4 :0:10, rest2.y4 :0:10);
  close (f);
  close (f1);
end.
