const eps=1E-8;
type
  int=longint;
  ex = extended;
var
  n,i,ii,j,jj : int;
  s1,s2,s3 : ex;
  x,y,xm,ym : ex;
  x2,y2 : ex;
  d2x,d2y : ex;
  k,fi : ex;
  m3 : array [1..4,1..2] of ex;
  a,b,c,d,e,f : ex;
  ver : array [1..4,1..4] of ex;
function pol ( x1,y1,x2,y2 : ex ) : ex;
var
  a : ex;
begin
  if abs(x1-x2)>eps then a:=(y2-y1)/(x2-x1)
  else if y2>y1 then a:=Maxlongint
                else a:=-Maxlongint;
  a:=arctan(a);
  if a<0 then a:=a+2*pi;
  if x1>x2 then a:=a+pi;
  if a>=2*pi then a:=a-2*pi;
  pol:=a;
end;
procedure pov ( fi,x1,y1 : ex; var x2,y2 : ex );
var c1,c2 :ex;
begin
  x1:=x1-x;
  y1:=y1-x;
  c1:=sin(fi);
  c2:=cos(fi);
  x2:=x1*c2-y1*c1+x;
  y2:=y1*c2+x1*c1+y;
end;
begin
  Assign ( input , 'maps.in' );
  reset ( input );
  Assign ( output , 'maps.out' );
  rewrite ( output );
  read ( s1,xm,ym,s2);
  read ( s3 );
  for i:=1 to 4 do read ( m3[i][1],m3[i][2] );
  k:=s3/s1;
  fi:=pol(m3[1][1],m3[1][2],m3[2][1],m3[2][2]);
  a:=k*cos(fi)-1;
  b:=-k*sin(fi);
  c:=k*sin(fi);
  d:=k*cos(fi)-1;
  e:=-m3[1][1];
  f:=-m3[1][2];
  x:=(e*d-b*f)/(a*d-b*c);
  y:=(a*f-c*e)/(a*d-b*c);
{  writeln ( x:0:7,' ',y:0:7 );}
  x2:=x*s2/s1;
  y2:=y*s2/s1;
  d2x:=xm*s2/s1;
  d2y:=ym*s2/s1;
  if (x2<x+eps) and (d2x-x2<xm-x+eps) and (y2<y+eps) and (d2y-y2<ym-y+eps) then begin
    writeln ( x-x2:0:7,' ',y-y2:0:7 );
    writeln ( x+d2x-x2:0:7,' ',y-y2:0:7 );
    writeln ( x+d2x-x2:0:7,' ',y+d2y-y2:0:7 );
    writeln ( x-x2:0:7,' ',y+d2y-y2:0:7 );
    close ( output );
    halt(0);
  end;
  if (d2y-y2<x+eps) and (y2<xm-x+eps) and (x2<y+eps) and (d2x-x2<ym-y+eps) then begin
    writeln ( x+y2:0:7,' ',y-x2:0:7 );
    writeln ( x+y2:0:7,' ',y+d2x-x2:0:7 );
    writeln ( x-d2y+y2:0:7,' ',y+d2x-x2:0:7 );
    writeln ( x-d2y+y2:0:7,' ',y-x2:0:7 );
    close ( output );
    halt(0);
  end;
  if (d2x-x2<x+eps) and (x2<xm-x+eps) and (d2y-y2<y+eps) and (y2<ym-y+eps) then begin
    writeln ( x+x2:0:7,' ',y+y2:0:7 );
    writeln ( x-d2x+x2:0:7,' ',y+y2:0:7 );
    writeln ( x-d2x+x2:0:7,' ',y-d2y+y2:0:7 );
    writeln ( x+x2:0:7,' ',y-d2y+y2:0:7 );
    close ( output );
    halt(0);
  end;
  if (y2<x+eps) and (d2y-y2<xm-x+eps) and (d2x-x2<y+eps) and (x2<ym-y+eps) then begin
    writeln ( x-y2:0:7,' ',y+x2:0:7 );
    writeln ( x-y2:0:7,' ',y-d2x+x2:0:7 );
    writeln ( x+d2y-y2:0:7,' ',y-d2x+x2:0:7 );
    writeln ( x+d2y-y2:0:7,' ',y+x2:0:7 );
    close ( output );
    halt(0);
  end;
  ver[1][1]:=x-x2;
  ver[1][2]:=y-y2;
  ver[2][1]:=x+d2x-x2;
  ver[2][2]:=y-y2;
  ver[3][1]:=x+d2x-x2;
  ver[3][2]:=y+d2y-y2;
  ver[4][1]:=x-x2;
  ver[4][2]:=y+d2y-y2;
  fi:=0;
  while fi<2*pi do begin
    pov(fi,ver[1][1],ver[1][2],ver[1][3],ver[1][4]);
    if (ver[1][3]<-eps) or (ver[1][3]>xm-eps) or (ver[1][4]<-eps) or (ver[1][4]>ym-eps) then begin     fi:=fi+1E-7;
continue; end;

    pov(fi,ver[2][1],ver[2][2],ver[2][3],ver[2][4]);
    if (ver[2][3]<-eps) or (ver[2][3]>xm-eps) or (ver[2][4]<-eps) or (ver[2][4]>ym-eps) then begin     fi:=fi+1E-7;
continue; end;

    pov(fi,ver[3][1],ver[3][2],ver[3][3],ver[3][4]);
    if (ver[3][3]<-eps) or (ver[3][3]>xm-eps) or (ver[3][4]<-eps) or (ver[3][4]>ym-eps) then begin     fi:=fi+1E-7;
continue; end;

    pov(fi,ver[4][1],ver[4][2],ver[4][3],ver[4][4]);
    if (ver[4][3]<-eps) or (ver[4][3]>xm-eps) or (ver[4][4]<-eps) or (ver[4][4]>ym-eps) then begin     fi:=fi+1E-7;
 continue; end;
    for i:=1 to 4 do begin
      writeln ( ver[i][3]:0:7,' ',ver[i][4]:0:7 );
    end;
  end;
 writeln ( 'impossible' );
  close ( input );
  close ( output );
end.
