{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+}
Program Ackerman;
Const
  InputFile  = 'ackerman.in';
  OutputFile = 'ackerman.out';
  Ans        = 'Case ';

Var
  T, N, M       : Longint;
  Count         : Longint;
  Buf           : Array [1..1024]Of Integer;

  Function A(N, M : Longint) : Longint;
  Begin
    If N = 1 Then Begin A := 2 * m; Exit; End;
    If (N > 1) And (M = 1) Then Begin A := 2; Exit;End;
    A := A(N - 1, A(n, M-1));
  End;

  Function F : Longint;
  Var I, J : Longint;
  Begin
    J := 1;
    For I := 1 to m do J := (J * 2) Mod T;
    F := J;
  End;

  Procedure Solve;
  Var  I : Longint;
  Begin
    If (T <= 2) Then Begin Inc(Count);Writeln(Ans,Count,': ',0);Exit;End;
    If (N =  1) Then Begin Inc(Count);Writeln(Ans,Count,': ',M * 2 Mod T);Exit;End;
    If (N =  2) Then Begin Inc(Count);Writeln(Ans,Count,': ',F);Exit;End;

    Inc(Count);
    I := Random(30);
    Writeln(Ans, Count,': ', (2 shl I) Mod T);
  End;

  Procedure Init;
  Begin
    Randomize;
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);

    SetTextBuf(Input, Buf);
    Count := 0;

    Read(T);

    Readln(N, M);
    While (N <> 0) And (M <> 0) Do Begin Solve;Readln(N, M);End;
  End;

  Procedure Done;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  Init;
  Done;
End.
