#include <stdio.h>
#include <string.h>

#define NMAX 11
#define MMAX 2001

#define INT __int64
#define format "%I64d"

INT nl[NMAX][MMAX], A[NMAX][MMAX], naux;

int main()
{
	int i, j, k, T, N, M;

	memset(nl, 0, sizeof(nl));

	for (j = 1; j < MMAX; j++)
		nl[1][j] = 1;

	for (i = 2; i < NMAX; i++)
		for (j = 1; j < MMAX; j++)
		{		
			for (k = j / 2; k >= 1; k--)
			{	/*
				if (!nl[i - 1][k])
					break;
				*/
				nl[i][j] += nl[i - 1][k];
			}	
		}

	memset(A, 0, sizeof(A));
	for (i = 1; i < NMAX; i++)
	{
		A[i][1] = nl[i][1];

		for (j = 2; j < MMAX; j++)
			A[i][j] = A[i][j - 1] + nl[i][j];
	}

	scanf("%d", &T);
	for (k = 1; k <= T; k++)
	{
		scanf("%d %d", &N, &M);
		printf("Case %d: n = %d, m = %d, # lists = ", k, N, M);
		printf(format, A[N][M]);
		printf("\n");
	}

	return 0;
}