#include <stdio.h>
#include <string.h>

#define NMAX 260

char S[NMAX], s[2][NMAX], o[NMAX];
int i, j, k, N, a, cu, an, pas, found, msteps;
__int64 MAXSTEPS;

int main()
{
	int t = 0;

	//freopen("h.in", "r", stdin);

	while (scanf("%I64d", &MAXSTEPS) == 1)
	{
		scanf("%s", S + 1);
		
		printf("LINE %d", ++t);

		N = strlen(S + 1);

		k = 1;
		for (i = 1; i <= N; i++)
			if (S[i] != 'W' && S[i] != 'B')
			{
				k = 0;
				break;
			}

		if (N % 2 == 0 || !k || S[1] != 'W' || S[N] != 'W')
			printf(" NONE\n");
		else
		if (N == 1)
		{
			for (a = 0; a < 256; a++)
				printf(" (%d,0)", a);
			printf("\n");
		}
		else
		{
			if (MAXSTEPS > 10 * N * N)
				msteps = 10 * N * N;
			else
				msteps = (int)MAXSTEPS;
			
			found = 0;

			for (i = 1; i <= N; i++)
				if (S[i] == 'W')
					o[i] = 0;
				else
					o[i] = 1;

			for (a = 0; a < 256; a++)
			{
				cu = 0;
				/* creeaza prima linie */
				for (i = 1; i <= N; i++)
					s[cu][i] = 0;
				s[cu][(N + 1) / 2] = 1;

				/* incearca automatul #a */
				for (pas = 2; pas <= msteps; pas++)
				{
					an = cu;
					cu = 1 - cu;

					for (i = 2; i < N; i++)
						s[cu][i] = (
						             ( a & 
									   (1 << ( (s[an][i-1] << 2) + 
						                      (s[an][i] << 1) +
									          (s[an][i + 1])
									         )
									   )
									 ) > 0
								   );

					s[cu][1] = 0;
					s[cu][N] = 0;

					/* verifica egalitatea */
					k = 1;
					for (i = 2; i < N; i++)
						if (s[cu][i] != o[i])
						{
							k = 0;
							break;
						}

					if (k)
					{
						found = 1;
						printf(" (%d,%d)", a, pas);
						break;
					}
				}			
			}

			if (!found)
				printf(" NONE");

			printf("\n");
		}
	}

	return 0;
}