#include <stdio.h>
#include <math.h>

#define NMAX 20
#define eps 1e-7

double x[NMAX], p[NMAX], lm, vv, v, li, ls, m;
int i, j, k, N;

int main()
{
	int t = 0;

	scanf("%d", &N);
	while (N > -1)
	{
		for (i = 1; i <= N; i++)
			scanf("%lf %lf", &p[i], &x[i]);

		scanf("%lf %lf", &lm, &v);
		for (i = 1; i <= N; i++)
			p[i] = lm - p[i] + 1.0;

		li = 0; ls = 1.0;
		while (fabs(ls - li) > eps)
		{
			m = 0.5 * (li + ls);

			vv = 0;
			for (i = 1; i <= N; i++)
				vv += x[i] * pow(1.0 + m, p[i]);

			if (vv < v)
				li = m;
			else
				ls = m;
		}

		t++;
		if (t > 1)
			printf("\n");

		printf("Case %d: %.5lf\n", t, li);

		scanf("%d", &N);
	}

	return 0;
}