{$APPTYPE CONSOLE}
{.$Q+,R+,S+}

const
  MaxN = 10000;
  MaxA = 10000;
  MaxB = 10000;
var
  hollidays, hpy, hpyv, dow, year, i, j, t, A, B, N, M, E, E0: longint;
  C: array [1..MaxN] of longint;
  D: array [1..MaxB+1] of longint;
  R, H, Hv, Q, Qv, Hl: array [1..MaxA] of longint;

procedure normyrs(y: longint);
var
  nd, t, i: longint;
begin
  if y < 1 then
    exit;
  nd := y*B;
  Dec (E, nd);

  t := y div A;
  if t>0 then
  for i := 1 to A do begin
    Inc (Q[dow], t);
    dow := ((dow+B-1) mod A) + 1;
  end;

  t := y mod A;
  for i := 1 to t do begin
    Inc (Q[dow]);
    dow := ((dow+B-1) mod A) + 1;
  end;
end;

begin
  Assign (Input, 'holidays.in'); Reset (Input);

  Read (A, B, N);

  for i := 1 to N do
    Read (C[i]);

  Read (M);
  for i := 1 to M do
    Read (D[i]);

  Read (E);
  E0 := E;

  Close (Input);

  t := B div A;
  for i := 1 to A do
    H[i] := t;
  t := B mod A;
  for i := 1 to t do
    Inc (H[i]);
  t := (B+1) div A;
  for i := 1 to A do
    Hv[i] := t;
  t := (B+1) mod A;
  for i := 1 to t do
    Inc (Hv[i]);

  for i := 1 to M do begin
    if D[i] <> B+1 then
      Dec (H [((D[i]-1) mod A) + 1]);
    Dec (Hv [((D[i]-1) mod A) + 1]);
  end;

  fillchar (Q, sizeof (Q), 0);
  fillchar (Qv, sizeof (Qv), 0);
  year := 1;
  dow := 1;

  for i := 1 to N do begin
    t := C[i] - year;
    if t > E div B then
      t := E div B;

    normyrs (t);
    year := year + t;

    if E < B+1 then break;

    Dec (E, B+1);

    Inc (Qv[dow]);
    dow := ((dow+B) mod A) + 1;
    inc (year);
  end;
  normyrs (E div B);

  hollidays := 0;
  hpyv := M;
  hpy := M;
  if M > 0 then
  if D[M] = B+1 then
    dec (hpy);

  t := 0;
  for i := 1 to A do begin
    Inc (t, Q[i]);
  end;
  Inc (hollidays, t * hpy);
  t := 0;
  for i := 1 to A do begin
    Inc (t, Qv[i]);
  end;
  Inc (hollidays, t * hpyv);

  t := E div A;
  for i := 1 to A do
    Hl [((i + dow - 2) mod A) + 1] := t;
  t := E mod A;
  for i := 1 to t do
    Inc (Hl[((i + dow - 2) mod A) + 1]);

  for i := 1 to M do begin
    if D[i] > E then
      break;
    Dec (Hl [((D[i]+dow-2) mod A) + 1]);
    Inc (hollidays);
  end;

  for i := 1 to A do
    R[i] := Hl[i];

  for i := 1 to A do begin
    for j := 1 to A do begin
      t := (i-j+1);
      if t<=0 then
        Inc (t, A);
      if t > A then
        Dec (t, A);
      Inc (R[i], Q[j]*H[t]);
      Inc (R[i], Qv[j]*Hv[t]);
    end;
  end;

  t := 1;
  for i := 1 to A do
    if R[i] > R[t] then
      t := i;


  j := 0;
  for i := 1 to A do begin
    if R[i] = R[t] then inc (j);
  end;

  WriteLn ('num of answers: ', j:3);

  Assign (Output, 'holidays.out'); ReWrite (Output);

  WriteLn (t, ' ', R[t] + hollidays);

  Close (Output);
end.
