{$q+,r+}
const
    MAX_N = 10000;
    MAX_M = 100000;
    MAX_K = 100000;

type
    pbusy = ^tBusy;
    tBusy = record
        next: pBusy;
        t1, t2: longint;
    end;

type
    pEdge = ^tEdge;
    tEdge = record
        next: pEdge;
        index: longint;
    end;

var
    n, m, k, i, j:longint;
    b, e, t: array [1..MAX_M] of longint;
    busy, last: array [1..MAX_M] of pBusy;
    q: pBusy;
    edges: array [1..MAX_N] of pEdge;
    edge: pEdge;

    p, v: array [1..MAX_K] of longint;
    d: array [0..MAX_N] of longint;
    u: array [1..MAX_N] of boolean;
    prev: array [1..MAX_N] of longint;
    mini: longint;
    time: longint;
    wolftime: longint;

procedure rec(i, c: longint);
begin
    if i <> 1 then begin
        if b[prev[i]] = i then begin
            rec(e[prev[i]], c + 1);
        end else begin
            rec(b[prev[i]], c + 1);
        end;
        writeln(prev[i]);
    end else begin
        writeln(c);
    end;
end;

begin
    assign(input, 'redhat.in'); reset(input);
    assign(output, 'redhat.out'); rewrite(output);

    read(n, m, k);

    fillchar(edges, sizeof(edges), 0);
    for i := 1 to m do begin
        read(b[i], e[i], t[i]);

        new(edge);
        edge^.index := i;
        edge^.next := edges[b[i]];
        edges[b[i]] := edge;

        new(edge);
        edge^.index := i;
        edge^.next := edges[e[i]];
        edges[e[i]] := edge;
    end;

    fillchar(busy, sizeof(busy), 0);
    fillchar(last, sizeof(last), 0);
    wolftime := 0;
    for i := 1 to k do begin
        read(p[i], v[i]);

        new(q);
        q^.t1 := wolftime;
        wolftime := wolftime + v[i];
        q^.t2 := wolftime;
        q^.next := nil;
        if busy[p[i]] = nil then begin
            busy[p[i]] := q;
        end else begin
            last[p[i]]^.next := q;
        end;
        last[p[i]] := q;
    end;

    d[0] := MAXLONGINT;
    d[1] := 0;
    for i := 2 to n do begin
        d[i] := MAXLONGINT;
    end;

    fillchar(u, sizeof(u), 0);

    while not u[n] do begin
        mini := 0;
        for i := 1 to n do begin
            if not u[i] and (d[mini] > d[i]) then begin
                mini := i;
            end;
        end;
        u[mini] := true;

        edge := edges[mini];
        while edge <> nil do begin
            if mini = b[edge^.index] then begin
                i := e[edge^.index];
            end else begin
                i := b[edge^.index];
            end;
            j := edge^.index;

            time := d[mini];
            while (busy[j] <> nil) and (busy[j]^.t2 <= time) do begin
                busy[j] := busy[j]^.next;
            end;
            while (busy[j] <> nil) and (time + t[j] >= busy[j]^.t1) do begin
                time := busy[j]^.t2;
                busy[j] := busy[j]^.next;
            end;

            if d[i] > time + t[j] then begin
                d[i] := time + t[j];
                prev[i] := j;
            end;
            edge := edge^.next;
        end;
    end;

    if d[n] < wolftime then begin
        writeln('YES');
        rec(n, 0);
    end else begin
        writeln('NO');
    end;

    close(input);
    close(output);
end.