{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$APPTYPE CONSOLE}
const
  inf = $77777777;
  eps = 1e-10;
  TL = 1;
  PT = 2;
  MM = 3;
type
  int = longint;
var
  n, m, i, j, csn, ct, src, dst, z, k, t, cto, ctn: int;
  sum, sump: int64;
  nh: array[1 .. 2] of int;
  b, e, ne, sn, he, u, l, nd: array[1 .. 500000] of int;
  h, hh, d: array[1 .. 3, 1 .. 500000] of int;
  cc: array[1 .. 500000] of boolean;
  ch: int;
procedure siftup(z, x: int);
var
  i, j, t: int;
begin
  i := x;
  while (i > 1) do begin
    j := i div 2;
    if (d[z, h[z, i]] >= d[z, h[z, j]]) then
      break;
    t := h[z, i];
    h[z, i] := h[z, j];
    h[z, j] := t;
    hh[z, h[z, i]] := i;
    hh[z, h[z, j]] := j;
    i := j;
  end;
end;
procedure siftdown(z, x: int);
var
  i, j, k, t: int;
begin
  i := x;
  while (true) do begin
    j := 2 * i;
    if (j > nh[z]) then
      break;
    k := 2 * i + 1;
    if (k <= nh[z]) then
      if (d[z, h[z, k]] < d[z, h[z, j]]) then
        j := k;
    if (d[z, h[z, i]] <= d[z, h[z, j]]) then
      break;
    t := h[z, i];
    h[z, i] := h[z, j];
    h[z, j] := t;
    hh[z, h[z, i]] := i;
    hh[z, h[z, j]] := j;
    i := j;
  end;
end;
procedure wait_light;
var
  nrt, j: int;
begin
  j := h[TL, 1];
  if ((j = h[PT, 1]) and (cc[j])) then begin
    ctn := d[PT, h[PT, 1]];
  end;
{  if (d[TL, 2] = 48) then begin
    asm
      int 3
    end;
  end;}
  inc(csn);
  if (csn > 262200) then begin
    if (u[dst] > 0) and (nd[dst] <= 131072) then
      write(d[PT, dst])
    else
      write('-1');
    halt(0);
  end;
  cc[j] := not cc[j];
  dec(sum, (d[TL, j] - ct) * n);
  if (sum = 0) then begin
    if (u[dst] > 0) and (nd[dst] <= 131072) then
      write(d[PT, dst])
    else
      write('-1');
    halt(0);
  end;
  if (d[TL, j] <> ct) then
    sump := sum;
  ct := d[TL, j];
  nrt := sump mod sn[j];
  if (nrt = 0) then
    nrt := sn[j];
  inc(sum, nrt);
  sum := sum;
  inc(d[TL, j], nrt);
  siftdown(TL, 1);
end;
begin
  assign(input, 'traffic.in');
  reset(input);
  assign(output, 'traffic.out');
  rewrite(output);

  readln(n, m, src, dst);
  nh[TL] := 0;
  sum := 0;
  for i := 1 to n do begin
    read(ch);
    cc[i] := (ch = 0);
    read(d[TL, i], sn[i]);
    inc(sum, d[TL, i]);
    inc(nh[TL]);
    h[TL, nh[TL]] := i;
    hh[TL, i] := nh[TL];
    siftup(TL, nh[TL]);
  end;

  z := 0;
  fillchar(he, sizeof(he), 0);
  for i := 1 to m do begin
    read(j, k, t);
    inc(z);
    b[z] := j;
    e[z] := k;
    ne[z] := he[j];
    l[z] := t;
    he[j] := z;
    inc(z);
    b[z] := k;
    e[z] := j;
    ne[z] := he[k];
    l[z] := t;
    he[k] := z;
  end;
{  assert(seekeof);}

  fillchar(u, sizeof(u), 0);
  u[src] := 1;
  d[PT, src] := 0;
  nh[PT] := 1;
  h[PT, 1] := src;
  hh[PT, src] := 1;
  csn := 0;
  ct := 0;
  sump := sum;

  while true do begin
    if (nh[PT] = 0) then
      break;
    i := h[PT, 1];
    ctn := inf;
    while (d[PT, i] >= d[TL, h[TL, 1]]) do
      wait_light;
    if (d[PT, i] > ct) then begin
      dec(sum, (d[PT, i] - ct) * n);
      if (sum = 0) then begin
        write('-1');
        halt(0);
      end;
      ct := d[PT, i];
      sump := sum;
    end;
    cto := ct;
    if (i = dst) then begin
      u[i] := 2;
      break;
    end;

    if (ctn = inf) then begin
      if (cc[i]) then begin
        d[PT, h[PT, 1]] := d[TL, h[PT, 1]];
        siftdown(PT, 1);
        continue;
      end;
    end else
      ct := ctn;

    u[i] := 2;
    h[PT, 1] := h[PT, nh[PT]];
    hh[PT, nh[PT]] := 1;
    dec(nh[PT]);
    if (nh[PT] <> 0) then
      siftdown(PT, 1);

    i := he[i];
    while (i > 0) do begin
      j := e[i];
      {if (j = 3) then
        asm
          int 3
        end;}
      if (u[j] = 0) then begin
        u[j] := 1;
        d[PT, j] := ct + l[i];
        nd[j] := csn;
        inc(nh[PT]);
        h[PT, nh[PT]] := j;
        hh[PT, j] := nh[PT];
        siftup(PT, nh[PT]);
      end else if ((u[j] = 1) and (d[PT, j] > ct + l[i]) and (csn <= 131072)) then begin
        d[PT, j] := ct + l[i];
        nd[j] := csn;
        siftdown(PT, hh[PT, j]);
        siftup(PT, hh[PT, j]);
      end;
      i := ne[i];
    end;
    ct := cto;
  end;

  if (u[dst] < 2) or (nd[dst] > 131072) then
    write('-1')
  else
    write(d[pt, dst]);
end.