{$O-}
{$APPTYPE CONSOLE}

uses
    Math;

const
    inFile = 'ancient.in';
    outFile = 'ancient.out';

    maxN = 100000;
    maxC = 1000000000;
    infinity = maxlongint;

type
    TSegment = array[0..1] of integer;

var
    n : integer;
    s : array[1..maxN] of TSegment;

    minLen : integer;
    answer1, answer2 : integer;

procedure Solve;
var
    i, j : integer;

    procedure Update(i, j : integer);
    var
        left, right : integer;

    begin
        if i <> j then begin
            left := max(s[i,0], s[j,0]);
            right := min(s[i,1], s[j,1]);
            if (left < right) and (right - left < minLen) then begin
                answer1 := i;
                answer2 := j;
                minLen := right - left;
            end;
        end;
    end;

begin
    minLen := infinity;
    answer1 := 0;
    for i := 1 to n do
        for j := i + 1 to n do
            Update(i, j);
end;

procedure ReadData;
var
    i : integer;

begin
    assign(input, inFile);
    reset(input);

    read(n);
    if (n < 1) or (n > maxN) then
        RunError(239);

    for i := 1 to n do begin
        read(s[i,0], s[i,1]);
        if (abs(s[i,0]) > maxC) or (abs(s[i,1]) > maxC) or (s[i,0] >= s[i,1]) then
            RunError(239);
    end;

    close(input);
end;

procedure WriteData;
begin
    assign(output, outFile);
    rewrite(output);
    if answer1 = 0 then
        writeln(0)
    else
        writeln(answer1, ' ', answer2, ' ');
    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
