{
          

    :     
    :       
    :     
}

{$O-,Q+,R+}
{$APPTYPE CONSOLE}
{$DEFINE ALLOWMULTITEST}

program fraction;

const
    maxn = 200;
    maxp = 10000;
    maxdig = 400;

type
    tlong = array [0..maxdig] of longint;

procedure mult(var a: tlong; b: longint);
var
    i, c: longint;
begin
    c := 0;
    for i := 1 to a[0] do
    begin
        c := c + a[i] * b;
        a[i] := c mod 10;
        c := c div 10;
    end;
    while c > 0 do
    begin
        inc(a[0]);
        a[a[0]] := c mod 10;
        c := c div 10;
    end;
end;

procedure init(var a: tlong; b: longint);
begin
    a[1] := b;
    a[0] := 1;
end;

procedure print(var a: tlong);
var
    i: longint;
begin
    i := a[0];
    while (i > 1) and (a[i] = 0) do
    begin
        dec(i);
    end;

    while i > 0 do
    begin
        write(a[i]);
        dec(i);
    end;
    writeln;
end;

var
    i, j, n, t: longint;
    p: array [1..maxn] of longint;
    count: array [1..maxp] of longint;
    a, b: tlong;

begin
    assign(input, 'fraction.in');
    reset(input);
    assign(output, 'fraction.out');
    rewrite(output);

    if eoln then runerror(239);
    read(n);
    if not eoln then runerror(239);
    readln;
    if (n < 1) or (n > maxn) then
        runerror(239);

    for i := 1 to n do
    begin
        if eoln then runerror(239);

        read(p[i]);
        if (p[i] < 2) or (p[i] > maxp) then
            runerror(239);
        if i > 2 then
            inc(count[p[i]]);

        j := 2;
        while j * j <= p[i] do
        begin
            if p[i] mod j = 0 then
                runerror(239);
            inc(j);
        end;
    end;
    if not eoln then runerror(239);
    readln;

    {$IFNDEF ALLOWMULTITEST}
    if not eof then runerror(239);
    {$ENDIF}

    init(a, 1);
    init(b, 1);
    for i := 1 to maxp do
    begin
        if count[i] > 0 then
            mult(a, count[i] + 1);

        t := count[i];
        if p[1] = i then inc(t);
        if p[2] = i then inc(t);
        t := t div 2 + 1;
        if p[2] = i then
            dec(t);

        mult(b, t);
    end;

    print(a);
    print(b);

    close(input);
    close(output);
end.