{
          

    :      
    :       
    :     
}

{$APPTYPE CONSOLE}
{$O-,Q+,R+}
{$DEFINE ALLOWMULTITEST}

program total_control;

const
    maxn = 256;

var
    i, j, r, n, k: longint;
    cwc, cbc, nw, nb: longint;
    cw, cb, uw, ub: array [1..maxn] of boolean;
    a: array [1..maxn, 1..maxn] of shortint;
    white, black: array [1..maxn] of longint;
    count: longint;

begin
    assign(input, 'kingdom.in');
    reset(input);
    assign(output, 'kingdom.out');
    rewrite(output);

    if eoln then runerror(239);
    read(n);
    if eoln then runerror(239);
    read(k);
    if not eoln then runerror(239);
    readln;

    r := 1;
    for i := 1 to k do
    begin
        r := r * 2;
        if r >= n then
            break;
    end;

    if (k < 1) or (k > n) or (r < n) or (n < 2) or (n > maxn) then
        runerror(239);

    for i := 1 to n do
    begin
        for j := 1 to n do
        begin
            if eoln then runerror(239);
            read(a[i][j]);
        end;
        if not eoln then runerror(239);
        readln;
    end;

    {$IFNDEF ALLOWMULTITEST}
    if not eof then runerror(239);
    {$ENDIF}

    for i := 1 to n do
        for j := 1 to n do
            if (a[i][j] <> a[j][i]) or ((i = j) and (a[i][j] <> 0)) then
                runerror(239);

    cwc := 0;
    cbc := 0;
    nw := 0;
    nb := 0;
    fillchar(cw, sizeof(cw), 0);
    fillchar(cb, sizeof(cb), 0);
    while (cwc < n) and (cbc < n) do
    begin
        r := 0;
        if (nw < k) then
        begin
            for i := 1 to n do
{                if not cb[i] then}
                begin
                    count := 0;
                    for j := 1 to n do
                        if (a[j][i] <> 2) and not cw[j] then
                            inc(count);
                    if count >= (n - cwc + 1) div 2 then
                    begin
                        r := i;
                        break;
                    end;
                end;
        end;

        if (r = 0) and (nb < k) then
        begin
            for i := 1 to n do
{                if not cw[i] then}
                begin
                    count := 0;
                    for j := 1 to n do
                        if (a[i][j] <> 1) and not cb[j] then
                            inc(count);
                    if count >= (n - cbc + 1) div 2 then
                    begin
                        r := -i;
                        break;
                    end;
                end;
        end;

        if r = 0 then
            runerror(240);

        j := r;
        if j > 0 then
        begin
            for i := 1 to n do
                if (a[j][i] <> 2) and not cw[i] then
                begin
                    cw[i] := true;
                    inc(cwc);
                end;
            inc(nw);
            white[nw] := j;
            uw[j] := true;
        end else begin
            j := -j;
            for i := 1 to n do
                if (a[i][j] <> 1) and not cb[i] then
                begin
                    cb[i] := true;
                    inc(cbc);
                end;
            inc(nb);
            black[nb] := j;
            ub[j] := true;
        end;
    end;

    if cwc = n then
    begin
        if nw > k then
            runerror(241);
            
        writeln(1);
        writeln(k);
        for i := 1 to nw do
            write(white[i], ' ');
        i := 1;
        while nw < k do
        begin
            while uw[i] do inc(i);
            write(i, ' ');
            inc(i);
            inc(nw);
        end;

        writeln;
    end else begin
        if nb > k then
            runerror(241);

        writeln(2);
        writeln(k);
        for i := 1 to nb do
            write(black[i], ' ');
        i := 1;
        while nb < k do
        begin
            while ub[i] do inc(i);
            write(i, ' ');
            inc(i);
            inc(nb);
        end;

        writeln;
    end;

    close(input);
    close(output);
end.