{
          

    :     
    :       
    :     
}

{$O-,Q+,R+}
{$APPTYPE CONSOLE}
{$DEFINE ALLOWMULTITEST}

program packing;

uses
    math;

const
    maxx = 1000;

procedure readn(var x: longint; reqeoln: boolean);
begin
    if eoln then runerror(239);
    read(x);
    if (x < 1) or (x > maxx) then runerror(239);
    if eoln <> reqeoln then runerror(239);
    if reqeoln then readln;
end;

function fit(a, b, c, d: longint): boolean;
begin
    fit := ((a <= c) and (b <= d)) or ((a <= d) and (b <= c));
end;

var
    l1, w1, h1, l2, w2, h2, lc, wc, hc: longint;
    flag: boolean;

begin
    assign(input, 'packing.in');
    reset(input);
    assign(output, 'packing.out');
    rewrite(output);

    readn(l1, false);
    readn(w1, false);
    readn(h1, true);
    readn(l2, false);
    readn(w2, false);
    readn(h2, true);
    readn(lc, false);
    readn(wc, false);
    readn(hc, true);

    {$IFNDEF ALLOWMULTITEST}
    if not seekeof then runerror(239);
    {$ENDIF}

    flag := false;

    flag := flag or fit(max(l1, l2), w1 + w2, lc, wc);
    flag := flag or fit(max(l1, w2), w1 + l2, lc, wc);
    flag := flag or fit(max(w1, l2), l1 + w2, lc, wc);
    flag := flag or fit(max(w1, w2), l1 + l2, lc, wc);

    flag := flag and (h1 <= hc) and (h2 <= hc);

    if h1 + h2 <= hc then
    begin
        if fit(l1, w1, lc, wc)  and fit(l2, w2, lc, wc) then
        begin
            flag := true;
        end;
    end;

    if flag then
        writeln('YES')
    else
        writeln('NO');
    
    close(input);
    close(output);
end.