{
          

    :     
    :       
    :     
}

{$APPTYPE CONSOLE}

const
    inFile = 'packing.in';
    outFile = 'packing.out';

    maxC = 1000;

var
    l, w, h : array[1..3] of integer;
    answer : boolean;

function fit(ll, ww : integer) : boolean;
begin
    fit := (ll <= l[3]) and (ww <= w[3]) or (ll <= w[3]) and (ww <= l[3]);
end;

procedure Solve;
begin
    answer :=
        (l[1] * w[1] + l[2] * w[2] <= l[3] * w[3]) and (h[1] <= h[3]) and (h[2] <= h[3])  or
        (l[1] * w[1] <= l[3] * w[3]) and (l[2] * w[2] <= l[3] * w[3]) and (h[1] + h[2] <= h[3]);
    answer := answer and fit(l[1], w[1]) and fit(l[2], w[2]);
end;

procedure ReadData;
var
    i : integer;

begin
    assign(input, inFile);
    reset(input);

    for i := 1 to 3 do begin
        read(l[i], w[i], h[i]);
        if (l[i] <= 0) or (l[i] > maxC) or
           (w[i] <= 0) or (w[i] > maxC) or
           (h[i] <= 0) or (h[i] > maxC) then
            RunError(239);
    end;

    close(input);
end;

procedure WriteData;
begin
    assign(output, outFile);
    rewrite(output);
    if answer then
        writeln('YES')
    else
        writeln('NO');
    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
