{
          

    :     
    :       
    :     
}

{$APPTYPE CONSOLE}

uses
    SysUtils;

const
    inFile = 'terminal.in';
    outFile = 'terminal.out';

    maxN = 300;
    maxK = 40000;
    maxV = 1000;
    maxA = 10000000;

    dirs = 'RLDU';

var
    m, n : integer;
    k : integer;
    answer : array[1..maxN,1..maxN] of integer;

    q : array[1..4,1..maxN,1..maxN] of integer;

function strtok(var s : string) : string;
begin
    while (length(s) > 0) and (s[1] = ' ') do
        delete(s, 1, 1);
    result := '';
    while (length(s) > 0) and (s[1] <> ' ') do begin
        result := result + s[1];
        delete(s, 1, 1);
    end;
end;

var
    ntimes : integer = 0;

procedure Solve;
var
    i : integer;
    s, cmd : string;
    r, c : integer;
    sum : integer;
    r1, c1, r2, c2 : integer;
    d : integer;
    v : integer;

    function ParseDir(s : string) : integer;
    begin
        if length(s) <> 1 then
            RunError(239);
        ParseDir := pos(s, dirs);
    end;

    procedure Action(r, c, d, v : integer);
    begin
        inc(ntimes);
        if (d = 0) or (ntimes > maxA) then
            RunError(239);
        inc(q[d,r,c], v);
    end;

begin
    fillchar(c, sizeof(c), 0);

    for i := 1 to k do begin
        readln(s);
        cmd := strtok(s);
        if cmd = 'A' then begin
            r := strtoint(strtok(s));
            c := strtoint(strtok(s));
            d := ParseDir(strtok(s));
            v := strtoint(strtok(s));
            if (r < 1) or (r > m) or
               (c < 1) or (c > n) then
                RunError(239);
            if (v < 0) or (v > maxV) then
                RunError(239);
            Action(r, c, d, v);
        end else if cmd = 'B' then begin
            r1 := strtoint(strtok(s));
            c1 := strtoint(strtok(s));
            r2 := strtoint(strtok(s));
            c2 := strtoint(strtok(s));
            d  := ParseDir(strtok(s));
            v  := strtoint(strtok(s));
            if (r1 < 1) or (r1 > r2) or (r2 > m) or
               (c1 < 1) or (c1 > c2) or (c2 > n) then
                RunError(239);
            if (v < 0) or (v > maxV) then
                RunError(239);
            for r := r1 to r2 do
                for c := c1 to c2 do
                    Action(r, c, d, v);
        end else
            RunError(239);
    end;

    for r := 1 to m do begin
        sum := 0;
        for c := 1 to n do begin
            inc(sum, q[1,r,c]);
            inc(answer[r,c], sum);
        end;
        sum := 0;
        for c := n downto 1 do begin
            inc(sum, q[2,r,c]);
            inc(answer[r,c], sum);
        end;
    end;

    for c := 1 to n do begin
        sum := 0;
        for r := 1 to m do begin
            inc(sum, q[3,r,c]);
            inc(answer[r,c], sum);
        end;
        sum := 0;
        for r := m downto 1 do begin
            inc(sum, q[4,r,c]);
            inc(answer[r,c], sum);
        end;
    end;
end;

procedure ReadData;
begin
    assign(input, inFile);
    reset(input);

    readln(m, n);
    if (m < 1) or (m > maxN) or (n < 1) or (n > maxN) then
        RunError(239);
    readln(k);
    if (k < 0) or (k > maxK) then
        RunError(239);
end;

procedure WriteData;
var
    i, j : integer;

begin
    assign(output, outFile);
    rewrite(output);

    for i := 1 to m do begin
        for j := 1 to n do
            write(answer[i,j], ' ');
        writeln;
    end;

    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
