{$APPTYPE CONSOLE}
{:   
 :  ()}

{:  ,      - 1,
             - ?    ,         ?}
type
  tpoint =              {   }
    record
      x, y: integer;
    end;
  {}
  tedge =               { -  }
    record
      v1, v2: tpoint;
    end;
{}
function max( a, b: integer ): integer; {}
begin
  max := a;
  if ( b > a ) then
    max := b;
end;
{}
function min( a, b: integer ): integer; {}
begin
  min := a;
  if ( b < a ) then
    min := b;
end;
{}
{,       a  b,      c}
function intersect( a, b: tedge; var c: tedge ): boolean; 
var
  horizontal_a, horizontal_b, vertical_a, vertical_b: boolean; {  / }
  left, right, up, bottom: integer; {   }
begin
  {    }
  if ( a.v1.x = a.v2.x ) then vertical_a := true else vertical_a := false;
  if ( b.v1.x = b.v2.x ) then vertical_b := true else vertical_b := false;
  if ( a.v1.y = a.v2.y ) then horizontal_a := true else horizontal_a := false;
  if ( b.v1.y = b.v2.y ) then horizontal_b := true else horizontal_b := false;
  {}
  if ( vertical_a ) and ( vertical_b ) then {   }
    begin
      if ( a.v1.x <> b.v1.x ) then {    -  }
        begin
          intersect := false;
          exit;
        end;
      {}
      up := min( max( a.v1.y, a.v2.y ), max( b.v1.y, b.v2.y ) );    {    }
      bottom := max( min( a.v1.y, a.v2.y ), min( b.v1.y, b.v2.y ) );
      {}
      if ( up < bottom ) then {   -  }
        begin
          intersect := false;
          exit;
        end;
      {}
      intersect := true; { ,    }
      {}
      c.v1.x := a.v1.x;      c.v1.y := up;
      c.v2.x := a.v1.x;      c.v2.y := bottom;
      {}
      exit;
    end;
  {}
  if ( horizontal_a ) and ( horizontal_b ) then {   }
    begin
      if ( a.v1.y <> b.v1.y ) then { Y   -  }
        begin
          intersect := false;
          exit;
        end;
      {}
      right := min( max( a.v1.x, a.v2.x ), max( b.v1.x, b.v2.x ) ); {    }
      left := max( min( a.v1.x, a.v2.x ), min( b.v1.x, b.v2.x ) );
      {}
      if ( right < left ) then {   -  }
        begin
          intersect := false;
          exit;
        end;
      {}
      intersect := true; { ,    }
      {}
      c.v1.x := left;        c.v1.y := a.v1.y;
      c.v2.x := right;       c.v2.y := a.v1.y;
      {}
      exit;
    end;
  {}
  if ( vertical_a ) then {  ,  B -  }
    begin
      { }
      if ( min( b.v1.x, b.v2.x ) <= a.v1.x ) and ( a.v1.x <= max( b.v1.x, b.v2.x ) ) and ( min( a.v1.y, a.v2.y ) <= b.v1.y ) and ( b.v1.y <= max( a.v1.y, a.v2.y ) ) then
        begin
          intersect := true;  { -  }
          c.v1.x := a.v1.x;  c.v1.y := b.v1.y;
          c.v2.x := a.v1.x;  c.v2.y := b.v1.y;
          exit;
        end
      else
        begin
          intersect := false;
          exit;
        end;
    end;
  {}
  if ( vertical_b ) then {A -  ,  B - }
    begin
      { }
      if ( min( a.v1.x, a.v2.x ) <= b.v1.x ) and ( b.v1.x <= max( a.v1.x, a.v2.x ) ) and ( min( b.v1.y, b.v2.y ) <= a.v1.y ) and ( a.v1.y <= max( b.v1.y, b.v2.y ) ) then
        begin
          intersect := true;  { -  }
          c.v1.x := b.v1.x;  c.v1.y := a.v1.y;
          c.v2.x := b.v1.x;  c.v2.y := a.v1.y;
          exit;
        end
      else
        begin
          intersect := false;
          exit;
        end;
    end;
  {}
  intersect := false; {   -   -   }
end;
{}
var
  edges: array[0..1, 1..10] of tedge; { }
  esize: array[0..1] of integer;       {   }
  n, i, j, x1, y1, x2, y2: integer;    
  cnt, cur, next: integer;             {        }
  res, curedge: tedge;                 
{}
{     }
procedure add_edge( x1, y1, x2, y2: integer; c: integer ); 
begin
  inc( esize[c] );
  edges[c, esize[c]].v1.x := x1;
  edges[c, esize[c]].v1.y := y1;
  edges[c, esize[c]].v2.x := x2;
  edges[c, esize[c]].v2.y := y2;
end;
{}
{    }
function weight( x: tedge ): integer;
begin
  weight := max( x.v1.x, x.v2.x ) - min( x.v1.x, x.v2.x ) + max( x.v1.y, x.v2.y ) - min( x.v1.y, x.v2.y ) + 1;
end;
{}
begin 
  assign( input, 'buses.in' ); reset( input );         { }
  assign( output, 'buses.out' ); rewrite( output );
  {}
  fillchar( esize, sizeof( esize ), 0 );               {  }
  {}
  read( n ); {  }
  {}
  cur := 0; next := 1; {   }
  {}
  read( x1, y1, x2, y2 ); {  }
  {  "",        }
  add_edge( min( x1, x2 ), min( y1, y2 ), min( x1, x2 ), max( y1, y2 ) - 1, cur ); 
  add_edge( min( x1, x2 ), max( y1, y2 ), max( x1, x2 ) - 1, max( y1, y2 ), cur );
  add_edge( max( x1, x2 ), min( y1, y2 ) + 1, max( x1, x2 ), max( y1, y2 ), cur );
  add_edge( min( x1, x2 ) + 1, min( y1, y2 ), max( x1, x2 ), min( y1, y2 ), cur );
  {}
  for i := 2 to n do
    begin
      esize[next] := 0;   {     }
      {}
      read( x1, y1, x2, y2 ); {  }
      {}
      curedge.v1.x := min( x1, x2 ) + 1; curedge.v1.y := min( y1, y2 ); {      }
      curedge.v2.x := max( x1, x2 ); curedge.v2.y := min( y1, y2 );
      for j := 1 to esize[cur] do
        begin
          if ( intersect( curedge, edges[cur, j], res ) ) then
            add_edge( res.v1.x, res.v1.y, res.v2.x, res.v2.y, next );
        end;
      {}
      curedge.v1.x := min( x1, x2 ); curedge.v1.y := min( y1, y2 );     {      }
      curedge.v2.x := min( x1, x2 ); curedge.v2.y := max( y1, y2 ) - 1;
      for j := 1 to esize[cur] do
        begin
          if ( intersect( curedge, edges[cur, j], res ) ) then
            add_edge( res.v1.x, res.v1.y, res.v2.x, res.v2.y, next );   
        end;
      {}
      curedge.v1.x := min( x1, x2 ); curedge.v1.y := max( y1, y2 );     {      }
      curedge.v2.x := max( x1, x2 ) - 1; curedge.v2.y := max( y1, y2 ); 
      for j := 1 to esize[cur] do
        begin
          if ( intersect( curedge, edges[cur, j], res ) ) then
            add_edge( res.v1.x, res.v1.y, res.v2.x, res.v2.y, next );
        end;
      {}
      curedge.v1.x := max( x1, x2 ); curedge.v1.y := min( y1, y2 ) + 1; {      }
      curedge.v2.x := max( x1, x2 ); curedge.v2.y := max( y1, y2 );
      for j := 1 to esize[cur] do
        begin
          if ( intersect( curedge, edges[cur, j], res ) ) then
            add_edge( res.v1.x, res.v1.y, res.v2.x, res.v2.y, next );
        end;
      {}
      cur := next;      {   }
      next := 1 - next;
    end;
  {}
  cnt := 0; {       ( }
  for i := 1 to esize[cur] do
    inc( cnt, weight( edges[cur, i] ) );
  {}
  writeln( cnt ); {  }
end.