{$APPTYPE CONSOLE}
{:   
 :  ()}

{:    ?}
{       ?   T + L  T + L - 1?}
type
  theap = { - }
    object
      heap: array[1..50000] of integer;
      size: integer;
      {}
      procedure init;
      function extract_min: integer;  { }
      function peek_min: integer;     {"" }
      procedure add( x: integer );    {   }
      {}
      procedure up( x: integer );     {     }
      procedure down( x: integer );   {     }
      {}
    end;
{}
procedure theap.init;
begin
  size := 0;
  fillchar( heap, sizeof( heap ), 0 );
end;
{}
function theap.extract_min: integer;
begin
  extract_min := heap[1];
  heap[1] := heap[size];
  heap[size] := 0;
  dec( size );
  down( 1 );
end;
{}
function theap.peek_min: integer;
begin
  if ( size = 0 ) then
    peek_min := 1000000000
  else
    peek_min := heap[1];
end;
{}
procedure theap.down( x: integer );
var
  t, li, ri, mini, minv: integer;
begin
  mini := x; minv := heap[x];
  {}
  li := x shl 1; ri := li + 1;
  {}
  if ( li <= size ) and ( li > 0 ) then
    if ( heap[li] < minv ) then
      begin
        minv := heap[li];
        mini := li;
      end;
  {}
  if ( ri <= size ) and ( ri > 0 ) then
    if ( heap[ri] < minv ) then
      begin
{        minv := heap[ri];}
        mini := ri;
      end;
  {}
  if ( mini <> x ) then
    begin
      t := heap[x]; heap[x] := heap[mini]; heap[mini] := t;
      down( mini );
    end;
end;
{}
procedure theap.up( x: integer );
var
  p, ind, v: integer;
begin
  ind := x; v := heap[ind]; p := x shr 1;
  while ( p > 0 ) do
    begin
      if ( heap[p] > heap[x] ) then
        begin
          ind := p;
          heap[x] := heap[p];
          heap[p] := v;
        end
      else
        break;
      {}
      p := ind shr 1;
    end;
end;
{}
procedure theap.add( x: integer );
begin
  inc( size );
  heap[size] := x;
  up( size );
end;
{}
type
  tedge = 
    record
      t, l: integer;
    end;
{}
var
  curend, max, i, n: integer;  { ,     }
  e: array[1..50000] of tedge; { }
  h: theap;                    {}
{}
procedure qsort( l, r: integer ); {   }
var
  c, i, j: integer;
  t, x: tedge;
begin
  if ( l >= r ) then
    exit;
  {}
  c := l + random( r - l + 1 );
  x := e[c]; e[c] := e[l]; e[l] := x;
  {}
  i := l - 1; j := r + 1;
  while true do
    begin
      repeat inc( i ) until ( x.t < e[i].t ) or ( ( x.t = e[i].t ) and ( x.l <= e[i].l ) );
      repeat dec( j ) until ( x.t > e[j].t ) or ( ( x.t = e[j].t ) and ( x.l >= e[j].l ) );
      {}
      if ( i < j ) then
        begin
          t := e[i]; e[i] := e[j]; e[j] := t;
        end
      else
        break;
    end;
  {}
  qsort( l, j );
  qsort( j + 1, r );
end;
{}
begin
  assign( input, 'customs.in' ); reset( input );
  assign( output, 'customs.out' ); rewrite( output );
  {}
  read( n ); { }
  for i := 1 to n do
    read( e[i].t, e[i].l );
  {}
  qsort( 1, n ); {    ,     }
  h.init;        { }
  {}
  max := 0;  {   }
  {}
  for i := 1 to n do
    begin
      h.add( e[i].t + e[i].l - 1 ); {    }
      {}
      while true do  
        begin
          curend := h.peek_min;     {  ,     }
          if ( curend < e[i].t ) then
            h.extract_min
          else
            break;
        end;
      {}
      if ( h.size > max ) then      {     }
        max := h.size;
    end;
  {}
  writeln( max ); {  }
end.