{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
program macro;
uses testjury;
const MaxN=50;
      MaxM=300;
      dxs:array[0..7] of integer=(-1, -1, -1,  0,  0,  1,  1,  1);
      dys:array[0..7] of integer=(-1,  0,  1, -1,  1, -1,  0,  1);

      _dl=$01;
      _l =$02;
      _ul=$04;
      _d =$08;
      _u =$10;
      _dr=$20;
      _r =$40;
      _ur=$80;
      _bl=_dl or _l or _ul;
      _bu=_ul or _u or _ur;
      _br=_dr or _r or _ur;
      _bd=_dr or _d or _dl;

type tarr=array [1..2, 1..Maxn, boolean] of integer;
     parr=^tarr;
label sk1, sk2, o0, o1;
var b:array [0..3, 0..MaxN+1] of byte; (* cut/censored *)
    res, n, m, i, j, k, l, nx, ny, x, y, mn, tmp, qx, qy, kx, ky:integer;
    x1, y1, x2, y2, dp:integer;
    a:array [1..2, 1..MaxN] of parr;
    nadoelo, hewon, hadmoves:boolean;
    c:char;
begin
  ci ('queen.in'); ao ('queen.out');
  fillchar (b, sizeof (b), 0);
  noeoln; n:=getintr (2, MaxN); noeoln; m:=getintr (0, MaxM); reql (Reject);
  for i:=1 to m do
    begin
      x1:=getintr (1, 2); y1:=getintr (1, n); x2:=getintr (1, 2);
      y2:=getintr (1, n); reql (Reject);
      test (abs (x2-x1)+abs(y2-y1)=1);
      if x2=x1 then begin
        if y1>y2 then begin tmp:=y1; y1:=y2; y2:=tmp end;
        b[x1, y1]:=b[x1, y1] or _bu;
        b[x1, y2]:=b[x1, y2] or _bd;
        b[x1-1, y1]:=b[x1-1, y1] or _ur;
        b[x1-1, y2]:=b[x1-1, y2] or _dr;
        b[x1+1, y1]:=b[x1+1, y1] or _ul;
        b[x1+1, y2]:=b[x1+1, y2] or _dl;
      end else begin
        if x1>x2 then begin tmp:=x1; x1:=x2; x2:=tmp end;
        b[x1, y1]:=b[x1, y1] or _br;
        b[x2, y1]:=b[x2, y1] or _bl;
        b[x1, y1-1]:=b[x1, y1-1] or _ur;
        b[x2, y1-1]:=b[x2, y1-1] or _ul;
        b[x1, y1+1]:=b[x1, y1+1] or _dr;
        b[x2, y1+1]:=b[x2, y1+1] or _dl;
      end;
    end;
  reqeof;
  for i:=1 to n do begin
    b[1, i]:=b[1, i] or _bl;
    b[2, i]:=b[2, i] or _br;
  end;
  for i:=1 to 2 do begin
    b[i, 1]:=b[i, 1] or _bd;
    b[i, n]:=b[i, n] or _bu;
  end;
  for i:=1 to 2 do
    for j:=1 to n do begin
      new (a[i, j]);
      fillchar (a[i, j]^, sizeof (a[i, j]^), 0);
    end;
  (* lets analyze *)
  for i:=1 to 2 do
    for j:=1 to n do
      begin
        a[i, j]^[i, j, false]:=-1;
        a[i, j]^[i, j, true]:=1;
      end;
  mn:=1;
  repeat
    nadoelo:=true;
    for i:=1 to 2 do
      for j:=1 to n do
        for k:=1 to 2 do
          for l:=1 to n do
            begin
              if a[i, j]^[k, l, false]=0 then
                begin
//                  if (i=2) and (j=2) and (k=1) and (l=1) then asm int 3 end;
                  hewon:=true; hadmoves:=false;
                  for dp:=0 to 7 do begin
                    nx:=i; ny:=j;
                    while (b[nx, ny] and (1 shl dp))=0 do begin
                      inc (nx, dxs[dp]);
                      inc (ny, dys[dp]);
                      hadmoves:=true;
                      tmp:=a[nx, ny]^[k, l, true];
                      if (tmp>0) and (tmp<=mn) then
                        begin
                          a[i, j]^[k, l, false]:=mn+1;
                          nadoelo:=false;
                          goto sk1;
                        end;
                      if (tmp>=0) or (tmp=-mn-1)
                        then hewon:=false;
                    end;
                  end;
                  if not hadmoves then begin
                    a[i,j]^[k,l,false]:=-1;
                    nadoelo:=false
                  end else
                  if hewon then begin
                    a[i, j]^[k, l, false]:=-mn-1;
                    nadoelo:=false;
                  end;
                  sk1:
                end;
              end;
    for i:=1 to 2 do
      for j:=1 to n do
        for k:=1 to 2 do
          for l:=1 to n do
            begin
              if a[i, j]^[k, l, true]=0 then
                begin
                  hewon:=true; hadmoves:=false;
                  for dp:=0 to 7 do if (b[k, l] and (1 shl dp))=0 then begin
                    nx:=k+dxs[dp];
                    ny:=l+dys[dp];
                    hadmoves:=true;
                    tmp:=a[i, j]^[nx, ny, false];
                    if (tmp<0) and (tmp>=-mn) then
                      begin
                        a[i, j]^[k, l, true]:=-mn-1;
                        nadoelo:=false;
                        goto sk2;
                      end;
                    if (tmp<=0) or (tmp=mn+1)
                      then hewon:=false;
                  end;
                  if not hadmoves then begin
                    nadoelo:=false;
                    a[i, j]^[k, l, true]:=-1
                  end else
                  if hewon then begin
                    nadoelo:=false;
                    a[i, j]^[k, l, true]:=mn+1;
                  end;
                  sk2:
                end;
            end;
    inc (mn);
  until nadoelo;
  if a[2, n]^[1, 1, true]=2 then a[2, n]^[1, 1, true]:=4;
  if a[2, n]^[1, 1, true]=-2 then a[2, n]^[1, 1, true]:=-4;
  if a[2, n]^[1, 1, true]=0 then writeln ('draw')
  else
  if a[2, n]^[1, 1, true]>0 then writeln ('queen wins'#13#10, a[2, n]^[1, 1, true]-3)
  else
  writeln ('king wins'#13#10, -a[2, n]^[1, 1, true]-3);{
  read (qx, qy, kx, ky);
  if seekeoln then runerror (239);
  read (c);
  if not seekeof then runerror (239);
  case c of
    'Q':res:=a[qx, qy, kx, ky, false];
    'K':res:=a[qx, qy, kx, ky, true];
    else runerror (239);
  end;
  if not b[qx, qy] or not b[kx, ky] then runerror (239);
  if res=0 then writeln ('The game will end in a draw')
  else
  if res<0 then writeln ('King wins in ', -res-3, ' moves.')
  else
  writeln ('Queen wins in ', res-3, ' moves');}
  (* debug out *)
  (*res:=a[2, n]^[1, 1, true];
  if res=0 then halt;
  c:='K'; qx:=2; qy:=n; kx:=1; ky:=1;
  while abs (res)>1 do
    begin
      if c='Q' then
        begin
          for dp:=0 to 7 do begin
            nx:=qx; ny:=qy;
            while (b[nx, ny] and (1 shl dp))=0 do begin
              inc (nx, dxs[dp]);
              inc (ny, dys[dp]);
              if res<0 then
                if a[nx, ny]^[kx, ky, true]=res+1 then goto o0;
              if res>0 then
                if a[nx, ny]^[kx, ky, true]=res-1 then goto o0;
            end;
          end;
          o0:
          writeln ('Q', chr (qx+96), qy, '-', chr (nx+96), ny);
          qx:=nx; qy:=ny; c:='K'; res:=a[nx, ny]^[kx, ky, true];
        end
      else
        begin
          for dp:=0 to 7 do if (b[kx, ky] and (1 shl dp))=0 then begin
            nx:=kx+dxs[dp];
            ny:=ky+dys[dp];
            if res<0 then
              if a[qx, qy]^[nx, ny, false]=res+1 then goto o1;
            if res>0 then
              if a[qx, qy]^[nx, ny, false]=res-1 then goto o1;
          end;
          o1:
          writeln ('K', chr (kx+96), ky, '-', chr (nx+96), ny);
          kx:=nx; ky:=ny; c:='Q'; res:=a[qx, qy]^[kx, ky, false];
        end;
    end;*)
end.