{$R-,Q-,S-,E-,N+,O+,I-}
{$apptype console}

const
      cInFile='japan.in';
      cOutFile='japan.out';

      maxn = 200;

type int=integer;
     real=extended;

     TLine = array[0..maxn] of int;
     TField = array[1..maxn] of byte;
     TPair = record
       sum,nom:int;
     end;

var
  n,m:int;
  Hor,Ver:array[1..maxn] of TLine;
  Field,Cur:array[1..maxn] of TField;

  List:array[1..maxn] of TPair;

procedure ReadData;
var
  i,j,ch:int;
begin
  assign(input,cInFile);reset(input);
  Fillchar(Hor,SizeOf(Hor),0);
  Fillchar(Ver,SizeOf(Ver),0);
  Readln(n,m);
  for i:=1 to n do
  begin
    while not SeekEoln do
    begin
      read(ch);
      if ch<=0 then continue;
      inc(Hor[i][0]);
      Hor[i][Hor[i][0]]:=ch;
    end;
    readln;
  end;
  for i:=1 to m do
  begin
    while not SeekEoln do
    begin
      read(ch);
      if ch<=0 then continue;
      inc(Ver[i][0]);
      Ver[i][Ver[i][0]]:=ch;
    end;
    readln;
  end;
  close(input);
end;

Function SolveLine(m:int; Hor:TLine; var Field:TField):boolean;

// m - Length,  Hor - array of segment's lines, Field - the line from the field

var
  i,j,na,ko,k,l,last:int;
  t:array[0..maxn,0..maxn] of byte;
  black:array[1..maxn] of byte;
  flag,yes:boolean;
  ll:array[1..maxn+1] of int;
  calc:array[1..maxn] of int;
  used:array[1..maxn,1..maxn] of boolean;

  procedure Rec(p,q:int);
  var
    i,na,ko:int;
  begin
    if (p>=Hor[0])or used[p,q] then
    begin
      last:=1;
      if not used[p,q] then ko:=Hor[0]+1 else ko:=p;
      for i:=1 to ko do
      begin
        Fillchar(black[last],sizeof(black[1])*(ll[i]-last),1);
        last:=ll[i]+Hor[i];
      end;
      used[p,q]:=true;
      exit;
    end;
    used[p,q]:=true;
    na:=q+Hor[p]+1;
    ko:=m-Hor[p+1]+1;
    for i:=na to ko do
    begin
      if t[p+1,i] = 2 then
      begin
        ll[p+1]:=i;
        Rec(p+1,i);
      end;
      if Field[i] = 2 then break;
    end;
  end;

begin
  Result:=true;

  Fillchar(calc,sizeof(calc),0);
  calc[m]:=Ord(Field[m]<>1);
  for i:=m-1 downto 1 do
    if Field[i]<>1 then calc[i]:=calc[i+1]+1;

  Fillchar(t,SizeOf(t),0);
  t[0,0]:=1;
  for i:=0 to Hor[0]-1 do
  begin
    if i = 0 then ko:=0 else ko:=m-Hor[i]+1;
    for j:=0 to ko do if t[i,j] = 1 then
    begin
      if i<>0 then na:=j+Hor[i]+1 else na:=1;
      for k:=na to m-Hor[i+1]+1 do
      begin
        flag:=(calc[k]>=Hor[i+1]);
        if flag and (k+Hor[i+1]<=m) and (Field[k+Hor[i+1]]=2) then flag:=false;
        if flag then t[i+1,k]:=1;
        if Field[k] = 2 then break;
      end;
    end;
  end;

  yes:=false;
  for i:=1 to m do if t[Hor[0],i] = 1 then
  begin
    flag:=true;
    for j:=i+Hor[Hor[0]] to m do
      if Field[j] = 2 then
      begin
        flag:=false;
        break;
      end;
    if flag then
    begin
      t[Hor[0],i]:=2;
      yes:=true;
    end;
  end;

  if not yes then
  begin
    Result:=false;
    exit;
  end;

  for i:=Hor[0]-1 downto 1 do
    for j:=1 to m-Hor[i]+1 do if t[i,j] = 1 then
      for k:=j+1+Hor[i] to m-Hor[i+1]+1 do
      begin
        if t[i+1,k] = 2 then
        begin
          t[i,j]:=2;
          break;
        end;
        if Field[k] = 2 then break;
      end;  

  Fillchar(black,SizeOf(black),0);
  for i:=1 to Hor[0] do
    for j:=1 to m-Hor[i]+1 do if t[i,j] = 2 then
      Fillchar(black[j],Sizeof(black[1])*Hor[i],1);
  for i:=1 to m do if black[i] = 0 then Field[i]:=1;

  fillchar(black,sizeof(black),0);
  fillchar(used,sizeof(used),0);
  ll[Hor[0]+1]:=m+1;
  for i:=1 to m do if t[1,i] = 2 then
  begin
    ll[1]:=i;
    Rec(1,i);
  end;

  for i:=1 to m do if black[i] = 0 then Field[i]:=2;
end;

function ConvertHor(nom:int):boolean;
begin
  ConvertHor:=SolveLine(m,Hor[nom],Field[nom]);
end;

function ConvertVer(nom:int):boolean;
var
  f:TField;
  i:int;
begin
  for i:=1 to n do f[i]:=Field[i,nom];
  ConvertVer:=SolveLine(n,Ver[nom],f);
  for i:=1 to n do Field[i,nom]:=f[i];
end;

procedure OutData;
var
  i,j:int;
begin
  assign(output,cOutFile);
  rewrite(output); 
//  append(output);
  for i:=1 to n do
  begin
    for j:=1 to m do if Field[i,j] = 2 then write('*') else write('.');
    writeln; 
  end;
//  writeln;
  close(output);
end;

procedure HeapSort(var n:int);
var
  l,r:int; x:TPair;
  procedure sisp(l,r:int);
  var
    i,j:int;
  begin
    i:=l; j:=2*l; x:=List[l];
    if (j<r)and(List[j].sum>List[j+1].sum) then inc(j);
    while (j<=r)and(x.sum>List[j].sum) do
    begin
      List[i]:=List[j];
      i:=j; j:=2*j;
      if (j<r)and(List[j].sum>List[j+1].sum) then inc(j);
    end;
    List[i]:=x;
  end;
begin
  l:=n shr 1 +1; r:=n;
  while l>1 do
  begin
    dec(l); sisp(l,r);
  end;
  l:=1;
  while r>1 do
  begin
    x:=List[l]; List[l]:=List[r]; List[r]:=x;
    dec(r); sisp(l,r);
  end;
end;

procedure SortHor;
var
  i,j,sum:int;
begin
  for i:=1 to n do
  begin
    sum:=0;
    for j:=1 to Hor[i][0] do inc(sum,Hor[i][j]);
    for j:=1 to m do if Field[i,j] = 2 then dec(sum);
    List[i].sum:=sum;
    List[i].nom:=i;
  end;
  //HeapSort(n);
end;

procedure SortVer;
var
  i,j,sum:int;
begin
  for j:=1 to m do
  begin
    sum:=0;
    for i:=1 to Ver[j][0] do inc(sum,Ver[j][i]);
    for i:=1 to n do if Field[i,j] = 2 then dec(sum);
    List[j].sum:=sum;
    List[j].nom:=j;
  end;
  //HeapSort(m);
end;

procedure Solve;
var
  i,j:int;
  done,change:boolean;
begin
  while true do
  begin
  
    done:=true;
    Cur:=Field;

    SortHor;
    for i:=1 to n do
      ConvertHor(List[i].nom);
    SortVer;
    for i:=1 to m do
      ConvertVer(List[i].nom);

    change:=false;
    for i:=1 to n do 
      for j:=1 to m do
      begin
        if Field[i,j] = 0 then done:=false;
        if Cur[i,j]<>Field[i,j] then Change:=true;
      end;
      
    if done or not change then break;

  end;
end;

begin
  ReadData;
  Solve;
  OutData;
end.
