{$I+,Q+,R+}
program macro;
const MaxK=8;  MaxN=2000000000;  M=500000;  L=1260;

var
  A, B  : array [0..M] of integer;
  CU    : array [0..L] of integer;
  S     : array [1..MaxK] of integer;
  SP    : integer;

function rec (k, x : integer) : boolean;
var i, j, y : integer;
begin
  Result := false;
  if x <= M then begin
    if A[x] > k then exit;
    while x > 0 do begin
      y := B[x];  dec (x, CU[y]);  inc(SP);  S[SP] := y end;
    for i := 1 to SP - 1 do write (S[i], ' ');
    writeln (S[SP]);
    Result := true;  exit end;
  i := 0;  j := L;
  repeat
    y := (i + j) shr 1;
    if CU[y] <= x then i := y else j := y
  until j = i + 1;
  inc (SP);
  while i > 0 do begin
    S[SP] := i;
    if rec (k - 1, x - CU[i]) then begin Result := true; exit end;
    dec (i)
  end
end;

var x, y, z, t : integer;
begin
  for x := 0 to L do CU[x] := x*x*x;
  for x := 1 to M do begin
    y := 0;  t := 255;
    repeat
      inc (y);  z := x - CU[y];  if z < 0 then break;
      if A[z] + 1 < t then begin t := A[z] + 1;  B[x] := y end
    until false;
    A[x] := t
  end;
  assign (input, 'sumcubes.in');  reset (input);
  assign (output, 'sumcubes.out');  rewrite (output);
  repeat
    read (x);  assert ((x > 0) and (x <= MaxN));
    SP := 0;
    if not rec (MaxK, x) then writeln ('IMPOSSIBLE');
  until seekeof
end.
