{$I+,Q+,R+,O-}
program macro;
var
  S : string;
  P : integer;
  G : array [0..25, 0..25] of integer;

function rtree : integer; forward;

function rtree0 : integer;
var T : integer;
begin
  if S[P] = '(' then begin inc (P); rtree0 := rtree;
    assert (S[P] = ')');  inc(P) end
  else if S[P] in ['A'..'Z'] then begin
    T := ord(S[P]) - 65;  inc (P);
    G[T,T] := 0;  rtree0 := T
  end else rtree0 := rtree
end;

function rforest : integer;
var Q : integer;
begin
  if S[P] <> '(' then begin rforest := 1 shl rtree; exit end;
  inc (P);  Q := 1 shl rtree;
  while S[P] = ',' do begin
    inc (P);  Q := Q or (1 shl rtree)
  end;
  assert (S[P] = ')');  inc (P);
  rforest := Q
end;

function rtree : integer;
var T, W, i : integer;
begin
  T := rtree0;
  if S[P] = '-' then begin
    assert (S[P+1] = '>');  inc (P, 2);
    W := rforest;
    for i := 0 to 25 do if odd (W shr i) then
      begin G[i,T] := 1;  G[T,i] := 1 end;
  end;
  rtree := T;
end;

var _, R, i, j, k : integer;
begin
  assign (input, 'dist.in');  reset (input);
  assign (output, 'dist.out');  rewrite (output);
  _ := 0;
  repeat
    if _ > 0 then writeln;  inc (_);
    readln (S);  S := S + #0;  P := 1;
    fillchar (G, sizeof(G), $3f);
    R := rtree;
    for k := 0 to 25 do
      for i := 0 to 25 do
        for j := 0 to 25 do
          if G[i,k]+G[k,j] < G[i,j] then G[i,j] := G[i,k] + G[k,j];
    for i := 0 to 25 do
      if G[R,i] < 100 then writeln (chr(65+i), ' ', G[R,i])
  until seekeof
end.
