{$APPTYPE CONSOLE}
program Macro; {This program is a macrodefinition}
var d : array [1 .. 26, 1 .. 26] of integer;
  curch : char;
procedure match (c : char);
begin
  if curch <> c then runerror (239);
  read (curch);
end;
function gettree : integer; forward;
procedure add (x, y : integer);
begin
  if x <> y then begin d [x, y] := 1; d [y, x] := 1; end;
end;
procedure getrest (r : integer);
var x : integer;
begin
  if curch <> '-' then exit;
  match ('-'); match ('>');
  x := gettree;
  if x > 0 then begin add (r, x); exit; end;
  add (r, - x);
  repeat
    x := gettree;
    if x < 0 then runerror (239);
    add (r, x);
    if curch = ')' then break;
    match (',');
  until false;
  match (')');
end;
function gettree : integer;
var s : integer;
begin
  case curch of
    'A' .. 'Z' : begin
                   result := ord (curch) - ord ('A') + 1;
                   match (curch);
                   getrest (result);
                 end;
    '(' : begin
            match ('(');
            result := gettree;
            if curch = ',' then begin
              match (','); result := - result; exit;
            end;
            match (')');
            getrest (result);
          end
    else runerror (239);
  end;
end;
var root : integer;
  i, j, k : integer;
begin
  assign (input, 'dist.in'); reset (input);
  assign (output, 'dist.out'); rewrite (output);
  for i := 1 to 26 do
    for j := 1 to 26 do
      if i <> j then d [i, j] := 100 else d [i, j] := 0;
  match (curch);
  root := gettree;
  for k := 1 to 26 do
    for i := 1 to 26 do
      for j := 1 to 26 do
        if d [i, k] + d [k, j] < d [i, j] then d [i, j] := d [i, k] + d [k, j];
  for i := 1 to 26 do if d [root, i] < 100
    then writeln (chr (ord ('A') + i - 1), ' ', d [root, i]);
end.
