{$R+,Q+,S+}
Program WhenEverybodyHasLeftYouAndNobodyWantsToGiveYouAHandYouShouldRememberThatArtIsAPerfectFormOfEmotionalRelief;

Type
  Integer=LongInt;

Const
  TaskID='masterpiece';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxSize=66;

Var
  Height,Width,K:Integer;
  ResAm:Integer;
  Pic:Array[1..MaxSize,1..MaxSize]Of Byte;
  Res:Array[1..MaxSize,1..MaxSize]Of Byte;
  Best:Array[1..MaxSize,0..MaxSize,0..MaxSize,0..2]Of ShortInt;
  How:Array[1..MaxSize,0..MaxSize,0..MaxSize,0..2]Of ShortInt;
  Most:Array[1..MaxSize,0..MaxSize]Of ShortInt;
  MostLast:Array[1..MaxSize,0..MaxSize]Of ShortInt;
  AsFor:Array[0..MaxSize,0..MaxSize*MaxSize]Of SmallInt;
  ByFor:Array[0..MaxSize,0..MaxSize*MaxSize]Of ShortInt;

Procedure Load;
Var
  Ch:Char;
  Row,Col:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Assert(Not SeekEOLN);
  Read(Height);
  Assert(Not SeekEOLN);
  Read(Width);
  Assert(Not SeekEOLN);
  Read(K);
  Assert(SeekEOLN);
  ReadLn;
  For Row:=1 To Height Do Begin
    For Col:=1 To Width Do Begin
      Read(Ch);
      Assert((Ch='0') Or (Ch='1'));
      Pic[Row,Col]:=Ord(Ch)-Ord('0');
    End;
    Read(Ch);
    Assert(Ch=#13);
    Read(Ch);
    Assert(Ch=#10);
  End;
  Assert(EOF);
  Close(Input);
End;

Function Min(A,B:Integer):Integer;
Begin
  If A<B Then Min:=A Else Min:=B;
End;

Procedure ProcessRows;
Var
  NBest,CBest,CHow,Row,Col,Am,Last,PLast,NMove,NAdd:Integer;
Begin
  FillChar(Most,SizeOf(Most),0);
  For Row:=1 To Height Do Begin
    FillChar(Best,SizeOf(Best),0);
    For Col:=1 To Width Do
      For Am:=1 To Width Do
        For Last:=0 To 2 Do Begin
          CBest:=0;
          CHow:=-1;
          For PLast:=0 To 2 Do Begin
            If (Last<2) And (Last<>PLast) Then
              NMove:=1
            Else
              NMove:=0;
            If Pic[Row,Col]=Last Then
              NAdd:=1
            Else
              NAdd:=0;
            NBest:=Best[Row,Col-1,Am-NMove,PLast]+NAdd;
            If NBest>CBest Then Begin
              CBest:=NBest;
              CHow:=PLast;
            End;
          End;
          Best[Row,Col,Am,Last]:=CBest;
          How[Row,Col,Am,Last]:=CHow;
        End;
    For Am:=0 To Width Do Begin
      Most[Row,Am]:=0;
      MostLast[Row,Am]:=-1;
      For Last:=0 To 2 Do If Best[Row,Width,Am,Last]>Most[Row,Am] Then Begin
        Most[Row,Am]:=Best[Row,Width,Am,Last];
        MostLast[Row,Am]:=Last;
      End;
    End;
  End;
End;

Procedure CompleteRow(Row,Am:Integer);
Var
  I,NLast,Last:Integer;
Begin
  Last:=MostLast[Row,Am];
  For I:=Width DownTo 1 Do Begin
    If Am=0 Then Break;
    Res[Row,I]:=Last;
    NLast:=How[Row,I,Am,Last];
    If (Last<>NLast) And (Last<2) Then Dec(Am);
    Last:=NLast;
  End;
End;

Procedure Solve;
Var
  Cur,CBy,CMax,Row,I,J:Integer;
Begin
  FillChar(AsFor,SizeOf(AsFor),0);
  For Row:=1 To Height Do
    For I:=0 To Row*Width Do Begin
      CMax:=-1;
      CBy:=-1;
      For J:=0 To Min(I,Width) Do Begin
        Cur:=Most[Row,J]+AsFor[Row-1,I-J];
        If Cur>CMax Then Begin
          CMax:=Cur;
          CBy:=J;
        End;
      End;
      AsFor[Row,I]:=CMax;
      ByFor[Row,I]:=CBy;
    End;

  CMax:=-1;
  CBy:=-1;
  For I:=0 To Min(K,Height*Width) Do If AsFor[Height,I]>CMax Then Begin
    CMax:=AsFor[Height,I];
    CBy:=I;
  End;
  ResAm:=CMax;

  FillChar(Res,SizeOf(Res),2);
  Row:=Height;
  I:=CBy;
  While Row>0 Do Begin
    CompleteRow(Row,ByFor[Row,I]);
    Dec(I,ByFor[Row,I]);
    Dec(Row);
  End;
End;

Procedure Save;
Var
  Row,Col:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Height*Width-ResAm);
  For Row:=1 To Height Do Begin
    For Col:=1 To Width Do Write(Res[Row,Col]);
    WriteLn;
  End;
  Close(Output);
End;

Begin
  Load;
  ProcessRows;
  Solve;
  Save;
End.
