{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='painter.in';
  outfile='painter.out';
  move=20;
  renum = 1 shl move - 1; {1 shl 20 - 1}
  plus = 500001; {500001}
  mm = 1 shl (move+1);
type
  PNode = ^Node;
  Node = record
    x,y : LongInt;
    next,prev : PNode;
  end;
var
  a : array [1..mm] of PNode;
  n,kol,len : LongInt;
  root,last : PNode;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  readln(n);
end;
{}
Procedure Out;
begin
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  assign(output,outfile);
  rewrite(output);
  fillchar(a,sizeof(a),0);
end;
{}
Function Find(i,j : LongInt) : PNode;
var
  p : PNode;
begin
  p:=a[i];
  while (i>1) and (p=nil) do begin
    if not odd(i) then p:=a[i+1];
    i:=i div 2;
  end;
  Find:=p;
end;
{}
Procedure Upgrade(i : LongInt; p : PNode);
var
  j : LongInt;
begin
  a[i]:=p;
  while i>1 do begin
    j:=i div 2;
    if a[2*j]<>nil then a[j]:=a[2*j]
                   else a[j]:=a[2*j+1];
    i:=j;
  end;
end;
{}
Function Delete(var p : PNode) : Boolean;
begin
  Delete:=false;
  Upgrade(p^.x+renum,nil);
  Upgrade(p^.y+renum,nil);
  if p^.next<>nil then begin
    p^.x:=p^.next^.x;
    p^.y:=p^.next^.y;
    if p^.next^.next=nil then last:=p;
    if p^.next^.next<>nil then p^.next^.next^.prev:=p;
    p^.next:=p^.next^.next;
    Upgrade(p^.x+renum,p);
    Upgrade(p^.y+renum,p);
  end else begin
    if p^.prev<>nil then begin
      last:=p^.prev;
      last^.next:=nil;
      p:=nil;
    end else begin
      root:=nil; last:=nil;
      p:=nil;
    end;
    Delete:=true;
  end;
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
  x,y,l : LongInt;
  p,q,w : PNode;
  c1,c2 : LongInt;
  ch : Char;
begin
  kol:=0; len:=0;
  root:=nil; last:=nil;

  for k:=1 to n do begin
    readln(ch,x,l); y:=x+l;
    inc(x,plus); inc(y,plus);

    p:=Find(x+renum,y+renum);

    if p=nil then begin

      if ch='B' then begin
        if last=nil then begin
          new(root); root^.prev:=nil;
          root^.x:=x; root^.y:=y;
          root^.next:=nil; last:=root;
        end else begin
          new(q);
          q^.x:=x; q^.y:=y;
          q^.next:=nil; last^.next:=q;
          q^.prev:=last; last:=q;
        end;
        Upgrade(x+renum,last);
        Upgrade(y+renum,last);
        inc(kol); inc(len,l);
      end;

    end else begin

      if ch='W' then begin
        while p^.x<=y do begin
          if (p^.x>=x) and (p^.y<=y) then begin
            dec(kol); dec(len,p^.y-p^.x);
            if Delete(p) then break;
            if p=nil then break;
          end else
          if (p^.x<x) and (p^.y<=y) then begin
            Upgrade(p^.y+renum,nil);
            dec(len,p^.y-x); p^.y:=x;
            Upgrade(p^.y+renum,p);
            p:=p^.next; if p=nil then break;
          end else
          if (p^.x>=x) and (p^.y>y) then begin
            Upgrade(p^.x+renum,nil);
            dec(len,y-p^.x); p^.x:=y;
            Upgrade(p^.x+renum,p);
            p:=p^.next; if p=nil then break;
          end else begin
            inc(kol); dec(len,l);
            Upgrade(p^.y+renum,nil);
            new(q); q^.x:=y; q^.y:=p^.y;
            q^.next:=p^.next; q^.prev:=p;
            if p^.next<>nil then p^.next^.prev:=q;
            p^.next:=q; p^.y:=x;
            if q^.next=nil then last:=q;
            Upgrade(p^.y+renum,p);
            Upgrade(q^.x+renum,q);
            Upgrade(q^.y+renum,q);
            p:=p^.next; if p=nil then break;
          end;

        end;
      end else begin
        {Black}
        inc(kol); new(w);
        w^.x:=x; w^.y:=y;
        w^.next:=p;
        w^.prev:=p^.prev;
        if p^.prev<>nil then p^.prev^.next:=w
                        else root:=w;
        p^.prev:=w;

        while p^.x<=y do begin
          dec(kol); dec(len,p^.y-p^.x);
          if p^.x<w^.x then w^.x:=p^.x;
          if p^.y>w^.y then w^.y:=p^.y;
          if Delete(p) then break;
          if p=nil then break;
        end;
        Upgrade(w^.x+renum,w);
        Upgrade(w^.y+renum,w);
        inc(len,w^.y-w^.x);
      end;
    end;

    writeln(kol,' ',len);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
