{$I-,Q-,R-,S-}

const
  coutfile = 'painter.out';
  cinfile = 'painter.in';

  list = 1 shl 20;

type
  int = longint;
  real = extended;

  vert = record
           kb, kw, ko : int;
           s, f : boolean;
           lm, rm : int;
         end;

var
  n, k, m : int;
  ans : int;

  tree : array [1..list shl 1] of vert;

procedure outdata;
var
  i, j : int;
begin
  ans:= tree[1].ko;
  if (tree[1].kw <> 0) then inc(ans,ord(tree[1].s)+ord(tree[1].f)) else
    inc(ans);
  write(ans,' ');
  writeln(tree[1].kb);
end;

function min(a, b : int) : int;
begin
  if a < b then min:= a else min:= b;
end;

procedure push(v, l, r, c : int; cl : int);
begin
  if (tree[v].lm > r) or (tree[v].rm < l) then
  begin
    if cl = -1 then exit;
    if cl = 0 then
    begin
      tree[v].kw:= tree[v].rm - tree[v].lm + 1;
      tree[v].kb:= 0; tree[v].ko:= 0;
      tree[v].s:= false; tree[v].f:= false;
    end else
    begin
      tree[v].kb:= tree[v].rm - tree[v].lm + 1;
      tree[v].kw:= 0; tree[v].ko:= 0;
      tree[v].s:= true; tree[v].f:= true;
    end;
    exit;
  end;
  if cl = -1 then
  begin
    if tree[v].kw = 0 then cl:= 1;
    if tree[v].kb = 0 then cl:= 0;
  end;
  if (tree[v].lm >= l) and (tree[v].rm <= r) then
  begin
    if c = 0 then
    begin
      tree[v].kw:= tree[v].rm - tree[v].lm + 1;
      tree[v].kb:= 0; tree[v].ko:= 0;
      tree[v].s:= false; tree[v].f:= false;
    end else
    begin
      tree[v].kb:= tree[v].rm - tree[v].lm + 1;
      tree[v].kw:= 0; tree[v].ko:= 0;
      tree[v].s:= true; tree[v].f:= true;
    end;
  end else
  begin
    push(v shl 1, l, r, c,cl);
    push(v shl 1 + 1, l, r, c,cl);
    tree[v].s:= tree[v shl 1].s;
    tree[v].f:= tree[v shl 1 + 1].f;
    tree[v].kw:= tree[v shl 1].kw + tree[v shl 1 + 1].kw;
    tree[v].kb:= tree[v shl 1].kb + tree[v shl 1 + 1].kb;
    tree[v].ko:= tree[v shl 1].ko + tree[v shl 1 + 1].ko;
    if tree[v].kw = 0 then exit;
    if (tree[v shl 1].kw = 0) or (tree[v shl 1 + 1].kw = 0) then exit;
    if tree[v shl 1].f or tree[v shl 1 + 1].s then inc(tree[v].ko);
  end;
end;

procedure solve;
var
  i, j : int;
  xs, le : int;
  col : char;
begin
  readln(col,xs,le);
  if col = 'W' then push(1, xs+500001,xs+500001+le-1,0,-1) else
      push(1, xs+500001,xs+500001+le-1,1,-1);
  outdata;
end;

procedure init;
var
  i : int;
begin
  fillchar(tree,sizeof(tree),0);
  for i:= list to list shl 1 do
  begin
    tree[i].lm:= i-list + 1; tree[i].rm:= i-list + 1;
    tree[i].kw:= 1;
  end;
  for i:= list-1 downto 1 do
  begin
    tree[i].lm:= tree[i shl 1].lm; tree[i].rm:= tree[i shl 1 + 1].rm;
    tree[i].kw:= tree[i shl 1].kw + tree[i shl 1 + 1].kw;
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  init;
  readln(n);
  for i:= 1 to n do solve;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  close(input);
  close(output);
end.
