{$I-,Q-,R-,S-}

const
  coutfile = 'octagons.out';
  cinfile = 'octagons.in';

  eps = 1e-8;

type
  int = longint;
  real = extended;

  point = record
            x, y : real;
          end;

  line = record
            a, b, c : real;
          end;

  oct = array [1..8] of point;

var
  n, k, m : int;
  ans : int;

  a : array [1..500] of oct;

  kw : int;
  o : array [1..5000,0..2] of int;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
end;

procedure cross(x : int; var w : int);
var
  i : int;
  p1, p2 : point;
  l : line;
  minx, maxx : real;
  k : int;
  y : array [1..2] of reAL;
  e : real;
begin
  k:= 0;
  for i:= 1 to 8 do
  begin
    p1:= a[w,i];
    p2:= a[w,i mod 8 + 1];
    l.a:= p1.y-p2.y;
    l.b:= p2.x-p1.x;
    l.c:= -(l.a*p1.x+l.b*p1.y);
    minx:= p1.x; maxx:= p1.x;
    if minx > p2.x then minx:= p2.x;
    if maxx < p2.x then maxx:= p2.x;
    if (minx > x + eps) or (maxx < x - eps) then continue;
    if abs(l.b) > eps then
    begin
      inc(k);
      y[k]:= (l.a*x +l.c)/l.b;
    end else
    begin
      inc(k);
      y[k]:= p1.y;
      inc(k);
      y[k]:= p2.y;
      break;
    end;
  end;
  if y[1] > y[2] then
  begin
    e:= y[1];
    y[1]:= y[2];
    y[2]:= e;
  end;
  y[1]:= trunc(y[1]+10000-eps)-10000+1;
  y[2]:= trunc(y[2]+10000)-10000;
  inc(kw);
  o[kw,1]:= round(y[1]);
  o[kw,2]:= round(y[2]);
end;

procedure sort;
var
  i, j : int;
  x : int;
begin
  for i:= 1 to kw-1 do
    for j:= i+1 to kw do
      if o[i,1] > o[j,1] then
      begin
        x:= o[i,1];
        o[i,1]:= o[j,1];
        o[j,1]:= x;
        x:= o[i,2];
        o[i,2]:= o[j,2];
        o[j,2]:= x;
      end;
end;

procedure solve;
var
  i, j : int;
  c : int;
  q : int;
  l, r : int;
  er : int;
begin
  ans:= 0;
  for i:= -4000 to 4000 do
  begin
    kw:= 0;
    for j:= 1 to n do cross(i,j);
    sort;
    for j:= o[1,1] to 4000 do
    begin
      er:= 0;
      for q:= 1 to kw do
        if (j >= o[q,1])  and (j <= o[q,2]) then inc(er);
      if er >= k then inc(ans);
    end;
  end;
end;

procedure pov(var p : point; u : real);
var
  z : point;
begin
  z.x:= p.x*cos(u)-p.y*sin(u);
  z.y:= p.x*sin(u)+p.y*cos(u);
  p:= z;
end;

procedure readdata;
var
  i, j : int;
  x, y, r : real;
begin
  read(n);
  for i:= 1 to n do
  begin
    read(x,y,r);
    a[i,1].x:= 0;
    a[i,1].y:= r;
    for j:= 2 to 8 do
    begin
      a[i,j]:= a[i,j-1];
      pov(a[i,j],pi/8);
    end;
    for j:= 1 to 8 do
    begin
      a[i,j].x:= a[i,j].x + x;
      a[i,j].y:= a[i,j].x + y;
    end;
  end;
  read(k);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
