{$I-,Q-,R-,S-}
type tevent=record
       x,p,m:longint;
     end;
var n,i,npts,j,nevents,hsize,k,cnt,len:longint;
    color:array [0..100000] of char;
    start,finish,s,f,heap:array [0..100000] of longint;
    p,segment,hpos:array [0..200010] of longint;
    event:array [1..200010] of tevent;
    tcvet:array [0..200010] of char;
procedure qsort(l,r:longint);
var i,j,m,t:longint;
begin
  i:=l;
  j:=r;
  m:=p[l+random(r-l+1)];
  repeat
    while p[i]<m do
      inc(i);
    while p[j]>m do
      dec(j);
    if i<=j then
    begin
      t:=p[i];
      p[i]:=p[j];
      p[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;
function smaller(a,b:tevent):boolean;
begin
  smaller:=(a.x<b.x) or (a.x=b.x) and (a.m<b.m);
end;
procedure qsorte(l,r:longint);
var i,j:longint;
    m,t:tevent;
begin
  i:=l;
  j:=r;
  m:=event[(l+r) shr 1];
  repeat
    while smaller(event[i],m) do
      inc(i);
    while smaller(m,event[j]) do
      dec(j);
    if i<=j then
    begin
      t:=event[i];
      event[i]:=event[j];
      event[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsorte(l,j);
  if i<r then
    qsorte(i,r);
end;
function getnum(x:longint):longint;
var l,r,m:longint;
begin
  l:=0;
  r:=npts+1;
  while r-l>1 do
  begin
    m:=(l+r) shr 1;
    if p[m]<x then
      l:=m
    else r:=m;
  end;
  getnum:=r;
end;
procedure swapex(var a,b:longint);
var t:longint;
begin
  t:=a;
  a:=b;
  b:=t;
end;
procedure swap(i,j:longint);
begin
  swapex(heap[i],heap[j]);
  swapex(hpos[heap[i]],hpos[heap[j]]);
end;
function join(x:longint):longint;
var cur:longint;
begin
  inc(hsize);
  heap[hsize]:=x;
  hpos[x]:=hsize;
  cur:=hsize;
  while (cur<>1) and (heap[cur shr 1]<heap[cur]) do
  begin
    swap(cur,cur shr 1);
    cur:=cur shr 1;
  end;
end;
procedure deckey(x,k:longint);
var cur:longint;
begin
  heap[x]:=k;
  cur:=x;
  while (cur<>1) and (heap[cur shr 1]<heap[cur]) do
  begin
    swap(cur,cur shr 1);
    cur:=cur shr 1;
  end;
end;
procedure heapify(x:longint);
var l,r,max:longint;
begin
  l:=2*x;
  r:=2*x+1;
  max:=x;
  if (l<=hsize) and (heap[l]>heap[max]) then
    max:=l;
  if (r<=hsize) and (heap[r]>heap[max]) then
    max:=r;
  if max<>x then
  begin
    swap(max,x);
    heapify(max);
  end;
end;
procedure delete(x:longint);
var cur:longint;
begin
  cur:=x;
  while cur<>1 do
  begin
    swap(cur,cur shr 1);
    cur:=cur shr 1;
  end;
  swap(1,hsize);
  dec(hsize);
  heapify(1);
end;
begin
  randomize;
  assign(input,'painter.in');
  reset(input);
  readln(n);
  color[0]:='W';
  start[0]:=-600000;
  finish[0]:=1200000;
  for i:=1 to n do
    readln(color[i],start[i],finish[i]);
  close(input);
  for i:=0 to n do
    inc(finish[i],start[i]);
  assign(output,'painter.out');
  rewrite(output);
  nevents:=0;
  for i:=0 to n do
  begin
    inc(npts);
    p[npts]:=start[i];
    inc(npts);
    p[npts]:=finish[i];
    qsort(1,npts);
    k:=1;
    for j:=2 to npts do
      if p[j]<>p[j-1] then
      begin
        inc(k);
        p[k]:=p[j];
      end;
    npts:=k;
    for j:=0 to i do
    begin
      s[j]:=getnum(start[j]);
      f[j]:=getnum(finish[j]);
    end;
    nevents:=0;
    for j:=0 to i do
    begin
      inc(nevents);
      event[nevents].x:=s[j];
      event[nevents].p:=j;
      event[nevents].m:=1;
      inc(nevents);
      event[nevents].x:=f[j];
      event[nevents].p:=j;
      event[nevents].m:=-1;
    end;
    qsorte(1,nevents);
    hsize:=0;
    fillchar(segment,sizeof(segment),255);
    for j:=1 to nevents do
      case event[j].m of
        1:begin
            join(event[j].p);
            segment[event[j].x]:=heap[1];
          end;
        -1:begin
             delete(hpos[event[j].p]);
             segment[event[j].x]:=heap[1];
           end;
      end;
    for j:=1 to npts-1 do
      tcvet[j]:=color[segment[j]];
    cnt:=0;
    tcvet[0]:='W';
    for j:=1 to npts-1 do
      if (tcvet[j-1]='W') and (tcvet[j]='B') then
        inc(cnt);
    len:=0;
    for j:=1 to npts-1 do
      if tcvet[j]='B' then
        inc(len,p[j+1]-p[j]);
    if (i<>0) then
      writeln(cnt,' ',len);
  end;
  close(output);
end.
