{$R-,S-,Q-,I-,L-}
const infile='octagons.in'; outfile='octagons.out';
      sin22=0.382683432365;
      cos22=0.923879532511;
type octagon=record
               x,y,r,maxd,a:longint;
             end;
label 1;
var
  o:array[1..500] of octagon;
  n,k,i,j,x,y,q:longint;
  ans:longint;
  tot:int64;
  minx,maxx,miny,maxy:longint;
  d:double;

procedure init;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  minx:=4000;
  maxx:=-4000;
  miny:=4000;
  maxy:=-4000;
  tot:=0;
  for i:=1 to n do
  begin
    read(o[i].x,o[i].y,o[i].r);
    d:=o[i].r*cos22;
    o[i].maxd:=trunc(d);
    o[i].a:=trunc(2*o[i].r*sin22);
    if o[i].x-o[i].maxd<minx then
    minx:=o[i].x-o[i].maxd;
    if o[i].y-o[i].maxd<miny then
    miny:=o[i].y-o[i].maxd;
    if o[i].x+o[i].maxd>maxx then
    maxx:=o[i].x+o[i].maxd;
    if o[i].y+o[i].maxd>maxy then
    maxy:=o[i].y+o[i].maxd;
    tot:=tot+sqr(2*o[i].maxd);
  end;
  tot:=tot*250;
  read(k);
  close(input);
end;

function pointin(o:octagon; xp,yp:longint):boolean;
begin
  with o do
  begin
    if (xp>=x-maxd)and(xp<=x+maxd)and(yp>=y-a div 2)and(yp<=y+a div 2) then
    begin
      pointin:=true;
      exit;
    end;
    if (yp>=y-maxd)and(yp<=y+maxd)and(xp>=x-a div 2)and(xp<=x+a div 2) then
    begin
      pointin:=true;
      exit;
    end;
    if (xp>=x-maxd)and(xp<=x+maxd)and(yp>=y-maxd)and(yp<=y+maxd)
    and(abs(xp-x)+abs(yp-y)<=maxd+a div 2) then
    begin
      pointin:=true;
      exit;
    end;
  end;
  pointin:=false;
end;

begin
  init;
  if k>n then
  begin
    write(0);
    close(output);
    halt;
  end;
  ans:=0;
  if (maxx-minx)*(maxy-miny)<tot then
    for x:=minx to maxx do
      for y:=miny to maxy do
      begin
        q:=0;
        for i:=1 to n do
        begin
          if pointin(o[i],x,y) then inc(q);
          if q>=k then begin inc(ans); break; end;
          if (n-i)+q<k then break;
        end;
      end else
    for i:=1 to 500 do
      for x:=o[i].x-o[i].maxd to o[i].x+o[i].maxd do
        for y:=o[i].y-o[i].maxd to o[i].y+o[i].maxd do
        begin
          if not pointin(o[i],x,y) then goto 1;
          q:=1;
          if k=1 then begin inc(ans); goto 1; end;
          for j:=1 to i-1 do
            if pointin(o[j],x,y) then goto 1;
          for j:=i+1 to n do
          begin
            if pointin(o[j],x,y) then inc(ans);
            if q>=k then begin inc(ans); break; end;
            if (n-j)+q<k then break;
          end;
          1:
        end;
  write(ans);
  close(output);
end.