program zzz;

const
  eps = 1e-6;
type
  rec = record
    x: Longint;
    ev: byte;
  end;

  Tpoint = record
    x,y: Double;
  end;

  point = record
    x,y: Longint;
  end;

var
  xx1,xx2,i,x1,x2,res,sc,cur,y1,y2,j,k,n,m: Longint;
  miny,maxy,rr,ang,r,xx,yy: Double;
  v: array[1..500,1..8] of Tpoint;
  a: array[1..1000] of rec;

procedure swap(var a,b: rec);
var i: rec;
begin
  i := a;
  a := b;
  b := i;
end;

procedure qsort(st,fin: Longint);
var i,j: Longint;
    key: rec;
begin
  i := st;
  j := fin;
  key := a[st+random(fin-st)];
  while i <= j do begin
    while a[i].x > key.x do inc(i);
    while a[j].x < key.x do dec(j);
    if i <= j then begin
      swap(a[i],a[j]);
      inc(i);
      dec(j);
    end;
  end;
  if j > st then qsort(st,j);
  if i < fin then qsort(i,fin);
end;

begin
  assign(input,'octagons.in'); reset(input);
  read(n);
  for i := 1 to n do begin
    read(xx,yy,rr);
    ang := pi/8;
    for j := 1 to 8 do begin
      v[i,j].x := xx + rr * cos(ang);
      v[i,j].y := yy + rr * sin(ang);
{      vv[i,j].x := trunc(v[i,j].x);
      vv[i,j].y := trunc(v[i,j].y); }
      ang := ang + pi/4;
    end;
  end;
  read(k);
  res := 0;
{  for i := 1 to n do begin
    for j := 1 to 8 do begin
      if (j >= 3) and (j <= 6) then begin
        inc(vv[i,j].x);
      end;
      if j <= 4 then inc(vv[i,j].y);
    end;
  end;}
{  for i := 1 to 1 do begin
    for j := 1 to 8 do writeln(v[i,j].x:0:3,' ',v[i,j].y:0:3);
    writeln;
  end;}
  for i := 1 to n do begin
    for j := 1 to 8 do begin
      if (abs(v[i,j].x - round(v[i,j].x)) < 1e-6) then writeln('BOTVA');
    end;
  end;
  for i := -3850 to 3850 do begin
    sc := 0;
    for j := 1 to n do begin
      if (v[j,4].x <= i) and (v[j,1].x >= i) then begin
        if i < v[j,3].x then begin
          if abs(round(v[j,4].y - v[j,4].x) - v[j,4].y + v[j,4].x) < eps then begin
            xx1 := round(v[j,4].y - v[j,4].x + i);
          end else xx1 := trunc(v[j,4].y - v[j,4].x + i);
          if abs(round(v[j,6].y + v[j,6].x) - v[j,6].y - v[j,6].x) < eps then begin
            xx2 := round(v[j,6].y - i + v[j,6].x) - 1;
          end else xx2 := trunc(v[j,6].y + v[j,6].x - i);
        end else begin
          if i < v[j,2].x then begin
            xx2 := trunc(v[j,2].y);
            xx1 := trunc(v[j,6].y);
          end else begin
            if abs(round(v[j,1].y + v[j,1].x) - v[j,1].y - v[j,1].x) < eps then begin
              xx2 := round(v[j,1].y - i + v[j,1].x) - 1;
            end else xx2 := trunc(v[j,1].y + v[j,1].x - i);
            if abs(round(v[j,7].y - v[j,7].x) - v[j,7].y + v[j,7].x) < eps then begin
              xx1 := round(v[j,7].y + i - v[j,7].x);
            end else xx1 := trunc(v[j,7].y - v[j,7].x + i);

          end;
        end;
        inc(xx2);
        inc(sc);
        a[sc].ev := 0;
        a[sc].x := xx1;
        inc(sc);
        a[sc].ev := 1;
        a[sc].x := xx2;
      end;
    end;
    qsort(1,sc);
    cur := 0;
    for j := 1 to sc-1 do begin
      if a[j].ev = 1 then inc(cur) else dec(cur);
      if cur >= k then res := res - a[j+1].x + a[j].x;
    end;
  end;
  assign(output,'octagons.out'); rewrite(output);
  writeln(res);
  close(input);
  close(output);
end.
