{$I-,Q-,R-,S-}
const
  _2_20=1048576;

var
  size:array[1..21] of longint;
  b:byte;
  a:array[1.._2_20*2-1] of record
    t:byte;
    len,c:longint;
    lbc,rbc:byte;
  end;
  counter:longint;
  char1:char;
  l,r:longint;

function min(x,y:longint):longint;
begin
  if x<y then
    min:=x
  else
    min:=y;
end;

function max(x,y:longint):longint;
begin
  if x>y then
    max:=x
  else
    max:=y;
end;

function left(x:longint):longint;
begin
  left:=x shl 1;
end;

function right(x:longint):longint;
begin
  right:=(x shl 1) or 1;
end;

function lc(x:longint):longint;
begin
  lc:=x;
  while lc<_2_20 do begin
    lc:=lc shl 1;
  end;
end;

function rc(x:longint):longint;
begin
  rc:=x;
  while rc<_2_20 do begin
    rc:=rc shl 1;
    inc(rc);
  end;
end;

procedure paint(x,l,r:longint;col:byte;rank:byte);
var
  leftc,rightc,lb,rb,y:longint;

begin
  if x>=_2_20 then begin
    a[x].t:=col;
    a[x].c:=col;
    a[x].len:=col;
    a[x].lbc:=col;
    a[x].rbc:=col;
  end else begin
    lb:=lc(x);
    rb:=rc(x);
    if (lb=l) and (rb=r) then begin
      a[x].t:=col;
      a[x].c:=col;
      a[x].len:=col*size[rank];
      a[x].lbc:=col;
      a[x].rbc:=col;
      exit;
    end;
    leftc:=left(x);
    rightc:=right(x);
    if a[x].t<2 then begin
      a[leftc].t:=a[x].t;
      a[leftc].c:=a[x].t;
      a[leftc].len:=a[x].t*size[rank+1];
      a[leftc].lbc:=a[x].t;
      a[leftc].rbc:=a[x].t;

      a[rightc].t:=a[x].t;
      a[rightc].c:=a[x].t;
      a[rightc].len:=a[x].t*size[rank+1];
      a[rightc].lbc:=a[x].t;
      a[rightc].rbc:=a[x].t;
    end;
    y:=rc(leftc);
    if l<=y then
      paint(leftc,l,min(r,y),col,rank+1);
    inc(y);
    if r>=y then
      paint(rightc,max(l,y),r,col,rank+1);

    a[x].len:=a[rightc].len+a[leftc].len;
    a[x].c:=a[leftc].c+a[rightc].c;
    if (a[leftc].rbc=1) and (a[rightc].lbc=1) then begin
      dec(a[x].c);
    end;
    a[x].rbc:=a[rightc].rbc;
    a[x].lbc:=a[leftc].lbc;
    if (a[x].len=0) or (a[x].len=size[rank]) then begin
      a[x].t:=a[x].lbc;
    end else
      a[x].t:=2;
  end;
end;

begin
  assign(input,'painter.in');
  reset(input);
  assign(output,'painter.out');
  rewrite(output);

  readln(counter);

  size[21]:=1;
  for b:=20 downto 1 do
    size[b]:=size[b+1] shl 1;

  a[1].t:=0;
  a[1].c:=0;
  a[1].len:=0;
  a[1].lbc:=0;
  a[1].rbc:=0;
  while counter>0 do begin
    readln(char1,l,r);
    l:=l+_2_20+500000;
    r:=l+r-1;
    if char1='W' then
      paint(1,l,r,0,1)
    else
      paint(1,l,r,1,1);
    writeln(a[1].c,' ',a[1].len);

    dec(counter);
  end;

  close(input);
  close(output);
end.