type
   int = integer;
   integer = longint;

procedure init;
begin
   assign(input, 'octagons.in'); reset(input);
   assign(output, 'octagons.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

const
   maxn=500;

var
   x, y, r, r2:array[1..maxn] of integer;
   n, k: integer;
   minx,miny,maxx,maxy,maxr: integer;
   dx, dy: array[-4000..4000] of integer;
   xx1,xx2,yy1,yy2, u: array[1..maxn] of double;
   dz1, dz2: array[-8000..8000] of integer;
   cnt: int64;


function min(a, b: integer): integer;
begin
   if a< b then min:=a else min:=b;
end;
function max(a, b: integer): integer;
begin
   if a> b then max:=a else max:=b;
end;

procedure readinfo;
var
   i: integer;
begin
   readln(n);
   for i:=1 to n do
   begin
     readln(x[i],y[i],r[i]);
     r2[i]:=sqr(r[i]);
   end;
   readln(k);
end;

procedure calcd;
var
   i, k, o: integer;
begin
 for k:=1 to n do
 begin
   for i:=minx-maxr-1 to maxx+maxr+1 do
   begin
     if (i>=xx1[k])and(i<=xx2[k]) then
      inc(dx[i]);
   end;
   for i:=miny-maxr-1 to maxy+maxr+1 do
   begin
     if (i>=yy1[k])and(i<=yy2[k]) then
      inc(dy[i]);
   end;
 end;


end;

procedure clacldd;
var
   c,rc: double;
   i: integer;

begin
   c:=cos((45/2)*pi/180);
   for i:=1 to n do
   begin
      rc:=r[i]*c;
      xx1[i]:=x[i]-rc;
      xx2[i]:=x[i]+rc;
      yy1[i]:=y[i]-rc;
      yy2[i]:=y[i]+rc;
      u[i]:=sqr(rc);
   end;
end;

procedure ca;
var
   i, j, h, v: integer;

begin
   i:=minx-maxr-1;
   while (dx[i]<k)and(i<2*maxx) do
    inc(i);
   minx:=i;

   i:=miny-maxr-1;
   while (dy[i]<k)and(i<2*maxy) do
    inc(i);
   miny:=i;

   i:=maxx+maxr+1;
   while (dx[i]<k)and(i>=minx) do
    dec(i);
   maxx:=i;

   i:=maxy+maxr+1;
   while (dy[i]<k)and(i>=miny) do
    dec(i);
   maxy:=i;


   for i:=minx to maxx do
    for j:=miny to maxy do
    begin
     if (dx[i]>=k)and(dy[j]>=k)then
     begin
      v:=k;
      for h:=1 to n do
       if sqr(i-x[h])+sqr(j-y[h]) <=u[h] then
       begin
         dec(v);
         if v=0 then
          break;
       end;
      if v=0 then inc(cnt);
     end;
    end;
end;


procedure solve;
var
   i, v: integer;

label 1;
begin
  readinfo;
  if k>n then
   begin writeln(0); done; halt(0); end;

  maxr:=r[1];
  minx:=x[1];
  maxx:=x[1];
  miny:=y[1];
  maxy:=y[1];

  for i:=2 to n do
  begin
   if maxr<r[i] then maxr:=r[i];
   if maxy<y[i] then maxy:=y[i];
   if maxx<x[i] then maxx:=x[i];
   if miny>y[i] then miny:=y[i];
   if minx>x[i] then minx:=x[i];
  end;

  clacldd;
  calcd;
  ca;

{  cnt:=0;

  for x:=minx-maxr to maxx+maxr do
   for y:=miny-maxr to maxy+maxr do
   begin
      v:=k;
      for i:=1 to n do
       if inoc(x, y, i) then
       begin
        dec(v);
        if v=0 then
        begin
          inc(cnt);
          goto 1;
        end;
       end;
    1:
   end;
 }
  writeln(cnt);

end;

begin
 init;
 solve;
 done;
end.

