{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='thruput.in';
  outfile='thruput.out';
  nm=5005;
type
  Truba = record
    x,y : LongInt;
  end;
var
  b : array [1..nm,1..nm] of LongInt;
  f : array [1..nm] of Truba;
  p : array [1..nm] of LongInt;
  d : array [1..nm] of LongInt;
  n,time : LongInt;
{}
Procedure Inp;
var
  i,x,y,t : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  readln(n);
  for i:=1 to n-1 do begin
    readln(x,y,b[x,y]);
    b[y,x]:=b[x,y];
    f[i].x:=x; f[i].y:=y;
  end;
end;
{}
Procedure Out;
begin
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  assign(output,outfile);
  rewrite(output);
  fillchar(d,sizeof(d),0);
  fillchar(p,sizeof(p),0);
  fillchar(b,sizeof(b),0);
end;
{}
Procedure Dfs(x : LongInt);
var
  i : LongInt;
begin
  inc(time); d[x]:=time;
  for i:=1 to n do
    if (b[x,i]>0) and (d[i]=0) then begin
      p[i]:=x; Dfs(i);
    end;
end;
{}
Procedure Swap(var x,y : LongInt);
var
  bak : LongInt;
begin
  bak:=x;
  x:=y;
  y:=bak;
end;
{}
Procedure Solve;
var
  i,x,y,num,cost,max : LongInt;
  ch : Char;
begin
  time:=0; Dfs(1);
  repeat
    read(ch);
    if ch='D' then exit;
    if ch='C' then begin
      readln(ch,ch,ch,ch,ch,num,cost);
      b[f[num].x,f[num].y]:=cost;
      b[f[num].y,f[num].x]:=cost;
    end else begin
      readln(ch,ch,ch,ch,x,y);
      if d[y]>d[x] then Swap(x,y);
      max:=0;
      while x<>y do begin
        if b[x,p[x]]>max then max:=b[x,p[x]];
        x:=p[x];
      end;
      writeln(max);
    end;
  until false;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.