{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='thruput';
  fin =problem+'.in';
  fout=problem+'.out';
  maxn=300000;

var
  n,m,i,j,k,l,s,t:longint;
  a:array[0..maxn,1..4]of longint;
  b:array[0..maxn]of longint;
  c:array[0..maxn,1..2]of longint;
  d:array[1..maxn]of byte;

  ch:char;
  s1:string[4];
  s2:string[5];

procedure sort(l,r:longint);
var
  i,j,x:longint;
begin
  i:=l;
  j:=r;
  x:=a[(i+j)div 2,1];
  repeat
    while a[i,1]<x do
      inc(i);
    while a[j,1]>x do
      dec(j);
    if i<=j then begin
      a[m+1]:=a[i];
      a[i]:=a[j];
      a[j]:=a[m+1];
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then
    sort(i,r);
  if j>l then
    sort(l,j);
end;

function dfs(v:longint):longint;
var
  i,k:longint;
begin
  d[v]:=1;
  dfs:=-1;
  if v=t then begin
    dfs:=0;
    exit;
  end;
  for i:=b[v]to b[v+1]-1 do
    if d[a[i,2]]=0 then begin
      k:=dfs(a[i,2]);
      if k>=0 then
        if k<a[i,3] then
          k:=a[i,3];
      if k>0 then begin
        dfs:=k;
        exit;
      end;
    end;
end;

procedure init;
begin
  assign(output,fout);
  rewrite(output);
  assign(input,fin);
  reset(input);

    read(n);
    for i:=1 to n-1 do begin
      read(s,t,l);
      inc(m);
      a[m,1]:=s;
      a[m,2]:=t;
      a[m,3]:=l;
      a[m,4]:=i;
      inc(m);
      a[m,1]:=t;
      a[m,2]:=s;
      a[m,3]:=l;
      a[m,4]:=i;
    end;
    sort(1,m);
    for i:=1 to m do begin
      if a[i,1]<>a[i-1,1] then
        b[a[i,1]]:=i;
      if c[a[i,4],1]=0 then
        c[a[i,4],1]:=i
      else
        c[a[i,4],2]:=i;
    end;
    b[n+1]:=m+1;
    repeat
      read(ch);
      case ch of
        'D':exit;
        'Q':
        begin
          fillchar(d,sizeof(d),0);
          read(s1);
          readln(s,t);
          writeln(dfs(s));
        end;
        'C':
        begin
          read(s2);
          readln(k,t);
          a[c[k,1],3]:=t;
          a[c[k,2],3]:=t;
        end;
      end;
    until false;

  close(input);
  close(output);
end;

begin
  init;
end.