{$I-,Q-,R-,S-}

const
  coutfile = 'thruput.out';
  cinfile = 'thruput.in';

  list = 1 shl 18;

  nmax = 200000;

  inf = maxlongint shr 1;

type
  int = longint;
  real = extended;

  slist = ^tslist;
  tslist = record
            v, w : int;
            no1, no2 : int;
            next : slist;
          end;

  rebro = record
            u, v : int;
            s1, s2 : slist;
          end;

var
  n, m : int;
  ans, ans2 : int;

  tree, treev : array [1..list shl 1] of int;
  g : array [1..nmax] of slist;

  k : int;
  p : array [1..nmax,1..3] of int;
  no : int;
  nm, ponov, f : array [1..nmax] of int;

  kr : int;
  rb : array [1..nmax] of rebro;

procedure outdata;
var
  i, j : int;
begin

end;

function findmin(l, r : int) : int;
var
  min : int;
begin
  min:= inf;
  l:= list + l -1;
  r:= list + r -1;
  while l <= r do
  begin
    if min > treev[l] then min:= treev[l];
    if min > treev[r] then min:= treev[r];
    l:= (l+1) shr 1; r:= (r-1) shr 1;
  end;
  findmin:= min;
end;

function findmax(l, r : int) : int;
var
  max : int;
begin
  l:= list + l -1;
  r:= list + r -1;
  max:= -inf;
  while l <= r do
  begin
    if max < tree[l] then max:= tree[l];
    if max < tree[r] then max:= tree[r];
    l:= (l+1) shr 1; r:= (r-1) shr 1;
  end;
  findmax:= max;
end;

function findl(l, z : int) : int;
begin
  l:= list + l -1;
  while l > 1 do
  begin
    l:= (l-1) shr 1;
    if treev[l] = z then break;
  end;
  while l < list do
  begin
    l:= l shl 1;
    if treev[l + 1] = z then inc(l);
  end;
  findl:= l - list + 1;
end;

function findr(l, z : int) : int;
begin
  l:= list + l -1;
  while l > 1 do
  begin
    l:= (l+1) shr 1;
    if treev[l] = z then break;
  end;
  while l < list do
  begin
    l:= l shl 1;
    if treev[l] <> z then inc(l);
  end;
  findr:= l - list + 1;
end;

procedure change(v, b : int);
begin
  v:= v + list -1;
  tree[v]:= b;
  while v > 1 do
  begin
    v:= v shr 1;
    tree[v]:= tree[v shl 1 + 1];
    if tree[v] < tree[v shl 1] then tree[v]:= tree[v shl 1];
  end;
end;

procedure changev(v, b : int);
begin
  v:= v + list -1;
  treev[v]:= b;
  while v > 1 do
  begin
    v:= v shr 1;
    treev[v]:= treev[v shl 1 + 1];
    if treev[v] > treev[v shl 1] then treev[v]:= treev[v shl 1];
  end;
end;

procedure deep(v, pr : int; r : slist);
var
  x : slist;
begin
  inc(k);
  p[k,1]:= v;
  if nm[v] = -1 then
  begin
    nm[v]:= no+1;
    ponov[no+1]:= v;
    inc(no);
    f[v]:= k;
  end;
  p[k,2]:= nm[v];
  if r <> nil then r^.no1:= k;
  if r <> nil then p[k,3]:= r^.w else p[k,3]:= -1;
  x:= g[v];
  while x <> nil do
  begin
    if x^.v <> pr then
    begin
      deep(x^.v,v,x);
      inc(k);
      p[k,1]:= v;
      p[k,2]:= nm[v];
      p[k,3]:= x^.w;
      x^.no2:= k;
    end;
    x:= x^.next;
  end;
end;

procedure init;
var
  i : int;
begin
  for i:= 1 to list shl 1 do tree[i]:= -inf;
  fillchar(treev,sizeof(treev),0);
end;

procedure heapsort;
var
  l, r : int;
  x : rebro;

  procedure sift;
  var
    i, j : int;
  begin
    x:= rb[l];
    i:= l;
    j:= i shl 1;
    if (j < r) and ((rb[j].u < rb[j+1].u) or
      ((rb[j].u = rb[j+1].u) and (rb[j].v < rb[j+1].v))) then inc(j);
    while (j <= r) and ((x.u < rb[j].u) or
      ((x.u = rb[j].u) and (x.v < rb[j].v))) do
    begin
      rb[i]:= rb[j];
      i:= j;
      j:= i shl 1;
      if (j < r) and ((rb[j].u < rb[j+1].u) or
        ((rb[j].u = rb[j+1].u) and (rb[j].v < rb[j+1].v))) then inc(j);
    end;
    rb[i]:= x;
  end;

begin
  r:= kr;
  for l:= kr shr 1 downto 1 do sift;
  l:= 1;
  for r:= kr-1 downto 1 do
  begin
    x:= rb[1];
    rb[1]:= rb[r+1];
    rb[r+1]:= x;
    sift;
  end;
end;

function bin(u, v : int) : int;
var
  lo, hi, mid : int;
begin
  lo:= 1; hi:= n+1;
  while lo < hi-1 do
  begin
    mid:= (lo+hi) shr 1;
    if (u < rb[mid].u) or ((u = rb[mid].u) and (v < rb[mid].v)) then
      hi:= mid else lo:= mid;
  end;
  bin:= lo;
end;

procedure solve;
var
  i, j : int;
  ch : char;
  quer : boolean;
  az, bz, buf : int;
  mot : int;
  cur : int;
begin
  init;
  k:= 0;
  no:= 0;
  fillchar(nm,sizeof(nm),255);
  deep(1,-1,nil);
  for i:= 1 to k do
  begin
    treev[i-1+list]:= p[i,2];
    tree[i-1+list]:= p[i,3];
  end;
  for i:= list -1 downto 1 do
  begin
    treev[i]:= treev[i shl 1 + 1];
    if treev[i] > treev[i shl 1] then treev[i]:= treev[i shl 1];
    tree[i]:= tree[i shl 1 + 1];
    if tree[i] < tree[i shl 1] then tree[i]:= tree[i shl 1];
  end;
  while not eof do
  begin
    read(ch);
    if ch = 'D' then exit;
    if ch = 'Q' then
    begin
      quer:= true;
      for i:= 1 to 4 do read(ch);
      readln(az,bz);
      if f[az] > f[bz] then
      begin
        buf:= az;
        az:= bz;
        bz:= buf;
      end;
      mot:= findmin(f[az],f[bz]);
      cur:= findr(f[az],mot);
      ans:= findmax(f[az]+1,cur);
      cur:= findl(f[bz],mot);
      ans2:= findmax(cur+1,f[bz]);
      if ans < ans2 then ans:= ans2;
      writeln(ans);
    end else
    begin
      quer:= false;
      for i:= 1 to 5 do read(ch);
      readln(az,bz);
      if rb[az].s1 <> nil then change(rb[az].s1^.no1,bz);
      if rb[az].s1 <> nil then change(rb[az].s1^.no2,bz);
      if rb[az].s2 <> nil then change(rb[az].s2^.no1,bz);
      if rb[az].s2 <> nil then change(rb[az].s2^.no2,bz);
    end;
  end;
end;

procedure push(var x : slist; y, z : int);
var
  q : slist;
begin
  new(q);
  q^.v:= y;
  q^.w:= z;
  q^.no1:= 0;
  q^.no2:= 0;
  q^.next:= x;
  x:= q;
end;

procedure readdata;
var
  i, j : int;
  x,y,z : int;
begin
  read(n);
  fillchar(g,sizeof(g),0);
  for i:= 1 to n-1 do
  begin
    read(x,y,z);
    if x > y then
    begin
      j:= x;
      x:= y;
      y:= j;
    end;
    push(g[x],y,z);
    push(g[y],x,z);
    inc(kr);
    rb[kr].s1:= g[x];
    rb[kr].s2:= g[y];
  end;
  readln;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.