{$R-,S-,Q-,I-,L-}
const infile='queen.in'; outfile='queen.out';
type condition=record
                 cn,w:longint;
                 fch,lch:longint;
                 c,mm:longint;
               end;
var n,m,p,i,l:longint;
    x1,y1,x2,y2:longint;
    c:array[1..610000] of condition;
    cu:array[1..2,1..10000] of longint;
    vw:array[1..2,2..50] of longint;
    hw:array[1..50] of longint;
    kx,ky,qx,qy,dx,dy:longint;
    mov:longint;
    chance:boolean;
    minm,maxm:longint;
    depth:array[1..2,1..50] of longint;

procedure dfs(x,y:longint);
begin
  inc(mov);
  depth[x,y]:=1;
  if (x+1<=2)and(depth[x+1,y]=0)and(hw[y]=0) then dfs(x+1,y);
  if (x-1>=1)and(depth[x-1,y]=0)and(hw[y]=0) then dfs(x-1,y);
  if (y-1>=1)and(depth[x,y-1]=0)and(vw[x,y]=0) then dfs(x,y-1);
  if (y+1<=n)and(depth[x,y+1]=0)and(vw[x,y+1]=0) then dfs(x,y+1);
end;

function min(a,b:longint):longint;
begin
  if a<b then min:=a else min:=b;
end;

function max(a,b:longint):longint;
begin
  if a>b then max:=a else max:=b;
end;

function strike(kx,ky,qx,qy,c:longint):boolean;
var i,a:longint;
    have:boolean;
begin
  if (kx=qx) then
  begin
    have:=false;
    for i:=min(ky,qy)+1 to max(ky,qy) do
      if vw[kx,i]=1 then begin have:=true; break; end;
    if have then strike:=false else
      if abs(ky-qy)=1 then strike:=true else
        if c=2 then strike:=true else strike:=false;
    exit;
  end;
  if ky=qy then
  begin
    if hw[ky]=1 then strike:=false else strike:=true;
    exit;
  end;
  if abs(ky-qy)>1 then begin strike:=false; exit; end;
  a:=max(ky,qy);
  i:=min(ky,qy);
  if (hw[a]=1)or(hw[i]=1)or(vw[1,a]=1)or(vw[2,a]=1) then strike:=false else strike:=true;
end;

procedure createcond(kx,ky,qx,qy,col:longint);
begin
  inc(l);
  c[l].cn:=((ky-1)+n*(kx-1))*100+(qy-1)+n*(qx-1);
  c[l].c:=col;
  inc(cu[c[l].c,c[l].cn]);
  if c[p].fch=0 then c[p].fch:=l;
  c[p].lch:=l;
end;

procedure mainpart;
begin
  while p<l do
  begin
    inc(p);
    kx:=(c[p].cn div 100) div n+1;
    ky:=(c[p].cn div 100) mod n+1;
    qx:=(c[p].cn mod 100) div n+1;
    qy:=(c[p].cn mod 100) mod n+1;
    if strike(kx,ky,qx,qy,c[p].c) then continue;
    if c[p].c=1 then
      for dx:=-1 to 1 do
        for dy:=-1 to 1 do
        begin
          if (dx=0)and(dy=0) then continue;
          if (kx+dx<1)or(kx+dx>2) then continue;
          if (ky+dy<1)or(ky+dy>n) then continue;
          if (dy=1)and(vw[kx,ky+dy]=1) then continue;
          if (dy=-1)and(vw[kx,ky]=1) then continue;
          if ((dx=-1)or(dx=1))and(hw[ky]=1) then continue;
          if (dx=1)and(dy=1)and((hw[ky]=1)or(hw[ky+dy]=1)or(vw[kx,ky+dy]=1)or(vw[kx+dx,ky+dy]=1))
          then continue;
          if (dx=-1)and(dy=-1)and((hw[ky]=1)or(hw[ky+dy]=1)or(vw[kx,ky]=1)or(vw[kx+dx,ky]=1))
          then continue;
          if (dx=1)and(dy=-1)and((hw[ky]=1)or(hw[ky+dy]=1)or(vw[kx,ky]=1)or(vw[kx+dx,ky]=1))
          then continue;
          if (dx=-1)and(dy=1)and((hw[ky]=1)or(hw[ky+dy]=1)or(vw[kx,ky+dy]=1)or(vw[kx+dx,ky+dy]=1))
          then continue;
          if (cu[2,((ky+dy-1)+n*(kx+dx-1))*100+(qy-1)+n*(qx-1)]<=30){or(strike(kx+dx,ky+dy,qx,qy,3-c[p].c))} then
            createcond(kx+dx,ky+dy,qx,qy,2);
        end else
    begin
      for dx:=-1 to 1 do
        for dy:=-1 to 1 do
        begin
          if (dx=0)and(dy=0) then continue;
          if (qx+dx<1)or(qx+dx>2) then continue;
          if (qy+dy<1)or(qy+dy>n) then continue;
          if (dy=1)and(vw[qx,qy+dy]=1) then continue;
          if (dy=-1)and(vw[qx,qy]=1) then continue;
          if ((dx=-1)or(dx=1))and(hw[qy]=1) then continue;
          if (dx=1)and(dy=1)and((hw[qy]=1)or(hw[qy+dy]=1)or(vw[qx+dx,qy+dy]=1)or(vw[qx,qy+dy]=1))
          then continue;
          if (dx=-1)and(dy=-1)and((hw[qy]=1)or(hw[qy+dy]=1)or(vw[qx,qy]=1)or(vw[qx+dx,qy]=1))
          then continue;
          if (dx=1)and(dy=-1)and((hw[qy]=1)or(hw[qy+dy]=1)or(vw[qx,qy]=1)or(vw[qx+dx,qy]=1))
          then continue;
          if (dx=-1)and(dy=1)and((hw[qy]=1)or(hw[qy+dy]=1)or(vw[qx,qy+dy]=1)or(vw[qx+dx,qy+dy]=1))
          then continue;
          if (cu[1,((ky-1)+n*(kx-1))*100+(qy+dy-1)+n*(qx+dx-1)]<=30){or(strike(kx,ky,qx+dx,qy+dy,3-c[p].c))} then
            createcond(kx,ky,qx+dx,qy+dy,1);
        end;
      dx:=0;
      for dy:=1 to n do
      begin
        if qy+dy>n then break;
        if vw[qx,qy+dy]=1 then break;
        if (qy+dy=ky)and(kx=qx) then break;
        if dy=1 then continue;
        if (cu[1,((ky-1)+n*(kx-1))*100+(qy+dy-1)+n*(qx+dx-1)]<=30){or(strike(kx,ky,qx+dx,qy+dy,3-c[p].c))} then
          createcond(kx,ky,qx+dx,qy+dy,1);
      end;
      for dy:=-1 downto -n do
      begin
        if qy+dy<1 then break;
        if vw[qx,qy+dy+1]=1 then break;
        if (qy+dy=ky)and(kx=qx) then break;
        if dy=-1 then continue;
        if (cu[1,((ky-1)+n*(kx-1))*100+(qy+dy-1)+n*(qx+dx-1)]<=30){or(strike(kx,ky,qx+dx,qy+dy,3-c[p].c))} then
          createcond(kx,ky,qx+dx,qy+dy,1);
      end;
    end;
  end;
end;

begin
  fillchar(cu,sizeof(cu),0);
  fillchar(hw,sizeof(hw),0);
  fillchar(vw,sizeof(vw),0);
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n,m);
  for i:=1 to m do
  begin
    read(x1,y1,x2,y2);
    if y1=y2 then
      hw[y1]:=1;
    if x1=x2 then
      if y2>y1 then vw[x1,y2]:=1 else vw[x1,y1]:=1;
  end;
  close(input);
{  if strike(2,2,2,4,2) then write('yes') else write('no');
  close(output);}
  if strike(1,1,2,n,1) then
  begin
    writeln('queen wins');
    writeln(0);
    close(output);
    halt;
  end;
  fillchar(depth,sizeof(depth),0);
  mov:=0;
  dfs(1,1);
  if mov=1 then
  begin
    writeln('queen wins');
    writeln(0);
    close(output);
    halt;
  end;
  fillchar(depth,sizeof(depth),0);
  mov:=0;
  dfs(2,n);
  if mov=1 then
  begin
    writeln('king wins');
    writeln(1);
    close(output);
    halt;
  end;
  if depth[1,1]=0 then
  begin
    writeln('draw');
    close(output);
    halt;
  end;
  fillchar(c,sizeof(c),0);
  l:=1;
  c[l].cn:=2*n-1;
  c[l].c:=1;
  p:=0;
  cu[1,c[l].cn]:=1;
  mainpart;
  for p:=l downto 1 do
    if c[p].fch=0 then
    begin
      kx:=(c[p].cn div 100) div n+1;
      ky:=(c[p].cn div 100) mod n+1;
      qx:=(c[p].cn mod 100) div n+1;
      qy:=(c[p].cn mod 100) mod n+1;
      if strike(kx,ky,qx,qy,c[p].c) then
      begin
        c[p].w:=c[p].c;
        c[p].mm:=-1;
      end else
      begin
        c[p].mm:=0;
        c[p].w:=0;
      end;
    end else
    begin
      chance:=false;
      maxm:=-5;
      minm:=100000;
      for i:=c[p].fch to c[p].lch do
      begin
        if c[i].w=c[p].c then chance:=true;
        if (c[i].w=c[p].c)and(c[i].mm<minm) then minm:=c[i].mm;
        if (c[i].w=3-c[p].c)and(c[i].mm>maxm) then maxm:=c[i].mm;
      end;
      if chance then
      begin
        c[p].w:=c[p].c;
        c[p].mm:=minm+1;
      end else
      begin
        c[p].w:=3-c[p].c;
        c[p].mm:=maxm+1;
      end;
    end;
  if c[1].w=1 then
    writeln('king wins') else writeln('queen wins');
  writeln(c[1].mm);
  close(output);
end.