type int = longint;
     tgraph = array[1..200, 1..200] of int;
     tpart  = array[0..200] of int;

var n : int;
    bg, bd, dg : tgraph;
    pbg, pbd, pdg : tpart;
    ans : array[1..100, 1..2] of int;

procedure init;
var i, j : int;
begin
  read(n);
  for i:=1 to n do
    for j:=1 to n do read(bd[i, j+n]);
  for i:=1 to n do
    for j:=1 to n do read(dg[i, j+n]);
  for i:=1 to n do
    for j:=1 to n do read(bg[j, i+n]);
end;

procedure pairs(var w : tpart; var g : tgraph);
var mark : array[1..200] of int;
    i, j : int;
  function go(x, sum1, sum2 : int) : boolean;
  var y, t, up, down : int;
  begin
    if mark[x] = i then begin
      go:=(sum1 > sum2);
      exit;
    end;
    mark[x]:=i;
    if x <= n then begin
      down:=n+1;
      up:=2*n;
    end else begin
      down:=1;
      up:=n;
    end;
    t:=0;
    for y:=down to up do
      if (mark[y] <> i) and (w[y] <> x) then begin
        mark[y]:=i;
        if w[y] <> 0 then
          if go(w[y], sum1+g[x, y], sum2+g[w[y], y])
          then t:=2 else t:=1
        else t:=2;
        if t = 2 then begin
          if w[y] <> 0 then
            if w[w[y]] = y then w[w[y]]:=0;
          w[y]:=x;
          w[x]:=y;
          go:=true;
          exit;
        end;
      end;
    if t = 0 then go:=(sum1 > sum2) else go:=false;
  end;
begin
  fillchar(w, sizeof(w), 0);
  for i:=1 to n do begin
    j:=1+random(n)+n;
    while w[j] <> 0 do
      if j = 2*n then break else inc(j);
    if w[j] <> 0 then begin
      j:=n+1;
      while w[j] <> 0 do inc(j);
    end;
    w[i]:=j;
    w[j]:=i;
  end;
  fillchar(mark, sizeof(mark), 0);
  for i:=1 to 2*n do go(i, 0, 0);
  w[0]:=0;
  for i:=1 to n do if w[i] <> 0 then
    inc(w[0], g[i, w[i]]);
end;

procedure solve;
var sbg, sbd, sdg, s : int;
    i, t, k : int;
begin
  k:=1;
  s:=pbd[0]+pdg[0];
  for i:=1 to n do
    inc(s, bg[pbd[i+n], pdg[i]]);
  t:=pbg[0]+pdg[0];
  for i:=1 to n do
    inc(t, bd[pbg[i+n], pdg[i+n]+n]);
  if t > s then begin
    k:=2;
    s:=t;
  end;
  t:=pbg[0]+pbd[0];
  for i:=1 to n do
    inc(t, dg[pbd[i]-n, pbg[i]]);
  if t > s then k:=3;
  if k = 1 then
    for i:=1 to n do begin
      ans[i, 1]:=pbg[i]-n;
      ans[i, 2]:=pdg[ans[i, 1]]-n;
    end
  else if k = 2 then
    for i:=1 to n do begin
      ans[i, 1]:=pbg[i]-n;
      ans[i, 2]:=pdg[ans[i, 1]+n];
    end
  else
    for i:=1 to n do begin
      ans[i, 1]:=pbd[i]-n;
      ans[i, 2]:=pbg[i]-n;
    end;
end;

procedure wa;
var i : int;
begin
  for i:=1 to n do writeln(i, ' ', ans[i, 1], ' ', ans[i, 2]);
end;

begin
  assign(input, 'triples.in'); reset(input);
  assign(output, 'triples.out'); rewrite(output);
  init;
  randomize;
  pairs(pbg, bg);
  pairs(pbd, bd);
  pairs(pdg, dg);
  solve;
  wa;
  close(input); close(output);
end.
