const MAXY=100;
var field:array[0..3,0..100]of longint;{+1 QUEEN +mdone+1 QUEEN CAN -1 KING -mdone-1 KING CAN}
    wall:array[1..400,1..4]of longint;
    dist:array[1..2,1..MAXY,1..2,1..MAXY]of longint;
    n,m,mdone,ckx,cky,cqx,cqy:longint;

function IsWall(x1,y1,x2,y2:longint):boolean;forward;
procedure PCK;forward;

procedure FillDist;
var iii,jjj,ii,jj,hd,tl:longint;
    queue:array[1..2*MAXY+10,1..2]of longint;
begin
     mdone:=1;
     for ii:=1 to 2 do begin
         for jj:=1 to n do begin
             hd:=1;
             tl:=1;
             queue[hd,1]:=ii;
             queue[hd,2]:=jj;
             while hd<=tl do begin
                   ckx:=queue[hd,1];
                   cky:=queue[hd,2];
                   PCK;
                   for iii:=ckx-1 to ckx+1 do begin
                       for jjj:=cky-1 to cky+1 do begin
                           if field[iii,jjj]=-mdone-1 then begin
                              field[iii,jjj]:=0;
                              if (dist[ii,jj,iii,jjj]=0)or(dist[ii,jj,iii,jjj]>dist[ii,jj,ckx,cky]+1)then begin
                                 dist[ii,jj,iii,jjj]:=dist[ii,jj,ckx,cky]+1;
                                 inc(tl);
                                 queue[tl,1]:=iii;
                                 queue[tl,2]:=jjj;
                              end;
                           end;
                       end;
                   end;
                   inc(hd);
             end;
         end;
     end;
end;

procedure Load;
var i,t:longint;
begin
     read(n,m);
     for i:=1 to m do begin
         read(wall[i,1],wall[i,2],wall[i,3],wall[i,4]);
         if wall[i,3]<wall[i,1] then begin
            t:=wall[i,3];
            wall[i,3]:=wall[i,1];
            wall[i,1]:=t;
            t:=wall[i,2];
            wall[i,2]:=wall[i,4];
            wall[i,4]:=t;
         end;
         if wall[i,3]=wall[i,1] then begin
            if wall[i,4]<wall[i,2] then begin
            t:=wall[i,2];
            wall[i,2]:=wall[i,4];
            wall[i,4]:=t
            end;
         end;
     end;
     field[1,1]:=-1;
     field[2,n]:=+1;
     FillDist;
end;

function IsWall(x1,y1,x2,y2:longint):boolean;
var xx1,t,yy1,xx2,yy2,i:longint;
begin
     xx1:=x1;
     xx2:=x2;
     yy1:=y1;
     yy2:=y2;
     if xx2<xx1 then begin
         t:=xx2;
         xx2:=xx1;
         xx1:=t;
         t:=yy1;
         yy1:=yy2;
         yy2:=t;
     end;
     if xx2=xx1 then begin
         if yy2<yy1 then begin
            t:=yy1;
            yy1:=yy2;
            yy2:=t
         end;
     end;
     for i:=1 to m do begin
         if (wall[i,1]=xx1)and(wall[i,2]=yy1)and(wall[i,3]=xx2)and(wall[i,4]=yy2) then begin
            IsWall:=true;
            exit;
         end;
     end;
     IsWall:=false;
end;

procedure PCK;
var i,mx,my,kx,ky,j:longint;
begin
     kx:=ckx;
     ky:=cky;
     {left}
     mx:=kx;
     my:=ky-1;
     if my>0 then begin
        if not(IsWall(MX,MY,KX,KY)) then begin
           field[mx,my]:=-mdone-1;
        end;
     end;
     {right}
     mx:=kx;
     my:=ky+1;
     if my<n+1 then begin
        if not(IsWall(MX,ky,KX,mY)) then begin
           field[mx,my]:=-mdone-1;
        end;
     end;
     {up}
     mx:=kx-1;
     my:=ky;
     if mx>0 then begin
        if not(IsWall(MX,MY,KX,KY)) then begin
           field[mx,my]:=-mdone-1;
        end;
     end;
     {down}
     mx:=kx+1;
     my:=ky;
     if mx<3 then begin
        if not(IsWall(kX,MY,mX,KY)) then begin
           field[mx,my]:=-mdone-1;
        end;
     end;
     {l-u}
     mx:=kx-1;
     my:=ky-1;
     if (my>0)and(mx>0) then begin
        if not(IsWall(kx-1,ky,kx,ky)) then begin
           if not(IsWall(kx,ky-1,kx,ky)) then
              if not(IsWall(kx-1,ky-1,kx-1,ky))then
                 if not(IsWall(kx-1,ky-1,kx,ky-1)) then
                    field[mx,my]:=-mdone-1;
        end;
     end;
     {r-u}
     mx:=kx-1;
     my:=ky+1;
     if (my<n+1)and(mx>0) then begin
        if not(IsWall(kx-1,ky,kx,ky)) then begin
           if not(IsWall(kx,ky+1,kx,ky)) then
              if not(IsWall(kx-1,ky+1,kx-1,ky))then
                 if not(IsWall(kx-1,ky+1,kx,ky+1)) then
                    field[mx,my]:=-mdone-1;
        end;
     end;
     {l-d}
     mx:=kx+1;
     my:=ky-1;
     if (my>0)and(mx<3) then begin
        if not(IsWall(kx+1,ky,kx,ky)) then begin
           if not(IsWall(kx,ky-1,kx,ky)) then
              if not(IsWall(kx+1,ky-1,kx+1,ky))then
                 if not(IsWall(kx+1,ky-1,kx,ky-1)) then
                    field[mx,my]:=-mdone-1;
        end;
     end;
     {r-d}
     mx:=kx+1;
     my:=ky+1;
     if (my<n+1)and(mx<3) then begin
        if not(IsWall(kx+1,ky,kx,ky)) then begin
           if not(IsWall(kx,ky+1,kx,ky)) then
              if not(IsWall(kx+1,ky+1,kx+1,ky))then
                 if not(IsWall(kx+1,ky+1,kx,ky+1)) then
                    field[mx,my]:=-mdone-1;
        end;
     end;
end;

procedure PCQ;
var i,mx,my,kx,ky,j:longint;
begin
     kx:=cqx;
     ky:=cqy;
     {left}
     for i:=ky downto 2 do begin
         if not(IsWall(kx,i-1,kx,i)) then begin
            field[kx,i-1]:=mdone+1;
         end
         else break;
     end;
     {right}
     for i:=ky to n-1 do begin
         if not(IsWall(kx,i,kx,i+1)) then begin
            field[kx,i+1]:=mdone+1;
         end
         else break;
     end;
     {up}
     mx:=kx-1;
     my:=ky;
     if mx>0 then begin
        if not(IsWall(MX,MY,KX,KY)) then begin
           field[mx,my]:=mdone+1;
        end;
     end;
     {down}
     mx:=kx+1;
     my:=ky;
     if mx<3 then begin
        if not(IsWall(kX,MY,mX,KY)) then begin
           field[mx,my]:=mdone+1;
        end;
     end;
     {l-u}
     mx:=kx-1;
     my:=ky-1;
     if (my>0)and(mx>0) then begin
        if not(IsWall(kx-1,ky,kx,ky)) then begin
           if not(IsWall(kx,ky-1,kx,ky)) then
              if not(IsWall(kx-1,ky-1,kx-1,ky))then
                 if not(IsWall(kx-1,ky-1,kx,ky-1)) then
                    field[mx,my]:=+mdone+1;
        end;
     end;
     {r-u}
     mx:=kx-1;
     my:=ky+1;
     if (my<n+1)and(mx>0) then begin
        if not(IsWall(kx-1,ky,kx,ky)) then begin
           if not(IsWall(kx,ky+1,kx,ky)) then
              if not(IsWall(kx-1,ky+1,kx-1,ky))then
                 if not(IsWall(kx-1,ky+1,kx,ky+1)) then
                    field[mx,my]:=mdone+1;
        end;
     end;
     {l-d}
     mx:=kx+1;
     my:=ky-1;
     if (my>0)and(mx<3) then begin
        if not(IsWall(kx+1,ky,kx,ky)) then begin
           if not(IsWall(kx,ky-1,kx,ky)) then
              if not(IsWall(kx+1,ky-1,kx+1,ky))then
                 if not(IsWall(kx+1,ky-1,kx,ky-1)) then
                    field[mx,my]:=mdone+1;
        end;
     end;
     {r-d}
     mx:=kx+1;
     my:=ky+1;
     if (my<n+1)and(mx<3) then begin
        if not(IsWall(kx+1,ky,kx,ky)) then begin
           if not(IsWall(kx,ky+1,kx,ky)) then
              if not(IsWall(kx+1,ky+1,kx+1,ky))then
                 if not(IsWall(kx+1,ky+1,kx,ky+1)) then
                    field[mx,my]:=mdone+1;
        end;
     end;
end;

function DistQ(i,j:longint):longint;
begin
     DistQ:=dist[i,j,cqx,cqy];
end;

function DistK(i,j:longint):longint;
begin
     DistK:=dist[i,j,ckx,cky];
end;

procedure DMK;
var i,j,mini,minj,p,min:longint;
begin
     PCK;
     PCQ;
     min:=2000000;
     for i:=1 to 2 do begin
         for j:=1 to n do begin
             IF FIELD[I,J]<>-mdone-1 then continue;
             p:=DistQ(i,j);
             if p<min then begin
                mini:=i;
                minj:=j;
                min:=p;
             end;
         end;
     end;
     if min=2000000 then begin
        writeln('queen wins');
        write(mdone-1);
        close(output);
        halt(0);
     end;
     field[ckx,cky]:=0;
     ckx:=mini;
     cky:=minj;
     field[ckx,cky]:=-1;
end;

procedure DMQ;
var i,j,mini,minj,p,min:longint;
begin
     PCQ;
     PCK;
     min:=2000000;
     for i:=1 to 2 do begin
         for j:=1 to n do begin
             IF FIELD[I,J]<>mdone+1 then continue;
             p:=DistK(i,j);
             if p<min then begin
                mini:=i;
                minj:=j;
                min:=p;
             end;
         end;
     end;
     if min=2000000 then begin
        writeln('king wins');
        write(mdone-1);
        close(Output);
        halt(0);
     end;
     field[cqx,cqy]:=0;
     cqx:=mini;
     cqy:=minj;
     field[cqx,cqy]:=1;
end;

procedure Solve;
var i,j:longint;
begin
     for i:=1 to 2 do begin
         for j:=1 to n do field[i,j]:=0;
     end;
     mdone:=0;
     ckx:=1;
     cky:=1;
     cqx:=2;
     cqy:=n;
     while mdone<=500 do begin
           inc(mdone);
           DMK;
           inc(mdone);
           DMQ;
     end;
     write('draw');
end;

begin
     assign(input,'queen.in');
     assign(output,'queen.out');
     reset(input);
     rewrite(output);
     Load;
     Solve;
     close(input);
     close(output);
end.
