{$D-,I-,L-,R-}
Const InFile='queen.in';
      OutFile='queen.out';
      MaxN=1 + 50;{50}
Var A:Array[1..MaxN,1..2,1..MaxN,1..2,1..2] Of LongInt;
    B:Array[1..MaxN,1..2,1..MaxN,1..2,1..2] Of Boolean;
    C:Array[0..MaxN,1..2,0..MaxN,1..2] Of Boolean;
    D:Array[0..MaxN,1..2,0..MaxN,1..2] Of Boolean;
    N:Integer;
    Answer:LongInt;
Procedure ReadData;
  Var I,J,M:Integer;
      X1,Y1,X2,Y2:Integer;
      X,Y:Integer;
      H:Boolean;
  Begin
    Fillchar(C,Sizeof(C),True);
    For I:=1 To MaxN Do
      For J:=1 To 2 Do
        C[I,J,I,J]:=False;
    Assign(InPut,InFile);
    Reset(Input);
    Read(N,M);
    For I:=1 To M Do
      Begin
        Read(X1,Y1,X2,Y2);
        C[X1,Y1,X2,Y2]:=False;
        C[X2,Y2,X1,Y1]:=False;
        If X1=X2 Then
          Begin
            C[X1,Y1,X2 + 1,Y2]:=False;
            C[X1,Y1,X2 - 1,Y2]:=False;
            C[X1 + 1,Y1,X2,Y2]:=False;
            C[X1 - 1,Y1,X2,Y2]:=False;
            C[X2 + 1,Y2,X1,Y1]:=False;
            C[X2 - 1,Y2,X1,Y2]:=False;
            C[X2,Y2,X1 + 1,Y1]:=False;
            C[X2,Y2,X1 - 1,Y1]:=False;
          End
          Else
          Begin
            If Y1=1 Then
              Begin
                C[X1,Y1 + 1,X2,Y2]:=False;
                C[X1,Y1,X2,Y2 + 1]:=False;
                C[X2,Y2,X1,Y1 + 1]:=False;
                C[X2,Y2 + 1,X1,Y1]:=False;
              End
              Else
              Begin
                C[X1,Y1 - 1,X2,Y2]:=False;
                C[X1,Y1,X2,Y2 - 1]:=False;
                C[X2,Y2,X1,Y1 - 1]:=False;
                C[X2,Y2 - 1,X1,Y1]:=False;
              End
          End;
      End;
    Close(Input);
    For I:=1 To N Do
      For J:=1 To 2 Do
        Begin
          H:=True;
          X:=I - 1; Y:=J;
          While X>0 Do
            Begin
              H:=H And (C[X + 1,Y,X,Y]);
              C[I,J,X,Y]:=H;
              Dec(X);
            End;
          X:=I + 1; Y:=J;
          H:=True;
          While X<=N Do
            Begin
              H:=H And (C[X - 1,Y,X,Y]);
              C[I,J,X,Y]:=H;
              Inc(X);
            End;
          X:=I - 2; Y:=3-J;
          While X>0 Do
            Begin
              C[I,J,X,Y]:=False;
              Dec(X);
            End;
          X:=I + 2; Y:=J;
          While X<=N Do
            Begin
              C[I,J,X,Y]:=False;
              Inc(X);
            End;
        End;
    Fillchar(D,Sizeof(D),False);
    For I:=1 To N Do
      Begin
        D[I,1,I + 1,1]:=C[I,1,I + 1,1];
        D[I,1,I - 1,1]:=C[I,1,I - 1,1];
        D[I,2,I + 1,2]:=C[I,2,I + 1,2];
        D[I,2,I - 1,2]:=C[I,2,I - 1,2];
        D[I,1,I + 1,2]:=C[I,1,I + 1,2];
        D[I,1,I - 1,2]:=C[I,1,I - 1,2];
        D[I,2,I + 1,1]:=C[I,2,I + 1,1];
        D[I,2,I - 1,1]:=C[I,2,I - 1,1];
        D[I,1,I,2]:=C[I,1,I,2];
        D[I,2,I,1]:=C[I,2,I,1];
      End;
  End;
Procedure WriteData;
  Begin
    Assign(Output,OutFile);
    Rewrite(Output);
    If Answer=0 Then Write('draw') Else
      If Answer>0 Then Writeln('king wins') Else Writeln('queen wins');
    If Answer<>0 Then Write(Abs(Answer) - 1);
    Close(Output);
  End;
Procedure Init;
  Var F:Boolean;
      Xk,Yk,Xq,Yq,Xt,Yt:Integer;
  Begin
    Fillchar(A,Sizeof(A),0);
    Fillchar(B,Sizeof(B),False);
    {Queen's step}
    For Xk:=1 To N Do
      For Yk:=1 To 2 Do
        For Xq:=1 To N Do
         For Yq:=1 To 2 Do
           Begin
             F:=True;
             For Xt:=1 To N Do
               For Yt:=1 To 2 Do
                 If (Xq<>Xt)Or(Yq<>Yt) Then
                   If (C[Xq,Yq,Xt,Yt])And(not D[Xk,Yk,Xt,Yt]) Then
                     F:=False;
             If F Then
               A[Xk,Yk,Xq,Yq,2]:=1;
           End;
    {King's step}
    For Xk:=1 To N Do
      For Yk:=1 To 2 Do
        For Xq:=1 To N Do
         For Yq:=1 To 2 Do
           Begin
             F:=True;
             For Xt:=1 To N Do
               For Yt:=1 To 2 Do
                 If (Xk<>Xt)Or(Yk<>Yt) Then
                   If (D[Xk,Yk,Xt,Yt])And(not C[Xq,Yq,Xt,Yt]) Then
                     F:=False;
             If F Then
               A[Xk,Yk,Xq,Yq,1]:=-1;
           End;
  End;
Procedure Working;
  Function Max(A,B:LongInt):LongInt;
    Begin
      If A>B Then Max:=A Else Max:=B;
    End;
  Function Min(A,B:LongInt):LongInt;
    Begin
      If A>B Then Min:=B Else Min:=A;
    End;
  Function BetterForKing(A,B:LongInt):LongInt;
    Begin
      if (A=0)And(B=0) Then
        Begin
          BetterForKing:=0;
          Exit;
        End;
      If A=0 Then
        If B<0 Then
          BetterForKing:=0
            Else
              BetterForKing:=B + 1;
      If A=0 Then Exit;
      If (B=0) Then
        Begin
          if A>0 Then BetterForKing:=A Else BetterForKing:=0;
          Exit;
        End;
      If (A>0)And(B<0) Then
        begin
          Exit;
          BetterForKing:=A;
        End;
      If (A<0)And(B>0) Then
        Begin
          BetterForKing:=B + 1;
          Exit;
        End;
      If (A<0) Then
        If A<B Then BetterForKing:=A Else BetterForKing:=B - 1
          Else
            If A<B Then BetterForKing:=A Else BetterForKing:=B + 1;
    End;
  Function BetterForQueen(A,B:LongInt):LongInt;
    Begin
      if (A=0)And(B=0) Then
        Begin
          BetterForQueen:=0;
          Exit;
        End;
      If A=0 Then
        If B<0 Then
          BetterForQueen:=B - 1
            Else
              BetterForQueen:=0;
      If A=0 Then Exit;
      If (B=0) Then
        Begin
          If A<0 Then BetterForQueen:=A Else BetterForQueen:=0;
          Exit;
        End;
      If (A>0)And(B<0) Then
        Begin
          BetterForQueen:=B - 1;
          Exit;
        End;
      If (A<0)And(B>0) Then
        Begin
          BetterForQueen:=A;
          Exit;
        End;
      If (A<0) Then
        If A<B Then BetterForQueen:=B - 1 Else BetterForQueen:=A
          Else
            If A<B Then BetterForQueen:=B + 1 Else BetterForQueen:=A;
    End;
  Function Moving(Xk,Yk,Xq,Yq,H:Integer):LongInt;
    Var X,Y:Integer;
        T:Boolean;
    Begin
      Moving:=A[Xk,Yk,Xq,Yq,H];
      If A[Xk,Yk,Xq,Yq,H]<>0 Then Exit;
      If B[Xk,Yk,Xq,Yq,H] Then Exit;
      B[Xk,Yk,Xq,Yq,H]:=True;
      Case H Of
        1:Begin
            T:=False;
            For X:=1 To N Do
              If Not T Then
              For Y:=1 To 2 Do
                If D[Xk,Yk,X,Y] Then
                  If (X<>Xq)Or(Y<>Yq) Then
                    If Not C[Xq,Yq,X,Y] Then
                      Begin
                        A[Xk,Yk,Xq,Yq,H]:=Moving(X,Y,Xq,Yq,2);
                        If A[Xk,Yk,Xq,Yq,H]<0 Then Dec(A[Xk,Yk,Xq,Yq,H]);
                        If A[Xk,Yk,Xq,Yq,H]>0 Then Inc(A[Xk,Yk,Xq,Yq,H]);
                        T:=True;
                        Break;
                      End;
            For X:=1 To N Do
              For Y:=1 To 2 Do
                If D[Xk,Yk,X,Y] Then
                  If (X<>Xq)Or(Y<>Yq) Then
                    If Not C[Xq,Yq,X,Y] Then
                      A[Xk,Yk,Xq,Yq,H]:=
                           BetterForKing(A[Xk,Yk,Xq,Yq,H],Moving(X,Y,Xq,Yq,2));
          End;
        2:Begin
            T:=False;
            For X:=1 To N Do
              If Not T Then
              For Y:=1 To 2 Do
                If C[Xq,Yq,X,Y] Then
                  If (X<>Xk)Or(Y<>Yk) Then
                    If Not D[Xk,Yk,X,Y] Then
                      Begin
                        A[Xk,Yk,Xq,Yq,H]:=Moving(Xk,Yk,X,Y,1);
                        If A[Xk,Yk,Xq,Yq,H]<0 Then Dec(A[Xk,Yk,Xq,Yq,H]);
                        If A[Xk,Yk,Xq,Yq,H]>0 Then Inc(A[Xk,Yk,Xq,Yq,H]);
                        T:=True;
                        Break;
                      End;
            For X:=1 To N Do
              For Y:=1 To 2 Do
                If C[Xq,Yq,X,Y] Then
                  If (X<>Xk)Or(Y<>Yk) Then
                    If Not D[Xk,Yk,X,Y] Then
                      A[Xk,Yk,Xq,Yq,H]:=
                         BetterForQueen(A[Xk,Yk,Xq,Yq,H],Moving(Xk,Yk,X,Y,1));
          End;
      End;
      Moving:=A[Xk,Yk,Xq,Yq,H];
    End;
  Begin
    If N=2 Then
      Begin
        If D[1,1,1,2] And D[1,1,2,1] And D[1,1,2,2] Then
          begin
            Answer:=1;
            Exit;
          End;
      End;
    Answer:=Moving(1,1,n,2,1);
  End;
Begin
  ReadData;
  Init;
  Working;
  WriteData;
End.