{$I-,Q-,R-,S-}
const
  MAXN = 1000010;
type
  Integer = Longint;
  TChannel = record
    u, v, t: Integer;
  end;
var
  n, Uk: integer;
  Channels: array[1..MAXN * 2] of TChannel;
  Lb: array[1..MAXN] of Integer;
  what: array[1..MAXN] of record
    v1, v2: Integer;
  end;
  NNew: array[1..MAXN] of Boolean;
  Tree: array[1..MAXN] of record
    p, t: Integer;
  end;
  Tu: array[1..MAXN] of ShortInt;

procedure Init();
var i: Integer;
begin
  Assign(Input, 'thruput.in');
  Reset(Input);
  Assign(Output, 'thruput.out');
  Rewrite(Output);

  Read(n);
  for i := 1 to n - 1 do
  begin
    Inc(Uk);
    with Channels[uk] do
    begin
      readln(u, v, t);
      What[i].v1 := u;
      What[i].v2 := v;
    end;
    Inc(Uk);
    channels[Uk].v := Channels[uk - 1].u;
    channels[Uk].u := Channels[uk - 1].v;
    channels[Uk].t := Channels[uk - 1].t;
  end;
end;

procedure Sort(const l,r: longint);
var
  i,j,x: longint;
  y: TChannel;
begin
  i := l;
  j := r;
  x := Channels[(l+r) div 2].u;
  repeat
    while Channels[i].u < x do inc(i);
    while x < Channels[j].u do dec(j);
    if not(i>j) then
    begin
      y := Channels[i];
      Channels[i] := Channels[j];
      Channels[j] := y;
      inc(i);
      j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

procedure Dfs(const v, Parent, t: Integer);
var i: Integer;
begin
  NNew[v] := True;
  Tree[v].p := Parent;
  Tree[v].t := t;

  i := Lb[v];
  while (i > 0) and (i <= uk) and (Channels[i].u = v) do
  begin
    if not Nnew[Channels[i].v] then Dfs(Channels[i].v, v, Channels[i].t);
    Inc(i);
  end;
end;

procedure BuildTree();
var i: Integer;
begin
  Sort(1, uk);
  for i := 1 to uk do if Lb[Channels[i].u] = 0 then Lb[Channels[i].u] := i;
  Dfs(1, 1, 0);
end;

function Find(v1, v2: integer): Integer;
var Max1, Max2: Integer;
begin
  FillChar(Tu, Sizeof(Tu), 0);
  Max1 := 0;
  Max2 := 0;
  while (Tu[v1] <> 1) and (Tu[v2] <> -1) do
  begin
    Tu[v1] := -1;
    Tu[v2] := 1;

    if Tree[v2].t > Max2 then Max2 := Tree[v2].t;
    v2 := Tree[v2].p;

    if Tree[v1].t > Max1 then Max1 := Tree[v1].t;
    v1 := Tree[v1].p;
  end;
  if Max1 > Max2 then Find := Max1 else Find := Max2;
end;

procedure Solve();
var Change: boolean;
    ch: Char;
    m1, m2, v1, v2: Integer;
begin
  BuildTree();

  while not Eof() do
  begin
    Read(Ch);
    if Ch = 'D' then Break;

    Change := ch = 'C';

    while not (Ch = ' ') do Read(Ch);
    Read(m1, m2);

    if Change then
    begin
      v1 := What[m1].v1;
      v2 := What[m1].v2;
      if Tree[v1].p = v2 then Tree[v1].t := m2 else tree[v2].t := m2;
    end else
    begin
      Writeln(Find(m1, m2));
    end;

    readln;
  end;
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
