program zzz;

const maxn = 200010;

var i,j,n,m,h,max : longint;
    a,b,w,num,k : array [1..maxn] of longint;
    l,r : array [1..maxn] of longint;
    p1,p2 : array [1..maxn] of longint;
    ch : char;
    f : boolean;
    vis : array [1..maxn] of boolean;

procedure Swap(var i,j : longint);
var t : longint;
begin
   t := i;
   i := j;
   j := t;
end;

procedure Qsort(l,r : longint);
var i,j,x : longint;
begin
   i := l;
   j := r;
   x := a[random(r-l)+l];
   repeat
      while a[i] < x do inc(i);
      while a[j] > x do dec(j);
      if i <= j then begin
         if k[i] = 1 then p1[num[i]] := j else p2[num[i]] := j;
         if k[j] = 1 then p1[num[j]] := i else p2[num[j]] := i;
         Swap(a[i],a[j]);
         Swap(b[i],b[j]);
         Swap(k[i],k[j]);
         Swap(w[i],w[j]);
         inc(i);
         dec(j);
      end;
   until i>j;
   if l < j then Qsort(l,j);
   if i < r then Qsort(i,r);
end;

procedure Dfs(v : longint);
var i : longint;
begin
   if v = j then begin
      f := true;
      exit;
   end;
   vis[v] := true;
   for i := l[v] to r[v] do begin
      if not vis[b[i]] then begin
         Dfs(b[i]);
         if f and (w[i] > max) then max := w[i];
      end;
   end;
end;

begin
   randseed := 4398953;
   assign(input,'thruput.in'); reset(input);
   assign(output,'thruput.out'); rewrite(output);
   readln(n);
   m := n-1;
   for i := 1 to m do begin
      readln(a[i],b[i],w[i]);
      a[i+m] := b[i];
      b[i+m] := a[i];
      w[i+m] := w[i];
      num[i] := i;
      num[i+m] := i;
      k[i] := 1;
      k[i+m] := 2;
      p1[i] := i;
      p2[i] := i+m;
   end;
   m := m*2;
   Qsort(1,m);
   h := 1;
   for i := 2 to m do begin
      if a[i] <> a[h] then begin
         l[a[i-1]] := h;
         r[a[i-1]] := i-1;
         h := i;
      end;
   end;
   l[a[i]] := h;
   r[a[i]] := m;
   while true do begin
      read(ch);
      if ch = 'Q' then begin
         for i := 1 to 4 do read(ch);
         readln(i,j);
         fillchar(vis,sizeof(vis),false);
         f := false;
         max := -1;
         Dfs(i);
         writeln(max);
      end else if ch = 'C' then begin
         for i := 1 to 5 do read(ch);
         readln(i,j);
         w[p1[i]] := j;
         w[p2[i]] := j;
      end else break;
   end;
   close(output);
   close(input);
end.