{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
Uses SysUtils;
const
  inpfile='quest.in';
  outfile='quest.out';
  sec=24*60*60;
  tlim=1.9;
  nm=8;
  km=120;
  lm=100;
  mm=200;
type
  String100 = String[lm];

  Door = record
    x : LongInt;
    key : String100;
    u : Boolean;
  end;

  Person = record
    name : String100;
    t1n,t2n : LongInt;
    t1,t2 : array [1..km] of String100;
    u : Boolean;
  end;

  Oracul = record
    name : String100;
    t1n,t2n : LongInt;
    t1,t2 : array [1..km] of String100;
    u : Boolean;
  end;

  Room = record
    name : String100;
    c,o,i,dn : LongInt;
    d : array [1..20] of Door;
    p : array [1..km] of Person;
    b : array [1..km] of Oracul;
    t : array [1..km] of String100;
  end;
var
  a : array [1..nm] of Room;
  picked : array [1..nm] of Boolean;
  vis : array [1..nm] of Boolean;
  b : array [1..km] of String100;
  r : array [1..mm] of String;
  start,finish : String100;
  n,m,bn,rn : LongInt;
  time,tstart : extended;
{}
Procedure DelSpaces(var st : String100);
begin
  while (st[1]=' ') and (length(st)>0) do delete(st,1,1);
  while (st[length(st)]=' ') and (length(st)>0) do delete(st,length(st),1);
end;
{}
Function TL : Boolean;
begin
  if (now-tstart)*sec>=tlim then TL:=true
                            else TL:=false;
end;
{}
Procedure Inp;
var
  i,j : LongInt;
  x,y : LongInt;
  st : String100;
  ch : Char;
begin
  assign(input,inpfile);
  reset(input);
  readln(n);
  for i:=1 to n do begin
    readln(a[i].name);
    DelSpaces(a[i].name);
  end;

  readln(m);
  for i:=1 to m do begin
    read(x,y); readln(st);
    DelSpaces(st);
    inc(a[x].dn);
    a[x].d[a[x].dn].x:=y;
    a[x].d[a[x].dn].key:=st;

    inc(a[y].dn);
    a[y].d[a[y].dn].x:=x;
    a[y].d[a[y].dn].key:=st;
  end;

  for i:=1 to n do begin
    readln(a[i].c,a[i].o,a[i].i);
    for j:=1 to a[i].c do begin
      readln(a[i].p[j].name);
      st:='';
      while not eoln do begin
        read(ch);
        if ch=',' then begin
          inc(a[i].p[j].t1n);
          DelSpaces(st);
          a[i].p[j].t1[a[i].p[j].t1n]:=st;
          st:='';
        end else st:=st+ch;
      end; readln;

      inc(a[i].p[j].t1n);
      DelSpaces(st);
      a[i].p[j].t1[a[i].p[j].t1n]:=st;
      st:='';

      while not eoln do begin
        read(ch);
        if ch=',' then begin
          inc(a[i].p[j].t2n);
          DelSpaces(st);
          a[i].p[j].t2[a[i].p[j].t2n]:=st;
          st:='';
        end else st:=st+ch;
      end; readln;

      inc(a[i].p[j].t2n);
      DelSpaces(st);
      a[i].p[j].t2[a[i].p[j].t2n]:=st;
      st:='';

    end;

    for j:=1 to a[i].o do begin
      readln(a[i].b[j].name);
      st:='';
      while not eoln do begin
        read(ch);
        if ch=',' then begin
          inc(a[i].b[j].t1n);
          DelSpaces(st);
          a[i].b[j].t1[a[i].b[j].t1n]:=st;
          st:='';
        end else st:=st+ch;
      end; readln;

      inc(a[i].b[j].t1n);
      DelSpaces(st);
      a[i].b[j].t1[a[i].b[j].t1n]:=st;
      st:='';

      while not eoln do begin
        read(ch);
        if ch=',' then begin
          inc(a[i].b[j].t2n);
          DelSpaces(st);
          a[i].b[j].t2[a[i].b[j].t2n]:=st;
          st:='';
        end else st:=st+ch;
      end; readln;

      inc(a[i].b[j].t2n);
      DelSpaces(st);
      a[i].b[j].t2[a[i].b[j].t2n]:=st;
      st:='';

    end;

    for j:=1 to a[i].i do begin
      readln(a[i].t[j]);
      DelSpaces(a[i].t[j]);
    end;
  end;

  readln(start); DelSpaces(start);
  readln(finish); DelSpaces(finish);
end;
{}
Procedure Out(ok : Boolean);
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ok then begin
    for i:=1 to rn do writeln(r[i]);
  end else writeln('dead princess');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(r,sizeof(r),0);
  fillchar(picked,sizeof(picked),0);
  fillchar(vis,sizeof(vis),0);
end;
{}
Procedure Pick(var t : String100);
begin
  inc(bn); b[bn]:=t;
  inc(rn);
  r[rn]:='pick '+t;
end;
{}
Procedure Talk(var p : Person);
begin
  inc(rn);
  r[rn]:='talk to '+p.name;
end;
{}
Procedure Give(var p : Person);
var
  i,j,k : LongInt;
begin
  for i:=1 to p.t1n do
    for j:=1 to bn do
      if b[j]=p.t1[i] then
        for k:=j to bn-1 do b[k]:=b[k+1];
  dec(bn);

  inc(rn);
  r[rn]:='give ';
  for i:=1 to p.t1n-2 do
    r[rn]:=r[rn]+p.t1[i]+', ';

  if p.t1n>1 then
    r[rn]:=r[rn]+p.t1[p.t1n-1]+' and ';

  r[rn]:=r[rn]+p.t1[p.t1n]+' ';
  r[rn]:=r[rn]+'to '+p.name;
end;
{}
Procedure Take(var p : Person);
var
  i,j : LongInt;
begin
  inc(rn);
  r[rn]:='take ';
  for i:=1 to p.t2n-2 do begin
    r[rn]:=r[rn]+p.t2[i]+', ';
    inc(bn); b[bn]:=p.t2[i];
  end;

  if p.t2n>1 then begin
    r[rn]:=r[rn]+p.t2[p.t2n-1]+' and ';
    inc(bn); b[bn]:=p.t2[p.t2n-1];
  end;

  r[rn]:=r[rn]+p.t2[p.t2n]+' ';
  inc(bn); b[bn]:=p.t2[p.t2n];
  r[rn]:=r[rn]+'from '+p.name;
end;
{}
Procedure TakeB(var p : Oracul);
var
  i,j : LongInt;
begin
  inc(rn);
  r[rn]:='take ';
  for i:=1 to p.t2n-2 do begin
    r[rn]:=r[rn]+p.t2[i]+', ';
    inc(bn); b[bn]:=p.t2[i];
  end;

  if p.t2n>1 then begin
    r[rn]:=r[rn]+p.t2[p.t2n-1]+' and ';
    inc(bn); b[bn]:=p.t2[p.t2n-1];
  end;

  r[rn]:=r[rn]+p.t2[p.t2n]+' ';
  inc(bn); b[bn]:=p.t2[p.t2n];

  r[rn]:=r[rn]+'from '+p.name;
end;
{}
Procedure Use(var p : Oracul);
var
  i,j,k : LongInt;
begin
  inc(rn);
  r[rn]:='use ';
  for i:=1 to p.t1n-2 do
    r[rn]:=r[rn]+p.t1[i]+', ';
  if p.t1n>1 then
    r[rn]:=r[rn]+p.t1[p.t1n-1]+' and ';
  r[rn]:=r[rn]+p.t1[p.t1n]+' ';
  r[rn]:=r[rn]+'on '+p.name;
end;
{}
Procedure Open(var d : Door; x : LongInt);
var
  i,j : LongInt;
begin
  inc(rn);
  r[rn]:='open door to '+a[d.x].name;
  for i:=1 to a[d.x].dn do
    if a[d.x].d[i].x=x then begin
      a[d.x].d[i].u:=true;
      break;
    end;
  d.u:=true;
end;
{}
Procedure Work(x : LongInt);
var
  i,j,k : LongInt;
  ok : Boolean;
begin
  if a[x].name=finish then begin
    inc(rn); r[rn]:='save princess';
    Out(true);
  end;

  vis[x]:=true;
  if not picked[x] then begin
    for i:=1 to a[x].i do Pick(a[x].t[i]);
    picked[x]:=true;
  end;

  for i:=1 to a[x].c do if not a[x].p[i].u then begin
    for j:=1 to a[x].p[i].t1n do begin
      ok:=false;
      for k:=1 to bn do
        if b[k]=a[x].p[i].t1[j] then begin
          ok:=true; break;
        end;
      if not ok then break;
    end;
    if ok then begin
      Talk(a[x].p[i]);
      Give(a[x].p[i]);
      Take(a[x].p[i]);
      a[x].p[i].u:=true;
    end;
  end;

  for i:=1 to a[x].o do if not a[x].b[i].u then begin
    for j:=1 to a[x].b[i].t1n do begin
      ok:=false;
      for k:=1 to bn do
        if b[k]=a[x].b[i].t1[j] then begin
          ok:=true; break;
        end;
      if not ok then break;
    end;
    if ok then begin
      Use(a[x].b[i]);
      TakeB(a[x].b[i]);
      a[x].b[i].u:=true;
    end;
  end;

  for i:=1 to a[x].dn do
    if not a[x].d[i].u then begin
      for j:=1 to bn do
        if b[j]=a[x].d[i].key then begin
          Open(a[x].d[i],x);
          for k:=j to bn-1 do b[k]:=b[k+1];
          dec(bn);
          break;
        end;
    end;

  for i:=1 to a[x].dn do
    if not vis[a[x].d[i].x] and a[x].d[i].u then begin
      inc(rn); r[rn]:='go to '+a[a[x].d[i].x].name;
      Work(a[x].d[i].x);
      inc(rn); r[rn]:='go to '+a[x].name;
    end;
  vis[x]:=false;
end;
{}
Procedure Solve;
var
  i,j : LongInt;
begin
  rn:=0; bn:=0;
  for i:=1 to n do
    if start=a[i].name then begin
      while not TL do begin
        fillchar(vis,sizeof(vis),0);
        Work(i);
      end;
      break;
    end;

end;
{}
Begin
  tstart:=now;
  Init;
  Inp;
  Solve;
  Out(false);
End.
