{$I-,Q-,R-,S-}
uses sysutils;

const
  d_time=0.000018;

var
  chr:char;
  s:string;
  endtime:extended;
  k,z,c,o,i,j,n,m:byte;
  pr:array[1..200] of record
    door:byte;
    got:boolean;
    name:string;
  end;
  prc:byte;
  doors:array[1..200] of record
    r1,r2:byte;
    open:boolean;
    key:byte;
  end;
  rooms:array[1..8] of record
    name:string;
    dc,pc,oc:byte;
    d,o,p:array[1..200] of byte;
  end;
  ob:array[1..200] of record
    name:string;
    used:boolean;
    p:boolean;
    t,g:array[1..200] of byte;
    tc,gc:byte;
  end;
  obc:byte;
  sroom,proom:byte;
  u:array[1..8] of boolean;

procedure nosol;
begin

  close(output);
  assign(output,'quest.out');
  rewrite(output);

  write('dead princess');
  close(input);
  close(output);
  halt(0);
end;

procedure checktime;
begin
  if now>=endtime then begin
    nosol();
  end;
end;

procedure goodstr(var s:string);
var
  i,j:byte;
begin
  i:=1;
  j:=length(s);
  while s[i]=' ' do
    inc(i);
  while s[j]=' ' do
    dec(j);
  s:=copy(s,i,j+1-i);
end;

function findpr(s:string):byte;
var
  i:byte;
begin
  findpr:=0;
  for i:=1 to prc do
    if pr[i].name=s then begin
      findpr:=i;
      exit;
    end;
end;

procedure pick(i:byte);
begin
  writeln('pick ',pr[i].name);
  pr[i].got:=true;
end;

procedure use(i:byte);
var
  j:byte;
begin
  ob[i].used:=true;
  if ob[i].p then begin
    writeln('talk to ',ob[i].name);
    write('give ');
  end else begin
    write('use ');
  end;

  if ob[i].tc=1 then begin
    write(pr[ob[i].t[1]].name);
  end else begin
    for j:=1 to ob[i].tc-2 do begin
      write(pr[ob[i].t[j]].name,', ');
    end;
    write(pr[ob[i].t[ob[i].tc-1]].name,' and ',pr[ob[i].t[ob[i].tc]].name);
  end;
  if ob[i].p then begin
    write(' to ');
  end else begin
    write(' on ');
  end;
  writeln(ob[i].name);

  write('take ');

  if ob[i].gc=1 then begin
    write(pr[ob[i].g[1]].name);
  end else begin
    for j:=1 to ob[i].gc-2 do begin
      write(pr[ob[i].g[j]].name,', ');
    end;
    write(pr[ob[i].g[ob[i].gc-1]].name,' and ',pr[ob[i].g[ob[i].gc]].name);
  end;

  writeln(' from ',ob[i].name);

  for j:=1 to ob[i].gc do begin
    pr[ob[i].g[j]].got:=true;
  end;
end;

function canuse(i:byte):boolean;
var
  j:byte;
begin
  for j:=1 to ob[i].tc do
    if not pr[ob[i].t[j]].got then begin
      canuse:=false;
      exit;
    end;
  canuse:=true;
end;

procedure dfs(r:byte);
var
  i,j,r1:byte;

begin
  u[r]:=true;
  if r=proom then begin
    writeln('save princess');
    close(input);
    close(output);
    halt(0);
  end;
  for i:=1 to rooms[r].pc do begin
    j:=rooms[r].p[i];
    if not pr[j].got then begin
      pick(j);
    end;
  end;
  for i:=1 to rooms[r].oc do begin
    j:=rooms[r].o[i];
    if (not ob[j].used) and (canuse(j)) then begin
      use(j);
    end;
  end;

  for i:=1 to rooms[r].dc do begin
    j:=rooms[r].d[i];
    if (not doors[j].open) and (pr[doors[j].key].got) then begin
      doors[j].open:=true;
      r1:=r xor doors[j].r1 xor doors[j].r2;
      writeln('open door to ',rooms[r1].name);
    end;
  end;

  for i:=1 to rooms[r].dc do begin
    j:=rooms[r].d[i];
    if (doors[j].open) then begin
      r1:=r xor doors[j].r1 xor doors[j].r2;
      if not u[r1] then begin
        writeln('go to ',rooms[r1].name);
        dfs(r1);
        writeln('go to ',rooms[r].name);
      end;
    end;
  end;
end;

begin
  endtime:=now()+d_time;
  assign(input,'quest.in');
  reset(input);
  assign(output,'quest.out');
  rewrite(output);

  readln(n);
  for i:=1 to n do begin
    readln(rooms[i].name);
    goodstr(rooms[i].name);
    rooms[i].dc:=0;
    rooms[i].oc:=0;
    rooms[i].pc:=0;
  end;

  prc:=0;
  readln(m);
  for i:=1 to m do begin
    read(doors[i].r1,doors[i].r2);
    doors[i].open:=false;
    readln(s);
    goodstr(s);
    inc(prc);
    pr[prc].name:=s;
    pr[prc].got:=false;
    pr[prc].door:=i;
    doors[i].key:=prc;

    j:=doors[i].r1;
    inc(rooms[j].dc);
    rooms[j].d[rooms[j].dc]:=i;
    j:=doors[i].r2;
    inc(rooms[j].dc);
    rooms[j].d[rooms[j].dc]:=i;
  end;

  obc:=0;
  for j:=1 to n do begin
    readln(c,o,i);
    for z:=1 to c do begin
      inc(obc);
      inc(rooms[j].oc);
      rooms[j].o[rooms[j].oc]:=obc;
      readln(s);
      goodstr(s);
      ob[obc].name:=s;
      ob[obc].p:=true;
      ob[obc].used:=false;

      ob[obc].tc:=0;
      while not eoln() do begin
        s:='';
        read(chr);
        while (not eoln()) and (chr<>',') do begin
          s:=s+chr;
          read(chr);
        end;
        if chr<>',' then
          s:=s+chr;
        goodstr(s);
        inc(ob[obc].tc);
        k:=findpr(s);
        if k=0 then begin
          inc(prc);
          k:=prc;
          pr[k].name:=s;
          pr[k].door:=0;
          pr[k].got:=false;
        end;
        ob[obc].t[ob[obc].tc]:=k;
      end;
      readln();

      ob[obc].gc:=0;
      while not eoln() do begin
        s:='';
        read(chr);
        while (not eoln()) and (chr<>',') do begin
          s:=s+chr;
          read(chr);
        end;
        if chr<>',' then
          s:=s+chr;
        goodstr(s);
        inc(ob[obc].gc);
        k:=findpr(s);
        if k=0 then begin
          inc(prc);
          k:=prc;
          pr[k].name:=s;
          pr[k].door:=0;
          pr[k].got:=false;
        end;
        ob[obc].g[ob[obc].gc]:=k;
      end;
      readln();
    end;

    for z:=1 to o do begin
      inc(obc);
      inc(rooms[j].oc);
      rooms[j].o[rooms[j].oc]:=obc;
      readln(s);
      goodstr(s);
      ob[obc].name:=s;
      ob[obc].p:=false;
      ob[obc].used:=false;

      ob[obc].tc:=0;
      while not eoln() do begin
        s:='';
        read(chr);
        while (not eoln()) and (chr<>',') do begin
          s:=s+chr;
          read(chr);
        end;
        if chr<>',' then
          s:=s+chr;
        goodstr(s);
        inc(ob[obc].tc);
        k:=findpr(s);
        if k=0 then begin
          inc(prc);
          k:=prc;
          pr[k].name:=s;
          pr[k].door:=0;
          pr[k].got:=false;
        end;
        ob[obc].t[ob[obc].tc]:=k;
      end;
      readln();

      ob[obc].gc:=0;
      while not eoln() do begin
        s:='';
        read(chr);
        while (not eoln()) and (chr<>',') do begin
          s:=s+chr;
          read(chr);
        end;
        if chr<>',' then
          s:=s+chr;
        goodstr(s);
        inc(ob[obc].gc);
        k:=findpr(s);
        if k=0 then begin
          inc(prc);
          k:=prc;
          pr[k].name:=s;
          pr[k].door:=0;
          pr[k].got:=false;
        end;
        ob[obc].g[ob[obc].gc]:=k;
      end;
      readln();
    end;

    for z:=1 to i do begin
      readln(s);
      goodstr(s);
      k:=findpr(s);
      if k=0 then begin
        inc(prc);
        k:=prc;
        pr[k].name:=s;
        pr[k].door:=0;
        pr[k].got:=false;
      end;
      inc(rooms[j].pc);
      rooms[j].p[rooms[j].pc]:=k;
    end;
  end;

  readln(s);
  goodstr(s);
  for i:=1 to n do
    if rooms[i].name=s then begin
      sroom:=i;
      break;
    end;
  readln(s);
  goodstr(s);
  for i:=1 to n do
    if rooms[i].name=s then begin
      proom:=i;
      break;
    end;

  while true do begin
    checktime;
    fillchar(u,sizeof(u),false);
    dfs(sroom);
  end;
end.
