{$I-,Q-,R-,S-}

const
  coutfile = 'sumtwo.out';
  cinfile = 'sumtwo.in';

  nmax = 240017;

type
  int = longint;
  real = extended;

var
  n, k, m : int;
  ans : int;

  a : array [1..nmax] of int;

procedure outdata;
var
  i, j : int;
begin

  writeln;
end;

procedure heapsort;
var
  l, r : int;
  x : int;

  procedure sift;
  var
    i, j : int;
  begin
    x:= a[l];
    i:= l;
    j:= i shl 1;
    if (j < r) and (a[j+1] > a[j]) then inc(j);
    while (j <= r) and (x < a[j]) do
    begin
      a[i]:= a[j];
      i:= j;
      j:= i shl 1;
      if (j < r) and (a[j+1] > a[j]) then inc(j);
    end;
    a[i]:= x;
  end;

begin
  r:= n;
  for l:= n shr 1 downto 1 do sift;
  l:= 1;
  for r:= n-1 downto 1 do
  begin
    x:= a[1];
    a[1]:= a[r+1];
    a[r+1]:= x;
    sift;
  end;
end;

procedure solve;
var
  i, j : int;
  l, r : int;
begin
  heapsort;
  l:= 1;
  r:= n;
  while true do
  begin
    write(a[r],' ');
    dec(r);
    if r < l then break;
    write(a[l],' ');
    inc(l);
    if r < l then break;
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
  for i:= 1 to n do read(a[i]);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.