program Temp;
const infile = 'sumtwo.in';
      outfile = 'sumtwo.out';
      MAXN = 239017;
type int = longint;
var N : int;
    ar, ar2 : array[1..MAXN] of int;

procedure ReadData;
var i : int;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N);
  for i:=1 to N do read(ar[i]);
end;

procedure swap(var A, B : int);
var t : int;
begin
  t:=A; A:=B; B:=t;
end;

procedure Heapify(i, hs : int);
var l, r, largest : int;
begin
  repeat
    l:=2*i; r:=2*i+1; largest:=i;
    if (l<=hs)and(ar[l]>ar[largest]) then largest:=l;
    if (r<=hs)and(ar[r]>ar[largest]) then largest:=r;
    if largest=i then break;
    swap(ar[i], ar[largest]); i:=largest;
  until false;
end;

procedure HeapSort;
var i : int;
begin
  for i:=(N div 2) downto 1 do Heapify(i, N);
  for i:=N downto 2 do
  begin
    swap(ar[i], ar[1]);
    Heapify(1,i-1);
  end;
end;

procedure Solve;
var i : int;
    max : int;
begin
  HeapSort;
  for i:=1 to (N div 2) do
  begin
    ar2[i*2-1]:=ar[N-i+1];
    ar2[i*2]:=ar[i];
  end;
  if (N mod 2)=1 then ar2[N]:=ar[N div 2+1];
  max:=-MAXLONGINT;
  for i:=1 to N-1 do if ar2[i]+ar2[i+1]>max then max:=ar2[i]+ar2[i+1];
  writeln(max);
  for i:=1 to N do write(ar2[i], ' ');
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.