{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Const MaxN=2000100000;
      MaxC=1260;
Const INPUTFILE='sumcubes.in';
      OUTPUTFILE='sumcubes.out';

Type Real=Double;

var Cube:Array[0..MaxC] of Longint;
    Ans:Array[1..8] of Longint;
    N:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
if Answer=-1 then
  Writeln('IMPOSSIBLE')
else
begin
  for i:=1 to 8 do
    if Ans[i]<>0 then Write(Ans[i],' ');
end;
Close(Output);
Halt;
end;

Function Try(i,k:Longint):Integer;
var j,g,h:Longint;
begin
if i=0 then
begin
  Try:=0;
  Exit;
end;

j:=Round(Exp(Ln(i)/3));
if Cube[j]>i then Dec(j);
if k=1 then
begin
  if Cube[j]=i then
    Try:=j
  else
    Try:=-1;
  Exit;
end;

Repeat
  g:=Try(i-Cube[j],k-1);
  if g>=0 then Break;
  Dec(j);
Until j=0;
if j=0 then
  Try:=-1
else
  Try:=j;
end;

Procedure Solve;
var k,g,h:Longint;
begin
for i:=0 to MaxC do
  Cube[i]:=i*i*i;
FillChar(Ans,SizeOf(Ans),0);
Ans[1]:=g;
g:=Try(N,8);
if g<>-1 then
begin
  h:=N-Cube[g];
  Ans[1]:=g;
  for i:=2 to 8 do
  begin
    g:=Try(h,9-i);
    Ans[i]:=g;
    Dec(h,Cube[g]);
  end;
end;

if g<>-1 then
begin
  h:=0;
  for i:=1 to 8 do
    Inc(h,Cube[Ans[i]]);
  if h<>N then Halt(43);
end;
FWrite(g);
end;

begin
FRead;
Solve;
end.