const NUMCARD=250000;
var crd,ncrd:array[1..NUMCARD]of longint;
    n:longint;

procedure Load;
var i:longint;
begin
     read(n);
     for i:=1 to n do begin
         read(crd[i]);
     end;
end;

procedure Qsort(be,en:longint);
var l,r,x,t:longint;
begin
     x:=crd[random(en-be+1)+be];
     l:=be;
     r:=en;
     while l<=r do begin
           while crd[l]>x do inc(l);
           while crd[r]<x do dec(r);
           if l<=r then  begin
              t:=crd[l];
              crd[l]:=crd[r];
              crd[r]:=t;
              inc(l);
              dec(r);
           end;
     end;
     if r>be then Qsort(be,r);
     if l<en then Qsort(l,en);
end;

procedure Solve;
var i,ccrd,l,r:longint;
begin
     Qsort(1,n);
     l:=1;
     r:=n;
     ccrd:=1;
     while ccrd<=n do begin
           ncrd[ccrd]:=crd[l];
           inc(l);
           inc(ccrd);
           ncrd[ccrd]:=crd[r];
           inc(ccrd);
           dec(r);
     end;
end;

procedure Save;
var max,i:longint;
begin
     max:=-2000000009;
     for i:=1 to n-1 do begin
         if ncrd[i]+ncrd[i+1]>max then max:=ncrd[i]+ncrd[i+1];
     end;
     writeln(max);
     for i:=1 to n do begin
         write(ncrd[i]);
         if i<n then write(' ');
     end;
end;

begin
     assign(input,'sumtwo.in');
     assign(output,'sumtwo.out');
     reset(input);
     rewrite(output);
     randomize;
     Load;
     Solve;
     Save;
     close(input);
     close(output);
end.
