{$I-,Q-,R-,S-}
{$O1+,O2+}

const
  MAXK = 1260;
  MAXIT = 8;
type
  Integer = Longint;
var
  n: Longint;
  cu, ans: array[0..MAXK] of Longint;

procedure Init();
begin
  assign(Input, 'sumcubes.in');
  reset(Input);
  Assign(OUtput, 'sumcubes.out');
  rewrite(output);

  Read(n);
end;

procedure Solve();
var i, it, u: Longint;
begin
  for i := 1 to MAXK do cu[i] := i*i*i;

  it := 0;
  u := MAXK;

  while (n > 0) and (it <= MAXIT) do
  begin
    if cu[u] > n then Dec(u) else
    begin
      inc(ans[0]);
      ans[ans[0]] := u;
      Dec(n, cu[u]);
      inc(it);
    end;
  end;
  if it > MAXIT then n := 10;
end;

procedure Done;
var i: Longint;
begin
  if n > 0 then writeln('IMPOSSIBLE') else
    for i := 1 to ans[0] do write(ans[i], ' ');

  close(input);
  close(output);
end;

begin
  Init();
  Solve();
  Done();
end.