{$I-,Q-,R-,S-}
const
  MAXN = 239100;
type
  Integer = Longint;
  TArray = array[0..MAXN] of Longint;
var
  a, b, c: TArray;
  n, Max: Longint;

procedure Init();
var i: Longint;
begin
  Assign(Input, 'sumtwo.in');
  Reset(Input);
  Assign(Output, 'sumtwo.out');
  Rewrite(Output);
  Read(n);
  for i := 1 to n do Read(a[i]);
end;

procedure HeapIfy(const k: Longint);
var
  IsEnd: Boolean;
  l, i, s, Tmp: Longint;
begin
  IsEnd := False;
  i := k;

  while not IsEnd do
  begin
    IsEnd := True;
    l := a[i];
    s := i;
    if (i * 2 <= a[0]) then if (a[i * 2] < l) then
    begin
      l := a[i * 2];
      IsEnd := False;
      s := i * 2;
    end;
    if (i * 2 + 1 <= a[0]) then if (a[i * 2 + 1] < l) then
    begin
      l := a[i * 2 + 1];
      IsEnd := False;
      s := i * 2 + 1;
    end;
    if not IsEnd then
    begin
      Tmp := a[i];
      a[i] := a[s];
      a[s] := Tmp;
      i := s;
    end;
  end;
end;

procedure HeapSort();
var i: Longint;
begin
  a[0] := n;
  for i := n div 2 + 1 downto 1 do Heapify(i);
  for i := 1 to n do
  begin
    b[i] := a[1];
    a[1] := a[n - i + 1];
    Dec(a[0]);
    Heapify(1);
  end;
end;

procedure Solve();
var lu, ru, u, i: Longint;
begin
  HeapSort();
  lu := 0;
  ru := n + 1;
  u := 0;
  while lu < ru do
  begin
    Dec(ru);
    if lu < ru then
    begin
      inc(u);
      c[u] := b[ru];
    end;

    Inc(lu);
    if lu < ru then
    begin
      inc(u);
      c[u] := b[lu];
    end;
  end;

  Max := 0;
  for i := 1 to n - 1 do if c[i] + c[i + 1] > Max then Max := c[i] + c[i + 1];

end;

procedure Done();
var i: Longint;
begin
  Writeln(Max);
  for i := 1 to n do write(c[i], ' ');

  Close(input);
  Close(output);
end;

begin
  Init();
  Solve();
  Done();
end.
