{$A+,B-,D+,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
const infile='dist.in'; outfile='dist.out';
type TLexemType=(lxLetter,lxArrow,lxOpen,lxClose,lxZap);
     TLexem=record
              lt:TLexemType;
              lv:string[2];
            end;
var
  s,m:string;
  lex:array[1..300] of TLexem;
  lexnum,i,j,k,v:longint;
  cl:array[1..300] of longint;
  a:array[1..26,1..26] of longint;
  en:array[1..26] of longint;

procedure processtree(l,r:longint; var m:string);forward;
procedure processlist(l,r:longint; var m:string);forward;

procedure ml;
var i:longint;
begin
  for i:=1 to ord(s[0]) do
    case s[i] of
      'A'..'Z':begin
                 inc(lexnum);
                 lex[lexnum].lt:=lxLetter;
                 lex[lexnum].lv:=s[i];
               end;
      '-':begin
            inc(lexnum);
            lex[lexnum].lt:=lxArrow;
            lex[lexnum].lv:='->';
          end;
      ',':begin
            inc(lexnum);
            lex[lexnum].lt:=lxZap;
            lex[lexnum].lv:=',';
          end;
      '(':begin
            inc(lexnum);
            lex[lexnum].lt:=lxOpen;
            lex[lexnum].lv:='(';
          end;
      ')':begin
            inc(lexnum);
            lex[lexnum].lt:=lxClose;
            lex[lexnum].lv:=')';
          end;
    end;
end;

procedure procbrack;
var i,j,w:longint;
begin
  for i:=1 to lexnum-1 do
    if lex[i].lv='(' then
    begin
      j:=i;
      w:=1;
      while w>0 do
      begin
        inc(j);
        if lex[j].lv=')' then dec(w);
        if lex[j].lv='(' then inc(w);
      end;
      cl[i]:=j;
    end else cl[i]:=0;
end;

procedure processlist(l,r:longint; var m:string);
var i,j,k,last,w:longint;
    m_:string;
    is:boolean;
begin
  while (lex[l].lv='(')and(cl[l]=r) do
  begin
    inc(l);
    dec(r);
  end;
  last:=r+1;
  m:='';
  for i:=r downto l do
  begin
    if lex[i].lv='(' then dec(w);
    if lex[i].lv=')' then inc(w);
    if (lex[i].lv=',')and(w=0) then
    begin
      processtree(i+1,last-1,m_);
      for j:=1 to ord(m_[0]) do
      begin
        is:=false;
        for k:=1 to ord(m[0]) do
          if m[k]=m_[j] then
          begin is:=true; break; end;
        if not is then m:=m+m_[j];
      end;
      last:=i;
    end;
  end;
  processtree(l,last-1,m_);
  for j:=1 to ord(m_[0]) do
  begin
    is:=false;
    for k:=1 to ord(m[0]) do
      if m[k]=m_[j] then
      begin is:=true; break; end;
    if not is then m:=m+m_[j];
  end;
end;

procedure processtree(l,r:longint; var m:string);
var i,last,w,j,k:longint;
    mp,ml:string;
begin
  while (lex[l].lv='(')and(cl[l]=r) do
  begin
    inc(l);
    dec(r);
  end;
  m:='';
  if l=r then
  begin
    m:=lex[l].lv;
    exit;
  end;
  last:=r+1;
  mp:='';
  ml:='';
  for i:=r downto l do
  begin
    if lex[i].lv='(' then dec(w);
    if lex[i].lv=')' then inc(w);
    if (lex[i].lt=lxArrow)and(w=0) then
    begin
      mp:=ml;
      processlist(i+1,last-1,ml);
      for j:=1 to ord(ml[0]) do
        for k:=1 to ord(mp[0]) do
        begin
          a[ord(ml[j])-ord('A')+1,ord(mp[k])-ord('A')+1]:=1;
          a[ord(mp[k])-ord('A')+1,ord(ml[j])-ord('A')+1]:=1;
        end;
      last:=i;
      m:=ml;
    end;
  end;
  mp:=ml;
  processlist(l,last-1,ml);
  for j:=1 to ord(ml[0]) do
    for k:=1 to ord(mp[0]) do
    begin
      a[ord(ml[j])-ord('A')+1,ord(mp[k])-ord('A')+1]:=1;
      a[ord(mp[k])-ord('A')+1,ord(ml[j])-ord('A')+1]:=1;
    end;
  last:=i;
  m:=ml;
end;

begin
  for i:=1 to 26 do
    for j:=1 to 26 do
      a[i,j]:=1000;
  fillchar(en,sizeof(en),0);
  lexnum:=0;
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  readln(s);
  close(input);
  ml;
  procbrack;
  for i:=1 to lexnum do
    if lex[i].lt=lxLetter then
    en[ord(lex[i].lv[1])-ord('A')+1]:=1;
  for i:=1 to 26 do
    if en[i]=1 then m:=m+chr(i+ord('A')-1);
  processlist(1,lexnum,m);
  for i:=1 to 26 do
    a[i,i]:=0;
  for k:=1 to 26 do
    for i:=1 to 26 do
      for j:=1 to 26 do
        if a[i,k]+a[k,j]<a[i,j] then
        begin
          a[i,j]:=a[i,k]+a[k,j];
          a[j,i]:=a[i,j];
        end;
  v:=ord(m[1])-ord('A')+1;
  for i:=1 to 26 do
    if en[i]=1 then
      writeln(chr(ord('A')+i-1),' ',a[i,v]);
  close(output);
end.