{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_b;
const
  inpfile='young.in';
  outfile='young.out';
  osn=10000;
  inf=10000;
  nm=1005;
  lm=10;
type
  TLong = array [0..lm] of LongInt;
var
  a : array [0..nm,0..nm] of TLong;
  c : array [0..2*nm] of LongInt;
  n : LongInt;
  res,ed : TLong;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do read(c[i]);
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  write(res[res[0]]);
  for i:=res[0]-1 downto 1 do begin
    if res[i]<1000 then write(0);
    if res[i]<100 then write(0);
    if res[i]<10 then write(0);
    write(res[i]);
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(c,sizeof(c),0);
  fillchar(ed,sizeof(ed),0);
  ed[0]:=1; ed[1]:=1;
end;
{}
Procedure Sum(q,w : TLong; var r : TLong);
var
  i,p : LongInt;
begin
  fillchar(r,sizeof(r),0); p:=0;
  if q[0]>w[0] then r[0]:=q[0]+1
               else r[0]:=w[0]+1;
  for i:=1 to r[0] do begin
    p:=q[i]+w[i]+p;
    r[i]:=p mod osn;
    p:=p div osn;
  end;
  if r[r[0]]=0 then dec(r[0]);
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
  ok : Boolean;
begin
  a[n,1,0]:=1; a[n,1,1]:=1;
  for i:=1 to n do c[n+i]:=inf;
  for i:=n-1 downto 1 do begin
    for j:=1 to n-i+1 do begin
      if (c[i+j-2]>c[i+j-1]) and (j>1) then break;
      for k:=i+j to i+2*j-1 do begin
        if c[k]<c[k-j] then break;
        if i+j>n then begin Sum(a[i,j],ed,a[i,j]); break; end
                 else Sum(a[i,j],a[i+j,k-i-j+1],a[i,j]);
      end;
    end;
  end;

  res[0]:=0;
  fillchar(res,sizeof(res),0);
  for i:=1 to n do
    Sum(res,a[1,i],res);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.