{$I-,Q-,R-,S-}

const
  coutfile = 'young.out';
  cinfile = 'young.in';

  nmax = 1110;

  dig = 8;
  base = 100000000;

type
  int = longint;
  real = extended;

  thuge = array [0..6] of int;

var
  n, k, m : int;
  ans : thuge;

  p : array [1..nmax] of int;
  lb : array [1..nmax,1..nmax] of int;{index of left less element}
  ok : array [1..nmax,1..nmax] of boolean;
  a : array [0..nmax,0..nmax] of thuge;

procedure writehuge(var a : thuge);
var
  i, j : int;
  s : string[dig];
begin
  write(a[a[0]]);
  for i:= a[0]-1 downto 1 do
  begin
    str(a[i],s);
    for j:= length(s) to dig-1 do write('0');
    write(s);
  end;
  writeln;
end;

procedure addhuge(var a, b : thuge);
var
  r, i : int;
begin
  r:= 0;
  if a[0] < b[0] then a[0]:= b[0];
  for i:=1  to a[0] do
  begin
    a[i]:= a[i] + b[i] + r;
    r:= a[i] div base;
    a[i]:= a[i] - r*base;
  end;
  while r <> 0 do
  begin
    inc(a[0]);
    a[a[0]]:= r mod base;
    r:= r div base;
  end;
end;

procedure outdata;
var
  i, j : int;
begin
  writehuge(ans);
end;

procedure solve;
var
  i, j, r : int;
  l, si : int;
  max : int;
begin
  fillchar(lb,sizeof(lb),0);
  for i:= 1 to n do {n^2}
  begin
    l:= i;
    for j:= i-1 downto 1 do
      if p[i] > p[j] then
      begin
        for r:= j to l do lb[i,r]:= j;
        l:= j-1;
      end;
  end;
  fillchar(ok,sizeof(ok),0);
  for i:= 1 to n do ok[i,i]:= true;
  for i:= 1 to n do            {n^2}
    for j:= i+1 to n do ok[i,j]:= ok[i,j-1] and (p[j] > p[j-1]);
  fillchar(a,sizeof(a),0);
  for i:= 0 to n do
    for j:= 0 to n do a[i,j,0]:= 1;
  for i:= n downto 1 do  {n}
    if ok[1,i] then
    begin
      a[i,i,1]:= 1;
      a[i,i,0]:= 1;
    end;
  for r:= 1 to n-1 do
  begin
    j:= 1;
    i:= r+1;
    si:= i;
    max:= lb[i,i-1];
    while i <= n do
    begin
      if ok[i-j+1,i] then
      begin
        a[i,j]:= a[i,j+1];
        if i-j-max+1 >= j then addhuge(a[i,j],a[i-j,i-j-max+1]) else
          addhuge(a[i,j],a[i-j,j])
      end;
      inc(i);
      inc(j);
      if max < lb[i,si-1] - i + si then max:= lb[i,si-1] - i + si;
    end;
  end;
  ans:= a[n,1];
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
  for i:= 1 to n do read(p[i]);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
