{$A-,B-,D-,E-,F-,G-,I+,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 16384,0,655360}

Const MaxP=26;
Const INPUTFILE='dist.in';
      OUTPUTFILE='dist.out';
Const INF=1061109567;

Type Real=Double;
     TTree=record
     Root:Char;
     P:Integer;
     Child:Array[1..MaxP] of Byte;
     end;

var a:Array[1..MaxP] of TTree;
    mat:Array[1..MaxP,1..MaxP] of Longint;
    s,OS:String;
    Root:Byte;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Readln(s);
Close(Input);
{s:=s+'#';}
OS:=s;
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
for i:=1 to 26 do
  if mat[Root,i]<INF then
    Writeln(Chr(i+Ord('A')-1),' ',mat[Root,i]);
Close(Output);
Halt;
end;

Function ReadTree(s:String):Byte;
var i,j,g,h,L,m,n,b:Integer;

    s1,s2:String;
begin
Repeat
  m:=0;
  j:=0;
  L:=Length(s);
  i:=1;
  While (i<=L) AND (m=0) Do
  begin
    if s[i]='(' then
      j:=i
    else if s[i]=')' then
    begin
      s1:=Copy(s,j+1,i-j-1);
      s1:=s1+',';
      h:=1;
      Repeat
        g:=Pos(',',s1);
        if g=0 then Break;
        s2:=Copy(s1,h,g-h);
        b:=ReadTree(s2);
        Delete(s1,h,g-h+1);
        s1:=Chr(b+Ord('A')-1)+s1;
        Inc(h);
      Until g=0;
      Delete(s,j,i-j+1);
      Insert(s1,s,j);
      m:=1;
    end;
    Inc(i);
  end;
Until m=0;
s1:='';
s2:='';
Repeat
  m:=0;
  L:=Length(s);
  i:=L;
  While (i>0) AND (s[i]<>'>') Do Dec(i);
  if i>0 then
  begin
    j:=Ord(s[i-2])-Ord('A')+1;
    g:=i;
    Inc(i);
    While i<=L Do
    begin
      Inc(a[j].P);
      a[j].Child[a[j].P]:=Ord(s[i])-Ord('A')+1;
      Inc(i);
    end;
    Delete(s,g-1,L);
    m:=1;
  end;
Until m=0;
if L<>1 then
  FWrite(-1)
else
  ReadTree:=Ord(s[1])-Ord('A')+1;
end;

Procedure Solve;
var g,h,k:Longint;
begin
for i:=1 to 26 do
  a[i].Root:=Chr(i+Ord('A')-1);
Root:=ReadTree(s);

FillChar(Mat,SizeOf(Mat),63);
for i:=1 to 26 do
for j:=1 to a[i].P do
begin
  mat[i,a[i].Child[j]]:=1;
  mat[a[i].Child[j],i]:=1;
end;
for i:=1 to 26 do
  mat[i,i]:=0;

for k:=1 to 26 do
for i:=1 to 26 do
for j:=1 to 26 do
  if mat[i,k]+mat[k,j]<mat[i,j] then mat[i,j]:=mat[i,k]+mat[k,j];

FWrite(1543);
end;

begin
FRead;
Solve;
end.