const
     FileIn='young.in';
     FileOut='young.out';
     MaxN=1000;
var
   N: LongInt;
   Numbers: array [1..MaxN] of LongInt;
   Answer: LongInt;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=1 to N
         do Read (F, Numbers [NItem]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

var
   MaxInColumnBeforeRow: array [1..MaxN, 0..MaxN] of LongInt;

procedure Go (aNumbersUsed: LongInt; aLastRowLength: LongInt; aRow: LongInt);
var
   NColumn: LongInt;
   MaxInRow: LongInt;
begin
     MaxInRow:=0;
     for NColumn:=1 to aLastRowLength
         do if aNumbersUsed+NColumn>N
               then Break
               else begin
                    if (MaxInRow>=Numbers [aNumbersUsed+NColumn]) or (MaxInColumnBeforeRow [NColumn, aRow-1]>=Numbers [aNumbersUsed+NColumn])
                       then Break;
                    MaxInColumnBeforeRow [NColumn, aRow]:=Numbers [aNumbersUsed+NColumn];
                    MaxInRow:=Numbers [aNumbersUsed+NColumn];
                    if aNumbersUsed+NColumn>=N
                       then Inc (Answer)
                       else Go (aNumbersUsed+NColumn, NColumn, aRow+1);
               end;
end;

procedure Solve;
begin
     FillChar (MaxInColumnBeforeRow, SizeOf (MaxInColumnBeforeRow), 0);
     Answer:=0;
     Go (0, N, 1);
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
