program zzz;

var
  cur,i,j,k,n,m: Longint;
  g: array['A'..'Z','A'..'Z'] of boolean;
  kor,cc: char;
  q: array[1..30] of char;
  d: array[1..30] of Longint;
  bol,vis: array['A'..'Z'] of Boolean;
  ans: array['A'..'Z'] of Longint;
  s: string;

function next(): char;
begin
  while cur <= length(s) do if s[cur] <> ' ' then break;
  if cur > length(s) then next := '#' else begin
    next := s[cur];
    if s[cur] = '-' then inc(cur,2) else inc(cur);
  end;
end;

function isforest(pos: Longint): Boolean;
var i,cur: Longint;
begin
  cur := 1;
  isforest := true;
  for i := pos to length(s) do begin
    if cur = 0 then break;
    if cur = 1 then begin
      if s[i] = ','then exit;
    end;
    if s[i] = '('then inc(cur);
    if s[i] = ')'then dec(cur);
  end;
  isforest := false;
end;

function tree(prev: char): char; forward;
procedure forest(prev: char);
var ch: char;
begin
  ch := tree(prev);
  g[ch,prev] := true;
  g[prev,ch] := true;
  while cc = ',' do begin
    ch := tree(prev);
    g[ch,prev] := true;
    g[prev,ch] := true;
  end;
end;

function tree(prev: char): char;
var buf,ans: char;
begin
  cc := next();
  if cc = '(' then begin
    if isforest(cur) then begin
      forest(prev);
      cc := next();
    end else begin
      buf := tree('!');
      if prev <> '!'then begin
        g[prev,buf] := true;
        g[buf,prev] := true;
      end;
      cc := next();
      if cc = '-' then tree(buf);
    end;
  end else begin
    if cc in ['A'..'Z'] then begin
      if prev <>'!' then begin
        g[prev,cc] := true;
        g[cc,prev] := true;
      end;
      buf := cc;
      cc := next();
      if cc = '-' then tree(buf);
    end;
  end;
  tree := buf;
end;

procedure bfs();
var t,p,i,j: Longint;
    ch: char;
begin
  t := 1;
  p := 1;
  ans[kor] := 0;
  d[1] := 0;
  q[1] := kor;
  vis[kor] := true;
  while t <= p do begin
    for i := ord('A') to ord('Z') do begin
      ch :=chr(i);
      if g[q[t],ch] and not vis[ch] then begin
        vis[ch] := true;
        inc(p);
        ans[ch] := d[t] + 1;
        d[p] := d[t] + 1;
        q[p] := ch;
      end;
    end;
    inc(t);
  end;
end;

begin
  assign(input,'dist.in'); reset(input);
  assign(output,'dist.out'); rewrite(output);
  cur := 1;
  readln(s);
  kor := tree('!');
  bfs();
  for i := 1 to length(s) do begin
    if s[i] in ['A'..'Z'] then bol[s[i]] := true;
  end;
  for i := ord('A') to ord('Z') do begin
    if bol[chr(i)] then writeln(chr(i),' ',ans[chr(i)]);
  end;
  close(input);
  close(output);
end.
