program zzz;

const
  osn = 100000000;

type
  tlong = array[0..6] of Longint;

var
  buf,one: tlong;
  cur: array[1..1001] of Tlong;
  i,j,k,n,m,t,cc: Longint;
  incr,p: array[1..1001] of Longint;
  a: array[1..1000,1..1000] of Tlong;
  dis: array[1..1000,1..1000] of Longint;

function min(a,b: Longint): Longint;
begin
  if a > b then min := b else min := a;
end;

function max(a,b: Longint): Longint;
begin
  if a > b then max := a else max := b;
end;

procedure sumlong(a,b: Tlong; var c: Tlong);
var i,j: Longint;
begin
  for i := 1 to max(a[0],b[0]) do begin
    c[i] := a[i] + b[i];
  end;
  for i := 1 to max(a[0],b[0]) do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] mod osn;
  end;
  c[0] := max(a[0],b[0]) + 1;
  while (c[c[0]] = 0) and (c[0] <> 0) do dec(c[0]);
end;

procedure printlong(a: TLong);
var i,j: Longint;
begin
  write(a[a[0]]);
  for i := a[0]-1 downto 1 do begin
    j := osn;
    while j <> 1 do begin
      j := j div 10;
      write(a[i] div j);
      a[i] := a[i] mod j;
    end;
  end;
  writeln;
end;

procedure zero(var a: Tlong);
var i: Longint;
begin
  for i := a[0] downto 1 do a[i] := 0;
  a[0] := 0;
end;

begin
  assign(input,'young.in'); reset(input);
  assign(output,'young.out'); rewrite(output);
  fillchar(a,sizeof(a),0);
  fillchar(cur,sizeof(cur),0);
  fillchar(buf,sizeof(buf),0);
  one[1] := 1;
  one[0] := 1;
  read(n);
  for i := 1 to n do read(p[i]);
  for i := 1 to n do begin
    cc := i+1;
    k := 0;
    for j := i+1 to n do begin
      if p[j-i] > p[j] then begin
        for t := cc to j do begin
          dis[t-i,t] := k-t+cc;
        end;
        k := 0;
        cc := j+1;
      end else inc(k);
    end;
    for t := cc to n do begin
      dis[t-i,t] := k-t+cc;
    end;
  end;
{  for i := 1 to n do begin
    for j := 1 to n do begin
      write(dis[i,j],' ');
    end;
    writeln;
  end;}
  for i := 1 to n do begin
    for j := i+1 to n+1 do begin
      if p[j] < p[j-1] then break;
    end;
    incr[i] := j-i;
  end;
{  for i := 1 to n do write(incr[i],' ');}
  for i := 1 to n do begin
    if incr[1] >= i then sumlong(a[1,i],one,a[1,i]);
  end;
  for i := 2 to n do begin
    zero(buf);
    for j := 1 to i-1 do zero(cur[j]);
    for j := 1 to i-1 do begin
      k := min(dis[j,i],i-j);
      if k = 0 then continue;
      sumlong(cur[k],a[j,i-1],cur[k]);
    end;
    for j := 1 to i-1 do begin
      sumlong(buf,cur[i-j],buf);
      if incr[i] >= i-j then sumlong(a[i,i+i-j-1],buf,a[i,i+i-j-1]);
    end;
  end;
  zero(buf);
  for i := 1 to n do begin
    sumlong(buf,a[i,n],buf);
  end;
  printlong(buf);
  close(input);
  close(output);
end.
