program asd;
var d:array['A'..'Z'] of integer;
    is,qis:array['A'..'Z'] of boolean;
    edges:array[1..700,1..2] of char;
    edgnum:integer;
    b:char;
    s:string;
    que:array [1..200] of char;
 {
procedure readtree(l,r:integer); forward;
procedure readforest(l,r:integer); forward;
procedure readlist(l,r:integer); forward;


procedure doedges(l,r:integer);
var i,j:integer;
begin
        for i:= l to r do begin
                if (s[i] in ['A'..'Z'])and (i>3) then begin
                        inc(edgnum);
                        edges[edgnum,1]:=s[i-3];
                        edges[edgnum,2]:=s[i];
                end;
        end;

end;


procedure readtree(l,r:integer);
var i,j:integer;
    c:char;
begin
        if l<r then exit;
        if (s[l]='(')and(s[r]=')') then begin dec(r);inc(r) end;
        for i:= l to r do if s[l]='(' then break;
        if i<r then begin
                doedges(l,i-3);
                c:=s[i-3];
                for j:= i to l do begin
                        if (s[j] in ['A'..'Z']) and
                                ((s[j-1]=',')or(s[j-1]='(')) then begin
                                inc (edgnum);
                                edges[edgnum,1]:=c;
                                edges[edgnum,2]:=s[j];
                        end;

                end;

                readlist(i+1,r-1);
        end
        else doedges(l,r);
end;


procedure readforest(l,r:integer);
begin
        if l<r then exit;
        if (s[l]='(') and (s[r]=')') then readlist(l+1,r-1)
        else readtree(l,r);
end;

procedure readlist(l,r:integer);
var i,j:integer;
        c:char;
begin
     if l<r then exit;
     for i:= l to r do if s[i]=',' then break;
     if (i<r) and (i>l) then begin
        readtree(l,i-1);readlist(i+1,r);
     end
     else readtree(l,r);
end;
                }

procedure doedge(a,b:char);
begin
        inc(edgnum);
        edges[edgnum,1]:=a;
        edges[edgnum,2]:=b;
end;

procedure load;
var c:char;
    i,l,j,k,q,w,e:integer;
begin
        edgnum:=0;
        fillchar(d,sizeof(d),1);
        fillchar(is,sizeof(is),0);
        read(s);
        l:=length(s);
        for i:= 1 to l do if s[i] in ['A'..'Z'] then is[s[i]]:=true;
        qis:=is;
        i:=pos('->',s) ;
        while i>0 do begin
                if s[i-1] in ['A'..'Z'] then begin
                        if s[i+2] in ['A'..'Z'] then doedge(s[i-1],s[i+2])
                        else begin
                                k:=0;
                                for j:= i+2 to l do begin
                                        if s[j]='(' then inc(k);
                                        if s[j]=')' then dec(k);
                                        if k=0 then break;
                                end;
                                for k:=i+2 to j do if (s[k-1]=',') then begin
                                        for q:=k to l do if s[q] in ['A'..'Z']  then break;
                                        doedge(s[i-1],s[q]);
                                end;
                                for q:=i+2 to l do if s[q] in ['A'..'Z']  then break;
                                doedge(s[i-1],s[q]);
                        end;
                end
                else if s[i+2] in ['A'..'Z'] then begin
                        k:=0;
                        for j:= i-1 downto 1 do begin
                                   if s[j]='(' then inc(k);
                                   if s[j]=')' then dec(k);
                                   if k=0 then break;
                        end;
                        for q:=k to l do if s[q] in ['A'..'Z']  then break;
                        doedge(s[q],s[i+2]);
                end
                else begin
                        k:=0;
                        for j:= i-1 downto 1 do begin
                                   if s[j]='(' then inc(k);
                                   if s[j]=')' then dec(k);
                                   if k=0 then break;
                        end;
                        for e:=k to l do if s[q] in ['A'..'Z']  then break;
                                k:=0;
                                for j:= i+2 to l do begin
                                        if s[j]='(' then inc(k);
                                        if s[j]=')' then dec(k);
                                        if k=0 then break;
                                end;
                                for k:=i+2 to j do if (s[k-1]=',') then begin
                                        for q:=k+1 to l do if s[q] in ['A'..'Z']  then break;
                                        doedge(s[e],s[q]);
                                end;
                                for k:= i to l do if s[k] in ['A'..'Z'] then break;
                                for q:=i+2 to l do if s[q] in ['A'..'Z']  then break;
                                doedge(s[e],s[q]);

                end;
                s[i]:='_';
                i:=pos('->',s);
        end;
end;

procedure solve;
var i,j,k,q,be,en:integer;
    c:char;
begin
        for i:= 1 to edgnum do begin
                edges[i+edgnum,1]:=edges[i,2];
                edges[i+edgnum,2]:=edges[i,1];
        end;
        edgnum:=edgnum*2;
        for q:=1 to length(s) do if s[q] in ['A'..'Z'] then break;
        que[1]:=s[q];
        be:=1;
        en:=1;
        d[que[1]]:=0;
        QIS[QUE[1]]:=FALSE;
        while be<=en do begin
                for i:= 1 to edgnum do begin
                        if (edges[i,1]=que[be])and(qis[edges[i,2]]) then begin
                                inc(en);
                                que[en]:=edges[i,2];
                                qis[que[en]]:=false;
                                d[que[en]]:=d[que[be]]+1;
                        end;

                end;
                inc(be);
        end;
        for c:='A' to 'Z' do if is[c] then writeln(c,' ',d[c]);
end;


begin
        assign(input,'dist.in');
        assign(output,'dist.out');
        reset(input);
        rewrite(output);
        load;
        solve;
        close(output);
end.