type integer=longint;
var
   n: integer;
   a: array[1..1000]of integer;
   cnt: int64;
   m: array[0..1000,1..1000] of integer;
   d: array[0..1000,1..1000] of int64;
   prev:array[0..1000] of integer;


procedure init;
var
   i: integer;
begin
   assign(input, 'young.in'); reset(input);
   assign(output, 'young.out'); rewrite(output);
   readln(n);
   for i:= 1 to n do
    read(a[i]);
end;

procedure done;
begin
   close(input);
   close(output);
end;

procedure build(i, j, k: integer);
begin
   if j> prev[i-1] then exit;
   if (i>1)and(a[k]<m[i-1,j]) then exit;
   if (j>1)and(a[k]<m[i, j-1]) then exit;

   m[i, j]:=a[k];
   inc(prev[i]);

   if k=n then
    inc(cnt)
   else
   begin
    build(i, j+1, k+1);
    build(i+1, 1, k+1);
   end;

   m[i, j]:= 0;
   dec(prev[i]);
end;

function min(a, b: integer): integer;
begin
   if a< b then min := a else min := b;
end;


procedure solve2;
var
   i, j, k: integer;
begin
   for i:=1 to n do
   begin
      d[i,1]:=1;
      d[1,i]:=1;
      d[0,i]:=1;
   end;


   for i:=2 to n do
    for j:=2 to n do
    begin
      d[i,j]:=0;
      for k:=1 to min(i,j) do
       inc(d[i,j], d[i-k,k]);
    end;

   cnt:= d[n, n];
end;
function vozr:boolean;
var
   i: integer;
begin
   for i:=1 to n do
    if a[i]<> i then begin vozr :=false; exit end;
   vozr:=true;
end;

procedure solve;
begin
   cnt:=0;
   prev[0]:=n;
   if vozr then
    solve2 else
    if a[1]=1 then
     build(1, 1, 1);

   writeln(cnt);
end;

{


procedure solve;
var
   i, j, k: integer;
begin
   for i:=1 to n do
   begin
      d[i,1]:=1;
      d[1,i]:=1;
   end;

   for i:=2 to n do
    for j:=2 to n do
    begin
      d[i,j]:=0;
      for k:=1 to i-1 do
       inc(d[i,j], d[i-k,k]);
    end;


   writeln(d[n,n]);
end;}
begin
   init;
   solve;
   done;
end.


