  {$I-,Q-,R-,S-}
  {$M 40000000}
const maxn=1000;
type mas=array[0..maxn] of longint;
var i,n:longint;
    cur,b,c,d,e:mas;

Procedure swap(var a,b:longint);
var t:longint;
begin
     t:=a;
     a:=b;
     b:=t;
end;

Procedure convert(q:longint; var a:mas);
begin
     fillchar(a,sizeof(a),0);
     while q<>0 do
     begin
          inc(a[0]);
          a[a[0]]:=q mod 10;
          q:=q div 10;
     end;
end;

Procedure reverse(var a:mas);
var I:longint;
begin
     for i:=1 to a[0] div 2 do swap(a[i],a[a[0]-i+1]);
end;

Procedure mullong(const a,b:mas; var c:mas);
var i,j:longint;
begin
     fillchar(c,sizeof(c),0);
     for i:=1 to a[0] do
     begin
          for j:=1 to b[0] do
          begin
               c[i+j-1]:=c[i+j-1]+a[i]*b[j];
               c[i+j]:=c[i+j]+(c[i+j-1] div 10);
               c[i+j-1]:=c[i+j-1] mod 10;
          end;
     end;
     c[0]:=a[0]+b[0];
     while c[c[0]]=0 do
     begin
          dec(c[0]);
          if c[0]=1 then break;
     end;
end;

Function moreeq(const a,b:mas; l,r:longint):boolean;
var i,j:longint;
begin
     if b[0]>r-l+1 then
     begin
          moreeq:=false;
          exit;
     end else
     if b[0]<r-l+1 then
     begin
          moreeq:=true;
          exit;
     end;
     for i:=b[0] downto 1 do
     begin
          if a[r-b[0]+i]>b[i] then
          begin
               moreeq:=true;
               exit;
          end;
          if a[r-b[0]+i]<b[i] then
          begin
               moreeq:=false;
               exit;
          end;
     end;
     moreeq:=true;
end;

Procedure sublong(var a,b:mas; const l,r:longint);
var i:longint;
begin
     for i:=1 to b[0] do
     begin
          a[l+i-1]:=a[l+i-1]-b[i];
          if a[l+i-1]<0 then
          begin
            dec(a[l+i]);
            a[l+i-1]:=a[l+i-1]+10;
          end;
     end;
     if a[0]<>1 then
     while a[a[0]]=0 do
     begin
          dec(a[0]);
          if a[0]=1 then break;
     end;
end;

Procedure divmodlong(a,b:mas; var ldiv,lmod:mas);
var i,t,cnt:longint;
begin
     fillchar(ldiv,sizeof(ldiv),0);
     fillchar(lmod,sizeof(lmod),0);
     i:=a[0];
     cnt:=0;
     while i>0 do
     begin
          cnt:=0;
          while moreeq(a,b,i,a[0]) do
          begin
               t:=a[0];
               sublong(a,b,i,t);
               inc(cnt);
          end;
          inc(ldiv[0]);
          ldiv[ldiv[0]]:=cnt;
          dec(i);
     end;
     reverse(ldiv);
     while ldiv[ldiv[0]]=0 do
     begin
          dec(ldiv[0]);
          if ldiv[0]=1 then break;
     end;
     lmod:=a;
end;

procedure swaplong(var a,b:mas);
var t:mas;
begin
     t:=a;
     a:=b;
     b:=t;
end;

Function eqzero(const a:mas):boolean;
begin
     if (a[1]=0)and(a[0]=1) then eqzero:=true else eqzero:=false;
end;

Procedure gcd(const a,b:mas; var c:mas);
var i,j,t1,t2:mas;
begin
     i:=a;
     j:=b;
     if moreeq(i,j,1,i[0]) then swaplong(i,j);
     while not eqzero(i) do
     begin
          divmodlong(j,i,t1,t2);
          j:=t2;
          swaplong(i,j);
     end;
     c:=j;
end;

begin
     assign(input,'lcm.in');
     reset(input);
     assign(output,'lcm.out');
     rewrite(output);
     read(n);
     cur[0]:=1;
     cur[1]:=1;
     for i:=1 to n do
     begin
          convert(i,b);
          mullong(cur,b,c);
          GCD(cur,b,d);
          divmodlong(c,d,cur,b);
     end;
     for i:=cur[0] downto 1 do write(cur[i]);
     close(input);
     close(output);
end.
