program Temp;
const infile = 'lcm.in';
      outfile = 'lcm.out';
      OSN = 10;
      MAXL = 2000;
type int = record
  l : longint;
  v : array[0..MAXL] of longint;
end;
var N : integer;
    res : int;

procedure print0(l : longint);
var s : string;
begin
  str(l, s);
  write(s);
end;

procedure LPrint(n : int);
var i : integer;
begin
  write(n.v[n.l]);
  for i:=n.l-1 downto 1 do Print0(n.v[i]);
end;

function max(a, b : longint) : longint;
begin
  if a > b then max:=a else max:=b;
end;

procedure swap(var a, b : longint);
var t : longint;
begin
  t:=a; a:=b; b:=t;
end;

procedure swap1(var a, b : int);
var t : int;
begin
  t:=a; a:=b; b:=t;
end;

Operator + (A, B : int)C : int; Overload;
var i : integer;
    p, r, l : longint;
begin
  l:=max(A.l, B.l); C.l:=l; p:=0;
  for i:=1 to l do
  begin
    r:=A.v[i]+B.v[i]+p; p:=r div OSN; r:=r mod OSN;
    C.v[i]:=r;
  end;
  while p<>0 do begin inc(C.l); C.v[C.l]:=p mod OSN; p:=p div OSN; end;
end;

Operator - (A, B : int)C : int;
var i : integer;
    p, r, l : longint;
begin
  l:=max(A.l, B.l); C.l:=l; p:=0;
  for i:=1 to l do
  begin
    r:=A.v[i]-B.v[i]+p;
    if r<0 then begin r:=r+OSN; p:=-1; end else p:=0;
    C.v[i]:=r;
  end;
  while (C.l>1)and(C.v[C.l]=0) do dec(C.l);
end;

Operator * (A : int; B : longint)C : int; Overload;
var i : integer;
    p, r, l : longint;
begin
  fillchar(C, sizeof(C), 0);
  l:=A.l; C.l:=l; p:=0;
  for i:=1 to l do
  begin
    r:=A.v[i]*B+p; p:=r div OSN; r:=r mod OSN;
    C.v[i]:=r;
  end;
  while p<>0 do begin inc(C.l); C.v[C.l]:=p mod OSN; p:=p div OSN; end;
end;

function trans(n : int) : int;
var i, j : longint;
    t : int;
begin
  t:=n; j:=n.l;
  for i:=1 to (j div 2) do swap(t.v[i], t.v[j-i+1]);
  trans:=t;
end;

Operator := (A : longint)B : int;
begin
  fillchar(B, sizeof(B), 0);
  B.l:=1; B.v[1]:=1;
  B:=B*A;
end;

Operator * (A, B : int)C : int; Overload;
var t : int;
    i : integer;
begin
  C:=0;
  for i:=1 to A.l do
  begin
    t:=B*A.v[i];
    t:=trans(t); inc(t.l, i-1); t:=trans(t);
    C:=C+t;
  end;
end;

Operator + (A : int; B : longint)C : int; Overload;
var t : int;
begin
  t:=B; C:=A+t;
end;

function Gr(n1, n2 : int) : integer;
var i : integer;
begin
  if n1.l>n2.l then Gr:=1
  else if n1.l<n2.l then Gr:=-1
  else begin
    for i:=n1.l downto 1 do
      if n1.v[i]>n2.v[i] then begin Gr:=1; exit; end
        else if n1.v[i]<n2.v[i] then begin Gr:=-1; exit; end;
    Gr:=0;
  end;
end;

function LMod(n1, n2 : int) : int;
var t, p : int;
    i : integer;
begin
  t:=n1; p:=n1;
  for i:=n1.l-n2.l downto 0 do
  begin
    t:=n2;
    t:=trans(t); inc(t.l, i); t:=trans(t);
    while Gr(p, t)>-1 do p:=p-t;
  end;
  LMod:=p;
end;

function LDiv(n1, n2 : int) : int;
var t, ans, p : int;
    i : integer;
begin
  t:=n1; p:=n1; fillchar(ans, sizeof(ans), 0); ans.l:=0;
  for i:=n1.l-n2.l downto 0 do
  begin
    t:=n2; inc(ans.l);
    t:=trans(t); inc(t.l, i); t:=trans(t);
    while Gr(p, t)>-1 do begin p:=p-t; inc(ans.v[n1.l-n2.l-i+1]); end;
  end;
  ans:=trans(ans);
  while (ans.l>1)and(ans.v[ans.l]=0) do dec(ans.l);
  LDiv:=ans;
end;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N);
end;
function GCD(a, b : int) : int;
begin
  if Gr(a, b)=1 then swap1(a, b);
  while not ((b.l=1)and(b.v[1]=0)) do
  begin
    a:=LMod(a, b);
    swap1(a, b);
  end;
  GCD:=a;
end;

function NOK(a, b : int) : int;
begin
  NOK:=LDiv(a*b, GCD(a, b));
end;

procedure Solve;
var i : integer;
begin
  fillchar(res, sizeof(res), 0);
  res:=1;
  for i:=1 to N do res:=NOK(res, i);
  LPrint(res);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
