{$I-,Q-,R-,S-}

const
  coutfile = 'nearest.out';
  cinfile = 'nearest.in';

  nmax = 1111;

type
  int = longint;
  real = extended;

  d = record
        v : int;
        no : int;
      end;

  we = record
         v : int;
         sg : int;
       end;

var
  n, k, m : int;
  ans : int;

  a : array [1..nmax] of d;
  sg : array [1..nmax] of int;
  s : int;

  v : array [1..nmax] of we;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
  write(v[1].v);
  for i:= 2 to n do
  begin
    if v[i].sg = -1 then write('-') else write('+');
    write(v[i].v);
  end;
  writeln;
end;


procedure heapsort;
var
  l, r : int;
  x : d;

  procedure sift;
  var
    i, j : int;
  begin
    x:= a[l];
    i:= l;
    j:= i shl 1;
    if (j < r) and (abs(a[j+1].v) > abs(a[j].v)) then inc(j);
    while (j <= r) and (abs(x.v) < abs(a[j].v)) do
    begin
      a[i]:= a[j];
      i:= j;
      j:= i shl 1;
      if (j < r) and (abs(a[j+1].v) > abs(a[j].v)) then inc(j);
    end;
    a[i]:= x;
  end;

begin
  r:= n;
  for l:= n shr 1 downto 1 do sift;
  l:= 1;
  for r:= n-1 downto 1 do
  begin
    x:= a[1];
    a[1]:= a[r+1];
    a[r+1]:= x;
    sift;
  end;
end;

procedure solve;
var
  i, j : int;
begin
  s:= a[1].v;
  heapsort;
  for i:= n downto 1 do
    if a[i].no <> 1 then
    begin
      if s > k then
      begin
        dec(s,abs(a[i].v));
        if a[i].v > 0 then sg[i]:= -1 else sg[i]:= 1;
        continue;
      end;
      if s <= k then
      begin
        inc(s,abs(a[i].v));
        if a[i].v > 0 then sg[i]:= 1 else sg[i]:= -1;
        continue;
      end;
    end;
  ans:= s;
  for i:= 1 to n do
  begin
    v[a[i].no].v:= a[i].v;
    v[a[i].no].sg:= sg[i];
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n, k);
  for i:= 1 to n do read(a[i].v);
  for i:= 1 to n do a[i].no:= i;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.