{$I-,Q-,R-,S-}
const inf='nearest.in';
      ouf='nearest.out';
type ptree=^ttree;
     ttree=record
       x,y:longint;
       l,r,last:ptree;
     end;
var n,a0:longint;
    a:array [1..10000] of longint;
    tree:array [1..10000] of ptree;
    res:array [0..30000] of longint;
    res2:array [1..30000] of ptree;
procedure init;
var i:longint;
begin
  assign(input,inf);
  reset(input);
  read(n,a0);
  for i:=1 to n do
    read(a[i]);
  close(input);
end;
function find(t:ptree;x:longint):ptree;
begin
  while (t<>nil) and (t^.x<>x) do
    if x<t^.x then
      t:=t^.l
    else t:=t^.r;
  find:=t;
end;
procedure split(t:ptree;x:longint;var l,r:ptree);
begin
  if t=nil then
  begin
    l:=nil;
    r:=nil;
    exit;
  end;
  if x<t^.x then
  begin
    split(t^.l,x,l,t^.l);
    r:=t;
  end
  else begin
    split(t^.r,x,t^.r,r);
    l:=t;
  end;
end;
function insert(var t:ptree;x,y:longint):ptree;
var tmp:ptree;
begin
  if (t=nil) or (y>t^.x) then
  begin
    new(tmp);
    tmp^.x:=x;
    tmp^.y:=y;
    split(t,x,tmp^.l,tmp^.r);
    t:=tmp;
    insert:=t;
    exit;
  end;
  if x<t^.x then
    insert:=insert(t^.l,x,y)
  else insert:=insert(t^.r,x,y);
end;
function join(var t:ptree;x:longint):ptree;
begin
  if find(t,x)=nil then
    join:=insert(t,x,random(maxlongint))
  else join:=nil;
end;
procedure walk(t:ptree);
begin
  if t=nil then
    exit;
  walk(t^.l);
  inc(res[0]);
  res[res[0]]:=t^.x;
  res2[res[0]]:=t;
  walk(t^.r);
end;
procedure run;
var i,j:longint;
    curl:ptree;
begin
  randomize;
  join(tree[1],a[1]);
  for i:=2 to n do
  begin
    res[0]:=0;
    walk(tree[i-1]);
    for j:=1 to res[0] do
    begin
      curl:=join(tree[i],res[j]-a[i]);
      if curl<>nil then
        curl^.last:=res2[j];
      curl:=join(tree[i],res[j]+a[i]);
      if curl<>nil then
        curl^.last:=res2[j];
    end;
  end;
  res[0]:=0;
  walk(tree[n]);
end;
procedure done;
var ans,i,clen:longint;
    pans:ptree;
    current:array [1..10000] of longint;
begin
  assign(output,ouf);
  rewrite(output);
  ans:=-15000;
  for i:=1 to res[0] do
    if abs(res[i]-a0)<abs(ans-a0) then
    begin
      ans:=res[i];
      pans:=res2[i];
    end;
  clen:=n+1;
  while pans<>nil do
  begin
    dec(clen);
    current[clen]:=pans^.x;
    pans:=pans^.last;
  end;
  writeln(current[n]);
  write(a[1]);
  for i:=2 to n do
  begin
    if current[i]-current[i-1]=a[i] then
      write('+')
    else write('-');
    write(a[i]);
  end;
  close(output);
end;
begin
  init;
  run;
  done;
end.
