type int = longint;

var m, n : int;
    x, y, p : array[1..2] of int;
    a, c : array[1..100, 1..100] of int;
    q : array[1..100000, 1..2] of int;

procedure bfs_go;
var l, r, i : int;
  procedure add(dx, dy : int);
  begin
    if not ((dx >= 1) and (dx <= m) and
            (dy >= 1) and (dy <= n)) then exit;
    if a[dx, dy] <> -1 then exit;
    a[dx, dy]:=a[q[l, 1], q[l, 2]]+1;
    c[dx, dy]:=l;
    inc(r);
    q[r, 1]:=dx;
    q[r, 2]:=dy;
  end;
begin
  fillchar(c, sizeof(c), 0);
  for i:=1 to m do
    for l:=1 to n do a[i, l]:=-1;
  a[x[1], x[2]]:=0;
  l:=0;
  r:=1;
  q[1, 1]:=x[1];
  q[1, 2]:=x[2];
  while l < r do begin
    inc(l);
    for i:=1 to 2 do begin
      add(q[l, 1]-p[i], q[l, 2]-p[3-i]);
      add(q[l, 1]-p[i], q[l, 2]+p[3-i]);
      add(q[l, 1]+p[i], q[l, 2]-p[3-i]);
      add(q[l, 1]+p[i], q[l, 2]+p[3-i]);
    end;
  end;
end;

procedure wa(dx, dy : int);
begin
  if c[dx, dy] <> 0 then wa(q[c[dx, dy], 1], q[c[dx, dy], 2]);
  writeln(dx, ' ', dy);
end;

begin
  assign(input, 'horse.in'); reset(input);
  assign(output, 'horse.out'); rewrite(output);
  read(m, n, p[1], p[2], x[1], x[2], y[1], y[2]);
  bfs_go;
  if a[y[1], y[2]] = -1 then write('-1')
  else begin
    writeln(a[y[1], y[2]]);
    wa(y[1], y[2]);
  end;
  close(input); close(output);
end.