{$I-,Q-,R-,S-}
const
  OutFile = 'lcm.out';
type
  integer  = Longint;
var
  n: integer;
procedure Init();
begin
  Assign(input, 'lcm.in');
  Reset(Input);
  Assign(Output, OutFile);
  Rewrite(Output);
  Read(n);
end;

procedure Swap(var a, b: extended);
var t: extended;
begin
  t := a;
  a := b;
  b := t;
end;

function Nod(a, b: extended): extended;
begin
  if a < b then Swap(a, b);

  while (a > 0) and (b > 0) do
  begin
    a := a - trunc(a/b)*b;
    Swap(a, b);
  end;

  Nod := a;
end;

procedure Solve();
var i: Longint;
   nok, d: extended;
begin
  nok := 1;
  for i := 1 to n do
  begin
    d := nod(nok, i);
    nok := nok * trunc(i / d);
  end;
  Writeln(nok:0:0);
end;

procedure Done();
begin
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
