program zzz;

const maxm = 10000;
      osn = 100000;
      k = 5;
      maxn = 1010;

type TLong = array [0..maxm] of longint;

var i,j,n,m : longint;
    a : TLong;
    sim : array [1..maxn] of longint;
    num : array [1..maxn] of longint;

procedure InitLong(var a : TLong; x : longint);
begin
   fillchar(a,sizeof(a),0);
   a[0] := maxm;
   a[a[0]] := x;
end;

procedure Mul(var a : TLong; x : longint);
var i,j,ost : longint;
begin
   for i := maxm downto a[0] do a[i] := a[i]*x;
   ost := 0;
   for i := maxm downto a[0] do begin
      j := a[i]+ost;
      a[i] := j mod osn;
      ost := j div osn;
   end;
   while ost <> 0 do begin
      dec(a[0]);
      a[a[0]] := ost mod osn;
      ost := ost div osn;
   end;
end;

procedure WriteNum(i,x : longint);
begin
   if x > k then exit;
   WriteNum(i div 10,x+1);
   write(i mod 10);
end;

procedure WriteLong(var a : TLong);
var i : longint;
begin
   write(a[a[0]]);
   for i := a[0]+1 to maxm do WriteNum(a[i],1);
end;

procedure Simples;
var i,j : longint;
begin
   fillchar(sim,sizeof(sim),0);
   for i := 2 to maxn do begin
      if sim[i] = 0 then begin
         sim[i] := 1;
         for j := i+1 to maxn do begin
            if j mod i = 0 then sim[j] := 2;
         end;
      end;
   end;
end;

procedure Fahtor(x : longint);
var i,j,m : longint;
begin
   for i := 2 to x do begin
      if sim[i] <> 1 then continue;
      m := 0;
      while x mod i = 0 do begin
         x := x div i;
         inc(m);
      end;
      if m > num[i] then num[i] := m;
   end;
end;

begin
   assign(input,'lcm.in'); reset(input);
   assign(output,'lcm.out'); rewrite(output);
   read(n);
   InitLong(a,1);
   Simples;
   fillchar(num,sizeof(num),0);
   for i := 2 to n do Fahtor(i);
   for i := 1 to n do begin
      for j := 1 to num[i] do Mul(a,i);
   end;
   WriteLong(a);
   close(output);
   close(input);
end.
