{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='dfs';
  fin =problem+'.in';
  fout=problem+'.out';
  maxm=600000;
  maxn=11000;

var
  can:boolean;
  n,m,k,l,i,j,t:longint;
  a,a1,a2,a3:array[0..maxm]of longint;
  b,b1,b2,b3,c,d,b4,c1:array[0..maxn]of longint;

procedure dfs1(v:longint);
var
  i,j:longint;
begin
  d[v]:=1;
  for i:=b1[v] to b1[v+1]-1 do
    if d[a1[i]]=1 then
      a1[i]:=0;
  for i:=b2[v] to b2[v+1]-1 do
    dfs1(a2[i]);
  d[v]:=2;
end;

procedure init;
begin
  assign(input,fin);
  reset(input);

    fillchar(a1,sizeof(a1),0);
    fillchar(a2,sizeof(a2),0);
    fillchar(b1,sizeof(b1),0);
    fillchar(b2,sizeof(b2),0);
    read(n);
    m:=1;
    for i:=2 to n do
      read(c[i]);
    for i:=1 to n do begin
      read(b4[i]);
      b1[i]:=m;
      for j:=1 to b4[i] do begin
        read(a1[m]);
        inc(m);
      end;
    end;
    b1[n+1]:=m;
    dec(m);
    a:=a1;
    b:=b1;
    for i:=2 to n do
      inc(b2[c[i]]);
    inc(b2[1]);
    for i:=2 to n+1 do
      inc(b2[i],b2[i-1]);
    for i:=2 to n do begin
      dec(b2[c[i]]);
      a2[b2[c[i]]]:=i;
    end;
    c1:=c;

  close(input);
end;

procedure dfs(v:longint);
var
  i:longint;
begin
  d[v]:=1;
  for i:=b1[v] to b1[v+1]-1 do begin
    if d[a1[i]]=1 then
      can:=false;
    if (a1[i]<>0)and(d[a1[i]]=0) then
      dfs(a1[i]);
  end;
  c[v]:=t;
  dec(t);
  d[v]:=2;
end;

procedure sort(l,r:longint);
var
  i,j,x,y:longint;
begin
  i:=l;
  j:=r;
  if i>=j then
    exit;
  x:=c[a[(i+j)div 2]];
  repeat
    while c[a[i]]<x do
      inc(i);
    while c[a[j]]>x do
      dec(j);
    if i=j then begin
      inc(i);
      dec(j);
    end;
    if i<j then begin
      a[i]:=a[i] xor a[j];
      a[j]:=a[i] xor a[j];
      a[i]:=a[i] xor a[j];
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then
    sort(i,r);
  if j>l then
    sort(l,j);
end;

procedure solve;
begin
  dfs1(1);
  fillchar(d,sizeof(d),0);
  fillchar(c,sizeof(c),0);
  t:=n;
  can:=true;
  for i:=1 to n do
    if d[i]=0 then
      dfs(i);
  if not can then
    exit;

  c:=c1;
  fillchar(a3,sizeof(a3),0);
  fillchar(b3,sizeof(b3),0);
  for i:=1 to n do
    for j:=b1[i] to b1[i+1]-1 do
      if a1[j]<>0 then
        if c[a1[j]]<>i then
          inc(b3[a1[j]])
        else
          inc(b3[i]);
  inc(b3[1]);
  for i:=2 to n+1 do
    inc(b3[i],b3[i-1]);
  for i:=1 to n do
    for j:=b1[i] to b1[i+1]-1 do
      if a1[j]<>0 then
        if c[a1[j]]<>i then begin
          dec(b3[a1[j]]);
          a3[b3[a1[j]]]:=i;
        end
        else begin
          dec(b3[i]);
          a3[b3[i]]:=a1[j];
        end;
  b1:=b3;
  a1:=a3;
  fillchar(d,sizeof(d),0);
  dfs1(1);
  fillchar(d,sizeof(d),0);
  fillchar(c,sizeof(c),0);
  t:=n;
  can:=true;
  for i:=1 to n do
    if d[i]=0 then
      dfs(i);
  if not can then
    exit;

  for i:=1 to n do
    sort(b[i],b[i+1]-1);
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    if not can then
      write('NO')
    else begin
      writeln('YES');
      for i:=1 to n do begin
        write(b4[i],' ');
        for j:=b[i] to b[i+1]-1 do
          write(a[j],' ');
        writeln;
      end;
    end;

  close(output);
end;
begin
  init;
  solve;
  done;
end.
