  {$I-,Q-,R-,S-}
  {$M 64000000}
const maxn=10010; {10000}
type tlist=^plist;
     plist=record next:tlist; val:integer; bo:boolean; end;
     tlist2=^plist2;
     plist2=record next:tlist2; val,ind:integer; end;
     tlist3=^plist3;
     plist3=record next:tlist3; val:integer end;
     longint=integer;
     ttmas=array[1..maxn] of tlist3;
     tttmas=array[1..maxn] of integer;
     tdus=array[1..maxn] of record val,ind:longint; buf:tlist2; end;
var n,tttglob:longint;
    a:array[1..maxn] of tlist;
    p:array[1..maxn] of tlist2;
    res:array[1..maxn] of tlist3;
    color,next,num,pl,ttnum:array[1..maxn] of longint;
    dus:^tdus;
    vis:array[1..maxn] of boolean;
    lnk:array[1..maxn] of ^ttmas;
    ll:array[1..maxn] of tttmas;

Procedure add(const l,r:longint);
var p1,p2:tlist;
begin
     new(p1);
     p1^.next:=a[l];
     p1^.val:=r;
     p1^.bo:=false;
     a[l]:=p1;
     new(p2);
     p2^.next:=a[r];
     p2^.val:=-l;
     p2^.bo:=false;
     a[r]:=p2;
     if pl[r]=l then
     begin
          pl[r]:=0;
          a[l]^.bo:=true;
     end;
end;

Procedure addtree(const l,r:longint);
var pp:tlist2;
begin
     new(pp);
     pp^.next:=p[l];
     pp^.val:=r;
     if p[l]<>nil then pp^.ind:=p[l]^.ind+1 else pp^.ind:=1;
     ll[l][pp^.ind]:=r;
     p[l]:=pp;
end;

Procedure init;
var i,t,v,j:longint;
begin
     assign(input,'dfs.in');
     reset(input);
     assign(output,'dfs.out');
     rewrite(output);
     read(n);
     for i:=2 to n do
     begin
          read(t);
          pl[i]:=t;
          inc(ttnum[t]);
          addtree(t,i);
     end;
     for i:=1 to n do
     begin
          read(t);
          num[i]:=t;
          getmem(lnk[i],sizeof(pointer)*(ttnum[i]+1));
          for j:=1 to ttnum[i]+1 do lnk[i]^[j]:=nil;
          for j:=1 to t do
          begin
               read(v);
               add(i,v);
          end;
     end;
end;

Procedure union(const buf:tlist2; const w,ind:longint);
begin
     dus^[buf^.val].val:=w;
     dus^[buf^.val].buf:=buf;
end;

Function get(const q:longint; var buf:tlist2):longint;
var t:longint;
begin
     if dus^[q].val=q then
     begin
          get:=q;
          buf:=nil;
     end else
     if dus^[dus^[q].val].val=dus^[q].val then
     begin
          buf:=dus^[q].buf;
          get:=dus^[q].val;
     end else
     begin
          t:=get(dus^[q].val,dus^[q].buf);
          dus^[q].val:=t;
          get:=t;
          buf:=dus^[q].buf;
     end;
end;

Procedure addlink(const t,l,r:longint);
var p:tlist3;
begin
     new(p);
     p^.next:=lnk[t]^[l];
     p^.val:=r;
     lnk[t]^[l]:=p;
end;

Procedure LCA(const q,ind:longint);
var buf:tlist;
    buf2,bb:tlist2;
    anc:longint;
begin
     dus^[q].ind:=ind;
     buf2:=p[q];
     color[q]:=1;
     while buf2<>nil do
     begin
          next[q]:=buf2^.ind;
          LCA(buf2^.val,buf2^.ind);
          union(buf2,q,ind);
          buf2:=buf2^.next;
     end;
     color[q]:=2;
     buf:=a[q];
     while buf<>nil do
     begin
          if color[abs(buf^.val)]=2 then
          begin
               anc:=get(abs(buf^.val),bb);
               if anc<>q then
               begin
                    if buf^.val>0 then
                    begin
                         addlink(anc,bb^.ind,next[anc]);
                    end else
                    begin
                         addlink(anc,next[anc],bb^.ind);
                    end;
               end;
          end;
          buf:=buf^.next;
     end;
end;

Procedure UnionSet;
var i:longint;
begin
     new(dus);
     fillchar(dus^,sizeof(dus^),0);
     for i:=1 to n do dus^[i].val:=i;
end;

Procedure no;
begin
     writeln('NO');
     close(input);
     close(output);
     halt;
end;

Procedure add2(const r:longint);
var p:tlist3;
begin
     new(p);
     p^.next:=res[tttglob];
     p^.val:=ll[tttglob][r];
     res[tttglob]:=p;
end;

Procedure add3(const l,r:longint);
var p:tlist3;
begin
     new(p);
     p^.next:=res[l];
     p^.val:=r;
     res[l]:=p;
end;

Procedure dfs(const q:longint);
var buf,tb:tlist3;
begin
     color[q]:=1;
     buf:=lnk[tttglob]^[q];
     while buf<>nil do
     begin
          if color[buf^.val]=1 then no;
          if color[buf^.val]=0 then
          dfs(buf^.val);
          tb:=buf;
          buf:=buf^.next;
          dispose(tb);
     end;
     color[q]:=2;
     add2(q);
end;

Procedure compare;
var j:longint;
    buf2,ttb:tlist2;
    buf,tb:tlist;
begin
     for tttglob:=1 to n do
     begin
          fillchar(color,sizeof(color),0);
          buf:=a[tttglob];
          while buf<>nil do
          begin
               if (not buf^.bo)and(buf^.val>0) then add3(tttglob,buf^.val);
               tb:=buf;
               buf:=buf^.next;
               dispose(tb);
          end;
          buf2:=p[tttglob];
          while buf2<>nil do
          begin
               if color[buf2^.ind]=0 then dfs(buf2^.ind);
               buf2:=buf2^.next;
          end;
     end;
end;

Procedure check;
var i:longint;
begin
  for i:=1 to n do if pl[i]<>0 then no;
end;

procedure solve;
begin
     check;
     UnionSet;
     fillchar(vis,sizeof(vis),0);
     fillchar(color,sizeof(color),0);
     LCA(1,1);
     dispose(dus);
     compare;
end;

Procedure print;
var i:longint;
    buf:tlist3;
begin
     writeln('YES');
     for i:=1 to n do
     begin
          write(num[i],' ');
          buf:=res[i];
          while buf<>nil do
          begin
               write(buf^.val,' ');
               buf:=buf^.next;
          end;
          writeln;
     end;
end;

begin
     init;
     solve;
     print;
     close(input);
     close(output);
end.
