const maxn=100;
      maxm=100;
var was,lft,rght,anct,left,right,deep:array[0..maxn+1]of longint;
    en,em:array[0..maxm+1]of record
                           s,t:word;
                         end;
    children:array[1..maxn]of record
                                deep,num:word;
                              end;
    mx,ss,s,j,p,nn,e,n,i,k:longint;

procedure swap(i,j,l:word);
var t,jj:longint;
begin
  jj:=0;
  for t:=lft[l] to rght[l] do
    if children[t].num=en[j].t then
    begin
      jj:=t;
      break;
    end;
  if jj=0 then
    exit;
  if (was[i]<>0)and(was[jj]<>0) then
    exit;
  j:=jj;
  t:=children[i].deep;
  children[i].deep:=children[j].deep;
  children[j].deep:=t;
  t:=children[i].num;
  children[i].num:=children[j].num;
  children[j].num:=t;
  was[i]:=1;
  was[j]:=1;
end;

function truedfs(x:word):word;
var max,i:integer;
begin
  was[x]:=1;
  max:=0;
  for i:=lft[x] to rght[x] do
    if was[en[i].t]=0 then
    begin
      max:=1;
      break;
    end;
  if max=0 then
  begin
    truedfs:=1;
    exit;
  end;
  max:=-1;
  for i:=lft[x] to rght[x] do
  begin
    mx:=truedfs(en[i].t);
    if mx>max then
      max:=mx;
  end;
  truedfs:=max+1;
  was[x]:=0;
end;

procedure outno;
begin
  write('NO');
  close(output);
  halt(0);
end;

procedure qsort2(l,r:longint);
var i,j,m,t:longint;
begin
  if l<r then
  begin
    i:=l;
    j:=r;
    m:=children[random(r-l)+l].deep;
    while i<j do
    begin
      while children[i].deep>m do
        inc(i);
      while children[j].deep<m do
        dec(j);
      if i<=j then
      begin
        t:=children[i].deep;
        children[i].deep:=children[j].deep;
        children[j].deep:=t;
        t:=children[i].num;
        children[i].num:=children[j].num;
        children[j].num:=t;
        inc(i);
        dec(j);
      end;
    end;
    qsort2(l,j);
    qsort2(i,r);
  end;
end;

procedure dfs(x:word);
var max,i:integer;
begin
  if (right[x]+left[x]=0) then
  begin
    deep[x]:=1;
    exit;
  end;
  max:=-1;
  for i:=left[x] to right[x] do
  begin
    dfs(em[i].t);
    if deep[em[i].t]>max then
      max:=deep[em[i].t];
  end;
  deep[x]:=max+1;
end;

procedure qsort(l,r:longint);
var i,j,c,t,mm,m:longint;
begin
  if l<r then
  begin
    i:=l;
    j:=r;
    c:=random(r-l)+l;
    m:=em[c].s;
    mm:=em[c].t;
    while i<j do
    begin
      while (em[i].s<m)or((em[i].s=m)and(em[i].t<mm)) do
        inc(i);
      while (em[j].s>m)or((em[j].s=m)and(em[j].t>mm)) do
        dec(j);
      if i<=j then
      begin
        t:=em[i].s;
        em[i].s:=em[j].s;
        em[j].s:=t;
        t:=em[i].t;
        em[i].t:=em[j].t;
        em[j].t:=t;
        inc(i);
        dec(j);
      end;
    end;
    qsort(l,j);
    qsort(i,r);
  end;
end;

begin
  randomize;
  assign(input,'dfs.in');
  reset(input);
  read(n);
  e:=0;
  for i:=2 to n do
  begin
    read(anct[i]);
    inc(e);
    em[e].s:=anct[i];
    em[e].t:=i;
  end;
  nn:=n-1;
  ss:=0;
  for i:=1 to n do
  begin
    read(p);
    lft[i]:=ss+1;
    for j:=0 to p-1 do
    begin
      inc(ss);
      read(s);
      en[ss].s:=i;
      en[ss].t:=s;
      if anct[s]=i then
        dec(nn);
    end;
    rght[i]:=ss;
  end;
  close(input);
  qsort(1,e);
  em[0].s:=0;
  for i:=1 to e+1 do
    if em[i].s<>em[i-1].s then
    begin
      right[em[i-1].s]:=i-1;
      left[em[i].s]:=i;
    end;
  assign(output,'dfs.out');
  rewrite(output);
  if nn>0 then
    outno;
  nn:=0;
  dfs(1);
  if deep[1]<>truedfs(1) then
    outno;
  writeln('YES');
  for i:=1 to n do
  begin
    if lft[i]+rght[i]<>0 then
    begin
      for j:=lft[i] to rght[i] do
      begin
        children[j].deep:=deep[en[j].t];
        children[j].num:=en[j].t;
      end;
      qsort2(lft[i],rght[i]);
      fillchar(was,sizeof(was),0);
      for k:=lft[i] to rght[i] do
        for j:=lft[children[k].num] to rght[children[k].num] do
          if children[k].deep=deep[en[j].t] then
          begin
            swap(k,j,i);
            was[k]:=1;
          end;
      write(rght[i]-lft[i]+1);
      for j:=lft[i] to rght[i] do
        write(' ',children[j].num);
    end
                           else
      write(0);
    writeln;
  end;
  close(output);
end.