program Temp;
const infile = 'dfs.in';
      outfile = 'dfs.out';
      MAXN = 10000;
      MAXM = 500000;

type TEdge = record
  A, B : longint;
end;

var N : longint;
    GA, Gn : array[1..MAXN] of longint;
    GB : array[1..MAXM] of TEdge;
    p, tp : array[1..MAXN] of longint;
    vis : array[1..MAXN] of boolean;

procedure outno;
begin
  write('NO');
  close(input);
  close(output);
  halt(0);
end;

procedure ReadData;
var l : array[1..MAXN] of longint;
    cur, v, i, k : longint;

procedure add(u, v : longint);
begin
  inc(cur); GB[cur].A:=v; GB[cur].B:=0;
  if l[u]=0 then GA[u]:=cur else GB[l[u]].b:=cur;
  l[u]:=cur;
end;

begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N); p[1]:=0;
  for i:=1 to N-1 do read(p[i+1]);
  fillchar(tp, sizeof(tp), 0);
  for i:=1 to N do
  begin
    read(Gn[i]);
    for k:=1 to Gn[i] do
    begin
      read(v); add(i, v);
    end;
  end;
end;

procedure DFS(i : longint);
var j : longint;
begin
  vis[i]:=true; j:=GA[i];
  while j<>0 do
  begin
    if not vis[GB[j].A] then begin dfs(GB[j].A); tp[GB[j].A]:=i; end;
    j:=GB[j].B;
  end;
end;

procedure Solve;
var i, j : longint;
begin
  fillchar(vis, sizeof(vis), false);
  DFS(1);
  for i:=1 to N do if p[i]<>tp[i] then outno;
  writeln('YES');
  for i:=1 to N do
  begin
    write(Gn[i], ' '); j:=GA[i];
    while j<>0 do
    begin
      write(GB[j].A, ' ');
      j:=GB[j].B;
    end;
    writeln;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
