{$I-,Q-,R-,S-}
const
  inf = 'brides.in'; ouf= 'brides.out';
  max = 2010; maxv = 150;

  procedure swap(var a, b: integer);
  var
    c: integer;
  begin
    c := a; a := b; b := c;
  end;

var
  e: array[1..max,1..maxv] of integer;
  c,nm: array[0..maxv,0..maxv] of shortint;
  d: array[1..maxv,0..max] of longint;
  r, q,qq: array[1..maxv] of longint;
  pr: array[1..maxv] of integer;
  w: array[1..maxv] of byte;
  u: array[1..max] of byte;
  dw:array[1..max] of longint;
var
  n,m: longint;

  procedure relax(k: longint);
  var
    i,j: longint; dc: longint;
  begin
    w[k] := 1;
    for i := 1 to q[k] do
    begin
      j:=e[k,i]; dc:=d[k,i];
      if (w[j] = 0) then
        if (r[j] = -1) or
           (r[k] + dc < r[j]) then
           begin
             r[j] := r[k] + dc;
             pr[j] := k;
           end;
    end;
  end;
  procedure update;
  var
    i,j,k,cp: longint;
  begin
    i := n;
    while (pr[i] <> 0) do
    begin
      j:= pr[i];
      for k := 1 to q[j] do
       if (e[j,k] = i) then
       begin
         inc(q[i]);
         e[i,q[i]]:=j;
         d[i,q[i]]:=d[j,k];
         cp:=nm[j,k];
         u[cp] := 1 - u[cp];
         nm[i,q[i]]:=cp;
         e[j,k]:=e[j,q[j]];
         d[j,k]:=d[j,q[j]];
         nm[j,k]:=nm[j,q[j]];
         dec(q[j]); break;
       end;
       i:=j;
    end;
  end;
var
  p, i, j, jb, k, mf,a,b,dd: longint; ok: boolean;
  min, l, rr: longint;
  sumd: longint;
begin
  assign(input,inf);reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n, m, k);
  fillchar(q,sizeof(q),0);
  fillchar(c,sizeof(c),0);
  for i := 1 to m do
  begin
    readln(input, a, b, dd);
    inc(q[a]); e[a,q[a]]:=b; d[a,q[a]]:=dd;
    nm[a,q[a]]:=i;
    inc(q[b]); e[b,q[b]]:=a; d[b,q[b]]:=dd;
    nm[b,q[b]]:=i; dw[i]:= dd;
  end;
  fillchar(u, sizeof(u), 0);
  ok := true;
  for p := 1 to k do
  begin
    r[1] := 0;
    for i := 2 to n do r[i] := -1;
    fillchar(w,sizeof(w),0);
    fillchar(pr,sizeof(pr),0);
    relax(1);
    for i := 1 to n do
    begin
      min := -1;
      for j := 1 to n do
        if (w[j] = 0) and (r[j] > 0) then
          if (min = -1) or (r[j] < min) then
          begin
            min := r[j]; jb:=j;
          end;
     if (min < 0) then
     begin
       ok := false; break;
     end;
     if jb < n then relax(jb)
     else
     begin
       update; break;
     end;
    end;
    if not ok then break;
  end;
  if not ok then writeln(output,-1) else
  begin
    sumd := 0;
    for i := 1 to m do if (u[i] >0) then inc(sumd,dw[i]);
    writeln(output, (sumd/k):5:5);

    fillchar(c, sizeof(c),0);

    for i := 1 to n do
      for j := 1 to q[i] do
        if (u[nm[i,j]]=1) then
           inc(c[e[i,j],i]);
     qq:=q;
    for i := 1 to n do
      for j := 1 to n do
         c[i,j] := c[i,j] shr 1;
    for i := 1 to k do
    begin
      fillchar(w,sizeof(w),0);
      fillchar(q,sizeof(q),0);
      fillchar(pr,sizeof(pr),0);
      l:=1;rr:=1; q[l]:=1; w[1]:=1;
      ok := false;
      while (l <= rr) do
      begin
        j := q[l];
        for p := 1 to n do
          if (c[j, p] = 1) and (w[p] = 0) then
          begin
            inc(rr);q[rr]:=p;
            pr[rr]:=l;w[p]:=1;
            if (p = n) then
            begin
              ok := true; break;
            end;
          end;
        inc(l);
        if ok then break;
      end;
      j := 0;
      fillchar(r,sizeof(r),0);
      while (rr > 0) do
      begin
        inc(j); r[j] := q[rr];
        rr := pr[rr];
      end;
      write(output,j-1,' ');
      q:=qq;
      for p :=j downto 2 do
      begin
        for l := 1 to q[r[p-1]] do
          if (e[r[p-1],l] = r[p]) and
             (u[nm[r[p-1],l]] = 1) then
             begin
                u[nm[r[p-1],l]] := 0;
                write(output, nm[r[p-1],l],' ');
                break;
             end;
      end;
      for p := 1 to j - 1 do
        dec(c[r[p+1],r[p]]);
      writeln(output);
    end;

  end;
  close(input);close(output);
end.
