type int  = longint;
     tarr = array[1..10000] of int;

var n, t, m : int;
    e, v : array[1..500000, 1..2] of int;
    p, pp, ppp, tt, time : tarr;
    g, d : array[1..10000] of ^tarr;
    cycle : boolean;

procedure init;
var i : int;
begin
  fillchar(p, sizeof(p), 0);
  read(n);
  for i:=2 to n do begin
    read(pp[i]);
    inc(p[pp[i]]);
  end;
  m:=0;
  for i:=1 to n do begin
    read(t);
    while t > 0 do begin
      inc(m);
      e[m, 1]:=i;
      read(e[m, 2]);
      dec(t);
    end;
  end;
  for i:=1 to n do begin
    ppp[i]:=p[i];
    getmem(g[i], 4*p[i]);
  end;
  for i:=2 to n do begin
    g[pp[i]]^[ppp[pp[i]]]:=i;
    dec(ppp[pp[i]]);
  end;
end;

procedure dfs_tree(x : int);
var i : int;
begin
  pp[x]:=t;
  inc(t);
  for i:=1 to p[x] do dfs_tree(g[x]^[i]);
  ppp[x]:=t;
  inc(t);
end;

procedure mark;
var i, j : int;
begin
  fillchar(tt, sizeof(tt), 0);
  for i:=1 to m do
    if (pp[e[i, 2]] > ppp[e[i, 1]]) or
       (pp[e[i, 1]] > ppp[e[i, 2]])
    then begin
      v[i, 1]:=e[i, 2];
      v[i, 2]:=e[i, 1];
      inc(tt[v[i, 1]]);
    end else begin
      v[i, 1]:=e[i, 1];
      v[i, 2]:=e[i, 2];
      inc(tt[v[i, 1]]);
    end;
  for i:=1 to n do begin
    pp[i]:=tt[i];
    getmem(d[i], 4*tt[i]);
  end;
  for i:=1 to m do begin
    d[v[i, 1]]^[tt[v[i, 1]]]:=v[i, 2];
    dec(tt[v[i, 1]]);
  end;
end;

procedure topsort(x : int);
var i : int;
begin
  time[x]:=n+1;
  for i:=1 to pp[x] do
    if time[d[x]^[i]] = 0 then begin
      topsort(d[x]^[i]);
      if cycle then exit;
    end else
      if time[d[x]^[i]] = n+1 then begin
        cycle:=true;
        exit;
      end;
  time[x]:=t;
  dec(t);
end;

procedure dfs_go(x : int);
var j, max : int;
begin
  max:=time[x];
  for j:=1 to p[x] do begin
    dfs_go(d[x]^[j]);
    if time[d[x]^[j]] > max then max:=time[d[x]^[j]];
  end;
  time[x]:=max;
end;

procedure wa;
var i, x : int;
  procedure swap(y, z : int);
  var tt : int;
  begin
    tt:=ppp[y]; ppp[y]:=ppp[z]; ppp[z]:=tt;
  end;
  procedure heapify(y, len : int);
  var l : int;
  begin
    l:=y;
    while true do begin
      if 2*y <= len then
        if pp[ppp[l]] < pp[ppp[2*y]] then l:=2*y;
      if 2*y < len then
        if pp[ppp[l]] < pp[ppp[2*y+1]] then l:=2*y+1;
      if l = y then exit;
      swap(l, y);
      y:=l;
    end;
  end;
begin
  fillchar(p, sizeof(p), 0);
  for i:=1 to m do inc(p[e[i, 1]]);
  for i:=1 to n do begin
    ppp[i]:=p[i];
    getmem(d[i], 4*p[i]);
  end;
  for i:=1 to m do begin
    d[e[i, 1]]^[ppp[e[i, 1]]]:=e[i, 2];
    dec(ppp[e[i, 1]]);
  end;
  for x:=1 to n do begin
    write(p[x]);
    for i:=1 to p[x] do ppp[i]:=d[x]^[i];
    for i:=p[x] div 2 downto 1 do heapify(i, p[x]);
    for i:=p[x] downto 2 do begin
      swap(1, i);
      heapify(1, i-1);
    end;
    for i:=1 to p[x] do write(' ', ppp[i]);
    writeln;
  end;
end;

begin
  assign(input, 'dfs.in'); reset(input);
  assign(output, 'dfs.out'); rewrite(output);
  init;
  t:=1;
  dfs_tree(1);
  mark;
  t:=n;
  cycle:=false;
  topsort(1);
  if cycle then write('NO')
  else begin
    writeln('YES');
    dfs_go(1);
    wa;
  end;
  close(input); close(output);
end.
