program zzz;

const maxn = 4000;
      maxm = 200000;  {2 times more}

type TEdge = record
        u,v,next,num,w : longint;
     end;

var i,j,k,n,m,u,v,w,ans,min,h : longint;
    d,d1,p : array [1..maxn] of longint;
    g : array [0..maxn] of longint;
    col : array [1..maxn] of longint;
    ed : array [1..maxm] of TEdge;
    oldw : array [1..maxm] of longint;
    f : boolean;

procedure Add(u,v,w,num,val : longint);
begin
   ed[val].u := u;
   ed[val].v := v;
   ed[val].w := w;
   ed[val].num := num;
   ed[val].next := g[u];
   g[u] := val;
end;

procedure InitG;
var i : longint;
begin
   for i := 0 to n do g[i] := 0;
end;

procedure Swap(var i,j : longint);
var t : longint;
begin
   t := i;
   i := j;
   j := t;
end;

procedure Qsort(l,r : longint);
var i,j,x : longint;
begin
   i := l;
   j := r;
   x := d1[random(r-l)+l];
   repeat
      while d1[i] < x do inc(i);
      while d1[j] > x do dec(j);
      if i <= j then begin
         Swap(d1[i],d1[j]);
         Swap(p[i],p[j]);
         inc(i);
         dec(j);
      end;
   until i>j;
   if l < j then Qsort(l,j);
   if i < r then Qsort(i,r);
end;

procedure Botva;
begin
   write('-1');
   close(input);
   close(output);
   halt(0);
end;

procedure OutRes(ans : longint);
begin
   writeln(ans);
   for i := 1 to m do begin
      writeln(ed[i].w);
   end;
end;

begin
   randseed := 65893467;
   assign(input,'minister.in'); reset(input);
   assign(output,'minister.out'); rewrite(output);
   read(n,m);
   for i := 1 to n do begin
      read(d[i]);
      d1[i] := d[i];
      p[i] := i;
   end;
   InitG;
   for i := 1 to m do begin
      read(u,v,w);
      oldw[i] := w;
      Add(u,v,w,i,i);
      Add(v,u,w,i,i+m);
   end;
   fillchar(col,sizeof(col),0);
   col[1] := 1;
   Qsort(1,n);
   for h := 2 to n do begin
      k := p[h];
      i := g[k];
      f := false;
      while i <> 0 do begin
         if col[ed[i].v] = 1 then begin
            if d[ed[i].v] + ed[i].w <= d[k] then begin
              f := true;
              ed[i].w := d[k]-d[ed[i].v];
              if i > m then j := i-m else j := i+m;
              ed[j].w := d[k]-d[ed[j].u];
            end;
         end;
         i := ed[i].next;
      end;
      if not f then begin
         i := g[k];
         min := maxlongint;
         ans := 0;
         while i <> 0 do begin
            if col[ed[i].v] = 1 then begin
               if (d[k]-d[ed[i].v]-ed[i].w) < min then begin
                  min := (d[k]-d[ed[i].v]-ed[i].w);
                  ans := i;
               end;
            end;
            i := ed[i].next;
         end;
         if ans <> 0 then begin
            i := ans;
            ed[i].w := d[k]-d[ed[i].v];
            if i > m then j := i-m else j := i+m;
            ed[j].w := d[k]-d[ed[j].u];
         end else Botva;
      end;
      col[k] := 1;
   end;
   ans := 0;
   for i := 1 to m do begin
      inc(ans,abs(ed[i].w-oldw[i]));
   end;
   OutRes(ans);
   close(output);
   close(input);
end.