type
   integer=longint;
procedure init;
begin
   assign(input, 'brides.in'); reset(input);
   assign(output, 'brides.out'); rewrite(output);
end;

procedure done;
begin
   close(input);
   close(output);
end;

const
   maxn=200;
   maxm=2000;
   white=0;
   grey=1;
   black=2;

var
   n, m, k: integer;
   a:array[1..maxn,1..maxn] of byte;
   t,roadnum:array[1..maxn,1..maxn] of integer;

   c:array[1..maxn] of byte;
   times: array[1..100] of integer;
   maxtime: integer;


procedure readinfo;
var
   i, j, o, u: integer;
begin
   readln(n, m, k);
   for i:=1 to m do
   begin
     readln(j, o, u);

     inc(c[j]);
     a[j,c[j]]:=o;
     t[j,c[j]]:=u;
     roadnum[j,c[j]]:=i;


     inc(c[o]);
     a[o,c[o]]:=j;
     t[o,c[j]]:=u;
     roadnum[o,c[o]]:=i;
   end;
end;





var d: array[1..maxn] of integer;
    color, p: array[1..maxn] of byte;
    rd: array[1..maxn] of integer;
    v:array[1..maxn] of boolean;
    q:array[1..maxn*4] of integer;
    qq: integer;

function Relax(x, y, road: integer):boolean;
begin
   if d[x]+t[x,road]<d[y] then
   begin
    d[y]:=d[x]+t[x,road];
    p[y]:=x;
    rd[y]:=road;
    Relax:=true;
   end
   else
    Relax:=false;
end;

procedure hea(x: integer);
var
    t1, o: integer;
begin
 repeat
   t1:=x*2;
   if t1>qq then exit;
   if (t1<qq)and(q[t1+1]<q[t1]) then
    inc(t1);
   if q[x]<q[t1] then exit;
   o:= q[x];
   q[x]:=q[t1];
   q[t1]:=o;
   x:=t1;
 until false;
end;

procedure push(x: integer);
var
   i, j, k: integer;
begin
   inc(qq);
   i:=qq;
   q[i]:=x;
   while (i>1)and(q[i div 2]>q[i]) do
   begin
    j:=i div 2;
    k:=q[j];
    q[j]:=q[i];
    q[i]:=k;
    i:=j;
   end;
end;


function extract: integer;
begin
   extract:=q[1];
   q[1]:=q[qq];
   dec(qq);
   hea(1);
end;

function empty: boolean;
begin
   empty:=qq=0;
end;

function max(a, b: integer): integer;
begin
   if a> b then max := a else max := b;
end;

procedure go;
var
   i, j, x, y, road: integer;
begin
   d[1]:=0;
   for i:=2 to n do
    d[i]:=maxlongint;
   fillchar(color,n,white);

   qq:=0;
   push(1);
   while (not empty)and(color[n]<>black) do
   begin
      x:= extract;
      color[x]:=grey;
      for i:= 1 to c[x] do
      begin
       y:=a[x,i];
       road:=roadnum[x,i];
       if color[y]<>black then
       begin
        if color[y]=white then
         begin
         color[y]:=grey;
         Relax(x,y,road);
         Push(y);
         end
         else
          if Relax(x,y, road) then Push(y);
       end;
      end;
      color[x]:=black;
   end;
   maxtime:=d[n];
end;

procedure del(q,w,rr: integer);
var
   i, j: integer;
begin
   for i:=1 to c[q] do
    if a[q,i]=w then
     if roadnum[q,i]=rr then
     begin
      a[q,i]:=a[q,c[q]];
      t[q,i]:=t[q,c[q]];
      roadnum[q,i]:=roadnum[q,c[q]];
      dec(c[q]);
      exit;
     end;
end;

procedure delroad(a, b, road1: integer);
begin
 del(a,b, road1);
 del(b,a, road1);
end;

var st: array[1..100,0..maxm] of byte;
procedure processpath(x: integer);
var
   i, sc,j: integer;
begin
   sc:=0;
   i:=n;
   while i<>1 do
   begin
    inc(sc);
    st[x][sc]:=rd[i];
    delroad(i,p[i],rd[i]{,rd[p[i]]});
    i:=p[i];
   end;
   st[x,0]:=sc;

end;

procedure writeRes;
var
   i, j: integer;
   e: extended;
begin
   e:=0.0;
   for i:=1 to k do
    e:=e + times[i];
   writeln(e/k:0:5);
   for i:=1 to k do
   begin
    write(st[i,0],' ');
    for j:=st[i,0] downto 1 do
    begin
     write(st[i,j],' ');
    end;
    writeln;
   end;
end;



procedure solve;
var
   i: integer;
begin
  readinfo;
  for i:=1 to k do
  begin
   go;
   if maxtime=maxlongint then
   begin
    writeln('-1');
    done;
    halt(0);
   end;
   times[i]:=maxtime;

   processpath(i);
  end;

  writeres;
end;

begin
   init;
   solve;
   done;
end.


