program Temp;
const infile = 'masterpiece.in';
      outfile = 'masterpiece.out';
      MAXN = 64;
      MAXM = 64;
      MAXK = 4096;
type t1 = array[1..MAXM] of integer;
var max : array[1..MAXN, 0..MAXM] of integer;
    ans : array[1..MAXN, 0..MAXM] of t1;
    tab : array[1..MAXN, 1..MAXM] of integer;
    V, t2 : array[0..MAXN, 0..MAXK] of integer;
    N, M, K : integer;

procedure ReadData;
var s : string[MAXM];
    i, j : integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  readln(N, M, K);
  for i:=1 to N do
  begin
    readln(s);
    for j:=1 to M do tab[i, j]:=ord(s[j])-48;
  end;
end;

procedure Process(p : integer);
var i, j, c0, e, l, mx : integer;
    t : t1;
begin
  for i:=1 to MAXM do t[i]:=2;
  i:=1; j:=M; c0:=tab[p, i]; e:=0;
  while tab[p, j]<>c0 do dec(j);
  while i<=j do
  begin
    inc(e); c0:=tab[p, i]; mx:=0;
    for l:=i to j do t[l]:=c0;
    for l:=1 to M do if tab[p, l]=t[l] then inc(mx);
    ans[p, e]:=t; max[p, e]:=mx;
    while (i<M)and(tab[p, i]=c0) do inc(i);
    while (j>0)and(tab[p, j]=c0) do dec(j);
  end;
  for i:=e+1 to M do
  begin
    max[p, i]:=M; ans[p, i]:=t;
  end;
end;

procedure Solve;
var i, j, l, mx : integer;
begin
  fillchar(max, sizeof(max), 0);
  fillchar(t2, sizeof(t2), 0);
  fillchar(V, sizeof(V), 0);
  for i:=1 to N do Process(i);
  for i:=1 to N do
    for j:=0 to M do
      for l:=0 to K-j do
        if V[i, l+j] < V[i-1, j]+max[i, l] then
        begin
          V[i, l+j] := V[i-1, j]+max[i, l];
          t2[i, l+j] := l;
        end;
  mx:=0;
  for i:=0 to K do if V[N, i]>mx then begin mx:=V[N, i]; l:=i; end;
  writeln(N*M-mx);
  for i:=1 to N do
  begin
    for j:=1 to M do write(ans[i, t2[i, l], j]);
    l:=t2[i, l];
    writeln;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
