{$I-,Q-,R-,S-}

const
  coutfile = 'masterpiece.out';
  cinfile = 'masterpiece.in';

  nmax = 65;
  inf = maxlongint shr 1;

type
  int = longint;
  real = extended;

  tar = array [1..nmax] of boolean;
  tab = array [1..nmax] of int;
  tp = array [0..nmax,0..nmax,0..1] of int;

var
  n, k, m : int;
  ans, kol : int;

  g : array [1..nmax] of tar;
  r : array [1..nmax] of tab;

  p, f : array [1..nmax] of tp;
  c : array [0..nmax,0..nmax*nmax] of int;
  o : array [1..nmax,0..nmax*nmax,1..2] of int; {kdays, 0 or 1}

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
  for i:= 1 to n do
  begin
    for j:= 1 to m do write(r[i,j]);
    writeln;
  end;
end;

procedure outl(var r : tab; var f : tp; day, col : int);
var
  i : int;
begin
  if day = 0 then
  begin
    for i:= 1 to m do r[i]:= 2;
    exit;
  end;
  for i:= m downto 1 do
  begin
    r[i]:= col;
    if col <> f[i,day,col] then
    begin
      dec(day);
      col:= 1-col;
    end;
  end;
end;

procedure out(n, kol : int);
begin
  while n >= 1 do
  begin
    outl(r[n], f[n] ,o[n,kol,1],o[n,kol,2]);
    dec(kol,o[n,kol,1]);
    dec(n);
  end;
end;

procedure go(var p, f : tp; var l : tar);
var
  i, j : int;
begin
  fillchar(f,sizeof(f),255);
  for i:= 0 to m do
    for j:= 0 to m do
    begin
      p[i,j,0]:= inf; p[i,j,1]:= inf;
    end;
  p[1,1,0]:= ord(l[1]); p[1,1,1]:= 1-ord(l[1]);
  for i:= 2 to m do
    for j:= 1 to i do
    begin
      if not l[i] then
      begin
        p[i,j,0]:= p[i-1,j,0]; f[i,j,0]:= 0;
        p[i,j,1]:= p[i-1,j,1]+1; f[i,j,1]:= 1;
        if j > 1 then
        begin
          if p[i,j,0] > p[i-1,j-1,1] then
          begin
            p[i,j,0]:= p[i-1,j-1,1];
            f[i,j,0]:= 1;
          end;
          if p[i,j,1] > p[i-1,j-1,0]+1 then
          begin
            p[i,j,1]:= p[i-1,j-1,0]+1;
            f[i,j,1]:= 0;
          end;
        end;
      end else
      begin
        p[i,j,1]:= p[i-1,j,1]; f[i,j,1]:= 1;
        p[i,j,0]:= p[i-1,j,0]+1; f[i,j,0]:= 0;
        if j > 1 then
        begin
          if p[i,j,1] > p[i-1,j-1,0] then
          begin
            p[i,j,1]:= p[i-1,j-1,0];
            f[i,j,1]:= 0;
          end;
          if p[i,j,0] > p[i-1,j-1,1]+1 then
          begin
            p[i,j,0]:= p[i-1,j-1,1]+1;
            f[i,j,0]:= 1;
          end;
        end;
      end;
    end;
  p[m,0,0]:= m;
  p[m,0,1]:= m;
end;

procedure solve;
var
  i, j, q : int;
begin
  fillchar(p,sizeof(p),0);
  fillchar(f,sizeof(f),255);
  for i:= 1 to n do go(p[i],f[i],g[i]);
  fillchar(o,sizeof(o),255);
  for i:= 0 to n do
    for j:= 0 to n*m do c[i,j]:= inf;
  c[0,0]:= 0;
  for i:= 1 to n do
  begin
    for q:= 0 to (i-1)*m do
      for j:= 0 to m do
        if q + j <= k then
        begin
          if c[i,q+j] > c[i-1,q] + p[i,m,j,0] then
          begin
            c[i,q+j]:= c[i-1,q] + p[i,m,j,0];
            o[i,q+j,1]:= j;
            o[i,q+j,2]:= 0;
          end;
          if c[i,q+j] > c[i-1,q] + p[i,m,j,1] then
          begin
            c[i,q+j]:= c[i-1,q] + p[i,m,j,1];
            o[i,q+j,1]:= j;
            o[i,q+j,2]:= 1;
          end;
        end;
  end;
  ans:= inf;
  for i:= 0 to k do
    if ans > c[n,i] then
    begin
      ans:= c[n,i];
      kol:= i;
    end;
  out(n,kol);
end;

procedure readdata;
var
  i, j : int;
  x : char;
begin
  readln(n, m, k);
  for i:= 1 to n do
  begin
    for j:= 1 to m do
    begin
      read(x);
      g[i,j]:= x = '1';
    end;
    readln;
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
