const maxn=1010;
var n,cnt,ans:longint;
    s:string;
    a:array[0..maxn] of record ln:boolean; val:string; end;
    sp,tsp:array[1..maxn] of longint;
    isend:array[1..maxn] of boolean;
    ch:char;
    res:array[1..maxn*maxn] of record numword,numspace,p,sym,numsymwrd,sumsym:longint; end;

Function readword(var s:string; var bo:boolean; var ns:longint):boolean;
begin
     if ch=#26 then
     begin
          readword:=false;
          exit;
     end;
     s:='';
     while not (ch in [#10,#13,#32]) do
     begin
          s:=s+ch;
          read(ch);
          if ch=#26 then
          begin
               readword:=true;
               exit;
          end;
     end;
     ns:=0;
     if ch=#32 then bo:=false else bo:=true;
     while ch in [#10,#13,#32] do
     begin
          if (ch=#32)or(ch=#10) then inc(ns);
          read(ch);
     end;
     readword:=true;
end;

Procedure init;
var ss:string;
    bo:boolean;
    ns:longint;
begin
     assign(input,'aliens.in');
     reset(input);
     assign(output,'aliens.out');
     rewrite(output);
     readln(n);
     readln(s);
     read(ch);
     while readword(ss,bo,ns) do
     begin
          inc(cnt);
          a[cnt].val:=ss;
          a[cnt].ln:=bo;
          sp[cnt]:=ns;
     end;
end;

Procedure look(const q,w,e:longint);
var i,j:longint;
    min,p,t:longint;
begin
     if (q=1)and(e=1) then
     begin
          if w=n then
          begin
               inc(ans);
               res[ans].numword:=q;
               res[ans].numspace:=0;
               res[ans].p:=1;
               res[ans].sym:=e;
               res[ans].numsymwrd:=w;
               res[ans].sumsym:=w;
          end;
          exit;
     end;
     min:=maxlongint;
     p:=0;
     for i:=1 to ans do
     begin
          if res[i].sym=e-1 then
          begin
               if (res[i].numword=q)and(res[i].numsymwrd<>0) then
               begin
                    if w-res[i].numsymwrd=n then
                    begin
                         if res[i].numspace<min then
                         begin
                              min:=res[i].numspace;
                              p:=i;
                         end;
                    end;
               end else
               begin
                    if res[i].numsymwrd=0 then
                    begin
                         t:=res[i].sumsym;
                         for j:=res[i].numword+1 to q-1 do t:=t+sp[j]+length(a[j].val);
                         t:=t+w;
                    if t<=n*e then
                    begin
                         if res[i].numspace+(n*e-t)<min then
                         begin
                              min:=res[i].numspace+(n*e-t);
                              p:=i;
                         end;
                    end;
                    end else
                    begin
                    t:=res[i].sumsym+(length(a[res[i].numword].val)-res[i].numsymwrd);
                    t:=t+sp[res[i].numword];
                    for j:=res[i].numword+1 to q-1 do t:=t+sp[j]+length(a[j].val);
                    t:=t+w;
                    if t<=n*e then
                    begin
                         if res[i].numspace+(n*e-t)<min then
                         begin
                              min:=res[i].numspace+(n*e-t);
                              p:=i;
                         end;
                    end;
                    end;
               end;
          end;
     end;
     if min<>maxlongint then
     begin
          inc(ans);
          res[ans].numword:=q;
          res[ans].numspace:=min;
          res[ans].p:=p;
          res[ans].sym:=e;
          res[ans].numsymwrd:=w;
          res[ans].sumsym:=n*e;
     end;
end;

Procedure look2(const q:longint);
var i,j,k,t,o,min,p:longint;
begin
     min:=maxlongint;
     for i:=1 to length(s) do if s[i]=' ' then
     begin
          min:=maxlongint;
          for j:=1 to ans do if (res[j].sym=i-1) then
          begin
               t:=res[j].sumsym+(length(a[res[j].numword].val)-res[j].numsymwrd);
               t:=t+sp[res[j].numword];
               for k:=res[j].numword+1 to q do t:=t+sp[k]+length(a[k].val);
               t:=t-sp[q];
               if t<n*i then
               begin
                    if t+sp[q]>=n*i then
                    begin
                         if min>res[j].numspace then
                         begin
                              min:=res[j].numspace;
                              p:=j;
                         end;
                    end else
                    begin
                         if min>res[j].numspace+(n*i-(t+sp[q])) then
                         begin
                              min:=res[j].numspace+(n*i-(t+sp[q]));
                              p:=j;
                         end;
                    end;
               end;
          end;
          if min<>maxlongint then
          begin
               inc(ans);
               res[ans].numword:=q+1;
               res[ans].numspace:=min;
               res[ans].p:=p;
               res[ans].sym:=i;
               res[ans].numsymwrd:=0;
               res[ans].sumsym:=n*i
          end;
     end;
end;

Procedure solve;
var i,j,k,sum:longint;
begin
     res[1].numword:=0;
     res[1].numspace:=0;
     res[1].p:=0;
     res[1].sym:=0;
     res[1].numsymwrd:=0;
     res[1].sumsym:=0;
     ans:=1;
     for i:=1 to cnt do
     begin
          for j:=1 to length(a[i].val) do
          begin
               for k:=1 to length(s) do
               begin
                    if a[i].val[j]=s[k] then
                    begin
                         look(i,j,k);
                    end;
               end;
          end;
          look2(i);
     end;
end;

Procedure print;
var i,min,p,j:longint;
begin
     min:=maxlongint;
     for i:=1 to ans do if (res[i].sym=length(s))and(res[i].numspace<min) then
     begin
          min:=res[i].numspace;
          p:=i;
     end;
     if min=maxlongint then
     begin
          writeln('IMPOSSIBLE');
     end else
     begin
          writeln(min);
          i:=p;
          while i<>1 do
          begin
               if (res[i].numspace-res[res[i].p].numspace=0) then i:=res[i].p else
               begin
                    inc(sp[res[i].numword-1],res[i].numspace-res[res[i].p].numspace);
                    i:=res[i].p;
               end;
          end;
          for i:=1 to cnt do
          begin
               write(a[i].val);
               for j:=1 to sp[i]-1 do write(' ');
               if not a[i].ln then write(' ');
               if a[i].ln then writeln;
          end;
     end;
end;

begin
     init;
     a[cnt].ln:=true;
     solve;
     print;
     close(input);
     close(output);
end.
