program Aliens;
const infile = 'aliens.in';
      outfile = 'aliens.out';
      MAXL = 51;
      MAXM = 1001;
      inf = 25000;

type int = integer;
var song : array[0..MAXM] of char;
    a : array[0..MAXL, 0..MAXM] of int;
    afr : array[0..MAXL, 0..MAXM] of byte;
    sp : array[1..MAXM] of integer;
    br : array[1..MAXM] of boolean;
    len, N, ls : int;
    ms : string;

function min(a, b : int) : int;
begin
  if a < b then min:=a else min:=b;
end;

procedure ReadData;
var ch : char;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  readln(N);  readln(ms); len:=0; ls:=length(ms);
  fillchar(br, sizeof(br), false);
  while not eof(input) do
  begin
    read(ch);
    if ch=#13 then continue;
    if ch=#10 then begin ch:=#32; br[len+1]:=true; end;
    inc(len); song[len]:=ch;
  end;
end;

procedure Solve;
var i, j, k, l, p : int;
    b : boolean;
begin
  fillchar(sp, sizeof(sp), 0);
  for i:=0 to MAXL do
    for j:=0 to MAXM do
      a[i, j]:=inf;
  for i:=0 to MAXM do a[0, i]:=0;
  for i:=0 to ls do
    for j:=1 to len do
    begin
      if ms[i]<>song[j] then continue; b:=false;
      for k:=0 to min(j, n-1) do
      begin
        if song[j-k]=' ' then b:=true;
        if b then
          if (a[i, j] > a[i-1, j-k]+n-k) then
          begin
            a[i, j] := a[i-1, j-k]+n-k;
            afr[i, j]:=j-k;
          end;
      end;
      if j>=n then
        if (a[i, j] > a[i-1, j-n]) then
        begin
          a[i, j] := a[i-1, j-n];
          afr[i, j]:=j-n;
        end;
    end;
  j:=1;
  for i:=1 to len do
    if (a[ls, i] < a[ls, j]) then j:=i;
  if a[ls, j]=inf then begin write('IMPOSSIBLE'); exit; end;
  writeln(a[ls, j]);
  i:=j; k:=ls;
  repeat
    l:=n-(i-afr[k, i]);
    if l<>0 then begin
      for p:=afr[k, i] to i do if song[p]=' ' then break;
      sp[p]:=sp[p]+l;
    end;
    i:=afr[k, i]; dec(k);
  until i=0;
  for i:=1 to len do
  begin
    for j:=1 to sp[i] do write(' ');
    if br[i] then begin writeln; continue; end;
    if song[i]=' ' then write(' ') else write(song[i]);
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
