{$apptype console}

{Dmitry Orlov}

{$R+,S+,I+,Q+}

program template;
const
 nmax = 300;
 p = 3;
 inverse :array [0..p-1] of integer = (0,1,2);
 cinfile = 'input.txt';
 coutfile = 'output.txt';
type
 int = longint;
 real = extended;
 tmatrix = array [1..nmax,1..nmax] of int;
var
 n :int;
 a,b :tmatrix;
 c :tmatrix;
 ans :int;

procedure init;
begin
 ans := 0;
 fillchar (a,sizeof(a),0);
 fillchar (b,sizeof(b),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n);
 for i := 1 to n do
  for j := 1 to n do
   read (a[i,j]);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  for j := 1 to n do
   begin
    write (b[i,j],' ');
    if j = n then
     writeln;
   end;
 close (output);
end;

procedure solveSubMatrix (st :int);
var i,j :int;
    sum :int;
begin
 b[st,st] := a[st,st];
 for i := st+1 to n do
  begin
   sum := a[st,i];
   for j := st+1 to i-1 do
    sum := (sum - b[st,j]*b[j,i] + p*p) mod p;
   b[st,i] := (sum*inverse[b[st,st] + b[i,i]]) mod p;
  end;
end;

procedure solve;
var i,j :int;
begin
 for i := n downto 1 do
  solveSubMatrix (i);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.