{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'seq.out';
  cinfile = 'seq.in';

  nmax = 100010;

  inf = maxlongint shr 1;

type
  int = longint;
  real = extended;

var
  n, k : int;
  ans : int;

  a, minr, s : array [0..nmax] of int;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
end;

procedure solve;
var
  i, j : int;
  min : int;
begin
  min:= s[n];
  minr[n]:= s[n];
  for i:= n-1 downto 1 do
  begin
    if min > s[i] then min:= s[i];
    minr[i]:= min;
  end;
  ans:= 0;
  min:= inf;
  for i:= 1 to n do
  begin
    inc(ans,ord((minr[i] - s[i-1] > 0) and (min + s[n] - s[i-1] > 0)));
    if min > s[i] then min:= s[i];
  end;
end;

procedure init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(minr,sizeof(minr),0);
end;

procedure readdata;
var
  i, j : int;
begin
  init;
  read(n);
  s[0]:= 0;
  for i:= 1 to n do
  begin
    read(a[i]);
    s[i]:= s[i-1] + a[i];
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.