{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'dvd.out';
  cinfile = 'dvd.in';

  dmax = 111;

  nmax = 2010;

  gmin = 1869;
  gmax = 2005;

type
  int = longint;
  real = extended;

  str = string[dmax];

  film = record
           y, r : int;
           name : str;
         end;

  per = array [0..5] of byte;

  list = ^tlist;
  tlist = record
            x : int;
            next : list;
          end;

var
  n : int;
  ans : int;

  a : array [0..nmax] of film;

  g : array [gmin..gmax,1..5] of int;
  gl : array [gmin..gmax,1..5] of list;

  k, p1, p2 : array [gmin..gmax,1..5,0..5] of integer;
  pp : array [gmin..gmax,1..5,0..5] of per;
  q : list;

procedure out(y,r,h : int);
var
  i : int;
begin
  if r = 0 then exit;
  out(y-1,p1[y,r,h],p2[y,r,h]);
  for i:= 1 to pp[y,r,h][0] do
  begin
    q:= gl[y,pp[y,r,h][i]];
    while q <> nil do
    begin
      writeln(a[q^.x].name);
      q:= q^.next;
    end;
  end;
end;

procedure outdata;
var
  i, j, g : int;
  y, r, h : int;
begin
  ans:= 0;
  for i:= gmin to gmax do
    for j:= 1 to 5 do
      for g:= 0 to 5 do
        if ans < k[i,j,g] then
        begin
          ans:= k[i,j,g];
          y:= i;
          r:= j;
          h:= g;
        end;
  writeln(ans);
  out(y,r,h);
end;

procedure go(y, r, h : int);
var
  p : per;
  u : array [1..5] of boolean;
  num : int;

  procedure rec(no : int);
  var
    i : int;
  begin
    if no+h > 5 then exit;
    for i:= 1 to 5 do
      if not u[i] then
      begin
        inc(num,g[y+1,i]);
        u[i]:= true;
        inc(p[0]);
        p[p[0]]:= i;
        if k[y+1,i,h+no] < num then
        begin
          k[y+1,i,h+no]:= num;
          p1[y+1,i,h+no]:= r;
          p2[y+1,i,h+no]:= h;
          pp[y+1,i,h+no]:= p;
        end;
        rec(no+1);
        dec(p[0]);
        dec(num,g[y+1,i]);
        u[i]:= false;
      end;
  end;
var
  i : int;

begin
  fillchar(u,sizeof(u),0);
  u[r]:= true;
  num:= k[y,r,h] + g[y+1,r];
  p[0]:= 1;
  p[1]:= r;
  if k[y+1,r,h] < num then
  begin
    k[y+1,r,h]:= num;
    p1[y+1,r,h]:= r;
    p2[y+1,r,h]:= h;
    pp[y+1,r,h]:= p;
  end;
  rec(1);
end;

procedure solve;
var
  i, j : int;
  y, r, h : int;
begin
  fillchar(k,sizeof(k),0);
  fillchar(p1,sizeof(p1),0);
  fillchar(p2,sizeof(p2),0);
  for y:= gmin to gmax-1 do
    for r:= 1 to 5 do
      for h:= 0 to 5 do
        go(y,r,h);
end;

procedure push(var x : list; y : int);
var
  z : list;
begin
  new(z);
  z^.x:= y;
  z^.next:= x;
  x:= z;
end;

procedure readdata;
var
  i, j : int;
  ch : char;
begin
  fillchar(g,sizeof(g),0);
  fillchar(gl,sizeof(gl),0);
  readln(n);
  for i:= 1 to n do
  begin
    read(ch);
    a[i].name:= ch;
    read(ch);
    while ch <> '"' do
    begin
      a[i].name:= a[i].name + ch;
      read(ch);
    end;
    a[i].name:= a[i].name + ch;
    readln(a[i].y,a[i].r);
    inc(g[a[i].y,a[i].r]);
    push(gl[a[i].y,a[i].r],i);
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.