  {$I-,Q-,R-,S-}
const infile = 'snow.in'; outfile = 'snow.out';
      maxn = 105; maxm = 40005; inf = 1000000000;
type st = array [1..3] of longint;
var g: array [1..maxm] of st;
    s: array [1..maxn,1..2] of longint;
    update,new_update: array [1..maxn] of longint;
    f: array [1..maxn] of longint;
    cur: array [1..maxm,1..2] of longint;
    n,m,k: longint;
    find: boolean;

    tmpn: longint;
    tmps: st;

procedure sort(l,r: longint);
var i,j,w: longint;
begin
     i:=l; j:=r; w:=g[(l+r) div 2,1];
     repeat
           while (g[i,1] < w) do inc(i);
           while (g[j,1] > w) do dec(j);
           if i <= j then begin
              tmps:=g[i]; g[i]:=g[j]; g[j]:=tmps;
              inc(i); dec(j);
           end;
     until i > j;
     if i < r then sort(i,r);
     if l < j then sort(l,j);
end;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(n,m,k);
     for i:=1 to m do begin
         read(g[i,1],g[i,2],g[i,3]);
         g[i+m,1]:=g[i,2];
         g[i+m,2]:=g[i,1];
         g[i+m,3]:=g[i,3];
     end;
     m:=2*m;
     sort(1,m);
     s[g[1,1],1]:=1;
     for i:=2 to m do
         if g[i,1] <> g[i-1,1] then begin
            s[g[i-1,1],2]:=i-1;
            s[g[i,1],1]:=i;
         end;
     s[g[m,1],2]:=m;
     close(input);
end;

procedure loc_sort(l,r: longint);
var i,j,w: longint;
begin
     i:=l; j:=r; w:=cur[l+random(r-l+1),2];
     repeat
           while (cur[i,2] < w) do inc(i);
           while (cur[j,2] > w) do dec(j);
           if i <= j then begin
              tmpn:=cur[i,1]; cur[i,1]:=cur[j,1]; cur[j,1]:=tmpn;
              tmpn:=cur[i,2]; cur[i,2]:=cur[j,2]; cur[j,2]:=tmpn;
              inc(i); dec(j);
           end;
     until i > j;
     if i < r then loc_sort(i,r);
     if l < j then loc_sort(l,j);
end;

procedure make(v: longint);
var i,t,num,min: longint;
begin
     num:=0;
     for i:=s[v,1] to s[v,2] do begin
         inc(num); cur[num,1]:=i; cur[num,2]:=f[g[i,2]]+g[i,3];
     end;
     loc_sort(1,num);
     if num < k then t:=num else t:=k;
     for i:=1 to t do
         cur[i,2]:=cur[i,2]+g[cur[i,1],3];
     min:=inf;
     for i:=1 to num do
         if cur[i,2] < min then min:=cur[i,2];
     if min < f[v] then begin
        new_update[v]:=1;
        f[v]:=min; find:=true;
     end;
end;

procedure solve;
var num_upd,i,j: longint;
begin
     fillchar(update,SizeOf(update),0);
     for i:=1 to n do f[i]:=inf;
     update[n]:=1; f[n]:=0; randseed:=inf div 2003;
     repeat
           fillchar(new_update,SizeOf(new_update),0); find:=false;
           for i:=1 to n do begin
               for j:=s[i,1] to s[i,2] do
                   if update[g[j,2]] = 1 then break;
               if update[g[j,2]] = 1 then make(i);
           end;
           update:=new_update;
     until (not find);
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     if f[1] = inf then write(-1)
        else write(f[1]);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
