{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const infile = 'dvd.in'; outfile = 'dvd.out'; max = 2005; inf = 10000000;
type tf = record name: string; dt,c: longint; end;
var film: array [1..max] of tf;
    f: array [1..max,0..5] of longint;
    s1,s2: array [1..max,0..5] of longint;
    n,mx,mx1,mx2: longint;
    tmps: tf;

procedure init;
var i: longint;
    ch: char;
begin
     assign(input,infile);
     reset(input);
     readln(n);
     for i:=1 to n do begin
         read(ch);
         while (not (ch = '"')) do read(ch);
         film[i].name:=ch; read(ch);
         while (not (ch = '"')) do begin
               film[i].name:=film[i].name+ch;
               read(ch);
         end;
         film[i].name:=film[i].name+ch;
         readln(film[i].dt,film[i].c);
     end;
     close(input);
end;

procedure sort(l,r: longint);
var i,j,w,q: longint;
begin
     i:=l; j:=r; w:=film[(l+r) div 2].dt; q:=film[(l+r) div 2].c;
     repeat
           while (film[i].dt < w)or((film[i].dt = w)and(film[i].c < q)) do inc(i);
           while (film[j].dt > w)or((film[j].dt = w)and(film[j].c > q)) do dec(j);
           if i <= j then begin
              tmps:=film[i]; film[i]:=film[j]; film[j]:=tmps;
              inc(i); dec(j);
           end;
     until i > j;
     if i < r then sort(i,r);
     if l < j then sort(l,j);
end;

function min(v1,v2: longint): longint;
begin
     if v1 < v2 then min:=v1
        else min:=v2;
end;

procedure solve;
var i,j,k,t: longint;
begin
     sort(1,n);
     for i:=1 to n do
         for j:=0 to 5 do f[i,j]:=0;
     f[1,0]:=1;
     for i:=2 to n do
                 for j:=n downto 1 do if (film[j].dt <= film[i].dt) then begin
                     if film[j].c = film[i].c then t:=0
                        else t:=1;
                     for k:=0 to 5-t do
                         if f[i,k+t] < f[j,k]+1 then begin
                            s1[i,k+t]:=j;
                            s2[i,k+t]:=k;
                            f[i,k+t]:=f[j,k]+1;
                            if f[i,k+t] > mx then begin
                               mx:=f[i,k+t];
                               mx1:=i; mx2:=k+t;
                            end;
                         end;
                 end;
end;

procedure done;
var t1,t2,i,ans: longint;
    ss: array [1..max] of string;
begin
     assign(output,outfile);
     rewrite(output);
     writeln(mx); ans:=0;
     while (mx1 <> 0) do begin
           inc(ans);
           ss[ans]:=film[mx1].name;
           t1:=mx1; t2:=mx2;
           mx1:=s1[t1,t2];
           mx2:=s2[t1,t2];
     end;
     for i:=ans downto 1 do writeln(ss[i]);
     close(output);
end;

begin
     init;
     solve;
     done;
end.