{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const MaxN = 2000;

Type TFilm = Record
               Name: String[100];
               Year: Integer;
               Region: Byte;
             End;

Var I, N: Integer;
    C: Char;
    A: array[1..MaxN] of TFilm;

Procedure Swap(var A, B: TFilm);
Var C: TFilm;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure Hoar(Left, Right: Integer);
Var I, J, X: Integer;
Begin
  I := Left;
  J := Right;
  X := A[Random(J - I + 1) + I].Year;
  While I < J do Begin
    While A[I].Year < X do Inc(I);
    While A[J].Year > X do Dec(J);
    If I <= J Then Begin
      Swap(A[I], A[J]);
      Inc(I);
      Dec(J);
    End;
  End;
  If Left < J Then Hoar(Left, J);
  If I < Right Then Hoar(I, Right);
End;

Begin
  Assign(Input, 'dvd.in');
  Assign(Output, 'dvd.out');
  Reset(Input);
  Rewrite(Output);
  Readln(N);
  For I := 1 to N do Begin
    Read(C);
    Repeat
      A[I].Name := A[I].Name + C;
      Read(C);
    Until C = '"';
    A[I].Name := A[I].Name + C;
    Read(A[I].Year, A[I].Region);
    Readln;
  End;
  Hoar(1, N);
  Writeln(N);
  For I := 1 to N do
    Writeln(A[I].Name);
  Close(Input);
  Close(Output);
End.