{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
Program Sequence;
Const
     InFile = 'seq.in';
     OutFile = 'seq.out';
     NMax = 100000;
Var
   N : LongInt;
   A : Array [0..NMax] Of LongInt;
   MinA,MaxA : LongInt;
   Res : LongInt;

 Procedure ReadData;
  Var
     I : LongInt;
   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (N);
     MinA:= 10001; MaxA:= -10001;
     For I:= 1 To N Do Begin
       Read (A[I]);
       If A[I] < MinA Then MinA:= A[I];
       If A[I] > MaxA Then MaxA:= A[I];
     End;
     Close (Input);
   End;

 Function Next (I : LongInt) : LongInt;
  Begin
    If I < N Then Next:= I + 1 Else Next:= 1;
  End;

 Procedure Solve;
  Var
     CurS,I,J,K : LongInt;
     GoodSeq : Boolean;
   Begin
     If (MinA >= 0) And (MaxA > 0) Then Begin
      Res:= N;
      Exit;
     End;

     Res:= 0;
     For I:= 1 To N Do Begin
       GoodSeq:= True;
       J:= I;
       CurS:= 0;
       For K:= 1 To N Do Begin
         Inc (CurS,A[J]);
         If CurS < 0 Then Begin
          GoodSeq:= False;
          Break;
         End;
         J:= Next (J);
       End;
       If GoodSeq Then Inc (Res);
     End;
   End;

 Procedure WriteData;
  Begin
    Assign (Output,OutFile); ReWrite (Output);
    Write (Res);
    Close (Output);
  End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.
