const MaxN = 100005;

var
  fi, fo: text;
  n: longint;
  a,s,h,hl: array[0..MaxN] of longint;
  count: longint;

procedure Swap(var a,b: longint);
var c: longint;
begin
  c:=a; a:=b; b:=c;
end;

function Check(i: longint): integer;
var l, r: boolean;
begin
  l:=false; r:=false;
  Check:=0;
  if (i*2<=n) and (s[h[i]]>s[h[i*2]]) then l:=true;
  if (i*2+1<=n) and (s[h[i]]>s[h[i*2+1]]) then r:=true;
  if l and r then begin
    if s[h[i*2]]<s[h[i*2+1]] then Check:=-1 else Check:=1;
  end else
    if l then Check:=-1 else
      if r then Check:=1;
end;

procedure heapify(i: longint);
begin
  i:=hl[i];
  while (i>1) and (s[h[i]]<s[i div 2]) do begin
    swap(h[i],h[i div 2]);
    i:=i div 2;
  end;
  while Check(i)<>0 do begin
    if Check(i)=-1 then begin
      Swap(h[i],h[i*2]);
      Swap(hl[h[i]],hl[h[i*2]]);
      i:=i*2;
    end else begin
      Swap(h[i],h[i*2+1]);
      Swap(hl[h[i]],hl[h[i*2+1]]);
      i:=i*2+1;
    end;
  end;
end;

procedure Solve;
var
  i, base,j: longint;
begin
{  s[0]:=MaxLongInt;}
  s[1]:=a[1];
  For i:=2 to n do
    s[i]:=s[i-1]+a[i];
  For i:=1 to n do begin
    h[i]:=i;
    hl[i]:=i;
  end;
  For i:=n downto 2 do
    if s[h[i]]<s[h[i div 2]] then begin
      Swap(h[i],h[i div 2]);
      Swap(hl[h[i]],hl[h[i div 2]]);
    end;
  base:=0;
  For i:=1 to n do begin
    if s[h[1]]-base>0 then begin
      inc(count);
      {Write(fo,i,': ',base,' - ');
      For j:=1 to n do Write(fo,s[j],' ');
      WRiteLn(fo);}
    end;
    base:=base+a[i];
    s[i]:=s[n]+base;
    heapify(i);
  end;

end;

procedure Init;
var i: longint;
begin
  Assign(fi,'seq.in');
  Assign(fo,'seq.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,n);
  For i:=1 to n do
    Read(fi,a[i]);
end;

procedure Done;
begin
  WriteLn(fo,count);
  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
