{$R-}{$I-}{$N+}

var
  f,f1 :text;

const name = 'dvd';

var
  n :integer;
  reg,year,nreg,nyear :array[1..2000] of integer;
  names,nnames        :array[1..2000] of string;
  data                :array[0..9]    of integer;
  mat                 :array[1..5,1..2000] of integer;
  flags               :array[1..5,1..2000,1..2000] of boolean;

procedure Sort1 (k :integer);
var i :integer;
begin
  {key[i] = (year[i]/k) mod 10}
  for i := 0 to 9 do
    data[i] := 0;
  for i := 1 to n do
    inc(data[year[i] div k mod 10]);
  for i := 1 to 9 do
    data[i] := data[i]+data[i-1];
  for i := n downto 1 do
    begin
      nreg[i]  := reg[data[year[i] div k mod 10]];
      nyear[i] := year[data[year[i] div k mod 10]];
      nnames[i]:= names[data[year[i] div k mod 10]];
      data[year[i] div k mod 10] := data[year[i] div k mod 10]-1;
    end;
  reg := nreg;
  year := nyear;
  names := nnames;
end;

procedure SortAll;
var i :integer;
begin
  Sort1 (1);
  Sort1 (10);
  Sort1 (100);
  Sort1 (1000);
end;

procedure Process;
var t,i,j,k,max,maxn :integer;
begin
  flags[1,1,1] := true;
  flags[2,1,1] := true;
  flags[3,1,1] := true;
  flags[4,1,1] := true;
  flags[5,1,1] := true;
  mat[1,1] := 1;
  mat[2,1] := 1;
  mat[3,1] := 1;
  mat[4,1] := 1;
  mat[5,1] := 1;
  for t := 2       to n do
    begin
      if reg[t]=reg[t-1] then
        begin mat [1,t] := mat[1,t-1]+1;
              flags[1,t]:= flags[1,t-1];
              flags[1,t,t] := true; end
        else begin mat [1,t] := 1;
                   flags [1,t,t] := true;
                   end;
      for i := 2 to 5 do
        begin
          if reg[t]=reg[t-1] then
            begin mat [i,t] := mat[i,t-1]+1;
                  flags[i,t] := flags [i,t-1];
                  flags[i,t,t] := true; end;
          for j := t-1 downto 1 do
            begin
              if reg[t]=reg[j] then continue;
              if mat[i,t] <= mat [i-1,j] then
                begin
                  mat[i,t] := mat [i-1,j]+1;
                  flags[i,t]:=flags[i-1,j];
                  flags[i,t,t]:=true;
                end;
            end;
        end;
    end;
end;

var
  i :integer;
  c :char;

begin
  assign (f,name+'.in');
  assign (f1,name+'.out');
  reset (f);
  rewrite (f1);
    readln (f,n);
    for i := 1 to n do
      begin
        read (f,c);
        names[i]:= '"';
        repeat
          read (f,c);
          names[i] := names[i]+c;
        until c = '"';
        readln (f,year[i],reg[i]);
      end;
    SortAll;
    Process;
    writeln (f1,mat[5,n]);
    for i := 1 to n do
      if flags[5,n,i] then
        writeln (f1,names[i]);
  close (f);
  close (f1);
end.
