const
     FileIn='seq.in';
     FileOut='seq.out';
     MaxN=100000;
var
   N: LongInt;
   Seq: array [1..MaxN] of LongInt;
   Answer: LongInt;

   Sums, MinLeft, MinRight: array [1..MaxN] of Int64;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, N);
     for NItem:=1 to N
         do Read (F, Seq [NItem]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

procedure CalcSums;
var
   NItem: LongInt;
begin
     Sums [1]:=Seq [1];
     for NItem:=2 to N
         do Sums [NItem]:=Sums [NItem-1]+Seq [NItem];
     MinLeft [1]:=Seq [1];
     for NItem:=2 to N
         do if Seq [NItem]<0
               then MinLeft [NItem]:=MinLeft [NItem-1]+Seq [NItem]
               else MinLeft [NItem]:=MinLeft [NItem-1];
     MinRight [N]:=Seq [N];
     for NItem:=N-1 downto 1
         do if Seq [NItem]<0
               then MinRight [NItem]:=MinRight [NItem+1]+Seq [NItem]
               else MinRight [NItem]:=MinRight [NItem+1];
end;

function GetMinRight (aFirst: LongInt): Int64;
var
   Sum, MinSum: Int64;
   Index: LongInt;
begin
     Sum:=Seq [aFirst];
     MinSum:=Sum;
     for Index:=aFirst+1 to N
         do begin
            Sum:=Sum+Seq [Index];
            if MinSum>Sum
               then MinSum:=Sum;
         end;
     GetMinRight:=MinSum;
end;

procedure FindAnswer;
var
   j: LongInt;
   MinRight: LongInt;
begin
     Answer:=0;
     for j:=2 to N
         do begin
            MinRight:=GetMinRight (j);
            if (MinRight>0) and ((Sums [N]-Sums [j-1])+MinLeft [j-1]>0)
               then Inc (Answer);
         end;
end;

procedure Solve;
begin
     CalcSums;
     FindAnswer;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
