program zzz;

const
  maxn = 100000;
  xx = 1 shl 17;
  inf = MaxLongint;

var
  ans,i,j,k,n,m,sum: Longint;
  mm,a: array[0..maxn] of Longint;
  tr: array[1..1 shl 18] of Longint;

function min(a,b: Longint): Longint;
begin
  if a > b then min := b else min := a;
end;

procedure buildtree(n: Longint);
var i,j: Longint;
begin
  for i := 1 to 1 shl 18 do begin
    tr[i] := inf;
  end;
  for i := 1 to n do begin
    tr[xx+i-1] := mm[i];
  end;
  for i := xx-1 downto 1 do begin
    tr[i] := min(tr[i*2],tr[i*2+1]);
  end;
end;

function query(st,fin: Longint): Longint;
var ans: Longint;
begin
  st := st + xx - 1;
  fin := fin + xx - 1;
  ans := inf;
  while st <= fin do begin
    ans := min(ans,tr[st]);
    ans := min(ans,tr[fin]);
    st := (st+1) div 2;
    fin := (fin-1) div 2;
  end;
  query := ans;
end;

begin
  assign(input,'seq.in'); reset(input);
  read(n);
  for i := 1 to n do read(a[i]);
  k := 0;
  for i := 1 to n do begin
    k := k + a[i];
    mm[i] := k;
  end;
  mm[0] := 0;
  sum := k;
  buildtree(n);
  k := 0;
  if query(1,n) > 0 then ans := 1 else ans := 0;
  for i := 2 to n do begin
    k := k + a[i-1];
    if min(query(i,n)-k,sum-k+query(1,i-1)) > 0 then inc(ans);
  end;
  assign(output,'seq.out'); rewrite(output);
  writeln(ans);
  close(input);
  close(output);
end.
