#define ONLINE
#include <stdio.h>

void calcprefix(short*prefixes,const short*str,const short len) {
  short pos,prefix;
  prefixes[0]=0;
  prefix=0;
  for (pos=1; pos<len; pos++) {
    while ((prefix>0)&&(str[prefix]!=str[pos])) prefix=prefixes[prefix-1];
    if (str[prefix]==str[pos]) prefix++;
    prefixes[pos]=prefix;
  }
}
short findmatch(const short*str,const short*needle,const short*prefixes,const short len) {
  short pos,match;
  match=0;
  for (pos=0; pos<len; pos++) {
    while ((match>0)&&(needle[match]!=str[pos])) match=prefixes[match-1];
    if (needle[match]==str[pos]) match++;
  }
  return(len-match);
}

short n_nums,n_bar;
short*nums;
short*prefixes;

int main(void) {
  #ifdef ONLINE
  freopen("e.in","rt",stdin);
  freopen("e.out","wt",stdout);
  #endif
  short i_num;
  scanf("%hd",&n_nums);
  nums=new short[n_nums];
  for (i_num=0; i_num<n_nums; i_num++) scanf("%hd",&nums[i_num]);
  prefixes=new short[n_nums];
  calcprefix(prefixes,nums,n_nums);
  n_bar=findmatch(nums+1,nums,prefixes,n_nums-1)+1;
  delete[]prefixes;
  printf("%hd\n",n_bar);
  delete[]nums;
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


