{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'g.out';
  cinfile = 'g.in';

  nmax = 3011;
  tmax = 1000010;

type
  int = longint;
  real = extended;
  integer = smallint;

  mas = array [1..nmax] of int;

var
  n, k : int;
  ans : int;

  s, f : mas;
  t : array [0..tmax] of integer;

procedure outdata;
var
  i, j : int;
begin
  writeln(t[f[n]]);
  for i:= 1 to f[n] do
    if t[i] > t[i-1] then write(i,' ');
  writeln;
end;

procedure sort(var s, f : mas);
var
  i, j, x : int;
begin
  for i:= 1 to n-1 do
    for j:= i+1 to n do
      if f[i] > f[j] then
      begin
        x:= f[i];
        f[i]:= f[j];
        f[j]:= x;
        x:= s[i];
        s[i]:= s[j];
        s[j]:= x;
      end;
end;

procedure solve;
var
  i, j : int;
  x : int;
  c, cp : int;
  q : boolean;
begin
  sort(s,f);
  t[0]:= 0;
  c:= 1;
  cp:= 1;
  i:= 0;
  while c <= n do
  begin
    inc(i);
    q:= false;
    if cp <= n then
    begin
      while (i = f[cp]-1) and (cp <= n) do
      begin
        q:= q or (t[i-1] - t[s[cp]-1] = 0);
        inc(cp);
      end;
    end;
    while (i = f[c]) and (c <= n) do
    begin
      q:= q or (t[i-1] - t[s[c]-1] <= 1);
      inc(c);
    end;
    t[i]:= t[i-1]+ord(q);
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
  for i:= 1 to n do read(s[i],f[i]);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.