{$I-,Q-,R-,S-}
const
  maxn=3000;

type
  rekl=record
    b,e:longint;
  end;

var
  t1,t2:longint;
  j,m,i,n:integer;
  a:array[1..maxn] of rekl;
  ans:array[1..maxn*2] of longint;
  c:integer;

procedure swap(i,j:integer);
var
  temp:rekl;
begin
  temp:=a[i];
  a[i]:=a[j];
  a[j]:=temp;
end;

procedure qsort(l,r:integer);
var
  i,j:integer;
  x:longint;
begin
  i:=l;
  j:=r;
  x:=a[(l+r) div 2].b;
  repeat
    while (a[i].b<x) do
      inc(i);
    while (x<a[j].b) do
      dec(j);
    if i<=j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;

begin
  assign(input,'g.in');
  reset(input);
  assign(output,'g.out');
  rewrite(output);

  read(n);
  for i:=1 to n do begin
    read(a[i].b,a[i].e);
  end;
  qsort(1,n);

  m:=1;
  for i:=2 to n do begin
    while (m>0) and (a[m].e>=a[i].e) do
      dec(m);
    inc(m);
    a[m]:=a[i];
  end;


  t1:=-1;
  t2:=-1;
  c:=0;
  i:=1;
  while true do begin
    while (i<=m) and (t2>=a[i].b) do begin
      inc(i);
    end;
    if i>m then
      break;
    if t1<a[i].b then begin
      inc(c);
      t2:=t1;
      t1:=a[i].e-1;
      ans[c]:=t1;
    end;
    inc(c);
    t2:=t1;
    t1:=a[i].e;
    ans[c]:=t1;
  end;


  writeln(c);
  for i:=1 to c do
    write(ans[i],' ');

  close(input);
  close(output);
end.

