{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}

type
  TPoint = record x,y : integer; end;

var
  l,u,x1,y1 : integer;
  num1,num : integer;
  p,p1     : array [1..80] of TPoint;
  use      : array [1..40] of boolean;
  rt       : extended;
  rx,ry    : longint;
  q        : array [1..40] of longint;
  t        : array [1..40] of record v,time : longint; end;
  down,up  : integer;
  a,b      : array [1..40] of Tpoint;
  time     : array [1..40] of longint;
  min      : extended;
  n,i,j    : integer;

procedure init;
begin
  assign(input,'f.in'); reset(input);
  assign(output,'f.out'); rewrite(output);
  read(n); num1:=0;
  for i:=1 to n do
  begin
    read(a[i].x,a[i].y,b[i].x,b[i].y,time[i]);
    num1:=num1+2;
    p[num1-1].x:=a[i].x;
    p[num1-1].y:=a[i].y;
    p[num1].x:=b[i].x;
    p[num1].y:=b[i].y;
  end;
  close(input);
end;

function Check(q,w : integer) : boolean;
var
  i : integer;
  t,a1,b1,a2,b2 : extended;

begin
  check:=false;
  for i:=1 to n do
    if ((a[i].x=p1[q].x)and(a[i].y=p1[q].y)and(b[i].x=p1[w].x)and(b[i].y=p1[w].y))or
       ((a[i].x=p1[w].x)and(a[i].y=p1[w].y)and(b[i].x=p1[q].x)and(b[i].y=p1[q].y)) then
       begin
         check:=true;
         exit;
       end;
end;

procedure Sort(l, r: Integer);
var
  x1,i, j, x, y: integer;

begin
  i := l; j := r; x := p[(l+r) DIV 2].x; x1:=p[(l+r) div 2].y;
  repeat
    while (p[i].x<x)or((p[i].x=x)and(p[i].y<x1)) do i := i + 1;
    while (x<p[j].x)or((x=p[j].x)and(x1<p[j].y)) do j := j - 1;
    if i <= j then
    begin
      y:=p[i].x; p[i].x:=p[j].x; p[j].x:=y;
      y:=p[i].y; p[i].y:=p[j].y; p[j].y:=y;
      i:=i+1; j:=j-1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

function max(q,w : integer) : integer;
begin
  if q>w then max:=q else max:=w;
end;

function Intersect(a1,b1,a2,b2 : tpoint) : boolean;
var
  maxx,minx,maxy,miny : integer;

begin
  intersect:=false;
  if (a2.x<>b2.x)and(a2.y<>b2.y) then
  begin
    if abs(a1.y-a2.y)=1 then
      if abs(b1.y-b2.y)=1 then
    if abs(a1.x-a2.x)=0 then
      if abs(b1.x-b2.x)=0 then intersect:=true;
  end;
end;

procedure UpdateTurn(z : integer);
begin
  if q[z]=0 then
  begin
    q[z]:=q[t[down].v]+1;
    t[up].v:=z;
    t[up].time:=t[down].time+1;
    up:=up+1;
  end;
end;

begin
  init;
  Sort(1,n*2);
  num:=1; p1[1]:=p[1];
  for i:=2 to num1 do
    if not((p[i].x=p[i-1].x)and(p[i].y=p[i-1].y)) then
    begin
      num:=num+1;
      p1[num]:=p[i];
    end;
  rt:=maxlongint;
  for j:=1 to num do
  begin
    min:=0;
    fillchar(t,sizeof(t),0);
    fillchar(q,sizeof(q),0);
    down:=1;
    up:=2;
    t[1].v:=j;
    t[1].time:=1;
    q[j]:=1;
    while down<up do
    begin
      for i:=1 to num do
        if Check(t[down].v,i)=true then
        begin
          if (p1[t[down].v].x<>p1[i].x)and(p1[t[down].v].y<>p1[i].y) then
            for u:=1 to n do
              if Intersect(p1[t[down].v],p1[i],a[u],b[u]) then
              begin
                for l:=1 to num do
                  if (p1[l].x=a[u].x)and(p1[l].y=a[u].y) then
                  begin
                     x1:=l;
                     break;
                  end;
                for l:=1 to num do
                  if (p1[l].x=b[u].x)and(p1[l].y=b[u].y) then
                  begin
                     y1:=l;
                     break;
                  end;
                UpdateTurn(x1); UpdateTurn(y1);
              end;
           if q[i]=q[t[down].v] then
           begin
             if (q[i]+0.5)>min then min:=(q[i]+0.5);
           end;
           UpdateTurn(i);
        end;
      down:=down+1;
    end;
    for i:=1 to up do
      if t[i].time>min then min:=t[i].time;
    if min<rt then
    begin
      rt:=min;
      rx:=p1[j].x;
      ry:=p1[j].y;
    end;
  end;
  writeln(rx,' ',ry);
  write(rt-1:0:2);
  close(output);
end.
