{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
const
  inf = 'f.in'; ouf = 'f.out';
  max = 50; eps = 1e-8;
type
  real = extended;
  byar = array[1..max] of byte;
  procedure swap(var a, b: integer);
  var
    c: integer;
  begin
    c := a; a := b; b := c;
  end;
var
  a, b: array[1..max] of integer;
  t, ts: array[1..max] of real;
  c: array[1..max * 2] of byar;
  x, y: array[1..max * 2] of integer;
  w, fb, bc: byar;
  n, m: integer;
  function cross(ia, ib: integer): boolean;
  var
    xa, ya, xb, yb, xc, yc, xd, yd: integer;
  begin
    xa := x[a[ia]]; xb := x[b[ia]];
    ya := y[a[ia]]; yb := y[b[ia]];

    xc := x[a[ib]]; xd := x[b[ib]];
    yc := y[a[ib]]; yd := y[b[ib]];
    if (xa > xb) then
    begin
      swap(xa, xb); swap(ya, yb);
    end;
    if (xc > xd) then
    begin
      swap(xc, xd); swap(yc, yd);
    end;
    if (xa = xc) and (xb = xd) and
    (((ya > yc) and (yd > yb)) or
     ((ya < yc) and (yd < yb))) then cross := true else cross := false;
  end;
  function burn(k: integer): real;
  var
    i, j, p, q: longint; ct: real;
    tm: real; again: boolean;
  begin
    fillchar(w, sizeof(w), 0); q := n;
    fillchar(bc, sizeof(bc), 0);
    tm := 0; ct := 0;
    w := c[k]; bc[k] := 1;
    fillchar(fb, sizeof(fb), 0);
    while (q > 0) do
    begin
      tm := -1; again := false;
      for i := 1 to n do
        if (w[i] > 0) and (w[i] < 5)
        and ((tm = -1) or (tm> t[i])) then
           tm := t[i];
      for i := 1 to n do
        if (w[i] > 0) and (w[i] < 5) and (t[i] = tm) then
        begin
          for j := 1 to n do
            if (w[j] < 3) and (fb[j] = 0) then
              if cross(i, j) then
              begin
                 fb[j] := 1; fb[i] := 1;
                 inc(w[j],2); again := true;
                 if (w[j] = 2) then t[j] := t[j] / 2;
                 if (w[j] = 3) then t[j] := 1/3* t[j];
                 if (w[j] = 4) then t[j] := 2/3* t[j];
                 t[j] := t[j] + tm / 2;
              end;
        end;
      if again then continue;
      for i := 1 to n do
        if (w[i] > 0) and (w[i] < 5) and (t[i] = tm) then
          w[i] := 5;
      for i := 1 to n do
        if (w[i] < 5) and (w[i] > 0) then
          t[i] := t[i] - tm;
{We delete burned matches, determing, whose turn is to burn}
      for i := 1 to n do
        if (w[i] = 5) and (t[i] = tm) then
        begin
          t[i] := 0; dec(q);
          if (bc[a[i]] = 0) then
          begin
             for p := 1 to n do
               if (w[p] < 4) and (c[a[i], p] > 0) then
               begin
                 inc(w[p], c[a[i], p]);
                 if (w[p] = 2) then t[p] := t[p]/2;
                 if (w[p] = 3) then t[p] := t[p]*2/3;
                 if (w[p] = 4) then t[p] := t[p]*3/4;
               end;
             bc[a[i]] := 1;
          end;
           if (bc[b[i]] = 0) then
           begin
             for p := 1 to n do
               if (w[p] < 4) and (c[b[i],p] > 0) then
               begin
                 inc(w[p], c[b[i], p]);
                 if (w[p] = 2) then t[p] := t[p]/2;
                 if (w[p] = 3) then t[p] := t[p]*2/3;
                 if (w[p] = 4) then t[p] := t[p]*3/4;
               end;
             bc[b[i]] := 1;
           end;
        end;
      ct := ct + tm;
    end;
    burn := ct;
  end;
var
  i, j: integer; xc, yc: integer;
  xm, ym: integer; cm, tm: real; ok: boolean;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  read(input, n);
  fillchar(w, sizeof(w), 0);
  fillchar(a, sizeof(a), 0); b := a;
  fillchar(c, sizeof(c), 0);
  for i := 1 to n do
  begin
    read(input, xc, yc);
    ok := true;
    for j := 1 to m do
      if (x[j] = xc) and (y[j] = yc) then
      begin
        ok := false; break;
      end;
    if ok then
    begin
      inc(m); a[i] := m; x[m] := xc; y[m] := yc; j := m;
    end else a[i] := j;
    c[j, i] := 1;
    read(input, xc, yc); read(input, t[i]);
    ok := true;
    for j := 1 to m do
      if (x[j] = xc) and (y[j] = yc) then
      begin
        ok := false; break;
      end;
    if ok then
    begin
      inc(m); b[i] := m; x[m] := xc; y[m] := yc; j := m;
    end else b[i] := j;
    c[j, i] := 1;
  end;
  tm := -1; xc := 0; yc := 0;
  ts := t;
  for i := 1 to m do
  begin
    t := ts;
    cm := burn(i);
    if (tm = -1) or (tm - cm > eps) then
    begin
      tm := cm; xc := x[i]; yc := y[i];
    end;
  end;
  writeln(output, xc, ' ', yc);
  writeln(output, tm:2:4);
  close(input); close(output);
end.
