program zzz;

const
  inf = 1E20;
  MaxN = 100;
type
  TPoint = record
    x,y: Longint;
  end;
  TReal = Double;

var
  a: array[1..2*maxn,1..2] of TPoint;
  num: array[1..2*maxn,1..2] of Longint;
  Best,t: array[1..2*maxn] of TReal;
  is: array[1..2*maxn] of Boolean;
  sc,i,j,ansx,ansy,k,coln,n,m: Longint;
  p1,p2: TPoint;
  ans: TReal;
  fl1,fl2: Boolean;

procedure Doit(nc,aa,bb: Longint);
var i,j,k: Longint;
    res,tm: Double;
begin
  res := 0;
  for i := 1 to coln do best[i] := inf;
  best[nc] := 0;
  {FORD-BELLMAN}
  for j := 1 to coln do begin
    for i := 1 to n do begin
      if best[num[i,1]] > best[num[i,2]] + t[i] then best[num[i,1]] := best[num[i,2]] + t[i];
      if best[num[i,2]] > best[num[i,1]] + t[i] then best[num[i,2]] := best[num[i,1]] + t[i];
    end;
  end;
  {/FORD-BELLMAN}
  for i := 1 to n do begin
    if best[num[i,1]] < best[num[i,2]] then begin
      tm := best[num[i,2]] - best[num[i,1]] + (t[i] - best[num[i,2]] + best[num[i,1]])/2 + best[num[i,1]];
    end else begin
      tm := best[num[i,1]] - best[num[i,2]] + (t[i] - best[num[i,1]] + best[num[i,2]])/2 + best[num[i,2]];
    end;
    if tm > res then res := tm;
  end;
  if res < ans then begin
    ans := res;
    ansx := aa;
    ansy := bb;
  end;
end;

begin
  assign(input,'f.in'); reset(input);
  assign(output,'f.out'); rewrite(output);
  read(n);
  for i := 1 to n do begin
    read(a[i,1].x,a[i,1].y,a[i,2].x,a[i,2].y,t[i]);
    for j := 1 to 2 do begin
      a[i,j].x := a[i,j].x * 2;
      a[i,j].y := a[i,j].y * 2;
    end;
  end;
  sc := n;
  for i := 1 to n do begin
    if is[i] then continue;
    for j := i+1 to n do begin
      p1.x := (a[i,1].x+a[i,2].x) div 2;
      p2.x := (a[j,1].x+a[j,2].x) div 2;
      p1.y := (a[i,1].y+a[i,2].y) div 2;
      p2.y := (a[j,1].y+a[j,2].y) div 2;
      if (p1.x = p2.x) and (p1.y = p2.y) then begin
        inc(sc);
        a[sc,1] := a[i,1];
        a[sc,2] := p1;
        t[sc] := t[i]/2;
        inc(sc);
        a[sc,1] := a[j,1];
        a[sc,2] := p1;
        t[sc] := t[j]/2;
        a[i,1] := p1;
        a[j,1] := p1;
        t[i] := t[i]/2;
        t[j] := t[j]/2;
        is[i] := true;
        is[j] := true;
        break;
      end;
    end;
  end;
  n := sc;
  coln := 0;
  ans := inf;
  for i := 1 to n do begin
    fl1 := false;
    fl2 := false;
    for j := i-1 downto 1 do begin
      for k := 1 to 2 do begin
        if (a[j,k].x = a[i,1].x) and (a[j,k].y = a[i,1].y) then begin
          fl1 := true;
          num[i,1] := num[j,k];
        end;
        if (a[j,k].x = a[i,2].x) and (a[j,k].y = a[i,2].y) then begin
          fl2 := true;
          num[i,2] := num[j,k];
        end;
      end;
    end;
    if not fl1 then begin
      inc(coln);
      num[i,1] := coln;
    end;
    if not fl2 then begin
      inc(coln);
      num[i,2] := coln;
    end;
  end;
  for i := 1 to n do begin
    for j := 1 to 2 do begin
      if a[i,j].x mod 2 = 0 then Doit(num[i,j],a[i,j].x,a[i,j].y);
    end;
  end;
  writeln(ansx div 2,' ',ansy div 2);
  writeln(ans:0:7);
  close(input);
  close(output);
end.
