program zzz;

const
  maxn = 3000;

type
  rec = record
    st,fin: Longint;
  end;

var
  a: array[1..maxn] of rec;
  cur: array[1..maxn] of Longint;
  vis: array[1..2*maxn] of Boolean;
  b: array[1..2*maxn] of Longint;
  ans,sc,i,j,k,n,m: Longint;

procedure swap(var a,b: Longint);
var i: Longint;
begin
  i := a;
  a := b;
  b := i;
end;

procedure sort(st,fin: Longint);
var i,j,k: Longint;
begin
  k := b[st+random(fin-st)];
  i := st;
  j := fin;
  while i <= j do begin
    while k > b[i] do inc(i);
    while k < b[j] do dec(j);
    if i <= j then begin
      swap(b[i],b[j]);
      inc(i);
      dec(j);
    end;
  end;
  if j > st then sort(st,j);
  if i < fin then sort(i,fin);
end;

function candel(j: Longint): Boolean;
var i: Longint;
begin
  candel := false;
  for i := 1 to n do begin
    if (b[j] >= a[i].st) and (b[j] <= a[i].fin) and (cur[i] = 2) then exit;
  end;
  candel := true;
end;

procedure del(j: Longint);
var i: Longint;
begin
  for i := 1 to n do begin
    if (b[j] >= a[i].st) and (b[j] <= a[i].fin) then dec(cur[i]);
  end;
end;

begin
  assign(input,'g.in'); reset(input);
  assign(output,'g.out'); rewrite(output);
  read(n);
  for i := 1 to n do read(a[i].st,a[i].fin);
  for i := 1 to n do begin
    b[i*2-1] := a[i].st;
    b[i*2] := a[i].fin;
  end;
  sort(1,2*n);
  sc := 1;
  for i := 2 to 2*n do begin
    if b[i] <> b[sc] then begin
      inc(sc);
      b[sc] := b[i];
    end;
  end;
  for i := 1 to n do begin
    for j := 1 to sc do begin
      if (b[j] >= a[i].st) and (b[j] <= a[i].fin) then inc(cur[i]);
    end;
  end;
  fillchar(vis,sizeof(vis),true);
  for i := 1 to sc do begin
    if candel(i) then begin
      vis[i] := false;
      del(i);
    end;
  end;
  for i := 1 to sc do if vis[i] then inc(ans);
  writeln(ans);
  for i := 1 to sc do if vis[i] then write(b[i],' ');
  writeln;
  close(input);
  close(output);
end.
