#include <stdio.h>
#include <math.h>
#define m 10000
#define e 1e-7
#define inf 1e10
typedef double dbl;
int n,k,bad[m],g[m],sp[m],ll;
dbl x1[m],y11[m],x2[m],y2[m],xx1[m],yy1[m],xx2[m],yy2[m],v[m],xl[m],yl[m],
ss[m];
dbl ds(dbl x1,dbl y11,dbl x2,dbl y2)
{
  return (x1-x2)*(x1-x2)+(y11-y2)*(y11-y2);
}
void read(void)
{
  int i;
  scanf("%d",&n);
  for(i=1;i<=n;i++)
  {
    scanf("%lf%lf%lf%lf%lf",&x1[i],&y11[i],&x2[i],&y2[i],&v[i]);
    v[i]=sqrt(ds(x1[i],y11[i],x2[i],y2[i]))/v[i];
  }
}
dbl time(dbl x1,dbl y11,dbl x2,dbl y2,dbl v)
{
  dbl t;
  t=ds(x1,y11,x2,y2);
  t=sqrt(t);
  t/=v;
  return t;
}
dbl abc(dbl x1,dbl y11,dbl x2,dbl y2,dbl *a,dbl *b,dbl *c)
{
  *a=y11-y2;*b=x2-x1;*c=x1**a+y11**b;
}
int isin(dbl x1,dbl y11,dbl x2,dbl y2,dbl x,dbl y)
{
  dbl a,b,c;
  if(fabs(x1-x2)<e&&fabs(y11-y2)<e)
  {
    if(fabs(x1-x)<e&&fabs(y11-y)<e)return 1;
    return 0;
  }
  abc(x1,y11,x2,y2,&a,&b,&c);
  if(fabs(a*x+b*y-c)>e)return 0;
  if(((y11>y-1e-7&&y+1e-7>y2)||(y2>y-1e-7&&y+1e-7>y11))&&
    ((x1>x-e&&x+e>x2)||(x2>x-e&&x+e>x1)))return 1;
  return 0;
}
int inter(dbl x1,dbl y11,dbl x2,dbl y2,
dbl xx1,dbl yy1,dbl xx2,dbl yy2,dbl *x,dbl *y)
{
  dbl a1,a2,b1,b2,c1,c2,d;
  abc(x1,y11,x2,y2,&a1,&b1,&c1);
  abc(xx1,yy1,xx2,yy2,&a2,&b2,&c2);
  d=a1*b2-a2*b1;
  if(fabs(d)>e)
  {
    *x=(c1*b2-c2*b1)/d;
    *y=(a1*c2-a2*c1)/d;
    return 1;
  }
  if(isin(x1,y11,x2,y2,xx1,yy1)){*x=xx1;*y=yy1;return 1;}
  if(isin(x1,y11,x2,y2,xx2,yy2)){*x=xx2;*y=yy2;return 1;}
  if(isin(xx1,yy1,xx2,yy2,x1,y11)){*x=x1;*y=y11;return 1;}
  if(isin(xx1,yy1,xx2,yy2,x2,y2)){*x=x2;*y=y2;return 1;}
  return 0;
}
dbl min2(dbl x,dbl y)
{
  if(x<y&&fabs(x)>e)return x;
  if(fabs(y)>e)return y;
  return inf;
}
dbl calc2(int s)
{
  int i,j,p,a[m],pp;
  dbl x,y;
  if(s==2)
    s=2;
  for(i=1,p=0;i<=k;i++)
  {
    if(i==4)
      i=4;
    if(isin(x1[s],y11[s],x2[s],y2[s],xx1[i],yy1[i])&&
       isin(x1[s],y11[s],x2[s],y2[s],xx2[i],yy2[i]))
      p++,a[p]=i;
  }
  for(j=1;j<=p;j++)bad[j]=0;
  for(i=1;i<=p;i++)
    for(j=1;j<=p;j++)
      if(i!=j&&!bad[j]&&
         isin(xx1[a[i]],yy1[a[i]],xx2[a[i]],yy2[a[i]],xx1[a[j]],yy1[a[j]])&&
         isin(xx1[a[i]],yy1[a[i]],xx2[a[i]],yy2[a[i]],xx2[a[j]],yy2[a[j]]))
        bad[j]=1;
  for(i=1,pp=0;i<=p;i++)
    if(!bad[i])g[++pp]=a[i];
  if(pp==2)
  {
    if(inter(xx1[g[1]],yy1[g[1]],xx2[g[1]],yy2[g[1]],
             xx1[g[2]],yy1[g[2]],xx2[g[2]],yy2[g[2]],&x,&y))
      return 0;
    if(isin(xx1[g[1]],yy1[g[1]],xx2[g[1]],yy2[g[1]],x1[s],y11[s]))
      return sqrt(ds(xx2[g[1]],yy2[g[1]],xx1[g[2]],yy1[g[2]]));
    return (sqrt(ds(xx2[g[2]],yy2[g[2]],xx1[g[1]],yy1[g[1]])))/2/v[s];
  }
  if(pp==0)return (sqrt(ds(x1[s],y11[s],x2[s],y2[s])))/v[s];
  return (sqrt(ds(x1[s],y11[s],x2[s],y2[s]))-
         sqrt(ds(xx1[g[1]],yy1[g[1]],xx2[g[1]],yy2[g[1]])))/v[s];
}
dbl calc(int s)
{
  dbl l=calc2(s);
  return l;
}
void init(void)
{
  int i,j;
  for(i=1;i<=n;i++)
  {
    if(fabs(ds(x1[i],y11[i],x2[i],y2[i])-1)>e)
    {
       dbl x=(x1[i]+x2[i])/2,y=(y11[i]+y2[i])/2;
       if(fabs(x1[i]-floor(x1[i]))>e||fabs(x2[i]-floor(x2[i]))>e)continue;
       if((x<x1[i]-e&&x>x2[i]+e)||(x<x2[i]-e&&x>x1[i]+e))
       {
         n++;
         x1[n]=x;y11[n]=y;x2[n]=x2[i];y2[n]=y2[i];
         x2[i]=x;y2[i]=y;v[n]=v[i];
       }
    }
  }
  for(j=1;j<=k;j++)
  {
    i=sp[j];
    if(fabs(ds(x1[i],y11[i],x2[i],y2[i])-1)>e)
    {
       dbl x=(x1[i]+x2[i])/2,y=(y11[i]+y2[i])/2;
       if((x<xx1[i]-e&&x>xx2[i]+e)||(x<xx2[i]-e&&x>xx1[i]+e))
       {
         k++;
         xx1[k]=x;yy1[k]=y;xx2[k]=xx2[i];yy2[k]=yy2[i];
         xx2[i]=x;yy2[i]=y;
       }
    }
  }
}
dbl max2(dbl x,dbl y)
{
  if(x>y)return x;
  return y;
}
int good(dbl x,dbl y)
{
  int i;
  for(i=1;i<=k;i++)
    if(isin(xx1[i],yy1[i],xx2[i],yy2[i],x,y))return 0;
  return 1;
}
void solve(void)
{
  int i,j,jj,old=n,oldx1[m],oldx2[m],oldy1[m],oldy2[m],f;
  dbl bx,by,bt=inf,x,y,t1,t,tt;
  old=n;
  for(j=1;j<=n;j++)
    oldx1[j]=x1[j],oldy1[j]=y11[j],oldx2[j]=x2[j],oldy2[j]=y2[j];
  for(i=1;i<=n*2;i++)
  {
    if(i%2)
    {
      xx1[1]=x1[i/2+1],yy1[1]=y11[i/2+1];
      xx2[1]=x2[i/2+1],yy2[1]=y2[i/2+1];
    }
    else
    {
      xx2[1]=x1[i/2],yy2[1]=y11[i/2];
      xx1[1]=x2[i/2],yy1[1]=y2[i/2];
    }
    f=k=1;
    xx2[1]=xx1[1]/**0.99+xx2[1]*0.01*/;
    yy2[1]=yy1[1];/**0.99+yy2[1]*0.01;*/sp[1]=(i+1)/2;
    for(j=1;j<=n;j++)
      if(fabs(xx1[1]-x1[j])<e&&fabs(yy1[1]-y11[j])<e&&sp[1]!=j)
      {
        sp[++k]=j;xx1[k]=xx2[k]=x1[j];yy1[k]=yy2[k]=y11[j];
      }
      else if(fabs(xx1[1]-x2[j])<e&&fabs(yy1[1]-y2[j])<e&&sp[1]!=j)
      {
        sp[++k]=j;xx1[k]=xx2[k]=x2[j];yy1[k]=yy2[k]=y2[j];
      }
    t=0;
    //t=time(xx1[1],yy1[1],xx2[1],yy2[1],v[(i+1)/2]);
    while(f)
    {
      tt=inf;
      for(j=1;j<=k;j++)
        for(jj=1;jj<=n;jj++)
        {
          if(jj!=sp[j]&&inter(x1[sp[j]],y11[sp[j]],x2[sp[j]],y2[sp[j]],
             x1[jj],y11[jj],x2[jj],y2[jj],&x,&y))
          {
            if(good(x,y))
            {
              t1=min2(time(xx1[j],yy1[j],x,y,v[sp[j]]),
                      time(xx2[j],yy2[j],x,y,v[sp[j]]));
              //tt=min2(t1,tt);
              if(tt>t1&&fabs(t1)>e)
                ll=0,tt=t1;
              ll++;xl[ll]=x,yl[ll]=y;ss[ll]=jj;
            }
          }
          if(jj==sp[j])
          {
            if(fabs(ds(x1[jj],y11[jj],x2[jj],y2[jj])-1)>e)
            {
              x=(x1[sp[j]]+x2[sp[j]])/2;y=(y11[sp[j]]+y2[sp[j]])/2;
              if(good(x,y))
              {
                t1=min2(time(xx1[j],yy1[j],x,y,v[sp[j]]),
                        time(xx2[j],yy2[j],x,y,v[sp[j]]));
                if(tt>t1&&fabs(t1)>e)
                  ll=0,tt=t1;
                //tt=min2(t1,tt);
              }
            }
            x=x1[sp[j]];y=y11[sp[j]];
            if(good(x,y))
            {
              t1=min2(time(xx1[j],yy1[j],x,y,v[sp[j]]),
                      time(xx2[j],yy2[j],x,y,v[sp[j]]));
              if(tt>t1&&fabs(t1)>e)
                ll=0,tt=t1;
              //tt=min2(t1,tt);
            }
            x=x2[sp[j]];y=y2[sp[j]];
            if(j==2&&jj==2)
               j=2;
            if(good(x,y))
            {
              t1=min2(time(xx1[j],yy1[j],x,y,v[sp[j]]),
                      time(xx2[j],yy2[j],x,y,v[sp[j]]));
              if(tt>t1&&fabs(t1)>e)
                ll=0,tt=t1;
            }
          }
        }
      for(j=1;j<=k&&fabs(tt-inf)>e;j++)
        for(jj=1;jj<=n;jj++)
          if(jj!=sp[j]&&inter(x1[sp[j]],y11[sp[j]],x2[sp[j]],y2[sp[j]],
             x1[jj],y11[jj],x2[jj],y2[jj],&x,&y))
          {
            if(!good(x,y))continue;
            t1=min2(time(xx1[j],yy1[j],x,y,v[sp[j]]),
                    time(xx2[j],yy2[j],x,y,v[sp[j]]));
            if(fabs(tt-t1)<e)
            {
              k++;xx1[k]=xx2[k]=x;yy1[k]=yy2[k]=y;sp[k]=-jj;
            }
          }
       if(fabs(tt-inf)<e)
       {
         f=0;break;
       }
       t+=tt;
      for(j=1;j<=k;j++)
       {
         dbl t1=time(xx1[j],yy1[j],x1[sp[j]],y11[sp[j]],v[sp[j]]);
         if(sp[j]<0)
         {
           sp[j]=-sp[j];continue;
         }
         if(fabs(t1)>e)
         {
           t1=tt/t1;
           xx1[j]=x1[sp[j]]*t1+xx1[j]*(1-t1);
           yy1[j]=y11[sp[j]]*t1+yy1[j]*(1-t1);
         }
         t1=time(xx2[j],yy2[j],x2[sp[j]],y2[sp[j]],v[sp[j]]);
         if(fabs(t1)<e)continue;
         t1=tt/t1;
         xx2[j]=x2[sp[j]]*t1+xx2[j]*(1-t1);
         yy2[j]=y2[sp[j]]*t1+yy2[j]*(1-t1);
       }
       j=1;
     }
     init();
     t1=-inf;
     for(j=1;j<=n;j++)
       t1=max2(t1,calc(j));
     t+=t1;
     if(t<bt)
     {
       bt=t;bx=xx1[1];by=yy1[1];
     }
     n=old;
     for(j=1;j<=n;j++)
       x1[j]=oldx1[j],y11[j]=oldy1[j],x2[j]=oldx2[j],y2[j]=oldy2[j];
  }
  printf("%.0lf %.0lf\n%lf\n",bx,by,bt);
}
int main(void)
{
  freopen("f.in","r",stdin);
  //freopen("f.out","w",stdout);
  read();
  solve();
  return 0;
}

