{$I-,Q-,R-,S-}
Const
  InputFile = 'g.in';
  OutputFile ='g.out';

Type
  Pointer = Record
    A, B : longint;
  End;

Var
  N : Integer;
  O : Array [1..3000]Of Pointer;
  P : Array [1..3000]Of Boolean;
  Ans : Array [1..8000]Of Longint;
  K   : Longint;

  Procedure Add(V : Longint);
  Begin
    Inc(K); Ans[K] := V;
  End;

  Procedure Solve;
  Var
    I, J : Integer;
    L    : Longint;
  Begin
    K := 0;
    L := -100;
    For I := 1 To N Do
      If not P[I] Then
        Begin
          If (O[I].A > L) Then
            Begin
              L := O[I].B - 1;
              Add(L);
            End;
          For J := I To N Do If (O[J].A <= L)And(O[J].B >= O[I].B) Then P[J] := TRUE;
          L := O[I].B;
          Add(L);
        End;
  End;

  Procedure Swap(var A, B : Pointer);
  Var C : Pointer;
  Begin
    C := A;
    A := B;
    B := C;
  End;

  Procedure Sort(L, R : Integer);
  Var
    I, J        : Integer;
    V           : Longint;
  Begin
    I := L;
    J := R;
    V := O[(I + J)Div 2].B;
    Repeat
      While O[I].B < V Do Inc(I);
      While V < O[J].B Do Dec(J);
      If I <= J Then
        Begin
          Swap(O[I], O[J]);
          Inc(I);
          Dec(J);
        End;
    Until I > J;
    If I < R Then Sort(I, R);
    If L < J Then Sort(L, J);
  End;

  Procedure Init;
  Var I : Integer;
  Begin
    FillChar(P, SizeOf(P), False);
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);
    Read(N);
    For I := 1 to N Do Read(O[I].A,O[I].B);
    Close(Input);
    Sort(1,N);
  End;

  Procedure Done;
  Var
    I : longint;
  Begin
    Writeln(K);
    For I := 1 To K Do Write(Ans[I], ' ');
    Close(Output);
  End;

Begin
  Init;
    Solve;
  Done;
End.
