{$N+}
program TaskC;
const infile = 'convex.in';
      outfile = 'convex.out';
type t1 = record
  x, y:int64;
end;
var t:longint;

function sign(x:int64):int64;
begin
  sign:=ord(x>0)-ord(x<0);
end;

procedure inp;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(t);
end;

function mulv(x1, y1, x2, y2:int64):int64;
begin
  mulv:=sign(x1*y2-x2*y1);
end;

function solve:boolean;
var N, i, s, st:longint;
    p0, p1, p2, p3, pt:t1;
    f, b:boolean;
begin
  read(N);
  read(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y); p0:=p1;
  s:=mulv(p2.x-p1.x, p2.y-p1.y, p3.x-p2.x, p3.y-p2.y); b:=true;
  if s<>0 then f:=true else f:=false;
  for i:=1 to N-3 do
  begin
    p1:=p2; p2:=p3;
    read(p3.x, p3.y);
    st:=mulv(p2.x-p1.x, p2.y-p1.y, p3.x-p2.x, p3.y-p2.y);
    if (not f)and(st<>0) then begin f:=true; s:=st; continue; end;
    if st=0 then continue;
    if st=s then continue;
    b:=false;
  end;
  if not f then b:=false;
  if (p0.x<>p3.x)or(p0.y<>p3.y) then b:=false;
  solve:=b;
end;

procedure run;
var i:longint;
begin
  for i:=1 to t do
    if solve then writeln('YES') else writeln('NO');
end;

procedure outp;
begin
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
