#include <stdio.h>

#if 0
#define MSG(A) 			printf(#A"\n")
#define MSG1(A,A1)		printf(A,A1)
#define MSG2(A,A1,A2)		printf(A,A1,A2)
#define MSG3(A,A1,A2,A3)        printf(A,A1,A2,A3)
#else
#define MSG(A)
#define MSG1(A,A1)
#define MSG2(A,A1,A2)
#define MSG3(A,A1,A2,A3)
#endif


#define pr_d(X) printf("%d\n",X) 

struct point
{
	long x,y;
};

struct obl
{
	long begin,end;
	long len;
	char ON;
};

int L;
struct point p[30001];
struct obl o[30100];
int o_len = 0;
long W, H;
int max = 1;

#define KEY(X) X.x
typedef struct point sort_t;

void
build(sort_t *A, int i, int l)
{
	A--;
	int j = i << 1;
	sort_t x = A[i];
	for (;;)
	{
		if (j > l)	break;
		if (j < l)
			if (KEY(A[j+1]) > KEY(A[j])) j++;
		if ((KEY(x)) > KEY(A[j])) break;
		A[i] = A[j];
		i = j;
		j = i << 1;
	}
	A[i] = x;
}

void
sort(sort_t *A, int l)
{
	int i;
	for (i = l >> 1;i;i--)
		build(A,i,l);
	for (i = l-1;i;i--)
	{
		sort_t t = A[0];
		A[0] = A[i];
		A[i] = t; 
		build(A,1,i);
	}      
}

int
next(int i)
{	while (o[i].ON==0) i++; 
	if (o[i].ON == 3) return(-1);
	return(i);}

int
add(struct obl tmp)
{	int i = 0;
	while (o[i].ON) i++; o[i] = tmp; o[i].ON = 1;
	o_len++;
	return(i); 
}

void del(int i)
{	if (o[i].ON) o_len--;	o[i].ON = 0; }

void sqr(k)
{       int t;
	if ( (t = (o[k].end - o[k].begin)) > o[k].len) return;
	if (t > max) max = t;
	del(k);
}

int
main()
{
	{int n;	int i;
		FILE *f;
		f = fopen("square.in","r");
		L = 0;
		fscanf(f,"%d %ld %ld",&n, &W, &H);
		for (i = 0; i < n; i++)
		{
			fscanf(f,"%d %d", &p[L].x, &p[L].y);
			if (p[L].x > 0 && p[L].x < W)
				if (p[L].y > 0 && p[L].y < H) L++;
		}
		fclose(f);
	}
	sort(p,L);
	p[L].x = W;
	p[L].y = 0;
	L++;
	{int i;	for (i = 0;i < L+10;i++) o[i].ON = 0;
	 o[L + 5].ON = 3;
	}
	
	{	
		int i; 
		int t = 0;
	 	struct obl tmp;

		for (i = 0; i < L; i++)	
		{
			int k = -1;
			if (t != p[i].x)
			{       t = p[i].x - t;
				tmp.begin = 0;
				tmp.end = H;
				tmp.len = 0;
				add(tmp);
				MSG1("- %d\n", i);
				while ( (k = next(k+1)) != -1) 
				{
					o[k].len +=t;
					sqr(k);
					MSG3("  %d - %d %d\n", 
						o[k].begin,
						o[k].end,
						o[k].len);
				}
				t = p[i].x;
			}
			k = -1;
			while ( (k = next(k+1)) != -1)
			{
				struct obl tmp;
				int e = p[i].y;
				if (e > o[k].begin &&
				    e < o[k].end)
				{
					tmp = o[k];
					if (tmp.len > max) max = tmp.len;
					o[k].end = e;
					tmp.begin = e;
					sqr(add(tmp));
					sqr(k);
				}
			}	
		}
	}
	{
		FILE *f;
		f = fopen("square.out","w");
		fprintf(f,"%d\n",max);
		fclose(f);
	}
	return(0);
}
