#include <stdio.h>
#include <stdlib.h>

#define LL 20
#define SS 300
#define NN 1000

struct NUM {
  int v;
  int w;
};

FILE *fi, *fo;
NUM a[NN];
long long n,k;
int sk, sn;
int lk, ln;
int ans[SS];
int anss;
int arn[SS], ark[SS];
long long f1[LL][SS][LL];
long long f2[LL][SS];

int w(int n)
{
  int res;
  res=0;
  while(n>0)
  {
    res+=n%10;
    n/=10;
  }
  return res;
}

int cmp(NUM a, NUM b)
{
  int aa[10];
  int bb[10];
  int al,bl;
  if(a.w>b.w)
    return 1;
  if(a.w<b.w)
    return -1;
  al=0;
  while(a.v>0)
  {
    aa[al++]=a.v%10;
    a.v/=10;
  }
  bl=0;
  while(b.v>0)
  {
    bb[bl++]=b.v%10;
    b.v/=10;
  }
  while((al>0)&&(bl>0))
  {
    if(aa[al-1]>bb[bl-1])
      return 1;
    if(aa[al-1]<bb[bl-1])
      return -1;
    al--;
    bl--;
  }
  if((al==0)&&(bl==0))
    return 0;
  if(al>0)
    return 1;
  return -1;
}

void sort()
{
  int i,j;
  NUM x;
  for(i=0;i<n;i++)
  {
    for(j=i+1;j<n;j++)
    {
      if(cmp(a[i],a[j])>0)
      {
        x=a[i];
        a[i]=a[j];
        a[j]=x;
      }
    }
  }
}

void n2num(int *ar, long long n, int *l, int *s)
{
  int i;
  *l=0;
  *s=0;
  while(n>0)
  {
    ar[(*l)++]=n%10LL;
    n/=10LL;
    (*s)+=ar[(*l)-1];;
  }
  for(i=(*l);i<SS;i++)
    ar[i]=0;
}

int main()
{
  int i,j;
  int ii,jj;
  int sk1;
  bool flag;
  long long s;
  fi=fopen("grlex.in","rt");
  fo=fopen("grlex.out","wt");

  fscanf(fi,"%lld%lld",&n,&k);
  n2num(arn,n,&ln,&sn);
  n2num(ark,k,&lk,&sk);

  if(k==1LL)
  {
    fprintf(fo,"1\n1\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }

  if(n<=NN)
  {
    for(i=0;i<n;i++)
    {
      a[i].v=i+1;
      a[i].w=w(i+1);
    }
    sort();
    for(i=0;i<n;i++)
      if(a[i].v==k)
        fprintf(fo,"%d\n",i+1);
    fprintf(fo,"%d\n",a[k-1].v);

    fclose(fi);
    fclose(fo);
    return 0;
  }

  for(i=1;i<SS;i++)
    f2[0][i]=0;
  f2[0][0]=1;
  for(i=1;i<=ln;i++)
  {
    for(j=0;j<SS;j++)
    {
      f2[i][j]=0;
      for(ii=0;ii<9;ii++)
        if(ii<=j)
          f2[i][j]+=f2[i-1][j-ii];
    }
  }

  for(i=1;i<SS;i++)
    for(j=0;j<ln;j++)
      f1[0][i][j]=0;
  for(j=0;j<ln;j++)
    f1[0][0][j]=1;
  for(i=1;i<=ln;i++)
  {
    for(j=0;j<SS;j++)
    {
      f1[i][j][0]=0;
      for(ii=1;ii<=ln;ii++)
      {
        f1[i][j][ii]=0;
        for(jj=1;jj<arn[ii-1];jj++)
          if(jj<=j)
            f1[i][j][ii]+=f2[i-1][j-jj];
        if((arn[ii-1]<=j)/*&&(arn[ii-1]>0)*/)
          f1[i][j][ii]+=f1[i-1][j-arn[ii-1]][ii-1];
      }
    }
  }

  s=0LL;
  for(i=1;i<sk;i++)
  {
    for(j=1;j<ln;j++)
      s+=f2[j][i];
    s+=f1[ln][i][ln];
  }
/*  for(j=1;j<lk;j++)
    s+=f1[j][sk][ln];*/
  sk1=sk;
  flag=true;
  if(lk<ln)
    flag=false;
  for(i=lk-1;i>=0;i--)
  {
    if(flag)
      if(ark[i]<arn[i])
        flag=false;
    if(flag) {
      if(i<lk-1) {
        for(j=0;j<ark[i];j++)
          for(ii=0;ii<=ln-lk+i;ii++)
            s+=f2[ii][sk1-j];
        for(ii=0;ii<i;ii++)
          s+=f2[ii][sk1-ark[i]];
      } else {
        for(j=1;j<ark[i];j++)
          for(ii=0;ii<=ln-lk+i;ii++)
            s+=f2[ii][sk1-j];
        for(ii=0;ii<i;ii++)
          s+=f2[ii][sk1-ark[i]];
/*      if(i<lk-1)
        for(j=0;j<ark[i];j++)
          s+=f1[i][sk1-j][i];
      else
        for(j=1;j<ark[i];j++)
          s+=f1[i][sk1-j][i];*/
      }
    } else {
      if(i<lk-1) {
        for(j=0;j<ark[i];j++)
          for(ii=0;ii<=ln-lk+i;ii++)
            s+=f2[ii][sk1-j];
        for(ii=0;ii<i;ii++)
          s+=f2[ii][sk1-ark[i]];
      } else {
        for(j=1;j<ark[i];j++)
          for(ii=0;ii<=ln-lk+i;ii++)
            s+=f2[ii][sk1-j];
        for(ii=0;ii<i;ii++)
          s+=f2[ii][sk1-ark[i]];
      }
    }
    sk1-=ark[i];
  }
  s++;
  fprintf(fo,"%lld\n",s);
  flag=true;
  s=0;
  for(i=1;i<SS;i++)
  {
    for(j=ln-1;j<ln;j++)
    {
      if(k-s<=f2[j][i])
      {
        anss=i;
        j=ln+1;
        i=SS;
      }
      else
       s+=f2[j][i];
    }
    if(k-s<=f1[ln][i][ln])
    {
      anss=i;
      i=SS+1;
    }
    else
      s+=f1[ln][i][ln];
  }
  for(i=0;;i++)
  {
    ans[i]=-1;
    if(flag) {
      if(i==0) {
        for(j=1;j<arn[ln-i-1];j++)
        {
          if(k-s<=f2[ln-i-1][anss-j])
          {
            ans[i]=j;
            flag=false;
            break;
          }
          else
            s+=f2[ln-i-1][anss-j];
        }
        if(ans[i]<0)
        {
          for(j=1;j<ln-i-1;j++)
          {
            if(k-s<=f2[j][anss-arn[ln-i-1]])
            {
              ans[i]=arn[ln-i-1];
              break;
            }
            else
              s+=f2[j][anss-arn[ln-i-1]];
          }
          if(ans[i]<0)
          {
            if(k-s<=f1[ln-i-1][anss-arn[ln-i-1]][ln-i-1])
              ans[i]=arn[ln-i-1];
            else
              s+=f1[ln-i-1][anss-arn[ln-i-1]][ln-i-1];
          }
        }
      } else {
        for(j=0;j<arn[ln-i-1];j++)
        {
          if(k-s<=f2[ln-i-1][anss-j])
          {
            ans[i]=j;
            flag=false;
            break;
          }
          else
            s+=f2[ln-i-1][anss-j];
        }
        if(ans[i]<0)
        {
          for(j=1;j<ln-i-1;j++)
          {
            if(k-s<=f2[j][anss-arn[ln-i-1]])
            {
              ans[i]=arn[ln-i-1];
              break;
            }
            else
              s+=f2[j][anss-arn[ln-i-1]];
          }
          if(ans[i]<0)
          {
            if(k-s<=f1[ln-i-1][anss-arn[ln-i-1]][ln-i-1])
              ans[i]=arn[ln-i-1];
            else
              s+=f1[ln-i-1][anss-arn[ln-i-1]][ln-i-1];
          }
        }
      }
    } else {
      if(i==0) {
        for(j=1;j<9;j++)
        {
          if(k-s<=f2[ln-i-1][anss-j])
          {
            ans[i]=j;
            break;
          }
          else
            s+=f2[ln-i-1][anss-j];
        }
      } else {
        for(j=0;j<9;j++)
        {
          if(k-s<=f2[ln-i-1][anss-j])
          {
            ans[i]=j;
            break;
          }
          else
            s+=f2[ln-i-1][anss-j];
        }
      }
    }
//    break;
    anss-=ans[i];
    if(k-s<1)
      break;
    if(ans[i]<0)
    {
      i--;
      break;
    }
  }
  for(j=0;j<=i;j++)
    fprintf(fo,"%d",ans[j]);
  fprintf(fo,"\n");

  fclose(fi);
  fclose(fo);
  return 0;
}
