  {$I-,Q-,R-,S-}
const infile = 'convex.in'; outfile = 'convex.out'; max = 1000005;
type int = int64;
type pt = record x,y: int; end;
     line = record a,b,c: int; end;
var cv: array [1..max] of pt;
    st,t,i,j,n,fx,fy: longint;
    first: line;

function eq(t1,t2: pt): boolean;
begin
     eq:=(t1.x = t2.x)and(t1.y = t2.y);
end;

function check_lines: boolean;
var w: longint;
begin
     first.a:=cv[2].y-cv[1].y;
     first.b:=cv[1].x-cv[2].x;
     first.c:=-(cv[1].x*first.a+cv[1].y*first.b);
     check_lines:=true;
     for w:=3 to n do
         if first.a*cv[w].x+first.b*cv[w].y+first.c <> 0 then exit;
     check_lines:=false;
end;

function s(p1,p2,p3: pt): int;
begin
     s:=p1.x*p2.y-p2.x*p1.y+p2.x*p3.y-p3.x*p2.y+p3.x*p1.y-p1.x*p3.y;
end;

function check_convex: boolean;
var j1,j2,j3,d: longint;
begin
     j1:=st; j2:=j1 mod n+1; j3:=j2 mod n+1; d:=0;
     check_convex:=false;
     repeat
           if s(cv[j1],cv[j2],cv[j3]) > 0 then begin
              if d < 0 then exit;
              if d = 0 then d:=1;
           end;
           if s(cv[j1],cv[j2],cv[j3]) < 0 then begin
              if d > 0 then exit;
              if d = 0 then d:=-1;
           end;
           j1:=j2; j2:=j3;
           j3:=j3 mod n+1;
     until j1 = st;
     check_convex:=true;
end;

function check_square: boolean;
var j1,j2: longint;
    sq1,sq2: int;
begin
     sq1:=0;
     for j1:=1 to n do begin
         j2:=j1 mod n+1;
         sq1:=sq1+abs(s(cv[j1],cv[j2],cv[st]));
     end;
     sq2:=0;
     for j1:=1 to n do begin
         sq2:=sq2+cv[j1].x*cv[j1 mod n+1].y-cv[j1 mod n+1].x*cv[j1].y;
     end;
     sq2:=abs(sq2);
     if sq1 = sq2 then check_square:=true
        else check_square:=false;
end;

var ok: boolean;
begin
     assign(input,infile);
     assign(output,outfile);
     rewrite(output);
     reset(input);
     read(t);
     fillchar(cv,SizeOf(cv),0);
     for i:=1 to t do begin
         read(n); st:=0; ok:=true;
         for j:=1 to n do begin
             read(fx,fy); cv[j].x:=fx; cv[j].y:=fy;
             if (st = 0)or(cv[j].y < cv[st].y)or((cv[j].y = cv[st].y)and(cv[j].x > cv[st].x)) then st:=j;
             if (st <> j)and(not ((st = 1)and(j = n)))and eq(cv[j],cv[st]) then begin ok:=false; end;
         end;
         if (not ok)or(not eq(cv[1],cv[n]))or(not check_lines)or(not check_convex)or
            (not check_square) then writeln('NO')
                 else writeln('YES');
     end;
     close(input);
     close(output);
end.
