{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const MaxL = 19;
      MaxW = 162;

Type TDecomposite = array[1..MaxL] of Byte;

Var I, J, W: Integer;
    N, K, P, NumK, PosK, Cur, Prev, PPrev: Int64;
    Ln, Lk, St: Byte;
    Cn, Ck: TDecomposite;
    A, B: array[1..MaxL, 0..MaxW] of Int64;
    X: array[1..MaxW] of Int64;

Procedure GenL(N: Int64; var L: Byte; var C: TDecomposite);
Var I: Integer;
    X: Byte;
Begin
  While N > 0 do Begin
    Inc(L);
    C[L] := N mod 10;
    N := N div 10;
  End;
  For I := 1 to L shr 1 do Begin
    X := C[I];
    C[I] := C[L - I + 1];
    C[L - I + 1] := X;
  End;
End;

Function Weight(A: Int64): Byte;
Var Res: Byte;
Begin
  Res := 0;
  While A > 0 do Begin
    Inc(Res, A mod 10);
    A := A div 10;
  End;
  Weight := Res;
End;

Procedure GenA;
Var I, J, K, S: Integer;
Begin
  For I := 1 to 9 do
    A[1, I] := 1;
  For I := 1 to Cn[1] do
    B[1, I] := 1;
  S := Cn[1];
  For I := 2 to Ln do Begin
    For J := 0 to 9 do
      For K := 1 to MaxW - J do
        Inc(A[I, K + J], A[I - 1, K]);
    For J := 0 to 9 do
      For K := 1 to S - 1 do
        Inc(B[I, K + J], B[I - 1, K]);
    For J := 0 to Cn[I] do
      Inc(B[I, S + J]);
    S := S + Cn[I];
  End;
  A[Ln] := B[Ln];
  B := A;
End;

Procedure GenX;
Begin
  For I := 1 to Ln do
    For J := 1 to MaxW do
      Inc(X[J], A[I, J]);
End;

Procedure ReGenA;
Var I, J, K, S: Integer;
Begin
  FillChar(A, SizeOf(A), 0);
  For I := 1 to Ck[1] - 1 do
    A[1, I] := 1;
  S := Ck[1];
  For I := 2 to Ln do Begin
    For J := 0 to 9 do
      For K := 1 to MaxW - J do
        Inc(A[I, K + J], A[I - 1, K]);
    For J := 0 to Ck[I] - 1 do
      Inc(A[I, S + J]);
    S := S + Ck[I];
  End;
  S := 0;
  For I := 1 to Lk do Begin
    Inc(S, Ck[I]);
    Inc(A[I, S]);
  End;
  For I := 0 to MaxW do
    If A[Ln, I] > B[Ln, I] Then A[Ln, I] := B[Ln, I];
End;

Begin
  Assign(Input, 'grlex.in');
  Assign(Output, 'grlex.out');
  Reset(Input);
  Rewrite(Output);
  Read(N, K);
  GenL(N, Ln, Cn);
  GenA;
  GenX;
  W := Weight(K);
  For I := 1 to W - 1 do Inc(NumK, X[I]);
  GenL(K, Lk, Ck);
  ReGenA;
  For I := 1 to Ln do Inc(NumK, A[I, W]);
  Writeln(NumK);
  W := 1;
  While PosK + X[W] < K do Begin
    Inc(PosK, X[W]);
    Inc(W);
  End;
  St := 1;
  Repeat
    For J := St to 9 do Begin
      Cur := 0;
      Lk := 1;
      Ck[1] := J;
      St := J;
      P := PPrev * 10 + J;
      While W - St > 0 do Begin
        Inc(Lk);
        If W - St > 9
        Then Begin
          Ck[Lk] := 9;
          Inc(St, 9);
        End
        Else Begin
          Ck[Lk] := W - St;
          St := W;
        End;
        P := P * 10 + Ck[Lk];
      End;
      If P > N Then Continue;
      ReGenA;
      For I := 1 to Ln do Inc(Cur, A[I, W]);
      If PosK + Cur >= K Then Begin
        Write(J);
        Break;
      End;
      Prev := Cur;
    End;
    PPrev := PPrev * 10 + J;
    Dec(W, J);
    Dec(Ln);
    Inc(PosK, Prev);
    St := 0;
  Until W = 0;
  Close(Input);
  Close(Output);
End.