{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const Half = 1000000000;

Type TPoint = Record
                X, Y: Longint;
              End;

Var I, J, K, N, X1, Y1, X2, Y2: Longint;
    A, B, C, F: TPoint;
    M: String[3];
    W, P, S: Shortint;

Function VectMul(X1, Y1, X2, Y2: Int64): Shortint;
Var K: Int64;
Begin
  K := X1 * Y2 - X2 * Y1;
  If K > 0
  Then
    VectMul := 1
  Else
    If K < 0 Then VectMul := - 1
             Else VectMul := 0;
End;

Function SameDest(X1, Y1, X2, Y2: Int64): Boolean;
Begin
  SameDest := X1 * X2 + Y1 * Y2 > 0;
End;

Procedure Quit;
Begin
  Close(Input);
  Close(Output);
  Halt;
End;

Begin
  Assign(Input, 'convex.in');
  Assign(Output, 'convex.out');
  Reset(Input);
  Rewrite(Output);
  Read(K);
  For I := 1 to K do Begin
    Read(N);
    Read(B.X, B.Y);
    Read(C.X, C.Y);
    F := B;
    J := 2;
    Repeat
      Inc(J);
      A := B;
      B := C;
      Read(C.X, C.Y);
      X1 := B.X - A.X;
      Y1 := B.Y - A.Y;
      X2 := C.X - B.X;
      Y2 := C.Y - B.Y;
      W := VectMul(X1, Y1, X2, Y2);
      If (W = 0) and not (SameDest(X1, Y1, X2, Y2)) Then Break;
    Until (W <> 0) or (J = N);
    If W = 0 Then Begin
      Writeln('NO');
      Continue;
    End;
    M := 'YES';
    For J := J + 1 to N do Begin
      A := B;
      B := C;
      Read(C.X, C.Y);
      P := VectMul(B.X - A.X, B.Y - A.Y, C.X - B.X, C.Y - B.Y);
      S := VectMul(B.X - F.X, B.Y - F.Y, C.X - F.X, C.Y - F.Y);
      If ((P <> W) and (P <> 0)) or
         ((J < N) and (S <> W) and (S <> 0))
      Then Begin
        M := 'NO';
        Break;
      End;
    End;
    If (C.X <> F.X) or (C.Y <> F.Y) Then M := 'NO';
    Writeln(M);
  End;
  Close(Input);
  Close(Output);
End.