{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
Uses SysUtils;
const
  inpfile='square.in';
  outfile='square.out';
  sec=24.0*60.0*60.0;
  tl=2.9;
  nm=30005;
type
  Coord = record
    x,y : LongInt;
  end;
var
  a : array [1..nm] of Coord;
  n,m,k,ans : LongInt;
  start : Extended;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(k,n,m);
  for i:=1 to k do
    read(a[i].x,a[i].y);
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(ans);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
end;
{}
Procedure Swap(var q,w : Coord);
var
  bak : Coord;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l, r: LongInt);
var
  i, j, x : LongInt;
begin
  i := l; j := r; x := a[(l+r) DIV 2].x;
  repeat
    while a[i].x < x do inc(i);
    while x < a[j].x do dec(j);
    if i <= j then
    begin
      Swap(a[i],a[j]);
      inc(i); dec(j);
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;
{}
Function Min(q,w : LongInt) : LongInt;
begin
  if q<w then min:=q else min:=w;
end;
{}
Function Max(q,w : LongInt) : LongInt;
begin
  if q>w then max:=q else max:=w;
end;
{}
Procedure Rec(x1,y1,x2,y2 : LongInt);
var
  l,r,m,bak : LongInt;
  ok : Boolean;
begin
  bak:=min(x2-x1,y2-y1);
  if bak<=ans then exit;

  l:=1; r:=k;
  repeat
    m:=(l+r) div 2;
    if a[m].x<=x1 then l:=m+1
                  else r:=m;
  until l>=r;

  ok:=true;
  while a[l].x<x2 do begin
    if (a[l].y>y1) and (a[l].y<y2) then begin
      ok:=false;
      Rec(x1,y1,a[l].x,y2);
      Rec(a[l].x,y1,x2,y2);
      Rec(x1,y1,x2,a[l].y);
      Rec(x1,a[l].y,x2,y2);
    end;
    inc(l);
  end;

  if ok then begin
    ans:=max(ans,bak);
    if (now-start)*sec>=tl then Out;
  end;

end;
{}
Procedure Solve;
begin
  Sort(1,k); ans:=1;

  a[n+1].x:=MaxLongInt div 2;
  a[n+1].y:=MaxLongInt div 2;

  Rec(0,0,n,m);
end;
{}
Begin
  start:=now;
  Init;
  Inp;
  Solve;
  Out;
End.