{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

{Alexey Timofeev }

const
	FILEIN='convex.in';
  FILEOUT='convex.out';
	NMAX=1000000;
	eps=1E-5;
type
  mt=longint;
  longint=extended;
	point=record
  	x,y:longint;
  end;
var
	a:array[1..NMAX] of point;
  i,j,n,t:mt;
procedure initdata;
begin

end;

procedure outdata(ot:boolean);
begin
	if ot then writeln('YES') else writeln('NO');
end;

function vect(x1,y1,x2,y2,x,y:longint):longint;
begin
  vect:=(x1-x)*(y2-y)-(x2-x)*(y1-y);
end;

function scal(x1,y1,x2,y2,x,y:longint):longint;
begin
  scal:=(x1-x)*(x2-x)+(y1-y)*(y2-y);
end;


function good(a,b:extended):boolean;
var
	ot:boolean;
begin
  ot:=false;
	if (a>-eps) and (b>-eps) then ot:=true;
  if (a<eps) and (b<eps) then ot:=true;
	good:=ot;
end;

function ugl(x1,y1,x2,y2,x3,y3:longint):extended;
var
	ot,leng:extended;
	sn,cs:longint;
begin
  sn:=vect(x1,y1,x3,y3,x2,y2);
  cs:=scal(x1,y1,x3,y3,x2,y2);
  if abs(cs)>eps then ot:=arctan(sn/cs) else ot:=pi/2;
  if sn<0 then ot:=-ot;
  if ot<-eps then ot:=ot+pi;
  if abs(ot)<eps  then if cs>0 then ot:=0 else ot:=pi;
  ugl:=ot;
end;

procedure solve;
var
	ug,realug:extended;
  i:mt;
	onepr:boolean;
begin
  onepr:=true;
  realug:=(n-2)*pi;
  ug:=0;
  for i:=2 to n-2 do
  begin
    if good(vect(a[i-1].x,a[i-1].y,a[i+1].x,a[i+1].y,a[i].x,a[i].y),
						vect(a[i].x,a[i].y,a[i+2].x,a[i+2].y,a[i+1].x,a[i+1].y)) then
    begin
      ug:=ug+ugl(a[i-1].x,a[i-1].y,a[i].x,a[i].y,a[i+1].x,a[i+1].y);
      if (ug-realug)>eps then
      begin
      	outdata(false);
        exit;
      end;
      if abs(vect(a[i-1].x,a[i-1].y,a[i+1].x,a[i+1].y,a[i].x,a[i].y))>eps then onepr:=false;
		end else
    begin
    	outdata(false);
      exit;
    end;
  end;

  if good(vect(a[n-2].x,a[n-2].y,a[n].x,a[n].y,a[n-1].x,a[n-1].y),
					vect(a[n-1].x,a[n-1].y,a[1].x,a[1].y,a[n].x,a[n].y)) then
  begin
    ug:=ug+ugl(a[n-2].x,a[n-2].y,a[n-1].x,a[n-1].y,a[n].x,a[n].y);
    if (ug-realug)>eps then
    begin
    	outdata(false);
      exit;
    end;
  	if abs(vect(a[n-2].x,a[n-2].y,a[n].x,a[n].y,a[n-1].x,a[n-1].y))>eps then onepr:=false;
	end else
  begin
   	outdata(false);
    exit;
  end;

  if good(vect(a[n-1].x,a[n-1].y,a[1].x,a[1].y,a[n].x,a[n].y),
					vect(a[n].x,a[n].y,a[2].x,a[2].y,a[1].x,a[1].y)) then
  begin
    ug:=ug+ugl(a[n-1].x,a[n-1].y,a[n].x,a[n].y,a[1].x,a[1].y);
    if (ug-realug)>eps then
    begin
    	outdata(false);
      exit;
    end;
  	if abs(vect(a[n-1].x,a[n-1].y,a[1].x,a[1].y,a[n].x,a[n].y))>eps then onepr:=false;
	end else
  begin
   	outdata(false);
    exit;
  end;

  if good(vect(a[n].x,a[n].y,a[2].x,a[2].y,a[1].x,a[1].y),
					vect(a[1].x,a[1].y,a[3].x,a[3].y,a[2].x,a[2].y)) then
  begin
    ug:=ug+ugl(a[n].x,a[n].y,a[1].x,a[1].y,a[2].x,a[2].y);
    if (ug-realug)>eps then
    begin
    	outdata(false);
      exit;
    end;
  	if abs(vect(a[n].x,a[n].y,a[2].x,a[2].y,a[1].x,a[1].y))>eps then onepr:=false;
	end else
  begin
   	outdata(false);
    exit;
  end;

  if onepr or (abs(ug-realug)>eps) then
  begin
  	outdata(false);
    exit;
  end;

	outdata(true);
end;

procedure readdata;
begin
	assign(input,FILEIN);reset(input);
  assign(output,FILEOUT);rewrite(output);

  read(t);
  for i:=1 to t do
  begin
  	read(n);
    for j:=1 to n do read(a[j].x,a[j].y);
    dec(n);
    if (a[n+1].x=a[1].x) and (a[n+1].y=a[1].y) then solve
    else outdata(false);
  end;

end;

begin
	initdata;
  readdata;
	close(output);
end.
