{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T+,V+,X+,Y+}
Program Problem;
Const
     InFile = 'square.in';
     OutFile = 'square.out';
     NMax = 30000;
Type
    TPoint = Record
     X,Y : LongInt;
    End;
    TArray = Array [0..NMax] Of TPoint;
Var
   N,NN,W,H : LongInt;
   P : TArray;
   FX,FY : Array [0..NMax] Of LongInt;
   L : LongInt;

 Procedure ReadData;
  Var
     I : LongInt;
   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (N,W,H);
     For I:= 1 To N Do Read (P[i].X,P[I].Y);
     Close (Input);
   End;

 Function Min (A,B : LongInt) : LongInt;
  Begin
    If A < B Then Min:= A Else Min:= B;
  End;

 Function Max (A,B : LongInt) : LongInt;
  Begin
    If A > B Then Max:= A Else Max:= B;
  End;

 Function InP (X,Y : LongInt) : Boolean;
  Var
     I : LongInt;
   Begin
     InP:= True;
     For I:= 1 To N Do
       If (P[I].X = X) And (P[I].Y = Y) Then Exit;
     InP:= False;
   End;

 Procedure Solve;
  Var
     I,J,K,CurL : LongInt;
     P0,PX,PY : TPoint;
     FX,FY : Boolean;
   Begin
     NN:= N;
     If Not InP (0,0) Then Begin
      Inc (NN);
      P[NN].X:= 0; P[NN].Y:= 0;
     End;
     If Not InP (W,H) Then Begin
      Inc (NN);
      P[NN].X:= W; P[NN].Y:= H;
     End;

     L:= -1;

     For I:= 1 To NN - 1 Do
       For J:= I + 1 To NN Do Begin

         P0.X:= Min (P[I].X,P[J].X); P0.Y:= Min (P[I].Y,P[J].Y);

         FX:= False;
         For K:= 1 To NN Do
           If (P[K].X > P0.X) And (P[K].Y > P0.Y) Then
            If Not FX Then Begin
             FX:= True;
             PX:= P[K];
            End
            Else
             If P[K].X < PX.X Then PX:= P[K];

         FY:= False;
         For K:= 1 To NN Do
           If (P[K].X > P0.X) And (P[K].Y > P0.Y) Then
            If Not FY Then Begin
             FY:= True;
             PY:= P[K];
            End
            Else
             If P[K].Y < PY.Y Then PY:= P[K];

         If FX And FY Then Begin
          CurL:= Min (Max(PX.X - P0.X,PX.Y - P0.Y),
                      Max(PY.X - P0.X,PY.Y - P0.Y));
          If (P0.X + CurL > W) Or (P0.Y + CurL > H)
           Then CurL:= Min (W - P0.X,H - P0.Y);

          If CurL > L Then L:= CurL;
         End;

       End;
   End;

 Procedure WriteData;
  Var
     I : LongInt;
  Begin
    Assign (Output,OutFile); ReWrite (Output);
    Write (L);
    Close (Output);
  End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.







