const
  MaxN = 30005;

type
  Tpoint = record
    x,y: longint;
  end;

var
  fi, fo: text;
  n: longint;
  h,w: longint;
  a: array[1..MaxN] of Tpoint;
  xx,yy: array[1..MaxN] of longint;
  res: longint;

function min(a,b: longint):longint;
begin
  if a<b then min:=a else min:=b;
end;

procedure sortx(l,r: longint);
var
  i,j,x,y: longint;
begin
  i:=l;
  j:=r;
  x:=a[xx[(l+r) div 2]].x;
  repeat
    while a[xx[i]].x<x do inc(i);
    while x<a[xx[j]].x do dec(j);
    if not(i>j) then begin
      y:=xx[i];
      xx[i]:=xx[j];
      xx[j]:=y;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then sortx(l,j);
  if i<r then sortx(i,r);
end;

procedure sorty(l,r: longint);
var
  i,j,x,y: longint;
begin
  i:=l;
  j:=r;
  x:=a[yy[(l+r) div 2]].y;
  repeat
    while a[yy[i]].y<x do inc(i);
    while x<a[yy[j]].y do dec(j);
    if not(i>j) then begin
      y:=yy[i];
      yy[i]:=yy[j];
      yy[j]:=y;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then sorty(l,j);
  if i<r then sorty(i,r);
end;

type
  TLongArr = array[0..MaxN] of longint;

var
  need: array[1..MaxN] of longint;
  _true: longint;
  {lev: longint;}

procedure Rec(x1,y1,x2,y2,n: longint;var xx,yy: array of longint);
var
  i,j,t,nx,ny: longint;
  px,py: ^TLongArr;


begin
  if min(x2-x1,y2-y1)<=res then exit;
  {inc(lev);
  For i:=1 to lev do write('  ');
  writeLn('call ',n,'-(',x1,',',y1,'),(',x2,',',y2,')');}
  if n=0 then begin
    res:=min(x2-x1,y2-y1);
    {For i:=1 to lev do write('  ');
    WriteLn('--ref ',res,'-(',x1,',',y1,'),(',x2,',',y2,')');
    dec(lev);}
    exit;
  end;
  GetMem(px,sizeof(longint)*(n div 2));
  GetMem(py,sizeof(longint)*(n div 2));
  j:=n div 2;

{div by x}
  t:=a[xx[j]].x;
 {x part 1}
  inc(_true);
  nx:=0;
  For i:=0 to j-1 do if a[xx[i]].x<t then begin
    px^[nx]:=xx[i];
    inc(nx);
    need[xx[i]]:=_true;
  end;
  ny:=0;
  For i:=0 to n-1 do if need[yy[i]]=_true then begin
    py^[ny]:=yy[i];
    inc(ny);
  end;
  Rec(x1,y1,t,y2,nx,px^,py^);
 {x part 2}
  inc(_true);
  nx:=0;
  For i:=j+1 to n-1 do if a[xx[i]].x>t then begin
    px^[nx]:=xx[i];
    inc(nx);
    need[xx[i]]:=_true;
  end;
  ny:=0;
  For i:=0 to n-1 do if need[yy[i]]=_true then begin
    py^[ny]:=yy[i];
    inc(ny);
  end;
  Rec(t,y1,x2,y2,nx,px^,py^);

{div by y}
  for i:=0 to n-1 do
    if yy[i]=xx[j] then begin
      j:=i;
      break;
    end;
  t:=a[yy[j]].y;
 {y part 1}
  inc(_true);
  ny:=0;
  For i:=0 to j-1 do if a[yy[i]].y<t then begin
    py^[ny]:=yy[i];
    inc(ny);
    need[yy[i]]:=_true;
  end;
  nx:=0;
  For i:=0 to n-1 do if need[xx[i]]=_true then begin
    px^[nx]:=xx[i];
    inc(nx);
  end;
  Rec(x1,y1,x2,t,ny,px^,py^);
 {y part 2}
  inc(_true);
  ny:=0;
  For i:=j+1 to n-1 do if a[yy[i]].y>t then begin
    py^[ny]:=yy[i];
    inc(ny);
    need[yy[i]]:=_true;
  end;
  nx:=0;
  For i:=0 to n-1 do if need[xx[i]]=_true then begin
    py^[nx]:=xx[i];
    inc(nx);
  end;
  Rec(x1,t,x2,y2,ny,px^,py^);

  {FreeMem(px,sizeof(longint)*(n div 2));
  FreeMem(py,sizeof(longint)*(n div 2));}
  dispose(px); dispose(py);
  {dec(lev);}
end;

procedure Solve;
begin
  {WriteLn;}
  if n=0 then begin
    res:=min(h,w);
    exit;
  end;
  sortx(1,n); sorty(1,n);
  res:=1;
  Rec(0,0,w,h,n,xx,yy);
end;

procedure Init;
var i,k,x,y: longint;
begin
  Assign(fi,'square.in');
  Assign(fo,'square.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,k,w,h);
  For i:=1 to k do begin
    Read(fi,x,y);
    if ((x<>0) and (x<>w)) and ((y<>0) and (y<>h)) then begin
      inc(n);
      a[n].x:=x; a[n].y:=y;
      xx[n]:=n; yy[n]:=n;
    end;
  end;
end;

procedure Done;
begin
  writeLn(fo,res);
  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
