{$I-}{$R-}{$N+}
var
  f,f1 :text;

const name = 'convex';

type TPoint = record x,y :longint; end;

var
  mas,mas1 :array[1..1000000] of TPoint;
  n,i,j :longint;

procedure rot (i,j :longint);
var p :TPoint;
begin
  p := mas[i]; mas[i] := mas[j]; mas[j] := p;
end;

function cmp (bas,i,j :longint) :longint;
var e :extended; x1,x2,y1,y2 :longint;
begin
  x1 := mas[i].x-mas[bas].x;
  x2 := mas[j].x-mas[bas].x;
  y1 := mas[i].y-mas[bas].y;
  y2 := mas[j].y-mas[bas].y;
  e := x1*y2-x2*y1;
  if e>0 then cmp:=1 else
    if e=0 then cmp:=0 else
      cmp:=-1;
end;

function sqrlen (i,j :longint) :extended;
begin
  sqrlen := sqr(mas[i].x-mas[j].x)+sqr(mas[i].y-mas[j].y);
end;

function Luchshe (i,j :longint):boolean;
begin
  Luchshe := (cmp(1,i,j)=1) or
             ((cmp(1,i,j)=0) and (sqrlen(1,i)<sqrlen(1,j)))
end;

function Eq (i,j :longint):boolean;
begin
  Eq := (mas[i].x=mas[j].x) and (mas[i].y=mas[j].y);
end;

function Sort :boolean;
var i :integer;
begin
  if not Luchshe (2,3) then
    for i := 1 to (n div 2) do
      rot (i+1,n-i+1);
  {chek}
  Sort := true;
  for i := 2 to n-1 do
    if not Luchshe (i,i+1) then exit;
  Sort := false;
end;

procedure Chek;
label _bad;
begin
  read (f,n);
  for i := 1 to n do
    read (f,mas[i].x,mas[i].y);
  dec(n);
    {begin}
    if (mas[1].x<>mas[n+1].x) or (mas[1].y<>mas[n+1].y) then goto _bad;
    {Find t.O}
    j := 1;
    for i := 2 to n do
      begin
        if mas[i].y<mas[j].y then j := i;
        if (mas[i].y=mas[j].y) and (mas[i].x>mas[j].x) then j := i;
      end;
    for i := 1 to j-1 do
        mas1[i] := mas[i-j+1+n];
    for i := j to n do
        mas1[i] := mas[i-j+1];
    mas := mas1;
    if Sort then goto _bad;
    if cmp(1,2,n)=0 then goto _bad;
    for i := 3 to n do
      if cmp (i-2,i-1,i) < 0 then goto _bad;
    if cmp (n-1,n,1) < 0 then goto _bad;
    if cmp (n,1,2) < 0 then goto _bad;
    {end}
  writeln (f1,'YES');
  exit;
_bad:
  writeln (f1,'NO');
end;

var _k,_kol :longint;

begin
  assign (f,name+'.in');
  assign (f1,name+'.out');
  reset (f);
  rewrite (f1);
    read (f,_kol);
    for _k := 1 to _kol do
      Chek;
  close (f);
  close (f1);
end.
