{$I-,Q-,R-,S-}

const

  maxn=30000;
  maxs=1000000;

var
  w,h:longint;
  i,n,j:longint;
  x,y:array[1..maxn+2] of longint;
  minl:longint;

procedure out(ans:longint);
begin
  write(ans);
  close(input);
  close(output);
  halt(0);
end;

procedure swap(i,j:longint);
var
  temp:longint;
begin
  temp:=x[i];
  x[i]:=x[j];
  x[j]:=temp;
  temp:=y[i];
  y[i]:=y[j];
  y[j]:=temp;
end;

function min(a,b:longint):longint;
begin
  if a>b then
    min:=b
  else
    min:=a;
end;

function max(a,b:longint):longint;
begin
  if a<b then
    max:=b
  else
    max:=a;
end;

procedure check(a,b:longint);
var
  blen:longint;
  i:longint;

begin
  blen:=min(w-x[a],h-y[b]);
  if blen<=minl then
    exit;
  for i:=a+1 to n do begin
    if (x[i]-x[a]>=blen) then
      break;
    if (x[i]>x[a]) and (x[i]<x[a]+blen) and (y[i]>y[b]) and (y[i]<y[b]+blen) then begin
      blen:=max(x[i]-x[a],y[i]-y[b]);
      if blen<=minl then
        exit;
    end;
  end;
  minl:=blen;
end;

procedure qsort(l,r:longint);
var
  i,j,x1,y1:longint;
begin
  i:=l;
  j:=r;
  x1:=x[(l+r) div 2];
  y1:=y[(l+r) div 2];
  repeat
    while (x[i]<x1) or ((x[i]=x1) and (y[i]<y1)) do
      inc(i);
    while (x1<x[j]) or ((x1=x[j]) and (y1<y[j])) do
      dec(j);
    if i<=j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;

begin
  assign(input,'square.in');
  reset(input);
  assign(output,'square.out');
  rewrite(output);
  read(n,w,h);
  i:=0;
  while i<n do begin
    inc(i);
    read(x[i],y[i]);
    if (x[i]=0) or (x[i]=w) or (y[i]=0) or (y[i]=h) then begin
      dec(i);
      dec(n);
    end;
  end;
  inc(n);
  x[n]:=0;
  y[n]:=0;
  inc(n);
  x[n]:=w;
  y[n]:=0;
  qsort(1,n);


  minl:=1;
  for i:=1 to n-1 do begin
    if (w-x[i])<=minl then
      out(minl);
    for j:=i+1 to n do begin
      if (x[j]>x[i]) and ((y[j]<y[i]) or (y[i]=0)) and (h-y[j]>minl) then begin
        check(i,j);
      end;
    end;
  end;
  out(minl);
end.
