{$I-,Q-,R-,S-}
const eps=1e-8;
var q,w,n,i,min,t,slen,cur,p1:longint;
    x,y,num,stack:array [1..1000] of longint;
    ok:boolean;
function vec(x1,y1,x2,y2:longint):real;
begin
  vec:=(x1+0.0)*y2-(x2+0.0)*y1;
end;
function ls(x1,y1,x2,y2:longint):boolean;
var v,d1,d2:comp;
begin
  v:=vec(x1-x[1],y1-y[1],x2-x[1],y2-y[1]);
  d1:=sqr(x1-x[1]+0.0)+sqr(y1-y[1]);
  d2:=sqr(x2-x[1]+0.0)+sqr(y2-y[1]);
  ls:=(v>eps) or (abs(v)<eps) and (d1<d2-eps);
end;
procedure qsort(l,r:longint);
var i,j,mx,my,t:longint;
begin
  i:=l;
  j:=r;
  mx:=x[(l+r) shr 1];
  my:=y[(l+r) shr 1];
  repeat
    while ls(x[i],y[i],mx,my) do
      inc(i);
    while ls(mx,my,x[j],y[j]) do
      dec(j);
    if i<=j then
    begin
      t:=x[i];
      x[i]:=x[j];
      x[j]:=t;
      t:=y[i];
      y[i]:=y[j];
      y[j]:=t;
      t:=num[i];
      num[i]:=num[j];
      num[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;
begin
  assign(input,'convex.in');
  reset(input);
  assign(output,'convex.out');
  rewrite(output);
  read(q);
  for w:=1 to q do
  begin
    read(n);
    min:=1;
    for i:=1 to n do
    begin
      read(x[i],y[i]);
      num[i]:=i;
      if (x[i]<x[min]) or (x[i]=x[min]) and (y[i]<y[min]) then
        min:=i;
    end;
    if (x[1]<>x[n]) or (y[1]<>y[n]) then
    begin
      writeln('NO');
      continue;
    end;
    for i:=2 to n-1 do
      if vec(x[i]-x[i-1],y[i]-y[i-1],x[i+1]-x[i-1],y[i+1]-y[i-1])<-eps then
      begin
        for i:=1 to n div 2 do
        begin
          t:=x[i];
          x[i]:=x[n-i+1];
          x[n-i+1]:=t;
          t:=y[i];
          y[i]:=y[n-i+1];
          y[n-i+1]:=t;
        end;
        break;
      end;
    t:=x[1];
    x[1]:=x[min];
    x[min]:=t;
    t:=y[1];
    y[1]:=y[min];
    y[min]:=t;
    t:=num[1];
    num[1]:=num[min];
    num[min]:=t;
    qsort(2,n);
    cur:=n-1;
    while (cur>0) and (abs(vec(x[cur]-x[1],y[cur]-y[1],x[n]-x[1],y[n]-y[1]))<eps) do
      dec(cur);
    if cur=0 then
    begin
      writeln('NO');
      continue;
    end;
    inc(cur);
    for i:=cur to (n+cur-1) shr 1 do
    begin
      t:=x[i];
      x[i]:=x[n+cur-i];
      x[n+cur-i]:=t;
      t:=y[i];
      y[i]:=y[n+cur-i];
      y[n+cur-i]:=t;
      t:=num[i];
      num[i]:=num[n+cur-i];
      num[n+cur-i]:=t;
    end;
    for i:=1 to n-1 do
      if (x[i]=x[i+1]) and (y[i]=y[i+1]) and (num[i]<num[i+1]) then
      begin
        t:=x[i];
        x[i]:=x[i+1];
        x[i+1]:=t;
        t:=y[i];
        y[i]:=y[i+1];
        y[i+1]:=t;
        t:=num[i];
        num[i]:=num[i+1];
        num[i+1]:=t;
      end;
    slen:=1;
    stack[1]:=1;
    for i:=2 to n do
    begin
      while (slen>2) and (vec(x[stack[slen]]-x[stack[slen-1]],y[stack[slen]]-y[stack[slen-1]],
                             x[i]-x[stack[slen-1]],y[i]-y[stack[slen-1]])<-eps) do
        dec(slen);
      inc(slen);
      stack[slen]:=i;
    end;
    if slen<>n then
    begin
      writeln('NO');
      continue;
    end;
    for p1:=1 to n do
      if num[stack[p1]]=1 then
        break;
    if num[stack[p1]]<>1 then
    begin
      writeln('NO');
      continue;
    end;
    ok:=true;
    for i:=p1 to n do
      if num[stack[i]]<>i-p1+1 then
      begin
        ok:=false;
        break;
      end;
    for i:=1 to p1-1 do
      if num[stack[i]]<>n-p1+i+1 then
      begin
        ok:=false;
        break;
      end;
    if not ok then
    begin
      writeln('NO');
      continue;
    end;
    writeln('YES');
  end;
  close(input);
  close(output);
end.
