{$I-,Q-,R-,S-}
const
     FileIn='grlex.in';
     FileOut='grlex.out';
     MaxN=1000000;
type
    TNumber=record
                  V: LongInt;
                  O: LongInt;
            end;
var
   N, K: LongInt;
   Numbers: array [1..MaxN] of TNumber;
   AnswerIndexOfK, AnswerNumberAtK: LongInt;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, N, K);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, AnswerIndexOfK);
     Writeln (F, AnswerNumberAtK);
     Close (F);
end;

function Less (var aFirstItem, aSecondItem: TNumber): Boolean;
var
   FirstS, SecondS: string;
begin
     if aFirstItem.O<aSecondItem.O
        then Less:=true
        else if aFirstItem.O=aSecondItem.O
                then begin
                     Str (aFirstItem.V, FirstS);
                     Str (aSecondItem.V, SecondS);
                     Less:=FirstS<SecondS;
                end
                else Less:=false;
end;

procedure QSort (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   MiddleItem, TempItem: TNumber;
begin
     i:=aLeft;
     j:=aRight;
     MiddleItem:=Numbers [(aLeft+aRight) div 2];
     repeat
           while Less (Numbers [i], MiddleItem)
                 do Inc (i);
           while Less (MiddleItem, Numbers [j])
                 do Dec (j);
           if i<=j
              then begin
                   TempItem:=Numbers [i];
                   Numbers [i]:=Numbers [j];
                   Numbers [j]:=TempItem;
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSort (aLeft, j);
     if i<aRight
        then QSort (i, aRight);
end;

function Omega (aNumber: LongInt): LongInt;
var
   O: LongInt;
begin
     O:=0;
     while aNumber>0
           do begin
              O:=O+aNumber mod 10;
              aNumber:=aNumber div 10;
           end;
     Omega:=O;
end;

procedure Solve;
var
   Index: LongInt;
begin
     for Index:=1 to N
         do with Numbers [Index]
                 do begin
                    V:=Index;
                    O:=Omega (Index);
                 end;
     QSort (1, N);
     AnswerIndexOfK:=0;
     for Index:=1 to N
         do if Numbers [Index].V=K
               then begin
                    AnswerIndexOfK:=Index;
                    Break;
               end;
     AnswerNumberAtK:=Numbers [K].V;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
