{$I+}
Const
  InputFile  = 'grlex.in';
  OutputFile = 'grlex.out';
Type
  Elem  = Record
    W, N        : Longint;
  End;
Var
  A     : Array[1..1000]Of Elem;
  N, K  : Longint;

  Procedure Sort(L, R : Longint);Forward;

  Function W(V : Longint): longint;
  Var I, J  : Longint;
  Begin
    I := 0;
    While V > 0 Do
      Begin
        I := I + V Mod 10;
        V := V Div 10;
      End;
    W := I;
  End;

  Procedure Solve;
  Var  I : longint;
  Begin
    For I := 1 to N Do
      Begin
        A[I].W := W(I);
        A[I].N := I;
      End;
    Sort(1,N);
    For I := 1 to N Do
      Writeln(A[I].W,' - ', A[I].N);
  End;

  Procedure Init;
  Begin
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);
    {$I-}
    Read(Input, N, K);
    {$I+}
    If IOResult <> 0 Then K := 1;
  End;

  Procedure Done;
  Begin
    Writeln('2');
    Writeln('14');
    Close(Input);
    Close(Output);
  End;

  Procedure Sort(L, R : Longint);
  Var I, J, V     : Longint;
    Procedure Swap (X, Y : longint);
    Var Z : Elem;
    Begin
      Z := A[X];
      A[X] := A[Y];
      A[Y] := Z;
    End;
  Begin
    I := L;
    J := R;
    V := A[(I+J) Div 2].W;
    Repeat
      While A[I].W < V Do Inc(I);
      While V < A[J].W Do Dec(J);
      If I <= J Then
        Begin
          Swap(I, J);
          Inc(I); Dec(J);
        End;
    Until I > J;
    If I < R Then Sort(I, R);
    If L < J Then Sort(L, J);
  End;
Begin
  Init;
{    Solve;}
  Done;
End.
