{$I-,Q-,R-,S-}
Const
  InputFile  = 'convex.in';
  OutputFile = 'convex.out';
Type
  Extended = Double;

Var
  N, CountTestS : Longint;
  Buf           : Array [0..255] Of Longint;

  Procedure EndTest(V : Longint);
  Var  I : Longint;
  Begin
    For I := 1 to V Do ReadLn;
  End;
  Procedure Solve;
  Label
    HaltC;
  Var
    I, J, X, Y, X0, Y0, X1, Y1, X2, Y2  : Longint;
    Left, Right, FAL            : Boolean;
    C1, C2                      : Longint;
    v1 ,v2, Ang                 : Extended;

  Begin
    While CountTestS > 0 Do
      Begin
        Dec(CountTestS);
        Readln(N);
        If N <= 3 Then
           Begin
             Writeln('NO');
             EndTest(N);
             Continue;
           End;
        Left  := False;
        Right := False;
        Fal   := False;
        Readln(X0, Y0);
        x1 := x0;
        y1 := y0;
        Readln(X2, Y2);
        Ang := 0;
        For I := 3 to N Do
          Begin
            Readln(X, Y);
            C1 := (x2-x1)*(y-y2)-(y2-y1)*(x-x2);
            C2 := (X2-x1)*(X-x2)+(Y2-Y1)*(y-y2);
            If Left Then
              If (C1 < 0)Or((C1 = 0)and(C2 < 0))
                Then Begin EndTest(N-I);Writeln('NO');Goto HaltC;End;
            If Right Then
              If (C1 > 0)Or((C1 = 0)and(C2 < 0))
                Then Begin EndTest(N-I);Writeln('NO');GoTo HaltC;End;
            If Not Left and Not Right Then
              Begin
                If (C1 = 0)and(C2 < 0)
                  Then Begin EndTest(N-I);Writeln('NO');GoTo HaltC;End;
                If C1 < 0 Then Right := True;
                If C1 > 0 Then Left  := True;
              End;
            If C2 <> 0
              Then V1 := ArcTan(Abs(c1)/c2)
              Else V1 := Pi/2;
            If V1 < 0 Then V1 := V1 + pi;
            Ang := Ang + v1;
            If Ang> 2*pi Then Begin EndTest(N-I);Writeln('NO');GoTo HaltC;End;
            x1 := x2;
            y1 := y2;
            x2 := x;
            y2 := y;
          End;
        FAL := (X0 = X)And(Y0 = Y);
        If FAL And (Left Or Right) Then Writeln('YES') Else Writeln('NO');
        HaltC:
      End;
  End;

  Procedure Init;
  Begin
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);
    SetTextBuf(Input, Buf);
    Read(CountTestS);
  End;

  Procedure Done;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  Init;
    Solve;
  Done;
End.
