#include <stdio.h>
#include <math.h>

#if 0
#define MSG(A) 			printf(#A"\n")
#define MSG1(A,A1)		printf(A,A1)
#define MSG2(A,A1,A2)		printf(A,A1,A2)
#define MSG3(A,A1,A2,A3)        printf(A,A1,A2,A3)
#define _M_			printf("Message %d\n",__LINE__);
#else
#define MSG(A)
#define MSG1(A,A1)
#define MSG2(A,A1,A2)
#define MSG3(A,A1,A2,A3)
#define _M_
#endif

#define FOR(A1,B1,C1) for(A1 = B1;A1 < C1; A1++)
#define FOR2(A1,B1,C1,A2,B2,C2) for(A1 = B1;A1 < C1; A1++)\
					for(A2 = B2;A2 < C2; A2++)
#define CMP(A,B)  if (A == B)
#define sqr(X) ((X)*(X))

struct pix
{
	int x,y;
};


typedef struct pix sort_t;

int m,n;
int x,y;
struct pix a[40000];
int len = 0;

double
KEY(struct pix p)
{
	
	return((x - p.x)/
		sqrt(sqr((x - p.x))+sqr((y - p.y))));
}

void
build(sort_t *A, int i, int l)
{
	A--;
	int j = i << 1;
	sort_t x = A[i];
	for (;;)
	{
		if (j > l)	break;
		if (j < l)
			if (KEY(A[j+1]) > KEY(A[j])) j++;
		if ((KEY(x)) > KEY(A[j])) break;
		A[i] = A[j];
		i = j;
		j = i << 1;
	}
	A[i] = x;
}

void
sort(sort_t *A, int l)
{
	int i;
	for (i = l >> 1;i;i--)
		build(A,i,l);
	for (i = l-1;i;i--)
	{
		sort_t t = A[0];
		A[0] = A[i];
		A[i] = t; 
		build(A,1,i);
	}      
}

int
pov(	struct pix p1,
	struct pix p2,
	struct pix p3)
{
	long long x1,x2;
	long long y1,y2,k;
	x1 = p1.x - p2.x;
	y1 = p1.y - p2.y;
	x2 = p2.x - p3.x;
	y2 = p2.y - p3.y;
	k = x1*y2 - x2 * y1;
	if (k > 0) return (1);
	if (k < 0) return (-1);
	return(0);
}


int
main()
{
	int b = 1;
	{
		FILE *f;
		f = fopen("input.txt","r");
		fscanf(f,"%d %d", &n, &m);
		fscanf(f,"%d %d", &x, &y);
		{	
			struct pix tmp = {x,y};
			int i;
			FOR (i,0,n)
			{
				fscanf(f,"%d %d %d %d",
					&a[len].x, &a[len].y,
					&a[len+1].x, &a[len+1].y);
				if (pov(tmp,a[len],a[len+1]))
					b = 0;
				len += 2;
			}
		}
		fclose(f);
	}
	{
		FILE *f;
		long long t = m;
		f = fopen("output.txt","w");
		if (b)
			fprintf (f,"%lld\n",t*t);
		else
			fprintf (f,"%d\n",0);
		fclose(f);
	}
}
