#include <stdio.h>
#include <string.h>

#define FOR(A1,B1,C1) for(A1 = B1;A1 < C1; A1++)
#define FOR2(A1,B1,C1,A2,B2,C2) for(A1 = B1;A1 < C1; A1++)\
					for(A2 = B2;A2 < C2; A2++)
#define CMP(A,B)  if (A == B)


#define AX &ax
#define BX &bx
#define CX &cx
#define DX &dx


struct big_int
{
	char a[200];
	int len;
}ax,bx,cx,dx;


char avt[27][22];

char s[21];
int len;
char m,n;

struct big_int a[21][21];

struct big_int *
set(struct big_int *a,int k)
{
	int i;
	FOR (i,1,200)
		a->a[i] = 0;
	a->a[0] = k; 
	if (k)
		a->len = 1;
	else
		a->len = 0;
	return(a);
}

struct big_int *
mov(struct big_int *a, struct big_int *b)
{
	int i;
	FOR (i,0,200)
		a->a[i] = b->a[i];
	a->len = b->len;
	return(a);	
}

struct big_int *
mull(struct big_int *a,int b)
{
	int i;
	int per = 0;
	FOR (i,0,a->len)
	{
		int t = (a->a[i] * b + per);
		per = t / 10;
		a->a[i] = t % 10;
	}
	for (i = a->len;per;i++)
	{
		a->a[i] = per % 10;
		per /= 10;
	}
	a->len = i;
	return(a);
}

struct big_int *
add(struct big_int *a, struct big_int *b)
{
	int i;
	int per = 0;
	int len = a->len > b->len ? a->len : b->len;
	for (i = 0; i < len; i++)
	{
		int t = a->a[i] + b->a[i] + per;
		a->a[i] = t % 10;
		per = t / 10;
	}
	for (i = len;per;i++)
	{
		a->a[i] = per % 10;
		per /= 10;
	}
	a->len = i;
	return(a);
}

int
print(struct big_int *a)
{
	int i;
	FILE *f;
	f = fopen("output.txt","w");
	i = a->len;
	while (a -> a[--i] == 0);
	for(;i>=0;i--)
	{
		fprintf(f,"%d",(int)a->a[i]);
	}
	fprintf(f,"\n");
	fclose(f);
	return(0);
}

int
build_avt(char *s)
{            
	int i,j;
	FOR (i,0,27)
		avt[i][0] = 0;
	avt[0][0] = 1;
	FOR2(i,1,len+1,	j,0,27)
		if(j == s[i]) avt[j][i] = i+1;
		else CMP(j,26)
		{
			avt[26][i] = avt[ (s[i+1]) ][ avt[26][i-1] ];
		}else
		{
			avt[j][i] = avt[ (s[i]) ][ avt[26][i-1] ];
		}
	return(0);
}


int
main()
{
	{
		int i;
		FILE *f;
		f = fopen("input.txt","r");
		fscanf(f,"%s",s);
		fscanf(f,"%d %d", &m, &n);
		len = strlen(s);
		FOR(i, 0,len) s[i] -= 'a' ;
		fclose(f);
	}
	if (len > m)
	{
		struct big_int t;
		set(&t,0);
		print(&t);
		return(0);
	}
	build_avt(s);
/*	{       int i,j;
		FOR (i,0,len+1)
		{
			FOR (j,0,27)
			{
				printf("%d ",avt[j][i]);	
			}
			printf("\n");
		}
	} */
	{
		int i,j;
		FOR2 (i,0,22, j,0,22) set(&a[i][j],0);
		set(&a[0][0],1);
	}
	{
		int i,j,k,u;
		FOR (u,0,m)
		FOR2 (i,0,n,	j,0,len+1)
			if (a[i][j].len)
			{
				FOR (k,0,26)
				{
					int t = i,b = j;
					b = avt[k][b];
					CMP (b,len+1) t++;
					add(&a[t][b], &a[i][j]);
				}
			}
	}
	{
		int i;
		struct big_int tmp;
		set(&tmp,0);
		FOR (i,0,len+1)
		{
			add(&tmp,&a[n][i]);	
		}
		print(&tmp);
	}
	return(0);
}
