#define ONLINE
#include <stdio.h>
#include <string.h>

long n,n_cells;
short*a_cont,*b_cont,**a,**b;

int main(void) {
  #ifdef ONLINE
  freopen("input.txt","rt",stdin);
  freopen("output.txt","wt",stdout);
  #endif
  long i,j;
  scanf("%ld",&n);
  n_cells=n*n;
  a_cont=new short[n_cells]; b_cont=new short[n_cells];
  a=new short*[n]; b=new short*[n];
  for (i=0,j=0; i<n; i++,j+=n) { a[i]=&a_cont[j]; b[i]=&b_cont[j]; }
  memset(a_cont,0,sizeof(short)*n_cells);
  memset(b_cont,0,sizeof(short)*n_cells);
  for (i=0; i<n; i++) for (j=0; j<n; j++) scanf("%hd",&a[i][j]);
  long k;
  for (k=0; k<n; k++) b[k][k]=1;
  long diagonal;
  for (diagonal=1; diagonal<n; diagonal++) for (i=0,j=diagonal; j<n; i++,j++) {
    b[i][j]=a[i][j];
    for (k=i+1; k<=j-1; k++) b[i][j]-=b[i][k]*b[k][j];
    b[i][j]=(b[i][j]%3+3)%3;
    b[i][j]=(b[i][j]*2)%3;
  }
  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      if (j) printf(" ");
      printf("%hd",b[i][j]);
    } printf("\n");
  }
  delete[]a; delete[]b;
  delete[]a_cont; delete[]b_cont;
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


