{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'output.txt';
  cinfile = 'input.txt';

  nmax = 310;

type
  int = longint;
  real = extended;

var
  n, k : int;
  ans : int;

  a : array [1..nmax,1..nmax] of shortint;
  b : array [1..nmax,1..nmax] of shortint;

procedure outdata;
var
  i, j : int;
begin
  for i:= 1 to n do
  begin
    for j:= 1 to n-1 do write(b[i,j],' ');
    writeln(b[i,n]);
  end;
end;

function rec(i, j : int) : shortint;
var
  k, s : integer;
begin
  if b[i,j] > -1 then
  begin
    rec:= b[i,j];
    exit;
  end;
  s:= 0;
  for k:= i+1 to j-1 do inc(s,rec(i,k)*rec(k,j));
  s:= (a[i,j]-s+3000) mod 3;
  b[i,j]:= (s shl 1) mod 3;
  rec:= b[i,j];
end;

procedure solve;
var
  i, j : int;
begin
  fillchar(b,sizeof(b),255);
  for i:= 1 to n-1 do
    for j:= i+1 to n do b[j,i]:= 0;
  for i:= 1 to n do b[i,i]:= 1;
  for i:= 1 to n-1 do
    for j:= i+1 to n do rec(i,j);
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
  for i:= 1 to n do
    for j:= 1 to n do read(a[i,j]);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
