{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 5000000,0,5000000}
const infile = 'input.txt'; outfile = 'output.txt'; max = 305;
type mat = array [1..max,1..max] of longint;
var c,a,b,ans: mat;
    n: longint;
    w: longint;

procedure init;
var i,j: longint;
begin
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n do
         for j:=1 to n do
             read(a[i,j]);
     close(input);
end;

function check: boolean;
var i,j,k,s: longint;
begin
     check:=false;
     for i:=1 to n do
         for j:=1 to n do begin
             s:=0;
             for k:=1 to n do
                 s:=(s+ans[i,k]*ans[k,j]) mod 3;
             if s <> a[i,j] then exit;
         end;
     check:=true;
end;

procedure mult(a,b: mat; var c: mat);
var i,j,k: longint;
begin
     fillchar(c,SizeOf(c),0);
     for i:=1 to n do
        for k:=i to n do
         for j:=k to n do begin
             c[i,j]:=(c[i,j]+b[i,k]*a[k,j]) mod 3;
         end;
end;

procedure power(st: longint);
var x: longint;
begin
     x:=st; b:=a; ans:=a;
     while x > 0 do begin
           if x mod 2 = 0 then begin
              mult(b,b,c); b:=c; x:=x div 2;
           end
              else begin
                   c:=ans; mult(c,b,ans); x:=x-1;
              end;
     end;
end;

procedure solve;
var st,cr,pow: longint;
begin
     st:=1; cr:=4; pow:=1;
     while n > cr do begin
           st:=st*3; cr:=st*4;
           pow:=pow+st;
     end;
     power(pow);
end;

procedure done;
var i,j: longint;
begin
     assign(output,outfile);
     rewrite(output);
     for i:=1 to n do begin
         for j:=1 to n do
             write(ans[i,j],' ');
         writeln;
     end;
     close(output);
end;

begin
     init;
     solve;
     done;
end.
