{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_c;
const
  inpfile='input.txt';
  outfile='output.txt';
  osn=10000;
  lm=50;
  nm=22;
type
  TLong = array [0..lm] of LongInt;
var
  a,c : array [0..nm,0..nm] of TLong;
  b : array [0..nm,'a'..'z'] of LongInt;
  n,m,len : LongInt;
  s : String;
  res,ed : TLong;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  readln(s);
  read(m,n);
  len:=length(s);
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  write(res[res[0]]);
  for i:=res[0]-1 downto 1 do begin
    if res[i]<1000 then write(0);
    if res[i]<100 then write(0);
    if res[i]<10 then write(0);
    write(res[i]);
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
  fillchar(ed,sizeof(ed),0);
  ed[0]:=1; ed[1]:=1;
end;
{}
Function Max(q,w : LongInt) : LongInt;
begin
  if q>w then max:=q else max:=w;
end;
{}
Procedure Sum(q,w : TLong; var r : TLong);
var
  i,p : LongInt;
begin
  fillchar(r,sizeof(r),0); p:=0;
  r[0]:=max(q[0],w[0])+1;
  for i:=1 to r[0] do begin
    p:=q[i]+w[i]+p;
    r[i]:=p mod osn;
    p:=p div osn;
  end;
  if r[r[0]]=0 then dec(r[0]);
end;
{}
Procedure Solve;
var
  i,j,k,l,eq : LongInt;
  ch : Char;
  ok : Boolean;
begin
  for i:=0 to len do
    for ch:='a' to 'z' do begin
      b[i,ch]:=0;
      if i=len then l:=len
               else l:=i+1;

      for j:=l downto 1 do
        if s[j]=ch then begin
          ok:=true;
          for k:=j-1 downto 1 do
            if s[k]<>s[i+1+k-j] then begin
              ok:=false; break;
            end;
          if ok then begin
            b[i,ch]:=j;
            break;
          end;
        end;
    end;

  a[0,0]:=ed;
  for k:=1 to m do begin
    for i:=0 to n do
      for j:=0 to len do
        for ch:='a' to 'z' do begin
          if b[j,ch]=len then eq:=i+1
                         else eq:=i;
          Sum(c[eq,b[j,ch]],a[i,j],c[eq,b[j,ch]]);
        end;
    a:=c; fillchar(c,sizeof(c),0);
  end;

  fillchar(res,sizeof(res),0);
  for i:=0 to len do
    Sum(res,a[n,i],res);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.