{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
Program B;
Const
     InFile = 'input.txt';
     OutFile = 'output.txt';
     NMax = 300;
Type
    TMatrix = Array [0..NMax,0..NMax] Of LongInt;
Var
   N : LongInt;
   A,B : TMatrix;

 Procedure ReadData;
  Var
     I,J : LongInt;
   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (N);
     For I:= 1 To N Do
       For J:= 1 To N Do Read (A[I,J]);
     Close (Input);
   End;

 Procedure Solve;
  Var
     D,I,J,II,JJ,K,S : LongInt;
   Begin
     FillChar (B,SizeOf(B),0);
     For I:= 1 To N Do B[I,I]:= 1;

     For D:= 2 To N Do Begin
       I:= 1; J:= D;
       While (I <= N) And (J <= N) Do Begin

         II:= I + 1; JJ:= I + 1;
         S:= 0;
         While (II < J) And (JJ < J) Do Begin
           S:= (S + B[I,JJ] * B[II,J]) Mod 3;
           Inc (II); Inc (JJ);
         End;
         S:= (3 - (3 + A[I,J] - S) Mod 3) Mod 3;
         B[I,J]:= S;
         Inc (I); Inc (J);
       End;
     End;
   End;

 Procedure WriteData;
  Var
     I,J : LongInt;
   Begin
     Assign (Output,OutFile); ReWrite (Output);
     For I:= 1 To N Do Begin
       For J:= 1 To N Do Write (B[I,J],' ');
       WriteLn;
     End;
     Close (Output);
   End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.

