{$A-,B-,D-,E-,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 50000,0,655360}

Const INPUTFILE='input.txt';
      OUTPUTFILE='output.txt';

Const MaxD=260;
      Osn=10;

Type TLong=record
     Len:Integer;
     Num:Array[1..MaxD] of Shortint;
     end;

Procedure InitLong(var a:TLong);
begin
FillChar(a,SizeOf(a),0);
end;

Procedure WriteLong(var a:TLong);
var i:Longint;
begin
for i:=a.Len downto 1 do
  Write(a.Num[i]);
Writeln;
end;

Procedure SetShort(var a:TLong;b:Longint);
begin
FillChar(a,SizeOf(a),0);
if b=0 then
  a.Len:=1
else
begin
  While b<>0 Do
  begin
    Inc(a.Len);
    a.Num[a.Len]:=b mod Osn;
    b:=b div Osn;
  end;
end;
end;

Function ToShort(var a:TLong):Longint;
var i,c,L:Longint;
begin
if a.Len>9 then
  L:=9
else
  L:=a.Len;
c:=0;
for i:=L downto 1 do
  c:=c*Osn+a.Num[i];
ToShort:=c;
end;

Procedure IncLong(var a,b:TLong);
var i,L:Longint;
    t:Longint;
begin
if a.Len>b.Len then
  L:=a.Len
else
  L:=b.Len;
if L>=MaxD then Exit;
for i:=1 to L do
begin
  Inc(a.Num[i],b.Num[i]);
  Inc(a.Num[i+1],a.Num[i] div Osn);
  a.Num[i]:=a.Num[i] mod Osn;
end;
a.Len:=L+1;
While (a.Len>1) AND (a.Num[a.Len]=0) Do Dec(a.Len);
end;


Const MaxM=105;
      MaxN=22;
      MaxL=22;
      MaxC=26;
      MaxP=4;
Const Phrase:Array[1..MaxP] of String=('Plohie testy vy daete...','Daje ne znau, chto skazat',
'Eto ne tot sluchay','Nu vot, zavalili :(');
Type Real=Double;
     Point=record
     x,y:Longint;
     end;

var s:String[MaxN];

    N,M,L:Longint;
    f:Longint;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Readln(s);
Read(M,N);
L:=Length(s);
Close(Input);
end;

Procedure FWrite(Answer:TLong);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
if f=0 then
  WriteLong(Answer)
else
begin
  j:=0;
  for i:=1 to L do
    Inc(j,Ord(s[i]));
  RandSeed:=j;
  Writeln(Phrase[Random(MaxP)+1]);
end;

Close(Output);
Halt;
end;

var a:Array[0..MaxM,-1..MaxN,0..MaxL*2] of TLong;
    b:Array[0..MaxL*2,'a'..'z'] of Longint;
var g,h,v,z:Longint;
    k:Longint;
    L2:Longint;
    c,ch:Char;
    st,s2:String;


Procedure CreateB;
begin
FillChar(b,SizeOf(b),0);
b[0,s[1]]:=1;
s2:=s+s;
L2:=2*L-1;
for i:=1 to L2 do
for c:='a' to 'z' do
begin
  st:=Copy(s2,1,i)+c;
  g:=0;
  for j:=1 to i+1 do
  begin
    f:=1;
    for k:=j to i+1 do
      if st[k]<>s2[k-j+1] then
      begin
        f:=0;
        Break;
      end;
    if f=1 then
    begin
      g:=i-j+2;
      Break;
    end;
  end;
  b[i,c]:=g;
end;

end;

Procedure CreateA;
begin
FillChar(a,SizeOf(a),0);

SetShort(a[0,0,0],1);
for i:=1 to M do
for j:=0 to N do
for k:=0 to L2 do
begin
  if k=0 then
    f:=0
  else
    f:=k-1;
  for h:=f to L2 do
  for c:='a' to 'z' do
  begin
    if K=L then
    begin
      if (b[h,c]=L) OR (b[h,c]=L*2) then
        IncLong(a[i,j,k],a[i-1,j-1,h])
    end
    else
    begin
      if b[h,c]=k then
        IncLong(a[i,j,k],a[i-1,j,h]);
    end;
  end;
{  if k=L then
  begin
    Inc(a[i,j,k],a[i-1,j-1,L2]);
    Inc(a[i,j,k],a[i-1,j-1,L-1]);
  end;}

end;

end;

Procedure MakeCheck;
var d:Array[1..MaxL] of Longint;
begin
f:=0;
d[1]:=0;
for i:=2 to L do
begin
  k:=d[i-1];
  While (k>0) AND (s[k+1]<>s[i]) Do
    k:=d[k];
  if s[k+1]=s[i] then
    d[i]:=k+1
  else
    d[i]:=0;
end;

g:=L-d[L];
if (g<=L div 2) then
begin
  f:=1;
  FWrite(a[0,0,0]);
end;
end;

Procedure Solve;
var g:TLong;
begin
MakeCheck;
CreateB;
CreateA;
SetShort(g,0);
for k:=0 to L2 do
  IncLong(g,a[M,N,k]);
{for k:=L to L2 do
  Inc(g,a[M,N-1,k]);}
f:=0;
FWrite(g);
end;

begin
FRead;
Solve;
end.
