{$N+}
type
  real = extended;
const
  inf = 'input.txt'; ouf = 'output.txt';
  max = 20010;
  pi = 3.1415926535897932385;
  eps = 1e-6;
  procedure iswap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
  procedure rswap(var a, b: real);
  var
    c: real;
  begin
    c := a; a := b; b := c;
  end;
var
  xp, yp, xpr, ypr, xma, yma, xmi, ymi, tt, ttt: real;
  xc, yc: integer;
  procedure cross(xa, ya, xb, yb, xc, yc, xd, yd: longint);
  var
    a, b, c, d, e, f: longint;
    det, t, s: real;
  begin
    a := xb - xa; b := xc - xd; c := xc - xa;
    d := yb - ya; e := yc - yd; f := yc - ya;
    det := a * e - d * b;
    if (det <> 0) then
    begin
       s := (f * a - c * d)/det;
       t := (c * e - b * f)/det;
       if (s >= 0) and (s <= 1) and
         (t >= 0) then
         begin
           xp := (1 - s) * xc + s * xd;
           yp := (1 - s) * yc + s * yd;
           if (s = 0) then
           begin
             if (t < tt) or (tt = -1) then
             begin
               xma := xp; yma := yp; tt := t;
             end;
           end else
           if (s = 1) then
           begin
             if (t < ttt) or (ttt = -1) then
             begin
               xmi := xp; ymi := yp; ttt := t;
             end;
           end else
           begin
             if (t < tt) or (tt = -1) then
             begin
               xma := xp; yma := yp; tt := t;
             end;
             if (t < ttt) or (ttt = -1) then
             begin
               xmi := xp; ymi := yp; ttt := t;
             end;
           end;
         end;
    end;
  end;
var
  xa, ya, xb, yb: array[1..max] of longint;
  x, y: array[1..max shl 1] of longint;
  a: array[1..max shl 1] of real;
  function vec(xa, ya, xb, yb: longint): longint;
  begin
    vec := xa * yb - xb * ya;
  end;
var
  hs: longint;
  procedure down(k: longint);
  var
    j, l: longint;
  begin
    l := k; j := k shl 1;
    if (j <= hs) and
    (a[j] - a[l] > eps) then l := j;
    inc(j);
    if (j <= hs) and
    (a[j] - a[l] > eps) then l := j;
    if (l <> k) then
    begin
      iswap(x[l], x[k]); iswap(y[l], y[k]);
      rswap(a[l], a[k]); down(l);
    end;
  end;
var
  d, s: real;
  xx, yy: longint;
  m, nn, n, i, j: longint;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n, m);
  readln(input, xc, yc);
  for i := 1 to n do
    readln(input, xa[i], ya[i], xb[i], yb[i]);
  inc(n);
  xa[n] := 0; ya[n] := 0; xa[n] := m; ya[n] := 0;
  inc(n);
  xa[n] := 0; ya[n] := 0; xb[n] := 0; yb[n] := m;
  inc(n);
  xa[n] := m; ya[n] := m; xb[n] := m; yb[n] := 0;
  inc(n);
  xa[n] := m; ya[n] := m; xb[n] := 0; yb[n] := m;
  for i := 1 to n do
  begin
    j := i shl 1;
    x[j - 1] := xa[i]; x[j] := xb[i];
    y[j - 1] := ya[i]; y[j] := yb[i];
  end;
  nn := n shl 1;
  for i := 1 to nn do
  begin
    xx := x[i] - xc; yy := y[i] - yc;
    if (xx <> 0) then d := abs(yy/xx);
    if (xx > 0) then
    begin
      if (yy > 0) then a[i] := arctan(d)
      else
      if (yy < 0) then a[i] := 2 * pi - arctan(d)
      else a[i] := 0;
    end else
    if (xx < 0) then
    begin
      if (yy > 0) then a[i] := pi - arctan(d)
      else
      if (yy < 0) then a[i] := pi + arctan(d)
      else  a[i] := pi;
    end else
           if (yy > 0) then a[i] := pi/2
           else a[i] := 3*pi/2;
  end;
  for i := 1 to n do
    if (vec(xa[i]-xc, ya[i]-yc, xb[i]-xc, yb[i]-yc) < 0) then
    begin
      iswap(xa[i],xb[i]); iswap(ya[i], yb[i]);
    end;
  hs := nn;
  for i := (nn+1) shr 1 downto 1 do down(i);
  while (hs > 1) do
  begin
    iswap(x[1], x[hs]); iswap(y[1], y[hs]);
    rswap(a[1], a[hs]);
    dec(hs); down(1);
  end;
  x[nn + 1] := x[1]; y[nn + 1] := y[1];
  a[nn + 1] := a[1]; s := 0;
  for i := 1 to nn + 1do
  begin
    if (i > 1) then
      if (x[i] = x[i - 1]) and
         (y[i] = y[i - 1]) then
           continue;
    tt := -1; ttt := -1;
    xma := x[i]; yma := y[i];
    xmi := x[i]; ymi := y[i];
    for j := 1 to n do
      cross(xc, yc, x[i], y[i],
               xa[j], ya[j], xb[j], yb[j]);
        if (i > 1) then
        begin
          xma := xma - xc; yma := yma - yc;
          xmi := xmi - xc; ymi := ymi - yc;
          s := s + 0.5 * abs(xmi*ypr - ymi*xpr);
          xpr := xma; ypr := yma;
        end else
        begin
          xpr := xma - xc; ypr := yma - yc;
        end;
  end;
  writeln(output, s:6:6);
  close(input); close(output);
end.