{$I-,Q-,R-,S-}
const eps=1e-8;
var min,n,j,m,x0,y0,i,cnt:longint;
    x1,y1,x2,y2:longint;
    x,y:array [1..1000] of real;
    xx,yy,t,curs,ans:real;
procedure push(xx,yy:real);
var i:longint;
begin
  for i:=1 to cnt do
    if (abs(x[i]-xx)<1e-8) and (abs(y[i]-yy)<1e-8) then
      break;
  inc(cnt);
  x[cnt]:=xx;
  y[cnt]:=yy;
end;
function crotr(x1,y1,x2,y2,x3,y3,x4,y4:longint):boolean;
var a,b,c,d,e,f,dx,dy,dd:longint;
    t,s:real;
begin
  a:=x2-x1;
  b:=x3-x4;
  c:=x3-x1;
  d:=y2-y1;
  e:=y3-y4;
  f:=y3-y1;
  dx:=c*e-b*f;
  dy:=a*f-c*d;
  dd:=a*e-b*d;
  crotr:=false;
  if dd=0 then
    exit;
  t:=dx/dd;
  s:=dy/dd;
  crotr:=(t>=0) and (t<=1) and (s>=0) and (s<=1);
end;
function crl(x1,y1,x2,y2,x3,y3,x4,y4:longint;var xc,yc:real):boolean;
var a,b,c,d,e,f,dx,dy,dd:longint;
    t,s:real;
begin
  a:=x2-x1;
  b:=x3-x4;
  c:=x3-x1;
  d:=y2-y1;
  e:=y3-y4;
  f:=y3-y1;
  dx:=c*e-b*f;
  dy:=a*f-c*d;
  dd:=a*e-b*d;
  crl:=false;
  if dd=0 then
    exit;
  t:=dx/dd;
  s:=dy/dd;
  crl:=(t>=0) and (s>=0) and (s<=1);
  xc:=x1+(x2-x1)*t;
  yc:=y1+(y2-y1)*t;
end;
function ls(x1,y1,x2,y2:real):boolean;
var v,d1,d2:real;
begin
  v:=x1*y2-x2*y1;
  d1:=x1*x1+y1*y1;
  d2:=x2*x2+y2*y2;
  ls:=(v>eps) or (abs(v)<eps) and (d1<d2);
end;
procedure qsort(l,r:longint);
var i,j:longint;
    mx,my,t:real;
begin
  i:=l;
  j:=r;
  mx:=x[(l+r) shr 1];
  my:=y[(l+r) shr 1];
  repeat
    while ls(x[i]-x[1],y[i]-y[1],mx-x[1],my-y[1]) do
      inc(i);
    while ls(mx-x[1],my-y[1],x[j]-x[1],y[j]-y[1]) do
      dec(j);
    if i<=j then
    begin
      t:=x[i];
      x[i]:=x[j];
      x[j]:=t;
      t:=y[i];
      y[i]:=y[j];
      y[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;
begin
  assign(input,'input.txt');
  reset(input);
  read(n,m,x0,y0);
  ans:=0;
  for i:=1 to n do
  begin
    read(x1,y1,x2,y2);
    cnt:=0;
    push(x1,y1);
    push(x2,y2);
    if crotr(0,0,x0,y0,x1,y1,x2,y2) then
      push(0,0);
    if crotr(0,m,x0,y0,x1,y1,x2,y2) then
      push(0,m);
    if crotr(m,0,x0,y0,x1,y1,x2,y2) then
      push(m,0);
    if crotr(m,m,x0,y0,x1,y1,x2,y2) then
      push(m,m);
    if crl(x0,y0,x1,y1,0,0,0,m,xx,yy) then
      push(xx,yy);
    if crl(x0,y0,x1,y1,0,m,m,m,xx,yy) then
      push(xx,yy);
    if crl(x0,y0,x1,y1,m,m,m,0,xx,yy) then
      push(xx,yy);
    if crl(x0,y0,x1,y1,m,0,0,0,xx,yy) then
      push(xx,yy);
    if crl(x0,y0,x2,y2,0,0,0,m,xx,yy) then
      push(xx,yy);
    if crl(x0,y0,x2,y2,0,m,m,m,xx,yy) then
      push(xx,yy);
    if crl(x0,y0,x2,y2,m,m,m,0,xx,yy) then
      push(xx,yy);
    if crl(x0,y0,x2,y2,m,0,0,0,xx,yy) then
      push(xx,yy);
    min:=1;
    for j:=2 to cnt do
      if (x[j]<x[min]) or (x[j]=x[min]) and (y[j]<y[min]) then
        min:=j;
    t:=x[1];
    x[1]:=x[min];
    x[min]:=t;
    t:=y[1];
    y[1]:=y[min];
    y[min]:=t;
    qsort(2,cnt);
    x[cnt+1]:=x[1];
    y[cnt+1]:=y[1];
    curs:=0;
    for j:=1 to cnt do
      curs:=curs+x[j]*y[j+1]-x[j+1]*y[j];
    ans:=ans+abs(curs)/2;
  end;
  ans:=m*m-ans;
  close(input);
  assign(output,'output.txt');
  rewrite(output);
  write(ans:0:10);
  close(output);
end.
