const
     FileIn='input.txt';
     FileOut='output.txt';
     MaxN=300;
     Module=3;
     Limit=6;
type
    TMatrix=array [1..MaxN, 1..MaxN] of LongInt;
var
   N: LongInt;
   A, B, C: TMatrix;
   Used: array [1..MaxN, 1..MaxN] of Boolean;
   Answer: Boolean;

procedure ReadData;
var
   F: Text;
   i, j: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for j:=1 to N
         do for i:=1 to N
                do Read (F, A [i, j]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   i, j: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if not Answer
        then Writeln (F, 0)
        else for j:=1 to N
                 do begin
                    for i:=1 to N-1
                        do Write (F, B [i, j], #32);
                    Writeln (F, B [N, j]);
                 end;
     Close (F);
end;

function Check: Boolean;
var
   i, j, k: LongInt;
begin
     FillChar (C, SizeOf (C), 0);
     for i:=1 to N
         do for j:=1 to N
                do for k:=1 to N
                       do C [i, j]:=(C [i, j]+B [i, k]*B [k, j]) mod Module;
     for i:=1 to N
         do for j:=1 to N
                do if A [i, j]<>C [i, j]
                      then begin
                           Check:=false;
                           Exit;
                      end;
     Check:=true;
end;

procedure Recursion (aX, aY: LongInt);

procedure CallNext;
begin
     if not Answer
        then if aX<N
                then Recursion (aX+1, aY)
                else if aY<N
                        then Recursion (1, aY+1)
                        else if Check
                                then Answer:=true;
end;

begin
     if aX<aY
        then begin
             B [aX, aY]:=0;
             CallNext;
        end
        else if aX=aY
                then begin
                     B [aX, aY]:=1;
                     CallNext;
                end
                else begin
                     B [aX, aY]:=0;
                     while B [aX, aY]<=Limit
                           do begin
                              CallNext;
                              if Answer
                                 then Break;
                              Inc (B [aX, aY]);
                           end;
                end;
end;

procedure Solve;
begin
     Answer:=false;
     if N<Limit
        then begin
             FillChar (B, SizeOf (B), 0);
             Recursion (1, 1);
        end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
