#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NN 300
#define MAX_S 30

struct POINT {
  int v;
  int s;
  int cur_sum;
};

FILE *fi, *fo;
int n,d,x;
POINT a[NN];
int v_s[MAX_S];
int l;

int getmy(int n, int d);
bool ismygood(int n, int d);

int lg(int n)
{
  return (int)(log(n)/log(2)+1.00001);
}

int getmy(int n, int d)
{
  int res;
  if(n<=2)
    return (2*d+1);
  res=(d+1)*lg(n);
  if(ismygood(lg(n),d))
    res+=getmy(lg(n),d);
  else
    res+=(2*d+1)*lg(lg(n));
  return res;
}

bool ismygood(int n, int d)
{
  int r1,r2;
  if(d==0)
    return false;
  if(n<=2)
    return false;
  r2=(2*d+1)*lg(n);
  r1=getmy(n,d);
  if(r1<r2)
    return true;
  return false;
}

int getcc()
{
  int c;
  c=getc(fi);
  while((c==' ')||(c=='\n')||(c=='\r')||(c=='\t'))
    c=getc(fi);
  return c;
}

int de_code(int n, int *s)
{
  int res;
  int i;
  (*s)=0;
  res=0;
  for(i=0;i<lg(n);i++)
  {
    x=getcc()-'0';
    if(x==0)
      res*=2;
    else
    {
      res=res*2+1;
      (*s)++;
    }
  }
  return res;
}

void wr_code()
{
  int i;
  for(i=lg(n)-1;i>=0;i--)
    fprintf(fo,"%d",a[i]);
}

int decode(int beg_ind,int n)
{
  int s;
  int ind;
  int i,j;
  int m,k;
  ind=beg_ind;
  if(ismygood(n,d))
  {
    for(i=0;i<d+1;i++)
    {
      a[ind].v=de_code(n,&a[ind].s);
      a[ind].cur_sum=0;
      ind++;
    }
    s=decode(ind,lg(n));
    for(i=beg_ind;i<ind;i++)
    {
      if(a[i].s!=s)
        a[i].cur_sum=-1;
      else
        for(j=beg_ind;j<i;j++)
          if(a[j].v==a[i].v)
            a[i].cur_sum=a[j].cur_sum+1;
    }
    m=-1;
    k=-1;
    for(i=beg_ind;i<ind;i++)
    {
      if(a[i].cur_sum>m)
      {
        m=a[i].cur_sum;
        k=a[i].v;
      }
    }
    return k;
  }
  else
  {
    for(i=0;i<2*d+1;i++)
    {
      a[ind].v=de_code(n,&a[ind].s);
      a[ind].cur_sum=0;
      ind++;
    }
    for(i=beg_ind;i<ind;i++)
    {
      for(j=beg_ind;j<i;j++)
        if(a[j].v==a[i].v)
          a[i].cur_sum=a[j].cur_sum+1;
    }
    m=-1;
    k=-1;
    for(i=beg_ind;i<ind;i++)
    {
      if(a[i].cur_sum>m)
      {
        m=a[i].cur_sum;
        k=a[i].v;
      }
    }
    return k;
  }
}

/*int getsum()
{
  int i;
  int res;
  res=0;
  for(i=0;i<lg(n);i++)
    res+=a[i];
  return res;
}*/

int main()
{
  fi=fopen("decode.in","rt");
  fo=fopen("decode.out","wt");

  fscanf(fi,"%d%d",&n,&d);
  if(n==1)
  {
    fprintf(fo,"1\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  n--;
  fprintf(fo,"%d\n",decode(0,n)+1);
  

  fclose(fi);
  fclose(fo);
  return 0;
}
