  {$I-,Q-,R-,S-}
uses sysutils;
const infile = 'tore.in'; outfile = 'tore.out';
      maxn = 23; maxk = maxn*maxn;
type pt = record x,y: longint; end;
var t: array [0..maxn,0..maxn] of longint;
    p: array [1..maxk] of pt;
    can_x,can_y: array [1..maxk,1..maxn,1..maxk] of byte;
    num_x,num_y: array [1..maxk,1..maxn] of longint;
    pos_y: array [1..maxn] of longint;
    sty,stx,w,m,n,k,npy,best: longint;
    mx,ans_mx: array [0..maxk] of longint;
    start: double;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(m,n,k);
     fillchar(t,SizeOf(t),0);
     for i:=1 to k do begin
         read(p[i].x,p[i].y);
         t[p[i].x,p[i].y]:=i;
     end;
     best:=maxlongint;
     close(input);
end;

procedure gen_can;
var stx,sty,i,j: longint;
    nx,ny: longint;
begin
     fillchar(num_x,SizeOf(num_x),0);
     fillchar(num_y,SizeOf(num_y),0);
     for stx:=1 to m do begin
         for i:=1 to k do begin
             nx:=(p[i].x+stx) mod m;
             for j:=1 to k do
                 if p[j].x = nx then begin
                    inc(num_x[i,stx]); can_x[i,stx,num_x[i,stx]]:=j;
                 end;
         end;
     end;
     fillchar(can_y,SizeOf(can_y),0);
     for sty:=1 to n do begin
         for i:=1 to k do begin
             ny:=(p[i].y+sty) mod n;
             for j:=1 to k do
                 if p[j].y = ny then begin
                    inc(num_y[i,sty]); can_y[i,sty,num_y[i,sty]]:=j;
                 end;
         end;
     end;
end;

procedure rec_x(v: longint);
var i,cw: longint;
begin
     if (w > k div 2)or(w+k-v+1 < k div 2) then exit;
     if (v <= k)and(mx[v] > -1) then begin rec_x(v+1); exit; end;
     if v > k then begin
        if w = k div 2 then begin
           cw:=0;
           for i:=1 to k do
               if mx[i] = 1 then cw:=cw+p[i].x+p[i].y
                  else cw:=cw-p[i].x-p[i].y;
           if abs(cw) < best then begin
              best:=abs(cw); ans_mx:=mx;
           end;
        end;
        exit;
     end;
     mx[v]:=1; inc(w);
     if (mx[t[(p[v].x+stx) mod m,(p[v].y+sty) mod n]] = -1) then begin
        mx[t[(p[v].x+stx) mod m,(p[v].y+sty) mod n]]:=0;
        rec_x(v+1);
        mx[t[(p[v].x+stx) mod m,(p[v].y+sty) mod n]]:=-1;
     end;
     mx[v]:=-1; dec(w);
     rec_x(v+1);
end;

procedure solve;
var i,ww,j,q: longint;
begin
     start:=now;
     gen_can; fillchar(ans_mx,SizeOf(ans_mx),0);
     for stx:=1 to m do begin
         npy:=0;
         for sty:=1 to n do begin
             q:=k;
             for i:=1 to k do
                 if (num_x[i,stx] = 0)or(num_y[i,sty] = 0) then begin
                    dec(q);
                 end;
             if q >= k div 2 then begin
                inc(npy); pos_y[npy]:=sty;
             end;
         end;
         for j:=1 to npy do begin
             sty:=pos_y[j];
             for ww:=1 to k do mx[ww]:=-1;
             rec_x(1);
             if (now-start)*60*60*24 > 1.8 then exit;
             if best = 0 then exit;
         end;
     end;
end;

procedure done;
var k_res,i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     k_res:=0;
     for i:=1 to k do
         if ans_mx[i] = 1 then inc(k_res);
     if k_res = 0 then begin
        write(-1);
     end
        else begin
     writeln(k_res);
     for i:=1 to k do
         if ans_mx[i] = 1 then
            writeln(p[i].x,' ',p[i].y);
     end;
     close(output);
end;

begin
     init;
     if k mod 2 = 0 then solve;
     done;
end.
