{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_b;
Uses SysUtils;
const
  inpfile='tore.in';
  outfile='tore.out';
  nm=25;
  km=nm*nm;
  sec=24*60*60;
  tl=1.9;
type
  Coord = record
    x,y : LongInt;
  end;
var
  a : array [0..nm,0..nm] of LongInt;
  b : array [1..km] of Coord;
  col,rc : array [0..km] of LongInt;
  n,m,k,res,sum,dx,dy : LongInt;
  time : Extended;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(m,n,k);
  for i:=1 to k do begin
    read(b[i].x,b[i].y);
    a[b[i].x,b[i].y]:=i;
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  if res>=0 then
  for i:=1 to k do
    if rc[i]=1 then writeln(b[i].x,' ',b[i].y);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(col,sizeof(col),0);
  fillchar(rc,sizeof(rc),0);
end;
{}
Function Min(q,w : LongInt) : LongInt;
begin
  if q<w then min:=q else min:=w;
end;
{}
Function Count : LongInt;
var
  i,res : LongInt;
begin
  res:=0;
  for i:=1 to k do
    if col[i]=1 then inc(res,b[i].x+b[i].y)
                else dec(res,b[i].x+b[i].y);
  Count:=abs(res);
end;
{}
var
  ns : LongInt;
{}
Function Crd(x,dx,n : LongInt)  : LongInt;
begin
  x:=x+dx;
  while x>n do dec(x,n);
  while x<0 do inc(x,n);
  Crd:=x;
end;
{}
Procedure Paint(x,kol : LongInt);
var
  i : LongInt;
begin
  if kol=0 then begin
    if (now-time)*sec>=tl then Out;
    res:=k div 2; ns:=Count;
    if ns<sum then begin
      sum:=ns; rc:=col;
    end;
    exit;
  end;

  for i:=x to k-kol+1 do
    if (col[i]=0) and (col[a[Crd(b[i].x,dx,m),Crd(b[i].y,dy,n)]]=0) then begin
      col[i]:=1;
      col[a[Crd(b[i].x,dx,m),Crd(b[i].y,dy,n)]]:=2;
      Paint(i+1,kol-1);
      col[i]:=0;
      col[a[Crd(b[i].x,dx,m),Crd(b[i].y,dy,n)]]:=0;
    end;
end;
{}
Procedure Solve;
var
  i,j,kol : LongInt;
begin
  res:=-1; if odd(k) then Out;
  if k=0 then begin
    res:=0; Out;
  end;
  sum:=MaxLongInt;

  col[0]:=-1;
  kol:=k div 2;
  for i:=1 to k do
    for j:=1 to k do
      if i<>j then begin
        dx:=b[j].x-b[i].x;
        dy:=b[j].y-b[i].y;
        Paint(1,kol);
      end;
end;
{}
Begin
  time:=now;
  Init;
  Inp;
  Solve;
  Out;
End.