{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

{Alexey Timofeev }

const
	FILEIN='tore.in';
  FILEOUT='tore.out';
  PMAX=405;
type
	point=record
  	x,y:integer;
  end;
  pnode=^node;
  node=record
  	left,right:pnode;
    key:integer;
    j:integer;
  end;
var
	p:array[1..PMAX] of point;
	i_t1,i_t2,cur,s,s1,s2,s3,t2,is,i_ot,i_ot2,i,j,n,m,k,x,y,t,min:integer;
	a,b:array[1..PMAX] of integer;
	ot,ot2:array[1..PMAX] of integer;
procedure initdata;
begin
  fillchar(a,sizeof(a),0);
	fillchar(ot,sizeof(ot),0);
  i_ot:=0;
end;

procedure outdata(flag:boolean);
begin
	assign(output,FILEOUT);rewrite(output);
  if (flag) and (i_ot2=k div 2) then
  begin
    writeln(i_ot2);
  	for i:=1 to i_ot2 do writeln(p[ot2[i]].x,' ',p[ot2[i]].y);
  end else writeln(-1);
	close(output);
	halt;
end;

procedure readdata;
begin
	assign(input,FILEIN);reset(input);
  s:=0;
  read(m,n,k);
  for i:=1 to k do
  begin
  	read(p[i].x,p[i].y);
  	s:=s+p[i].x+p[i].y;
	end;
	if k mod 2<>0 then outdata(false);
end;

function game(x,y:integer):integer;
var
	q,root:pnode;

procedure maketree(var p:pnode;t,j:integer);
begin
  if p=nil then
  begin
  	new(p);
    p^.left:=nil;
    p^.right:=nil;
    p^.key:=t;
    p^.j:=j;
  	exit;
  end;
  if p^.key>t then maketree(p^.left,t,j)
  else maketree(p^.right,t,j);
end;

function get(p:pnode;t:integer):integer;
begin
  if p=nil then
  begin
    get:=0;
		exit;
  end;
	if p^.key=t then get:=p^.j
	else if p^.key>t then get:=get(p^.left,t)
  else get:=get(p^.right,t);
end;

procedure disposetree(var p:pnode);
begin
	if p=nil then  exit;
  disposetree(p^.left);
  disposetree(p^.right);
  dispose(p);
end;

begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  i_ot:=0;
  s1:=0;

  {make GRAF}
  root:=nil;
  for i:=1 to k do maketree(root,p[i].x*21+p[i].y,i);

  for i:=1 to k do
  begin
  	a[i]:=get(root,((p[i].x+x)mod m)*21+(p[i].y+y)mod n);
    if a[i]<>0 then b[a[i]]:=1;
  end;

  disposetree(root);

  {suicide if some left}
  for i:=1 to k do if (a[i]=0) and (b[i]=0) then
  begin
  	game:=-1;
    exit;
  end;

  {finding only ways}
  for i:=1 to k do
	if b[i]=0 then
  begin
    j:=i;
    t:=1;
    while a[j]>0 do
    begin
     	inc(t);
      if t mod 2=0 then
      begin
       	inc(i_ot);
        ot[i_ot]:=j;
       	s1:=s1+p[j].x+p[j].y;
      end else s1:=s1-p[j].x-p[j].y;
     	j:=a[j];
      b[j]:=2;
    end;
    s1:=s1-p[j].x-p[j].y;

    if t mod 2<>0 then
    begin
    	game:=-1;
      exit;
    end;

  end;

  {finding circles}
  for i:=1 to k do
  if b[i]=1 then
  begin
    j:=i;
    t:=1;
    s2:=0;

    while a[j]<>i do
    begin
    	inc(t);
      if t mod 2= 0 then
      begin
        s2:=s2+p[j].x+p[j].y;
      end else s2:=s2-p[j].x-p[j].y;
    	j:=a[j];
      b[j]:=3;
    end;
    s2:=s2-p[j].x-p[j].y;

    if t mod 2<>0 then
    begin
    	game:=-1;
      exit;
    end;

    if ((s1>=0) and (s2<=0)) or ((s1<=0) and (s2>=0)) then
		begin
      j:=i;
    	t:=1;
	    while a[j]<>i do
  	  begin
    		inc(t);
      	if t mod 2= 0 then
      	begin
        	inc(i_ot);
          ot[i_ot]:=j;
      	end;
    		j:=a[j];
      	b[j]:=3;
    	end;
      s1:=s1+s2
		end else
		begin
      j:=a[i];
    	t:=1;
	    while a[j]<>a[i] do
  	  begin
    		inc(t);
      	if t mod 2= 0 then
      	begin
        	inc(i_ot);
          ot[i_ot]:=j;
      	end;
    		j:=a[j];
      	b[j]:=3;
    	end;
      s1:=s1-s2
		end;

  end;

  game:=abs(s1);
end;

procedure solve;
begin
  min:=-1;
  for x:=0 to m-1 do
  	for y:=0 to n-1 do
    begin
      cur:=game(x,y);
      if (cur<>-1) and ((cur<min) or (min=-1)) then
      begin
				min:=cur;
      	ot2:=ot;
        i_ot2:=i_ot;
    	end;
		end;
	if min<>-1 then outdata(true) else outdata(false);
end;

begin
	initdata;
  readdata;
  solve;
end.