{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T+,V+,X+,Y+}
Program C;
Const
     InFile = 'magic.in';
     OutFile = 'magic.out';
     MMax = 500000;
     NMax = 1500;
Var
   F,M,N,K : LongInt;
   E : Array [0..NMax,0..NMax] Of LongInt;
   Res : Array [0..NMax,0..NMax] Of LongInt;
   Len : Array [0..NMax] Of LongInt;
   Q : Array [0..NMax] Of LongInt;

 Procedure Init;
  Begin
    Assign (Input,InFile); ReSet (Input);
    Assign (Output,OutFile); ReWrite (Output);
  End;

 Procedure ReadData;
  Var
     A,B,I : LongInt;
   Begin
     Read (N,M);
     Read (F);
     FillChar (E,SizeOf(E),0);
     For I:= 1 To M Do Begin
       Read (A,B);
       Inc (E[A,0]); E[A,E[A,0]]:= B;
       Inc (E[B,0]); E[B,E[B,0]]:= A;
     End;
   End;

 Procedure FillLen;
  Var
     Cur,I,J,QHead,QTail : LongInt;
  Begin
    For I:= 1 To N Do Len[I]:= -1;
    FillChar (Q,SizeOf(Q),0);
    QHead:= 2; QTail:= 1;
    Q[1]:= F;
    Len[F]:= 0;
    While QHead > QTail Do Begin
      Cur:= Q[QTail];
      Inc (QTail);
      For J:= 1 To E[Cur,0] Do
        If Len[E[Cur,J]] = -1 Then Begin
         Q[QHead]:= E[Cur,J];
         Inc (QHead);
         Len[E[Cur,J]]:= Len[Cur] + 1;
        End;
    End;
  End;

 Procedure Solve;
  Var
     A,B,I,J,II,JJ,INext,JNext : LongInt;
   Begin
     If N > NMax Then Begin
      Read (K);
      For I:= 1 To K Do Write (0,' ');
      Exit;
     End;

     For I:= 1 To N Do
       For J:= 1 To N Do Res[I,J]:= -1;
     For I:= 1 To N Do Res[I,I]:= 0;
     FillLen;

     For II:= 1 To N Do Begin
       I:= Q[II];
       For A:= 1 To E[I,0] Do
         If Len[E[I,A]] <= Len[I] Then Begin
          INext:= E[I,A];

          For JJ:= 1 To N Do Begin
            J:= Q[JJ];
            If (Len[J] <= Len[I]) Then
             If (Res[I,J] = -1) Or (Res[I,J] > Res[INext,J])
              Then Res[I,J]:= Res[INext,J];
          End;

          For JJ:= 1 To II Do Begin
            J:= Q[JJ];
            For B:= 1 To E[J,0] Do
              If Len[E[J,B]] <= Len[J] Then Begin
               JNext:= E[J,B];
               If (I = J) And (INext = JNext) Then Begin
                If (Res[I,J] = -1) Or (Res[I,J] > Res[INext,JNext] + 1)
                 Then Res[I,J]:= Res[INext,JNext] + 1
               End
               Else
                If (Res[I,J] = 1) Or (Res[I,J] > Res[INext,JNext])
                 Then Res[I,J]:= Res[INext,JNext];
              End;
          End;
         End;
     End;

     Read (K);
     For I:= 1 To K Do Begin
       Read (II,JJ);
       WriteLn (Res[II,JJ]);
     End;
   End;

 Procedure Done;
  Begin
    Close (Input);
    Close (Output);
  End;

 BEGIN
   Init;
   ReadData;
   Solve;
   Done;
 END.
