{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 50000,0,655360}

Const INPUTFILE='tore.in';
      OUTPUTFILE='tore.out';

Const MaxN=21;
      MaxK=MaxN*MaxN;
      MaxW=MaxK*MaxN div 4;

Const INF=MaxLongInt;

Type Real=Double;
     Point=record
     x,y:Longint;
     end;
     Chain=record
     B,R:Array[1..MaxK] of Integer;
     L:Integer;
     W:Longint;
     end;

var a:Array[1..MaxK+2] of Point;
    b,c:Array[1..MaxK] of Integer;

    N,M,K:Longint;
    Ans:Array[1..MaxK] of Longint;
    Num:Longint;
    i,j:Longint;

Function CmpA(i,j:Longint):Shortint;
begin
if a[i].y<a[j].y then
  CmpA:=-1
else if a[i].y>a[j].y then
  CmpA:=1
else
begin
  if a[i].x<a[j].x then
    CmpA:=-1
  else if a[i].x>a[j].x then
    CmpA:=1
  else
    CmpA:=0;
end;
end;

Procedure QSort(L,R:Longint);
var i,j:Longint;
begin
i:=L;
j:=R;
a[K+1]:=a[(i+j) div 2];
Repeat
  While CmpA(i,K+1)=-1 Do Inc(i);
  While CmpA(j,K+1)=1 Do Dec(j);
  if i<=j then
  begin
    a[K+2]:=a[i];
    a[i]:=a[j];
    a[j]:=a[K+2];
    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if L<j then QSort(L,j);
end;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N,M,K);
for i:=1 to K do
  Read(a[i].x,a[i].y);
Close(Input);
QSort(1,K);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writeln(Answer);
for i:=1 to Answer do
  Writeln(a[Ans[i]].x,' ',a[Ans[i]].y);
Close(Output);
Halt;
end;

Function FindPoint(x,y:Longint):Longint;
var L,R,mid:Longint;
    f:Longint;
begin
L:=1;
R:=K;
f:=0;
a[K+1].x:=x; a[K+1].y:=y;
While L<R Do
begin
  mid:=(L+R) div 2;
  if CmpA(mid,K+1)=1 then
    R:=mid
  else if CmpA(mid,K+1)=-1 then
    L:=mid+1
  else
  begin
    f:=mid;
    Break;
  end;
end;
if CmpA(L,K+1)=0 then f:=L;
FindPoint:=f;
end;

var f,Blue:Array[1..MaxK] of Boolean;
    Chains:Array[1..MaxK] of Chain;
    W:Array[0..MaxW,1..MaxN] of Boolean;
    Inv:Array[1..MaxK] of Boolean;
    Take:Array[1..MaxK] of Longint;
    NumC:Integer;

Procedure Solve;
var g,h,l,v:Longint;
    Cur:Longint;
    dx,dy:Longint;
    lt:Longint;
begin
g:=-1;
for dx:=0 to M-1 do
for dy:=0 to N-1 do
begin
  FillChar(b,SizeOf(b),0);
  FillChar(c,SizeOf(c),0);
  for i:=1 to K do
  begin
    b[i]:=FindPoint((a[i].x+dx) mod M,(a[i].y+dy) mod N);
    if b[i]>0 then c[b[i]]:=i;
  end;

  Cur:=0;
  NumC:=0;
  FillChar(Chains,SizeOf(Chains),0);
  FillChar(f,SizeOf(f),False);
  FillChar(Blue,SizeOf(Blue),False);

  for i:=1 to K do
  begin
    if (c[i]=0) AND (f[i]=False) then
    begin
      j:=i;
{      While c[j]>0 Do j:=c[j];}
      h:=1;
      Inc(NumC);
      lt:=0;
      While b[j]>0 Do
      begin
        Inc(lt);
        Chains[NumC].B[lt]:=j;
        Chains[NumC].R[lt]:=b[j];
        Blue[j]:=True;
        f[j]:=True;
        Inc(Chains[NumC].W,a[j].x+a[j].y);
        Dec(Chains[NumC].W,a[b[j]].x+a[b[j]].y);
        j:=b[j];
        Inc(h);
        f[j]:=True;
        if b[j]>0 then
        begin
          j:=b[j];
          Inc(h);
        end;
      end;
{      Inc(Cur,Chains[NumC].W);}
      Chains[NumC].L:=lt;
      if Odd(h) then
      begin
        Cur:=INF;
        Break;
      end;
    end;
    if Cur=INF then Break;
  end;
  if Cur=INF then Continue;

  for i:=1 to K do
  begin
    if f[i]=False then
    begin
      j:=i;
      h:=1;
      f[j]:=True;
      While f[b[j]]=False Do
      begin
        f[j]:=True;
        j:=b[j];
        Inc(h);
      end;
      f[j]:=True;
      if Odd(h) then
      begin
        Cur:=INF;
        Break;
      end;
      Inc(NumC);
      j:=i;
      lt:=Chains[NumC].L;
      While (lt=Chains[NumC].L) OR (j<>i) Do
      begin
        Inc(Chains[NumC].w,a[j].x+a[j].y);
        Inc(lt);
        Chains[NumC].B[lt]:=j;
        j:=b[j];
        Chains[NumC].R[lt]:=j;
        Dec(Chains[NumC].w,a[j].x+a[j].y);
        j:=b[j];
      end;
      Chains[NumC].L:=lt;
    end;
  end;

  if Cur=INF then Continue;
{  if (g=-1) OR (g>Cur) then
  begin}
    FillChar(W,SizeOf(W),False);
    w[Abs(Chains[1].W),1]:=True;
    for i:=2 to NumC do
    for j:=0 to MaxW do
    begin
      if (w[Abs(j-Abs(Chains[i].W)),i-1]=True) OR ((j+Abs(Chains[i].W)<=MaxW) AND (w[j+Abs(Chains[i].W),i-1]=True)) then
        w[j,i]:=True;
    end;
    for j:=0 to MaxW do
      if w[j,NumC]=True then Break;
    if (g=-1) OR (g>j) then
    begin
      g:=j;
      i:=NumC;
      FillChar(Inv,SizeOf(Inv),False);
      While i>1 Do
      begin
        if (j+Abs(Chains[i].W)<=MaxW) AND (w[j+Abs(Chains[i].W),i-1]=True) then
        begin
          Take[i]:=-i;
          if Chains[i].W<0 then Take[i]:=-Take[i];
          j:=j+Abs(Chains[i].W);
          Dec(i);
        end
        else if (w[Abs(j-Abs(Chains[i].W)),i-1]=True) then
        begin
          if j-Abs(Chains[i].W)>=0 then
          begin
            Take[i]:=i;
            if Chains[i].W<0 then Take[i]:=-Take[i];
            j:=j-Abs(Chains[i].W);
            Dec(i);
          end
          else
          begin
            Take[i]:=i;
            if Chains[i].W<0 then Take[i]:=-Take[i];
            j:=Abs(Chains[i].W)-j;
            Inv[i]:=True;
            Dec(i);
          end;
        end
        else
        begin
          Writeln('Fignq vyshla...');
          Break;
        end;
      end;
      Take[1]:=1;
      if Chains[1].W<0 then Take[1]:=-Take[1];
      for i:=N downto 1 do
        if Inv[i]=True then
        begin
          for h:=1 to i-1 do
            Take[h]:=-Take[h];
        end;
      Num:=0;
      for i:=1 to N do
      begin
        if Take[i]>0 then
        begin
          for j:=1 to Chains[i].L do
          begin
            Inc(Num);
            Ans[Num]:=Chains[i].B[j];
          end;
        end
        else
        begin
          for j:=1 to Chains[i].L do
          begin
            Inc(Num);
            Ans[Num]:=Chains[i].R[j];
          end;
        end;
      end;
    end;
 { end;}
end;
if g=-1 then Num:=-1;
FWrite(Num);
end;

begin
FRead;
Solve;
end.