const
  MaxCLen = 32*21;
  MegaSeed = 667;

var
  fi, fo: text;
  n,d,x: longint;

procedure MakePerm(var a: array of integer;l:integer;seed:longint);
var i,j,c: integer;
begin
  RandSeed:=seed;
  For i:=0 to l-1 do begin
    a[i]:=i;
  end;
  For i:=0 to l-1 do begin
    j:=random(l-i);
    c:=a[i];
    a[i]:=a[i+j];
    a[i+j]:=c;
  end;
end;

var
  clen,len: integer;
  RepNum: integer;
  bX: array[0..MaxCLen-1] of byte;
  code: array[0..MaxCLen-1] of byte;
  a: array[0..MaxCLen-1] of integer;

function GetRepNum:integer;
var res: integer;
begin
  res:=d-1;
  if res<3 then res:=3;
  if not odd(res) then inc(res);
  GetRepNum:=res;
end;

procedure EnCode;
var i: longint;
begin
  dec(x);
  for i:=0 to len-1 do begin
    bX[i]:=x mod 2;
    x:=x shr 1;
  end;

  RepNum:=GetRepNum;
  clen:=len*RepNum;
  For i:=0 to clen-1 do
    bX[i]:=bX[i mod len];
  MakePerm(a,clen,MegaSeed);
  For i:=0 to clen-1 do
    code[i]:=bX[a[i]];
end;



procedure Solve;
begin
  Encode;
end;

procedure Init;
var i,t: longint;
begin
  Assign(fi,'code.in');
  Assign(fo,'code.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,n,d,x);
  t:=1;
  len:=0;
  while t<n do begin
    inc(len);
    t:=t*2;
  end;

end;

procedure Done;
var i: integer;
begin
  For i:=0 to clen-1 do
    Write(fo,code[i]);
  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
