{$I-,Q-,R-,S-}
Const
  FIn  = 'decode.in';
  FOut = 'decode.out';
{---------------------------------------------------------------------------}
Var
  Input,Output:TEXT;
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxD=10;
  Zero=Ord('0');
  MaxLen=30;

Var
  N,D,X:LongInt;
  ColCopy,Len:LongInt;

Function Gen(A:LongInt):String;
Var Out:String; R:LongInt;
begin
  Out:='';
  R:=0;
  A:=A-1;
  while A<>0 do
  begin
    Out:=Chr(Zero+A mod 2)+Out;
    A:=A div 2;
    R:=R+1;
  end;
  If Len<>-1 then
    For R:=R+1 to Len do Out:='0'+Out;
  Gen:=Out;
end;

Const
  ColSha=4*3*2*1;
  Sha:array[1..ColSha,1..4]of Byte=(
      (1,2,3,4),(1,2,4,3),(1,3,2,4),(1,3,4,2),(1,4,2,3),(1,4,3,2),
      (2,1,3,4),(2,1,4,3),(2,3,1,4),(2,3,4,1),(2,4,1,3),(2,4,3,1),
      (3,1,2,4),(3,1,4,2),(3,2,1,4),(3,2,4,1),(3,4,1,2),(3,4,2,1),
      (4,1,2,3),(4,1,3,2),(4,2,1,3),(4,2,3,1),(4,3,1,2),(4,3,2,1));
Var
  NL,_NL:array[1..MaxLen]of Byte;
  L,_L:String;
  S,NumSha:LongInt;
Procedure Put;
Var R:Byte;
begin
  _NL:=NL;
  _L:=L;
  For R:=1 to 4 do
  begin
    _L[S+R]:=L[S+Sha[NumSha,R]];
    _NL[S+R]:=NL[S+Sha[NumSha,R]];
  end;
  {?!?!}
  L:=_L;
  NL:=_NL;
end;
{------------------}

Var
  Ch:Char;
  Mas:array[1..MaxLen,0..1]of LongInt;
  R,R1:LongInt;

begin
  Init;
  {}
  ReadLn(Input,N,D);
  ColCopy:=D+1;
  Len:=Length(Gen(N));
  {}
  If Len<4 then
  begin
    For R:=1 to 2*D+1 do
      For R1:=1 to Len do
      begin
        Read(Input,Ch);
        Inc(Mas[R1,Ord(Ch)-Zero]);
      end;
  end else
  begin
    L:=Gen(1);
    For R:=1 to Len do NL[R]:=R;
    {}
    S:=Len;
    NumSha:=0;
    For R:=1 to ColCopy do
    begin
      Dec(S,4); If S<0 then S:=Len-4;
      Inc(NumSha); If NumSha=ColSha+1 then NumSha:=1;

      Put;
      For R1:=1 to Len do
      begin
        Read(Input,Ch);
        Inc(Mas[_NL[R1],Ord(Ch)-Zero]);
      end;
    end;
  end;
  {}
  X:=0;
  For R:=1 to Len do
    if Mas[R,0]>Mas[R,1] then X:=X*2+0 else X:=X*2+1;
  X:=X+1;
  {}
  WriteLn(Output,X);
  {}
  Done;
end.