const
     FileIn='code.in';
     FileOut='code.out';
     MaxShift=30;
     MaxN=1 shl MaxShift;
     MaxX=MaxN;
     MaxD=10;
     MaxAnswerLength=(2*MaxD+1)*(MaxShift+1);
var
   N, D, X: LongInt;
   AnswerLength: LongInt;
   CurrentMaxShift: LongInt;
   Answer: array [1..MaxAnswerLength] of Byte;

procedure CalcSmth;
begin
     CurrentMaxShift:=0;
     while 1 shl CurrentMaxShift<N-1
           do Inc (CurrentMaxShift);
     AnswerLength:=CurrentMaxShift*(2*D+1);
end;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, N, D, X);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NBit: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NBit:=1 to AnswerLength
         do Write (F, Answer [NBit]);
     Close (F);
end;

procedure Solve;
var
   Shift: LongInt;
   Bits: array [0..MaxShift] of Byte;
   NIteration: LongInt;
   AnswerBitIndex: LongInt;
begin
     CalcSmth;

     for Shift:=0 to CurrentMaxShift-1
         do Bits [Shift]:=Byte ((X-1) and (1 shl Shift)<>0);
     AnswerBitIndex:=1;
     for Shift:=0 to CurrentMaxShift-1
         do for NIteration:=1 to 2*D+1
                do begin
                   Answer [AnswerBitIndex]:=Bits [Shift];
                   Inc (AnswerBitIndex);
                end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
