  {$I-,Q-,R-,S-}
const maxn=100000;
type mas=array[1..maxn] of longint;
var n,d,x,k,len,nor,dmax:longint;
    a,b,c,ee,rr:mas;

Function getstep:longint;
var i,res:longint;
begin
     i:=n-1;
     res:=0;
     while i<>0 do
     begin
          inc(res);
          i:=i shr 1;
     end;
     getstep:=res;
end;

Procedure init;
var i,j:longint;
    ch:char;
begin
     assign(input,'decode.in');
     reset(input);
     assign(output,'decode.out');
     rewrite(output);
     read(n,d);
     if n=1 then
     begin
      writeln(1);
      close(input);
      close(output);
      halt;
     end;
     while not eof do
     begin
          read(ch);
          if ch in['0','1'] then
          begin
               inc(len);
               c[len]:=ord(ch)-48;
          end;
     end;
     k:=getstep;
     for i:=1 to k do a[i]:=c[i];
end;

Function getvec(const L,R:longint; var cnt:longint):longint;
var i,j,med,cc,c1:longint;
begin
     if l>r then exit;
     if (l=r) then
     begin
          getvec:=a[l];
          exit;
     end;
     med:=(l+r) div 2;
     cc:=cnt+1;
     c1:=cc;
     inc(cnt);
     b[cc]:=getvec(l,med,cnt) mod 2;
     inc(cnt);
     cc:=cnt;
     b[cc]:=getvec(med+1,r,cnt) mod 2;
     getvec:=b[c1]+b[cc];
end;

Function getvec3(const L,R:longint; var cnt:longint):longint;
var i,j,med,cc,c1:longint;
begin
   if l>r then exit;
     if (l=r) then
     begin
          getvec3:=ee[l];
          exit;
     end;
     med:=(l+r) div 2;
     cc:=cnt+1;
     c1:=cc;
     inc(cnt);
     rr[cc]:=getvec3(l,med,cnt) mod 2;
     inc(cnt);
     cc:=cnt;
     rr[cc]:=getvec3(med+1,r,cnt) mod 2;
     getvec3:=rr[c1]+rr[cc];
end;

Function getvec2(const L,R:longint; var cnt:longint):longint;
var i,j,med,cc,c1,q:longint;
begin
   if l>r then exit;
     if (l=r) then
     begin
          ee[l]:=b[cnt];
          getvec2:=a[l];
          exit;
     end;
     med:=(l+r) div 2;
     cc:=cnt+1;
     c1:=cc;
     inc(cnt);
     q:=getvec2(l,med,cnt) mod 2;
     inc(cnt);
     cc:=cnt;
     q:=getvec2(med+1,r,cnt) mod 2;
     getvec2:=b[c1]+b[cc];
end;

Procedure print(const q:longint);
begin
     writeln(q+1);
     close(input);
     close(output);
     halt;
end;

Procedure deconvert(const a:mas);
var i,j:longint;
begin
     for i:=k downto 1 do
     begin
          x:=x+a[i]*(1 shl (k-i));
     end;
end;

Procedure provnorm;
var q,i,j,numerr,cc:longint;
begin
     q:=1;
     b[1]:=getvec(1,k,q);
     q:=k*2-1;
     dmax:=(len-k) div q;
     numerr:=0;
     cc:=k+1;
     for i:=1 to dmax do
     begin
          for j:=1 to q do
          begin
               if c[cc]<>b[j] then inc(numerr);
               inc(cc);
          end;
     end;
     if numerr<=d then
     begin
          deconvert(a);
          print(x);
     end;
end;

Procedure provnenorm;
var i,j,cc,q,numerr,h,qq:longint;
begin
     cc:=(k*2)-1;
     for i:=1 to dmax do
     begin
          fillchar(b,sizeof(b),0);
          for j:=1 to (k*2)-1 do
          begin
               b[j]:=c[(i-1)*cc+j+k];
          end;
          q:=1;
          getvec2(1,k,q);
          numerr:=0;
          for j:=1 to k do if ee[j]<>a[j] then inc(numerr);
          q:=1;
          rr[1]:=getvec3(1,k,q) mod 2;
          q:=k*2-1;
          qq:=k+1;
          for j:=1 to dmax do
          begin
               for h:=1 to q do
               begin
                    if rr[h]<>c[qq] then inc(numerr);
                    inc(qq);
               end;
          end;
          if numerr<=d then
          begin
               deconvert(ee);
               print(x);
          end;
     end;
end;

Procedure solve;
var q:longint;
begin
     provnorm;
     provnenorm;
end;

begin
     init;
     solve;
     writeln('Cheto ne raskodirovalos:((');
     close(input);
     close(output);
end.
