{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Type Tip=LongInt;
  Const Inp='code.in';
        Out='code.out';
        Max=5000;
        Help : Array [1..31] Of Int64=(1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,
        65536,131072,262144,524288,1048576,2097152,4194304,8388608,16777216,33554432,67108864,134217728,
        268435456,536870912,1073741824);
  Var N,D,X : Tip;
      Answer : Array [0..Max] Of Tip;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
Begin
  FIllChar(Answer,SizeOf(Answer),0);
  Read(N,D,X);
  Dec(N);
  Dec(X);
End;

Procedure Solve;
  Var I,J,Count : LongWord;
      HelpCount,K : Tip;
Begin
  Count :=0;
  While Help[Count+1]<=N Do
    Inc(Count);
  HelpCount :=0;
  While Help[HelpCount+1]<=Count Do
    Inc(HelpCount);
  For I :=1 To Count Do
    If (1 Shl (Count-I)) And X<>0 Then
      Answer[I] :=1;
  Answer[0] :=Count;
  For I :=1 To HelpCount Do
    For J :=1 To Count Do
      If J And (1 Shl (I-1))>0 Then
        Begin
          Answer[Count+I] :=(Answer[Count+I]+Answer[J]) Mod 2;
          Answer[Count+HelpCount+1] :=(Answer[Count+HelpCount+1]+Answer[J]) Mod 2;
        End;
  Inc(Answer[0],HelpCount+1);
  If D=0 Then
    Begin
      For I :=1 To Count Do
        Write(Answer[I]);
      Exit;
    End;
  If D=1 Then K :=1
  Else K :=D+1;
  For J :=1 To K Do
    For I :=1 To Answer[0] Do
      Write(Answer[I]);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
