{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
  Type Tip=LongInt;
  Const Inp='tore.in';
        Out='tore.out';
        MaxK=400;
        Max=20;
  Var M,N,K : Tip;
      Points : Array [1..MaxK] Of Record X,Y : Tip; End;
      InAnswer,HelpIn : Array [1..MaxK] Of Boolean;
      Map : Array [0..Max,0..Max] Of Tip;
      InTo : Array [0..Max,0..Max] Of Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Tip;
Begin
  Fillchar(Map,SizeOf(Map),0);
  Read(M,N,K);
  For I :=1 To K Do
    Begin
      Read(Points[I].X,Points[I].Y);
      Map[Points[I].X,Points[I].Y] :=I;
    End;
End;

Function GetX(Const X,DX : Tip) : Tip;
  Var Help : Tip;
begin
  Help :=X+Dx;
  If Help<0 Then Inc(Help,M);
  GetX :=Help;
End;

Function GetY(Const Y,DY : Tip) : Tip;
  Var Help : Tip;
begin
  Help :=Y+DY;
  If Help<0 Then Inc(Help,N);
  GetY :=Help;
End;

Procedure Solve;
  Var MayAnswer,Cool : Boolean;
      I,J,A,DX,DY,Min,NowX,NowY,Z,NowSum,COunt : Tip;
      Use : Array [1..MaxK] Of Tip;
Begin
  If Odd(K) Then
    Begin
      WriteLn(-1);
      Exit;
    End;
  Min :=maxLongInt;
  MayAnswer :=False;
  FillChar(InAnswer,SizeOf(InAnswer),0);
  For I :=1 To K Do
    For J :=1 To K Do
      If I<>J Then
        Begin
          DX :=Points[I].X-Points[J].X;
          DY :=Points[I].Y-Points[J].Y;
          FillChar(Use,SizeOf(Use),255);
          FillChar(InTo,SizeOf(InTo),0);
          COunt :=0;
          For A :=1 To K Do
            If (Map[GetX(Points[A].X,Dx),GetY(Points[A].Y,DY)]<>0) Then
               Begin
                 Use[Map[Points[A].X,Points[A].Y]] :=0;
                 Use[Map[GetX(Points[A].X,Dx),GetY(Points[A].Y,DY)]] :=A;
                 InTo[GetX(Points[A].X,Dx),GetY(Points[A].Y,DY)] :=True;
                 HelpIn[Map[GetX(Points[A].X,Dx),GetY(Points[A].Y,DY)]] :=True;
                 Inc(Count);
               End;
          Cool :=True;
          For A:=1 To K Do
            If Use[Map[Points[A].X,Points[A].Y]]=-1 Then
              Begin
                Cool :=False;
                Break;
              End;
          If Not Cool Then Break;
          MayAnswer :=True;
          FillChar(Use,SizeOf(Use),255);
          FillChar(helpIn,Sizeof(helpIn),0);
          NowSum :=0;
          For A :=1 To K Do
            If (Use[A]=-1) And (Not(InTo[Points[A].X,Points[A].Y]) Or (Count=K)) Then
              Begin
                HelpIn[Map[Points[A].X,Points[A].Y]] :=True;
                Use[Map[Points[A].X,Points[A].Y]] :=1;
                Inc(NowSum,Points[A].X+Points[A].Y);
                NowX :=GetX(Points[A].X,Dx);
                NowY :=GetY(Points[A].Y,DY);
                Use[Map[NowX,NowY]] :=1;
                Dec(NowSum,NowX+NowY);
                NowX :=GetX(NowX,Dx);
                NowY :=GetY(NowY,DY);
                Z :=2;
                While (Map[NowX,NowY]<>0) And (Use[Map[NowX,NowY]]=-1) Do
                  Begin
                    Use[Map[NowX,NowY]] :=1;
                    Z :=3-Z;
                    If Z=1 Then
                      Begin
                        HelpIn[Map[NowX,NowY]] :=True;
                        Inc(NowSum,NowX+NowY);
                      End
                    Else
                      Dec(NowSum,NowX+NowY);
                    NowX :=GetX(NowX,Dx);
                    NowY :=GetY(NowY,DY);
                    If (Z=1) And (Map[NowX,NowY]=0) Then
                      Begin
                        MayAnswer :=false;
                        Break;
                      End;
                  End;
                If Not MayAnswer Then Break;
              End;
          If Abs(NowSum)<Min Then
            Begin
              Min :=Abs(NowSum);
              InAnswer :=HelpIn;
            End;
        End;
  If MayAnswer Then
    Begin
      WriteLn(K Div 2);
      For I:=1 To K Do
        If InAnswer[I] Then
          WriteLn(Points[I].X,' ',Points[I].Y);
    End
  Else
    WriteLn(-1);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
