program TaskA;
const MAXN = 100000;
      infile = 'docs.in';
      outfile = 'docs.out';
      Inf=MAXLONGINT;
type t1 = record
  A, B:longint;
end;
     t2 = record
  C, D:longint;
end;
     t3 = record
  val, l, r, vali, p:longint;
end;
var ar:array[0..MAXN]of t1;
    pos:array[1..MAXN]of longint;
    sob:array[1..MAXN]of t2;
    res:array[1..MAXN]of longint;
    tree:array[1..2*MAXN]of t3;
    N, M, tek:longint;

procedure inp;
var i:longint;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N);
  for i:=1 to N do read(ar[i].A, ar[i].B);
  read(M);
  for i:=1 to M do read(sob[i].C, sob[i].D);
end;

procedure HeapSort;
var i, heapsize:longint;

function left  (i:longint):longint; begin left:=2*i; end;
function right (i:longint):longint; begin right:=2*i+1; end;
function parent(i:longint):longint; begin parent:=i div 2; end;

procedure swap(var a, b:t1);
var t:t1;
begin
  t:=a; a:=b; b:=t;
end;

procedure sw(var a, b:longint);
var t:longint;
begin
  t:=a; a:=b; b:=t;
end;

procedure Heapify(i:longint);
var l, r, largest:longint;
begin
  l:=left(i); r:=right(i); largest:=i;
  if (l<=heapsize)and(ar[l].A>ar[i].A) then largest:=l;
  if (r<=heapsize)and(ar[r].A>ar[largest].A) then largest:=r;
  if (largest<>i) then begin swap(ar[i], ar[largest]); sw(pos[i], pos[largest]); Heapify(largest); end;
end;

procedure BuildHeap;
var i:longint;
begin
  heapsize:=N;
  for i:=heapsize div 2 downto 1 do Heapify(i);
end;

begin
  BuildHeap;
  for i:=N downto 2 do
  begin
    swap(ar[i], ar[1]);
    sw(pos[i], pos[1]);
    dec(heapsize);
    Heapify(1);
  end;
end;

function search1(v:longint):longint;
var i, m, l, r:longint;
begin
  i:=N; l:=1; r:=N;
  while true do
  begin
    m:=(l+r)div 2;
    if (ar[m].A>=v) then begin r:=m; i:=m; end else l:=m+1;
    if l>=r then break;
  end;
  if v>ar[i].A then search1:=-1 else search1:=i;
end;

function search2(v:longint):longint;
var i, m, l, r:longint;
begin
  i:=1; l:=1; r:=N;
  while true do
  begin
    m:=(l+r)div 2+(l+r)mod 2;
    if (ar[m].A>v) then r:=m-1 else begin l:=m; i:=m; end;
    if l>=r then break;
  end;
  if v<ar[i].A then search2:=-1 else search2:=i;
end;

function mn(a, b:longint):longint;
begin
  if a<b then mn:=a else mn:=b;
end;

function min(t, a, b, l, r:longint):longint;
var m, min1, min2:longint;
begin
  if (a=l)and(b=r) then begin min:=tree[t].vali; exit; end;
  m:=(l+r)div 2;
  if (a>=l)and(a<=m)and(b>=l)and(b<=m) then min:=min(tree[t].l, a, b, l, m)
  else if (a>=m+1)and(a<=r)and(b>=m+1)and(b<=r) then min:=min(tree[t].r, a, b, m+1, r)
  else begin
    min1:=min(tree[t].l, a, m, l, m);
    min2:=min(tree[t].r, m+1, b, m+1, r);
    if ar[min1].B<ar[min2].B then min:=min1 else min:=min2;
  end;
end;

procedure make(i, v:longint);
var l, r, m, t:longint;
begin
  l:=1; r:=N; t:=1;
  while l<r do
  begin
    m:=(l+r)div 2;
    if (l<=i)and(m>=i) then begin t:=tree[t].l; r:=m; end else begin t:=tree[t].r; l:=m+1; end;
  end;
  tree[t].val:=v; tree[t].vali:=i; t:=tree[t].p;
  while t>0 do
  begin
    tree[t].val:=mn(tree[tree[t].l].val, tree[tree[t].r].val);
    if tree[t].val=tree[tree[t].l].val then tree[t].vali:=tree[tree[t].l].vali else tree[t].vali:=tree[tree[t].r].vali;
    t:=tree[t].p;
  end;
end;

function BTree(i, j:longint):longint;
var k, m:longint;
begin
  k:=tek; tree[k].val:=Inf; tree[k].vali:=0;
  if i=j then begin tree[k].l:=0; tree[k].r:=0; BTree:=k; inc(tek); exit; end;
  m:=(i+j)div 2;
  inc(tek);
  tree[k].l:=BTree(i, m); tree[k].r:=BTree(m+1, j);
  tree[tree[k].l].p:=k; tree[tree[k].r].p:=k;
  BTree:=k;
end;

procedure run;
var a, b, i, j:longint;
begin
  for i:=1 to N do pos[i]:=i;
  HeapSort; tek:=1; BTree(1, N); tree[1].p:=0;
  for i:=1 to N do make(i, ar[i].B);
  for i:=1 to M do
  begin
    a:=search1(sob[i].C);
    b:=search2(sob[i].D);
    if (a=-1)or(b=-1)or(a>b) then begin write('BOTVA'); exit; end;
    j:=min(1, a, b, 1, N); if ar[j].B=Inf then begin write('BOTVA'); exit; end;
    res[i]:=j; ar[j].B:=inf; make(j, inf);
  end;
  for i:=1 to M do write(pos[res[i]], ' ');
end;

procedure outp;
begin
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
