program TaskC;
const MAXP = 100;
      MAXL = 200001;
      infile = 'calc.in';
      outfile = 'calc.out';
type Tlexem = (_num, _var, _plus, _minus, _mul, _div, _open, _close, _end);
var vr:array['c'..'z']of longint;
    st:array[1..MAXL] of char;
    p, N, M:integer;
    cur:Tlexem;
    val:longint;
    len, pos:longint;

function md(a:longint):longint;
begin
  md:=(a+100*p)mod p;
end;

function mdv(a, b:longint):longint;
begin
  mdv:=md(a div b);
end;

procedure inp;
var i:integer;
    ch, t:char;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  readln(p); readln(N);
  for i:=1 to N do readln;
  readln(M);
  for i:=1 to M do
  begin
    read(ch); read(t); readln(vr[ch]);
  end; len:=1;
  while not eof(input) do begin read(st[len]); inc(len); end;
  st[len]:=#200;
end;

function expr:longint; forward;
function slag:longint; forward;
function mul:longint; forward;

procedure next;
begin
  case st[pos] of
    '+': cur:=_plus;
    '-': cur:=_minus;
    '*': cur:=_mul;
    '/': cur:=_div;
    '(': cur:=_open;
    ')': cur:=_close;
    'c'..'z': begin cur:=_var; val:=vr[st[pos]]; end;
    '0'..'9': begin
                cur:=_num; val:=ord(st[pos])-48; inc(pos);
                while ('0'<=st[pos])and(st[pos]<='9') do
                  val:=(10*val+ord(st[pos])-48)mod p;
                dec(pos);
              end;
    #200: cur:=_end;
  end;
  inc(pos);
end;

function expr:longint;
var res:longint;
    tmp:Tlexem;
begin
  res:=slag;
  while (cur=_plus)or(cur=_minus) do begin
    tmp:=cur;
    next;
    if tmp=_plus then res:=md(res+slag) else res:=md(res-slag);
  end;
  expr:=res;
end;

function slag:longint;
var res:longint;
    tmp:Tlexem;
begin
  res:=mul;
  while (cur=_mul)or(cur=_div) do begin
    tmp:=cur;
    next;
    if tmp=_mul then res:=md(res*mul) else res:=mdv(res, mul);
  end;
  slag:=res;
end;

function mul:longint;
var res:longint;
    tmp:Tlexem;
begin
  case cur of
    _num: begin mul:=val; next; exit; end;
    _var: begin mul:=val; next; exit; end;
    _open: begin next; mul:=expr; next; exit; end;
    _minus: begin next; mul:=-mul(); exit; end;
  end;
end;

procedure run;
begin
  pos:=1; next;
  write(expr);
end;

procedure outp;
begin
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
