{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 10000000, 30000000}

const
  coutfile = 'calc.out';
  cinfile = 'calc.in';

  pmax = 100;

type
  int = longint;
  real = extended;

  str = string[40];

var
  n, k : int;
  ans : int;

  p : int;
  o : array [0..pmax] of int;

  bo : array [chr(0)..chr(255)] of int;
  bop : array [chr(0)..chr(255)] of str;

  up : array [chr(0)..chr(255)] of str;

  vr : array ['a'..'z'] of int;
  lexm : char;

  uprior : array [1..20] of boolean;

procedure init;
begin
  fillchar(uprior,sizeof(uprior),0);
  fillchar(o,sizeof(o),0);
  fillchar(bo,sizeof(bo),0);
  fillchar(bop,sizeof(bop),0);
  fillchar(up,sizeof(up),0);
  fillchar(vr,sizeof(vr),0);
end;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
end;

function expr(var s : str;var l : integer) : integer;
var
  za, zb, t : integer;

  function lex : char;
  var
    ch : char;
  begin
    if l = 0 then
    begin
      read(ch);
      while ch = ' ' do read(ch);
    end else
    begin
      ch:= s[l];
      inc(l);
    end;
    lex:= ch;
    lexm:= ch;
  end;

  function un : integer;
  var
    x : integer;
    c : char;
  begin
    c:= lex;
    if c in ['0'..'9'] then
    begin
      x:= ord(c) - ord('0');
      c:= lex;
      if c in ['0'..'9'] then
      begin
        x:= x*10 + ord(c) - ord('0');
        lex;
      end;
      un:= x;
      exit;
    end;
    if c in ['a'..'z'] then
    begin
      un:= vr[c];
      lex;
      exit;
    end;
    case c of
      '-' : un:= p-un;
      '+' : un:= un;
      '(' : begin
              un:= expr(s,l);
              lex;
            end;
      else begin
        za:= vr['a'];
        vr['a']:= expr(s,l);
        t:= 1;
        un:= expr(up[c],t);
        vr['a']:= za;
      end;
    end;
  end;

  function pods(pr : integer) : integer;
  var
    x : integer;
    op : char;
  begin
    while not uprior[pr] do inc(pr);
    if pr = 20 then
    begin
      x:= un;
      pods:= x;
      exit;
    end;
    x:= pods(pr+1);
    op:= lexm;
    while bo[op] = pr do
    begin
      case op of
        '+' : x:= (x + pods(pr+1)) mod p;
        '-' : x:= (x + p - pods(pr+1)) mod p;
        '*' : x:= (x * pods(pr+1)) mod p;
        '/' : x:= (x * o[pods(pr+1)]) mod p;
        else
        begin
          za:= vr['a'];
          zb:= vr['b'];
          vr['a']:= x;
          vr['b']:= pods(pr+1);
          t:= 1;
          x:= expr(bop[op],t);
          vr['a']:= za;
          vr['b']:= zb;
        end;
      end;
      op:= lexm;
    end;
    pods:= x;
  end;

begin
  expr:= pods(1);
end;

procedure solve;
var
  i, j : int;
  s : str;
  t : integer;
begin
  s:= '';
  t:= 0;
  ans:= expr(s,t);
end;

procedure readdata;
var
  i, j : int;
  c, zn, buf : char;
  pr : int;
begin
  read(p);
  init;
  for i:= 1 to p-1 do
    for j:= 1 to p-1 do
      if (i*j) mod p = 1 then o[i]:= j;
  readln(n);
  for i:= 1 to n do
  begin
    read(c);
    if c  = 'U' then
    begin
      read(zn);
      while not (zn in [chr(33)..chr(127)]) do read(zn);
      read(buf);
      while buf <> '=' do read(buf);
      readln(up[zn]);
      up[zn]:= up[zn]+#0;
    end else
    begin
      read(pr);
      read(zn);
      while not (zn in [chr(33)..chr(127)]) or (zn in ['a'..'z']) do read(zn);
      read(buf);
      while buf <> '=' do read(buf);
      readln(bop[zn]);
      bop[zn]:= bop[zn]+#0;
      bo[zn]:= pr;
      uprior[pr]:= true;
    end;
  end;
  readln(k);
  for i:= 1 to k do
  begin
    read(c);
    read(buf);
    while buf <> '=' do read(buf);
    read(buf);
    vr[c]:= 0;
    while not eoln do
    begin
      if buf in ['0'..'9'] then vr[c]:= vr[c]*10+ord(buf)-ord('0');
      read(buf);
    end;
    if buf in ['0'..'9'] then vr[c]:= vr[c]*10+ord(buf)-ord('0');
    readln;
  end;
  bo['-']:= 5;
  bo['+']:= 5;
  bo['*']:= 15;
  bo['/']:= 15;
  uprior[20]:= true;
  uprior[15]:= true;
  uprior[5]:= true;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
