  {$I-,Q-,R-,S-}
const infile = 'docs.in'; outfile = 'docs.out'; max = 132000;
var a,b: array [0..max] of longint;
    num: array [1..max] of longint;
    f: array [1..max*2-1] of longint;
    res: array [1..max] of longint;
    p,n,t,m,c,d,up_g,down_g,min: longint;

    tmp: longint;

procedure sort(l,r: longint);
var i,j,x: longint;
begin
     i:=l; j:=r; x:=a[(l+r) div 2];
     repeat
           while a[i] < x do inc(i);
           while x < a[j] do dec(j);
           if i <= j then begin
              tmp:=a[i]; a[i]:=a[j]; a[j]:=tmp;
              tmp:=b[i]; b[i]:=b[j]; b[j]:=tmp;
              tmp:=num[i]; num[i]:=num[j]; num[j]:=tmp;
              inc(i); dec(j);
           end;
     until i > j;
     if i < r then sort(i,r);
     if l < j then sort(l,j);
end;

procedure make_tree;
var i: longint;
begin
     p:=1;
     while p < n do p:=p*2;
     for i:=p to p+n-1 do f[i]:=i-p+1;
     a[0]:=maxlongint; b[0]:=maxlongint;
     for i:=p+n to 2*p-1 do f[i]:=0;
     for i:=p-1 downto 1 do
         if b[f[2*i]] < b[f[2*i+1]] then f[i]:=f[2*i]
            else f[i]:=f[2*i+1];
end;

procedure find_up(q: longint; var g: longint);
var mid,up,down: longint;
begin
     down:=1; up:=n;
     while (up-down) > 1 do begin
           mid:=(up+down) div 2;
           if (a[mid] <= q) then down:=mid
              else up:=mid;
     end;
     if a[up] <= q then g:=up
        else g:=down;
end;

procedure find_down(q: longint; var g: longint);
var down,up,mid: longint;
begin
     down:=1; up:=n;
     while (up-down) > 1 do begin
           mid:=(up+down) div 2;
           if (a[mid] >= q) then up:=mid
              else down:=mid;
     end;
     if a[down] >= q then g:=down
        else g:=up;
end;

procedure rmq(l,r: longint; var ans: longint);
var i,j,cmin: longint;
begin
     i:=l+p-1; j:=r+p-1; cmin:=maxlongint; ans:=0;
     while (i <= j) do begin
           if cmin > b[f[i]] then begin
              ans:=f[i]; cmin:=b[f[i]];
           end;
           i:=(i+1) div 2;
           if cmin > b[f[j]] then begin
              ans:=f[j]; cmin:=b[f[j]];
           end;
           j:=(j-1) div 2;
     end;
end;

procedure update(q: longint);
var i,j: longint;
begin
     i:=q+p-1; b[q]:=maxlongint;
     while i > 1 do begin
           i:=i div 2;
           if b[f[2*i]] < b[f[2*i+1]] then j:=2*i
              else j:=2*i+1;
           if b[f[i]] > b[f[j]] then f[i]:=f[j]
     end;
end;

begin
     assign(input,infile);
     reset(input);
     read(n);
     for t:=1 to n do begin
         read(a[t],b[t]); num[t]:=t;
     end;
     sort(1,n);
     make_tree;
     read(m);
     assign(output,outfile);
     rewrite(output);
     for t:=1 to m do begin
         read(c,d);
         find_up(d,up_g);
         find_down(c,down_g);
         rmq(down_g,up_g,min);
         if min = 0 then break;
         update(min);
         res[t]:=num[min];
     end;
     if min = 0 then write('BOTVA')
        else begin
             for t:=1 to m do
                 write(res[t],' ');
        end;
     close(output);
     close(input);
end.
