  {$I-,Q-,R-,S-}
const infile = 'sphere.in'; outfile = 'sphere.out';
      eps = 0.000001; max = 1005;
type pt = record x,y,z: extended; end;
var t: array [1..max] of pt;
    dst: array [1..max,1..max] of extended;
    nnew: array [1..max] of longint;
    n,s1,s2: longint;
    r,d: extended;

procedure calc_pos(g1: extended; t1: char; g2: extended; t2: char; v: longint);
var rr: extended;
begin
     t[v].y:=r*sin(g1*pi/180);
     rr:=r*cos(g1*pi/180);
     if t1 = 'S' then t[v].y:=-t[v].y;
     t[v].x:=rr*cos(g2*pi/180);
     t[v].z:=rr*sin(g2*pi/180);
     if t2 = 'W' then t[v].z:=-t[v].z;
end;

procedure init;
var i: longint;
    t1,t2: char;
    g1,g2: extended;
begin
     assign(input,infile);
     reset(input);
     read(n,s1,s2,r,d);
     for i:=1 to n do begin
         read(g1); read(t1);
         while (t1 <> 'N')and(t1 <> 'S') do read(t1);
         read(g2); read(t2);
         while (t2 <> 'W')and(t2 <> 'E') do read(t2);
         calc_pos(g1,t1,g2,t2,i);
     end;
     close(input);
end;

function dist(p1,p2: pt): extended;
begin
     dist:=sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y)+sqr(p1.z-p2.z));
end;

function dist_sphere(p1,p2: pt): extended;
var h,a,ang,pp,f: extended;
begin
     pp:=pi;
     a:=dist(p1,p2);
     h:=sqrt(abs(r*r-a*a/4));
     if abs(h) < eps then ang:=pi
        else ang:=2*arctan(a/(2*h));
     f:=ang*r;
     dist_sphere:=f;
end;

procedure find_dist;
var i,j: longint;
begin
     fillchar(dst,SizeOf(dst),0);
     for i:=1 to n do
         for j:=i+1 to n do begin
             dst[i,j]:=dist_sphere(t[i],t[j]);
             dst[j,i]:=dst[i,j];
             if dst[i,j]-d > eps then begin
                dst[i,j]:=-1; dst[j,i]:=-1;
             end;
         end;
end;

procedure solve;
var og: array [1..max] of longint;
    yk1,yk2,i: longint;
begin
     find_dist;
     yk1:=1; yk2:=0; og[1]:=s1;
     for i:=1 to n do nnew[i]:=-1;
     nnew[s1]:=0;
     while yk1 > yk2 do begin
           inc(yk2);
           for i:=1 to n do
               if (nnew[i] < 0)and(dst[og[yk2],i] > -eps) then begin
                  inc(yk1); og[yk1]:=i;
                  nnew[i]:=nnew[og[yk2]]+1;
               end;
     end;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(nnew[s2]);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
