{$A+,B-,D+,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
const maxnm=100000;
      max2s=128*1024;
      big=2000000000;
type doc=record
           a,b:longint;
         end;
var n,m,i,m2,l,r:longint;
    a:array[1..max2s] of doc;
    c,d:array[1..max2s] of longint;
    w:array[1..max2s*2] of longint;
    q:array[1..max2s,1..2] of longint;
    mn:longint;
    docs:array[1..maxnm] of longint;
    beg:array[1..maxnm] of longint;
function min(a,b:longint):longint;
begin
  if a<b then min:=a else min:=b;
end;
procedure swap(var a,b:doc);
var c:doc;
begin
  c:=a;
  a:=b;
  b:=c;
end;
function max2(a:longint):longint;
var b:longint;
begin
  b:=1;
  while b<a do b:=b shl 1;
  max2:=b;
end;
function minimum(l,r,n:longint):longint;
var min1,min2:longint;
begin
  if (l=r) then begin minimum:=l; exit; end;
  if (l=q[n,1])and(r=q[n,2]) then begin minimum:=w[n]; exit end;
  if (w[n]<=r)and(w[n]>=l) then begin minimum:=w[n]; exit; end;
  if (l>=q[2*n,1])and(l<=q[2*n,2]) and (r<=q[2*n,2]) then minimum:=minimum(l,r,2*n) else
  if (l>=q[2*n+1,1])and(l<=q[2*n+1,2]) and (r<=q[2*n+1,2]) then minimum:=minimum(l,r,2*n+1) else
  begin
    min1:=minimum(l,q[2*n,2],2*n);
    min2:=minimum(q[2*n+1,1],r,2*n+1);
    if w[min1+m2-1]<w[min2+m2-1] then minimum:=min1 else minimum:=min2;
  end;
end;
function left(l:longint):longint;
var i,j:longint;
begin
  i:=1;
  j:=m2;
  if l<=a[i].a then begin left:=i; exit; end;
  while j-i>1 do
  begin
    if a[(j+i) div 2].a<l then i:=(i+j) div 2
    else j:=(i+j) div 2;
  end;
  left:=j;
end;
function right(l:longint):longint;
var i,j:longint;
begin
  i:=1;
  j:=m2;
  if l>=a[j].a then begin right:=j; exit; end;
  while j-i>1 do
  begin
    if a[(j+i) div 2].a>l then j:=(i+j) div 2
    else i:=(i+j) div 2;
  end;
  right:=i;
end;
procedure delete(i:longint);
var j:longint;
begin
  j:=i+m2-1;
  w[j]:=big;
  j:=j div 2;
  if w[2*j]>w[2*j+1] then w[j]:=2*j+1-m2+1 else w[j]:=2*j-m2+1;
  j:=j div 2;
  while j>=1 do
  begin
    if w[w[2*j]+m2-1]<w[w[2*j+1]+m2-1] then w[j]:=w[2*j] else w[j]:=w[2*j+1];
    j:=j div 2;
  end;
end;
procedure swp(var a,b:longint);
var c:longint;
begin
  c:=a;
  a:=b;
  b:=c;
end;
procedure sort(l,r:longint);
var i,j,x:longint;
begin
  i:=l;
  j:=r;
  x:=a[random(j-i+1)+i].a;
  while i<j do
  begin
    while a[i].a<x do inc(i);
    while a[j].a>x do dec(j);
    if i<=j then
    begin
      swap(a[i],a[j]);
      swp(beg[i],beg[j]);
      inc(i);
      dec(j);
    end;
  end;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;
begin
  fillchar(w,sizeof(w),0);
  assign(input,'docs.in');
  reset(input);
  read(n);
  for i:=1 to n do
    read(a[i].a,a[i].b);
  read(m);
  for i:=1 to m do
    read(c[i],d[i]);
  close(input);
  for i:=1 to n do
    beg[i]:=i;
  sort(1,n);
  m2:=max2(n);
  for i:=n+1 to m2 do
  begin
    a[i].b:=big;
    a[i].a:=big;
  end;
  for i:=m2 to m2*2-1 do
  begin
    w[i]:=a[i-m2+1].b;
    q[i,1]:=i-m2+1;
    q[i,2]:=i-m2+1;
  end;
  for i:=m2-1 downto m2 div 2 do
  begin
    q[i,1]:=q[2*i,1];
    q[i,2]:=q[2*i+1,2];
    if w[2*i]<w[2*i+1] then w[i]:=2*i-m2+1 else w[i]:=2*i+1-m2+1;
  end;
  for i:=m2 div 2-1 downto 1 do
  begin
    q[i,1]:=q[2*i,1];
    q[i,2]:=q[2*i+1,2];
    if w[w[2*i]+m2-1]<w[w[2*i+1]+m2-1] then w[i]:=w[2*i] else w[i]:=w[2*i+1];
  end;
  assign(output,'docs.out');
  rewrite(output);
  for i:=1 to m do
  begin
    l:=left(c[i]);
    r:=right(d[i]);
    mn:=minimum(l,r,1);
    if w[mn+m2-1]=big then begin write('BOTVA'); close(output); halt; end;
    delete(mn);
    docs[i]:=beg[mn];
  end;
  for i:=1 to m do
    write(docs[i],' ');
  close(output);
end.
