{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='docs.in';
  outfile='docs.out';
  inf = MaxLongInt;
  nm=400005;
type
  Document = record
    a,b,n : LongInt;
  end;
var
  a : array [0..nm] of Document;
  b : array [1..nm] of LongInt;
  res : array [1..nm] of LongInt;
  n,m,k : LongInt;
  ans : Boolean;
{}
Procedure Inp;
var
  i,j : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do begin
    read(a[i].a,a[i].b);
    a[i].n:=i;
  end;
  read(m);
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ans then begin
    for i:=1 to m do write(a[res[i]].n,' ');
  end else writeln('BOTVA');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(res,sizeof(res),0);
end;
{}
Procedure Swap(var q,w : Document);
var
  bak : Document;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l, r: LongInt);
var
  i, j, x : LongInt;
begin
  i := l; j := r; x := a[(l+r) DIV 2].a;
  repeat
    while a[i].a < x do inc(i);
    while x < a[j].a do dec(j);
    if i <= j then
    begin
      Swap(a[i],a[j]);
      inc(i); dec(j);
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;
{}
Function Rmq(l,r : LongInt) : LongInt;
var
  m,r1,r2,l0,r0 : LongInt;
begin
  if l>r then begin rmq:=0; exit; end;
  r1:=b[l]; r2:=b[r];
  while l<>r do begin
    m:=l div 2;
    if (2*m=l) and (2*m+1<>r) and (a[b[2*m+1]].b<a[r1].b) then r1:=b[2*m+1];
    l0:=m;

    m:=r div 2;
    if (2*m+1=r) and (2*m<>l) and (a[b[2*m]].b<a[r2].b) then r2:=b[2*m];
    r0:=m;

    l:=l0; r:=r0;
  end;
  if a[r1].b<a[r2].b then rmq:=r1
                     else rmq:=r2;
end;
{}
Procedure Update(x : LongInt);
begin
  x:=x div 2;
  while x>0 do begin
    if a[b[2*x]].b<a[b[2*x+1]].b then b[x]:=b[2*x]
                                 else b[x]:=b[2*x+1];
    x:=x div 2;
  end;
end;
{}
Procedure Solve;
var
  i,j,t : LongInt;
  l,r,mid,x,y,q,w : LongInt;
begin
  ans:=true; Sort(1,n);

  k:=1; a[0].b:=inf;
  while  k<n do k:=2*k;
  for i:=k to k+n-1 do b[i]:=i-k+1;
  for i:=k+n to 2*k-1 do b[i]:=0;
  for i:=k-1 downto 1 do begin
    if a[b[2*i]].b<a[b[2*i+1]].b then b[i]:=b[2*i]
                                 else b[i]:=b[2*i+1];
  end;

  for t:=1 to m do begin
    read(x,y);
    l:=1; r:=n;
    while l<>r do begin
      mid:=(l+r) div 2;
      if a[mid].a>=x then r:=mid
                     else l:=mid+1;
    end;
    q:=l; if a[q].a<x then q:=n+1;

    l:=1; r:=n;
    while l<>r do begin
      mid:=(l+r+1) div 2;
      if a[mid].a<=y then l:=mid
                     else r:=mid-1;
    end;
    w:=l; if a[w].a>y then w:=0;


    res[t]:=rmq(k+q-1,k+w-1);
    if res[t]=0 then begin
      ans:=false; Out;
    end;
    b[k+res[t]-1]:=0;
    update(k+res[t]-1);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.