{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

{Alexey Timofeev }

const
	FILEIN='sphere.in';
  FILEOUT='sphere.out';
  NMAX=1005;
  eps=1E-7;
type
	point=record
  	x,y,z,s,d:extended;
  end;
	elem=record
  	t:integer;
    r:extended;
  end;
var
	min,s1,s2,n,i,j:longint;
  a:array[1..NMAX] of point;
	ch:char;
	r,d:extended;
	stack:array[0..NMAX] of integer;
	t,s,f:integer;
	c:array[0..NMAX] of elem;
	b:array[0..NMAX] of boolean;
function rast(a,b:point):extended;
var
	t,fi:extended;
begin
  t:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y)+sqr(a.z-b.z));
  t:=t/2;
  if abs(r-t)>eps then fi:=arctan(t/sqrt(sqr(r)-sqr(t)))
  else fi:=pi/2;
  rast:=2*fi*r;
end;


procedure initdata;
begin
  fillchar(b,sizeof(b),0);
	fillchar(c,sizeof(c),0);
end;

procedure put(x:integer);
begin
	s:=(s+1) mod NMAX;
  stack[s]:=x;
end;

procedure pop(var x:integer);
begin
  f:=(f+1) mod NMAX;
	x:=stack[f];
end;

function empty:boolean;
begin
  empty:=(f=s);
end;

procedure outdata(ot:integer);
begin
	assign(output,FILEOUT);rewrite(output);
  writeln(ot);
	close(output);
	halt;
end;


procedure readdata;
begin
	assign(input,FILEIN);reset(input);
  read(n,s1,s2,r);
  readln(d);
  for i:=1 to n do
  begin
    read(a[i].s);
    read(ch,ch);
    if ch='S' then a[i].s:=-a[i].s;
    read(a[i].d);
    read(ch,ch);
    if ch='E' then a[i].d:=-a[i].d;
    if not eof then readln;
  	a[i].z:=r*sin(a[i].s*pi/180);
    a[i].x:=r*cos(a[i].s*pi/180)*cos(a[i].d*pi/180);
    a[i].y:=r*cos(a[i].s*pi/180)*sin(a[i].d*pi/180);
  end;
end;

procedure solve;
var
	i:integer;
	good:boolean;
begin
  {Deixtra}
  b[s1]:=true;
  c[s1].t:=0;
  c[s1].r:=d;

  for i:=1 to n do
  	if i<>s1 then c[i].t:=-1;

  for i:=1 to n do
  if i<>s1 then
  	if rast(a[s1],a[i])-d<eps then
    begin
      c[i].t:=c[s1].t+1;
      c[i].r:=rast(a[s1],a[i]);
    end;

  while true do
  begin
    min:=0;
    for i:=1 to n do
     	if not b[i] then
        if c[i].t<>-1 then
      		if (c[i].t<c[min].t) or ((c[i].t=c[min].t) and (c[i].r<c[min].r)) or (min=0) then
    			min:=i;

    if min=0 then break;
    b[min]:=true;
    for i:=1 to n do
    	if not b[i] then
      	if rast(a[min],a[i])-d<eps then
          if (c[i].t=-1) or (c[i].t>c[min].t)
          and not ( (c[min].r+rast(a[min],a[i])-d>eps) and (c[i].t=c[min].t+1) and (c[i].r<rast(a[i],a[min])))
					then
          begin
          	c[i].t:=c[min].t;
            c[i].r:=c[min].r+rast(a[min],a[i]);
            if c[i].r-d>eps then
            begin
            	inc(c[i].t);
              c[i].r:=rast(a[i],a[min]);
            end;
          end else
      		if (c[i].t=c[min].t) and (c[i].r>c[min].r+rast(a[min],a[i]))
          then c[i].r:=c[min].r+rast(a[min],a[i]);

  end;

end;

begin
	initdata;
  readdata;
  solve;
  outdata(c[s2].t);
end.