{$I-}{$R-}{$N+}
var
  f,f1 :text;

const name = 'calc';

var
  p,val :longint;
  id    :char;
  lexem :integer;

const
  _var=1;
  _int=2;
  _ope=3;
  _sko=4;
  _skz=5;

type
  TSTROKA = string;
  TString = record s:TSTROKA; pos:integer; end;

var
  variables  :array['a'..'z']of integer;
  operations :array  [char]  of TString;
  prioritet  :array  [char]  of integer;
  s :TString; c:char;  str :string;

function  Sumbol (s :TString) :char;
begin
  Sumbol:=c;
end;

procedure NS     (var s:TString);
begin
  if (s.pos=0     ) or (s.pos=1)   then inc (s.pos) else
  if (s.s[s.pos-1]) in [#33..#127] then inc (s.pos);
{ if s.pos = 101 then
    begin
      s.pos := 1;
      repeat
        read (f,c);
        inc (s.pos);
        s.s[s.pos] := c;
      until not (c in [#33..#127]) or eof(f) or (s.pos=100);
      if s.pos<>100 then s.s[s.pos+1] := #0;
    end;      }
  c := s.s[s.pos];
end;

procedure NEXT (var s :TString);
  procedure GetInt;
  begin
    lexem:=_int;
    val  := 0;
    while Sumbol(s) in ['0'..'9'] do
      begin
        val := val*10+ord(Sumbol(s))-ord('0');
        NS(s);
      end;
  end;
  procedure GetVar;
  begin
    lexem := _var;
    id    := Sumbol(s);
    NS(s);
  end;
  procedure GetOp;
  begin
    lexem := _ope;
    id    := Sumbol(s);
    NS(s);
  end;
  procedure GetSkO;
  begin
    lexem := _sko;
    NS(s);
  end;
  procedure GetSkZ;
  begin
    lexem := _skz;
    NS(s);
  end;
begin
  if Sumbol(s) in ['0'..'9']      then GetInt else
  if Sumbol(s) in ['a'..'z']      then GetVar else
  if Sumbol(s) = '('              then GetSkO else
  if Sumbol(s) in [')',#0..#32]   then GetSkZ else
                                       GetOp;
end;

var
  steka,stekb,stekval,steklexem :array[1..50]of longint;
  stekid :array[1..50]of char;
  steksize    :longint;

procedure PUSH;
begin
  inc(steksize);
  steka[steksize]:=variables['a'];
  stekb[steksize]:=variables['b'];
  stekid[steksize]:=id;
  stekval[steksize]:=val;
  steklexem[steksize]:=lexem;
end;

procedure POP;
begin
  variables['a'] := steka[steksize];
  variables['b'] := stekb[steksize];
  id := stekid[steksize];
  val := stekval[steksize];
  lexem := steklexem[steksize];
  dec (steksize);
end;

function Module (a,p :longint) :longint;
begin
  while (a<0) do a := a + p;
  a := a mod p;
  Module := a;
end;

function Process (pr :longint; var s :TString) :longint;
var a,b,i :longint; op :char;
begin
  if pr=20
    then
      begin
        case lexem of
          _ope :
            begin
              if prioritet[id] = 20 then
                begin
                  op := id;
                  NEXT(s);
                  a := Process (20,s);
                  PUSH;
                  variables['a'] := a;
                  operations[op].pos := 0;
                  NS(operations[op]);
                  NEXT(operations[op]);
                  Process := Process (1,operations[op]);
                  POP;
                end;
            end;
          _int: begin Process := val; NEXT(s); end;
          _var: begin Process := variables[id]; NEXT(s); end;
          _sko:
            begin
              NEXT(s);
              Process := Process (1,s);
              NEXT(s);
            end;
        end;
      end
    else
      begin
        a := Process(pr+1,s);
        while True do
          begin
            case lexem of
              _ope:
                begin
                  op := id;
                  if prioritet[op]<pr then break;
                  NEXT(s);
                  b := Process(pr+1,s);
                  case op of
                    '*':a:=(a*b) mod p;
                    '+':a:=(a+b) mod p;
                    '-':a:=Module((a-b),p);
                    '/':
                      begin
                        for i := 1 to p do
                          if a=((i*b) mod p) then
                            begin
                              a := i;
                              break;
                            end;
                      end;
                    else
                      begin
                        PUSH;
                        variables['a']:=a;
                        variables['b']:=b;
                        operations[op].pos := 0;
                        NS(operations[op]);
                        NEXT(operations[op]);
                        a := Process(1,operations[op]);
                        POP;
                      end;
                  end;
                end;
              _skz:begin break; end;
            end;
          end;
        Process:=a;
      end;
end;

var
  i,j,k,n :longint;    stroka :string;

procedure ReadChar;
begin
  repeat
    read(f,c);
  until c<>' ';
end;

begin
  assign (f,name+'.in');
  assign (f1,name+'.out');
  reset (f);
  rewrite (f1);
    readln(f,p,n);
    for i := 1 to n do
      begin
        ReadChar;
        if c='B' then read(f,j) else j:=20;
        if j<>20 then ReadChar; {c='a'}
        ReadChar;
        prioritet[c]:=j;
        j := ord(c);
        ReadChar; {c='b'} ReadChar; {c='='}
        readln (f,stroka);
        for k := 1 to length(stroka) do
          if stroka[k] = ' ' then
            begin
              delete (stroka,k,1);
              dec(k);
            end;
        stroka := stroka+#0;
        s.s := stroka;
        operations[chr(j)]:=s;
      end;
    readln (f,n);
    for i := 1 to n do
      begin
        readln (f,stroka);
        s.s := stroka;
        s.pos := 3;
        NEXT(s);
        variables[stroka[1]]:=val;
      end;
    readln (f,s.s);
    s.s := s.s+#0;
    s.pos := 0;
    prioritet['*']:= 15;
    prioritet['/']:= 15;
    prioritet['+']:=  5;
    prioritet['-']:=  5;
    c := 'q';
    NS(s);
    NEXT(s);
    i := Process(1,s);
    i := Module (i,p);
    writeln (f1,i);
  close (f);
  close (f1);
end.
