{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 65000,0,655360}
{$N+}
type
  real = extended;
const
  inf = 'sphere.in'; ouf = 'sphere.out';
  max = 1005;
  eps = 1e-9;
  pi = 3.1415926535897932385;
var
  rr, d: real;
  a: array[1..max,1..max] of byte;
  w: array[1..max] of integer;
  q: array[1..max shl 1+1] of integer;
  lg, lt: array[1..max] of real;
  cr, l, r, n, i, j, s1, s2: longint; ch: char;
  x, y, z, al, bt, dd, dn: real; ok: boolean;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  read(input, n); read(input, s1, s2);
  read(input, rr, d); d := d / rr;
  for i := 1 to n do
  begin
    read(input, lg[i]);
    lg[i] := lg[i] * pi / 180;
    read(input, ch);
    while ch = ' ' do read(input, ch);
    if (ch = 'S') then lg[i] := - lg[i];
    read(input, lt[i]);
    lt[i] := lt[i] * pi / 180;
    read(input, ch);
    while (ch = ' ') do read(input, ch);
    if (ch = 'E') then lt[i] := -lt[i];
    readln(input);
  end;
  fillchar(a, sizeof(a), 0);
  for i := 1 to n - 1 do
    for j := i + 1 to n do
    begin
      al := abs(lg[j] - lg[i]);
      bt := abs(lt[j] - lt[i]);
      x := sin(al); y := sin(bt);
      z := abs(cos(al) - cos(bt));
      dd := sqr(x) + sqr(y) + sqr(z);
      dn :=  1 - dd/4;
      if (abs(dn) < eps) then dd := pi else
      begin
        dd := dd / dn; dd := sqrt(dd);
        dd := 2 * arctan(dd);
      end;
      if (d - dd > -eps) then
      begin
        a[i, j] := 1; a[j, i] := 1;
      end;
    end;
  fillchar(w, sizeof(w), 0);
  fillchar(q, sizeof(q), 0);
  l := 1; r := 1; q[1] := s1; w[s1] := 1;
  ok := true;
  while ok do
  begin
    cr := q[l]; ok := false;
    for i := 1 to n do
      if (a[cr, i] = 1) and (w[i] = 0) then
      begin
        inc(r); w[i] := w[cr] + 1;
        q[r] := i; ok := true;
        if (i = s2) then
        begin
          ok := false; break;
        end;
      end;
    inc(l);
  end;
  writeln(output, w[s2] - 1);
  close(input); close(output);
end.
