  {$I-,Q-,R-,S-}
const maxn=110000;
type mas=array[1..maxn] of longint;
     ttype=record x,y,l,r,ind:longint; end;
     mas2=array[0..maxn] of ttype;
var a,b,ind,res:mas;
    T:mas2;
    n,cnt,m,root:longint;

Procedure init;
var i:longint;
begin
     assign(input,'docs.in');
     reset(input);
     assign(output,'docs.out');
     rewrite(output);
     read(n);
     for i:=1 to n do
     begin
          read(a[i],b[i]);
          ind[i]:=i;
     end;
     t[0].x:=-1;
end;

Function merge(const l,r:longint):longint;
begin
     if (l=0) then
     begin
          merge:=r;
          exit;
     end else
     if (r=0) then
     begin
          merge:=l;
          exit;
     end;
     if t[l].y<t[r].y then
     begin
          t[l].r:=merge(t[l].r,r);
          merge:=l;
     end else
     begin
          t[r].l:=merge(l,t[r].l);
          merge:=r;
     end;
end;

Procedure swap(var a,b:ttype);
var t:ttype;
begin
     t:=a;
     a:=b;
     b:=t;
end;

Procedure delete(const q,x:longint);
var qq,ttt,i:longint;
begin
     if x<t[q].x then delete(t[q].l,x) else
     if x>t[q].x then delete(t[q].r,x) else
     if x=t[q].x then
     begin
          qq:=merge(t[q].l,t[q].r);
          t[q]:=t[qq];
          if root=q then root:=qq;
     end;
end;

procedure qSort(l, r: longint);
var
  i, j, x, y: longint;
begin
  i := l; j := r; x := a[(l+r) DIV 2];
  repeat
    while a[i] < x do i := i + 1;
    while x < a[j] do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      y := b[i]; b[i] := b[j]; b[j] := y;
      y := ind[i]; ind[i] := ind[j]; ind[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then qSort(l, j);
  if i < r then qSort(i, r);
end;

procedure qSort2(l, r: longint);
var
  i, j, x, y: longint;
begin
  i := l; j := r; x := b[(l+r) DIV 2];
  repeat
    while b[i] < x do i := i + 1;
    while x < b[j] do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      y := b[i]; b[i] := b[j]; b[j] := y;
      y := ind[i]; ind[i] := ind[j]; ind[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then qSort2(l, j);
  if i < r then qSort2(i, r);
end;

procedure add(const x,y,ind:longint; var mr:longint);
var i,j:longint;
begin
     i:=root;
     j:=0;
     if cnt=0 then
     begin
          inc(cnt);
          t[cnt].x:=x;
          t[cnt].y:=y;
          t[cnt].ind:=ind;
          root:=1;
          exit;
     end;
     while true do
     begin
          if y<t[i].y then
          begin
               inc(cnt);
               t[cnt].x:=x;
               t[cnt].y:=y;
               t[cnt].ind:=ind;
               t[cnt].l:=i;
               t[j].r:=cnt;
               if j=0 then root:=cnt;
               exit;
          end else
          begin
               if t[i].r=0 then
               begin
                    inc(cnt);
                    t[cnt].x:=x;
                    t[cnt].y:=y;
                    t[cnt].ind:=ind;
                    t[cnt].l:=0;
                    t[i].r:=cnt;
                    exit;
               end;
               j:=i;
               i:=t[i].r;
          end;
     end;
end;

Procedure PreProcess;
var i,j,jbeg,mr:longint;
begin
     qsort(1,n);
     i:=1;
     j:=1;
     jbeg:=1;
     while i<=n do
     begin
          jbeg:=j;
          j:=i;
          while a[i]=a[j] do
          begin
               inc(j);
               if j>n then break;
          end;
          i:=j;
          qsort2(jbeg,j-1);
     end;
     mr:=0;
     for i:=1 to n do
     begin
          add(a[i],b[i],ind[i],mr);
     end;
end;

Procedure printbotva;
begin
     writeln('BOTVA');
     close(input);
     close(output);
     halt;
end;

Function get(const l,r:longint):longint;
var i:longint;
begin
     i:=root;
     while true do
     begin
         if t[i].r<>0 then if t[t[i].r].x=-1 then t[i].r:=0;
         if t[i].l<>0 then if t[t[i].l].x=-1 then t[i].l:=0;
          if t[i].x<l then
          begin
               i:=t[i].r;
               if i=0 then
               begin
                    get:=0;
                    exit;
               end;
          end else
          if t[i].x>r then
          begin
               i:=t[i].l;
               if i=0 then
               begin
                    get:=0;
                    exit;
               end;
          end else break;
     end;
     get:=i;
end;

Procedure mainsolve;
var i,j,l,r,v:longint;
begin
     read(m);
     for i:=1 to m do
     begin
          read(l,r);
          v:=get(l,r);
          if v=0 then printbotva else res[i]:=t[v].ind;
          delete(root,t[v].x);
     end;
end;

Procedure solve;
begin
     PreProcess;
     mainsolve;
end;

Procedure print;
var i,j:longint;
begin
     for i:=1 to m do write(res[i],' ');
end;

begin
     init;
     solve;
     print;
     close(input);
     close(output);
end.
