program zzz;

const
  eps = 1E-6;

type
  Real = Extended;
  TPoint = record
    x,y,z: Real;
  end;

var
  g: array[1..1000,1..1000] of Boolean;
  city: array[1..1000] of TPoint;
  cen: Tpoint;
  ch: char;
  cst,q: array[1..1000] of Longint;
  vis: array[1..1000] of Boolean;
  head,tail,i,j,st,fin,k,n,m: Longint;
  ang1,ang2,l1,l2,rp,d: Real;

function getchar(): char;
var ch: char;
begin
  read(ch);
  while ch = ' ' do read(ch);
  getchar := ch;
end;

function getcos(a,b,c: TPoint): Real;
begin
  getcos := ((a.x-b.x) * (c.x-b.x) + (a.y-b.y) * (c.y-b.y) + (a.z-b.z) * (c.z-b.z)) / sqr(rp);
end;

function getdis(a,b,c: TPoint): Real;
var coss,sinn,ang: Real;
begin
  coss := getcos(a,b,c);
  if abs(coss - 1) < eps then begin
    getdis := pi * rp;
    exit;
  end;
  if abs(coss + 1) < eps then begin
    getdis := pi * rp;
    exit;
  end;
  sinn := sqrt(1 - sqr(coss));
  if abs(coss) < eps then begin
    getdis := pi * rp / 2;
    exit;
  end;
  ang := arctan(sinn/coss);
  if ang < 0 then ang := ang + pi;
  getdis := ang * rp;
end;

procedure getcoor(var p: TPoint; a1,a2: Real);
var rr: Real;
begin
  p.z := rp * sin(a1);
  rr := rp * cos(a1);
  p.x := rr * sin(a2);
  p.y := rr * cos(a2);
end;

begin
  assign(input,'sphere.in'); reset(input);
  readln(n,st,fin,rp,d);
  cen.x := 0;
  cen.y := 0;
  cen.z := 0;
  for i := 1 to n do begin
    read(ang1);
    ang1 := ang1 / 180 * pi;
    case getchar() of
      'S': begin
        ang1 := -ang1;
      end;
      'N': begin
      end;
    end;
    read(ang2);
    ang2 := ang2 / 180 * pi;
    case getchar() of
      'W': begin
        ang2 := -ang2;
      end;
      'E': begin
      end;
    end;
    getcoor(city[i],ang1,ang2);
  end;
  for i := 1 to n do begin
    for j := 1 to n do begin
      if getdis(city[i],cen,city[j]) - d < eps then begin
        g[i,j] := true;
      end;
    end;
  end;
  head := 1;
  tail := 1;
  q[1] := st;
  vis[st] := true;
  while head >= tail do begin
    for i := 1 to n do begin
      if g[i,q[tail]] and not vis[i] then begin
        inc(head);
        q[head] := i;
        vis[i] := true;
        cst[i] := cst[tail] + 1;
      end;
    end;
    inc(tail);
  end;
  assign(output,'sphere.out'); rewrite(Output);
  if not vis[fin] then writeln('-1') else writeln(cst[fin]);
  close(input);
  close(output);
end.
