{$D-,E+,I-,L-,P-,Q-,R-,S-,T+,V+,X+,Y+}
uses math;

type float=extended;

const maxn=1000;
eps:float=1e-12;

var n,s1,s2,i,j,v,u:integer;
r,d:float;
g1,g2:float;
c:char;
x,y,z:array[1..maxn]of float;
xx,yy,zz,ixj,ij,sum:float;

g:array[1..maxn,1..maxn]of byte;
q:array[1..maxn]of integer;
ql,qr:integer;
ans:array[1..maxn]of integer;

begin
assign(input,'sphere.in');reset(input);
read(n);
read(s1,s2);
read(r,d);
for i:=1 to n do
 begin
  read(g1);g1:=pi*g1/180;
  read(c);
  while c=' 'do read(c);
  if c='S' then g1:=-g1;
  read(g2);g2:=pi*g2/180;
  read(c);
  while c=' 'do read(c);
  if c='W' then g2:=-g2;
  x[i]:=cos(g2)*cos(g1);
  y[i]:=sin(g2)*cos(g1);
  z[i]:=sin(g1);
 end;
close(input);
for i:=1 to n do for j:=1 to n do
 begin
  xx:=sqr(y[i]*z[j]-y[j]*z[i]);
  yy:=sqr(x[i]*z[j]-x[j]*z[i]);
  zz:=sqr(x[i]*y[j]-x[j]*y[i]);
  sum:=xx+yy+zz;
  if sum>eps then ixj:=sqrt(xx+yy+zz) else ixj:=0;
  ij:=x[i]*x[j]+y[i]*y[j]+z[i]*z[j];
  if r*abs(arctan2(ixj,ij))<d+eps then g[i,j]:=1 else g[i,j]:=0;
 end;

fillchar(ans,sizeof(ans),255);
ql:=1;qr:=1;q[1]:=s1;ans[s1]:=0;
while ql<=qr do
 begin
  u:=q[ql];
  for v:=1 to n do if (ans[v]=-1)and(g[u,v]=1)then
    begin
     inc(qr);
     q[qr]:=i;
     ans[v]:=ans[u]+1;
    end;
  inc(ql);
 end;
assign(output,'sphere.out');rewrite(output);
writeln(ans[s2]);
close(output);
end.