#include <stdio.h>
#include <math.h>
#define m 1002
#define e 1e-7
int n,s1,s2,q[m],mark[m],dd[m],h;
char a[m][m];
double g1,g2,r,r2,d,x[m],y[m],z[m];
void read(void)
{
  int i;
  char t1[10],t2[10];
  scanf("%d%d%d%lf%lf",&n,&s1,&s2,&r,&d);
  for(i=1;i<=n;i++)
  {
    scanf("%lf%s%lf%s",&g1,t1,&g2,t2);
    g1*=M_PI/180;g2*=M_PI/180;
    h=sin(g1)*r;
    r2=sqrt(r*r-h*h);
    if(t1[0]=='N')y[i]=h;else y[i]=-h;
    if(t2[0]=='E')x[i]=cos(g2)*r2,z[i]=sin(g2)*r2;
    else x[i]=cos(g2)*r2,z[i]=-sin(g2)*r2;
  }
}
double ang(double s,double c)
{
  return acos(c);
}
void calc(void)
{
  int i,j;
  for(i=1;i<=n;i++)
    for(j=1;j<=n;j++)a[i][j]=0;
  for(i=1;i<=n;i++)
    for(j=i+1;j<=n;j++)
    {
      double aa,xx,yy,zz;
      xx=y[i]*z[j]-z[i]*y[j];
      yy=-x[i]*z[j]+z[i]*x[j];
      zz=x[i]*y[j]-y[i]*x[j];
      aa=ang(sqrt(xx*xx+yy*yy+zz*zz)/r/r,(x[i]*x[j]+y[i]*y[j]+z[i]*z[j])/r/r)*r;
      if(aa<d+e)a[i][j]=a[j][i]=1;
    }
}
void solve(void)
{
  int l,p,i;
  calc();
  q[1]=s1;
  for(i=1;i<=n;i++)mark[i]=0,dd[i]=-1;
  dd[s1]=0;mark[s1]=1;
  for(l=p=1;p<=l;p++)
    for(i=1;i<=n;i++)
      if(a[q[p]][i]&&!mark[i])
      {
        mark[i]=1;q[++l]=i;dd[i]=dd[q[p]]+1;
      }
  printf("%d\n",dd[s2]);
}
int main(void)
{
  freopen("sphere.in","r",stdin);
  freopen("sphere.out","w",stdout);
  read();
  solve();
  return 0;
}

