{$M 30000000,0,30000000}
const resr:set of char=['+','-','*','/','(',')','=','0'..'9','a'..'z'];
const maxn=200000;
type
  int=longint;
  ptree = ^ttree;
  ttree = record
    tip : char;
    num : int;
    col : int;
    l,r : ptree;
  end;
  top = record
    tip: char;
    znak : char;
    pr : int;
    p : ptree;
  end;
var
  n,p,i,ii,j,jj : int;
  colop : int;
  op : array [-4..30] of top;
  opnum : array [char] of int;
  colconst : int;
  mconst : array [char] of int;
  ch,ch1 : char;
  s : string;
  sscol : int;
  ss : array [1..maxn] of char;
  tek : int;
  curr : int;
  vval : int;
function makeop ( s : string ) : ptree;
var
  max,posmax,skob : int;
  i : int;
  p : pTree;
  code : word;
begin
  if (s='a') or (s='b') then begin
    new(p);
    p^.tip:=s[1];
    p^.l:=nil;
    p^.r:=nil;
    makeop:=p;
    exit;
  end;
  max:=100;
  skob:=0;
  for i:=1 to length(s) do begin
    if s[i]='(' then inc(skob);
    if s[i]=')' then dec(skob);
    if (skob=0) and (opnum[s[i]]<>0) then begin
      if op[opnum[s[i]]].pr<max then begin
        max:=op[opnum[s[i]]].pr;
        posmax:=i;
      end;
    end;
  end;
  if (max=100)and (s[1]='(') then begin
    makeop:=makeop(copy(s,2,length(s)-2));
    exit;
  end;
  if max=100 then begin
    new(p);
    p^.tip:='C';
    val ( s , p^.num , code );
    p^.l:=nil;
    p^.r:=nil;
    makeop:=p;
    exit;
  end;
  new(p);
  p^.tip:='O';
  p^.num:=opnum[s[posmax]];
  if posmax=1 then p^.r:=nil
  else p^.r:=makeop(copy(s,posmax+1,length(s)-posmax));
  if posmax=1 then p^.l:=makeop(copy(s,posmax+1,length(s)-posmax));
  p^.l:=makeop(copy(s,1,posmax-1));
  makeop:=p;
end;
procedure dfs ( p : ptree );
begin
  write ( '( ' );
  if p^.l<>nil then dfs(p^.l);
  if p^.tip='O' then write ( op[p^.num].znak,' ' ) else
  if p^.tip='C' then write ( p^.num,' ' ) else
  write ( p^.tip,' ' );
  if p^.r<>nil then dfs(p^.r);
  write ( ') ');
end;
procedure readlex;
var
  s : string;
  code : word;
begin
  if tek>sscol then begin
    curr:=255;
    exit;
  end;
    if ss[tek]='(' then begin
      curr:=253;
      inc ( tek );
      exit;
    end;
    if ss[tek]=')' then begin
      curr:=254;
      inc ( tek );
      exit;
    end;
    if ss[tek] in ['0'..'9'] then begin
      s:='';
      while ss[tek] in ['0'..'9'] do begin
        s:=s+ss[tek];
        inc ( tek );
      end;
      val ( s , vval , code );
      curr:=252;
      exit;
    end;
    if mconst[ss[tek]]<>255 then begin
      curr:=252;
      vval:=mconst[ss[tek]];
      inc ( tek );
      exit;
    end;
    if opnum[ss[tek]]<>0 then begin
      curr:=251;
      vval:=opnum[ss[tek]];
      inc ( tek );
      exit;
    end;
    curr:=250;
end;
function sum ( a,b : byte ) : byte;
var t : int;
begin
  t:=a+b;
  sum:=(t) mod p;
end;
function ras ( a,b : byte ) : byte;
var
  t : int;
begin
  t:=a-b;
  ras:=(t) mod p;
end;
function mul ( a, b : byte ) : byte;
var t : int;
begin
  t:=a*b;
  mul:=t mod p;
end;
function dv ( a, b : byte ):byte;
var t : int; c : byte;
begin
  for c:=1 to p-1 do begin
    t:=c*b;
    t:=t mod p;
    if a=t then begin
      dv:=c;
      exit;
    end;
  end;
end;
function znach ( onum : int; o : ptree; a,b : byte ) : byte;
var t1,t2 : byte;
begin
  if o^.tip='C' then begin
    znach:=o^.num;
    exit;
  end;
  if o^.tip='a' then begin
    znach:=a;
    exit;
  end;
  if o^.tip='b' then begin
    znach:=b;
    exit;
  end;
  if onum=-3 then begin
    znach:=sum(a,b);
    exit;
  end;
  if onum=-2 then begin
    znach:=ras(a,b);
    exit;
  end;
  if onum=-1 then begin
    znach:=mul(a,b);
    exit;
  end;
  if onum=-4 then begin
    znach:=dv(a,b);
    exit;
  end;
  if o^.l<>nil then t1:=znach(0,o^.l,a,b);
  if o^.r<>nil then t2:=znach(0,o^.r,a,b);
  znach:=znach(o^.num,op[o^.num].p,t1,t2)
end;
function calc ( rank : byte ) : byte;
var
  a : byte;
  oldval : int;
begin
  if rank=21 then begin
    case curr of
      252 : begin
        calc:=vval;
        ReadLex;
        exit;
      end;
      253 : begin
        calc:=calc(1);
        ReadLex;
        exit;
      end;
    end;
    calc:=0;
    exit;
  end;
  a:=calc(rank+1);
  while (curr=251) and (op[vval].pr=rank) do begin
    oldval:=vval;
    Readlex;
    a:=znach(oldval,op[oldval].p,a,calc(rank+1));
  end;
  calc:=a;
end;
begin
  fillchar ( opnum , sizeof ( opnum ) , 0 );
  Assign ( input , 'calc.in' );
  reset ( input );
  Assign ( output , 'calc.out' );
  rewrite ( output );
  op[-3].znak:='+';
  op[-3].pr:=5;
  op[-3].tip:='B';
  opnum['+']:=-3;
  op[-2].znak:='-';
  op[-2].pr:=5;
  op[-2].tip:='B';
  opnum['-']:=-2;
  op[-1].znak:='*';
  op[-1].pr:=15;
  op[-1].tip:='B';
  opnum['*']:=-1;
  op[-4].znak:='/';
  op[-4].pr:=15;
  op[-4].tip:='B';
  opnum['/']:=-4;
  readln ( p );
  readln ( colop );
  for i:=1 to colop do begin
    read ( ch );
    op[i].tip:=ch;
    if ch='B' then begin
      read ( op[i].pr );
      read ( ch );
      read ( ch );
      read ( op[i].znak );
      opnum[op[i].znak]:=i;
      read ( ch );
      read ( ch );
      readln ( s );
      op[i].p:=makeop(s);
    end;
    if ch='U' then begin
      op[i].pr:=20;
      read ( ch );
      read ( op[i].znak );
      opnum[op[i].znak]:=i;
      read ( ch );
      read ( ch );
      readln ( s );
      op[i].p:=makeop(s);
    end;
  end;
{  for i:=1 to colop do begin
    dfs(op[i].p);
    writeln;
  end;}
  readln ( colconst );
  for ch:=chr(0) to char(255) do mconst[ch]:=255;
  for i:=1 to colconst do begin
    read ( ch );
    read(ch1);
    readln ( mconst[ch] );
  end;
{  for ch:='c' to 'z' do writeln ( mconst[ch] );}
  sscol:=0;
  while not eoln do begin
    inc ( sscol );
    read ( ss[sscol] );
  end;
  tek:=1;
  curr:=0;
{  while (curr<>255) and (curr<>250) do begin
    readlex;
    writeln ( curr , ' ' , vval );
  end;}
  readlex;
  writeln ( calc ( 1 ) );

  close ( input );
  close ( output );
end.