{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Type Tip=LongInt;
  Const Inp='docs.in';
        Out='docs.out';
        MaxN=100000;
  Var Error : Boolean;
      N,M,Num : Tip;
      Answer : Array [1..MaxN] Of Tip;
      Inform,Inform2 : Array [1..MaxN] Of Record X,Y,Num : TIp; End;
      Tree : Array [1..MaxN*2] Of record B,E,Min,L,R,Num,Parent : Tip End;
      Where,where2 : Array [1..MaxN] Of Tip;
      Use : Array [1..MaxN] Of Boolean;
      Y,LenTree : Tip;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

procedure Sort2(l, r: Tip);
var
  i, j, x: Tip;
begin
  i := l; j := r; x := Inform2[(l+r) DIV 2].Y;
  repeat
    while Inform2[i].Y < x do i := i + 1;
    while x < Inform2[j].Y do j := j - 1;
    if i <= j then
    begin
      y := Inform2[i].Y; Inform2[i].Y := Inform2[j].Y; Inform2[j].Y := y;
      y := Inform2[i].X; Inform2[i].X := Inform2[j].X; Inform2[j].X := y;
      y := Inform2[i].Num; Inform2[i].Num := Inform2[j].Num; Inform2[j].Num := y;
      Y :=Where2[I]; Where2[I] :=Where2[J]; Where2[J] :=Y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort2(l, j);
  if i < r then Sort2(i, r);
end;

procedure Sort(l, r: Tip);
var
  i, j, x: Tip;
begin
  i := l; j := r; x := Inform[(l+r) DIV 2].X;
  repeat
    while Inform[i].X < x do i := i + 1;
    while x < Inform[j].X do j := j - 1;
    if i <= j then
    begin
      y := Inform[i].Y; Inform[i].Y := Inform[j].Y; Inform[j].Y := y;
      y := Inform[i].X; Inform[i].X := Inform[j].X; Inform[j].X := y;
      y := Inform[i].Num; Inform[i].Num := Inform[j].Num; Inform[j].Num := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

Function FindE(Const X : Tip) : Tip;
  Var L,R : Tip;
Begin
  If Inform[N].X<=X Then
    Begin
      FindE :=N;
      Exit;
    End;
  If Inform[1].X>X Then
    Begin
      FindE :=-1;
      Error :=True;
      Exit;
    End;
  L :=1;
  R :=N;
  While R-L>1 Do
    Begin
      If Inform[(R+L) Div 2].X>X Then
        R :=(R+L) Div 2
      Else If Inform[(R+L) Div 2].X<X Then
        L :=(R+L) Div 2
      Else
        Begin
          R :=(R+L) Div 2;
          L :=R;
        End;
    End; {L&R in otrezok}
  If Inform[L].X=X  Then
    FindE :=L
  Else If Inform[R].X=X Then
    FindE :=R
  Else If (Inform[L].X<X) And (Inform[R].X>X) Then
    FindE :=L
  Else
    Begin
      Error :=True;
      FindE :=-1;
    End;
End;

Function FindB(Const X : Tip) : Tip;
  Var L,R : Tip;
Begin
  If Inform[1].X>=X Then
    Begin
      FindB :=1;
      Exit;
    End;
  If Inform[N].X<X Then
    Begin
      FindB :=-1;
      Error :=True;
      Exit;
    End;
  L :=1;
  R :=N;
  While R-L>1 Do
    Begin
      If Inform[(R+L) Div 2].X>X Then
        R :=(R+L) Div 2
      Else If Inform[(R+L) Div 2].X<X Then
        L :=(R+L) Div 2
      Else
        Begin
          R :=(R+L) Div 2;
          L :=R;
        End;
    End; {L&R in otrezok}
  If Inform[L].X=X  Then
    FindB :=L
  Else If Inform[R].X=X Then
    FindB :=R
  Else If (Inform[L].X<X) And (Inform[R].X>X) Then
    FindB :=R
  Else
    Begin
      Error :=True;
      FindB :=-1;
    End;
End;

Function FindY(Const Y : Tip) : Tip;
  Var L,R : Tip;
Begin
  L :=1;
  R :=N;
  While R-L>1 Do
    Begin
      If Inform2[(R+L) Div 2].Y>Y Then
        R :=(R+L) Div 2
      Else If Inform2[(R+L) Div 2].Y<Y Then
        L :=(R+L) Div 2
      Else
        Begin
          R :=(R+L) Div 2;
          L :=R;
        End;
    End; {L&R in otrezok}
  If Inform2[L].Y=Y  Then
    FindY :=L
  Else If Inform2[R].Y=Y Then
    FindY :=R
  Else
    Begin
      Error :=True;
      FindY :=-1;
    End;
End;


Function Min(Const A,B : Tip) : Tip;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

procedure CountMin(X,Y : Tip);
  Var Help : Tip;
Begin
  If X=Y Then
    Begin
      Inc(LenTree);
      Tree[LenTree].Min :=Inform[X].Y;
      Tree[LenTree].Num :=Inform[X].Num;
      Where[X] :=LenTree;
      Tree[LenTree].B :=X;
      Tree[LenTree].E :=Y;
      Tree[LenTree].L :=0;
      Tree[LenTree].R :=0;
    End
  Else
    Begin
      CountMin(X,(X+Y) Div 2);
      Help :=LenTree;
      CountMin((X+Y) Div 2+1,Y);
      Inc(LenTree);
      Tree[LenTree-1].Parent :=LenTree;
      Tree[Help].Parent :=LenTree;
      Tree[LenTree].Min :=Min(Tree[LenTree-1].Min,Tree[Help].Min);
      Tree[LenTree].L :=Help;
      Tree[LenTree].R :=LenTree-1;
      Tree[LenTree].B :=X;
      Tree[LenTree].E :=Y;
    End;
End;

Function FindMin(B,E,Pol : Tip) :  Tip;
  Var X,Y : Tip;
Begin
  If (B=Tree[Pol].B) And (E=Tree[Pol].E) Then
     FindMin :=Tree[Pol].Min
  Else
    If (Tree[Pol].B+Tree[Pol].E) Div 2+1<=B Then
      FindMin :=FindMin(B,E,Tree[Pol].R)
    Else If (Tree[Pol].B+Tree[Pol].E) Div 2>=E Then
      FindMin :=FindMin(B,E,Tree[Pol].L)
    Else
      FindMin :=Min(FindMin(B,(Tree[Pol].B+Tree[Pol].E) Div 2,Tree[Pol].L),
                     FindMin((Tree[Pol].B+Tree[Pol].E) Div 2+1,E,Tree[Pol].R));
End;

Procedure DeleteTree(Const What : Tip);
  Var Help,MinHelp : Tip;
Begin
  If Tree[What].Parent=0 Then Exit;
  Help :=Tree[What].Parent;
  MinHelp :=Min(Tree[Tree[Help].L].Min,Tree[Tree[Help].R].Min);
  If Tree[Help].Min<>MinHelp Then
    Begin
      Tree[Help].Min :=MinHelp;
      DeleteTree(Help);
    End;
End;

Procedure InitAndSolve;
  Var I,X,Y,Top,WhereX,WhereY,Min,HelpMin : Tip;
Begin
  FillChar(tree,SizeOf(Tree),0);
  Read(N);
  For I :=1 To N Do
    Begin
      Inform[I].Num :=I;
      Read(Inform[I].X,Inform[I].Y);
    End;
  Read(M);
  If N<M Then
    Begin
      WriteLn('BOTVA');
      Exit;
    End;
  Sort(1,N);
  Error :=False;
  LenTree :=0;
  CountMin(1,N);
  Inform2 :=Inform;
  Where2 :=Where;
  Sort2(1,N);
  For I :=1 To M Do
    Begin
      Read(X,Y);
      WhereX :=FindB(X);
      WhereY :=FindE(Y);
      If (WhereY<WhereX) Or
         ((WhereX=WhereY) And ((Inform[WhereX].X<X) Or (Inform[WhereX].X>Y))) Then
           Error :=True;
      If (Error) Then Break;
      HelpMin :=FindMin(WhereX,WhereY,LenTree);
      If HelpMin=MaxLongInt Then
        Begin
          Error :=True;
          Break;
        End;
      Answer[I] :=FindY(HelpMin);
      Tree[Where2[Answer[I]]].Min :=MaxLongInt;
      DeleteTree(Where2[Answer[I]]);
      Answer[I] :=Inform2[Answer[I]].Num;
      If Error Then Break;
    End;
  If Error Then
    WriteLn('BOTVA')
  Else
    For I :=1 To M Do
      Write(Answer[I],' ');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  InitAndSolve;
  CloseFiles;
End.
