#include<stdio.h>

#define FOR(A1,B1,C1) for(A1 = B1;A1 < C1; A1++)
#define FOR2(A1,B1,C1,A2,B2,C2) for(A1 = B1;A1 < C1; A1++)\
					for(A2 = B2;A2 < C2; A2++)
#define CMP(A,B)  if (A == B)

#if 0
#define MSG(A) 			printf(#A"\n")
#define MSG1(A,A1)		printf(A,A1)
#define MSG2(A,A1,A2)		printf(A,A1,A2)
#define MSG3(A,A1,A2,A3)        printf(A,A1,A2,A3)
#define _M_			printf("Message %d\n",__LINE__);
#else
#define MSG(A)
#define MSG1(A,A1)
#define MSG2(A,A1,A2)
#define MSG3(A,A1,A2,A3)
#define _M_
#endif

struct date
{	
	int d;
	int m;
};


char mouns[12][10]=
	{"January",	"February",
	 "March",	"April",
	 "May",		"June",
	 "July",	"August",
	 "September",	"November",
	 "October",	"December"};

int dt[2][12] =
	{{31,28,31,30,31,30,31,31,30,31,30,31}
	,{31,29,31,30,31,30,31,31,30,31,30,31}};

int Y1,Y2;
int n;
struct date 	d[100];
struct date 	h[100];
char		aIr[100];
int		h1[366];
int		h2[367];
int a[101][101];
int year[101][101];
int yy[100];

int
get_m(char *c)
{
	int i;
	FOR(i,0,12) CMP((*(int *)mouns[i]),*(int *)c) break;
	return(i);
}    

int
set(struct date d,int k)
{
	if (d.d != 29 || d.m != 1)
		h1[ dt[0][d.m] + d.d ] = k;
	h2[ dt[1][d.m] + d.d ] = k;
	return(0);
}


int
hld	(struct date d1,int y1
	,struct date d2,int y2)
{
	int y,j,n = 0,v;
	int k;
	int *h;
	for(y = y1; y <= y2;y++)
	{
		v = (y%4 == 0)&&(y%100 != 0)||(y%400 == 0)?1:0;
		h = v ? h2 : h1;
		j = (y == y1) ? (dt[v][d1.m] + d1.d + 1) : (1);
//		MSG2("%d %d\n",y,n);
		if (y == y2)                    
		{
			k = dt[v][d1.m] + d1.d + 1;
			for(;j <= k;j++) n += h[j];
		}
		else
			for(;j <= 365+v;j++) n += h[j];
	}
	return(n);
}


int
main()
{
	{
		int i;
		FILE *f;
		f = fopen("holidays.in","r");
		fscanf(f,"%d %d", &Y1, &Y2);
		fscanf(f,"%d", &n);
		FOR(i,0,n)
		{
			char s[10];
			int t;
			fscanf(f,"%s %d",s,&t);
			d[i].m = get_m(s);
			d[i].d = t;
//			MSG2("- %s %d ",mouns[d[i].m],t);
			fscanf(f,", %s",s);
//			MSG1(" -%c- ",*s);
			aIr[i] = *s;
			fscanf(f,"%s %d",s,&t);
			h[i].m = get_m(s);
			h[i].d = t;
//			MSG2("%s %d\n",mouns[h[i].m],t);
		}
		fclose(f);
	}
	{
		int i,j,s1,s2;
		FOR(i,0,12)
		{
			s1 += dt[0][i];
			s2 += dt[1][i];
			dt[0][i] = s1 - dt[0][i];
			dt[1][i] = s2 - dt[1][i];
		}

		FOR2(i,0,101,	j,0,101)  a[i][j] = -1;
		FOR(i,0,101) a[i][0] = 0;
	}
	
	{
		int i,j,k;
		for(i = Y1;i <= Y2;i++)
		{
			FOR(j,0,366) h1[i] = h2[i] = 0;
			h2[366] = 0;
			FOR(j,0,n)
			{
				if (aIr[j] == 'a')
					set(h[j],1);
				else	set(h[j],0);
				if (a[i-Y1][j] != -1)
				{
	/*/////////////////////*/
	int tmp = 0,l = i + 1;
	if (dt[1][d[j].m] + d[j].d < dt[1][d[j+1].m] + d[j+1].d )
	{
		if ((d[j].m == d[j+1].m)&&(d[j].d == d[j+1].d));
		else 
		{	tmp = hld(d[j],i,d[j+1],i);
			if (a[i-Y1][j+1] < a[i-Y1][j] + tmp) 
			{
				a[i-Y1][j+1] = a[i-Y1][j] + tmp;
				year[i - Y1][j+1] = i - Y1;
			}
			l = i;
		}
	}
	else
	{	tmp = hld(d[j],i,d[j+1],i+1);
		if (a[i+1-Y1][j+1] < a[i-Y1][j] + tmp) 
		{
			a[i+1-Y1][j+1] = a[i-Y1][j] + tmp;
			year[i+1-Y1][j+1] = i-Y1;
		}
		}
	for(;l < Y2;l++)
	{
		tmp += hld(d[j+1],l,d[j+1],l+1);
		if (a[l+1-Y1][j+1] < a[i-Y1][j] + tmp) 
		{
			a[l+1-Y1][j+1] = a[i-Y1][j] + tmp;
			year[l+1-Y1][j+1] = i-Y1;
		}
	}				
	/*\\\\\\\\\\\\\\\\\\\\\*/
				}
			}
			
		}
	}

	{
		FILE *f;
		int i,j;
		f = fopen("holidays.out","w");

		fprintf(f,"%d\n",a[Y2 - Y1][n]);
		j = Y2 - Y1;
		for(i=n;i>=1;i--)
		{
			yy[i-1] = year[j][i];
			j = year[j][i];
		}
		FOR(i,0,n)
		{
			fprintf(f,"%s %d %d, ",
				mouns[d[i].m],d[i].d, 
				yy[i] + Y1);
			if (aIr[i] = 'a')
				fprintf(f,"added ");
			else
				fprintf(f,"removed ");
			fprintf(f,"%s %d\n",mouns[h[i].m],h[i].d);
		}
		fclose(f);
	}                               
	return(0);
}
