#include <stdio.h>
#include <stdlib.h>

#define BASE 100000000
#define NN 110
#define LL 25

struct LLONG {
  int l;
  long long a[LL];
};

FILE *fi, *fo;
int n,m;
int p[NN+1];
int pp,qq;
int q[NN+1];
int mark[NN];
int cur_mark;
bool g1[NN][NN];
bool g2[NN][NN];
int sm[NN];
int t[NN];
LLONG a[NN+1][NN+1];
LLONG one,two;

int min(int a, int b)
{
  return (a<b)?a:b;
}

int max(int a, int b)
{
  return (a>b)?a:b;
}

void zero(LLONG *a)
{
  int i;
  a->l=0;
  for(i=0;i<LL;i++)
    a->a[i]=0LL;
}

void set_one(LLONG *a)
{
  int i;
  a->l=1;
  for(i=0;i<LL-1;i++)
    a->a[i]=0LL;
  a->a[LL-1]=1LL;
}

void cpy(LLONG *a, LLONG *b) // <=> b=a
{
  int i;
  b->l=a->l;
  for(i=0;i<LL;i++)
    b->a[i]=a->a[i];
}

void umn(LLONG *a, long long q)
{
  int i;
  long long r;
  r=0;
  if(a->l==0)
    return ;
  if(q==0)
  {
    zero(a);
    return ;
  }
  for(i=LL-1;i>=LL-a->l;i--)
  {
    a->a[i]=a->a[i]*q+r;
    r=a->a[i]/BASE;
    a->a[i]%=BASE;
  }
  while(r>0)
  {
    a->a[LL-(++(a->l))]=r%BASE;
    r/=BASE;
  }
}

void umn(LLONG *a, long long q,int shift)
{
  int i;
  long long r;
  LLONG b;
  r=0;
  if(a->l==0)
    return ;
  if(q==0)
  {
    zero(a);
    return ;
  }
  zero(&b);
  b.l=a->l+shift;
  for(i=LL-1;i>=LL-a->l;i--)
  {
    b.a[i-shift]=a->a[i]*q+r;
    r=b.a[i-shift]/BASE;
    b.a[i-shift]%=BASE;
  }
  cpy(&b,a);
//  a->l+=shift;
  while(r>0)
  {
    a->a[LL-(++(a->l))]=r%BASE;
    r/=BASE;
  }
}

void sum(LLONG *a, LLONG *b)
{
  int i;
  long long r;
  a->l=max(a->l,b->l);
  r=0;
  for(i=LL-1;i>=LL-a->l;i--)
  {
    a->a[i]+=r+b->a[i];
    r=a->a[i]/BASE;
    a->a[i]%=BASE;
  }
  while(r>0)
  {
    a->a[LL-(++(a->l))]=r%BASE;
    r/=BASE;
  }
}

void div(LLONG *a, long long q)
{
  long long r;
  int i;
  r=0;
  if(a->l==0)
    return ;
  for(i=LL-a->l;i<LL;i++)
  {
    r=r*BASE+a->a[i];
    a->a[i]=r/q;
    r%=q;
  }
  while(a->a[LL-a->l]==0)
  {
    a->l--;
    if(a->l==0)
      break;
  }
}

void umn(LLONG *a, LLONG *b)
{
  int i;
  LLONG c;
  LLONG res;
  zero(&res);
  for(i=LL-1;i>=LL-b->l;i--)
  {
    if(b->a[i]!=0)
    {
      cpy(a,&c);
      umn(&c,b->a[i],LL-1-i);
      sum(&res,&c);
    }
  }
  cpy(&res,a);
}

void umn_c(LLONG *a, int n, int k)
{
  int i;
  if(k>n-k)
   k=n-k;
  for(i=n-k+1;i<=n;i++)
    umn(a,i);
  for(i=2;i<=k;i++)
    div(a,i);
}

void umn_f(LLONG *a, int n)
{
  int i;
  for(i=2;i<=n;i++)
    umn(a,i);
}

void div_f(LLONG *a, int n)
{
  int i;
  for(i=2;i<=n;i++)
    div(a,i);
}

void wr(LLONG *a)
{
  int i;
  if(a->l==0)
  {
    fprintf(fo,"0\n");
    return ;
  }
  fprintf(fo,"%lld",a->a[LL-a->l]);
  for(i=LL-a->l+1;i<LL;i++)
    fprintf(fo,"%08lld",a->a[i]);
  fprintf(fo,"\n");
}

int f_p(int x)
{
  int i;
  int w;
  int ans;
  w=1;
  ans=0;
  for(i=0;i<=pp;i++)
  {
    ans+=w*p[i];
    ans%=n;
    w*=x;
    w%=n;
  }
  return ans;
}

int f_q(int x)
{
  int i;
  int w;
  int ans;
  w=1;
  ans=0;
  for(i=0;i<=qq;i++)
  {
    ans+=w*q[i];
    ans%=n;
    w*=x;
    w%=n;
  }
  return ans;
}

void buildg1()
{
  int i,j;
  for(i=0;i<n;i++)
    for(j=0;j<n;j++)
      g1[i][j]=false;
  for(i=0;i<n;i++)
  {
    g1[i][f_p(i)]=true;
    g1[i][f_q(i)]=true;
  }
}

void floid()
{
  int i,j,k;
  for(k=0;k<n;k++)
    for(i=0;i<n;i++)
      for(j=0;j<n;j++)
        if(g1[i][k]&&g1[k][j])
          g1[i][j]=true;
}

void buildg2()
{
  int i,j;
  int m;
  buildg1();
  floid();
  for(i=0;i<n;i++)
    mark[i]=-1;
  cur_mark=0;
  for(i=0;i<n;i++)
  {
    for(j=0;j<i;j++)
    {
      if(g1[j][i]&&g1[i][j])
      {
        mark[i]=mark[j];
        break;
      }
    }
    if(mark[i]<0)
      mark[i]=cur_mark++;
  }
  m=cur_mark;
  for(i=0;i<m;i++)
    for(j=0;j<m;j++)
      g2[i][j]=false;
  for(i=0;i<n;i++)
    for(j=0;j<n;j++)
      if(g1[i][j])
        g2[mark[i]][mark[j]]=true;

  n=m;
}

int find_zero()
{
  int i;
  for(i=0;i<n;i++)
    if(sm[i]==0)
      return i;
  return 0;
}

void build_t()
{
  int i,j,k;
  for(i=0;i<n;i++)
    sm[i]=0;
  for(i=0;i<n;i++)
    for(j=0;j<n;j++)
      if(g2[i][j])
        sm[j]++;
  for(i=0;i<n;i++)
  {
    k=find_zero();
    t[i]=k;
    sm[k]=NN*2;
    for(j=0;j<n;j++)
      if(g2[k][j])
        sm[j]--;
  }
}

LLONG *get(int x, int y)
{
  LLONG c;
  int i,q,w;
  if(x>y)
    return &one;
//  if(x==y)
//    return &two;
  if(a[x][y].l<0)
  {
    set_one(&a[x][y]);
    q=x+1;
    w=x;
    for(i=x+1;i<=y;i++)
    {
      if(g2[t[x]][t[i]])
      {
        if(w>=q)
        {
          umn(&a[x][y],get(q,w));
          q=i+1;
          w=i;
        }
      }
      else
        w++;
    }
    if(w>=q)
      umn(&a[x][y],get(q,w));
    sum(&a[x][y],get(x+1,y));
  }
  return &a[x][y];
}

int main()
{
  int i,j,k;
  fi=fopen("invar.in","rt");
  fo=fopen("invar.out","wt");

  fscanf(fi,"%d",&n);
  fscanf(fi,"%d",&pp);
  for(i=0;i<=pp;i++)
    fscanf(fi,"%d",&p[pp-i]);
  fscanf(fi,"%d",&qq);
  for(i=0;i<=qq;i++)
    fscanf(fi,"%d",&q[qq-i]);
  buildg2();
  build_t();

  for(i=0;i<n;i++)
    for(j=0;j<n;j++)
      a[i][j].l=-1;
  wr(get(0,n-1));

  fclose(fi);
  fclose(fo);
  return 0;
}
