#define ONLINE
#include <stdio.h>
#include <string.h>

#define MONTHS_NUM 12

const short months_days[MONTHS_NUM]=
  {31,29,31,30,31,30,31,31,30,31,30,31};
const char months_names[MONTHS_NUM][16]=
  {"J","F","Mar","Ap","May","Jun","Jul","Au","S","O","N","D"};
const short cheatydate=60;

struct TDate {
  short date,month,day;
  char monthname[16];
  void scan(void);
  void print(void);
};
struct TRecord {
  char type;
  TDate when,what;
  short year;
  char typestr[16];
  void scan(void);
  void print(const short);
};

struct TInfo {
  short count;
  short prev_year;
};

short year_min,year_max,n_years,n_records,count;
TRecord*records;
TInfo*info_cont,**info;

int main(void) {
  #ifdef ONLINE
  freopen("holidays.in","rt",stdin);
  freopen("holidays.out","wt",stdout);
  #endif
  short i_rec,i_year;
  scanf("%hd %hd",&year_min,&year_max);
  n_years=year_max-year_min+1;
  scanf("%hd",&n_records);
  records=new TRecord[n_records];
  for (i_rec=0; i_rec<n_records; i_rec++) records[i_rec].scan();
  info_cont=new TInfo[n_records*n_years]; info=new TInfo*[n_records];
  { short i,j;
    for (i=0,j=0; i<=n_records; i++,j+=n_years) info[i]=&info_cont[j];
  }
  for (i_year=0; i_year<n_years; i_year++) {
    if (records[0].what.date!=cheatydate) {
      info[0][i_year].count=n_years-i_year;
      if (records[0].when.date>=records[0].what.date) info[0][i_year].count--;
    } else {
      info[0][i_year].count=n_years-i_year;
      if (records[0].when.date>=records[0].what.date) info[0][i_year].count--;
    }
    info[0][i_year].prev_year=-1;
  }
  for (i_rec=1; i_rec<n_records; i_rec++) {
      info[i_rec][0].count=-1;
      info[i_rec][0].prev_year=-1;
    for (i_year=1; i_year<n_years; i_year++) if (info[i_rec-1][i_year-1].count>=0) {
      short i_year_prev;
      info[i_rec][i_year].prev_year=i_year-1;
      for (i_year_prev=i_year-2; i_year_prev>=0; i_year_prev--) {
        if (info[i_rec-1][i_year_prev].count<0) break;
        if (info[i_rec-1][i_year_prev].count>=info[i_rec-1][info[i_rec][i_year].prev_year].count)
        info[i_rec][i_year].prev_year=i_year_prev;
      }
      short count;
      if (records[i_rec].what.date!=cheatydate) {
        count=n_years-i_year;
        if (records[i_rec].when.date>=records[i_rec].what.date) count--;
      } else {
        count=n_years-i_year;
        if (records[i_rec].when.date>=records[i_rec].what.date) count--;
      }
      info[i_rec][i_year].count=info[i_rec-1][info[i_rec][i_year].prev_year].count;
      if (!records[i_rec].type) info[i_rec][i_year].count+=count;
      else info[i_rec][i_year].count-=count;
    } else {
      info[i_rec][i_year].count=-1;
      info[i_rec][i_year].prev_year=-1;
    }
  }
  count=info[n_records-1][n_years-1].count;
  if (count>=0) {
    i_year=n_years-1;
    for (i_rec=n_records-1; i_rec>=0; i_rec--) {
      records[i_rec].year=i_year+year_min;
      i_year=info[i_rec][i_year].prev_year;
    }
    printf("%hd\n",count);
    for (i_rec=0; i_rec<n_records; i_rec++) records[i_rec].print(records[i_rec].year);
  } else printf("-1\n");
  delete[]info_cont; delete[]info;
  delete[]records;
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


void TRecord::scan(void) {
  when.scan();
  scanf("%s",typestr); scanf("%s",typestr);
  if ((*typestr=='a')||(*typestr=='A')) type=0; else type=1;
  what.scan();
}
void TRecord::print(const short year) {
  when.print();
  printf(" %hd, %s ",year,typestr);
  what.print();
  printf("\n");
}
void TDate::scan(void) {
  scanf("%s%hd",monthname,&day);
  date=day;
  for (month=0; month<MONTHS_NUM; month++) {
    if (!strnicmp(monthname,months_names[month],strlen(months_names[month])))
    break;
    date+=months_days[month];
  }
}
void TDate::print(void) {
  printf("%s %hd",monthname,day);
}


