{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'casino.out';
  cinfile = 'casino.in';

  nmax = 60;

  dmax = 30;
  base = 10000;
  dig = 4;

type
  int = longint;
  real = extended;

  thuge = array [0..dmax] of int;

var
  n, k : int;

  ans : thuge;

  kb : int;
  a, b : array [0..nmax] of int;

  d : array [0..nmax,0..nmax] of thuge;

procedure outdata;
var
  i, j : int;
  s : string;
begin
  write(ans[ans[0]]);
  for i:= ans[0]-1 downto 1 do
  begin
    str(ans[i],s);
    for j:= length(s) to dig-1 do write('0');
    write(s);
  end;
  writeln;
end;

procedure mulhuge(var a, b : thuge);
var
  i, j, r : int;
  c : thuge;
begin
  fillchar(c,sizeof(c),0);
  r:= 0;
  for i:= 1 to a[0]+1 do
    for j:= 1 to b[0]+1 do
    begin
      inc(c[i+j-1],a[i]*b[j]+r);
      r:= c[i+j-1] div base;
      c[i+j-1]:= c[i+j-1] - r*base;
    end;
  c[0]:= a[0]+b[0]+2;
  a:= c;
  while (a[0] > 1) and (a[a[0]] = 0) do dec(a[0]);
end;

procedure mulint(var a : thuge; b : int);
var
  i, r : int;
begin
  r:= 0;
  for i:= 1 to a[0] do
  begin
    a[i]:= a[i]*b + r;
    r:= a[i] div base;
    a[i]:= a[i] - r*base;
  end;
  while r > 0 do
  begin
    inc(a[0]);
    a[a[0]]:= r mod base;
    r:= r div base;
  end;
end;

procedure addhuge(var a, b : thuge);
var
  i, r : int;
begin
  r:= 0;
  if a[0] < b[0] then a[0]:= b[0];
  for i:= 1 to a[0] do
  begin
    a[i]:= a[i]+b[i] + r;
    r:= a[i] div base;
    a[i]:= a[i] - r*base;
  end;
  while r > 0 do
  begin
    inc(a[0]);
    a[a[0]]:= r mod base;
    r:= r div base;
  end;
end;

procedure divint(var a : thuge; b : int);
var
  i, r : int;
begin
  r:= 0;
  for i:= a[0] downto 1 do
  begin
    r:= r*base+a[i];
    a[i]:= r div b;
    r:= r mod b;
  end;
  while (a[0] > 1) and (a[a[0]] = 0) do dec(a[0]);
end;

procedure rec(var t : thuge;l,k : int);
var
  i : int;
  c1, c2 : thuge;
begin
  if k = l then
  begin
    fillchar(t,sizeof(t),0);
    t[0]:= 1;
    t[1]:= 1;
    exit;
  end;
  if d[l,k][0] > 0 then
  begin
    t:= d[l,k];
    exit;
  end;
  rec(t,l,k+1);
  mulint(t,k+1);
  for i:= k+2 to l do
  begin
 {   rec(c1,i-1,k);
    rec(c2,l-i+1,1);
    mulhuge(c1,c2);
    addhuge(t,c1);}
    rec(c1,l-1,k);
    addhuge(t,c1);
  end;
end;

procedure solve;
var
  i, j : int;
  q, w : int;
  e : int;
  t : thuge;
  c1, c2 : thuge;
begin
  fillchar(b,sizeof(b),0);
  a[0]:= 1;
  kb:= 0;
  for i:= 1 to n do
  begin
    if (a[i] = 0) and (a[i-1] = 1) then
    begin
      inc(kb);
      b[kb]:= 0;
    end;
    if a[i] = 0 then inc(b[kb]);
  end;
  if (a[1] = 0) and (a[n] = 0) and (kb > 1) then
  begin
    b[1]:= b[1] + b[kb];
    dec(kb);
  end;
  fillchar(ans,sizeof(ans),0);
  ans[0]:= 1;
  ans[1]:= 1;
  k:= 0;
  for i:= 1 to kb do k:= k + b[i];
  if k = n then
  begin
    for i:= 1 to n do mulint(ans,n);
    exit;
  end;
  if k = 0 then exit;
  d[0,0][0]:= 1;
  d[0,0][1]:= 1;
  d[1,1][0]:= 1;
  d[1,1][1]:= 1;
  for i:= 2 to n do
  begin
    for j:= 2 to i do
    begin
      for q:= 0 to i-j do
        for w:= 1 to j-1 do
        begin
          c1:= d[i-j,q];
          c2:= d[j-1,w];
          mulhuge(c1,c2);
          for e:= 1 to i do mulint(c1,e);
          for e:= 1 to i-j do divint(c1,e);
          for e:= 1 to j-1 do divint(c1,e);
          divint(c1,q+1);
          addhuge(d[i,w],c1);
        end;
    end;
    for q:= 1 to i-1 do
    begin
      c1:= d[i-1,q];
      mulint(c1,i);
      divint(c1,q+1);
      addhuge(d[i,q+1],c1);
    end;
  end;
  for i:= 1 to k do mulint(ans,i);
  for i:= 1 to kb do
    for j:= 2 to b[i] do divint(ans,j);
  for i:= 1 to kb do
  begin
    fillchar(c1,sizeof(c1),0);
    c1[0]:= 1;
    for j:= 1 to b[i] do addhuge(c1,d[b[i],j]);
    mulhuge(ans,c1);
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
  for i:= 1 to n do read(a[i]);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.