{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_b;
const
  inpfile='invar.in';
  outfile='invar.out';
  osn=10000;
  lm=40;
  nm=105;
type
  TLong = array [0..lm] of LongInt;
var
  a,b : array [0..nm] of LongInt;
  ca,cb : array [0..nm] of LongInt;
  p,q : array [0..nm] of LongInt;
  d : array [0..nm,0..nm] of LongInt;
  pn,qn,can,cbn,n : LongInt;
  res : TLong;
{}
Procedure Inp;
var
  i,j : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  read(pn);
  for i:=pn downto 0 do read(p[i]);
  read(qn);
  for i:=qn downto 0 do read(q[i]);
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  write(res[res[0]]);
  for i:=res[0]-1 downto 1 do begin
    if res[i]<1000 then write(0);
    if res[i]<100 then write(0);
    if res[i]<10 then write(0);
    write(res[i]);
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(p,sizeof(p),0);
  fillchar(q,sizeof(q),0);
  fillchar(d,sizeof(d),0);
  fillchar(ca,sizeof(ca),0);
  fillchar(cb,sizeof(cb),0);
end;
{}
Procedure CountAB;
var
  i,j,k,t : LongInt;
begin
  for i:=0 to n-1 do begin
    k:=1; t:=0;
    for j:=0 to pn do begin
      t:=(t+k*p[j]) mod n;
      k:=(k*i) mod n;
    end;
    a[i]:=t;

    k:=1; t:=0;
    for j:=0 to qn do begin
      t:=(t+k*q[j]) mod n;
      k:=(k*i) mod n;
    end;
    b[i]:=t;
  end;
end;
{}
var
  u : array [0..nm] of LongInt;
  rt : LongInt;
{}
Procedure DfsA(x : LongInt);
begin
  if u[x]=2 then exit;
  if u[x]=1 then begin
    inc(can); rt:=x; exit;
  end;
  u[x]:=1;
  DfsA(a[x]);

  if rt<>-1 then begin
    ca[x]:=can;
    if x=rt then rt:=-1;
  end;
  u[x]:=2;
end;
{}
Procedure DfsB(x : LongInt);
begin
  if u[x]=2 then exit;
  if u[x]=1 then begin
    inc(cbn); rt:=x; exit;
  end;
  u[x]:=1;
  DfsB(b[x]);

  if rt<>-1 then begin
    cb[x]:=cbn;
    if x=rt then rt:=-1;
  end;
  u[x]:=2;
end;
{}
var
  ul,ur : array [0..nm] of Boolean;
{}
Function Left(x : LongInt) : Boolean; forward;
{}
Function Right(x : LongInt) : Boolean;
var
  i : LongInt;
  res : Boolean;
begin
  res:=true;
  if ur[x] then begin
    Right:=true; exit;
  end;
  ur[x]:=true;
  if d[0,x]=1 then res:=false;
  for i:=1 to can do
    if d[i,x]=1 then res:=res and Left(i);
  Right:=res;
end;
{}
Function Left(x : LongInt) : Boolean;
var
  i : LongInt;
  res : Boolean;
begin
  res:=true;
  if ul[x] then begin
    Left:=true; exit;
  end;
  ul[x]:=true;
  if d[x,0]=1 then res:=false;
  for i:=1 to cbn do
    if d[x,i]=1 then res:=res and Right(i);
  Left:=res;
end;
{}
Function Max(q,w : LongInt) : LongInt;
begin
  if q>w then max:=q else max:=w;
end;
{}
Procedure Sum(var r : TLong; q,w : TLong);
var
  i,p : LongInt;
begin
  fillchar(r,sizeof(r),0); p:=0;
  r[0]:=max(q[0],w[0])+1;
  for i:=1 to r[0] do begin
    p:=q[i]+w[i]+p;
    r[i]:=p mod osn;
    p:=p div osn;
  end;
  if r[r[0]]=0 then dec(r[0]);
end;
{}
Procedure Solve;
var
  i,j,k,t : LongInt;
begin
  CountAB;
  can:=0; cbn:=0;

  fillchar(u,sizeof(u),0);
  for i:=0 to n-1 do begin
    rt:=-1; DfsA(i);
  end;

  fillchar(u,sizeof(u),0);
  for i:=0 to n-1 do begin
    rt:=-1; DfsB(i);
  end;

  for i:=0 to n-1 do
    d[ca[i],cb[i]]:=1;

  k:=0;
  fillchar(ul,sizeof(ul),0);
  fillchar(ur,sizeof(ur),0);
  for i:=1 to can do
    if not ul[i] then begin
      if Left(i) then inc(k);
    end;

  res[0]:=1; res[1]:=1;
  for i:=1 to k do
    Sum(res,res,res);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.