{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_c;
const
  inpfile='holidays.in';
  outfile='holidays.out';
  Month : array [1..12] of String = ('January','February','March',
                                     'April','May','June','Jule',
                                     'August','September','October',
                                     'November','December');
  nm=105;
type
  Calendar = record
    date : LongInt;
    month : String;
  end;
  Holiday = record
    k : LongInt;
    q,w : Calendar;
    year : LongInt;
  end;
var
  a : array [1..nm] of Holiday;
  b : array [1..nm] of Calendar;
  bn,n,start,fin,res : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
  st : String;
  ch : Char;
begin
  assign(input,inpfile);
  reset(input);
  readln(start,fin,n);
  for i:=1 to n do begin
    read(ch);
    repeat
      a[i].q.month:=a[i].q.month+ch;
      read(ch);
    until ch=' ';

    read(ch);
    repeat
      a[i].q.date:=10*a[i].q.date+ord(ch)-ord('0');
      read(ch);
    until ch=',';
    read(ch,ch);

    st:='';
    repeat
      st:=st+ch;
      read(ch);
    until ch=' ';

    if st='added' then a[i].k:=1
                  else a[i].k:=-1;

    read(ch);
    repeat
      a[i].w.month:=a[i].w.month+ch;
      read(ch);
    until ch=' ';

    readln(a[i].w.date);
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  for i:=1 to n do begin
    write(a[i].q.month,' ',a[i].q.date,' ',a[i].year,' ');
    if a[i].k=1 then write(',added ')
                else write(',removed ');
    writeln(a[i].w.month,' ',a[i].w.date);
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
end;
{}
Function More(q,w : Calendar) : Boolean;
var
  i,j,m1,m2 : LongInt;
begin
  for i:=1 to 12 do
    if q.month=Month[i] then m1:=i;
  for i:=1 to 12 do
    if w.month=Month[i] then m2:=i;
  if m1>m2 then More:=true
  else if m1<m2 then More:=false
  else begin
    if q.date>w.date then More:=true
                     else More:=false;
  end;
end;
{}
Function Eq(q,w : Calendar) : Boolean;
begin
  if (q.month=w.month) and (q.date=w.date) then Eq:=true
                                           else Eq:=false;
end;
{}
Function Count : LongInt;
var
  u : array [1..nm] of Boolean;
  i,j,t,res : LongInt;
  bol : Boolean;
begin
  fillchar(u,sizeof(u),0); res:=0;
  for i:=start to fin do begin
    for j:=1 to n do
      if a[j].year=i then begin
        if More(a[j].w,a[j].q) then begin
          if a[j].k=1 then bol:=true
                      else bol:=false;
          for t:=1 to bn do
            if Eq(b[t],a[j].w) then u[t]:=bol;
        end;
      end;

    for j:=1 to bn do
      if u[j] then begin
        if (b[j].month='February') and (b[j].date=29) then begin
          if (i mod 4=0) and ((i mod 100<>0) or (i mod 400=0)) then inc(res);
        end else inc(res);
      end;

    for j:=1 to n do
      if a[j].year=i then begin
        if a[j].k=1 then bol:=true
                    else bol:=false;
          for t:=1 to bn do
            if Eq(b[t],a[j].w) then u[t]:=bol;

      end;
  end;
  Count:=res;
end;
{}
Procedure Solve;
var
  i,j,k,t,q,w : LongInt;
begin
  k:=0; t:=0; q:=0;
  for i:=1 to n do begin
    k:=k+a[i].k;
    if k>t then begin
      t:=k; q:=i;
    end;
  end;

  a[1].year:=start;
  for i:=2 to q do begin
    if not More(a[i].q,a[i-1].q) then a[i].year:=a[i-1].year+1
                                 else a[i].year:=a[i-1].year;
    if (a[i].q.month='February') and (a[i].q.date=29) then begin
      while not ((a[i].year mod 4=0) and ((a[i].year mod 100<>0)
      or (a[i].year mod 400 = 0))) do inc(a[i].year)
    end;
  end;

  w:=0;
  for i:=q+1 to n do
    if not More(a[i].q,a[i-1].q) then inc(w);

  a[q+1].year:=fin-w+1;
  for i:=q+2 to n do begin
    if not More(a[i].q,a[i-1].q) then a[i].year:=a[i-1].year+1
                                 else a[i].year:=a[i-1].year;
    if (a[i].q.month='February') and (a[i].q.date=29) then begin
      while not ((a[i].year mod 4=0) and ((a[i].year mod 100<>0)
      or (a[i].year mod 400 = 0))) do inc(a[i].year)
    end;

  end;

  for i:=1 to n do
    if a[i].k=1 then begin
      inc(bn);
      b[bn]:=a[i].w;
    end;

  res:=Count;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.