{$A+,B-,D-E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

{Alexey Timofeev }

const
	FILEIN='casino.in';
  FILEOUT='casino.out';
  NMAX=60;
  LMAX=100;
	sys=10000;
type
	tlong=array[0..LMAX] of longint;
var
	a:array[0..NMAX] of byte;
	s,i,j,n:longint;
  inter:array[0..NMAX] of integer;
  bc,t:tlong;
  i_n:integer;
	f:array[0..NMAX] of tlong;
	c:array[0..NMAX,0..NMAX] of tlong;
function max(a,b:longint):longint;
begin
	if a>b then max:=a else max:=b;
end;

procedure makeup(var a:tlong;x:longint);
begin
	fillchar(a,sizeof(a),0);
	a[0]:=1;
  a[1]:=x;
end;

procedure mul2(a:tlong;x:longint;var c:tlong);
var
	i,ost:longint;
begin
  fillchar(c,sizeof(c),0);
  ost:=0;
  i:=0;
  for i:=1 to a[0] do
  begin
  	c[i]:=ost+a[i]*x;
    ost:=c[i] div sys;
    c[i]:=c[i] mod sys;
  end;
  while ost>0 do
  begin
  	inc(i);
    c[i]:=ost;
    ost:=c[i] div sys;
    c[i]:=c[i] mod sys;
  end;
	c[0]:=i;
end;

procedure add(a,b:tlong;var c:tlong);
var
	i,j,ost:longint;
begin
  j:=max(a[0],b[0]);

  fillchar(c,sizeof(c),0);
  ost:=0;

  i:=0;
  for i:=1 to j do
  begin
    c[i]:=a[i]+b[i]+ost;
    ost:=c[i] div sys;
    c[i]:=c[i] mod sys;
  end;

  while ost>0 do
  begin
    inc(i);
  	c[i]:=ost;
    ost:=c[i] div sys;
    c[i]:=c[i] mod sys;
  end;

  c[0]:=i;
end;

procedure mul(a,b:tlong;var c:tlong);
var
	i,j,ost,t:longint;
begin
  fillchar(c,sizeof(c),0);
  i:=0;
	for i:=1 to a[0] do
  begin
    ost:=0;
    j:=0;
  	for j:=1 to b[0] do
    begin
      c[i+j-1]:=c[i+j-1]+ost+a[i]*b[j];
      ost:=c[i+j-1] div sys;
      c[i+j-1]:=c[i+j-1] mod sys;
    end;
    t:=i+j-1;
  	while ost>0 do
    begin
      inc(t);
      c[t]:=c[t]+ost;
      ost:=c[t] div sys;
      c[t]:=c[t] mod sys;
    end;
  	if c[0]<t then c[0]:=t;
  end;
end;

procedure longout(a:tlong);
var
	i:longint;
begin
  if a[0]>0 then
  begin
    write(a[a[0]]);
		for i:=a[0]-1 downto 1 do
  	begin
      if a[i]<1000 then write(0);
      if a[i]<100 then  write(0);
      if a[i]<10 then 	write(0);
      write(a[i]);
  	end;
  end else writeln(0);

end;

procedure divl(a:tlong;x:longint;var c:tlong);
var
	i,ost:longint;
begin
  fillchar(c,sizeof(c),0);
  ost:=0;
	for i:=a[0] downto 1 do
  begin
  	c[i]:=(a[i]+sys*ost) div x;
    ost:=(a[i]+sys*ost) mod x;
  end;
  c[0]:=777;
  i:=a[0];
	while (c[i]=0) do dec(i);
  c[0]:=i;
end;

procedure initdata;
begin
  fillchar(a,sizeof(a),0);
  fillchar(inter,sizeof(inter),0);
	fillchar(f,sizeof(f),0);
	fillchar(c,sizeof(c),0);
end;

procedure outdata;
begin
	assign(output,FILEOUT);rewrite(output);

  longout(bc);

	close(output);
	halt;
end;

procedure readdata;
begin
	assign(input,FILEIN);reset(input);
  read(n);
  for i:=1 to n do read(a[i]);

end;

procedure solve;
begin
  {make pre-position}
  i_n:=0;
  a[0]:=1;

  for i:=1 to n do
  begin
    if a[i]=0 then
    begin
      if a[i-1]=1 then inc(i_n);
			inc(inter[i_n]);
    end;
  end;

	if (a[1]=0) and (a[n]=0) and (i_n>1) then
  begin
  	inter[1]:=inter[1]+inter[i_n];
    dec(i_n);
  end;

  {make FuckToReal}
  for i:=0 to n do makeup(c[0,i],1);

  for i:=1 to n do
  	for j:=0 to n do
      begin
    		{c[i,j]:=(c[i-1,j]*(i+j))div i;}
      	mul2(c[i-1,j],(i+j),c[i,j]);
        divl(c[i,j],i,c[i,j]);
      end;

  {make dinamic...}
  makeup(f[0],1);
  makeup(f[1],1);

  for i:=2 to n do
    begin
      makeup(f[i],0);
	  	for j:=1 to i do
        begin
   		  	{f[i]:=f[i]+f[j-1]*f[i-j]*c[j-1,i-j]*j;}
          mul(f[j-1],f[i-j],t);
          mul(t,c[j-1,i-j],t);
          mul2(t,j,t);
          add(f[i],t,f[i]);
    		end;
    end;

  {find result}
  makeup(bc,1);
  for i:=1 to i_n do s:=s+inter[i];
  for i:=1 to i_n-1 do
  begin
  	{bc:=bc*c[s-inter[i],inter[i]];}
    mul(bc,c[s-inter[i],inter[i]],bc);
    s:=s-inter[i];
  end;

  for i:=1 to i_n do
  begin
		{bc:=bc*f[inter[i]];}
    mul(bc,f[inter[i]],bc)
  end;
end;

begin
	initdata;
  readdata;
  solve;
  outdata;
end.
