{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  problem='casino';
  fin= problem+'.in';
  fout=problem+'.out';

type
  long=record
    l:longint;
    z:array[1..100]of shortint;
  end;

procedure readlong(var a:long);
var
  i:longint;
  c:char;
begin
  fillchar(a,sizeof(a),0);
  repeat
    read(c);
  until c in ['0'..'9'];

  repeat
    inc(a.l);
    for i:=a.l downto 2 do
      a.z[i]:=a.z[i-1];
    a.z[1]:=ord(c)-ord('0');
    read(c);
  until not (c in ['0'..'9']);

  while (a.z[a.l]=0)and(a.l>1) do
    dec(a.l);
end;

procedure writelong(const a:long);
var
  i:longint;
begin
  for i:=a.l downto 1 do
    write(a.z[i]);
end;

procedure inclong(const a,b:long;var c:long);
var
  i:longint;
begin
  fillchar(c,sizeof(c),0);
  c.l:=a.l+1;
  if c.l<b.l+1 then
    c.l:=b.l+1;
  for i:=1 to c.l do begin
    inc(c.z[i],a.z[i]+b.z[i]);
    inc(c.z[i+1],c.z[i] div 10);
    c.z[i]:=c.z[i] mod 10;
  end;
  if c.z[c.l]=0 then
    dec(c.l);
end;

procedure multlong(const a,b:long;var c:long);
var
  i,j:longint;
begin
  fillchar(c,sizeof(c),0);
  c.l:=a.l+b.l;
  for i:=1 to a.l do
    for j:=1 to b.l do begin
      inc(c.z[i+j-1],a.z[i]*b.z[j]);
      inc(c.z[i+j],c.z[i+j-1] div 10);
      c.z[i+j-1]:=c.z[i+j-1] mod 10;
    end;
  while (c.z[c.l]=0)and(c.l>1) do
    dec(c.l);
end;

var
  i,j,k,n,m:longint;
  a,b,c:long;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);

  close(input);

  assign(input,fin);
  reset(input);

    readlong(a);

  close(input);
end;

procedure solve;
begin
  c:=a;
  for i:=1 to n-1 do begin
    b:=c;
    multlong(a,b,c);
  end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    writelong(c);

  close(output);
end;

begin
  init;
  solve;
  done;
end.