{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 2000384,0,655360}
const
  problem='invar';
  fin= problem+'.in';
  fout=problem+'.out';

var
  ok:boolean;
  ans,t:array[0..50]of byte;
  a,b,a1,b1,d:array[0..150]of byte;
  e:array[1..2,0..150]of byte;
  c:array[0..150,0..150]of byte;
  i,j,k,m,n,l,p,q:longint;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(m);
    read(p);
    for i:=0 to p do
      read(a1[p-i]);
    read(q);
    for i:=0 to q do
      read(b1[q-i]);

  close(input);
end;

function dfs1(u,v:byte):boolean;
var
  ok:boolean;
begin
  d[v]:=1;
  dfs1:=false;
  if a[v]=u then begin
    a1[v]:=u+1;
    dfs1:=true;
    exit;
  end;
  if d[a[v]]=1 then
    exit;
  ok:=dfs1(u,a[v]);
  if ok then begin
    dfs1:=true;
    a1[v]:=u+1;
    exit;
  end;
end;

function dfs2(u,v:byte):boolean;
var
  ok:boolean;
begin
  d[v]:=1;
  dfs2:=false;
  if b[v]=u then begin
    b1[v]:=u+1;
    dfs2:=true;
    exit;
  end;
  if d[b[v]]=1 then
    exit;
  ok:=dfs2(u,b[v]);
  if ok then begin
    dfs2:=true;
    b1[v]:=u+1;
    exit;
  end;
end;

function dfs(v,d:longint):boolean;
var
  i:longint;
  ok:boolean;
begin
  e[d,v]:=1;
  dfs:=false;
  if d=1 then begin
    if a1[v]=1 then
      exit;
    for i:=1 to m do
      if (c[v,i]=1)and(e[2,i]=0) then begin
        ok:=dfs(i,2);
        if not ok then
          exit;
      end;
    for i:=1 to m do
      if c[v,i]=1 then
        break;
    if c[v,i]=1 then
      dfs:=true;
    exit;
  end
  else begin
    if b1[v]=1 then
      exit;
    for i:=1 to m do
      if (c[i,v]=1)and(e[1,i]=0) then begin
        ok:=dfs(i,1);
        if not ok then
          exit;
      end;
    for i:=1 to m do
      if c[i,v]=1 then
        break;
    if c[i,v]=1 then
      dfs:=true;
    exit;
  end;
end;

procedure solve;
begin
  for i:=0 to m-1 do
    for j:=0 to m-1 do begin
      k:=1;
      for l:=1 to j do
        k:=(k*i) mod m;
      c[i,j]:=k;
    end;

  fillchar(a,sizeof(a),0);
  for i:=0 to m-1 do begin
    k:=0;
    for l:=0 to p do
      k:=(k+c[i,l]*a1[l])mod m;
    a[i]:=k;
  end;

  fillchar(b,sizeof(b),0);
  for i:=0 to m-1 do begin
    k:=0;
    for l:=0 to q do
      k:=(k+c[i,l]*b1[l])mod m;
    b[i]:=k;
  end;

  fillchar(a1,sizeof(a1),0);
  fillchar(b1,sizeof(b1),0);
  for i:=0 to m-1 do begin
    fillchar(d,sizeof(d),0);
    dfs1(i,i);
    fillchar(d,sizeof(d),0);
    dfs2(i,i);
  end;

  a:=a1;
  b:=b1;
  fillchar(a1,sizeof(a1),0);
  fillchar(b1,sizeof(b1),0);
  fillchar(c,sizeof(c),0);
  fillchar(d,sizeof(d),0);
  for i:=0 to m-1 do begin
    if a[i]=0 then
      b1[b[i]]:=1;
    if b[i]=0 then
      a1[a[i]]:=1;
    if (a[i]<>0)and(b[i]<>0) then
      c[a[i],b[i]]:=1;
  end;

  fillchar(e,sizeof(e),0);
  k:=0;
  for i:=1 to m do
    if e[1,i]=0 then begin
      ok:=dfs(i,1);
      if ok then
        inc(k);
    end;

  fillchar(ans,sizeof(ans),0);
  ans[0]:=1;
  ans[1]:=1;
  for i:=1 to k do begin
    for j:=1 to ans[0] do
      ans[j]:=2*ans[j];
    for j:=1 to ans[0] do begin
      inc(ans[j+1],ans[j] div 10);
      ans[j]:=ans[j] mod 10;
    end;
    if ans[ans[0]+1]>0 then
      inc(ans[0]);
  end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    for i:=ans[0] downto 1 do
      write(ans[i]);

  close(output);
end;

begin
  init;
  solve;
  done;
end.