{$I-,Q-,R-,S-}
Const
  FIn  = 'casino.in';
  FOut = 'casino.out';
{---------------------------------------------------------------------------}
Var
  Input,Output:TEXT;
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=50;
  MaxLen=100;

Type
  TLong=Record
    L:Byte;
    C:array[1..MaxLen]of Byte;
  end;

Var
  N:LongInt;
  Mas:array[1..MaxN] of Byte;
  Func,Fact:array[0..MaxN]of TLong;

Function Max(A,B:LongInt):LongInt;
begin
  If A>B then Max:=A else Max:=B;
end;

Procedure Add(A,B:TLong; Var C:TLong);
Var
  R,O,S:Byte;
begin
  FillChar(C,SizeOf(C),0);
  O:=0;
  C.L:=Max(A.L,B.L);
  For R:=1 to C.L do
  begin
    S:=O+A.C[R]+B.C[R];
    C.C[R]:=S mod 10;
    O:=S div 10;
  end;
  While O<>0 do
  begin
    Inc(C.L);
    C.C[C.L]:=O mod 10;
    O:=O div 10;
  end;
end;

Function Cmp(A,B:TLong):Boolean; {A>=B}
Var R:LongInt;
begin
  if A.L>B.L then Cmp:=True else
  if A.L<B.L then Cmp:=False else
  begin
    For R:=1 to A.L do
      if A.C[R]>B.C[R] then
      begin
        Cmp:=True;
        Exit;
      end else
      if A.C[R]<B.C[R] then
      begin
        Cmp:=False;
        Exit;
      end;
    Cmp:=True;
  end;
end;

Procedure Sub(A,B:TLong; Var C:TLong);
Var R,O,S:LongInt;
begin
  O:=0;
  For R:=1 to A.L do
  begin
    S:=A.C[R]-B.C[R]-O;
    If S<0 then
    begin
      O:=1;
      S:=S+10
    end else O:=0;
    C.C[R]:=S;
  end;
  R:=MaxLen;
  While (C.C[R]=0)and(R>1) do Dec(R);
  C.L:=R;
end;

Procedure LongMul(A,B:TLong; Var C:TLong);
Var i,j,S,O:LongInt;
begin
  FillChar(C,SizeOf(C),0);
  For j:=1 to B.L do
  begin
    O:=0;
    For i:=1 to A.L do
    begin
      S:=O+C.C[i+j-1]+A.C[i]*B.C[j];
      if i+j-1>C.L then C.L:=i+j-1;
      C.C[i+j-1]:=S mod 10;
      O:=S div 10;
    end;
    While O<>0 do
    begin
      Inc(i);
      if i>C.L then C.L:=i;
      C.C[i]:=O mod 10;
      O:=O div 10;
    end;
  end;
end;

Procedure ShortMul(A:TLong; B:LongInt; Var C:TLong);
Var
  S,i,O:LongInt;
begin
  FillChar(C,SizeOf(C),0);
  O:=0;
  C.L:=A.L;
  For i:=1 to A.L do
  begin
    S:=O+A.C[i]*B;
    C.C[i]:=S mod 10;
    O:=S div 10;
  end;
  While O<>0 do
  begin
    Inc(i);
    if i>C.L then C.L:=i;
    C.C[i]:=O mod 10;
    O:=O div 10;
  end;
end;

Procedure LongDiv(A,B:TLong; Var C:TLong);
Var
  i,R,Pos,O,j,S:LongInt;
  Flag:Boolean;
begin
  FillChar(C,SizeOf(C),0);
  Pos:=0;
  {}
  While True do
  begin
    Flag:=False;
    i:=A.L-Pos;
    j:=B.L;
    For j:=B.L downto 1 do
    begin
      if A.C[i]>B.C[j] then
      begin
        Flag:=True;
        Break;
      end else
      If A.C[i]<B.C[j] then Break;
      dec(i);
    end;

    if Flag then
    begin
      O:=0;
      For R:=Pos to A.L do
      begin
        S:=A.C[R]-B.C[R]-O;
        If S<0 then
        begin
          O:=1;
          S:=S+10
        end else O:=0;
        C.C[R]:=S;
      end;
      R:=MaxLen;
      While (C.C[R]=0)and(R>1) do Dec(R);
      C.L:=R;
    end;
    Pos:=Pos+1;
  end;
end;

Var
  Ans:TLong;

  C:array[1..MaxN,0..MaxN]of TLong;
  SLen,Col:LongInt;
  Len:array[1..MaxN]of LongInt;

  R,R1,R2:LongInt;
  Flag:Boolean;
  A,B, Temp:TLong;
  Temp4,Temp2,Temp3:Extended;

  TTT:array[1..MaxN]of Extended;

Procedure CalcFunc(L:LongInt; Var Res:TLong);
Var i:Byte;Temp:TLong;
begin
  FillChar(Res,SizeOf(Res),0);
  for i:=1 to L do
  begin
    Temp:=Func[i-1];
    ShortMul(Temp,i,Temp);
    LongMul(Temp,Func[L-i],Temp);
    LongMul(Temp,C[L-1,i-1],Temp);
    Add(Res,Temp,Res);
  end;
end;

begin
  Init;
  {}
  ReadLn(Input,N);
  For R:=1 to N do Read(Input,Mas[R]);
  {}
  Col:=0; Flag:=True; SLen:=0;
  For R:=1 to N do
  begin
    If Mas[R]=0 then
    begin
      Inc(SLen);
      If Flag then
      begin
        Inc(Col);
        Flag:=False;
        Len[Col]:=1;
      end else
      begin
        Inc(Len[Col]);
      end;
    end else
    If Mas[R]=1 then Flag:=True;
  end;
  If Mas[1]=Mas[N] then
  begin
    Len[1]:=Len[1]+Len[Col];
    Len[Col]:=0;
    Dec(Col);
  end;
  {}
  FillChar(Fact,SizeOf(Fact),0);
  FillChar(Func,SizeOf(Func),0);
  FillChar(C,SizeOf(C),0);
  {}
  C[1,0].L:=1; C[1,0].C[1]:=1;
  C[1,1].L:=1; C[1,1].C[1]:=1;
  For R:=2 to MaxN do
  begin
    C[R,0].L:=1; C[R,0].C[1]:=1;
    For R1:=1 to R do
      Add(C[R-1,R1-1],C[R-1,R1],C[R,R1]);
  end;
  {}
  Fact[1].L:=1; Fact[1].C[1]:=1;
  For R:=2 to MaxN do ShortMul(Fact[R-1],R,Fact[R]);
  {}
  Func[0].L:=1; Func[0].C[1]:=1;
  Func[1].L:=1; Func[1].C[1]:=1;
  For R:=2 to MaxN do CalcFunc(R,Func[R]);
  {}
  Ans:=Fact[SLen];
  {}
  For R:=1 to Col do
    LongMul(Ans,Func[Len[R]],Ans);
  {Ans:=Ans*Func[Len[R]]/Fact[Len[R]];}
  {}
  Temp.L:=1; Temp.C[1]:=1;
  For R:=1 to Col do LongMul(Temp,Fact[Len[R]],Temp);
  {}
  Temp2:=0;
  For R:=Ans.L downto 1 do Temp2:=Temp2*10+Ans.C[R];
  Temp3:=0;
  For R:=Temp.L downto 1 do Temp3:=Temp3*10+Temp.C[R];
  Temp2:=Temp2/Temp3;
  WriteLn(Output,Temp2:0:0);
  Done;
  {}
  R:=Ans.L;
  While (Ans.C[R]=0)and(R>1) do Dec(R);
  For R:=R downto 1 do Write(Output,Ans.C[R]);
  {}
  Done;
end.
