{$I-,Q-,R-,S-}
Const
  FIn  = 'invar.in';
  FOut = 'invar.out';
{---------------------------------------------------------------------------}
Var
  Input,Output:TEXT;
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxM=100;
  MaxPQ=100;


Type
  TMas=array[0..MaxM-1]of LongInt;
  TPol=array[0..MaxPQ] of LongInt;
  PPol=^TPol;
  PMas=^TMas;

Var
  M,P,Q:LongInt;
  A,B:TPol;

  R:LongInt;

Function _Mul(A,B:LongInt):LongInt;
begin
  _Mul:=(A*B)mod M;
end;
Function _Add(A,B:LongInt):LongInt;
begin
  _Add:=(A+B)mod M;
end;

Function Compute(A:PPol; X:LongInt):LongInt;
Var R,R1,Ans,C:LongInt;
begin
  Ans:=0;
  For R:=0 to P do
  begin
    C:=A^[R];
    For R1:=1 to R do C:=_Mul(C,X);
    Ans:=_Add(Ans,C);
  end;
  Compute:=Ans;
end;

Var
  Gr1,Gr2:TMas;
  Mark1,Mark2:TMas;
  Use:array[0..MaxM-1] of Boolean;

  Mn:set of byte;
  Flag:Boolean;

Procedure Go(Gr,Mark:PMas; X,M:Byte);
begin
  FillChar(Use,SizeOf(Use),0);
  While Not Use[X] do
  begin
    Use[X]:=True;
    X:=Gr^[X];
  end;
  While Mark^[X]=0 do
  begin
    Mark^[X]:=M;
    X:=Gr^[X];
  end;
end;


begin
  Init;
  {}
  ReadLn(Input,M);
  Read(Input,P);
  For R:=P downto 0 do Read(Input,A[R]);
  Read(Input,Q);
  For R:=Q downto 0 do Read(Input,B[R]);
  {}
  For R:=0 to M-1 do Gr1[R]:=Compute(@A,R);
  For R:=0 to M-1 do Gr2[R]:=Compute(@B,R);
  {}
  For R:=0 to M-1 do
    If Mark1[R]=0 then Go(@Gr1,@Mark1,R,R+1);
   For R:=0 to M-1 do
    If Mark2[R]=0 then Go(@Gr2,@Mark2,R,R+1);
  {}
  WriteLn(Output,0);
  Done;
  {}
  Mn:=[0,1,2,3,4,5];
  Flag:=True;
  For R:=0 to M-1 do
    if R in Mn then
      if Not ((Gr1[R] in Mn)and(Gr2[R] in Mn)) then Flag:=False;
  if Flag then WriteLn('OK') else WriteLn('WRONG!!!');
  {}
  Done;
end.