{$I-,Q-,R-,S-}
const
  maxn=100;
  month:array[1..12] of string[9]=(
    'January',
    'February',
    'March',
    'April',
    'May',
    'June',
    'July',
    'August',
    'September',
    'October',
    'November',
    'December');
  _30=[4,6,7,9,11];
  _31=[1,3,5,8,10,12];

  action:array[false..true] of string[7]=(
    'removed',
    'added');

var
  sum,s1:longint;
  ys,yf,y1,m1,d1,y2,m2,d2:integer;
  i,j,n:integer;
  a:array[1..maxn] of record
    y,m,d,m1,d1:integer;
    a:boolean;
    z:integer;
  end;
  c:char;
  s:string;

function vis(y:integer):boolean;
begin
  vis:=(y mod 4=0) and not ((y mod 100=0) and not (y mod 400=0));
end;

procedure nextday(var y,m,d:integer);
begin
  inc(d);
  if (d>31) or ((d>30) and (m in _30)) or ((m=2) and (d>29) or ((not vis(y) and (d>28)))) then begin
    d:=1;
    inc(m);
    if m>12 then begin
      m:=1;
      inc(y);
    end;
  end;
end;

procedure prevday(var y,m,d:integer);
begin
  dec(d);
  if d<1 then begin
    dec(m);
    if m<1 then begin
      m:=12;
      dec(y);
    end;

    if (m in _31) then begin
      d:=31;
    end else begin
      if (m in _30) then begin
        d:=30;
      end else begin
        if vis(y) then
          d:=29
        else
          d:=28;
      end;
    end;
  end;
end;

procedure adddown(i:integer);
begin
  if (a[i].m>m2) or ((a[i].m=m2) and (a[i].d>d2)) then begin
    dec(y2);
    m2:=12;
    d2:=31;
  end;
  if (a[i].m=2) and (a[i].d=29) then begin
    while not vis(y2) do begin
      dec(y2);
      m2:=12;
      d2:=31;
    end;
  end;
  a[i].y:=y2;
  m2:=a[i].m;
  d2:=a[i].d;
  prevday(y2,m2,d2);
end;

procedure addup(i:integer);
begin
  if (a[i].m<m1) or ((a[i].m=m1) and (a[i].d<d1)) then begin
    inc(y1);
    m1:=1;
    d1:=1;
  end;
  if (a[i].m=2) and (a[i].d=29) then begin
    while not vis(y1) do begin
      inc(y1);
      m1:=1;
      d1:=1;
    end;
  end;
  a[i].y:=y1;
  m1:=a[i].m;
  d1:=a[i].d;
  nextday(y1,m1,d1);
end;

begin
  assign(input,'holidays.in');
  reset(input);
  assign(output,'holidays.out');
  rewrite(output);
  readln(ys,yf);
  y1:=ys;
  y2:=yf;
  readln(n);
  for i:=1 to n do begin
    s:='';
    read(c);
    while c<>' ' do begin
      s:=s+c;
      read(c);
    end;
    for j:=1 to 12 do begin
      if s=month[j] then begin
        a[i].m:=j;
        break;
      end;
    end;
    s:='';
    read(c);
    while c<>',' do begin
      s:=s+c;
      read(c);
    end;
    val(s,a[i].d,j);
    while not (c in ['a','r']) do
      read(c);
    s:='';
    while c<>' ' do begin
      s:=s+c;
      read(c);
    end;
    a[i].a:=s='added';
    s:='';
    read(c);
    while c<>' ' do begin
      s:=s+c;
      read(c);
    end;
    for j:=1 to 12 do begin
      if s=month[j] then begin
        a[i].m1:=j;
      end;
    end;
    readln(a[i].d1);
  end;

  a[n].z:=0;
  for i:=n-1 downto 1 do begin
    a[i].z:=a[i+1].z;
    if a[i+1].a then
      inc(a[i].z)
    else
      dec(a[i].z);
  end;

  m1:=1;
  d1:=1;
  m2:=12;
  d2:=31;
  for i:=1 to n do begin
    if (a[i].a) or (a[i].z>0) then begin
      addup(i);
    end else begin
      for j:=n downto i do begin
        adddown(j);
      end;
      break;
    end;
  end;
  prevday(y1,m1,d1);
  nextday(y2,m2,d2);
  if (y1>y2) or ((y1=y2) and ((m1>m2) or ((m1=m2) and (d1>=d2)))) then begin
    write(-1);
  end else begin
    sum:=0;
    for i:=1 to n do begin
      if not ((a[i].m1=2) and (a[i].d1=29)) then begin
        s1:=yf-a[i].y;
      end else begin
        s1:=0;
        for y1:=a[i].y+1 to yf do begin
          if vis(y1) then
            inc(s1);
        end;
      end;
      if (a[i].m<a[i].m1) or ((a[i].m=a[i].m1) and (a[i].d<a[i].d1)) then
        inc(s1);
      if a[i].a then
        sum:=sum+s1
      else
        sum:=sum-s1;
    end;
    writeln(sum);
    for i:=1 to n do begin
      writeln(month[a[i].m],' ',a[i].d,' ',a[i].y,', ',action[a[i].a],' ',month[a[i].m1],' ',a[i].d1);
    end;
  end;
  close(input);
  close(output);
end.
