{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$M 128384,0,655360}
const
  inf = 'invar.in'; ouf = 'invar.out';
  max = 110;
var
  p: array[0..max] of byte;
  w, ca, cb, a, b: array[0..max*2] of byte;
  g: array[1..max*2, 1..max*2] of byte;
  r: array[1..max] of byte;
  n, mr: byte;
  procedure find(k: byte);
  var
    i: byte;
  begin
     w[k] := mr;
     for i := 1 to n do
       if (w[i] = 0) and (g[k, i] = 1) then
         find(i);
  end;
var
  d, rl, i, j, m, pw, k: byte; cr: integer;
  qa, qb: integer; ok: boolean;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, m); read(input, pw);
{Read data and build graph}
  for i := pw downto 0 do read(input, p[i]);
  cr := 0;
  for i := 0 to m - 1 do
  begin
    cr := 0;
    for j := pw downto 0 do
      cr := (cr * i + p[j]) mod m;
    a[i] := cr;
  end;
  readln(input); read(input, pw);
  for i := pw downto 0 do read(input, p[i]);
  cr := 0;
  for i := 0 to m - 1 do
  begin
    cr := 0;
    for j := pw downto 0 do cr := (cr * i + p[j]) mod m;
    b[i] := cr;
  end;
{Getting cycles of obtained graphs}
  fillchar(w, sizeof(w), 0);
  fillchar(ca, sizeof(ca), 0);
  fillchar(cb, sizeof(cb), 0);
{for graph A}
  qa := 0; pw := 0;
  for i := 0 to m - 1 do
    if (w[i] = 0) then
    begin
       inc(pw); j := i;
       while (w[j] = 0) do
       begin
         w[j] := pw; j := a[j];
       end;
       if (w[j] = pw) then
       begin
         inc(qa); k := j;
         repeat
           ca[k] := qa; k := a[k];
         until k = j;
       end;
    end;
{For Graph B}
  fillchar(w, sizeof(w), 0);
  qb := 0; pw := 0;
  for i := 0 to m - 1 do
    if (w[i] = 0) then
    begin
       inc(pw); j := i;
       while (w[j] = 0) do
       begin
         w[j] := pw; j := b[j];
       end;
       if (w[j] = pw) then
       begin
         inc(qb); k := j;
         repeat
           cb[k] := qb; k := b[k];
         until k = j;
       end;
    end;
{Getting power of 2 by building new graph and
    searching linked components in it}
  fillchar(g, sizeof(g), 0);
  for i := 0 to m - 1 do
    if (ca[i] > 0) and (cb[i] > 0) then
    begin
       g[ca[i],qa + cb[i]] := 1;
       g[qa + cb[i],ca[i]] := 1;
    end;
  pw := 0; n := qa + qb;
  fillchar(w, sizeof(w), 0);
  for i := 1 to qa do
    if (w[i] = 0) then
    begin
      mr := i; find(i);
      fillchar(a, sizeof(a), 0);
      for j := 1 to qa do
        if (w[j] = mr) then
        begin
           for k := 0 to m-1 do
           if (ca[k] = j) then inc(a[k]);
        end;
      for j := qa + 1 to n do
        if (w[j] = mr) then
        begin
           for k := 0 to m-1 do
             if (cb[k] = j-qa) then inc(a[k]);
        end;
      ok := true;
      for j := 0 to m - 1 do
        if (a[j] mod 2 <> 0) then
        begin
          ok := false; break;
        end;
      if ok then inc(pw);
    end;
{  writeln(output, 1 shl pw);}
  rl := 1;
  fillchar(r, sizeof(r), 0);
  r[1] := 1;
  for i := 1 to pw do
  begin
    d := 0;
    for j := 1 to rl do
    begin
      d := r[j] shl 1 + d;
      r[j] := d mod 10;
      d := d div 10;
    end;
    if (d > 0) then
    begin
      inc(rl); r[rl] := d;
    end;
  end;
  for i := rl downto 1 do write(output, r[i]);
  close(input); close(output);
end.
