  {$I-,Q-,R-,S-}
const infile = 'maps.in'; outfile = 'maps.out';
      eps = 0.000001; num_t = 5321;
type pt = record x,y: extended; end;
     map = array [1..4] of pt;
     line = record a,b,c: extended; end;
var m1,m2,m3: map;
    s1,s2,s3,mx1,my1,mx3,my3: extended;
    res: pt;
    ok: boolean;

procedure init;
begin
     assign(input,infile);
     reset(input);
     m1[1].x:=0; m1[1].y:=0;
     read(s1,m1[2].x,m1[4].y);
     m1[2].y:=0; m1[4].x:=0;
     m1[3].x:=m1[2].x; m1[3].y:=m1[4].y;
     read(s2);
     read(s3,m3[1].x,m3[1].y,m3[2].x,m3[2].y,m3[3].x,m3[3].y,m3[4].x,m3[4].y);
     close(input);
end;

procedure get_ans_1(t: pt);
begin
     m2[1].x:=t.x-s2*(t.x)/s1;
     m2[1].y:=t.y-s2*(t.y)/s1;
     m2[3].x:=t.x+s2*(m1[3].x-t.x)/s1;
     m2[3].y:=t.y+s2*(m1[3].y-t.y)/s1;
     m2[2].x:=m2[3].x; m2[2].y:=m2[1].y;
     m2[4].x:=m2[1].x; m2[4].y:=m2[3].y;
end;

procedure get_ans_2(t: pt);
begin
     m2[1].x:=t.x-s2*(t.x)/s1;
     m2[1].y:=t.y+s2*(t.y)/s1;
     m2[3].x:=t.x+s2*(m1[3].x-t.x)/s1;
     m2[3].y:=t.y-s2*(m1[3].y-t.y)/s1;
     m2[2].x:=m2[3].x; m2[2].y:=m2[1].y;
     m2[4].x:=m2[1].x; m2[4].y:=m2[3].y;
end;

procedure get_ans_3(t: pt);
begin
     m2[1].x:=t.x+s2*(t.x)/s1;
     m2[1].y:=t.y+s2*(t.y)/s1;
     m2[3].x:=t.x-s2*(m1[3].x-t.x)/s1;
     m2[3].y:=t.y-s2*(m1[3].y-t.y)/s1;
     m2[2].x:=m2[3].x; m2[2].y:=m2[1].y;
     m2[4].x:=m2[1].x; m2[4].y:=m2[3].y;
end;

procedure get_ans_4(t: pt);
begin
     m2[1].x:=t.x+s2*(t.x)/s1;
     m2[1].y:=t.y-s2*(t.y)/s1;
     m2[3].x:=t.x-s2*(m1[3].x-t.x)/s1;
     m2[3].y:=t.y+s2*(m1[3].y-t.y)/s1;
     m2[2].x:=m2[3].x; m2[2].y:=m2[1].y;
     m2[4].x:=m2[1].x; m2[4].y:=m2[3].y;
end;

function s(t1,t2,t3: pt): extended;
begin
     s:=abs(t1.x*t2.y-t1.y*t2.x+t2.x*t3.y-t3.x*t2.y+t3.x*t1.y-t1.x*t3.y);
end;

function contain(t: map; p: pt): boolean;
begin
     contain:=abs(s(t[1],t[2],p)+s(t[2],t[3],p)+s(t[3],t[4],p)+s(t[4],t[1],p)-s(t[1],t[3],t[2])-s(t[1],t[3],t[4])) < eps;
end;

function can: boolean;
var i: longint;
begin
     can:=false;
     for i:=1 to 4 do
         if not contain(m1,m2[i]) then exit;
     for i:=1 to 4 do
         if not contain(m2,m3[i]) then exit;
     can:=true;
end;

procedure ptl(p1,p2: pt; var l: line);
begin
     l.a:=p2.y-p1.y;
     l.b:=p1.x-p2.x;
     l.c:=-(p1.x*l.a+p1.y*l.b);
end;

procedure calc_res;
var l1,l2: line;
    c1,c2,p,w,t,r: extended;
begin
     ptl(m3[2],m3[1],l1);
     c1:=s1/(s3*sqrt(l1.a*l1.a+l1.b*l1.b));
     ptl(m3[1],m3[4],l2);
     c2:=s1/(s3*sqrt(l2.a*l2.a+l2.b*l2.b));
     p:=(l2.b*c2)/(1-l2.a*c2);
     w:=(l2.c*c2)/(1-l2.a*c2);
     t:=1-c1*(l1.b+l1.a*p);
     r:=c1*(l1.a*w+l1.c);
     res.y:=r/t;
     res.x:=p*res.y+w;
end;

procedure rot(p: pt; ang: extended; var nw: pt);
begin
     nw.x:=p.x*cos(ang)-p.y*sin(ang);
     nw.y:=p.x*sin(ang)+p.y*cos(ang);
end;

procedure rotate(var p: pt; ang: extended);
var t,nw: pt;
begin
     t.x:=p.x-res.x; t.y:=p.y-res.y;
     rot(t,ang,nw);
     p.x:=nw.x+res.x; p.y:=nw.y+res.y;
end;

procedure rotate_m(ang: extended);
begin
     rotate(m2[1],ang);
     rotate(m2[2],ang);
     rotate(m2[3],ang);
     rotate(m2[4],ang);
end;

procedure solve;
var k: longint;
    ang: extended;
begin
     calc_res;
     if not contain(m3,res) then begin
        ok:=false; exit;
     end;
     ok:=true;
     get_ans_1(res);
     if can then exit;
     k:=0;
     while k <= num_t do begin
           ang:=pi/num_t;
           rotate_m(ang);
           if can then exit;
           inc(k);
     end;
     ok:=false;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     if ok then begin
        for i:=1 to 4 do
            writeln(m2[i].x,' ',m2[i].y);
     end
        else write('impossible');
     close(output);
end;

begin
     init;
     solve;
     done;
end.
