{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='maps.in';
  outfile='maps.out';
  eps=1e-10;
type
  Coord = record
    x,y : Extended;
  end;
  Rectangle = array [1..5] of Coord;
var
  a,b,c : Rectangle;
  s1,s2,s3,xm,ym : Extended;
  p : Coord;
  ok : Boolean;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(s1,xm,ym,s2,s3);
  a[1].x:=0; a[1].y:=0;
  a[2].x:=xm; a[2].y:=0;
  a[3].x:=xm; a[3].y:=ym;
  a[4].x:=0; a[4].y:=ym;
  a[5]:=a[1];

  read(b[1].x,b[1].y,b[2].x,b[2].y,b[3].x,b[3].y,b[4].x,b[4].y);
  b[5]:=b[1];
end;
{}
Procedure Out;
var
  i,j : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ok then begin
    for i:=1 to 4 do
      writeln(c[i].x:0:10,' ',c[i].y:0:10);
  end else writeln('impossible');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
end;
{}
Function Vc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Vc:=(p2.x-p1.x)*(p4.y-p3.y)-(p4.x-p3.x)*(p2.y-p1.y);
end;
{}
Function Sc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Sc:=(p2.x-p1.x)*(p4.x-p3.x)+(p4.y-p3.y)*(p2.y-p1.y);
end;
{}
Function Min(q,w : Extended) : Extended;
begin
  if q<w then min:=q else min:=w;
end;
{}
Function Max(q,w : Extended) : Extended;
begin
  if q>w then max:=q else max:=w;
end;
{}
Procedure Move(var r,p0,p1,p2 : Coord; d : Extended);
begin
  r.x:=p0.x+(p2.x-p1.x)*d;
  r.y:=p0.y+(p2.y-p1.y)*d;
end;
{}
Function Cross(var p1,p2,p3,p4 : Coord) : Boolean;
begin
  if (Vc(p1,p2,p1,p3)*Vc(p1,p2,p1,p4)<-eps) and
     (Vc(p3,p4,p3,p1)*Vc(p3,p4,p3,p2)<-eps) then Cross:=true
                                            else Cross:=false;
end;
{}
Procedure Check;
var
  i,j : LongInt;
begin
  ok:=true;
  for i:=1 to 4 do begin
    for j:=1 to 4 do
      if Cross(a[j],a[j+1],c[i],c[i+1]) then begin
        ok:=false; break;
      end;
    if not ok then break;
    for j:=1 to 4 do
      if Cross(b[j],b[j+1],c[i],c[i+1]) then begin
        ok:=false; break;
      end;
    if not ok then break;
  end;

  if ok then Out;
end;
{}
Function Len(var q,w : Coord) : Extended;
begin
  Len:=sqrt(sqr(q.x-w.x)+sqr(q.y-w.y));
end;
{}
Procedure FindPoint;
var
  d1,d2,a1,b1,c1,a2,b2,c2 : Extended;
begin
  d1:=Len(b[1],b[2]);
  d2:=Len(b[1],b[4]);

  a1:=(b[1].y-b[2].y);
  b1:=(b[2].x-b[1].x-d1*s3/s1);
  c1:=b[1].x*b[2].y-b[2].x*b[1].y;

  a2:=(b[4].y-b[1].y-d2*s3/s1);
  b2:=(b[1].x-b[4].x);
  c2:=b[4].x*b[1].y-b[1].x*b[4].y;

  p.x:=(c1*b2-c2*b1)/(a2*b1-a1*b2);
  p.y:=-(c1*a2-c2*a1)/(a2*b1-a1*b2);

  if (p.x<-eps) or (p.y<-eps)
  or (p.x>a[3].x+eps) or (p.y>a[3].y+eps) then exit;


  Move(c[1],p,p,b[1],s2/s3);
  Move(c[2],p,p,b[2],s2/s3);
  Move(c[3],p,p,b[3],s2/s3);
  Move(c[4],p,p,b[4],s2/s3);
  c[5]:=c[1];
  Check;

  Move(c[1],p,p,a[1],s2/s1);
  Move(c[2],p,p,a[2],s2/s1);
  Move(c[3],p,p,a[3],s2/s1);
  Move(c[4],p,p,a[4],s2/s1);
  c[5]:=c[1];
  Check;

end;
{}
Procedure Solve;
begin
  FindPoint;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.