{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
const
  problem='ackerman';
  fin= problem+'.in';
  fout=problem+'.out';

var
  t,i,j,k,l,q:longint;
  a:array[0..150]of byte;
  n,m,ans:array[1..1000]of byte;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(t);
    a[0]:=1;
    repeat
      inc(q);
      read(n[q],m[q]);
    until (n[q]=0)and(m[q]=0);
    dec(q);

  close(input);
end;

procedure solve;
begin
  for i:=1 to 2000000 do begin
    a[i]:=(2*a[i-1])mod t;
    for j:=0 to i-1 do
      if a[i]=a[j] then begin
        l:=i-j;
        break;
      end;
    if a[i]=a[j] then
      break;
  end;
  k:=i-1;

  for i:=1 to q do begin
    if n[i]=1 then
      ans[i]:=(2*m[i])mod t;
    if n[i]=2 then
      ans[i]:=a[(m[i]-k+l-1) mod l+(k-l+1)];
    if n[i]>2 then
      ans[i]:=a[k-l+1];
    if m[i]=1 then
      ans[i]:=2 mod t;
    if m[i]=2 then
      ans[i]:=4 mod t;
  end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    for i:=1 to q do
      writeln('Case ',i,': ',ans[i]);

  close(output);
end;

begin
  init;
  solve;
  done;
end.