{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 50000,0,655360}

Const INPUTFILE='ackerman.in';
      OUTPUTFILE='ackerman.out';

Const MaxN=102;
      MaxM=102;
      MaxT=102;

Type Real=Double;
     Point=record
     x,y:Longint;
     end;

var a:Array[1..MaxN,1..MaxM,0..MaxT] of Longint;

    N,M,T:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Read(T);

end;

Function A2modB(a,b:Longint):Longint;
var i,j,c:Longint;
begin
c:=1;
{While Odd(b)=False Do
begin
  Dec(a);
  b:=b shr 1;
  c:=(c*2);
end;}
if b=1 then
begin
  A2modB:=0;
  Exit;
end;
a:=a mod (b-1);
if a<b then
begin
  for i:=1 to a do
    c:=(c*2) mod b;
end;
A2ModB:=c;
end;

Procedure Prepare;
var i,j,k,P:Longint;
begin
FillChar(a,SizeOf(a),0);

{for i:=1 to T-1 do
  if A2modB(i,T)=1 then
  begin
    P:=i;
    Break;
  end;}

for j:=1 to MaxM do
for k:=1 to T do
  a[1,j,k]:=(2*j) mod k;
for i:=1 to MaxN do
for k:=1 to T do
  a[i,1,k]:=2 mod k;

for j:=2 to MaxM do
for k:=1 to T do
  a[2,j,k]:=A2modB(j,k);

for i:=3 to MaxN do
for j:=2 to MaxM do
for k:=1 to T do
  a[i,j,k]:=A2modB(a[i,j-1,k-1],k);
end;

Function Count(i,j:Longint):Longint;
begin
Count:=a[i,j,T];
end;

Procedure Solve;
var g,h:Longint;
    k:Longint;
begin
Prepare;
k:=0;
Repeat
  Inc(k);
  Read(g,h);
  if (g>0) AND (h>0) then
    Writeln('Case ',k,': ',Count(g,h));
Until (g=0) AND (h=0);

Close(Output);
Close(Input);
end;

begin
FRead;
Solve;
end.