type
  TPoint = record x,y : extended; end;

var
  t           : TPoint;
  m,lx,ly     : extended;
  a1,b1,c1,d1 : TPoint;
  xc,yc       : extended;
  s1,s2,s3    : extended;
  P1          : TPoint;
  a,b,c,d     : TPoint;
  n,i,j       : integer;

procedure init;
begin
  assign(input,'maps.in'); reset(input);
  assign(output,'maps.out'); rewrite(output);
  read(s1,p1.x,p1.y,s2);
  read(s3,a.x,a.y,b.x,b.y,c.x,c.y,d.x,d.y);
  close(input);
end;

function More(q,w : extended) : boolean;
begin
  More:=(q-w)>=1e-7;
end;

function Eq(q,w : extended) : boolean;
begin
  Eq:=abs(q-w)<=1e-7;
end;

function Check : boolean;
var
  x1,y1 : extended;

begin
  Check:=false;
  if More(b1.x,0) and More(p1.y,a1.x) and
     More(p1.y,b1.y) and More(c1.y,0) then
     begin
       x1:=(xc-b1.x)/s2;
       y1:=(yc-c1.y)/s2;
       if Eq(x1,xc)and Eq(y1,yc) then Check:=true else Check:=false;
     end else Check:=false;
end;

begin
  init;

  if more(b.x,a.x) then
  begin
    t:=a;
    a:=b;
    b:=t;
  end;

  if more(d.y,b.y) then
  begin
    t:=d;
    d:=b;
    b:=t;
  end;

  m:=1/s1;
  s1:=s1*m;
  s2:=s2*m;
  s3:=s3*m;

  xc:=b.x/(1-s3);
  yc:=c.y/(1-s3);

  lx:=p1.x*s2; ly:=p1.y*s2;

  b1.x:=xc*(1-s2);
  a1.x:=b1.x+lx;
  c1.x:=b1.x;
  d1.x:=a1.x;

  c1.y:=yc*(1-s2);
  b1.y:=c1.y+ly;
  a1.y:=b1.y;
  d1.y:=c1.y;

  if check = true then
  begin
    writeln(a1.x:0:6,' ',a1.y:0:6);
    writeln(b1.x:0:6,' ',b1.y:0:6);
    writeln(c1.x:0:6,' ',c1.y:0:6);
    writeln(d1.x:0:6,' ',d1.y:0:6);
  end else write('impossible');
  close(output);
end.