{$N+}
type
  real = extended;
const
  inf = 'maps.in'; ouf = 'maps.out';
  eps = 1e-8;
var
  x1, y1, x2, y2, x3, y3, x4, y4,
  x0, y0, xn, yn: real;
  s1, s2, s3: real;
  k, a, b, d, e, d1, e1, det, dx, dy: real;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, s1, xn, yn); readln(input, s2);
  read(input, s3, x1, y1, x2, y2, x3, y3, x4, y4);
  a := sqr(x2 - x1) + sqr(y2 - y1);
  b := sqr(x4 - x1) + sqr(y4 - y1);
  a := sqrt(a); b := sqrt(b);
  d := s3 * (x2 - x1)/a  - s1;
  e := s3 * (x4 - x1)/b;
  d1:= s3 * (y2 - y1)/a;
  e1 :=s3 * (y4 - y1)/b - s1;
  det := d * e1-e * d1;
  if (abs(det) < eps) then
    writeln(output, 'impossible')
  else
  begin
     dx := e * y1 - x1 * e1;
     dy := d1 * x1 - d * y1;
     x0 := dx / det;
     y0 := dy / det;
     k := s2 / s1;
     a := xn * k; b := yn * k;
     xn := x0; yn := y0;
     x1 := x0 - xn * s2; y1 := y0 - yn * s2;
     writeln(output, x1:7:7, ' ', y1:7:7);
     writeln(output,(x1+a):7:7,' ',y1:7:7);
     writeln(output,(x1+a):7:7,' ',(y1+b):7:7);
     writeln(output,x1:7:7,' ',(y1+b):7:7);
  end;
  close(input); close(output);
end.