{$D-,E+,I-,L-,P-,Q-,R-,S-,T+,V+,X+,Y+}
type float=extended;

point=record
x,y:float;
end;

line=record
a,b,c:float;
end;

tsystem=record
a1,b1,c1:float;
a2,b2,c2:float;
end;

const step:float=pi/500;

procedure outno;
begin
assign(output,'maps.out');rewrite(output);
writeln('impossible');
close(output);
halt;
end;

procedure point2line(a,b:point;var l:line);
var q:float;
begin
l.a:=b.y-a.y;
l.b:=a.x-b.x;
l.c:=-(l.a*a.x+l.b*a.y);
q:=sqrt(sqr(l.a)+sqr(l.b));
l.a:=l.a/q;
l.b:=l.b/q;
l.c:=l.c/q;
end;


procedure solve(z:tsystem;var ans:point);
var d,dx,dy:float;
begin
with z do
 begin
  d:=a1*b2-a2*b1;
  dx:=c1*b2-b1*c2;
  dy:=a1*c2-a2*c1;
  if d=0 then outno;
  ans.x:=dx/d;ans.y:=dy/d;
 end;
end;


var
i:integer;

s1,s2,s3:float;
rect1:point;
p:array[1..4]of point;
l1,l2:line;
z:tsystem;
p0:point;
ans0:array[1..4]of point;

alpha,nextalpha:float;
sinus,cosin:float;
anstry:array[1..4]of point;


function vect(x1,y1,x2,y2:float):float;
begin
vect:=x1*y2-x2*y1;
end;

function good(a:point):boolean;
var v:array[1..4]of float;
i,j:integer;
begin
v[1]:=vect(a.x-anstry[1].x,a.y-anstry[1].y,anstry[2].x-anstry[1].x,anstry[2].y-anstry[1].y);
v[2]:=vect(a.x-anstry[2].x,a.y-anstry[2].y,anstry[3].x-anstry[2].x,anstry[3].y-anstry[2].y);
v[3]:=vect(a.x-anstry[3].x,a.y-anstry[3].y,anstry[4].x-anstry[3].x,anstry[4].y-anstry[3].y);
v[4]:=vect(a.x-anstry[4].x,a.y-anstry[4].y,anstry[1].x-anstry[4].x,anstry[1].y-anstry[4].y);
good:=false;
for i:=1 to 4 do for j:=1 to 4 do if (i<>j) then
 begin
  if v[i]*v[j]<0 then exit;
 end;
good:=true;
end;


begin
assign(input,'maps.in');reset(input);
read(s1,rect1.x,rect1.y);
read(s2);
read(s3,p[1].x,p[1].y,p[2].x,p[2].y,p[3].x,p[3].y,p[4].x,p[4].y);
close(input);
point2line(p[2],p[1],l1);
point2line(p[1],p[4],l2);

z.a1:=l1.b-(s3/s1);
z.b1:=-l1.a;
z.c1:=-l2.c;
z.a2:=l1.a;
z.b2:=z.a1;
z.c2:=-l1.c;
solve(z,p0);
ans0[1].x:=p0.x*(s1-s2)/s1;
ans0[4].x:=ans0[1].x;

ans0[2].x:=p0.x+(rect1.x-p0.x)*s2/s1;
ans0[3].x:=ans0[2].x;

ans0[1].y:=p0.y*(s1-s2)/s1;
ans0[2].y:=ans0[1].y;

ans0[4].y:=p0.y+(rect1.y-p0.y)*s2/s1;
ans0[3].y:=ans0[4].y;

for i:=1 to 4 do
 begin
  p[i].x:=p[i].x-p0.x;
  p[i].y:=p[i].y-p0.y;
  ans0[i].x:=ans0[i].x-p0.x;
  ans0[i].y:=ans0[i].y-p0.y;
 end;
rect1.x:=rect1.x-p0.x;
rect1.y:=rect1.y-p0.y;


nextalpha:=-pi;
while nextalpha<=pi do
 begin
  alpha:=nextalpha;
  nextalpha:=alpha+step;
  sinus:=sin(alpha);
  cosin:=cos(alpha);
  anstry[1].x:=-ans0[1].y*sinus+ans0[1].x*cosin;
  if (anstry[1].x<-p0.x) or (anstry[1].x>rect1.x) then continue;
  anstry[1].y:= ans0[1].x*sinus+ans0[1].y*cosin;
  if (anstry[1].y<-p0.y) or (anstry[1].y>rect1.y) then continue;

  anstry[2].x:=-ans0[2].y*sinus+ans0[2].x*cosin;
  if (anstry[2].x<-p0.x) or (anstry[2].x>rect1.x) then continue;
  anstry[2].y:= ans0[2].x*sinus+ans0[2].y*cosin;
  if (anstry[2].y<-p0.y) or (anstry[2].y>rect1.y) then continue;

  anstry[3].x:=-ans0[3].y*sinus+ans0[3].x*cosin;
  if (anstry[3].x<-p0.x) or (anstry[3].x>rect1.x) then continue;
  anstry[3].y:= ans0[3].x*sinus+ans0[3].y*cosin;
  if (anstry[3].y<-p0.y) or (anstry[3].y>rect1.y) then continue;

  anstry[4].x:=-ans0[4].y*sinus+ans0[4].x*cosin;
  if (anstry[4].x<-p0.x) or (anstry[4].x>rect1.x) then continue;
  anstry[4].y:= ans0[4].x*sinus+ans0[4].y*cosin;
  if (anstry[4].y<-p0.y) or (anstry[4].y>rect1.y) then continue;

  if good(p[1])and good(p[2])and good(p[3])and good(p[4]) then
     begin
      assign(output,'maps.out');rewrite(output);
      writeln(anstry[1].x+p0.x:0:10,' ',anstry[1].y+p0.y:0:10);
      writeln(anstry[2].x+p0.x:0:10,' ',anstry[2].y+p0.y:0:10);
      writeln(anstry[3].x+p0.x:0:10,' ',anstry[3].y+p0.y:0:10);
      writeln(anstry[4].x+p0.x:0:10,' ',anstry[4].y+p0.y:0:10);
      close(output);
      halt;
     end;
 end;

outno;
end.