{$Q-,R-,S-,N+}
Const
   InputFile = 'maps.in';
  OutputFile = 'maps.out';

Type
  TMap  = Record
    X1, Y1, X2, Y2, X3, Y3, X4, Y4, S : Extended;
  End;

Var
  M1, M2, M3    : TMap;
  S1, S2, S3    : Extended;
  Res           : Boolean;

  Function Min(A, B : Extended) : Extended;
  Begin
    If A < B Then Min := A Else Min := B;
  End;

  Procedure Solve;
  Var A, B, C, D, X, Y  : Extended;
  Begin
    Res := True;
    If (M3.X1 = M3.X2)or(M3.Y1 = M3.Y2) Then
      Begin
        A := (M3.Y1 - M1.Y1)/(M3.X1 - M1.X1);
        B := M3.Y1 - A * M3.X1;

        C := (M3.Y2 - M1.Y2)/(M3.X2 - M1.X2);
        D := M3.Y2 - C * M3.X2;

        X := (D - B)/(A - C);
        Y := X * A + B;

        A := 1 - S2 / S1;

        M2.X1 := X * A ;
        M2.Y1 := Y * A ;

        B := S2 / S1;

        C := M1.X2 * B;
        D := M1.Y2 * B;

        M2.X2 := M2.X1 + C;
        M2.Y2 := M2.Y1 + D;
     End
       Else
         Res := False;
  End;

  Procedure Init;
  Begin
    Assign(Input, InputFile);   Reset(Input);
    Readln(S1, M1.X2, M1.Y2);
    M2.X1 := 0;
    M2.X1 := 0;
    Readln(S2);
    Readln(S3, M3.X1, M3.Y1, M3.X2, M3.Y2, M3.X3, M3.Y3, M3.X4, M3.Y4);
    Close(Input);
  End;

  Procedure Done;
  Begin
    Assign(Output, OutputFile); Rewrite(Output);
    If Res Then
    With M2 Do
      Begin
        Writeln(X1:0:6,' ', Y1:0:6);
        Writeln(X2:0:6,' ', Y1:0:6);
        Writeln(X2:0:6,' ', Y2:0:6);
        Writeln(X1:0:6,' ', Y2:0:6);
      End
   Else
     Writeln('impussible');
    Close(Output);
  End;

Begin
  Init;
    Solve;
  Done;
End.
