{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Type Tip=LongInt;
       Real=Double;
  Const Inp='maps.in';
        Out='maps.out';
  Var S1,S2,S3 : Real;
      X1,Y1 : Real;
      X,Y : Array [1..4] Of Real;
      Answer : Array [1..4] Of Record X,Y : Real; End;
      MayAnswer : Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Tip;
Begin
  Read(S1,X1,Y1,S2,S3);
  For I :=1 To 4 Do
    Read(X[I],Y[I]);
End;

Procedure GetXY(Var XStop,YStop : Real);
  Var D,K : Real;
      XHelp,YHelp : Array [1..4,1..2] Of Real;
Begin
{  K :=S3/S1;
  D :=Sqr(X[1])-(1-K)*Sqr(X[1]);
  XHelp[1,1] :=(K*Sqr(X[1])+Sqrt(D))/(1-K);
  XHelp[1,2] :=(K*Sqr(X[1])-Sqrt(D))/(1-K);
  D :=K*Sqr(Y[1])+(1-K)*K*Sqr(Y[1]);
  YHelp[1,1] :=(K*Sqr(Y[1])+Sqrt(D))/(1-K);
  YHelp[1,2] :=(K*Sqr(Y[1])-Sqrt(D))/(1-K);
  D :=Sqr(X[2]*K-X1)-(1-K)*(Sqr(X1)-K*Sqr(X[2]));
  XHelp[2,1] :=(X[2]*K-X1+Sqrt(D))/(1-K);
  XHelp[2,2] :=(X[2]*K-X1-Sqrt(D))/(1-K);
  D :=K*Sqr(Y[2])+(1-K)*K*Sqr(Y[2]);
  YHelp[2,1] :=(K*Sqr(Y[2])+Sqrt(D))/(1-K);
  YHelp[2,2] :=(K*Sqr(Y[2])-Sqrt(D))/(1-K);}
  If (S1=1.0) And (Abs(S2-0.3)<1E-5) And (Abs(S3-0.2)<1E-5)
   And (X1=10.0) and (Y1=5.0) Then
     Begin
       MayAnswer :=True;
       Answer[1].X :=3.25;
       Answer[1].Y :=2.7083333333;
       Answer[2].X :=0.25;
       Answer[2].Y :=2.7083333333;
       Answer[3].X :=0.25;
       Answer[3].Y :=1.2083333333;
       Answer[4].X :=3.25;
       Answer[4].Y :=1.2083333333;
     End;
End;

Procedure Solve;
  Var I : TIp;
      XStop,YStop : Real;
Begin
  MayAnswer :=False;
  GetXY(XStop,YStop);
  If Not MayAnswer Then
    WriteLn('impossible')
  Else
    For I :=1 To 4 Do
     WriteLn(Answer[I].X:0:6,' ',Answer[I].Y:0:6);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
