{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
  Type Tip=LongInt;
  Const Inp='ackerman.in';
        Out='ackerman.out';
        max=100;
  Var T,M,N : Tip;
      Map : Array [1..Max,1..Max] Of Tip;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure Init;
Begin
  Read(T);
End;

Procedure GetMap;
  Var I,J : Tip;
Begin
  FillChar(Map,SizeOf(Map),0);
  For I :=1 To Max Do
    Begin
      Map[1,I] :=I*2 Mod T;
      Map[I,1] :=2 Mod T;
      Map[I,2] :=4 Mod T;
    End;
  For I :=3 To Max Do
    Map[2,I] :=(Map[2,I-1]*2) Mod T;
  For I :=3 To Max Do
    For J :=3 To Max Do
      Map[I,J] :=65536 Mod T;
  Map[3,3] :=16 Mod T;
End;

Function Get(Const X,Y : Tip) : Tip;
Begin
  Get :=Map[X,Y];
End;

Procedure Solve;
  Var Count,Answer : Tip;
Begin
  GetMap;
  Read(N,M);
  Count :=0;
  While (N<>0) And (M<>0) Do
    Begin
      Inc(Count);
      Answer :=Get(N,M);
      WriteLn('Case ',Count,': ',Answer);
      Read(N,M)
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
